/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.actions.AbstractAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.Property"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.util.ListenerList"); //$NON-NLS-1$

(function() {
var Property= com.ibm.team.rtc.foundation.api.ui.actions.Property;
var ListenerList= com.ibm.team.rtc.foundation.web.ui.util.ListenerList;

dojo.declare("com.ibm.team.rtc.foundation.web.ui.actions.AbstractAction", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fPropertyListener: null,

	fName: null,

	fIconUrl: null,

	fCanHandle: null,

	fIsChecked: null,

	constructor: function() {
		this.fPropertyListener= new ListenerList();
	},

	addPropertyListener: function(listener) {
		this.fPropertyListener.addListener(listener);
	},

	removePropertyListener: function(listener) {
		this.fPropertyListener.removeListener(listener);
	},

	setName: function(name) {
		this.fName= name;
		this.firePropertyChangeEvent(Property.Name, this.fName);
	},

	getName: function() {
		return this.fName;
	},

	setIconUrl: function(iconUrl) {
		this.fIconUrl= iconUrl;
		this.firePropertyChangeEvent(Property.IconUrl, this.fIconUrl);
	},

	getIconUrl: function() {
		return this.fIconUrl;
	},

	setCanHandle: function(value) {
		this.fCanHandle= value;
		this.firePropertyChangeEvent(Property.Enabled, this.fCanHandle);
	},

	canHandle: function() {
		return this.fCanHandle;
	},

	handleWithEvent: function(widget, event, location) {
		this.handle();
	},

	setChecked: function(checked) {
		this.fIsChecked= checked;
		this.firePropertyChangeEvent(Property.Checked, this.fIsChecked);
	},

	isChecked: function() {
		return this.fIsChecked;
	},

	firePropertyChangeEvent: function(property, newValue) {
		var $subject= this.fPropertyListener.getListeners();
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var listener= $subject[$count];
			listener.onPropertyChange(this, property, newValue);
		}
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.actions.IAbstractItem': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.api.ui.actions.IAction': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.api.ui.actions.IActionItem': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.api.ui.actions.IMenuItem': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.api.ui.actions.IPropertyChangeEventProvider': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.api.ui.actions.IToolBarItem': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.web.ui.actions.IEventAction': true //$NON-NLS-1$
	}
});

})();
