/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.cache.internal.MultiWorkItemProxyFetch"); //$NON-NLS-1$

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.api.common.WorkItemAttributes"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.cache.internal.Cache"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.cache.internal.WorkItemProxyFactory"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.dtos.DTOUtil"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.rest.TeamRepositoryExceptionFactory"); //$NON-NLS-1$

(function() {
var ServiceResponseHandler= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var WorkItemAttributes= com.ibm.team.workitem.api.common.WorkItemAttributes;
var Cache= com.ibm.team.workitem.web.cache.internal.Cache;
var WorkItemProxyFactory= com.ibm.team.workitem.web.cache.internal.WorkItemProxyFactory;
var DTOUtil= com.ibm.team.workitem.web.client.dtos.DTOUtil;
var WorkItemClient= com.ibm.team.workitem.web.client.internal.WorkItemClient;
var TeamRepositoryExceptionFactory= com.ibm.team.workitem.web.client.internal.rest.TeamRepositoryExceptionFactory;

/**
 * @since 3.0
 */
var MultiWorkItemProxyFetch= dojo.declare("com.ibm.team.workitem.web.cache.internal.MultiWorkItemProxyFetch", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	constructor: function() {
	}
});

MultiWorkItemProxyFetch.fetchWorkItems= function(handler, clientParams, proxyParams) {
	var result= {};
	result.itemProxyArray= [];
	result.clientParams= clientParams;
	result.proxyParams= proxyParams;
	MultiWorkItemProxyFetch.fetchWorkItems2(handler, result);
};
MultiWorkItemProxyFetch.fetchWorkItems2= function(handler, result) {
	result.itemProxyArray= [];
	var clientParams= result.clientParams;
	var proxyParams= result.proxyParams;
	if (clientParams == null || clientParams.s == null || clientParams.s.length === 0) {
		handler.doCallback(result);
		return ;
	}
	var ids= clientParams.s;
	var fetchIds= [];
	for (var i= 0; i < ids.length; i++){
		var itemId= ids[i];
		var idx= itemId.indexOf(";"); //$NON-NLS-1$
		if (idx !== -1) {
			itemId= itemId.substring(0, idx);
		}
		var workItemProxy= Cache.getItemByItemId(itemId);
		var skip= workItemProxy != null;
		if (skip) {
			if (!workItemProxy.isNewWorkItem()) {
				var attributeIds= clientParams.a;
				for (var j= 0; skip && j < attributeIds.length; j++){
					var args= {};
					args.path= ["attributes", attributeIds[j]]; //$NON-NLS-1$
					skip&= workItemProxy.isValueFetched(args);
				}
			}
		}
		if (skip) {
			result.itemProxyArray.push(workItemProxy);
		} else {
			fetchIds.push(ids[i]);
		}
	}
	if (fetchIds.length > 0) {
		var fetchParams= {};
		fetchParams.projectAreaItemId= clientParams.projectAreaItemId;
		fetchParams.a= clientParams.a;
		var hasId= false;
		for (var i= 0; i < clientParams.a.length; i++){
			if ((clientParams.a[i] === WorkItemAttributes.ID)) {
				hasId= true;
				break;
			}
		}
		if (!hasId) {
			clientParams.a.push(WorkItemAttributes.ID);
		}
		fetchParams.s= fetchIds;
		fetchParams.includeApprovals= clientParams.includeApprovals === true;
		fetchParams.includeLinks= clientParams.includeLinks === true;
		var onDtos= dojo.hitch(this, function(dtos) {
			if (dtos != null && dtos.length !== 0) {
				MultiWorkItemProxyFetch.fillResultWithProxies(result, proxyParams, dtos);
			} else {
				console.warn("[MultiWorkItemProxyFetch] NO RESULT FROM SERVER"); //$NON-NLS-1$
			}
			handler.doCallback(result);
		});
		var onFailure= dojo.hitch(this, function(data) {
			var exception= TeamRepositoryExceptionFactory.INSTANCE.createException(data);
			handler.doErrorCallback(exception);
		});
		var getWorkItemsHandler= new ServiceResponseHandler({'onSuccess': onDtos, 'onFailure': onFailure}, 'onSuccess', 'onFailure'); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		WorkItemClient.postGetWorkItems(getWorkItemsHandler, fetchParams);
	} else {
		handler.doCallback(result);
	}
};
MultiWorkItemProxyFetch.refreshWorkItems= function(handler, result) {
	if (result.clientParams == null) {
		result.clientParams= {};
	}
	if (result.clientParams.s == null) {
		result.clientParams.s= [];
	}
	if (result.itemProxyArray == null) {
		result.itemProxyArray= [];
	}
	for (var i= 0; i < result.itemProxyArray.length; i++){
		result.clientParams.s.push(result.itemProxyArray[i].getItemId());
	}
	result.proxyParams.isKeepingChangedValues= result.proxyParams.isKeepingChangedValues === false ? false : true;
	MultiWorkItemProxyFetch.fetchWorkItems2(handler, result);
};
MultiWorkItemProxyFetch.fillResultWithProxies= function(result, proxyParams, dtos) {
	for (var i= 0; i < dtos.length; i++){
		if (dtos[i] != null) {
			var attributeMap= DTOUtil.getAttributeMap(dtos[i]);
			dtos[i]["attributes"]= attributeMap; //$NON-NLS-1$
			var idAttr= attributeMap[WorkItemAttributes.ID];
			if (idAttr != null) {
				var id= idAttr.id;
				proxyParams.id= parseInt(id);
				if (proxyParams.isShownInRecentlyViewed !== true) {
					proxyParams.isShownInRecentlyViewed= false;
				}
				var proxy= WorkItemProxyFactory.getWorkItemProxy(proxyParams);
				var mergeArgs= {};
				mergeArgs.isKeepingChangedValues= result.proxyParams.isKeepingChangedValues === false ? false : true;
				mergeArgs.workItemDTO= dtos[i];
				proxy.mergeWorkItemDTO(mergeArgs);
				var clone= dojo.clone(dtos[i]);
				proxy.storedObject= clone;
				var attributes= {};
				for (var j= 0; j < clone.attributes.length; j++){
					attributes[clone.attributes[j].key]= clone.attributes[j].value;
				}
				proxy.storedObject["attributes"]= attributes; //$NON-NLS-1$
				if (result.clientParams.a != null) {
					proxy["isPartialFetch"]= true; //$NON-NLS-1$
				}
				result.itemProxyArray.push(proxy);
			}
		}
	}
};

})();
