/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.cache.internal.MultiWorkItemProxySave"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.rest.TeamRepositoryExceptionFactory"); //$NON-NLS-1$

(function() {
var Assert= com.ibm.jdojo.util.Assert;
var ServiceResponseHandler= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var WorkItemClient= com.ibm.team.workitem.web.client.internal.WorkItemClient;
var TeamRepositoryExceptionFactory= com.ibm.team.workitem.web.client.internal.rest.TeamRepositoryExceptionFactory;

/**
 * @since 3.0
 */
dojo.declare("com.ibm.team.workitem.web.cache.internal.MultiWorkItemProxySave", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	constructor: function() {
	}
});

com.ibm.team.workitem.web.cache.internal.MultiWorkItemProxySave.saveWorkItems= function(toSave, onSuccess, onFailed, onError) {
	var saveArgMap= {};
	var saveArgsN= dojo.map(toSave, dojo.hitch(this, function(proxy, index, array) {
		var saveArgs= {};
		saveArgs.onSuccess= dojo.hitch(this, function(resultParameters) {
		});
		saveArgs.applyDelta= true;
		saveArgMap[proxy.getItemId()]= saveArgs;
		return proxy._getSaveAppArgs(saveArgs);
	}));
	var multiSaveComplete= dojo.hitch(this, function(result) {
		if (result.severity <= 2) {
			var dtos= {};
			var $subject= result.workItems;
			var $length= $subject.length;
			for (var $count= 0; $count < $length; $count++){
				var workItemDTO= $subject[$count];
				dtos[workItemDTO.itemId]= workItemDTO;
			}
			var $subject2= toSave;
			var $length2= $subject2.length;
			for (var $count2= 0; $count2 < $length2; $count2++){
				var proxy= $subject2[$count2];
				var workItemDTO= dtos[proxy.getItemId()];
				if (!(workItemDTO != null)) Assert.fail("workItemDTO != null", "com.ibm.team.workitem.web.cache.internal.MultiWorkItemProxySave:78");
				var saveArgs= saveArgMap[proxy.getItemId()];
				if (!(saveArgs != null)) Assert.fail("saveArgs != null", "com.ibm.team.workitem.web.cache.internal.MultiWorkItemProxySave:80");
				proxy._storeWorkItemCompleted(workItemDTO, saveArgs);
				proxy.clearRetainedState(true);
			}
			onSuccess();
		} else {
			onFailed(result);
		}
	});
	var multiSaveFailure= dojo.hitch(this, function(result) {
		onError(TeamRepositoryExceptionFactory.INSTANCE.createException(result));
	});
	WorkItemClient.postWorkItemN(new ServiceResponseHandler({'onSuccess': multiSaveComplete, 'onFailure': multiSaveFailure}, 'onSuccess', 'onFailure'), saveArgsN); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
};

})();
