/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.cache.internal.RequiredPropertiesUpdater"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Exception"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.lang.JavaScriptException"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.Context"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemClient"); //$NON-NLS-1$

(function() {
var Exception= com.ibm.jdojo.lang.Exception;
var JavaScriptException= com.ibm.jdojo.lang.JavaScriptException;
var jdojo= com.ibm.jdojo.lang.Runtime;
var ServiceResponseHandler= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var Context= com.ibm.team.workitem.web.client.internal.Context;
var WorkItemClient= com.ibm.team.workitem.web.client.internal.WorkItemClient;

var RequiredPropertiesUpdater= dojo.declare("com.ibm.team.workitem.web.cache.internal.RequiredPropertiesUpdater", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fConfiguration: null,

	fProjectAreaItemId: null,

	constructor: function(projectAreaItemId) {
		this.fProjectAreaItemId= projectAreaItemId;
	},

	handleAttributeChange: function(workItem, attributeId, callback) {
		if (this.fProjectAreaItemId == null) 
			return ;
		if (this.fConfiguration == null) {
			var transaction= new RequiredPropertiesTransaction();
			transaction.callback= callback;
			transaction.workItem= workItem;
			var callbackList= RequiredPropertiesUpdater.fTransactionsInProgress[this.fProjectAreaItemId];
			if (callbackList != null) {
				callbackList.push(transaction);
				return ;
			}
			callbackList= [transaction];
			RequiredPropertiesUpdater.fTransactionsInProgress[this.fProjectAreaItemId]= callbackList;
			var onSuccess= dojo.hitch(this, function(result) {
				var configuration= [];
				if (result != null) {
					var $subject2= result;
					var $length2= $subject2.length;
					for (var $count2= 0; $count2 < $length2; $count2++){
						var dto= $subject2[$count2];
						configuration.push(new ConditionConfiguration(dto));
					}
				}
				this.fConfiguration= configuration;
				var callbackList2= RequiredPropertiesUpdater.fTransactionsInProgress[this.fProjectAreaItemId];
				if (callbackList2 != null) {
					for (var i= 0; i < callbackList2.length; i++){
						this.handleRequiredAttributes(configuration, callbackList2[i].workItem, callbackList2[i].callback);
					}
					delete RequiredPropertiesUpdater.fTransactionsInProgress[this.fProjectAreaItemId];
				}
			});
			var onFailure= dojo.hitch(this, function(result) {
				console.error(result);
			});
			var handler= new ServiceResponseHandler({'onSuccess': onSuccess, 'onFailure': onFailure}, 'onSuccess', 'onFailure'); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
			var params= {};
			params.projectAreaItemId= this.fProjectAreaItemId;
			WorkItemClient.getRequiredAttributesConfiguration(handler, params);
		} else {
			this.handleRequiredAttributes(this.fConfiguration, workItem, callback);
		}
	},

	handleRequiredAttributes: function(configuration, workItem, callback) {
		if (configuration.length === 0) 
			return ;
		var attributes= {};
		var $subject3= configuration;
		var $length3= $subject3.length;
		for (var $count3= 0; $count3 < $length3; $count3++){
			var cfg= $subject3[$count3];
			if (cfg.matches(workItem)) {
				var $subject4= cfg.getAttributes();
				var $length4= $subject4.length;
				for (var $count4= 0; $count4 < $length4; $count4++){
					var attributeId= $subject4[$count4];
					attributes[attributeId]= true;
				}
			}
		}
		callback(jdojo.getProperties(attributes));
	}
});

RequiredPropertiesUpdater.fgInstances= {};
RequiredPropertiesUpdater.fTransactionsInProgress= {};
RequiredPropertiesUpdater.getRequiredPropertiesUpdater= function(projectAreaItemId) {
	var updater= RequiredPropertiesUpdater.fgInstances[projectAreaItemId];
	if (updater == null) {
		updater= new RequiredPropertiesUpdater(projectAreaItemId);
		RequiredPropertiesUpdater.fgInstances[projectAreaItemId]= updater;
	}
	return updater;
};
var RequiredPropertiesTransaction= dojo.declare("com.ibm.team.workitem.web.cache.internal.RequiredPropertiesUpdater.RequiredPropertiesTransaction", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	workItem: null,

	callback: null
});
var ConditionConfiguration= dojo.declare("com.ibm.team.workitem.web.cache.internal.RequiredPropertiesUpdater.ConditionConfiguration", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fClazz: null,

	fContext: null,

	fAttributes: null,

	constructor: function(dto) {
		this.fClazz= dojo.getObject(dto.scriptClass);
		this.fContext= new Context(ConditionConfiguration.getJSONProperty(dto, "configuration"), null); //$NON-NLS-1$
		this.fAttributes= ConditionConfiguration.getJSONProperty(dto, "attributes"); //$NON-NLS-1$
	},

	getAttributes: function() {
		return this.fAttributes;
	},

	matches: function(workItem) {
		if (this.fClazz != null) {
			var condition= jdojo.newInstance(this.fClazz);
			try {
				this.fContext.setWorkflowAction(workItem.getValue(ConditionConfiguration.WORKFLOW_ACTION));
				return condition.matches(workItem, this.fContext);
			} catch (e) {
				if ((e= e instanceof Exception ? e : new JavaScriptException(e)) instanceof Exception) {
					console.error(e);
				} else {
					throw e;
				}
			}
		}
		return false;
	}
});

ConditionConfiguration.WORKFLOW_ACTION= "workflowAction"; //$NON-NLS-1$
ConditionConfiguration.getJSONProperty= function(dto, key) {
	var $subject= dto.properties;
	var $length= $subject.length;
	for (var $count= 0; $count < $length; $count++){
		var property= $subject[$count];
		if ((key === property.key)) {
			if (property.value != null) {
				return dojo.fromJson(property.value);
			}
		}
	}
	return null;
};

})();
