/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.calm.foundation.web.calmdialogs.AbstractCALMDialogWidget"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.calm.foundation.web.calmdialogs.ModuleContext"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("dojox.xml.parser"); //$NON-NLS-1$
dojo.require("jazz.ui.RemoteChooserResponder"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.calm.foundation.web.internal.calmdialogs", "ModuleMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var Assert= com.ibm.jdojo.util.Assert;
var ModuleContext= com.ibm.team.calm.foundation.web.calmdialogs.ModuleContext;
var ModuleMessages= dojo.i18n.getLocalization("com.ibm.team.calm.foundation.web.internal.calmdialogs", "ModuleMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var _Templated= dijit._Templated;
var _Widget= dijit._Widget;
var parser= dojox.xml.parser;
var RemoteChooserResponder= jazz.ui.RemoteChooserResponder;

dojo.declare("com.ibm.team.calm.foundation.web.calmdialogs.AbstractCALMDialogWidget", [ _Widget, _Templated], { //$NON-NLS-1$

	templatePath: dojo.moduleUrl("com.ibm.team.calm.foundation.web", "calmdialogs/templates/AbstractCALMDialogWidget.html"), //$NON-NLS-1$ //$NON-NLS-2$

	_dialogArguments: null,

	_loadingMessage: null,

	_itemPickerNode: null,

	_context: null,

	_responder: null,

	constructor: function() {
		var searchString= window.location.search.replace(new RegExp("^\\?"), ""); //$NON-NLS-1$ //$NON-NLS-2$
		this._dialogArguments= dojo.queryToObject(searchString);
		this._responder= new RemoteChooserResponder();
	},

	postCreate: function() {
		this.inherited("postCreate", arguments, []); //$NON-NLS-1$
		var body= dojo.body();
		dojo.style(body, 'minWidth', "200px"); //$NON-NLS-1$ //$NON-NLS-2$
		dojo.style(body, 'background', "none"); //$NON-NLS-1$ //$NON-NLS-2$
		parser.replaceChildren(this._loadingMessage, window.document.createTextNode(ModuleMessages.busyLoading));
		this._initializeContext();
	},

	_initializeContext: function() {
		var successHandler= dojo.hitch(this, function(context) {
			this._initProject();
			return context;
		});
		var failureHandler= dojo.hitch(this, function(error) {
			this._handleError(ModuleMessages.msgCanNotInitializeContext);
			return error;
		});
		var deferred= new dojo.Deferred();
		deferred.addCallbacks(successHandler, failureHandler);
		this._context= new ModuleContext(deferred);
		this._context.initialize();
	},

	_initProject: function() {
		var name= this._dialogArguments["projectAreaName"]; //$NON-NLS-1$
		var itemId= this._dialogArguments["projectAreaId"]; //$NON-NLS-1$
		if (name != null) {
			this._context.setCurrentProjectAreaByName(name);
		} else if (itemId != null) {
			this._context.setCurrentProjectAreaByItemId(itemId);
		}
		var pa= this._context.getCurrentProjectArea();
		if (pa == null) {
			var msg= dojo.string.substitute(ModuleMessages.msgNoProjectAreaFound, [ name != null ? name : itemId ]) ;
			this._handleError(msg);
		} else {
			this._openDialog(pa);
		}
	},

	_openDialog: function(pa) {
		if (!(false)) Assert.fail("_openDialog must be implemented by sub classes", "com.ibm.team.calm.foundation.web.calmdialogs.AbstractCALMDialogWidget:100"); //$NON-NLS-1$
	},

	_handleError: function(message) {
		window.alert(message);
		this._close(null, null);
	},

	_setContentWidget: function(domNode) {
		this._itemPickerNode.removeChild(this._loadingMessage);
		this._itemPickerNode.appendChild(domNode);
	},

	_getHeight: function() {
		return this._itemPickerNode.clientHeight;
	},

	_getReturnNamespace: function() {
		Assert.isTrue(false, "Abstract method '_getReturnNamespace' invoked");
	},

	isOSLCCoreProtocol: function() {
		var protocol= window.location.hash;
		return ("#oslc-core-windowName-1.0" === protocol) || ("#oslc-core-postMessage-1.0" === protocol); //$NON-NLS-1$ //$NON-NLS-2$
	},

	_close: function(resultArray, returnMessage) {
		var newItems= [];
		var isOSLCCore= this.isOSLCCoreProtocol();
		var returnNamespace= isOSLCCore ? "oslc" : this._getReturnNamespace(); //$NON-NLS-1$
		if (resultArray != null) {
			for (var i= 0; i < resultArray.length; i++){
				var item= resultArray[i];
				var newItem= {};
				newItem["rdf:resource"]= item.url; //$NON-NLS-1$
				newItem[returnNamespace + ":label"]= item.summary; //$NON-NLS-1$
				newItems.push(newItem);
			}
		}
		var response= {};
		if (!isOSLCCore) {
			response[returnNamespace + ":message"]= returnMessage; //$NON-NLS-1$
		}
		response[returnNamespace + ":results"]= newItems; //$NON-NLS-1$
		this._responder.sendResponse(dojo.toJson(response, false));
	},

	updateSize: function(width, height) {
		this._responder.sendResize(width, height);
	}
});

})();
