/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.calm.foundation.web.calmdialogs.CALMDocument"); //$NON-NLS-1$

dojo.require("dojox.xml.DomParser"); //$NON-NLS-1$
dojo.require("jazz.app.auth"); //$NON-NLS-1$
dojo.require("jazz.client.xhr"); //$NON-NLS-1$

(function() {
var DomParser= dojox.xml.DomParser;

var CALMDocument= dojo.declare("com.ibm.team.calm.foundation.web.calmdialogs.CALMDocument", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	content: null,

	root: null,

	constructor: function(content) {
		this.content= content;
		this.root= null;
	},

	getContent: function() {
		return this.content;
	},

	getRoot: function() {
		if (this.root == null) {
			this.root= DomParser.parse(this.content);
		}
		return this.root;
	},

	getNodeText: function(xPath, xPathNamespaceContext) {
		return this.getNodeTextForNode(this.getRoot(), xPath, xPathNamespaceContext);
	},

	getNodeTextForNode: function(xmlNode, xPath, xPathNamespaceContext) {
		var node= this.getFirstNodeForNode(xmlNode, xPath, xPathNamespaceContext);
		if (node != null) 
			return this.getText(node);
		return null;
	},

	getNodes: function(xPath, xPathNamespaceContext) {
		return this.getNodesForNode(this.getRoot(), xPath, xPathNamespaceContext);
	},

	getNodesForNode: function(xmlNode, xPath, xPathNamespaceContext) {
		var segments= xPath.split("/"); //$NON-NLS-1$
		return this._collectNodes(xmlNode, segments, [], xPathNamespaceContext);
	},

	getAttributeText: function(xPath, xPathNamespaceContext) {
		return this.getAttributeTextForNode(this.getRoot(), xPath, xPathNamespaceContext);
	},

	getAttributeTextForNode: function(xmlNode, xPath, xPathNamespaceContext) {
		var index= xPath.lastIndexOf("/"); //$NON-NLS-1$
		if (index + 1 === xPath.length || xPath.charAt(index + 1) !== "@") { //$NON-NLS-1$
			return null;
		}
		var attributeName= xPath.substring(index + 2);
		if (index !== -1) {
			var node= this.getFirstNodeForNode(xmlNode, xPath.substring(0, index), xPathNamespaceContext);
			if (node != null) 
				return this._getAttribute(node, attributeName, xPathNamespaceContext);
			return null;
		}
		return this._getAttribute(xmlNode, attributeName, xPathNamespaceContext);
	},

	getFirstNode: function(xPath, xPathNamespaceContext) {
		return this.getFirstNodeForNode(this.getRoot(), xPath, xPathNamespaceContext);
	},

	getFirstNodeForNode: function(xmlNode, xPath, xPathNamespaceContext) {
		var nodes= this.getNodesForNode(xmlNode, xPath, xPathNamespaceContext);
		if (nodes.length > 0) 
			return nodes[0];
		return null;
	},

	_collectNodes: function(xmlNode, pathSegments, result, xPathNamespaceContext) {
		if (pathSegments.length === 0) {
			result.push(xmlNode);
			return result;
		}
		var first= pathSegments[0];
		var segments= pathSegments.slice(1);
		var regEx= new RegExp("([\\d\\w-_:]+)\\[(@?[\\d\\w-_:]+)='([^']+)'\\]"); //$NON-NLS-1$
		var matches= first.match(regEx);
		if (matches == null) {
			var nodes= this._getElementByTagName(xmlNode, first, xPathNamespaceContext);
			for (var i= 0; i < nodes.length; i++){
				this._collectNodes(nodes[i], segments, result, xPathNamespaceContext);
			}
			return result;
		} else {
			var elementName= matches[1];
			var matchName= matches[2];
			var matchVal= matches[3];
			var isAttribMatch= matchName.charAt(0) === "@"; //$NON-NLS-1$
			if (isAttribMatch) 
				matchName= matchName.substring(1);
			var nodes= this._getElementByTagName(xmlNode, elementName, xPathNamespaceContext);
			for (var i= 0; i < nodes.length; i++){
				var node= nodes[i];
				if (isAttribMatch) {
					if (this._getAttribute(node, matchName, xPathNamespaceContext) === matchVal) {
						this._collectNodes(node, segments, result, xPathNamespaceContext);
					}
				} else {
					var innerNodes= this._getElementByTagName(node, matchName, xPathNamespaceContext);
					if (innerNodes.length === 1 && this.getText(innerNodes[0]) === matchVal) {
						this._collectNodes(node, segments, result, xPathNamespaceContext);
					}
				}
			}
			return result;
		}
	},

	getText: function(node) {
		if (node.childNodes.length === 1 && ("#text" === node.childNodes[0].nodeName)) { //$NON-NLS-1$
			return node.childNodes[0].nodeValue;
		}
		return null;
	},

	_getAttribute: function(node, name, xPathNamespaceContext) {
		var s= name.split(":", 2); //$NON-NLS-1$
		if (s.length === 1) {
			return node.getAttribute(name);
		} else {
			var ns= xPathNamespaceContext.getNamespaceURI(s[0]);
			return node.getAttributeNS(s[1], ns);
		}
	},

	_getElementByTagName: function(node, name, xPathNamespaceContext) {
		var s= name.split(":", 2); //$NON-NLS-1$
		if (s.length === 1) {
			return node.childrenByName(name);
		} else {
			var ns= xPathNamespaceContext.getNamespaceURI(s[0]);
			return node.childrenByNameNS(s[1], ns);
		}
	}
});

CALMDocument.load= function(documentURL, resultCallback, requestHeaders) {
	var args= {};
	args.url= documentURL;
	args.headers= requestHeaders;
	args.load= dojo.hitch(this, function(response, ioArgs) {
		resultCallback.callback(new CALMDocument(response));
	});
	args.error= dojo.hitch(this, function(response, ioArgs) {
		resultCallback.errback(response);
	});
	jazz.client.xhrGet(args);
};

})();
