/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.calm.foundation.web.calmdialogs.ModuleContext"); //$NON-NLS-1$

dojo.require("com.ibm.team.calm.foundation.web.client.ContributorClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.calm.foundation.web.client.ProcessClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("jazz.app.context"); //$NON-NLS-1$

(function() {
var ContributorClient= com.ibm.team.calm.foundation.web.client.ContributorClient;
var ProcessClient= com.ibm.team.calm.foundation.web.client.ProcessClient;
var ServiceResponseHandler= com.ibm.team.repository.web.transport.ServiceResponseHandler;

dojo.declare("com.ibm.team.calm.foundation.web.calmdialogs.ModuleContext", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	deferred: null,

	contributor: null,

	projectAreas: null,

	_currentProjectArea: null,

	constructor: function(deferred) {
		this.deferred= deferred;
	},

	initialize: function() {
		var onSuccess= dojo.hitch(this, "_onContributorEvaluated"); //$NON-NLS-1$
		var onFailure= dojo.hitch(this, "_onFailure"); //$NON-NLS-1$
		var handler= new ServiceResponseHandler({'onSuccess': onSuccess, 'onFailure': onFailure}, 'onSuccess', 'onFailure'); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		ContributorClient.getCurrentContributor(handler);
	},

	findProjectAreaByName: function(name) {
		for (var i= 0; i < this.projectAreas.length; i++){
			if ((name === this.projectAreas[i].name)) {
				return this.projectAreas[i];
			}
		}
		return null;
	},

	findProjectAreaById: function(itemId) {
		for (var i= 0; i < this.projectAreas.length; i++){
			if ((itemId === this.projectAreas[i].itemId)) {
				return this.projectAreas[i];
			}
		}
		return null;
	},

	setCurrentProjectAreaByName: function(name) {
		var projectArea= this.findProjectAreaByName(name);
		if (projectArea != null) 
			this.setCurrentProjectArea(projectArea);
	},

	setCurrentProjectAreaByItemId: function(itemId) {
		var projectArea= this.findProjectAreaById(itemId);
		if (projectArea != null) 
			this.setCurrentProjectArea(projectArea);
	},

	setCurrentProjectArea: function(projectArea) {
		this._currentProjectArea= projectArea;
		jazz.app.context.set(projectArea);
	},

	getCurrentProjectArea: function() {
		return this._currentProjectArea;
	},

	_onContributorEvaluated: function(contributor) {
		this.contributor= contributor;
		dojo.setObject("com.ibm.team.repository.web.client.internal.AUTHENTICATED_CONTRIBUTOR", contributor); //$NON-NLS-1$
		var onSuccess= dojo.hitch(this, "_onProjectAreasEvaluated"); //$NON-NLS-1$
		var onFailure= dojo.hitch(this, "_onFailure"); //$NON-NLS-1$
		var params= {};
		params.hideArchivedProjects= true;
		params.userId= contributor.userId;
		var handler= new ServiceResponseHandler({'onSuccess': onSuccess, 'onFailure': onFailure}, 'onSuccess', 'onFailure'); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		ProcessClient.getAllProjectAreas(handler, params);
	},

	_onProjectAreasEvaluated: function(projectAreas) {
		this.projectAreas= projectAreas;
		this.deferred.callback(this);
	},

	_onFailure: function(error) {
		this.deferred.errback(error);
	},

	toString: function() {
		var result= "Contributor: " + this.contributor.name + ", project areas: "; //$NON-NLS-1$ //$NON-NLS-2$
		for (var i= 0; i < this.projectAreas.length; i++){
			result+= this.projectAreas[i].name + ", "; //$NON-NLS-1$
		}
		return result;
	}
});

})();
