/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.calm.foundation.web.calmdialogs.RemoteItemPicker"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.JavaScriptException"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("jazz.ui.Dialog"); //$NON-NLS-1$
dojo.require("jazz.ui.RemoteChooserContainer"); //$NON-NLS-1$

(function() {
var JavaScriptException= com.ibm.jdojo.lang.JavaScriptException;
var _Widget= dijit._Widget;
var Dialog= jazz.ui.Dialog;
var RemoteChooserContainer= jazz.ui.RemoteChooserContainer;

dojo.declare("com.ibm.team.calm.foundation.web.calmdialogs.RemoteItemPicker", _Widget, { //$NON-NLS-1$

	dialogTitle: null,

	secondaryTitle: null,

	pickerURL: null,

	width: null,

	height: null,

	namespace: null,

	onOk: null,

	floatingPane: null,

	dialogContent: null,

	fContainerElement: null,

	constructor: function(args) {
		if (args.dialogTitle == null) 
			throw new JavaScriptException("Missing 'dialogTitle'"); //$NON-NLS-1$
		if (args.namespace == null) 
			throw new JavaScriptException("Missing 'namespace'"); //$NON-NLS-1$
		if (args.pickerURL == null) 
			throw new JavaScriptException("Missing 'pickerURL'"); //$NON-NLS-1$
		if (args.onOk == null) 
			throw new JavaScriptException("Missing 'onOk'"); //$NON-NLS-1$
	},

	postCreate: function() {
		var frameSrc= this.pickerURL;
		var frameContainerArgs= {};
		frameContainerArgs.remoteLocation= frameSrc;
		frameContainerArgs.mode= ("oslc" === this.namespace) ? 'OSLC2' : 'OSLC1'; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		frameContainerArgs.onData= dojo.hitch(this, "_onData"); //$NON-NLS-1$
		frameContainerArgs.onResize= dojo.hitch(this, "_onResize"); //$NON-NLS-1$
		this.dialogContent= new RemoteChooserContainer(frameContainerArgs);
		this.fContainerElement= window.document.createElement("div"); //$NON-NLS-1$
		this.fContainerElement.appendChild(this.dialogContent.domNode);
		dojo.style(this.fContainerElement, "width", this.width); //$NON-NLS-1$
		dojo.style(this.fContainerElement, "height", this.height); //$NON-NLS-1$
		var floatingPaneParams= {};
		floatingPaneParams.primaryTitle= this.dialogTitle;
		floatingPaneParams.secondaryTitle= this.secondaryTitle;
		if (dojo.isIE && dojo.isIE <= 7) {
			floatingPaneParams.height= this.add(this.height, 5);
			floatingPaneParams.width= this.add(this.width, 7);
		} else {
			floatingPaneParams.height= ""; //$NON-NLS-1$
			floatingPaneParams.width= ""; //$NON-NLS-1$
		}
		floatingPaneParams.contentNode= this.fContainerElement;
		floatingPaneParams.onClose= dojo.hitch(this, function() {
			this.floatingPane= null;
			this.destroy(false);
			return true;
		});
		this.floatingPane= new Dialog(floatingPaneParams);
	},

	add: function(size, incr) {
		size= dojo.trim(size);
		if (this.endsWith(size, "px")) { //$NON-NLS-1$
			var val= parseInt(size.substring(0, size.length - 2)) + incr;
			return String(val) + "px"; //$NON-NLS-1$
		} else if (this.endsWith(size, "em")) { //$NON-NLS-1$
			var val= parseInt(size.substring(0, size.length - 2)) + ((incr / 10)|0);
			return String(val) + "em"; //$NON-NLS-1$
		}
		return size;
	},

	limitToMax: function(size, max, min) {
		size= dojo.trim(size);
		if (this.endsWith(size, "px")) { //$NON-NLS-1$
			var pixels= parseInt(size.substring(0, size.length - 2));
			if (pixels > max && max >= min) {
				return String(max) + "px"; //$NON-NLS-1$
			}
		} else if (this.endsWith(size, "em")) { //$NON-NLS-1$
			var pixels= parseInt(size.substring(0, size.length - 2)) * 10;
			if (pixels > max && max >= min) {
				return String(max) + "px"; //$NON-NLS-1$
			}
		}
		return size;
	},

	endsWith: function(str, end) {
		return str.indexOf(end) === (str.length - end.length);
	},

	_onResize: function(width, height) {
		var viewport= dijit.getViewport();
		if (width != null) {
			width= this.limitToMax(width, viewport.w - 40, 300);
			if (dojo.isIE && dojo.isIE <= 7) {
				this.floatingPane.setWidth(this.add(width, 7));
			} else {
				dojo.style(this.fContainerElement, "width", width); //$NON-NLS-1$
				this.floatingPane.setWidth(undefined);
			}
		}
		if (height != null) {
			height= this.limitToMax(height, viewport.h - 40, 300);
			if (dojo.isIE && dojo.isIE <= 7) {
				this.floatingPane.setHeight(this.add(height, 5));
			} else {
				dojo.style(this.fContainerElement, "height", height); //$NON-NLS-1$
				this.floatingPane.setHeight(undefined);
			}
		}
		this.floatingPane.updatePosition(null);
	},

	_onData: function(data) {
		this.floatingPane.close(null);
		if (data.length !== 0) {
			var response= dojo.fromJson(data);
			var resourceKey= "rdf:resource"; //$NON-NLS-1$
			var labelKey= this.namespace + ":label"; //$NON-NLS-1$
			var newItemsElem= response[this.namespace + ":results"]; //$NON-NLS-1$
			if (!dojo.isArray(newItemsElem) && this.namespace === "oslc_rm") { //$NON-NLS-1$
				newItemsElem= response["http://open-services.net/xmlns/rm/1.0/web/results"]; //$NON-NLS-1$
				resourceKey= "http://www.w3.org/1999/02/22-rdf-syntax-ns#resource"; //$NON-NLS-1$
				labelKey= "http://www.w3.org/2000/01/rdf-schema#label"; //$NON-NLS-1$
			}
			if (dojo.isArray(newItemsElem)) {
				var newItems= newItemsElem;
				var result= [];
				if (newItems.length > 0) {
					for (var i= 0; i < newItems.length; i++){
						var item= newItems[i];
						var elem= {};
						elem.url= item[resourceKey];
						elem.label= item[labelKey];
						result.push(elem);
					}
				}
				this.onOk(result);
			}
		}
	},

	destroy: function(preserveDom) {
		if (this.floatingPane != null) {
			this.floatingPane.destroy(preserveDom);
			this.floatingPane= null;
		}
		if (this.dialogContent != null) {
			this.dialogContent.destroy(preserveDom);
			this.dialogContent= null;
		}
		this.inherited("destroy", arguments, [preserveDom]); //$NON-NLS-1$
	}
});

})();
