/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.calm.foundation.web.calmdialogs.ServiceProviderSelectionDialog"); //$NON-NLS-1$

dojo.require("com.ibm.team.calm.foundation.web.calmdialogs.RemoteItemPicker"); //$NON-NLS-1$
dojo.require("com.ibm.team.calm.foundation.web.client.CALMFoundationClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("jazz.ui.Dialog"); //$NON-NLS-1$
dojo.require("jazz.ui.MessageBox"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.calm.foundation.web.calmdialogs", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var Messages= dojo.i18n.getLocalization("com.ibm.team.calm.foundation.web.calmdialogs", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
var RemoteItemPicker= com.ibm.team.calm.foundation.web.calmdialogs.RemoteItemPicker;
var CALMFoundationClient= com.ibm.team.calm.foundation.web.client.CALMFoundationClient;
var ServiceResponseHandler= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var _Templated= dijit._Templated;
var _Widget= dijit._Widget;
var Dialog= jazz.ui.Dialog;
var MessageBox= jazz.ui.MessageBox;

var ServiceProviderSelectionDialog= dojo.declare("com.ibm.team.calm.foundation.web.calmdialogs.ServiceProviderSelectionDialog", [ _Widget, _Templated], { //$NON-NLS-1$

	templatePath: dojo.moduleUrl("com.ibm.team.calm.foundation.web", "calmdialogs/templates/ServiceProviderSelectionDialog.html"), //$NON-NLS-1$ //$NON-NLS-2$

	fMessages: Messages,

	ftArtifactContainerList: null,

	ftSelectRadio: null,

	ftCreateRadio: null,

	ftOkButton: null,

	ftCancelButton: null,

	ftMessageBox: null,

	ftSelectParent: null,

	ftCreateParent: null,

	fTitle: null,

	fIconUrl: null,

	fFilterLinkTypeId: null,

	fServiceProviders: null,

	fProjectAreaItemId: null,

	fResultCallback: null,

	fSelectionDialogs: null,

	fCreationDialogs: null,

	fDialog: null,

	fMessageBox: null,

	fSelectedPicker: null,

	fSelectHandles: null,

	fCreateHandles: null,

	fIsDestroyed: null,

	constructor: function(params) {
		this.fTitle= params.title;
		this.fIconUrl= params.iconUrl;
		this.fServiceProviders= params.serviceProviderDTOs;
		this.fProjectAreaItemId= params.projectAreaItemId;
		this.fResultCallback= params.resultCallback;
		this.fFilterLinkTypeId= params.linkTypeId;
	},

	postCreate: function() {
		this.inherited("postCreate", arguments, []); //$NON-NLS-1$
		this.fMessageBox= new MessageBox();
		dojo.place(this.fMessageBox.domNode, this.ftMessageBox, 'only'); //$NON-NLS-1$
		this.populateArtifactContainerList();
		this.connectHandlers();
		this.updateEnablement();
		this.fIsDestroyed= false;
	},

	open: function() {
		var args= {};
		args.iconPath= this.fIconUrl;
		args.primaryTitle= Messages.ServiceProviderSelectionDialog_ADD_LINK;
		args.secondaryTitle= this.fTitle;
		args.contentNode= this.domNode;
		args.width= "32em"; //$NON-NLS-1$
		args.onClose= dojo.hitch(this, function() {
			this.onDialogClosed();
			return true;
		});
		this.fDialog= new Dialog(args);
	},

	populateArtifactContainerList: function() {
		dojo.empty(this.ftArtifactContainerList);
		var selectedProvider= null;
		var $subject= this.fServiceProviders;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var descriptor= $subject[$count];
			if (this.fFilterLinkTypeId != null && !(this.fFilterLinkTypeId === descriptor.itemLinkType)) 
				continue;
			var selected= (this.fServiceProviders.length === 1) || (descriptor.serviceDocumentUrl === ServiceProviderSelectionDialog.fgLastSelectedServiceProviderURLs[descriptor.itemLinkType]);
			if (selected) {
				selectedProvider= descriptor;
			}
			this.createOption(this.ftArtifactContainerList, descriptor.name, selected);
		}
		if (selectedProvider != null) {
			this.loadDialogDescriptions(selectedProvider);
		}
	},

	connectHandlers: function() {
		this.connect(this.ftOkButton, 'click', dojo.hitch(this, function(event) { //$NON-NLS-1$
			this.onOk(event);
		}));
		this.connect(this.ftCancelButton, 'click', dojo.hitch(this, function(event) { //$NON-NLS-1$
			this.onCancel(event);
		}));
		this.connect(this.ftArtifactContainerList, 'change', dojo.hitch(this, function(event) { //$NON-NLS-1$
			this.onArtifactContainerChange(event.currentTarget);
		}));
	},

	onPickerComboChange: function(event, combo, dialogs) {
		var index= combo != null ? combo.selectedIndex : 0;
		this.fSelectedPicker= dialogs[index];
		this.updateEnablement();
	},

	onArtifactContainerChange: function(combo) {
		this.fMessageBox.hideMessage();
		var index= combo.selectedIndex;
		if (index >= 0 && index < this.fServiceProviders.length) {
			var descriptor= this.fServiceProviders[index];
			this.loadDialogDescriptions(descriptor);
		}
	},

	loadDialogDescriptions: function(descriptor) {
		var parms= {};
		parms.projectAreaItemId= this.fProjectAreaItemId;
		parms.itemLinkType= descriptor.itemLinkType;
		parms.serviceDocumentUrl= descriptor.serviceDocumentUrl;
		var context= {};
		context["onSuccess"]= dojo.hitch(this, function(result) { //$NON-NLS-1$
			if (!this.fIsDestroyed) {
				this.fMessageBox.hideMessage();
				ServiceProviderSelectionDialog.fgLastSelectedServiceProviderURLs[descriptor.itemLinkType]= descriptor.serviceDocumentUrl;
				this.handlePickerDescriptions(result);
			}
		});
		context["onFailure"]= dojo.hitch(this, function(error) { //$NON-NLS-1$
			if (!this.fIsDestroyed) {
				this.handleError(error);
			}
		});
		var sh= new ServiceResponseHandler(context, "onSuccess", "onFailure"); //$NON-NLS-1$ //$NON-NLS-2$
		this.fMessageBox.showMessage({summary: Messages.ServiceProviderSelectionDialog_LOADING, type: 'INFO'}); //$NON-NLS-1$
		CALMFoundationClient.getAllPickerDescriptions(sh, parms);
	},

	handlePickerDescriptions: function(result) {
		if (result != null && result.length === 1 && this.fServiceProviders.length === 1) {
			this.fDialog.close(null);
			this.openPicker(result[0]);
			return ;
		}
		this.fSelectedPicker= null;
		this.fCreationDialogs= [];
		this.fSelectionDialogs= [];
		if (result != null) {
			var sortedPickers= result.sort(dojo.hitch(this, function(p1, p2) {
				var left= p1 != null ? p1.title : null;
				var right= p2 != null ? p2.title : null;
				if (left == null && right == null) {
					return 0;
				}
				if (left == null) 
					return 1;
				if (right == null) 
					return -1;
				return left.localeCompare(right);
			}));
			var $subject2= sortedPickers;
			var $length2= $subject2.length;
			for (var $count2= 0; $count2 < $length2; $count2++){
				var pickerDescription= $subject2[$count2];
				if (pickerDescription.pickerType === 'CREATION') { //$NON-NLS-1$
					this.fCreationDialogs.push(pickerDescription);
				} else if (pickerDescription.pickerType === 'SELECTION') { //$NON-NLS-1$
					this.fSelectionDialogs.push(pickerDescription);
				}
			}
			var selectionCombo= this.createControl(this.fSelectionDialogs, this.ftSelectParent);
			this.fSelectHandles= this.connectElements(selectionCombo, this.ftSelectRadio, this.fSelectionDialogs, this.fSelectHandles);
			var creationCombo= this.createControl(this.fCreationDialogs, this.ftCreateParent);
			this.fCreateHandles= this.connectElements(creationCombo, this.ftCreateRadio, this.fCreationDialogs, this.fCreateHandles);
			if (!(this.fSelectionDialogs.length == 0)) {
				this.fSelectedPicker= this.fSelectionDialogs[0];
			} else if (!(this.fCreationDialogs.length == 0)) {
				this.fSelectedPicker= this.fCreationDialogs[0];
			}
		} else {
			this.fMessageBox.showMessage({summary: Messages.ServiceProviderSelectionDialog_NO_PICKERS, type: 'INFO'}); //$NON-NLS-1$
		}
		this.updateEnablement();
	},

	createControl: function(pickers, parent) {
		var select= null;
		dojo.empty(parent);
		if (pickers.length > 1) {
			select= dojo.create("select", null, parent); //$NON-NLS-1$
			var $subject3= pickers;
			var $length3= $subject3.length;
			for (var $count3= 0; $count3 < $length3; $count3++){
				var pickerDescription= $subject3[$count3];
				this.createOption(select, pickerDescription.label, false);
			}
		} else if (pickers.length === 1) {
			dojo.create("span", {innerHTML: jazz.util.html.escape(pickers[0].label)}, parent); //$NON-NLS-1$
		} else {
			dojo.create("span", {innerHTML: Messages.ServiceProviderSelectionDialog_NOT_AVLBL}, parent); //$NON-NLS-1$
		}
		return select;
	},

	createOption: function(parent, title, preselect) {
		return dojo.create("option", {selected: preselect, defaultSelected: preselect, innerHTML: jazz.util.html.escape(title)}, parent); //$NON-NLS-1$
	},

	connectElements: function(select, radio, pickers, existing) {
		if (existing != null) {
			var $subject4= existing;
			var $length4= $subject4.length;
			for (var $count4= 0; $count4 < $length4; $count4++){
				var handle= $subject4[$count4];
				this.disconnect(handle);
			}
		}
		var handles= [];
		if (select != null) {
			handles.push(this.connect(select, 'change', dojo.hitch(this, function(event) { //$NON-NLS-1$
				this.onPickerComboChange(event, select, pickers);
			})));
		}
		handles.push(this.connect(radio, 'click', dojo.hitch(this, function(event) { //$NON-NLS-1$
			this.onPickerComboChange(event, select, pickers);
		})));
		return handles;
	},

	updateEnablement: function() {
		var creationOptions= this.fCreationDialogs == null ? 0 : this.fCreationDialogs.length;
		var selectionOptions= this.fSelectionDialogs == null ? 0 : this.fSelectionDialogs.length;
		this.ftCreateRadio.disabled= creationOptions === 0;
		this.ftSelectRadio.disabled= selectionOptions === 0;
		if (this.fSelectedPicker == null) {
			this.ftOkButton.disabled= "true"; //$NON-NLS-1$
			this.ftSelectRadio.checked= this.ftSelectRadio.defaultChecked= false;
			this.ftCreateRadio.checked= this.ftCreateRadio.defaultChecked= false;
		} else {
			this.ftOkButton.disabled= null;
			this.ftSelectRadio.checked= this.ftSelectRadio.defaultChecked= (this.fSelectedPicker.pickerType === 'SELECTION'); //$NON-NLS-1$
			this.ftCreateRadio.checked= this.ftCreateRadio.defaultChecked= (this.fSelectedPicker.pickerType === 'CREATION'); //$NON-NLS-1$
		}
	},

	handleError: function(error) {
		this.fMessageBox.showMessage({summary: error.message, type: 'ERROR'}); //$NON-NLS-1$
	},

	onOk: function(event) {
		if (this.fSelectedPicker != null) {
			this.fDialog.close(event);
			this.openPicker(this.fSelectedPicker);
		}
	},

	openPicker: function(picker) {
		var params= {};
		params.dialogTitle= picker.title;
		params.secondaryTitle= ""; //$NON-NLS-1$
		params.width= picker.widthHint;
		params.height= picker.heightHint;
		params.namespace= picker.namespace;
		params.pickerURL= picker.url;
		params.parentElement= this.domNode;
		params.onOk= this.fResultCallback;
		new RemoteItemPicker(params);
	},

	onCancel: function(event) {
		this.fDialog.close(event);
	},

	onDialogClosed: function() {
		this.fDialog= null;
		this.destroy(false);
	},

	destroy: function(preserveDom) {
		if (this.fDialog != null) {
			this.fDialog.destroy(preserveDom);
			this.fDialog= null;
		}
		if (this.fMessageBox != null) {
			this.fMessageBox.destroy(preserveDom);
			this.fMessageBox= null;
		}
		this.fIsDestroyed= true;
		this.inherited("destroy", arguments, [preserveDom]); //$NON-NLS-1$
	}
});

ServiceProviderSelectionDialog.fgLastSelectedServiceProviderURLs= {};

})();
