/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.calm.foundation.web.calmdialogs.testapp.CALMDialogsTestWidget"); //$NON-NLS-1$

dojo.require("com.ibm.team.calm.foundation.web.calmdialogs.CALMDocument"); //$NON-NLS-1$
dojo.require("com.ibm.team.calm.foundation.web.calmdialogs.ModuleContext"); //$NON-NLS-1$
dojo.require("com.ibm.team.calm.foundation.web.calmdialogs.NamespaceContext"); //$NON-NLS-1$
dojo.require("com.ibm.team.calm.foundation.web.calmdialogs.testapp.BackLinkCreationTestDialog"); //$NON-NLS-1$
dojo.require("com.ibm.team.calm.foundation.web.calmdialogs.testapp.RemoteItemPickerOpener"); //$NON-NLS-1$
dojo.require("com.ibm.team.calm.foundation.web.calmdialogs.testapp.TestLoggerWidget"); //$NON-NLS-1$
dojo.require("com.ibm.team.calm.foundation.web.client.CALMFoundationClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("dojox.xml.parser"); //$NON-NLS-1$
dojo.require("jazz.app.auth"); //$NON-NLS-1$
dojo.require("jazz.ui.ResourceLink"); //$NON-NLS-1$

(function() {
var CALMDocument= com.ibm.team.calm.foundation.web.calmdialogs.CALMDocument;
var ModuleContext= com.ibm.team.calm.foundation.web.calmdialogs.ModuleContext;
var NamespaceContext= com.ibm.team.calm.foundation.web.calmdialogs.NamespaceContext;
var BackLinkCreationTestDialog= com.ibm.team.calm.foundation.web.calmdialogs.testapp.BackLinkCreationTestDialog;
var RemoteItemPickerOpener= com.ibm.team.calm.foundation.web.calmdialogs.testapp.RemoteItemPickerOpener;
var TestLoggerWidget= com.ibm.team.calm.foundation.web.calmdialogs.testapp.TestLoggerWidget;
var CALMFoundationClient= com.ibm.team.calm.foundation.web.client.CALMFoundationClient;
var ServiceResponseHandler= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var _Templated= dijit._Templated;
var _Widget= dijit._Widget;
var parser= dojox.xml.parser;
var ResourceLink= jazz.ui.ResourceLink;

/**
 * Open with https://localhost:9443/jazz/_ajax-modules/com.ibm.team.calm.foundation.CALMDialogsTestWidget?debug=true
 *
 */
var CALMDialogsTestWidget= dojo.declare("com.ibm.team.calm.foundation.web.calmdialogs.testapp.CALMDialogsTestWidget", [ _Widget, _Templated], { //$NON-NLS-1$

	templatePath: dojo.moduleUrl("com.ibm.team.calm.foundation.web", "calmdialogs/testapp/templates/CALMDialogsTestWidget.html"), //$NON-NLS-1$ //$NON-NLS-2$

	serverUrl: null,

	projectAreaInputContainer: null,

	relatedAreasContainer: null,

	pickedResourcesContainer: null,

	serviceProviderContainer: null,

	loggerContainer: null,

	xPathNamespaceContext: null,

	projectAreaInput: null,

	relatedAreas: null,

	pickerTypeSelectCM: null,

	creationTypeSelectCM: null,

	pickerTypeSelectAPT: null,

	creationTypeSelectAPT: null,

	context: null,

	pickerDialogsCM: null,

	creationDialogsCM: null,

	pickerDialogsAPT: null,

	creationDialogsAPT: null,

	logger: null,

	remoteItemPicker: null,

	pickerResultCallBack: null,

	constructor: function() {
		this.xPathNamespaceContext= NamespaceContext.getDefaultNamespaceContext();
		this.pickerResultCallBack= dojo.hitch(this, function(result) {
			this._onResourcePicked(result);
		});
	},

	postCreate: function() {
		var loggerWidget= new TestLoggerWidget();
		this.loggerContainer.appendChild(loggerWidget.domNode);
		this.logger= loggerWidget;
		this.serverUrl.value= "https://" + window.location.host + net.jazz.ajax._contextRoot; //$NON-NLS-1$
		dojo.addOnLoad(dojo.hitch(this, function() {
			this._initializeContext();
		}));
	},

	_initializeContext: function() {
		var successHandler= dojo.hitch(this, function(context) {
			this._updateProjectAreaCombo();
			return context;
		});
		var failureHandler= dojo.hitch(this, function(error) {
			this._handleError(error);
			return error;
		});
		var deferred= new dojo.Deferred();
		deferred.addCallbacks(successHandler, failureHandler);
		this.context= new ModuleContext(deferred);
		this.context.initialize();
	},

	_updateProjectAreaCombo: function() {
		if (this.projectAreaInput != null) {
			this.projectAreaInputContainer.removeChild(this.projectAreaInput);
		}
		var documentURL= this.serverUrl.value + "/process/project-areas"; //$NON-NLS-1$
		var successHandler= dojo.hitch(this, function(content) {
			this._fillProjectAreaCombo(content);
			return content;
		});
		this._loadDocument(documentURL, successHandler, null);
	},

	_fillProjectAreaCombo: function(projectAreaDescXML) {
		var namespace= this.xPathNamespaceContext.getNamespaceURI("jp06"); //$NON-NLS-1$
		var select= window.document.createElement("select"); //$NON-NLS-1$
		select.className= "control"; //$NON-NLS-1$
		dojo.connect(select, "onchange", dojo.hitch(this, function(e) { //$NON-NLS-1$
			this._onProjectAreaChange();
		}));
		var projectAreaRootNodes= projectAreaDescXML.getRoot().getElementsByTagNameNS("project-areas", namespace); //$NON-NLS-1$
		if (projectAreaRootNodes.length === 1) {
			var projectAreaNodes= projectAreaRootNodes[0].getElementsByTagNameNS("project-area", namespace); //$NON-NLS-1$
			for (var i= 0; i < projectAreaNodes.length; i++){
				var name= projectAreaNodes[i].getAttributeNS("name", namespace); //$NON-NLS-1$
				var linkURL= projectAreaDescXML.getNodeTextForNode(projectAreaNodes[i], "jp06:links-url", this.xPathNamespaceContext); //$NON-NLS-1$
				if (linkURL != null) {
					var option= window.document.createElement("option"); //$NON-NLS-1$
					option.value= linkURL;
					option.setAttribute("_name", name); //$NON-NLS-1$
					option.appendChild(window.document.createTextNode(name));
					select.appendChild(option);
				}
			}
			this.projectAreaInput= select;
			this.projectAreaInputContainer.appendChild(select);
			this._onProjectAreaChange();
		}
	},

	_onProjectAreaChange: function() {
		var linkCollectionURL= this.projectAreaInput.value;
		this.context.setCurrentProjectAreaByName(this._getSelectedProjectArea());
		var params= {};
		params.domNode= this.domNode;
		params.logger= this.logger;
		params.projectId= this.context.getCurrentProjectArea().itemId;
		this.remoteItemPicker= new RemoteItemPickerOpener(params);
		var successHandler= dojo.hitch(this, function(content) {
			this._fillProjectLinksTable(content);
			return content;
		});
		this._loadDocument(linkCollectionURL, successHandler, null);
		this._loadCatalog();
		this._fillItemLinksTable();
	},

	_loadCatalog: function() {
		var catalogURL= this.serverUrl.value + "/oslc/workitems/catalog"; //$NON-NLS-1$
		var successHandler= dojo.hitch(this, function(content) {
			this._loadServices(content);
			return content;
		});
		var header= {};
		header["Accept"]= "text/xml"; //$NON-NLS-1$ //$NON-NLS-2$
		this._loadDocument(catalogURL, successHandler, header);
	},

	_loadServices: function(content) {
		var projectAreaName= this.context.getCurrentProjectArea().name;
		var serviceURL= content.getAttributeText("oslc_disc:ServiceProviderCatalog/oslc_disc:entry/oslc_disc:ServiceProvider[dc:title='" + projectAreaName + "']/oslc_disc:services/@rdf:resource", this.xPathNamespaceContext); //$NON-NLS-1$ //$NON-NLS-2$
		if (serviceURL != null) {
			var successHandler= dojo.hitch(this, function(content) {
				this.pickerDialogsCM= this._getDialogsFromServiceDoc(content, "changeRequests", "selectionDialog"); //$NON-NLS-1$ //$NON-NLS-2$
				this.creationDialogsCM= this._getDialogsFromServiceDoc(content, "changeRequests", "creationDialog"); //$NON-NLS-1$ //$NON-NLS-2$
				this.pickerDialogsAPT= this._getDialogsFromServiceDoc(content, "plans", "selectionDialog"); //$NON-NLS-1$ //$NON-NLS-2$
				this.creationDialogsAPT= this._getDialogsFromServiceDoc(content, "plans", "creationDialog"); //$NON-NLS-1$ //$NON-NLS-2$
				this._populateSelect(this.pickerDialogsCM, this.pickerTypeSelectCM);
				this._populateSelect(this.creationDialogsCM, this.creationTypeSelectCM);
				this._populateSelect(this.pickerDialogsAPT, this.pickerTypeSelectAPT);
				this._populateSelect(this.creationDialogsAPT, this.creationTypeSelectAPT);
				return content;
			});
			this._loadDocument(serviceURL, successHandler, null);
		} else {
			this.log("No entry found for " + projectAreaName + ". " + content.getContent()); //$NON-NLS-1$ //$NON-NLS-2$
		}
	},

	_getDialogsFromServiceDoc: function(content, itemName, dialogName) {
		var nodes= content.getNodes("oslc_cm:ServiceDescriptor/oslc_cm:" + itemName + "/oslc_cm:" + dialogName, this.xPathNamespaceContext); //$NON-NLS-1$ //$NON-NLS-2$
		var pickerDescriptions= [];
		var $subject= nodes;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var node= $subject[$count];
			var pd= {};
			pd.title= content.getNodeTextForNode(node, "dc:title", this.xPathNamespaceContext); //$NON-NLS-1$
			pd.url= content.getNodeTextForNode(node, "oslc_cm:url", this.xPathNamespaceContext); //$NON-NLS-1$
			pd.widthHint= content.getAttributeTextForNode(node, "@oslc_cm:hintWidth", this.xPathNamespaceContext); //$NON-NLS-1$
			pd.heightHint= content.getAttributeTextForNode(node, "@oslc_cm:hintHeight", this.xPathNamespaceContext); //$NON-NLS-1$
			pd.namespace= "oslc_cm"; //$NON-NLS-1$
			pickerDescriptions.push(pd);
		}
		return pickerDescriptions;
	},

	_loadServicesV2: function(content) {
		var projectAreaName= this.context.getCurrentProjectArea().name;
		this.pickerDialogsCM= this._getDialogsFromServiceDocV2(content, projectAreaName, "http://open-services.net/ns/cm#ChangeRequest", "oslc:selectionDialog"); //$NON-NLS-1$ //$NON-NLS-2$
		this.creationDialogsCM= this._getDialogsFromServiceDocV2(content, projectAreaName, "http://open-services.net/ns/cm#ChangeRequest", "oslc:creationDialog"); //$NON-NLS-1$ //$NON-NLS-2$
		this.pickerDialogsAPT= this._getDialogsFromServiceDocV2(content, projectAreaName, "http://open-services.net/ns/cm#Plan", "oslc:selectionDialog"); //$NON-NLS-1$ //$NON-NLS-2$
		this.creationDialogsAPT= this._getDialogsFromServiceDocV2(content, projectAreaName, "http://open-services.net/ns/cm#Plan", "oslc:creationDialog"); //$NON-NLS-1$ //$NON-NLS-2$
		this._populateSelect(this.pickerDialogsCM, this.pickerTypeSelectCM);
		this._populateSelect(this.creationDialogsCM, this.creationTypeSelectCM);
		this._populateSelect(this.pickerDialogsAPT, this.pickerTypeSelectAPT);
		this._populateSelect(this.creationDialogsAPT, this.creationTypeSelectAPT);
	},

	_getDialogsFromServiceDocV2: function(content, projectName, itemName, dialogName) {
		var nodes= content.getNodes("rdf:Description/oslc:serviceProvider[dc:title='" + projectName + "']/oslc:service/" + dialogName, this.xPathNamespaceContext); //$NON-NLS-1$ //$NON-NLS-2$
		var pickerDescriptions= [];
		var $subject2= nodes;
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var node= $subject2[$count2];
			var resourceType= content.getNodeTextForNode(node, "oslc:resourceType", this.xPathNamespaceContext); //$NON-NLS-1$
			if (resourceType === itemName) {
				var pd= {};
				pd.title= content.getNodeTextForNode(node, "dc:title", this.xPathNamespaceContext); //$NON-NLS-1$
				pd.url= content.getNodeTextForNode(node, "oslc:dialog", this.xPathNamespaceContext); //$NON-NLS-1$
				pd.widthHint= content.getNodeTextForNode(node, "oslc:hintWidth", this.xPathNamespaceContext); //$NON-NLS-1$
				pd.heightHint= content.getNodeTextForNode(node, "oslc:hintHeight", this.xPathNamespaceContext); //$NON-NLS-1$
				pd.namespace= "oslc"; //$NON-NLS-1$
				pickerDescriptions.push(pd);
			}
		}
		return pickerDescriptions;
	},

	_populateSelect: function(pickerDescriptions, select) {
		dojo.empty(select);
		var $subject3= pickerDescriptions;
		var $length3= $subject3.length;
		for (var $count3= 0; $count3 < $length3; $count3++){
			var pickerDescription= $subject3[$count3];
			var option= window.document.createElement("option"); //$NON-NLS-1$
			option.appendChild(window.document.createTextNode(pickerDescription.title));
			select.appendChild(option);
		}
	},

	_getSelectedProjectArea: function() {
		var item= this.projectAreaInput.childNodes.item(this.projectAreaInput.selectedIndex);
		return item.getAttribute("_name"); //$NON-NLS-1$
	},

	_fillProjectLinksTable: function(linksDocContent) {
		var doc= window.document;
		if (this.relatedAreas != null) {
			this.relatedAreasContainer.removeChild(this.relatedAreas);
		}
		this.relatedAreas= doc.createElement("table"); //$NON-NLS-1$
		this.relatedAreas.cellSpacing= "2"; //$NON-NLS-1$
		this.relatedAreas.className= "control"; //$NON-NLS-1$
		var nodes= linksDocContent.getNodes("jp:links/jp:link", this.xPathNamespaceContext); //$NON-NLS-1$
		var $subject4= nodes;
		var $length4= $subject4.length;
		for (var $count4= 0; $count4 < $length4; $count4++){
			var node= $subject4[$count4];
			var linkName= linksDocContent.getNodeTextForNode(node, "jp:link-type", this.xPathNamespaceContext); //$NON-NLS-1$
			var linkedProjectName= linksDocContent.getNodeTextForNode(node, "oslc_disc:ServiceProvider/dc:title", this.xPathNamespaceContext); //$NON-NLS-1$
			var linkedServiceDoc= linksDocContent.getAttributeTextForNode(node, "oslc_disc:ServiceProvider/oslc_disc:services/@rdf:resource", this.xPathNamespaceContext); //$NON-NLS-1$
			var tr= this._createRelatedAreaEntry(doc, linkName, linkedProjectName, linkedServiceDoc);
			this.relatedAreas.appendChild(tr);
		}
		this.relatedAreasContainer.appendChild(this.relatedAreas);
	},

	_createRelatedAreaEntry: function(doc, linkName, linkedProjectName, linkedServiceDoc) {

		var td1= doc.createElement("td"); //$NON-NLS-1$
		td1.appendChild(doc.createTextNode(linkName));
		var td2= doc.createElement("td"); //$NON-NLS-1$
		if (linkedServiceDoc != null) {
			var anchor= doc.createElement("a"); //$NON-NLS-1$
			anchor.appendChild(doc.createTextNode(linkedProjectName));
			anchor.href= linkedServiceDoc;
			anchor.target= "_blank"; //$NON-NLS-1$
			td2.appendChild(anchor);
		}
		var td3= doc.createElement("td"); //$NON-NLS-1$
		var pickerTypes= this._getPickerTypes(linkName);
		if (pickerTypes == null) {
			this.log("Link type " + linkName + " unknown"); //$NON-NLS-1$ //$NON-NLS-2$
		} else {
			for (var i= 0; i < pickerTypes.length; i++){
				var pickButton= doc.createElement("button"); //$NON-NLS-1$
				pickButton.appendChild(doc.createTextNode(pickerTypes[i].name));
				pickButton._itemLinkType= pickerTypes[i].workItemLinkType;
				pickButton._serviceDoc= linkedServiceDoc;
				pickButton._dialogType= pickerTypes[i].pickerType;
				dojo.connect(pickButton, 'click', dojo.hitch(this, function(e) { //$NON-NLS-1$
					var target= e.target;
					this.remoteItemPicker.findAndOpenPicker(target._itemLinkType, target._serviceDoc, target._dialogType, this.pickerResultCallBack);
				}));
				td3.appendChild(pickButton);
			}
		}
		var tr= doc.createElement("tr"); //$NON-NLS-1$
		tr.appendChild(td1);
		tr.appendChild(td2);
		tr.appendChild(td3);
		return tr;
	},

	_fillItemLinksTable: function() {
		parser.removeChildren(this.serviceProviderContainer);
		this.loadServiceProviders("com.ibm.team.workitem.WorkItem", CALMDialogsTestWidget.ITEM_TYPE_WORKITEM); //$NON-NLS-1$
		this.loadServiceProviders("com.ibm.team.apt.IterationPlanRecord", CALMDialogsTestWidget.ITEM_TYPE_PLAN); //$NON-NLS-1$
	},

	loadServiceProviders: function(itemType, itemName) {
		var parms= {};
		parms.projectAreaItemId= this.context.getCurrentProjectArea().itemId;
		parms.itemType= itemType;
		var context= {};
		context["onSuccess"]= dojo.hitch(this, function(result) { //$NON-NLS-1$
			this._populateServiceProvider(itemName, result);
		});
		context["onFailure"]= dojo.hitch(this, function(error) { //$NON-NLS-1$
			this._handleError(error);
		});
		var sh= new ServiceResponseHandler(context, "onSuccess", "onFailure"); //$NON-NLS-1$ //$NON-NLS-2$
		CALMFoundationClient.getServiceProviders(sh, parms);
	},

	_populateServiceProvider: function(itemName, serviceProviderDTOs) {
		var doc= dojo.doc;
		var parentDiv= doc.createElement("div"); //$NON-NLS-1$
		parentDiv.appendChild(doc.createTextNode(itemName + ":")); //$NON-NLS-1$
		if (serviceProviderDTOs == null || serviceProviderDTOs.length === 0) {
			parentDiv.appendChild(doc.createTextNode(" Not available (add project links)")); //$NON-NLS-1$
		} else {

			var select= doc.createElement("select"); //$NON-NLS-1$
			for (var i= 0; i < serviceProviderDTOs.length; i++){
				var option= window.document.createElement("option"); //$NON-NLS-1$
				var serviceProviderDTO= serviceProviderDTOs[i];
				if (serviceProviderDTO.hasCreationDialog || serviceProviderDTO.hasSelectionDialog) {
					option.value= serviceProviderDTO.serviceDocumentUrl;
					option.itemLinkType= serviceProviderDTO.itemLinkType;
					option.itemLinkName= serviceProviderDTO.itemLinkName;
					option.name= serviceProviderDTO.name;
					option.appendChild(window.document.createTextNode(dojo.string.substitute("${0} (${1})", [serviceProviderDTO.itemLinkName, serviceProviderDTO.name]))); //$NON-NLS-1$
					select.appendChild(option);
				}
			}
			parentDiv.appendChild(select);
			var selectButton= doc.createElement("button"); //$NON-NLS-1$
			selectButton.appendChild(doc.createTextNode("Select")); //$NON-NLS-1$
			dojo.connect(selectButton, 'click', dojo.hitch(this, function(e) { //$NON-NLS-1$
				var option= select.childNodes.item(select.selectedIndex);
				this.remoteItemPicker.findAndOpenPicker(option.itemLinkType, option.value, 'SELECTION', this.pickerResultCallBack); //$NON-NLS-1$
			}));
			parentDiv.appendChild(selectButton);
			var createButton= doc.createElement("button"); //$NON-NLS-1$
			createButton.appendChild(doc.createTextNode("Create")); //$NON-NLS-1$
			dojo.connect(createButton, 'click', dojo.hitch(this, function(e) { //$NON-NLS-1$
				var option= select.childNodes.item(select.selectedIndex);
				this.remoteItemPicker.findAndOpenPicker(option.itemLinkType, option.value, 'CREATION', this.pickerResultCallBack); //$NON-NLS-1$
			}));
			parentDiv.appendChild(createButton);
			var createBackLinkButton= doc.createElement("button"); //$NON-NLS-1$
			createBackLinkButton.appendChild(doc.createTextNode("Create BackLink")); //$NON-NLS-1$
			dojo.connect(createBackLinkButton, 'click', dojo.hitch(this, function(e) { //$NON-NLS-1$
				var option= select.childNodes.item(select.selectedIndex);
				var remoteItemName= option.itemLinkName.substring(option.itemLinkName.lastIndexOf(" ")); //$NON-NLS-1$
				this._openBackLinkCreationDialog(itemName, option.itemLinkType, remoteItemName, option.name, option.value);
			}));
			parentDiv.appendChild(createBackLinkButton);
		}
		this.serviceProviderContainer.appendChild(parentDiv);
	},

	_openBackLinkCreationDialog: function(itemName, itemLinkType, remoteItemName, remoteServiceProviderName, serviceDoc) {
		var params= {};
		params.localResourceType= itemName;
		params.localServiceProviderName= this.context.getCurrentProjectArea().name;
		if ((CALMDialogsTestWidget.ITEM_TYPE_WORKITEM === itemName)) {
			params.localPickerDescription= this.pickerDialogsCM[this.pickerTypeSelectCM.selectedIndex];
		} else if ((CALMDialogsTestWidget.ITEM_TYPE_PLAN === itemName)) {
			params.localPickerDescription= this.pickerDialogsAPT[this.pickerTypeSelectAPT.selectedIndex];
		}
		params.remoteResourceType= remoteItemName;
		params.remoteServiceProviderName= remoteServiceProviderName;
		params.calmLinkType= itemLinkType;
		params.serviceDocument= serviceDoc;
		params.resourcePicker= this.remoteItemPicker;
		params.logger= this.logger;
		new BackLinkCreationTestDialog(params).open();
	},

	onLocalWorkItemPickerButton: function() {
		var description= this.pickerDialogsCM[this.pickerTypeSelectCM.selectedIndex];
		this.remoteItemPicker.openPicker(description, this.pickerResultCallBack);
	},

	onLocalWorkItemCreationDialogButton: function() {
		var description= this.creationDialogsCM[this.creationTypeSelectCM.selectedIndex];
		this.remoteItemPicker.openPicker(description, this.pickerResultCallBack);
	},

	onLocalPlanPickerButton: function() {
		var description= this.pickerDialogsAPT[this.pickerTypeSelectAPT.selectedIndex];
		this.remoteItemPicker.openPicker(description, this.pickerResultCallBack);
	},

	onLocalPlanCreationDialogButton: function() {
		var description= this.creationDialogsAPT[this.creationTypeSelectAPT.selectedIndex];
		this.remoteItemPicker.openPicker(description, this.pickerResultCallBack);
	},

	_onResourcePicked: function(results) {
		var doc= window.document;
		for (var i= 0; i < results.length; i++){
			var curr= results[i];
			var divElement= doc.createElement("div"); //$NON-NLS-1$
			var spanElement= doc.createElement("span"); //$NON-NLS-1$
			divElement.appendChild(spanElement);
			var anchor= doc.createElement("a"); //$NON-NLS-1$
			anchor.appendChild(doc.createTextNode(curr.label));
			anchor.href= curr.url;
			anchor.target= "_blank"; //$NON-NLS-1$
			var args= {};
			args.uri= curr.url;
			args.label= curr.label;
			new ResourceLink(args, anchor);
			spanElement.appendChild(anchor);
			var accessArgs= {};
			accessArgs["url"]= curr.url; //$NON-NLS-1$
			accessArgs["debug"]= "true"; //$NON-NLS-1$ //$NON-NLS-2$
			var resourceTestURL= dojo.objectToQuery(accessArgs);
			var button1= doc.createElement("button"); //$NON-NLS-1$
			button1.appendChild(doc.createTextNode("Examine")); //$NON-NLS-1$
			dojo.connect(button1, 'click', dojo.hitch(this, function(e) { //$NON-NLS-1$
				e.stopPropagation();
				window.open("com.ibm.team.calm.foundation.OSLCResourcesTestWidget?" + resourceTestURL, null, null); //$NON-NLS-1$
			}));
			spanElement.appendChild(button1);
			this.pickedResourcesContainer.appendChild(divElement);
		}
	},

	_getPickerTypes: function(linkName) {
		if ((linkName === "tested-by")) { //$NON-NLS-1$
			var testCasePicker= {};
			testCasePicker.workItemLinkType= "com.ibm.team.workitem.linktype.testedByTestCase"; //$NON-NLS-1$
			testCasePicker.name= "Test Case Picker"; //$NON-NLS-1$
			testCasePicker.pickerType= 'SELECTION'; //$NON-NLS-1$
			var testPlanPicker= {};
			testPlanPicker.workItemLinkType= "com.ibm.team.apt.linktype.testedByTestPlan"; //$NON-NLS-1$
			testPlanPicker.name= "Test Plan Picker"; //$NON-NLS-1$
			testPlanPicker.pickerType= 'SELECTION'; //$NON-NLS-1$
			var testCaseCreation= {};
			testCaseCreation.workItemLinkType= "com.ibm.team.workitem.linktype.testedByTestCase"; //$NON-NLS-1$
			testCaseCreation.name= "Test Case Creation"; //$NON-NLS-1$
			testCaseCreation.pickerType= 'CREATION'; //$NON-NLS-1$
			var testPlanCreation= {};
			testPlanCreation.workItemLinkType= "com.ibm.team.apt.linktype.testedByTestPlan"; //$NON-NLS-1$
			testPlanCreation.name= "Test Plan Creation"; //$NON-NLS-1$
			testPlanCreation.pickerType= 'CREATION'; //$NON-NLS-1$
			return [testCasePicker, testCaseCreation, testPlanPicker, testPlanCreation];
		}
		if ((linkName === "implements")) { //$NON-NLS-1$
			var reqPicker= {};
			reqPicker.workItemLinkType= "com.ibm.team.workitem.linktype.implementsRequirement"; //$NON-NLS-1$
			reqPicker.name= "Requirement Picker"; //$NON-NLS-1$
			reqPicker.pickerType= 'SELECTION'; //$NON-NLS-1$
			var colPicker= {};
			colPicker.workItemLinkType= "com.ibm.team.apt.linktype.implementsRequirementCollection"; //$NON-NLS-1$
			colPicker.name= "Collection Picker"; //$NON-NLS-1$
			colPicker.pickerType= 'SELECTION'; //$NON-NLS-1$
			var reqCreation= {};
			reqCreation.workItemLinkType= "com.ibm.team.workitem.linktype.implementsRequirement"; //$NON-NLS-1$
			reqCreation.name= "Requirement Creation"; //$NON-NLS-1$
			reqCreation.pickerType= 'CREATION'; //$NON-NLS-1$
			var colCreation= {};
			colCreation.workItemLinkType= "com.ibm.team.apt.linktype.implementsRequirementCollection"; //$NON-NLS-1$
			colCreation.name= "Collection Creation"; //$NON-NLS-1$
			colCreation.pickerType= 'CREATION'; //$NON-NLS-1$
			return [reqPicker, reqCreation, colPicker, colCreation];
		}
		if ((linkName === "related-to")) { //$NON-NLS-1$
			var changeRequestPicker= {};
			changeRequestPicker.workItemLinkType= "com.ibm.team.workitem.linktype.relatedChangeManagement"; //$NON-NLS-1$
			changeRequestPicker.name= "Change Request Picker"; //$NON-NLS-1$
			changeRequestPicker.pickerType= 'SELECTION'; //$NON-NLS-1$
			var planPicker= {};
			planPicker.workItemLinkType= "com.ibm.team.apt.linktype.contributesToPlan"; //$NON-NLS-1$
			planPicker.name= "Plan Picker"; //$NON-NLS-1$
			planPicker.pickerType= 'SELECTION'; //$NON-NLS-1$
			var changeRequestCreation= {};
			changeRequestCreation.workItemLinkType= "com.ibm.team.workitem.linktype.relatedChangeManagement"; //$NON-NLS-1$
			changeRequestCreation.name= "Change Request Creation"; //$NON-NLS-1$
			changeRequestCreation.pickerType= 'CREATION'; //$NON-NLS-1$
			var planCreation= {};
			planCreation.workItemLinkType= "com.ibm.team.apt.linktype.contributesToPlan"; //$NON-NLS-1$
			planCreation.name= "Plan Creation"; //$NON-NLS-1$
			planCreation.pickerType= 'CREATION'; //$NON-NLS-1$
			return [changeRequestPicker, changeRequestCreation, planPicker, planCreation];
		}
		return null;
	},

	_loadDocument: function(documentURL, successHandler, headers) {
		this.log("Loading " + documentURL + "..."); //$NON-NLS-1$ //$NON-NLS-2$
		if (headers == null) {
			headers= {};
		}
		var deferred= new dojo.Deferred();
		deferred.addCallback(successHandler);
		deferred.addErrback(dojo.hitch(this, function(error) {
			this._handleError(error);
			return error;
		}));
		CALMDocument.load(documentURL, deferred, headers);
	},

	_loadRDFDocument: function(documentURL, successHandler) {
		this.log("Loading RDF " + documentURL + "..."); //$NON-NLS-1$ //$NON-NLS-2$
		var context= {};
		context["onSuccess"]= dojo.hitch(this, function(result) { //$NON-NLS-1$
			successHandler(new CALMDocument(result));
		});
		context["onFailure"]= dojo.hitch(this, function(error) { //$NON-NLS-1$
			this._handleError(error.message);
		});
		var sh= new ServiceResponseHandler(context, "onSuccess", "onFailure"); //$NON-NLS-1$ //$NON-NLS-2$
		var oslcResource= {};
		oslcResource.oslcCoreVersion= "2.0"; //$NON-NLS-1$
		oslcResource.resourceURL= documentURL;
		CALMFoundationClient.getRDFResource(sh, oslcResource);
	},

	/**
	 * Called when reload button is pressed
	 */
	onReloadButton: function() {
		this._updateProjectAreaCombo();
	},

	_handleError: function(object) {
		this.logger.handleError(object);
	},

	log: function(str) {
		this.logger.log(str);
	}
});

CALMDialogsTestWidget.RDF_CONTENT_TYPE= "application/rdf+xml"; //$NON-NLS-1$
CALMDialogsTestWidget.OSCL_CORE_HEADER= "OSLC-Core-Version"; //$NON-NLS-1$
CALMDialogsTestWidget.ITEM_TYPE_WORKITEM= "Work Item"; //$NON-NLS-1$
CALMDialogsTestWidget.ITEM_TYPE_PLAN= "Plan"; //$NON-NLS-1$

})();
