/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.calm.foundation.web.calmdialogs.testapp.RemoteItemPickerOpener"); //$NON-NLS-1$

dojo.require("com.ibm.team.calm.foundation.web.calmdialogs.RemoteItemPicker"); //$NON-NLS-1$
dojo.require("com.ibm.team.calm.foundation.web.client.CALMFoundationClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("dojo.string"); //$NON-NLS-1$

(function() {
var RemoteItemPicker= com.ibm.team.calm.foundation.web.calmdialogs.RemoteItemPicker;
var CALMFoundationClient= com.ibm.team.calm.foundation.web.client.CALMFoundationClient;
var ServiceResponseHandler= com.ibm.team.repository.web.transport.ServiceResponseHandler;

dojo.declare("com.ibm.team.calm.foundation.web.calmdialogs.testapp.RemoteItemPickerOpener", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fProjectID: null,

	fParentContainer: null,

	fLogger: null,

	constructor: function(params) {
		this.fProjectID= params.projectId;
		this.fParentContainer= params.parentContainer;
		this.fLogger= params.logger;
	},

	findAndOpenPicker: function(itemLinkType, serviceDoc, pickerType, pickerResultCallback) {
		var parms= {};
		parms.projectAreaItemId= this.fProjectID;
		parms.itemLinkType= itemLinkType;
		if (serviceDoc != null) 
			parms.serviceDocumentUrl= serviceDoc;
		var context= {};
		context["onSuccess"]= dojo.hitch(this, function(result) { //$NON-NLS-1$
			this.openPicker(this.findPicker(result, pickerType), pickerResultCallback);
		});
		context["onFailure"]= dojo.hitch(this, function(error) { //$NON-NLS-1$
			this.fLogger.handleError(error);
		});
		var sh= new ServiceResponseHandler(context, "onSuccess", "onFailure"); //$NON-NLS-1$ //$NON-NLS-2$
		CALMFoundationClient.getAllPickerDescriptions(sh, parms);
	},

	openPicker: function(pickerDescription, pickerResultCallback) {
		if (pickerDescription == null) {
			window.alert("No picker available."); //$NON-NLS-1$
			return ;
		}
		var pickerUrl= pickerDescription.url;
		if (window.location.search.indexOf("debug=true") !== -1) { //$NON-NLS-1$
			var qIndex= pickerUrl.indexOf("?"); //$NON-NLS-1$
			if (qIndex === -1) {
				qIndex= pickerUrl.indexOf("#"); //$NON-NLS-1$
				if (qIndex === -1) 
					qIndex= pickerUrl.length;
			} else {
				qIndex++;
			}
			pickerUrl= pickerUrl.substring(0, qIndex) + "debug=true&" + pickerUrl.substring(qIndex); //$NON-NLS-1$
		}
		var args= {};
		args.dialogTitle= pickerDescription.title;
		args.secondaryTitle= ""; //$NON-NLS-1$
		args.height= pickerDescription.heightHint;
		args.width= pickerDescription.widthHint;
		args.namespace= pickerDescription.namespace;
		args.pickerURL= pickerUrl;
		args.onOk= dojo.hitch(this, function(result) {
			pickerResultCallback(result);
			this.fLogger.log("Picker result: " + dojo.toJson(result, true)); //$NON-NLS-1$
		});
		args.parentElement= this.fParentContainer;
		this.fLogger.log(dojo.string.substitute("Opening ${0}, size: [${1}, ${2}]", [pickerUrl, pickerDescription.widthHint, pickerDescription.heightHint])); //$NON-NLS-1$
		new RemoteItemPicker(args);
	},

	findPicker: function(pickerDescriptions, pickerType) {
		var $subject= pickerDescriptions;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var pickerDescription= $subject[$count];
			if (pickerDescription.pickerType === pickerType) 
				return pickerDescription;
		}
		return null;
	}
});

})();
