/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.client.internal.ConfigurationParameters");

// See com.ibm.team.workitem.api.common.providers.ConfigurationParameters

(function() {
	
dojo.declare("com.ibm.team.workitem.web.client.internal.ConfigurationParameters", null, {
	
	constructor: function(object) {
		this._object= object;
	},
	
	getIdentifier: function() {
		return this.getString("id");
	},
	
	getString: function(name) {
		return this._object[name];
	},
	
	getStringDefault: function(name, defaultValue) {
		var value= this._object[name];
		return value || defaultValue;
	},
	
	getChild: function(name) {
		var children= this.getChildren(name);
		return children.length > 0 ? children[0] : null;
	},
	
	getChildren: function(name) {
		var children= this._object._children;
		var selected= new Array();
		for (var i= 0; i < children.length; i++) {
			if (children[i]._name == name) {
				selected.push(new com.ibm.team.workitem.web.client.internal.ConfigurationParameters(children[i]));
			}
		}
		return selected;
	},
	
	getDataConnector: function(name) {
		return null;
	},
	
	__sentinel: null
});

})();