 /*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.client.internal.ImageClient");

dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");

(function() { //module container

var checkNotNull 			= net.jazz.ajax.toolbox.lang.checkNotNull;
var checkNotEmpty 			= net.jazz.ajax.toolbox.lang.checkNotEmpty;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;


com.ibm.team.workitem.web.client.internal.ImageClient= {

	SERVICE_URI: "com.ibm.team.workitem.common.internal.model.IImageContentService",
	HOST_URI: dojo.baseUrl, 
	
	/**
	 * Access images in non-web plugins.
	 * Returns The fully qualified URL to the resource pointed to by 'path'.
	 * @param {Object} path  The path to a resource, relative to the plugin root: E.g. /<plugin-name>/icons/icon.gif
	 */
	getImageUrl: function(path) {
		checkNotEmpty(path, "path");
		var url;
		if (path.indexOf(this.SERVICE_URI) > -1) {
			url= ""; // was this.HOST_URI;
		} else {
			url= TeamServerClient._getServicePrefix() + this.SERVICE_URI;
		}
		if (path.charAt(0) != '/' && path.indexOf("http") != 0) {
			url += '/';
		}
// Sometimes the URL is a string and sometimes and object
// Result is always a string
		var result = url + path;
	try {
		if(result && dojo.isString(result) && (result.length < 4 || result.substring(0,4) != "http")) {
		 	result = result.replace(/\/\//g, "/");
		};
	} catch(e) {
		console.debug("Error in ImageClient, url=" + result);
	}
	return result;
	}
	
};

})();