/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.draw.DrawContext"); //$NON-NLS-1$


(function() {

/**
 * @since 3.0
 */
dojo.declare("com.ibm.team.rtc.foundation.web.ui.draw.DrawContext", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fColor: null,

	fLineStyle: null,

	fX: null,

	fY: null,

	fTargetElement: null,

	fClipX: null,

	constructor: function(surface, clipX) {
		this.fColor= "black"; //$NON-NLS-1$
		this.fLineStyle= "solid"; //$NON-NLS-1$
		this.fX= 0;
		this.fY= 0;
		this.fClipX= 99999;
		this.fTargetElement= surface;
		this.fClipX= clipX;
		dojo.addClass(this.fTargetElement, "renderRoot"); //$NON-NLS-1$
	},

	color: function(color) {
		this.fColor= color;
	},

	lineStyle: function(lineStyle) {
		this.fLineStyle= lineStyle;
	},

	move: function(x, y) {
		this.fX= x;
		this.fY= y;
	},

	drawLine: function(length, horizontal) {
		var classNames= "e l "; //$NON-NLS-1$
		var x= this.fX;
		var y= this.fY;
		if (horizontal) {
			this.fX+= length;
		} else {
			this.fY+= length;
		}
		if (length < 0) {
			if (horizontal) {
				x+= length;
			} else {
				y+= length;
			}
			length*= -1;
		}
		if (x < 0) {
			if (!horizontal || x + length < 0) 
				return ;
			length+= x;
			x= 0;
		} else if (x >= this.fClipX) {
			if (!horizontal || x - length > this.fClipX) 
				return ;
			length-= (x - this.fClipX);
			x= this.fClipX;
		}
		var style= {left: (x) + "px", top: (y) + "px", borderColor: this.fColor, borderStyle: this.fLineStyle}; //$NON-NLS-1$ //$NON-NLS-2$
		if (horizontal) {
			classNames+= "h"; //$NON-NLS-1$
			style.width= (length) + "px"; //$NON-NLS-1$
		} else {
			classNames+= "v"; //$NON-NLS-1$
			style.height= (length) + "px"; //$NON-NLS-1$
		}
		dojo.create("div", {className: classNames, style: style}, this.fTargetElement); //$NON-NLS-1$
	},

	drawShape: function(shape, size) {
		if (this.fX >= 0 && this.fX < this.fClipX) {
			var style= {left: (this.fX) + "px", top: (this.fY - ((size / 2)|0)) + "px"}; //$NON-NLS-1$ //$NON-NLS-2$
			shape.style(style, size, this.fColor);
			dojo.create("div", {className: "e s " + shape.fClassName, style: style}, this.fTargetElement); //$NON-NLS-1$ //$NON-NLS-2$
		}
	}
});
var Shape= dojo.declare("com.ibm.team.rtc.foundation.web.ui.draw.DrawContext.Shape", null, { //$NON-NLS-1$

	fClassName: null,

	constructor: function(className) {
		this.fClassName= className;
	},

	style: function(style, size, color) {
	},

	compareTo: function(other) {
		return this.ordinal - other.ordinal;
	}
});

Shape.values= [
	dojo.mixin(new Shape("arrowRight"), { //$NON-NLS-1$
		name: 'ArrowRight',
		ordinal: 0,
		style: function(style, size, color) {
			var p= ((size / 2)|0);
			style.borderTop= style.borderBottom= (p) + "px" + " solid transparent"; //$NON-NLS-1$ //$NON-NLS-2$
			style.borderLeft= (p + 1) + "px" + " solid " + color; //$NON-NLS-1$ //$NON-NLS-2$
			style.borderRight= "0"; //$NON-NLS-1$
		}
	})
];
Shape.ArrowRight= Shape.values[0];

})();
