/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.gridviewer.ColumnHeaderGadget"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.ColumnResizeGadget"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.GridGadget"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.MeasureUtil"); //$NON-NLS-1$

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var ColumnResizeGadget= com.ibm.team.rtc.foundation.web.ui.gridviewer.ColumnResizeGadget;
var GridGadget= com.ibm.team.rtc.foundation.web.ui.gridviewer.GridGadget;
var MeasureUtil= com.ibm.team.rtc.foundation.web.ui.gridviewer.MeasureUtil;

/**
 * @since 3.0
 */
var ColumnHeaderGadget= dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.ColumnHeaderGadget", GridGadget, { //$NON-NLS-1$

	fColumn: null,

	fComparator: null,

	fComparatorTwistie: null,

	listener: null,

	fFillContainer: null,

	fResizeGadget: null,

	fLabelContainer: null,

	constructor: function(column, viewer) {
		this.inherited(arguments, [viewer]);
		this.listener= dojo.hitch(this, 'onColumnComparatorChanged'); //$NON-NLS-1$
		this.fColumn= column;
		var comparator= null;
		if (jdojo.implementsInterface(this.fColumn, "com.ibm.team.rtc.foundation.api.ui.model.IPropertyColumn")) {
			var propertyDescriptor= this.fColumn.getPropertyDescriptor();
			if (jdojo.implementsInterface(propertyDescriptor, "com.ibm.team.rtc.foundation.api.ui.essentials.IColumnPropertyDescriptor")) {
				comparator= propertyDescriptor.getSorter();
			}
		}
		this.fComparator= comparator;
	},

	getMinimalHeight: function() {
		return ColumnHeaderGadget.DEFAULT_HEIGHT;
	},

	setFinalHeight: function(pixels) {
		var innerHeight= (pixels - 3) + "px"; //$NON-NLS-1$
		if (this.fResizeGadget != null) {
			this.fResizeGadget.setHeight(innerHeight);
		}
		if (this.fFillContainer != null && this.fLabelContainer != null) {
			this.fFillContainer.style.height= innerHeight;
			this.fLabelContainer.style.paddingTop= (pixels - ColumnHeaderGadget.DEFAULT_HEIGHT_PX) + "px"; //$NON-NLS-1$
		}
	},

	doCreate: function() {
		var classNames= "column " + this.fViewer.getColumnClassName(this.fColumn); //$NON-NLS-1$
		var result= dojo.create("td", {className: classNames}); //$NON-NLS-1$
		this.doCreateResizeHandle(result);
		this.doCreateCellContent(result);
		if (this.fComparator != null) {
			this.fViewer.addColumnComparatorListener(this.listener);
		}
		return result;
	},

	doDestroy: function() {
		if (this.fComparator != null) {
			this.fViewer.removeColumnComparatorListener(this.listener);
		}
	},

	doCreateCellContent: function(cellContainer) {
		this.fFillContainer= dojo.create("div", {className: "fill"}, cellContainer); //$NON-NLS-1$ //$NON-NLS-2$
		if (this.fColumn.getIconUri() != null) {
			dojo.create("img", {src: this.fColumn.getIconUri(), className: "icon"}, this.fFillContainer); //$NON-NLS-1$ //$NON-NLS-2$
		}
		this.fLabelContainer= dojo.create("div", {className: "labelContainer"}, this.fFillContainer); //$NON-NLS-1$ //$NON-NLS-2$
		var labelElement= dojo.create("span", {className: "label"}, this.fLabelContainer); //$NON-NLS-1$ //$NON-NLS-2$
		var labelText= this.fColumn.getLabel();
		dojo.place(dojo.doc.createTextNode(labelText != null ? labelText : ""), labelElement); //$NON-NLS-1$
		if (this.fComparator != null) {
			this.fComparatorTwistie= dojo.create("span", {className: "sort-twistie"}, this.fLabelContainer); //$NON-NLS-1$ //$NON-NLS-2$
		}
	},

	doCreateResizeHandle: function(result) {
		this.fResizeGadget= this.registerChild(new ColumnResizeGadget(this.fColumn, this.fViewer));
		dojo.place(this.fResizeGadget.createGadget(), result);
	},

	onColumnComparatorChanged: function(source, comparator) {
		dojo.removeClass(this.fComparatorTwistie, "asc"); //$NON-NLS-1$
		dojo.removeClass(this.fComparatorTwistie, "desc"); //$NON-NLS-1$
		if (source != null && comparator != null && source.getId() === this.fColumn.getId()) {
			var mode= comparator.isAscending() ? "asc" : "desc"; //$NON-NLS-1$ //$NON-NLS-2$
			dojo.addClass(this.fComparatorTwistie, mode);
		}
	},

	createDragData: function() {
		return null;
	},

	notifyDragCompleted: function(dragData, dropResponse) {
	},

	notifyDragCancelled: function(dragData) {
	},

	createDragAvatar: function(dragData) {
		return null;
	},

	onMouseClick: function(event) {
		if (this.fComparator != null) {
			this.fViewer.setColumnComparator(this.fColumn, this.fComparator);
		}
		return false;
	},

	onMouseEnter: function(element) {
		if (this.fComparator != null) {
			dojo.addClass(this.fGadgetNode, ColumnHeaderGadget.HOVER_CLASS);
		}
		return true;
	},

	onMouseLeave: function(element) {
		if (this.fComparator != null) {
			dojo.removeClass(this.fGadgetNode, ColumnHeaderGadget.HOVER_CLASS);
		}
		return true;
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.IColumnComparatorListener': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.IMouseClickHandler': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.IMouseOverListener': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.IDragSource': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.IDragable': true //$NON-NLS-1$
	}
});

ColumnHeaderGadget.DEFAULT_HEIGHT= "25px"; //$NON-NLS-1$
ColumnHeaderGadget.DEFAULT_HEIGHT_PX= MeasureUtil.INSTANCE.convertToPixels(ColumnHeaderGadget.DEFAULT_HEIGHT);
ColumnHeaderGadget.HOVER_CLASS= "hover"; //$NON-NLS-1$

})();
