/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.gridviewer.ConnectionGadget"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.web.ui.draw.DrawContext"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.GridGadget"); //$NON-NLS-1$

(function() {
var DrawContext= com.ibm.team.rtc.foundation.web.ui.draw.DrawContext;
var Shape= com.ibm.team.rtc.foundation.web.ui.draw.DrawContext.Shape;
var GridGadget= com.ibm.team.rtc.foundation.web.ui.gridviewer.GridGadget;

/**
 * @since 3.0
 */
dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.ConnectionGadget", GridGadget, { //$NON-NLS-1$

	fLink: null,

	fSource: null,

	fTarget: null,

	constructor: function(source, target, linkDescriptor, gridViewer) {
		this.inherited(arguments, [gridViewer]);
		this.fSource= source;
		this.fTarget= target;
		this.fLink= linkDescriptor;
	},

	doCreate: function() {
		this.fGadgetNode= dojo.create("div", {className: "connections " + this.fViewer.getColumnClassName(this.fLink.getColumn())}); //$NON-NLS-1$ //$NON-NLS-2$
		this.update();
		return this.fGadgetNode;
	},

	update: function() {
		dojo.empty(this.fGadgetNode);
		this.fGadgetNode.style.left= this.fViewer.getColumnXPos(this.fLink.getColumn()) + "px"; //$NON-NLS-1$
		var distance= this.fViewer.getDistance(this.fSource, this.fTarget);
		if (distance == null) 
			return ;
		var dc= new DrawContext(this.fGadgetNode, this.fViewer.getColumnWidth(this.fLink.getColumn()));
		var sourceCell= this.fSource.getCell(this.fLink.getColumn());
		var targetCell= this.fTarget.getCell(this.fLink.getColumn());
		if (sourceCell == null || targetCell == null) 
			return ;
		var source= sourceCell.getConnectionPosition(true);
		var target= targetCell.getConnectionPosition(false);
		if (source == null || target == null) 
			return ;
		target.y+= distance.y;
		var vLength= target.y - source.y;
		var vDir= vLength < 0 ? -1 : 1;
		vLength*= vDir;
		var hLength= target.x - source.x;
		var hDir= hLength < 0 ? -1 : 1;
		hLength*= hDir;
		dc.move(source.x, source.y);
		dc.drawLine(5, true);
		hLength-= 5 * hDir;
		if (hLength * hDir < 10) {
			dc.drawLine(10 * vDir, false);
			vLength-= 10;
			dc.drawLine(-(10 - hLength * hDir), true);
			hLength= 10;
			hDir= 1;
		}
		dc.drawLine(vLength * vDir, false);
		vLength= 0;
		dc.drawLine(hLength - 5, true);
		hLength= 0;
		dc.drawShape(Shape.ArrowRight, 6);
	}
});

})();
