/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.gridviewer.DragDropController"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.IDragable"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.IDropResponse"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.IDropTarget"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.IResizeData"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.MoveEvent"); //$NON-NLS-1$

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var Assert= com.ibm.jdojo.util.Assert;
var IDragable= com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.IDragable;
var IDropResponse= com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.IDropResponse;
var IDropTarget= com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.IDropTarget;
var ResizeType= com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.IResizeData.ResizeType;
var MoveEvent= com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.MoveEvent;

/**
 * @since 3.0
 */
var DragDropController= dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.DragDropController", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fGridViewer: null,

	fEventHandlers: null,

	fMoveEventHandle: null,

	fReleaseEventHandle: null,

	fDragDropState: null,

	fInsertFeedbackNode: null,

	fInsertFeedback: null,

	constructor: function(gridViewer) {
		this.fEventHandlers= [];
		this.fGridViewer= gridViewer;
	},

	initialize: function() {
		this.fEventHandlers.push(dojo.connect(this.fGridViewer.domNode, 'mousedown', dojo.hitch(this, "onMouseDown"))); //$NON-NLS-1$ //$NON-NLS-2$
		this.fEventHandlers.push(dojo.connect(this.fGridViewer.domNode, "ondragstart", dojo.hitch(this, "stopDragEvent"))); //$NON-NLS-1$ //$NON-NLS-2$
		this.fEventHandlers.push(dojo.connect(this.fGridViewer.domNode, "onselectstart", dojo.hitch(this, "stopDragEvent"))); //$NON-NLS-1$ //$NON-NLS-2$
		this.fEventHandlers.push(dojo.connect(this.fGridViewer.domNode, "ontouchstart", dojo.hitch(this, "onTouchStart"))); //$NON-NLS-1$ //$NON-NLS-2$
		this.fEventHandlers.push(dojo.connect(dojo.body(), "ondragstart", dojo.hitch(this, "stopDragEvent"))); //$NON-NLS-1$ //$NON-NLS-2$
		this.fEventHandlers.push(dojo.connect(dojo.body(), "onselectstart", dojo.hitch(this, "stopDragEvent"))); //$NON-NLS-1$ //$NON-NLS-2$
		this.fInsertFeedbackNode= dojo.create("div", {className: "dropFeedback"}, this.fGridViewer.domNode); //$NON-NLS-1$ //$NON-NLS-2$
		dojo.create("div", {className: "fill"}, this.fInsertFeedbackNode); //$NON-NLS-1$ //$NON-NLS-2$
	},

	dispose: function() {
		var $subject= this.fEventHandlers;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var handle= $subject[$count];
			dojo.disconnect(handle);
		}
		this.fEventHandlers= null;
	},

	isInDragOperation: function() {
		return this.fDragDropState != null;
	},

	stopDragEvent: function(event) {
		if (this.fDragDropState != null) {
			dojo.stopEvent(event);
		}
	},

	onMouseDown: function(event) {
		if (!(this.fDragDropState == null)) Assert.fail("this.fDragDropState == null", "com.ibm.team.rtc.foundation.web.ui.gridviewer.DragDropController:103");
		if (!(this.fMoveEventHandle == null && this.fReleaseEventHandle == null)) Assert.fail("this.fMoveEventHandle == null && this.fReleaseEventHandle == null", "com.ibm.team.rtc.foundation.web.ui.gridviewer.DragDropController:104");
		var dragSource= this.fGridViewer.getAspect(event.target, IDragable);
		if (dragSource != null) {
			this.fMoveEventHandle= dojo.connect(dojo.doc, 'mousemove', dojo.hitch(this, "onMouseMove")); //$NON-NLS-1$ //$NON-NLS-2$
			this.fReleaseEventHandle= dojo.connect(dojo.doc, 'mouseup', dojo.hitch(this, "onMouseRelease")); //$NON-NLS-1$ //$NON-NLS-2$
			this.fDragDropState= new InitialState(this, MoveEvent.fromMouseEvent(event), dragSource);
			dojo.stopEvent(event);
		}
	},

	onMouseMove: function(event) {
		try {
			var screenLocation= MoveEvent.fromMouseEvent(event);
			this.updateAvatarPosition(screenLocation);
			if (this.fDragDropState != null) {
				this.fDragDropState= this.fDragDropState.onMove(screenLocation);
			}
		} finally {
			if (this.fDragDropState == null) {
				this.onDragEnd();
			}
		}
	},

	onMouseRelease: function(event) {
		try {
			if (this.fDragDropState != null) {
				this.fDragDropState.onRelease(MoveEvent.fromMouseEvent(event));
			}
		} finally {
			this.fDragDropState= null;
			this.onDragEnd();
		}
	},

	onTouchStart: function(event) {
		if (!(this.fDragDropState == null)) Assert.fail("this.fDragDropState == null", "com.ibm.team.rtc.foundation.web.ui.gridviewer.DragDropController:141");
		if (!(this.fMoveEventHandle == null && this.fReleaseEventHandle == null)) Assert.fail("this.fMoveEventHandle == null && this.fReleaseEventHandle == null", "com.ibm.team.rtc.foundation.web.ui.gridviewer.DragDropController:142");
		if (event.touches.length === 1) {
			var dragSource= this.fGridViewer.getAspect(event.target, IDragable);
			if (dragSource != null) {
				event.preventDefault();
				this.fMoveEventHandle= dojo.connect(dojo.doc, "ontouchmove", dojo.hitch(this, "onTouchMove")); //$NON-NLS-1$ //$NON-NLS-2$
				this.fReleaseEventHandle= dojo.connect(dojo.doc, "ontouchend", dojo.hitch(this, "onTouchEnd")); //$NON-NLS-1$ //$NON-NLS-2$
				this.fDragDropState= new InitialState(this, MoveEvent.fromTouch(event), dragSource);
				dojo.stopEvent(event);
			}
		}
	},

	onTouchMove: function(event) {
		try {
			if (event.touches.length === 1) {
				var screenLocation= MoveEvent.fromTouch(event);
				this.updateAvatarPosition(screenLocation);
				if (this.fDragDropState != null) {
					event.preventDefault();
					this.fDragDropState= this.fDragDropState.onMove(screenLocation);
				}
			}
		} finally {
			if (this.fDragDropState == null) {
				this.onDragEnd();
			}
		}
	},

	onTouchEnd: function(event) {
		try {
			if (this.fDragDropState != null && event.touches.length === 0) {
				event.preventDefault();
				this.fDragDropState.onRelease(null);
				this.fDragDropState= null;
			}
		} finally {
			this.onDragEnd();
		}
	},

	onDragEnd: function() {
		if (this.fMoveEventHandle != null) {
			dojo.disconnect(this.fMoveEventHandle);
			this.fMoveEventHandle= null;
		}
		if (this.fReleaseEventHandle != null) {
			dojo.disconnect(this.fReleaseEventHandle);
			this.fReleaseEventHandle= null;
		}
		if (this.fAvatarGadget != null) {
			this.fAvatarGadget.destroy();
			this.fAvatarGadget= null;
		}
	},

	fLastGadget: null,

	fAvatarGadget: null,

	setFeedback: function(gadget, feedback) {
		this.removeFeedback();
		if (gadget != null) {
			var gadgetNode= gadget.getGadgetNode();
			if ((feedback & DragDropController.INSERT_FEEDBACK) !== 0) {
				this.fInsertFeedback= DragDropController.FEEDBACK_HORIZONTAL;
				var position= dojo.position(gadgetNode, false);
				var style= {};
				style.top= (position.y + ((feedback & IDropResponse.FEEDBACK_INSERT_BEFORE) !== 0 ? 0 : position.h) - 4) + "px"; //$NON-NLS-1$
				style.left= (position.x - 4) + "px"; //$NON-NLS-1$
				style.width= position.w + "px"; //$NON-NLS-1$
				dojo.style(this.fInsertFeedbackNode, style);
				dojo.addClass(this.fInsertFeedbackNode, this.fInsertFeedback);
			}
			if ((feedback & IDropResponse.FEEDBACK_SELECT) !== 0) {
				dojo.addClass(gadgetNode, "dropHover"); //$NON-NLS-1$
			}
			this.fLastGadget= gadget;
		}
	},

	removeFeedback: function() {
		if (this.fInsertFeedback != null) {
			dojo.removeClass(this.fInsertFeedbackNode, this.fInsertFeedback);
			this.fInsertFeedback= null;
		}
		if (this.fLastGadget != null && this.fLastGadget.getGadgetNode() != null) {
			dojo.removeClass(this.fLastGadget.getGadgetNode(), "dropHover"); //$NON-NLS-1$
		}
		this.fLastGadget= null;
	},

	createDragAvatar: function(dragSource, dragData, location) {
		this.fAvatarGadget= dragSource.createDragAvatar(dragData);
		if (this.fAvatarGadget != null) {
			var avatarElement= this.fAvatarGadget.createGadget();
			this.updateAvatarPosition(location);
			dojo.place(avatarElement, this.fGridViewer.domNode);
		}
	},

	updateAvatarPosition: function(screenLocation) {
		if (this.fAvatarGadget != null) {
			var offset= this.fAvatarGadget.getOffset();
			var x= screenLocation.clientX + offset.x;
			var y= screenLocation.clientY + offset.y;
			dojo.style(this.fAvatarGadget.getGadgetNode(), {top: y + "px", left: x + "px"}); //$NON-NLS-1$ //$NON-NLS-2$
		}
	},

	createResizeAvatar: function(resizeDragable, resizeData) {
		this.fAvatarGadget= resizeDragable.createResizeAvatar(resizeData);
		if (this.fAvatarGadget != null) {
			dojo.place(this.fAvatarGadget.createGadget(), this.fGridViewer.domNode);
		}
	}
});

DragDropController.OPERATION_NONE= "com-ibm-team-rtc-gridViewer-dndDisabled"; //$NON-NLS-1$
DragDropController.OPERATION_MOVE= "com-ibm-team-rtc-gridViewer-dndOk"; //$NON-NLS-1$
DragDropController.RESIZE_HORIZONTAL= "com-ibm-team-rtc-gridViewer-dndResizeHorizontal"; //$NON-NLS-1$
DragDropController.RESIZE_VERTICAL= "com-ibm-team-rtc-gridViewer-dndResizeVertical"; //$NON-NLS-1$
DragDropController.RESIZE_MOVE= "com-ibm-team-rtc-gridViewer-dndResizeMove"; //$NON-NLS-1$
DragDropController.RESIZE_PAN= "com-ibm-team-rtc-gridViewer-dndResizePan"; //$NON-NLS-1$
DragDropController.FEEDBACK_HORIZONTAL= "insertHorizontal"; //$NON-NLS-1$
DragDropController.INSERT_FEEDBACK= IDropResponse.FEEDBACK_INSERT_BEFORE | IDropResponse.FEEDBACK_INSERT_AFTER;
var DragDropState= dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.DragDropController.DragDropState", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fController: null,

	constructor: function(controller) {
		this.fController= controller;
	},

	onMove: function(location) {
		return this;
	},

	onRelease: function(location) {
	}
});
var InitialState= dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.DragDropController.InitialState", DragDropState, { //$NON-NLS-1$

	fDragable: null,

	fStartX: null,

	fStartY: null,

	fTarget: null,

	constructor: function(controller, location, dragSource) {
		this.inherited(arguments, [controller]);
		this.fStartX= location.clientX;
		this.fStartY= location.clientY;
		this.fTarget= location.target;
		this.fDragable= dragSource;
	},

	onMove: function(location) {
		if (Math.abs(location.clientX - this.fStartX) > InitialState.THRESHOLD || Math.abs(location.clientY - this.fStartY) > InitialState.THRESHOLD) {
			if (jdojo.implementsInterface(this.fDragable, "com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.IDragSource")) {
				var dragSource= this.fDragable;
				var dragData= dragSource.createDragData();
				if (dragData != null) {
					return new DragState(this.fController, dragSource, dragData, location);
				}
			}
			if (jdojo.implementsInterface(this.fDragable, "com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.IResizeDragable")) {
				var resizeDraggable= this.fDragable;
				var resizeData= resizeDraggable.startResize(this.fTarget, this.fStartX, this.fStartY);
				if (resizeData != null && resizeData.getResizeType() !== ResizeType.None) {
					return new ResizeState(this.fController, this.fDragable, resizeData);
				}
			}
			return null;
		}
		return this;
	}
});

InitialState.THRESHOLD= 4;
var DragState= dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.DragDropController.DragState", DragDropState, { //$NON-NLS-1$

	fDragSource: null,

	fDragData: null,

	fLastGadget: null,

	fLastTarget: null,

	fLastOperation: null,

	fLastFeedback: null,

	fLastLocation: null,

	constructor: function(controller, dragSource, dragData, location) {
		this.inherited(arguments, [controller]);
		this.fLastOperation= 0;
		this.fLastFeedback= 0;
		this.fDragSource= dragSource;
		this.fDragData= dragData;
		dojo.addClass(dojo.body(), DragDropController.OPERATION_NONE);
		this.fController.createDragAvatar(dragSource, dragData, location);
	},

	onMove: function(location) {
		this.fLastLocation= location;
		location.stopEvent();
		var dropResponse= null;
		var dropTarget= this.findDropTarget(location);
		if (dropTarget != null) {
			dropResponse= dropTarget.canDrop({dragData: this.fDragData, location: location});
		}
		this.setDropFeedback(dropTarget, dropResponse);
		return this;
	},

	onRelease: function(location) {
		this.onDragEnd(location != null ? location : this.fLastLocation);
	},

	onDragEnd: function(event) {
		var dropResponse= null;
		try {
			if (event != null) {
				var dropTarget= this.findDropTarget(event);
				if (dropTarget != null) {
					dropResponse= dropTarget.canDrop({dragData: this.fDragData, location: event});
					if (dropResponse != null && dropResponse.getOperation() !== IDropResponse.DROP_NO) {
						if (!dropTarget.drop(dropResponse)) {
							dropResponse= null;
						}
					}
				}
			}
			this.setDropFeedback(null, null);
		} finally {
			if (dropResponse != null) {
				this.fDragSource.notifyDragCompleted(this.fDragData, dropResponse);
			} else {
				this.fDragSource.notifyDragCancelled(this.fDragData);
			}
			dojo.removeClass(dojo.body(), DragDropController.OPERATION_NONE);
		}
	},

	findDropTarget: function(event) {
		this.fLastGadget= this.fController.fGridViewer.findGadget(event.clientX, event.clientY, this.fLastGadget);
		return this.fLastGadget != null ? this.fController.fGridViewer.getParentGadgetOfType(this.fLastGadget, IDropTarget) : null;
	},

	setDropFeedback: function(gadget, dropResponse) {
		var operation= IDropResponse.DROP_NO;
		var feedback= IDropResponse.FEEDBACK_NONE;
		if (dropResponse != null) {
			operation= dropResponse.getOperation();
			feedback= dropResponse.getFeedback();
		}
		if (this.fLastTarget !== gadget || operation !== this.fLastOperation || feedback !== this.fLastFeedback) {
			var feedbackSet= false;
			if (this.fLastTarget != null) {
				dojo.removeClass(this.fController.fGridViewer.domNode, this.fLastOperation === IDropResponse.DROP_NO ? DragDropController.OPERATION_NONE : DragDropController.OPERATION_MOVE);
			}
			if (gadget != null) {
				dojo.addClass(this.fController.fGridViewer.domNode, operation === IDropResponse.DROP_NO ? DragDropController.OPERATION_NONE : DragDropController.OPERATION_MOVE);
				this.fController.setFeedback(gadget, feedback);
				feedbackSet= true;
			}
			if (!feedbackSet && this.fLastTarget != null && this.fLastFeedback !== 0) {
				this.fController.removeFeedback();
			}
			this.fLastTarget= gadget;
			this.fLastOperation= operation;
			this.fLastFeedback= feedback;
		}
	}
});
var ResizeState= dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.DragDropController.ResizeState", DragDropState, { //$NON-NLS-1$

	fResizeDragable: null,

	fResizeData: null,

	fResizeStyle: null,

	fLastLocation: null,

	constructor: function(controller, resizeDragable, resizeData) {
		this.inherited(arguments, [controller]);
		this.fResizeDragable= resizeDragable;
		this.fResizeData= resizeData;
		this.fResizeStyle= ""; //$NON-NLS-1$
		if (this.fResizeData.getResizeType() === ResizeType.Horizontal) {
			this.fResizeStyle= DragDropController.RESIZE_HORIZONTAL;
		} else if (this.fResizeData.getResizeType() === ResizeType.Vertical) {
			this.fResizeStyle= DragDropController.RESIZE_VERTICAL;
		} else if (this.fResizeData.getResizeType() === ResizeType.Move) {
			this.fResizeStyle= DragDropController.RESIZE_MOVE;
		} else if (this.fResizeData.getResizeType() === ResizeType.Pan) {
			this.fResizeStyle= DragDropController.RESIZE_PAN;
		}
		dojo.addClass(dojo.body(), this.fResizeStyle);
		this.fController.createResizeAvatar(resizeDragable, resizeData);
	},

	onMove: function(location) {
		this.fLastLocation= location;
		location.stopEvent();
		this.fResizeDragable.onResizeDrag(this.fResizeData, location.clientX, location.clientY);
		return this;
	},

	onRelease: function(location) {
		if (location == null) 
			location= this.fLastLocation;
		this.fResizeDragable.doResize(this.fResizeData, location.clientX, location.clientY);
		dojo.removeClass(dojo.body(), this.fResizeStyle);
	}
});

})();
