/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.gridviewer.DynamicStyleManager"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.NativeStyleSheetManager"); //$NON-NLS-1$

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var Assert= com.ibm.jdojo.util.Assert;
var NativeStyleSheetManager= com.ibm.team.rtc.foundation.web.ui.gridviewer.NativeStyleSheetManager;

/**
 * @since 3.0
 */
dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.DynamicStyleManager", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fRules: null,

	fUpdateCount: null,

	fRuleUpdater: null,

	constructor: function() {
		this.fRules= {};
		this.fUpdateCount= 0;
	},

	beginUpdate: function() {
		if (!(this.fUpdateCount >= 0)) Assert.fail("this.fUpdateCount >= 0", "com.ibm.team.rtc.foundation.web.ui.gridviewer.DynamicStyleManager:28");
		if (!(this.fUpdateCount === 0 ? this.fRuleUpdater == null : this.fRuleUpdater != null)) Assert.fail("this.fUpdateCount === 0 ? this.fRuleUpdater == null : this.fRuleUpdater != null", "com.ibm.team.rtc.foundation.web.ui.gridviewer.DynamicStyleManager:29");
		this.fUpdateCount+= 1;
		var result= this.fRuleUpdater;
		if (result == null) {
			result= this.fRuleUpdater= new RuleUpdater(this.fRules);
		}
		return result;
	},

	endUpdate: function() {
		if (!(this.fUpdateCount > 0 && this.fRuleUpdater != null)) Assert.fail("this.fUpdateCount > 0 && this.fRuleUpdater != null", "com.ibm.team.rtc.foundation.web.ui.gridviewer.DynamicStyleManager:41");
		this.fUpdateCount-= 1;
		if (this.fUpdateCount === 0) {
			var ruleUpdater= this.fRuleUpdater;
			this.fRuleUpdater= null;
			if (ruleUpdater != null) {
				var newRules= ruleUpdater.fNewRules;
				var updateRules= ruleUpdater.fUpdateRules;
				var obsoleteRules= ruleUpdater.fObsoleteRules;
				var rules= NativeStyleSheetManager.getRules();
				for (var i= rules.length - 1; i >= 0; i--){
					var selector= rules[i].selectorText;
					if ((selector in updateRules)) {
						rules[i].style.cssText= updateRules[selector];
						this.fRules[selector]= updateRules[selector];
						delete updateRules[selector];
					}
				}
				var $subject= jdojo.getProperties(newRules);
				var $length= $subject.length;
				for (var $count= 0; $count < $length; $count++){
					var selector= $subject[$count];
					NativeStyleSheetManager.insertRule(selector, newRules[selector]);
					this.fRules[selector]= newRules[selector];
				}
			}
		}
	}
});
jdojo.declareInterface("com.ibm.team.rtc.foundation.web.ui.gridviewer.DynamicStyleManager.IRuleUpdater");

var RuleUpdater= dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.DynamicStyleManager.RuleUpdater", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fObsoleteRules: null,

	fNewRules: null,

	fUpdateRules: null,

	fPreviousRules: null,

	fCanOnlyUpdate: null,

	constructor: function(rules) {
		this.fObsoleteRules= {};
		this.fNewRules= {};
		this.fUpdateRules= {};
		this.fPreviousRules= rules;
		var $subject2= jdojo.getProperties(rules);
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var key= $subject2[$count2];
			this.fObsoleteRules[key]= true;
		}
	},

	allowUpdatedOnly: function() {
		if (!(jdojo.getProperties(this.fObsoleteRules).length === jdojo.getProperties(this.fPreviousRules).length)) Assert.fail("jdojo.getProperties(this.fObsoleteRules).length === jdojo.getProperties(this.fPreviousRules).length", "com.ibm.team.rtc.foundation.web.ui.gridviewer.DynamicStyleManager:103");
		if (!(jdojo.getProperties(this.fNewRules).length === 0)) Assert.fail("jdojo.getProperties(this.fNewRules).length === 0", "com.ibm.team.rtc.foundation.web.ui.gridviewer.DynamicStyleManager:104");
		this.fObsoleteRules= {};
		this.fCanOnlyUpdate= true;
	},

	setRule: function(selector, rule) {
		if ((selector in this.fPreviousRules)) {
			delete this.fObsoleteRules[selector];
			if (this.fPreviousRules[selector] !== rule) {
				this.fUpdateRules[selector]= rule;
			}
		} else {
			if (!(!this.fCanOnlyUpdate)) Assert.fail("!this.fCanOnlyUpdate", "com.ibm.team.rtc.foundation.web.ui.gridviewer.DynamicStyleManager:117");
			this.fNewRules[selector]= rule;
		}
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.DynamicStyleManager.IRuleUpdater': true //$NON-NLS-1$
	}
});

})();
