/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.gridviewer.ErrorCellGadget"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.JavaScriptException"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.CellGadget"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.rtc.foundation.web.ui.gridviewer", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var JavaScriptException= com.ibm.jdojo.lang.JavaScriptException;
var CellGadget= com.ibm.team.rtc.foundation.web.ui.gridviewer.CellGadget;
var Messages= dojo.i18n.getLocalization("com.ibm.team.rtc.foundation.web.ui.gridviewer", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

/**
 * @since 3.0
 */
dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.ErrorCellGadget", CellGadget, { //$NON-NLS-1$

	fException: null,

	fTextContainer: null,

	constructor: function(e, column, rowEntry, viewer) {
		this.inherited(arguments, [column, rowEntry, viewer]);
		this.fException= e;
	},

	doCreateCellContent: function(cellContainer) {
		dojo.addClass(cellContainer, "gridCellError"); //$NON-NLS-1$
		var message= dojo.create("div", {className: "message label"}, cellContainer); //$NON-NLS-1$ //$NON-NLS-2$
		this.fTextContainer= dojo.create("span", {className: "inner"}, message); //$NON-NLS-1$ //$NON-NLS-2$
		dojo.place(dojo.doc.createTextNode(Messages.ErrorCellGadget_CELL_LABEL), this.fTextContainer);
	},

	onTooltip: function(element) {
		var result= null;
		if (element === this.fTextContainer) {
			result= {};
			result.around= this.fTextContainer;
			var object= this.fException;
			if (object instanceof JavaScriptException) {
				object= object.getThrown();
			}
			var message= ""; //$NON-NLS-1$
			var trace= ""; //$NON-NLS-1$
			if (object instanceof Error) {
				var jsError= object;
				message= jsError.toString();
				if (dojo.isString(jsError["stack"])) { //$NON-NLS-1$
					trace= jsError["stack"].replace(new RegExp("\\n", "g"), "<br />"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
				}
			}
			result.html= "<div class='com-ibm-team-rtc-foundation-web-ui-gridviewer-ErrorCellGadget'>" + "<div class='title'>" + Messages.ErrorCellGadget_TOOLTIP_TITLE + "</div>" + "<div class='message'>" + message + "</div>" + "<div class='trace'>" + trace + "</div>" + "</div>"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$ //$NON-NLS-7$ //$NON-NLS-8$
		}
		return result;
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.ITooltipListener': true //$NON-NLS-1$
	}
});

})();
