/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.gridviewer.GridGadget"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.Utils"); //$NON-NLS-1$

(function() {
var Assert= com.ibm.jdojo.util.Assert;
var Utils= com.ibm.team.rtc.foundation.web.ui.gridviewer.Utils;

/**
 * @since 3.0
 */
dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.GridGadget", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fViewer: null,

	fGadgetNode: null,

	fChildGadgets: null,

	fIsReadOnly: null,

	constructor: function(viewer) {
		this.fChildGadgets= [];
		this.fViewer= viewer;
		this.fIsReadOnly= false;
	},

	createGadget: function() {
		if (!(this.fGadgetNode == null)) Assert.fail("duplicate gadget creation", "com.ibm.team.rtc.foundation.web.ui.gridviewer.GridGadget:36"); //$NON-NLS-1$
		this.fGadgetNode= this.doCreate();
		this.fViewer.registerGadget(this);
		dojo.query("a", this.fGadgetNode).forEach(dojo.hitch(this, function(element, index, array) { //$NON-NLS-1$
			element.tabIndex= -1;
		}));
		return this.fGadgetNode;
	},

	getGadgetNode: function() {
		return this.fGadgetNode;
	},

	registerChild: function(child) {
		this.fChildGadgets.push(child);
		return child;
	},

	destroy: function() {
		if (!(this.fGadgetNode != null)) Assert.fail("duplicate gadget disposal", "com.ibm.team.rtc.foundation.web.ui.gridviewer.GridGadget:57"); //$NON-NLS-1$
		this.fViewer.unregisterGadget(this);
		this.doDestroy();
		var $subject= this.fChildGadgets;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var childGadget= $subject[$count];
			childGadget.destroy();
		}
		this.fChildGadgets= null;
		if (this.fGadgetNode.parentNode != null) {
			this.fGadgetNode.parentNode.removeChild(this.fGadgetNode);
		}
		this.fGadgetNode= null;
	},

	isReadOnly: function() {
		return this.fIsReadOnly;
	},

	setReadOnly: function(readOnly) {
		this.fIsReadOnly= readOnly;
		var $subject2= this.fChildGadgets;
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var childGadget= $subject2[$count2];
			childGadget.setReadOnly(readOnly);
		}
	},

	getParent: function() {
		return this.fViewer.getParentGadget(this);
	},

	doCreate: function() {
		Assert.isTrue(false, "Abstract method 'doCreate' invoked");
	},

	doDestroy: function() {
	},

	getViewModel: function() {
		return this.fViewer.getViewModel();
	},

	getModificationPolicy: function() {
		return this.fViewer.getViewModel().getModificationPolicy();
	},

	findGadget: function(x, y) {
		return Utils.contains(dojo.position(this.fGadgetNode), x, y) ? this : null;
	}
});

})();
