/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.gridviewer.GridMenu"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.toolbar.PopupMenu"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.toolbar.SimplePopupMenuManager"); //$NON-NLS-1$

(function() {
var ItemStyle= com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle;
var PopupMenu= com.ibm.team.rtc.foundation.web.ui.toolbar.PopupMenu;
var SimplePopupMenuManager= com.ibm.team.rtc.foundation.web.ui.toolbar.SimplePopupMenuManager;

/**
 * @since 3.0
 */
dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.GridMenu", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fMenuManager: null,

	fGridViewer: null,

	fMenu: null,

	constructor: function(gridViewer) {
		this.fGridViewer= gridViewer;
		this.fMenuManager= new SimplePopupMenuManager();
	},

	open: function(forGadget) {
		if (this.fMenu == null) {
			this.fMenu= new PopupMenu(this.fMenuManager).create();
		}
		this.fGridViewer.showMenu(this.fMenu, forGadget.getGadgetNode());
		this.fMenu.focus();
	},

	addAction: function(item) {
		this.fMenuManager.addAction(item);
	},

	addMenuItem: function(item) {
		this.fMenuManager.addItem(item);
	},

	addEntry: function(id, label, iconUri, handler) {
		this.fMenuManager.addItem(new EntryItem(id, label, iconUri, handler));
	},

	destroy: function(preserveDom) {
		if (this.fMenu != null) {
			this.fMenu.destroy(preserveDom);
		}
	}
});
var EntryItem= dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.GridMenu.EntryItem", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fId: null,

	fName: null,

	fIconUrl: null,

	fHandler: null,

	constructor: function(id, name, iconUrl, handler) {
		this.fId= id;
		this.fName= name;
		this.fIconUrl= iconUrl;
		this.fHandler= handler;
	},

	getId: function() {
		return this.fId;
	},

	getName: function() {
		return this.fName;
	},

	getIconUrl: function() {
		return this.fIconUrl;
	},

	canHandle: function() {
		return true;
	},

	handle: function() {
		this.fHandler();
	},

	getStyle: function() {
		return ItemStyle.FLAT;
	},

	isChecked: function() {
		return false;
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.actions.IAbstractItem': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.api.ui.actions.IMenuItem': true //$NON-NLS-1$
	}
});

})();
