/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.gridviewer.GridRow"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.api.ui.essentials.IModificationPolicy"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.ViewEntryGadget"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.ModificationPolicyDropResponse"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.ViewEntryDragData"); //$NON-NLS-1$

(function() {
var Location= com.ibm.team.rtc.foundation.api.ui.essentials.IModificationPolicy.Location;
var ViewEntryGadget= com.ibm.team.rtc.foundation.web.ui.gridviewer.ViewEntryGadget;
var ModificationPolicyDropResponse= com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.ModificationPolicyDropResponse;
var ViewEntryDragData= com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.ViewEntryDragData;

/**
 * @since 3.0
 */
var GridRow= dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.GridRow", ViewEntryGadget, { //$NON-NLS-1$

	fCollapsible: null,

	constructor: function(entry, entryColumn, readAccessor, gadgetFactory, viewer) {
		this.inherited(arguments, [entry, entryColumn, readAccessor, gadgetFactory, viewer]);
		this.fCollapsible= true;
	},

	setCollapsible: function(collapsible) {
		this.fCollapsible= collapsible;
		if (this.fGadgetNode != null) {
			dojo.toggleClass(this.fGadgetNode, GridRow.NONCOLLAPSIBLE_CLASS, this.fCollapsible);
			if (!this.fCollapsible && !this.isExpanded()) {
				this.fViewer.setExpandedState(this.fViewEntry, true);
			}
		}
	},

	setHover: function(isHover, isMouse) {
		if (!this.isReadOnly()) {
			if (isHover) {
				dojo.addClass(this.fContentRow, GridRow.HOVER_CLASS);
				dojo.addClass(this.fContentRow, isMouse ? GridRow.MOUSE_HOVER_CLASS : GridRow.KEYBOARD_HOVER_CLASS);
			} else {
				if (!(dojo.hasClass(this.fContentRow, GridRow.MOUSE_HOVER_CLASS) ^ isMouse) && !((dojo.hasClass(this.fContentRow, GridRow.KEYBOARD_HOVER_CLASS) ^ !isMouse))) {
					dojo.removeClass(this.fContentRow, GridRow.HOVER_CLASS);
				}
				dojo.removeClass(this.fContentRow, isMouse ? GridRow.MOUSE_HOVER_CLASS : GridRow.KEYBOARD_HOVER_CLASS);
			}
		}
	},

	isAlwaysExpanded: function() {
		return !this.fCollapsible;
	},

	onMouseEnter: function(element) {
		if (!this.isReadOnly() && dojo.isDescendant(element, this.fContentRow)) {
			this.setHover(true, true);
		}
		return true;
	},

	onMouseLeave: function(element) {
		if (!this.isReadOnly() && dojo.isDescendant(element, this.fContentRow)) {
			this.setHover(false, true);
		} else if (this.fIsVirtual) {
			var $subject= this.fCells;
			var $length= $subject.length;
			for (var $count= 0; $count < $length; $count++){
				var cell= $subject[$count];
				if (cell.fGadgetNode != null && dojo.isDescendant(element, cell.fGadgetNode)) {
					this.setHover(false, true);
					break;
				}
			}
		}
		return true;
	},

	canDrop: function(event) {
		if (!(event.dragData instanceof ViewEntryDragData)) 
			return null;
		var draggedEntries= event.dragData.getViewEntries();
		var position= dojo.position(this.fContentElement);
		var locations;
		if (event.location.clientY - position.y < 4) {
			locations= [Location.Before, Location.Child, Location.After];
		} else if (event.location.clientY - position.y <= ((position.h / 2)|0)) {
			locations= [Location.Child, Location.Before, Location.After];
		} else if ((position.y + position.h) - event.location.clientY < 4) {
			locations= [Location.After, Location.Child, Location.Before];
		} else {
			locations= [Location.Child, Location.After, Location.Before];
		}
		if (this.isExpanded() && this.hasVisibleChildren()) {
			var afterLocation= dojo.indexOf(locations, Location.After);
			if (afterLocation !== -1) {
				locations.splice(afterLocation, 1);
			}
		}
		var $subject2= locations;
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var candidateLocation= $subject2[$count2];
			if (this.getModificationPolicy().canMove(draggedEntries, this.fViewEntry, candidateLocation)) {
				return new ModificationPolicyDropResponse(draggedEntries, this.fViewEntry, candidateLocation);
			}
		}
		return null;
	},

	drop: function(dropResponse) {
		if (!(dropResponse instanceof ModificationPolicyDropResponse)) {
			return false;
		}
		dropResponse.apply(this.getModificationPolicy());
		return true;
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.IMouseOverListener': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.IDropTarget': true //$NON-NLS-1$
	}
});

GridRow.ITEM_CLASS= "item"; //$NON-NLS-1$
GridRow.GROUP_CLASS= "group"; //$NON-NLS-1$
GridRow.ROW_CONTENT_CLASS= "rowContent"; //$NON-NLS-1$
GridRow.HOVER_CLASS= "hover"; //$NON-NLS-1$
GridRow.KEYBOARD_HOVER_CLASS= "keyboardHover"; //$NON-NLS-1$
GridRow.MOUSE_HOVER_CLASS= "mouseHover"; //$NON-NLS-1$
GridRow.NONCOLLAPSIBLE_CLASS= "noncollapsible"; //$NON-NLS-1$

})();
