/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.gridviewer.HeaderGadget"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.GridGadget"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.MeasureUtil"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.Utils"); //$NON-NLS-1$

(function() {
var GridGadget= com.ibm.team.rtc.foundation.web.ui.gridviewer.GridGadget;
var MeasureUtil= com.ibm.team.rtc.foundation.web.ui.gridviewer.MeasureUtil;
var Utils= com.ibm.team.rtc.foundation.web.ui.gridviewer.Utils;
var Direction= com.ibm.team.rtc.foundation.web.ui.gridviewer.Utils.Direction;

/**
 * @since 3.0
 */
dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.HeaderGadget", GridGadget, { //$NON-NLS-1$

	fColumns: null,

	fGadgetFactory: null,

	fHeaders: null,

	fHeight: null,

	fThisColumn: null,

	fVirtualPlaceholder: null,

	constructor: function(headerColumns, thisColumn, readAccessor, gadgetFactory, viewer) {
		this.inherited(arguments, [viewer]);
		this.fHeight= 0;
		this.fThisColumn= thisColumn;
		this.fGadgetFactory= gadgetFactory;
		this.fColumns= headerColumns.getColumns(readAccessor);
	},

	doCreate: function() {
		var headerElement= dojo.create("table", {className: "headerTable  " + this.fViewer.getColumnClassName(this.fThisColumn) + "_resize"}, this.fGadgetNode, 'first'); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		if (dojo.isIE < 8) {
			headerElement.setAttribute("cellSpacing", "0"); //$NON-NLS-1$ //$NON-NLS-2$
			headerElement.setAttribute("cellPadding", "0"); //$NON-NLS-1$ //$NON-NLS-2$
		}
		var body= dojo.create("tbody", null, headerElement); //$NON-NLS-1$
		var headerRow= dojo.create("tr", {className: "header"}, body); //$NON-NLS-1$ //$NON-NLS-2$
		var minHeight= null;
		this.fHeaders= [];
		for (var i= 0; i < this.fColumns.length; i++){
			var headerGadget= this.registerChild(this.fGadgetFactory.newHeaderGadget(this.fColumns[i]));
			dojo.place(headerGadget.createGadget(), headerRow);
			this.fHeaders.push(headerGadget);
			var currentHeight= headerGadget.getMinimalHeight();
			minHeight= minHeight != null ? MeasureUtil.INSTANCE.max(minHeight, currentHeight) : currentHeight;
		}
		var finalSize= this.fHeight= MeasureUtil.INSTANCE.convertToPixels(minHeight);
		var $subject= this.fHeaders;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var header= $subject[$count];
			header.setFinalHeight(finalSize);
		}
		if (this.fViewer.fVirtualTableContext != null) {
			this.fVirtualPlaceholder= dojo.create("td", {className: "virtualPlaceholder", style: {height: finalSize - 3 + "px"}}, headerRow, 'first'); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		}
		headerElement.style.height= this.fHeight + "px"; //$NON-NLS-1$
		return headerElement;
	},

	findGadget: function(x, y) {
		return Utils.find(this.fHeaders, x, y, Direction.Horizontal);
	},

	updateHeight: function() {
		var minHeight= null;
		var $subject2= this.fHeaders;
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var header= $subject2[$count2];
			var currentHeight= header.getMinimalHeight();
			minHeight= minHeight != null ? MeasureUtil.INSTANCE.max(minHeight, currentHeight) : currentHeight;
		}
		var finalSize= MeasureUtil.INSTANCE.convertToPixels(minHeight);
		if (finalSize !== this.fHeight) {
			this.fHeight= finalSize;
			var $subject3= this.fHeaders;
			var $length3= $subject3.length;
			for (var $count3= 0; $count3 < $length3; $count3++){
				var header= $subject3[$count3];
				header.setFinalHeight(finalSize);
			}
			if (this.fViewer.fVirtualTableContext != null) {
				this.fVirtualPlaceholder.style.height= (this.fHeight - 3) + "px"; //$NON-NLS-1$
			}
			this.fGadgetNode.style.height= this.fHeight + "px"; //$NON-NLS-1$
			this.fViewer.refreshVirtualizationState();
		}
	},

	canDrop: function(event) {
		return null;
	},

	drop: function(dropResponse) {
		return false;
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.IDropTarget': true //$NON-NLS-1$
	}
});

})();
