/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.gridviewer.KeyboardNavigationHandler"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.IViewModel"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.CellGadget"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.GridRow"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.ViewEntryGadget"); //$NON-NLS-1$

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var Assert= com.ibm.jdojo.util.Assert;
var Domain= com.ibm.team.rtc.foundation.api.ui.model.IViewModel.Domain;
var CellGadget= com.ibm.team.rtc.foundation.web.ui.gridviewer.CellGadget;
var GridRow= com.ibm.team.rtc.foundation.web.ui.gridviewer.GridRow;
var ViewEntryGadget= com.ibm.team.rtc.foundation.web.ui.gridviewer.ViewEntryGadget;
var keys= dojo.keys;

/**
 * @since 3.0
 */
dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.KeyboardNavigationHandler", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fGridViewer: null,

	fEventHandlers: null,

	fEditSessionCount: null,

	fFocusPreserveCount: null,

	fMustRestoreFocus: null,

	fMustRestoreFocusAfterEdit: null,

	fTopGuard: null,

	fBottomGuard: null,

	fIgnoreGuardFocus: null,

	constructor: function(gridViewer) {
		this.fEventHandlers= [];
		this.fEditSessionCount= 0;
		this.fFocusPreserveCount= 0;
		this.fMustRestoreFocus= false;
		this.fIgnoreGuardFocus= false;
		this.fRemoveFocusTimeout= 0;
		this.fFocusGainHandler= dojo.hitch(this, function(event) {
			if (event.target === this.fTopGuard || event.target === this.fBottomGuard) {
				if (!this.fIgnoreGuardFocus) {
					this.showFocus(this.ensureFocusNodeValid(this.fFocusEntry), this.fFocusColumn);
				}
				return ;
			}
			this.fGridViewerHasFocus= true;
			var focusEntry= this.fGridViewer.getAspect(event.target, ViewEntryGadget);
			if (focusEntry == null) {
				focusEntry= this.fFocusEntry != null ? this.ensureFocusNodeValid(this.fFocusEntry) : null;
			}
			if (focusEntry instanceof GridRow) {
				if (this.fRemoveFocusTimeout !== 0) {
					window.clearTimeout(this.fRemoveFocusTimeout);
					this.fRemoveFocusTimeout= 0;
					this.removeFocusRow(focusEntry);
				}
				if (focusEntry !== this.fFocusEntry && this.fFocusEntry instanceof GridRow) {
					this.fFocusEntry.setHover(false, false);
				}
				focusEntry.setHover(true, false);
				var cellGadget= this.fGridViewer.getAspect(event.target, CellGadget);
				if (cellGadget != null) {
					this.fFocusColumn= cellGadget.fColumn;
				}
				this.fFocusEntry= focusEntry;
				if (cellGadget != null && jdojo.implementsInterface(cellGadget, "com.ibm.team.rtc.foundation.web.ui.gridviewer.IFocusListener")) {
					if (event.target !== cellGadget.getGadgetNode()) {
						cellGadget.onFocusGain(event);
					}
				}
			}
		});
		this.fFocusLostHandler= dojo.hitch(this, function(event) {
			if (event.target === this.fTopGuard || event.target === this.fBottomGuard) {
				return ;
			}
			this.fGridViewerHasFocus= false;
			if (this.fFocusEntry instanceof GridRow && this.fEditSessionCount === 0) {
				this.fFocusRemoveRow= this.fFocusEntry;
				this.fRemoveFocusTimeout= window.setTimeout(dojo.hitch(this, function() {
					this.removeFocusRow(null);
					this.fRemoveFocusTimeout= 0;
				}), 0);
			}
			if (this.fFocusEntry instanceof GridRow) {
				var cellGadget= this.fGridViewer.getAspect(event.target, CellGadget);
				if (cellGadget != null && jdojo.implementsInterface(cellGadget, "com.ibm.team.rtc.foundation.web.ui.gridviewer.IFocusListener")) {
					if (event.target !== cellGadget.getGadgetNode()) {
						cellGadget.onFocusLost(event);
					}
				}
			}
		});
		this.fGridViewer= gridViewer;
	},

	initialize: function(topFocusGuard, bottomFocusGuard) {
		this.fTopGuard= topFocusGuard;
		this.fBottomGuard= bottomFocusGuard;
		this.setTabable(this.fTopGuard, true);
		this.setTabable(this.fBottomGuard, true);
		if (dojo.isIE) {
			this.fEventHandlers.push(dojo.connect(this.fGridViewer.domNode, "focusin", this.fFocusGainHandler)); //$NON-NLS-1$
			this.fEventHandlers.push(dojo.connect(this.fGridViewer.domNode, "focusout", this.fFocusLostHandler)); //$NON-NLS-1$
		} else {
			this.fGridViewer.domNode["addEventListener"].apply(this.fGridViewer.domNode, ["focus", this.fFocusGainHandler, true]); //$NON-NLS-1$ //$NON-NLS-2$
			this.fGridViewer.domNode["addEventListener"].apply(this.fGridViewer.domNode, ["blur", this.fFocusLostHandler, true]); //$NON-NLS-1$ //$NON-NLS-2$
		}
		this.fEventHandlers.push(dojo.connect(this.fGridViewer.domNode, 'keydown', dojo.hitch(this, "keyPressed"))); //$NON-NLS-1$ //$NON-NLS-2$
	},

	dispose: function() {
		var $subject= this.fEventHandlers;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var handle= $subject[$count];
			dojo.disconnect(handle);
		}
		if (!dojo.isIE) {
			this.fGridViewer.domNode["removeEventListener"].apply(this.fGridViewer.domNode, ["focus", this.fFocusGainHandler, true]); //$NON-NLS-1$ //$NON-NLS-2$
			this.fGridViewer.domNode["removeEventListener"].apply(this.fGridViewer.domNode, ["blur", this.fFocusLostHandler, true]); //$NON-NLS-1$ //$NON-NLS-2$
		}
		this.fEventHandlers= null;
	},

	onBeginEditSession: function() {
		if (this.fEditSessionCount === 0) {
			this.fMustRestoreFocusAfterEdit= this.fGridViewerHasFocus;
		}
		this.fEditSessionCount++;
	},

	onEndEditSession: function(restoreFocus) {
		this.fEditSessionCount--;
		if (!(this.fEditSessionCount >= 0)) Assert.fail("this.fEditSessionCount >= 0", "com.ibm.team.rtc.foundation.web.ui.gridviewer.KeyboardNavigationHandler:98");
		if (this.fEditSessionCount === 0 && this.fMustRestoreFocusAfterEdit) {
			if (restoreFocus) {
				this.showFocus(this.ensureFocusNodeValid(this.fFocusEntry), this.fFocusColumn);
			}
			this.fMustRestoreFocusAfterEdit= false;
		}
	},

	beginPreserveFocus: function() {
		if (this.fFocusPreserveCount === 0) {
			this.fMustRestoreFocus= this.fGridViewerHasFocus;
		}
		this.fFocusPreserveCount++;
	},

	endPreserveFocus: function() {
		this.fFocusPreserveCount--;
		if (!(this.fFocusPreserveCount >= 0)) Assert.fail("this.fFocusPreserveCount >= 0", "com.ibm.team.rtc.foundation.web.ui.gridviewer.KeyboardNavigationHandler:116");
		if (this.fFocusPreserveCount === 0 && this.fMustRestoreFocus) {
			this.showFocus(this.ensureFocusNodeValid(this.fFocusEntry), this.fFocusColumn);
			this.fMustRestoreFocus= false;
		}
	},

	ensureFocusNodeValid: function(currentEntry) {
		if (currentEntry != null) {
			if (currentEntry.getGadgetNode() != null && !currentEntry.getViewEntry().isDisposed()) {
				return currentEntry;
			}
		}
		return this.fGridViewer.getViewModel().readModel(dojo.hitch(this, function(readAccessor) {
			if (currentEntry != null) {
				var viewEntry= currentEntry.getViewEntry();
				if (!viewEntry.isDisposed()) {
					var newGadget= this.fGridViewer.getViewEntryGadget(viewEntry);
					if (newGadget != null && this.isVisible(newGadget)) {
						return newGadget;
					}
				}
				var element= viewEntry.getElement();
				var candidateEntry= readAccessor.getEntryNavigator(true).findPrimaryEntry(element);
				if (candidateEntry == null) {
					candidateEntry= readAccessor.getEntryNavigator(true).findFirstEntryInSubtree(element, readAccessor.getRootEntry(Domain.Content));
				}
				if (candidateEntry != null) {
					var newGadget= this.fGridViewer.getViewEntryGadget(candidateEntry);
					if (newGadget != null && this.isVisible(newGadget)) {
						return newGadget;
					}
				}
			}
			return this.findNextEntry(null, readAccessor);
		}));
	},

	keyPressed: function(event) {
		this.fGridViewer.getViewModel().readModel(dojo.hitch(this, function(readAccessor) {
			if (event.keyCode === keys.TAB) {
				var guard= event.shiftKey ? this.fTopGuard : this.fBottomGuard;
				this.fIgnoreGuardFocus= true;
				try {
					dijit.focus(guard);
				} finally {
					this.fIgnoreGuardFocus= false;
				}
				return null;
			}
			var isHandled= false;
			if (this.fFocusEntry != null) {
				var dispatchGadget= this.fFocusColumn != null ? this.fFocusEntry.getCell(this.fFocusColumn) : null;
				if (dispatchGadget == null) {
					dispatchGadget= this.fFocusEntry;
				}
				if (jdojo.implementsInterface(dispatchGadget, "com.ibm.team.rtc.foundation.web.ui.gridviewer.IKeyboardHandler")) {
					isHandled= dispatchGadget.onKeyDown(event);
				}
			}
			if (!isHandled) {
				switch(event.keyCode) {
					case keys.DOWN_ARROW:
						{
							var focusEntry= this.findNextEntry(this.fFocusEntry, readAccessor);
							this.iterateCustomFocus(focusEntry, this.fFocusColumn, true, true);
							this.showFocus(focusEntry, this.fFocusColumn);
							isHandled= true;
							break;
						}
					case keys.UP_ARROW:
						{
							var focusEntry= this.findPreviousEntry(this.fFocusEntry, readAccessor);
							this.iterateCustomFocus(focusEntry, this.fFocusColumn, true, true);
							this.showFocus(focusEntry, this.fFocusColumn);
							isHandled= true;
							break;
						}
					case keys.LEFT_ARROW:
						{
							if (event.ctrlKey) {
								if (this.fFocusEntry != null) {
									this.fGridViewer.setExpandedState(this.fFocusEntry.getViewEntry(), false);
								}
							} else {
								if (this.iterateCustomFocus(this.fFocusEntry, this.fFocusColumn, false, false)) {
									this.showFocus(this.fFocusEntry, this.fFocusColumn);
								} else {
									var newColumn= this.findColumn(this.fFocusColumn, false, readAccessor);
									this.iterateCustomFocus(this.fFocusEntry, newColumn, true, false);
									this.showFocus(this.fFocusEntry, newColumn);
								}
							}
							isHandled= true;
							break;
						}
					case keys.RIGHT_ARROW:
						{
							if (event.ctrlKey) {
								if (this.fFocusEntry != null) {
									this.fGridViewer.setExpandedState(this.fFocusEntry.getViewEntry(), true);
								}
							} else {
								if (this.iterateCustomFocus(this.fFocusEntry, this.fFocusColumn, false, true)) {
									this.showFocus(this.fFocusEntry, this.fFocusColumn);
								} else {
									var newColumn= this.findColumn(this.fFocusColumn, true, readAccessor);
									if (newColumn != null) {
										this.iterateCustomFocus(this.fFocusEntry, newColumn, true, true);
										this.showFocus(this.fFocusEntry, newColumn);
									}
								}
							}
							isHandled= true;
							break;
						}
					case keys.SPACE:
						{
							if (this.fFocusEntry != null) {
								var viewEntry= this.fFocusEntry.getViewEntry();
								this.fGridViewer.getViewModel().setSelected(viewEntry, !this.fFocusEntry.isSelected());
								isHandled= true;
							}
							break;
						}
				}
				if (isHandled) {
					event.preventDefault();
				}
			}
			return null;
		}));
	},

	registerFocus: function(entryGadget, column) {
		if (entryGadget !== this.fFocusEntry) {
			if (this.fFocusEntry instanceof GridRow) {
				this.fFocusEntry.setHover(false, false);
			}
			if (entryGadget instanceof GridRow) {
				entryGadget.setHover(true, false);
			}
			this.fFocusEntry= entryGadget;
		}
		this.fFocusColumn= column;
	},

	showFocus: function(entryGadget, column) {
		if (entryGadget != null) {
			this.fGridViewer.ensureMaterialized(entryGadget);
			var focusElement= entryGadget.fContentElement;
			if (entryGadget !== this.fFocusEntry) {
				if (this.fFocusEntry instanceof GridRow) {
					this.fFocusEntry.setHover(false, false);
				}
				this.fFocusEntry= entryGadget;
			}
			if (entryGadget instanceof GridRow) {
				entryGadget.setHover(true, false);
			}
			if (column != null) {
				var cell= entryGadget.getCell(column);
				if (cell != null) {
					focusElement= cell.getGadgetNode();
					if (jdojo.implementsInterface(cell, "com.ibm.team.rtc.foundation.web.ui.gridviewer.IFocusElementProvider")) {
						var customFocusElement= cell.getFocusElement();
						if (customFocusElement != null) {
							focusElement= customFocusElement;
						}
					}
				}
			}
			this.fFocusColumn= column;
			if (focusElement != null) {
				this.setTabable(focusElement, true);
				dijit.focus(focusElement);
			}
		}
	},

	iterateCustomFocus: function(entryGadget, column, reset, leftToRight) {
		if (entryGadget != null) {
			var cell= entryGadget.getCell(column);
			if (jdojo.implementsInterface(cell, "com.ibm.team.rtc.foundation.web.ui.gridviewer.IFocusElementProvider")) {
				return cell.nextFocusElement(reset, leftToRight);
			}
		}
		return false;
	},

	setTabable: function(element, tabable) {
		element.tabIndex= tabable ? 0 : -1;
	},

	findColumn: function(start, next, readAccessor) {
		if (this.fFocusEntry != null) {
			var columns= this.fFocusEntry.fPropertyColumns;
			if (columns.length === 0) 
				return null;
			var columnIndex= start != null ? dojo.indexOf(columns, start) : -1;
			columnIndex+= next ? 1 : -1;
			return columnIndex >= 0 && columnIndex < columns.length ? columns[columnIndex] : null;
		}
		return null;
	},

	findNextEntry: function(start, readAccessor) {
		var n= readAccessor.getEntryNavigator(true);
		var candidateGadget= start;
		var candidateEntry= null;
		if (candidateGadget == null) {
			candidateEntry= readAccessor.getRootEntry(Domain.Content);
			candidateGadget= this.fGridViewer.getViewEntryGadget(candidateEntry);
		} else {
			candidateEntry= candidateGadget.getViewEntry();
		}
		if (candidateEntry != null && candidateGadget != null) {
			if (candidateGadget.isExpanded()) {
				var entries= n.childEntries(candidateEntry);
				if (entries.length > 0) {
					return this.fGridViewer.getViewEntryGadget(entries[0]);
				}
			}
			while(!candidateEntry.isRootEntry()){
				var successorEntry= n.successorEntry(candidateEntry);
				if (successorEntry != null) {
					var entryGadget= this.fGridViewer.getViewEntryGadget(successorEntry);
					if (entryGadget != null && this.isVisible(entryGadget)) 
						return entryGadget;
				}
				candidateEntry= n.parentEntry(candidateEntry);
			}
		}
		return start;
	},

	findPreviousEntry: function(start, readAccessor) {
		var n= readAccessor.getEntryNavigator(true);
		if (start == null) {
			var rootGadget= this.fGridViewer.getViewEntryGadget(readAccessor.getRootEntry(Domain.Content));
			return this.getLastChild(rootGadget, readAccessor);
		}
		var candidateEntry= n.predecessorEntry(start.getViewEntry());
		if (candidateEntry != null) {
			return this.getLastChild(this.fGridViewer.getViewEntryGadget(candidateEntry), readAccessor);
		}
		var parentEntry= n.parentEntry(start.getViewEntry());
		if (!parentEntry.isRootEntry()) {
			return this.fGridViewer.getViewEntryGadget(parentEntry);
		}
		return start;
	},

	getLastChild: function(entryGadget, readAccessor) {
		var n= readAccessor.getEntryNavigator(true);
		if (entryGadget.isExpanded()) {
			var childEntries= n.childEntries(entryGadget.getViewEntry());
			if (childEntries.length > 0) {
				var lastChild= this.fGridViewer.getViewEntryGadget(childEntries[childEntries.length - 1]);
				return this.getLastChild(lastChild, readAccessor);
			}
		}
		return entryGadget;
	},

	isVisible: function(entryGadget) {
		entryGadget= entryGadget.getParent();
		while(entryGadget != null){
			if (!entryGadget.isExpanded()) 
				return false;
			entryGadget= entryGadget.getParent();
		}
		return true;
	},

	fGridViewerHasFocus: null,

	fFocusEntry: null,

	fFocusColumn: null,

	fFocusRemoveRow: null,

	fRemoveFocusTimeout: null,

	fFocusGainHandler: null,

	fFocusLostHandler: null,

	removeFocusRow: function(newRow) {
		if (this.fFocusRemoveRow != null && this.fFocusRemoveRow !== newRow) {
			this.fFocusRemoveRow.setHover(false, false);
			this.fFocusRemoveRow= null;
		}
	}
});

})();
