/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.gridviewer.LabelCell"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.CellGadget"); //$NON-NLS-1$

(function() {
var Assert= com.ibm.jdojo.util.Assert;
var CellGadget= com.ibm.team.rtc.foundation.web.ui.gridviewer.CellGadget;
var keys= dojo.keys;

/**
 * A generic label cell, with optional icon and link
 * @since 3.0
 */
dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.LabelCell", CellGadget, { //$NON-NLS-1$

	fLabel: null,

	fIconUrl: null,

	fLinkUrl: null,

	constructor: function(label, iconUrl, column, rowEntry, viewer) {
		this.inherited(arguments, [column, rowEntry, viewer]);
		this.fLabel= label;
		this.fIconUrl= iconUrl;
	},

	setLink: function(url) {
		if (!(this.fGadgetNode == null)) Assert.fail("this.fGadgetNode == null", "com.ibm.team.rtc.foundation.web.ui.gridviewer.LabelCell:40");
		this.fLinkUrl= url;
	},

	doCreateCellContent: function(cellContainer) {
		if (this.fIconUrl != null) {
			dojo.create("img", {src: this.fIconUrl, className: "icon"}, cellContainer); //$NON-NLS-1$ //$NON-NLS-2$
		}
		var textContainer;
		if (this.fLinkUrl != null) {
			textContainer= dojo.create("a", {href: this.fLinkUrl}, cellContainer); //$NON-NLS-1$
		} else {
			textContainer= dojo.create("span", null, cellContainer); //$NON-NLS-1$
		}
		dojo.addClass(textContainer, "label"); //$NON-NLS-1$
		textContainer.appendChild(dojo.doc.createTextNode(this.fLabel));
	},

	onKeyDown: function(event) {
		if (event.keyCode === keys.ENTER) {
			if (this.fLinkUrl != null) {
				window.location.replace(this.fLinkUrl);
				event.preventDefault();
				return true;
			}
		}
		return false;
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.IKeyboardHandler': true //$NON-NLS-1$
	}
});

})();
