/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.gridviewer.ToolbarGadget"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.Property"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.actions.ActionItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.GridGadget"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.toolbar.PopupMenu"); //$NON-NLS-1$

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var Assert= com.ibm.jdojo.util.Assert;
var ItemStyle= com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle;
var Property= com.ibm.team.rtc.foundation.api.ui.actions.Property;
var ActionItem= com.ibm.team.rtc.foundation.web.ui.actions.ActionItem;
var GridGadget= com.ibm.team.rtc.foundation.web.ui.gridviewer.GridGadget;
var PopupMenu= com.ibm.team.rtc.foundation.web.ui.toolbar.PopupMenu;
var keys2= dojo.keys;

var ToolbarGadget= dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.ToolbarGadget", GridGadget, { //$NON-NLS-1$

	fActions: null,

	fToolBarGadgets: null,

	constructor: function(viewer) {
		this.inherited(arguments, [viewer]);
		this.fActions= [];
		this.fToolBarGadgets= {};
		this.fCurrentActionIndex= 0;
	},

	addAction: function(action) {
		if (!(this.fToolBarGadgets[action.getId()] == null)) Assert.fail("this.fToolBarGadgets[action.getId()] == null", "com.ibm.team.rtc.foundation.web.ui.gridviewer.ToolbarGadget:360");
		this.fActions.push(action);
		if (jdojo.implementsInterface(action, "com.ibm.team.rtc.foundation.api.ui.actions.IPropertyChangeEventProvider")) {
			action.addPropertyListener(this);
		}
		if (this.fGadgetNode != null) {
			this.createWidgetForAction(action, this.fGadgetNode);
		}
	},

	getAction: function(id) {
		for (var i= 0; i < this.fActions.length; i++){
			var action= this.fActions[i];
			if (action.getId() === id) 
				return action;
		}
		return null;
	},

	fCurrentActionIndex: null,

	nextFocusElement: function(reset, leftToRight) {
		if (reset) {
			this.fCurrentActionIndex= leftToRight ? -1 : this.fActions.length;
		} else {
			var focusGadget= this.getFocusGadget();
			if (focusGadget != null && focusGadget.nextFocusElement(false, leftToRight)) {
				return true;
			}
		}
		while(true){
			this.fCurrentActionIndex+= leftToRight ? 1 : -1;
			var focusGadget= this.getFocusGadget();
			if (focusGadget != null) {
				if (focusGadget.nextFocusElement(true, leftToRight)) {
					return true;
				}
			} else {
				this.fCurrentActionIndex= Math.max(0, Math.min(this.fActions.length - 1, this.fCurrentActionIndex));
				return false;
			}
		}
	},

	getFocusElement: function() {
		var focusGadget= this.getFocusGadget();
		return focusGadget != null ? focusGadget.getFocusElement() : null;
	},

	onKeyDown: function(event) {
		var focusGadget= this.getFocusGadget();
		return focusGadget != null ? focusGadget.onKeyDown(event) : false;
	},

	getFocusGadget: function() {
		if (this.fCurrentActionIndex >= 0 && this.fCurrentActionIndex < this.fActions.length) {
			var action= this.fActions[this.fCurrentActionIndex];
			return this.fToolBarGadgets[action.getId()];
		}
		return null;
	},

	onMouseEnter: function(element) {
		var item= this.findToolBarGadget(element);
		if (item != null) {
			return item.onMouseEnter(element);
		}
		return false;
	},

	onMouseLeave: function(element) {
		var item= this.findToolBarGadget(element);
		if (item != null) {
			return item.onMouseLeave(element);
		}
		return false;
	},

	onMouseClick: function(event) {
		var gadget= this.findToolBarGadget(event.target);
		if (gadget != null) {
			return gadget.onMouseClick(event);
		}
		return false;
	},

	findToolBarGadget: function(element) {
		var target= element;
		while(target !== this.fGadgetNode){
			if (target == null || target.nodeType !== 1) 
				break;
			var actionId= target.getAttribute(ToolbarGadget.ACTION_ID);
			if (actionId != null && actionId.length > 0) {
				var result= this.fToolBarGadgets[actionId];
				if (result != null) {
					return result;
				}
			}
			target= target.parentNode;
		}
		return null;
	},

	doCreate: function() {
		var result= dojo.create("div", {className: ToolbarGadget.CLASSNAME}); //$NON-NLS-1$
		for (var i= 0; i < this.fActions.length; i++){
			var action= this.fActions[i];
			this.createWidgetForAction(action, result);
		}
		return result;
	},

	doDestroy: function() {
		for (var i= 0; i < this.fActions.length; i++){
			var action= this.fActions[i];
			if (jdojo.implementsInterface(action, "com.ibm.team.rtc.foundation.api.ui.actions.IPropertyChangeEventProvider")) {
				action.removePropertyListener(this);
			}
		}
		var keys= jdojo.getProperties(this.fToolBarGadgets);
		for (var i= 0; i < keys.length; ++i){
			var gadget= this.fToolBarGadgets[keys[i]];
			gadget.destroy();
		}
		this.inherited("doDestroy", arguments, []); //$NON-NLS-1$
	},

	createWidgetForAction: function(action, gadgetNode) {
		var item= null;
		var hasTextStyle= this.hasStyle(action, ItemStyle.TEXT);
		if (this.hasStyle(action, ItemStyle.FLAT)) {
			item= new ButtonGadget(action, hasTextStyle);
		} else if (this.hasStyle(action, ItemStyle.TOGGLE)) {
			item= new CheckedButtonGadget(action, hasTextStyle);
		} else if (this.hasStyle(action, ItemStyle.SEPARATOR)) {
			item= new Separator();
		} else if (this.hasStyle(action, ItemStyle.DROP_DOWN)) {
			item= new ButtonDropDownGadget(action, this.fViewer, hasTextStyle);
		} else {
			if (!(false)) Assert.fail("Button Style not supported", "com.ibm.team.rtc.foundation.web.ui.gridviewer.ToolbarGadget:512"); //$NON-NLS-1$
		}
		if (item != null) {
			item.createContent(gadgetNode);
			this.fToolBarGadgets[item.getId()]= item;
			item.updateEnabled();
		}
	},

	hasStyle: function(action, style) {
		if (jdojo.implementsInterface(action, "com.ibm.team.rtc.foundation.api.ui.actions.IAbstractItem")) {
			return (action.getStyle() & style) !== 0;
		} else {
			return style === ItemStyle.FLAT;
		}
	},

	onPropertyChange: function(source, property, newValue) {
		var gadget= this.fToolBarGadgets[source.getId()];
		if (gadget != null) {
			switch(property) {
				case Property.Enabled:
					gadget.updateEnabled();
					break;
				case Property.Name:
					gadget.updateName();
					break;
				case Property.Checked:
					if (gadget instanceof CheckedButtonGadget) 
						gadget.updateChecked();
					break;
			}
		}
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.actions.IPropertyListener': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.IFocusElementProvider': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.IKeyboardHandler': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.IMouseClickHandler': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.IMouseOverListener': true //$NON-NLS-1$
	}
});

ToolbarGadget.ACTION_ID= "actionId"; //$NON-NLS-1$
ToolbarGadget.CLASSNAME= "toolbarGadget"; //$NON-NLS-1$
jdojo.declareInterface("com.ibm.team.rtc.foundation.web.ui.gridviewer.ToolbarGadget.IToolBarGadget");

var ButtonGadget= dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.ToolbarGadget.ButtonGadget", ActionItem, { //$NON-NLS-1$

	fIncludeLabel: null,

	fButton: null,

	fActionLink: null,

	fActionIcon: null,

	fActionLabel: null,

	constructor: function(action, includeLabel) {
		this.inherited(arguments, [action]);
		this.fIncludeLabel= includeLabel;
	},

	createContent: function(parent) {
		var name= this.getName();
		var iconUrl= String(this.getIconUrl());
		var container= dojo.create("div", {className: ToolbarGadget.CLASSNAME + "-item"}); //$NON-NLS-1$ //$NON-NLS-2$
		this.fButton= dojo.create("div", {className: ToolbarGadget.CLASSNAME + "-button"}, container); //$NON-NLS-1$ //$NON-NLS-2$
		this.fButton.setAttribute(ToolbarGadget.ACTION_ID, this.getId());
		this.fActionLink= dojo.create("a", {href: "#", title: name, className: ToolbarGadget.CLASSNAME + "-action"}, this.fButton); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		this.fActionIcon= dojo.create("img", {src: iconUrl, alt: name}, this.fActionLink); //$NON-NLS-1$
		if (this.fIncludeLabel) {
			this.fActionLabel= dojo.create("span", {className: ToolbarGadget.CLASSNAME + "-label"}, this.fActionLink); //$NON-NLS-1$ //$NON-NLS-2$
			dojo.place(dojo.doc.createTextNode(name), this.fActionLabel);
		}
		dojo.place(container, parent, 'last'); //$NON-NLS-1$
	},

	onMouseEnter: function(element) {
		dojo.addClass(this.fButton, ButtonGadget.HOVER);
		dojo.addClass(this.fActionLink, ButtonGadget.HOVER_ON_PART);
		return true;
	},

	onMouseLeave: function(element) {
		dojo.removeClass(this.fButton, ButtonGadget.HOVER);
		dojo.removeClass(this.fActionLink, ButtonGadget.HOVER_ON_PART);
		return true;
	},

	onMouseClick: function(event) {
		if (this.canHandle()) {
			this.handle();
		}
		return true;
	},

	updateEnabled: function() {
		var isEnabled= this.canHandle();
		dojo.toggleClass(this.fButton, ToolbarGadget.CLASSNAME + "-button-disabled", !isEnabled); //$NON-NLS-1$
		dijit.setWaiState(this.fButton, "disabled", String(!isEnabled)); //$NON-NLS-1$
		if (isEnabled) {
			this.fActionLink.href= "#"; //$NON-NLS-1$
		} else {
			this.fButton.removeAttribute("href"); //$NON-NLS-1$
		}
	},

	updateName: function() {
		var name= this.getName();
		this.fActionLink.title= name;
		this.fActionIcon.alt= name;
	},

	nextFocusElement: function(reset, leftToRight) {
		return reset;
	},

	getFocusElement: function() {
		return this.fButton;
	},

	onKeyDown: function(event) {
		if (event.keyCode === keys2.ENTER) {
			event.preventDefault();
			this.handle();
			return true;
		}
		return false;
	},

	destroy: function() {
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.IFocusElementProvider': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.IKeyboardHandler': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.ToolbarGadget.IToolBarGadget': true //$NON-NLS-1$
	}
});

ButtonGadget.HOVER= "hover"; //$NON-NLS-1$
ButtonGadget.HOVER_ON_PART= "hoverOnPart"; //$NON-NLS-1$
var CheckedButtonGadget= dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.ToolbarGadget.CheckedButtonGadget", ButtonGadget, { //$NON-NLS-1$

	constructor: function(action, includeLabel) {
		this.inherited(arguments, [action, includeLabel]);
	},

	createContent: function(parent) {
		this.inherited("createContent", arguments, [parent]); //$NON-NLS-1$
		dojo.toggleClass(this.fButton, ToolbarGadget.CLASSNAME + "-button-pressed", this.isChecked()); //$NON-NLS-1$
	},

	updateChecked: function() {
		dojo.toggleClass(this.fButton, ToolbarGadget.CLASSNAME + "-button-pressed", this.isChecked()); //$NON-NLS-1$
	}
});
var ButtonDropDownGadget= dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.ToolbarGadget.ButtonDropDownGadget", ActionItem, { //$NON-NLS-1$

	fIncludeLabel: null,

	fButton: null,

	fActionLink: null,

	fActionIcon: null,

	fActionLabel: null,

	fDropDownLink: null,

	fDropDownIcon: null,

	fGridViewer: null,

	fMenu: null,

	constructor: function(action, gridViewer, includeLabel) {
		this.inherited(arguments, [action]);
		this.fGridViewer= gridViewer;
		this.fIncludeLabel= includeLabel;
	},

	createContent: function(parent) {
		var name= this.getName();
		var iconUrl= String(this.getIconUrl());
		var container= dojo.create("div", {className: ToolbarGadget.CLASSNAME + "-item"}); //$NON-NLS-1$ //$NON-NLS-2$
		this.fButton= dojo.create("div", {className: ToolbarGadget.CLASSNAME + "-button"}, container); //$NON-NLS-1$ //$NON-NLS-2$
		this.fButton.setAttribute(ToolbarGadget.ACTION_ID, this.getId());
		this.fActionLink= dojo.create("a", {href: "#", title: name, className: ToolbarGadget.CLASSNAME + "-action"}, this.fButton); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		this.fActionIcon= dojo.create("img", {src: iconUrl, alt: name}, this.fActionLink); //$NON-NLS-1$
		if (this.fIncludeLabel) {
			this.fActionLabel= dojo.create("span", {className: ToolbarGadget.CLASSNAME + "-label"}, this.fActionLink); //$NON-NLS-1$ //$NON-NLS-2$
			dojo.place(dojo.doc.createTextNode(name), this.fActionLabel);
		}
		this.fDropDownLink= dojo.create("a", {href: "#", className: ToolbarGadget.CLASSNAME + "-dropDown " + ToolbarGadget.CLASSNAME + "-arrow"}, this.fButton); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		dojo.place(container, parent, 'last'); //$NON-NLS-1$
	},

	onMouseEnter: function(element) {
		dojo.addClass(this.fButton, ButtonDropDownGadget.HOVER);
		dojo.addClass(this.fDropDownLink, ButtonDropDownGadget.HOVER);
		if (element === this.fActionLink || element === this.fActionIcon) {
			dojo.addClass(this.fActionLink, ButtonDropDownGadget.HOVER_ON_PART);
			dojo.removeClass(this.fDropDownLink, ButtonDropDownGadget.HOVER_ON_PART);
		} else if (element === this.fDropDownLink || element === this.fDropDownIcon) {
			dojo.addClass(this.fDropDownLink, ButtonDropDownGadget.HOVER_ON_PART);
			dojo.removeClass(this.fActionLink, ButtonDropDownGadget.HOVER_ON_PART);
		}
		return true;
	},

	onMouseLeave: function(element) {
		dojo.removeClass(this.fButton, ButtonDropDownGadget.HOVER);
		dojo.removeClass(this.fActionLink, ButtonDropDownGadget.HOVER_ON_PART);
		dojo.removeClass(this.fDropDownLink, ButtonDropDownGadget.HOVER);
		dojo.removeClass(this.fDropDownLink, ButtonDropDownGadget.HOVER_ON_PART);
		return true;
	},

	onMouseClick: function(event) {
		var target= event.target;
		while(target != null && target !== this.fButton){
			if (target === this.fActionLink) {
				if (!this.canHandle()) 
					return true;
				this.handleWithEvent(this.fGridViewer, event, this.fActionLink);
				return true;
			} else if (target === this.fDropDownLink) {
				if (jdojo.implementsInterface(this.getAction(), "com.ibm.team.rtc.foundation.api.ui.actions.IPopupMenuItem")) {
					dojo.stopEvent(event);
					if (this.fMenu == null) {
						this.fMenu= new PopupMenu(this.getAction().getPopupMenu()).create();
					}
					this.fGridViewer.showMenu(this.fMenu, this.fActionLink);
					this.fMenu.focus();
					return true;
				}
			}
			target= target.parentNode;
		}
		return false;
	},

	updateEnabled: function() {
	},

	updateName: function() {
		var name= this.getName();
		this.fActionLink.title= name;
		this.fActionIcon.alt= name;
	},

	fDropDownFocus: null,

	nextFocusElement: function(reset, leftToRight) {
		if (reset) {
			this.fDropDownFocus= !leftToRight;
			return true;
		} else {
			if (leftToRight === !this.fDropDownFocus) {
				this.fDropDownFocus= !this.fDropDownFocus;
				return true;
			}
		}
		return false;
	},

	getFocusElement: function() {
		return this.fDropDownFocus ? this.fDropDownLink : this.fActionLink;
	},

	onKeyDown: function(event) {
		if (event.keyCode === keys2.ENTER) {
			event.preventDefault();
			if (this.fDropDownFocus) {
				if (jdojo.implementsInterface(this.getAction(), "com.ibm.team.rtc.foundation.api.ui.actions.IPopupMenuItem")) {
					var item= this.getAction();
					var menu= new PopupMenu(item.getPopupMenu()).create();
					this.fGridViewer.showMenu(menu, this.fActionLink);
					menu.focus();
					return true;
				}
			} else {
				this.handle();
				return true;
			}
		}
		return false;
	},

	destroy: function() {
		if (this.fMenu != null) {
			this.fMenu.destroy(false);
		}
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.IFocusElementProvider': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.IKeyboardHandler': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.ToolbarGadget.IToolBarGadget': true //$NON-NLS-1$
	}
});

ButtonDropDownGadget.HOVER= "hover"; //$NON-NLS-1$
ButtonDropDownGadget.HOVER_ON_PART= "hoverOnPart"; //$NON-NLS-1$
var Separator= dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.ToolbarGadget.Separator", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fId: null,

	constructor: function() {
		this.fId= "com.ibm.team.rtc.foundation.web.ui.gridviewer.Separator." + Separator.fIdPool++; //$NON-NLS-1$
	},

	getId: function() {
		return this.fId;
	},

	getName: function() {
		return this.fId;
	},

	getIconUrl: function() {
		return null;
	},

	canHandle: function() {
		return true;
	},

	handle: function() {
	},

	getStyle: function() {
		return ItemStyle.SEPARATOR;
	},

	isChecked: function() {
		return false;
	},

	createContent: function(parent) {
		dojo.create("div", {className: ToolbarGadget.CLASSNAME + "-separator"}, parent, 'last'); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
	},

	onMouseEnter: function(element) {
		return true;
	},

	onMouseLeave: function(element) {
		return true;
	},

	onMouseClick: function(event) {
		return true;
	},

	updateEnabled: function() {
	},

	updateName: function() {
	},

	nextFocusElement: function(reset, leftToRight) {
		return false;
	},

	getFocusElement: function() {
		return null;
	},

	onKeyDown: function(event) {
		return false;
	},

	destroy: function() {
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.actions.IAbstractItem': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.api.ui.actions.IToolBarItem': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.IFocusElementProvider': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.IKeyboardHandler': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.ToolbarGadget.IToolBarGadget': true //$NON-NLS-1$
	}
});

Separator.fIdPool= 0;

})();
