/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.gridviewer.TreeLabelCell"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.LabelCell"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.TreeTwistie"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.model.EntryUtils"); //$NON-NLS-1$

(function() {
var LabelCell= com.ibm.team.rtc.foundation.web.ui.gridviewer.LabelCell;
var TreeTwistie= com.ibm.team.rtc.foundation.web.ui.gridviewer.TreeTwistie;
var EntryUtils= com.ibm.team.rtc.foundation.web.ui.model.EntryUtils;

/**
 * Similar to a LabelCell, but adds a tree twisty to expand / collapse
 * @since 3.0
 */
dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.TreeLabelCell", LabelCell, { //$NON-NLS-1$

	fParentLevelType: null,

	constructor: function(label, iconUrl, column, entry, viewer) {
		this.inherited(arguments, [label, iconUrl, column, entry, viewer]);
	},

	/**
	 * Only elements of the specified class will be counted as a tree level.
	 * This has an effect only when invoking before {@link TreeLabelCell#createGadget()}
	 * @param parentLevelType The parent element type which will be counted as tree level. set to null to count all levels
	 */
	setParentLevelType: function(parentLevelType) {
		this.fParentLevelType= parentLevelType;
	},

	doCreateCellContent: function(cellContainer) {
		dojo.place(this.registerChild(new TreeTwistie(this.getTreeLevel(this.fRowEntry), this.fRowEntry, this.fViewer)).createGadget(), cellContainer);
		this.inherited("doCreateCellContent", arguments, [cellContainer]); //$NON-NLS-1$
	},

	getTreeLevel: function(entry) {
		return entry.getModel().readModel(dojo.hitch(this, function(readAccessor) {
			var treeLevel= 0;
			var candidateParent= readAccessor.getParent(entry);
			while(!candidateParent.isRootEntry() && (this.fParentLevelType == null || EntryUtils.isType(candidateParent, this.fParentLevelType))){
				treeLevel++;
				candidateParent= readAccessor.getParent(candidateParent);
			}
			return treeLevel;
		}));
	}
});

})();
