/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.gridviewer.Utils"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$

(function() {
var Assert= com.ibm.jdojo.util.Assert;

/**
 * @since 3.0
 */
var Utils= dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.Utils", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" }
});

Utils.contains= function(box, x, y) {
	return x >= box.x && x <= (box.x + box.w) && y >= box.y && y <= (box.y + box.h);
};
Utils.find= function(gadgets, x, y, direction) {
	var low= 0;
	var high= gadgets.length - 1;
	var mid= 0;
	while(low <= high){
		mid= (low + high) >> 1;
		var gadget= gadgets[mid];
		var position= dojo.position(gadget.getGadgetNode());
		if (Utils.contains(position, x, y)) {
			return gadget.findGadget(x, y);
		} else if (direction.isLow(position, x, y)) {
			high= mid - 1;
		} else {
			low= mid + 1;
		}
	}
	return null;
};
var Direction= dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.Utils.Direction", null, { //$NON-NLS-1$

	isLow: function(coordinates, x, y) {
		Assert.isTrue(false, "Abstract method 'isLow' invoked");
	},

	compareTo: function(other) {
		return this.ordinal - other.ordinal;
	}
});

Direction.values= [
	dojo.mixin(new Direction(), {
		name: 'Horizontal',
		ordinal: 0,
		isLow: function(coordinates, x, y) {
			return x < coordinates.x;
		}
	}),
	dojo.mixin(new Direction(), {
		name: 'Vertical',
		ordinal: 1,
		isLow: function(coordinates, x, y) {
			return y < coordinates.y;
		}
	})
];
Direction.Horizontal= Direction.values[0];
Direction.Vertical= Direction.values[1];

})();
