/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.gridviewer.ViewEntryGadget"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Exception"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.lang.JavaScriptException"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.lang.RuntimeException"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.ColumnTag"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.IEntryColumn"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.ErrorCellGadget"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.GridGadget"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.HeaderGadget"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.Utils"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.model.EntryUtils"); //$NON-NLS-1$
dojo.require("dojo.string"); //$NON-NLS-1$

(function() {
var Exception= com.ibm.jdojo.lang.Exception;
var JavaScriptException= com.ibm.jdojo.lang.JavaScriptException;
var jdojo= com.ibm.jdojo.lang.Runtime;
var RuntimeException= com.ibm.jdojo.lang.RuntimeException;
var Assert= com.ibm.jdojo.util.Assert;
var ColumnTag= com.ibm.team.rtc.foundation.api.ui.model.ColumnTag;
var IEntryColumn= com.ibm.team.rtc.foundation.api.ui.model.IEntryColumn;
var ErrorCellGadget= com.ibm.team.rtc.foundation.web.ui.gridviewer.ErrorCellGadget;
var GridGadget= com.ibm.team.rtc.foundation.web.ui.gridviewer.GridGadget;
var HeaderGadget= com.ibm.team.rtc.foundation.web.ui.gridviewer.HeaderGadget;
var Utils= com.ibm.team.rtc.foundation.web.ui.gridviewer.Utils;
var Direction= com.ibm.team.rtc.foundation.web.ui.gridviewer.Utils.Direction;
var EntryUtils= com.ibm.team.rtc.foundation.web.ui.model.EntryUtils;
var string= dojo.string;

/**
 * @since 3.0
 */
var ViewEntryGadget= dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.ViewEntryGadget", GridGadget, { //$NON-NLS-1$

	fViewEntry: null,

	fDisplayClasses: null,

	fThisColumn: null,

	fPropertyColumns: null,

	fCells: null,

	fContentElement: null,

	fContentRow: null,

	fIsVirtual: null,

	fContentHeight: null,

	fHeaders: null,

	fHeaderGadgets: null,

	fHeaderElement: null,

	fChildrenElement: null,

	fChildEntryGadgets: null,

	fEntryColumnContainers: null,

	fConnectionElement: null,

	fConnectionGadgets: null,

	fGadgetFactory: null,

	fConnectionFactory: null,

	constructor: function(viewEntry, column, readAccessor, gadgetFactory, viewer) {
		this.inherited(arguments, [viewer]);
		this.fCells= [];
		this.fContentHeight= -1;
		this.fHeaderGadgets= [];
		this.fChildEntryGadgets= [];
		this.fConnectionGadgets= [];
		this.fViewEntry= viewEntry;
		this.fThisColumn= column;
		this.fIsVirtual= this.fViewer.fVirtualTableContext != null;
		var propertyColumns= null;
		var headers= null;
		var columnTags= viewEntry.getTags(ColumnTag);
		if (columnTags.length > 0) {
			var propertyColumnList= columnTags[0].getPropertyColumns();
			if (propertyColumnList != null) {
				propertyColumns= propertyColumnList.getColumns(readAccessor);
			}
			headers= columnTags[0].getHeaders();
		}
		this.fPropertyColumns= propertyColumns;
		this.fHeaders= headers;
		this.fGadgetFactory= gadgetFactory;
		this.fConnectionFactory= jdojo.implementsInterface(gadgetFactory, "com.ibm.team.rtc.foundation.web.ui.gridviewer.IConnectionGadgetFactory") ? gadgetFactory : null;
	},

	getViewEntry: function() {
		return this.fViewEntry;
	},

	getIdentifier: function() {
		return this.fViewEntry.getIdentifier();
	},

	setDisplayClasses: function(classes) {
		this.fDisplayClasses= classes;
		if (this.fContentElement != null) {
			dojo.addClass(this.fContentElement, classes);
		}
	},

	doBeginEdit: function() {
	},

	createDragVisuals: function() {
		if (this.fContentElement != null) {
			return this.fContentElement.cloneNode(true);
		}
		return null;
	},

	getContentBounds: function(column) {
		try {
			if (column != null) {
				var cell= this.getCell(column);
				return cell != null ? dojo.position(cell.getGadgetNode(), false) : null;
			}
			return this.fContentElement != null ? dojo.position(this.fContentElement, false) : null;
		} catch (e) {
			if ((e= e instanceof Exception ? e : new JavaScriptException(e)) instanceof Exception) {
				return null;
			} else {
				throw e;
			}
		}
	},

	getCell: function(column) {
		if (column != null) {
			var $subject= this.fCells;
			var $length= $subject.length;
			for (var $count= 0; $count < $length; $count++){
				var cell= $subject[$count];
				if (cell.fColumn.getIdentifier() === column.getIdentifier()) 
					return cell;
			}
		}
		return null;
	},

	getCellById: function(columnId) {
		var $subject2= this.fCells;
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var cell= $subject2[$count2];
			if (cell.fColumn.getId() === columnId) 
				return cell;
		}
		return null;
	},

	isExpanded: function() {
		return dojo.hasClass(this.fGadgetNode, ViewEntryGadget.EXPANDED);
	},

	setExpansionState: function(setExpanded) {
		var hasVisibleChildren= this.hasVisibleChildren();
		if (this.isExpanded() !== setExpanded && (!setExpanded || hasVisibleChildren) && !this.isAlwaysExpanded()) {
			this.fGadgetNode.className= this.toggleBooleanClass(this.fGadgetNode.className, ViewEntryGadget.ENTRY_EXPANSION_CLASSES, setExpanded);
			this.setExpansionRole(setExpanded, hasVisibleChildren);
			if (setExpanded && this.fChildrenElement == null) {
				this.getViewModel().readModel(dojo.hitch(this, function(readAccessor) {
					this.doCreateChildren(this.getVisibleChildren(readAccessor), null, readAccessor);
					return null;
				}));
			}
		}
	},

	isSelected: function() {
		return dojo.hasClass(this.fGadgetNode, ViewEntryGadget.SELECTED);
	},

	setSelectionState: function(setSelected) {
		if (this.isSelected() !== setSelected) {
			dojo.toggleClass(this.fGadgetNode, ViewEntryGadget.SELECTED, setSelected);
		}
	},

	addChild: function(viewEntry, readAccessor) {
		if (this.fChildEntryGadgets.length === 0) {
			this.fGadgetNode.className= this.toggleBooleanClass(this.toggleBooleanClass(this.fGadgetNode.className, ViewEntryGadget.ENTRY_CHILD_CLASSES, true), ViewEntryGadget.ENTRY_EXPANSION_CLASSES, this.isAlwaysExpanded());
			this.setExpansionRole(this.isAlwaysExpanded(), true);
		}
		if (this.fChildrenElement != null) {
			var siblingEntries= readAccessor.getEntryNavigator(true).siblingEntries(viewEntry);
			var insertionPoint= dojo.indexOf(siblingEntries, viewEntry);
			if (!(insertionPoint !== -1)) Assert.fail("insertionPoint !== -1", "com.ibm.team.rtc.foundation.web.ui.gridviewer.ViewEntryGadget:215");
			if (!(insertionPoint >= 0 && insertionPoint <= this.fChildEntryGadgets.length)) Assert.fail("insertionPoint >= 0 && insertionPoint <= this.fChildEntryGadgets.length", "com.ibm.team.rtc.foundation.web.ui.gridviewer.ViewEntryGadget:216");
			this.doCreateChild(viewEntry, insertionPoint, null, readAccessor);
		}
	},

	update: function(properties, readAccessor) {
		var columnSet= this.getColumnsToUpdate(properties, readAccessor);
		if (columnSet != null) {
			if (this.fContentElement != null) {
				var cellIndexOffset= this.fViewer.fVirtualTableContext != null ? 1 : 0;
				for (var i= 0; i < this.fCells.length; i++){
					var cellGadget= this.fCells[i];
					if (!(cellGadget.fColumn.getIdentifier() in columnSet)) {
						continue;
					}
					var column= cellGadget.fColumn;
					if (cellGadget.fGadgetNode != null) 
						cellGadget.destroy();
					cellGadget= null;
					try {
						cellGadget= this.fGadgetFactory.newCellGadget(column, this.fViewEntry);
					} catch (e) {
						if ((e= e instanceof Exception ? e : new JavaScriptException(e)) instanceof RuntimeException) {
							cellGadget= new ErrorCellGadget(e, column, this.fViewEntry, this.fViewer);
						} else {
							throw e;
						}
					}
					this.fCells.splice(i, 1, cellGadget);
					if (!this.fIsVirtual) {
						dojo.place(this.buildCellRendering(cellGadget), this.fContentRow, i + cellIndexOffset);
					}
				}
			}
		} else {
			this.doDisposeContent();
			this.doCreateContent();
		}
		this.updateLinks(columnSet);
		this.doDisposeHeader();
		this.doCreateHeader(readAccessor);
	},

	getColumnsToUpdate: function(properties, readAccessor) {
		return null;
	},

	addPropertyColumn: function(column, readAccessor) {
	},

	removePropertyColumn: function(column, readAccessor) {
	},

	removeChild: function(childGadget, readAccessor) {
		if (this.fChildEntryGadgets.length === 1) {
			this.fGadgetNode.className= this.toggleBooleanClass(this.toggleBooleanClass(this.fGadgetNode.className, ViewEntryGadget.ENTRY_CHILD_CLASSES, false), ViewEntryGadget.ENTRY_EXPANSION_CLASSES, this.isAlwaysExpanded());
			this.setExpansionRole(this.isAlwaysExpanded(), false);
		}
		if (this.fChildrenElement != null) {
			childGadget.destroy();
			var childIndex= dojo.indexOf(this.fChildEntryGadgets, childGadget);
			if (!(childIndex !== -1)) Assert.fail("childIndex !== -1", "com.ibm.team.rtc.foundation.web.ui.gridviewer.ViewEntryGadget:288");
			this.fChildEntryGadgets.splice(childIndex, 1);
		}
	},

	resort: function(readAccessor) {
		if (this.fChildrenElement != null) {
			this.fChildEntryGadgets.sort(dojo.hitch(this, function(left, right) {
				return left.getViewEntry().getOwnIndex() - right.getViewEntry().getOwnIndex();
			}));
			var currentNode= this.fChildrenElement.firstChild;
			var $subject3= this.fChildEntryGadgets;
			var $length3= $subject3.length;
			for (var $count3= 0; $count3 < $length3; $count3++){
				var childGadget= $subject3[$count3];
				if (childGadget.fGadgetNode !== currentNode) {
					this.fChildrenElement.removeChild(childGadget.fGadgetNode);
					this.fChildrenElement.insertBefore(childGadget.fGadgetNode, currentNode);
				} else {
					currentNode= currentNode.nextSibling;
				}
			}
		}
	},

	refresh: function(readAccessor) {
		this.doDisposeContent();
		this.doCreateContent();
		this.doDisposeHeader();
		this.doCreateHeader(readAccessor);
		if (this.fChildrenElement != null) {
			this.doDisposeChildren();
			this.doCreateChildren(this.getVisibleChildren(readAccessor), null, readAccessor);
		}
		this.fGadgetNode.className= this.toggleBooleanClass(this.toggleBooleanClass(this.fGadgetNode.className, ViewEntryGadget.ENTRY_CHILD_CLASSES, this.hasVisibleChildren()), ViewEntryGadget.ENTRY_EXPANSION_CLASSES, this.isAlwaysExpanded());
		this.setExpansionRole(this.isAlwaysExpanded(), this.fChildEntryGadgets.length > 0);
	},

	addLink: function(link) {
		if (!(link.getSource() === this.fViewEntry)) Assert.fail("link.getSource() === this.fViewEntry", "com.ibm.team.rtc.foundation.web.ui.gridviewer.ViewEntryGadget:336");
		var targetGadget= this.fViewer.getViewEntryGadget(link.getTarget());
		if (targetGadget != null) {
			var $subject4= this.fConnectionGadgets;
			var $length4= $subject4.length;
			for (var $count4= 0; $count4 < $length4; $count4++){
				var connectionGadget= $subject4[$count4];
				if (connectionGadget.fLink === link) 
					return ;
			}
			if (this.fConnectionElement == null) {
				this.fConnectionElement= dojo.create("div", {className: "connections"}, this.fGadgetNode); //$NON-NLS-1$ //$NON-NLS-2$
			}
			var connectionGadget= this.fConnectionFactory.newConnectionGadget(this, targetGadget, link);
			dojo.place(connectionGadget.createGadget(), this.fConnectionElement);
			this.fConnectionGadgets.push(connectionGadget);
		}
	},

	updateLink: function(link) {
		if (!(link.getSource() === this.fViewEntry)) Assert.fail("link.getSource() === this.fViewEntry", "com.ibm.team.rtc.foundation.web.ui.gridviewer.ViewEntryGadget:354");
		var targetGadget= this.fViewer.getViewEntryGadget(link.getTarget());
		if (targetGadget != null) {
			var $subject5= this.fConnectionGadgets;
			var $length5= $subject5.length;
			for (var $count5= 0; $count5 < $length5; $count5++){
				var connectionGadget= $subject5[$count5];
				if (connectionGadget.fLink === link) {
					connectionGadget.update();
				}
			}
		}
	},

	updateLinks: function(updateColumn) {
		var links= this.fViewer.getLinks(this.fViewEntry);
		if (links != null) {
			var $subject6= links;
			var $length6= $subject6.length;
			for (var $count6= 0; $count6 < $length6; $count6++){
				var link= $subject6[$count6];
				if (updateColumn != null && !(link.getColumn().getIdentifier() in updateColumn)) 
					continue;
				if (link.getSource() === this.fViewEntry) {
					this.updateLink(link);
				} else {
					var sourceGadget= this.fViewer.getViewEntryGadget(link.getSource());
					if (sourceGadget != null) {
						sourceGadget.updateLink(link);
					}
				}
			}
		}
	},

	removeLink: function(link) {
		if (!(link.getSource() === this.fViewEntry)) Assert.fail("link.getSource() === this.fViewEntry", "com.ibm.team.rtc.foundation.web.ui.gridviewer.ViewEntryGadget:385");
		if (this.fConnectionElement != null) {
			for (var i= 0; i < this.fConnectionGadgets.length; i++){
				var candidate= this.fConnectionGadgets[i];
				if (candidate.fLink === link) {
					this.fConnectionGadgets.splice(i, 1);
					candidate.destroy();
				}
			}
		}
	},

	findGadget: function(x, y) {
		var pos= dojo.position(this.fGadgetNode);
		if (!Utils.contains(pos, x, y)) 
			return null;
		if (this.fContentElement != null) {
			pos= dojo.position(this.fContentElement);
			if (Utils.contains(pos, x, y)) {
				return Utils.find(this.fCells, x, y, Direction.Horizontal);
			}
		}
		if (this.fHeaderElement != null) {
			pos= dojo.position(this.fHeaderElement);
			if (Utils.contains(pos, x, y)) {
				return Utils.find(this.fHeaderGadgets, x, y, Direction.Vertical);
			}
		}
		if (this.fChildrenElement != null) {
			pos= dojo.position(this.fChildrenElement);
			if (Utils.contains(pos, x, y)) {
				return Utils.find(this.fChildEntryGadgets, x, y, dojo.hasClass(this.fChildrenElement, ViewEntryGadget.ENTRYCOLUMNROOT) ? Direction.Horizontal : Direction.Vertical);
			}
		}
		return null;
	},

	setVirtual: function(isVirtual) {
		if (this.fIsVirtual !== isVirtual) {
			this.fIsVirtual= isVirtual;
			if (this.fContentElement != null) {
				if (!isVirtual) {
					var $subject7= this.fCells;
					var $length7= $subject7.length;
					for (var $count7= 0; $count7 < $length7; $count7++){
						var cell= $subject7[$count7];
						dojo.place(this.buildCellRendering(cell), this.fContentRow);
						cell.setVirtual(isVirtual);
					}
				} else {
					var $subject8= this.fCells;
					var $length8= $subject8.length;
					for (var $count8= 0; $count8 < $length8; $count8++){
						var cell= $subject8[$count8];
						this.fContentRow.removeChild(cell.fGadgetNode);
						cell.setVirtual(isVirtual);
					}
				}
			}
		}
	},

	doDestroy: function() {
		this.doDisposeContent();
		this.doDisposeHeader();
		this.doDisposeChildren();
		this.doDisposeLinks();
	},

	doCreate: function() {
		var className= "entry"; //$NON-NLS-1$
		return dojo.create("div", {className: className}); //$NON-NLS-1$
	},

	buildEntry: function(toExpand, readAccessor) {
		var children= this.getVisibleChildren(readAccessor);
		var hasChildren= children.length !== 0;
		var isExpanded= (hasChildren && toExpand != null && (this.fViewEntry.getIdentifier() in toExpand)) || this.isAlwaysExpanded();
		var isSelected= this.fViewEntry.getModel().isSelected(this.fViewEntry);
		this.fGadgetNode.className= this.toggleBooleanClass(this.toggleBooleanClass(this.fGadgetNode.className, ViewEntryGadget.ENTRY_CHILD_CLASSES, hasChildren), ViewEntryGadget.ENTRY_EXPANSION_CLASSES, isExpanded);
		this.setExpansionRole(isExpanded, hasChildren);
		dojo.toggleClass(this.fGadgetNode, ViewEntryGadget.SELECTED, isSelected);
		this.doCreateContent();
		this.doCreateHeader(readAccessor);
		this.doCreateLinks();
		if (isExpanded) {
			this.doCreateChildren(children, toExpand, readAccessor);
		}
	},

	isAlwaysExpanded: function() {
		return false;
	},

	doCreateContent: function() {
		if (!(this.fContentElement == null)) Assert.fail("this.fContentElement == null", "com.ibm.team.rtc.foundation.web.ui.gridviewer.ViewEntryGadget:490");
		if (this.fPropertyColumns != null) {
			var contentClassNames= ""; //$NON-NLS-1$
			if (this.fDisplayClasses != null) {
				contentClassNames= " " + this.fDisplayClasses.join(" "); //$NON-NLS-1$ //$NON-NLS-2$
			}
			var style= {};
			if (this.fViewer.fVirtualTableContext != null) {
				this.fContentHeight= this.fViewer.fVirtualTableContext.getContentHeight("rowContent" + contentClassNames); //$NON-NLS-1$
				style.height= this.fContentHeight + "px"; //$NON-NLS-1$
			}
			this.fContentElement= dojo.create("table", {className: "contentTable " + this.fViewer.getColumnClassName(this.fThisColumn) + "_resize" + contentClassNames}, this.fGadgetNode, 'first'); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
			var body= dojo.create("tbody", null, this.fContentElement); //$NON-NLS-1$
			this.fContentRow= dojo.create("tr", {className: "rowContent" + contentClassNames, style: style}, body); //$NON-NLS-1$ //$NON-NLS-2$
			if (dojo.isIE < 8) {
				this.fContentElement.setAttribute("cellSpacing", "0"); //$NON-NLS-1$ //$NON-NLS-2$
				this.fContentElement.setAttribute("cellPadding", "0"); //$NON-NLS-1$ //$NON-NLS-2$
			}
			if (this.fViewer.fVirtualTableContext != null) {
				style.height= (this.fContentHeight - 1) + "px"; //$NON-NLS-1$
				dojo.create("td", {className: "virtualPlaceholder", style: style}, this.fContentRow); //$NON-NLS-1$ //$NON-NLS-2$
			}
			var $subject9= this.fPropertyColumns;
			var $length9= $subject9.length;
			for (var $count9= 0; $count9 < $length9; $count9++){
				var column= $subject9[$count9];
				var cellGadget= null;
				try {
					cellGadget= this.fGadgetFactory.newCellGadget(column, this.fViewEntry);
				} catch (e) {
					if ((e= e instanceof Exception ? e : new JavaScriptException(e)) instanceof RuntimeException) {
						cellGadget= new ErrorCellGadget(e, column, this.fViewEntry, this.fViewer);
					} else {
						throw e;
					}
				}
				this.fCells.push(cellGadget);
				if (!this.fIsVirtual) {
					dojo.place(this.buildCellRendering(cellGadget), this.fContentRow);
				}
			}
		}
		return this.fContentElement;
	},

	buildCellRendering: function(cellGadget) {
		var rendering= null;
		try {
			rendering= cellGadget.fGadgetNode;
			if (rendering == null) {
				rendering= cellGadget.createGadget();
			}
		} catch (e) {
			if ((e= e instanceof Exception ? e : new JavaScriptException(e)) instanceof RuntimeException) {
				var index= dojo.indexOf(this.fCells, cellGadget);
				if (!(index !== -1)) Assert.fail("index !== -1", "com.ibm.team.rtc.foundation.web.ui.gridviewer.ViewEntryGadget:548");
				cellGadget= new ErrorCellGadget(e, this.fPropertyColumns[index], this.fViewEntry, this.fViewer);
				this.fCells.splice(index, 1, cellGadget);
				rendering= cellGadget.createGadget();
			} else {
				throw e;
			}
		}
		return rendering;
	},

	setExpansionRole: function(isExpanded, hasChildren) {
		if (!hasChildren) {
			dijit.removeWaiState(this.fGadgetNode, ViewEntryGadget.WAI_STATE_EXPANDED);
		} else {
			dijit.setWaiState(this.fGadgetNode, ViewEntryGadget.WAI_STATE_EXPANDED, String(isExpanded));
		}
	},

	doCreateHeader: function(readAccessor) {
		if (!(this.fHeaderElement == null)) Assert.fail("this.fHeaderElement == null", "com.ibm.team.rtc.foundation.web.ui.gridviewer.ViewEntryGadget:566");
		if (this.fHeaders != null) {
			this.fHeaderElement= dojo.create("div", {className: "header"}); //$NON-NLS-1$ //$NON-NLS-2$
			dojo.place(this.fHeaderElement, this.fGadgetNode, this.fContentElement != null ? 1 : 0);
			var $subject10= this.fHeaders;
			var $length10= $subject10.length;
			for (var $count10= 0; $count10 < $length10; $count10++){
				var header= $subject10[$count10];
				var headerGadget= new HeaderGadget(header, this.fThisColumn, readAccessor, this.fGadgetFactory, this.fViewer);
				dojo.place(headerGadget.createGadget(), this.fHeaderElement);
				this.fHeaderGadgets.push(headerGadget);
			}
		}
		return this.fContentElement;
	},

	getHeaderHeight: function() {
		var result= 0;
		var $subject11= this.fHeaderGadgets;
		var $length11= $subject11.length;
		for (var $count11= 0; $count11 < $length11; $count11++){
			var header= $subject11[$count11];
			result+= header.fHeight;
		}
		return result;
	},

	doCreateChildren: function(children, toExpand, readAccessor) {
		if (!(this.fChildrenElement == null)) Assert.fail("this.fChildrenElement == null", "com.ibm.team.rtc.foundation.web.ui.gridviewer.ViewEntryGadget:590");
		this.fChildrenElement= dojo.create("div", {className: "entryChildren"}, this.fGadgetNode, 'last'); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		var isEntryColumnRoot= false;
		var $subject12= children;
		var $length12= $subject12.length;
		for (var $count12= 0; $count12 < $length12; $count12++){
			var child= $subject12[$count12];
			isEntryColumnRoot|= EntryUtils.isType(child, IEntryColumn);
			this.doCreateChild(child, -1, toExpand, readAccessor);
		}
		dojo.toggleClass(this.fChildrenElement, ViewEntryGadget.ENTRYCOLUMNROOT, isEntryColumnRoot);
	},

	doCreateChild: function(child, insertIndex, toExpand, readAccessor) {
		var childGadget= this.doCreateChildGadget(child, readAccessor);
		if (EntryUtils.isType(child, IEntryColumn)) {
			if (this.fEntryColumnContainers == null) {
				this.fEntryColumnContainers= {};
			}
			var columnList= child.getElement().getColumnList();
			var containerRow= this.fEntryColumnContainers[columnList.getIdentifier()];
			if (containerRow == null) {
				var table= dojo.create("table", {className: "entryColumnTable " + this.fViewer.getColumnClassName(this.fThisColumn) + "_resize"}, this.fChildrenElement); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
				var tableBody= dojo.create("tbody", null, table); //$NON-NLS-1$
				containerRow= dojo.create("tr", {className: "columnContainerRow"}, tableBody); //$NON-NLS-1$ //$NON-NLS-2$
				if (this.fViewer.fVirtualTableContext != null) {
					dojo.create("td", {className: "virtualPlaceholder"}, containerRow); //$NON-NLS-1$ //$NON-NLS-2$
				}
				this.fEntryColumnContainers[columnList.getIdentifier()]= containerRow;
			}
			var gadgetElement= childGadget.createGadget();
			containerRow.appendChild(gadgetElement);
			if (insertIndex !== -1) {
				this.fChildEntryGadgets.splice(insertIndex, 0, childGadget);
			} else {
				this.fChildEntryGadgets.push(childGadget);
			}
		} else {
			if (insertIndex !== -1) {
				dojo.place(childGadget.createGadget(), this.fChildrenElement, insertIndex);
				this.fChildEntryGadgets.splice(insertIndex, 0, childGadget);
			} else {
				dojo.place(childGadget.createGadget(), this.fChildrenElement);
				this.fChildEntryGadgets.push(childGadget);
			}
		}
		childGadget.buildEntry(toExpand, readAccessor);
	},

	doCreateChildGadget: function(child, readAccessor) {
		return this.fGadgetFactory.newEntryGadget(child, this.fThisColumn, readAccessor);
	},

	doCreateLinks: function() {
		if (!(this.fConnectionElement == null)) Assert.fail("this.fConnectionElement == null", "com.ibm.team.rtc.foundation.web.ui.gridviewer.ViewEntryGadget:650");
		var links= this.fViewer.getLinks(this.fViewEntry);
		if (links != null) {
			var $subject13= links;
			var $length13= $subject13.length;
			for (var $count13= 0; $count13 < $length13; $count13++){
				var link= $subject13[$count13];
				if (link.getSource() === this.fViewEntry) {
					this.addLink(link);
				} else {
					var sourceGadget= this.fViewer.getViewEntryGadget(link.getSource());
					if (sourceGadget != null) {
						sourceGadget.addLink(link);
					}
				}
			}
		}
	},

	doDisposeContent: function() {
		if (this.fContentElement != null) {
			var $subject14= this.fCells;
			var $length14= $subject14.length;
			for (var $count14= 0; $count14 < $length14; $count14++){
				var cell= $subject14[$count14];
				if (cell.fGadgetNode != null) 
					cell.destroy();
			}
			this.fCells= [];
			try {
				this.fGadgetNode.removeChild(this.fContentElement);
			} catch (e) {
				if ((e= e instanceof Exception ? e : new JavaScriptException(e)) instanceof Exception) {
				} else {
					throw e;
				}
			}
			this.fContentElement= null;
		}
	},

	doDisposeHeader: function() {
		if (this.fHeaderElement != null) {
			var $subject15= this.fHeaderGadgets;
			var $length15= $subject15.length;
			for (var $count15= 0; $count15 < $length15; $count15++){
				var header= $subject15[$count15];
				header.destroy();
			}
			this.fHeaderGadgets= [];
			try {
				this.fGadgetNode.removeChild(this.fHeaderElement);
			} catch (e) {
				if ((e= e instanceof Exception ? e : new JavaScriptException(e)) instanceof Exception) {
				} else {
					throw e;
				}
			}
			this.fHeaderElement= null;
		}
	},

	doDisposeChildren: function() {
		if (this.fChildrenElement != null) {
			var $subject16= this.fChildEntryGadgets;
			var $length16= $subject16.length;
			for (var $count16= 0; $count16 < $length16; $count16++){
				var child= $subject16[$count16];
				child.destroy();
			}
			this.fChildEntryGadgets= [];
			try {
				this.fGadgetNode.removeChild(this.fChildrenElement);
			} catch (e) {
				if ((e= e instanceof Exception ? e : new JavaScriptException(e)) instanceof Exception) {
				} else {
					throw e;
				}
			}
			this.fChildrenElement= null;
		}
	},

	doDisposeLinks: function() {
		if (this.fConnectionElement != null) {
			var $subject17= this.fConnectionGadgets;
			var $length17= $subject17.length;
			for (var $count17= 0; $count17 < $length17; $count17++){
				var connection= $subject17[$count17];
				connection.destroy();
			}
			this.fConnectionGadgets= [];
			try {
				this.fGadgetNode.removeChild(this.fConnectionElement);
			} catch (e) {
				if ((e= e instanceof Exception ? e : new JavaScriptException(e)) instanceof Exception) {
				} else {
					throw e;
				}
			}
			this.fConnectionElement= null;
		}
	},

	toggleBooleanClass: function(classNames, booleanClassNames, doSet) {
		var result= " " + classNames + " "; //$NON-NLS-1$ //$NON-NLS-2$
		var toAddIndex= doSet ? 1 : 0;
		var toAdd= " " + booleanClassNames[toAddIndex] + " "; //$NON-NLS-1$ //$NON-NLS-2$
		var toRemove= " " + booleanClassNames[1 - toAddIndex] + " "; //$NON-NLS-1$ //$NON-NLS-2$
		if (result.indexOf(toAdd) < 0) 
			result+= toAdd;
		result= result.replace(toRemove, " "); //$NON-NLS-1$
		return string.trim(result);
	},

	hasVisibleChildren: function() {
		return this.getViewModel().readModel(dojo.hitch(this, function(readAccessor) {
			return this.getVisibleChildren(readAccessor).length > 0;
		}));
	},

	getVisibleChildren: function(readAccessor) {
		var children= [];
		var $subject18= readAccessor.getChildren(this.fViewEntry);
		var $length18= $subject18.length;
		for (var $count18= 0; $count18 < $length18; $count18++){
			var childEntry= $subject18[$count18];
			if (childEntry.isVisible()) {
				children.push(childEntry);
			}
		}
		return children;
	},

	$interfaces: {
		'com.ibm.jdojo.util.IMappable': true //$NON-NLS-1$
	}
});

ViewEntryGadget.EXPANDED= "expanded"; //$NON-NLS-1$
ViewEntryGadget.COLLAPSED= "collapsed"; //$NON-NLS-1$
ViewEntryGadget.CHILDREN= "children"; //$NON-NLS-1$
ViewEntryGadget.NOCHILDREN= "nochildren"; //$NON-NLS-1$
ViewEntryGadget.SELECTED= "selected"; //$NON-NLS-1$
ViewEntryGadget.ENTRYCOLUMNROOT= "entryColumnRoot"; //$NON-NLS-1$
ViewEntryGadget.WAI_STATE_EXPANDED= "expanded"; //$NON-NLS-1$
ViewEntryGadget.ENTRY_CHILD_CLASSES= [ViewEntryGadget.NOCHILDREN, ViewEntryGadget.CHILDREN];
ViewEntryGadget.ENTRY_EXPANSION_CLASSES= [ViewEntryGadget.COLLAPSED, ViewEntryGadget.EXPANDED];

})();
