/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.gridviewer.VirtualTableContext"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;

/**
 * @since 3.0
 */
var VirtualTableContext= dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.VirtualTableContext", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fClassHeightCache: null,

	fOutlineCache: null,

	fEntryCache: null,

	fMaterializedGadgets: null,

	fGridViewer: null,

	fStyle: null,

	fTop: null,

	fBottom: null,

	fIsVirtualizable: null,

	constructor: function(gridViewer, style) {
		this.fClassHeightCache= {};
		this.fMaterializedGadgets= {};
		this.fGridViewer= gridViewer;
		this.fStyle= style;
	},

	viewportChanged: function(top, bottom) {
		if (top !== this.fTop || bottom !== this.fBottom) {
			this.fTop= top;
			this.fBottom= bottom;
			this.updateVirtualizationState();
		}
	},

	entryChanged: function() {
		this.fOutlineCache= null;
	},

	updateVirtualizationState: function() {
		if (this.fGridViewer.fRoot != null) {
			if (this.fOutlineCache == null) {
				this.buildOutlineHeightCache();
			}
			var toVirtualize= this.fMaterializedGadgets;
			this.fMaterializedGadgets= {};
			if (this.fIsVirtualizable) {
				var topElement= this.findOutlineElement(this.fTop);
				for (var i= topElement; i < this.fOutlineCache.length; i++){
					var cacheEntry= this.fOutlineCache[i];
					if (cacheEntry.top < this.fBottom && cacheEntry.bottom > this.fTop) {
						cacheEntry.gadget.setVirtual(false);
						this.fMaterializedGadgets[cacheEntry.gadget.getIdentifier()]= cacheEntry.gadget;
						delete toVirtualize[cacheEntry.gadget.getIdentifier()];
					} else {
						break;
					}
				}
				var $subject= jdojo.getProperties(toVirtualize);
				var $length= $subject.length;
				for (var $count= 0; $count < $length; $count++){
					var key= $subject[$count];
					toVirtualize[key].setVirtual(true);
				}
			} else {
				for (var i= 0; i < this.fOutlineCache.length; i++){
					var cacheEntry= this.fOutlineCache[i];
					cacheEntry.gadget.setVirtual(false);
					this.fMaterializedGadgets[cacheEntry.gadget.getIdentifier()]= cacheEntry.gadget;
				}
			}
		}
	},

	getContentHeight: function(classNames) {
		var result= this.fClassHeightCache[classNames];
		if (result == null) {
			result= this.fStyle.getContentHeight(classNames);
			this.fClassHeightCache[classNames]= result;
		}
		return result;
	},

	getEntryTopPosition: function(gadget) {
		if (this.fEntryCache == null) {
			this.buildOutlineHeightCache();
		}
		var cacheEntry= this.fEntryCache[gadget.getIdentifier()];
		return cacheEntry != null ? cacheEntry.top : -1;
	},

	ensureMaterialized: function(gadget) {
		if (!(gadget.getIdentifier() in this.fMaterializedGadgets)) {
			gadget.setVirtual(false);
			this.fMaterializedGadgets[gadget.getIdentifier()]= gadget;
		}
	},

	findOutlineElement: function(position) {
		var low= 0;
		var high= this.fOutlineCache.length - 1;
		while(low <= high){
			var mid= (low + high) >> 1;
			var value= this.fOutlineCache[mid];
			if (value.top <= position && value.bottom > position) {
				return mid;
			} else if (value.top > position) {
				high= mid - 1;
			} else {
				low= mid + 1;
			}
		}
		return low;
	},

	buildOutlineHeightCache: function() {
		this.fIsVirtualizable= !VirtualTableContext.fgIsIOsTouchDevice;
		this.fOutlineCache= [];
		this.fEntryCache= {};
		var queue= [];
		Array.prototype.push.apply(queue, this.fGridViewer.fRoot.fChildEntryGadgets);
		var top= this.fGridViewer.fRoot.getHeaderHeight();
		while(queue.length > 0){
			var gadget= queue.shift();
			if (gadget.fContentHeight < 0) {
				this.fIsVirtualizable= false;
			}
			var bottom= top + gadget.fContentHeight;
			if (gadget.isExpanded()) {
				bottom+= gadget.getHeaderHeight();
				Array.prototype.unshift.apply(queue, gadget.fChildEntryGadgets);
			}
			var cacheEntry= {top: top, bottom: bottom, gadget: gadget};
			this.fOutlineCache.push(cacheEntry);
			this.fEntryCache[gadget.getIdentifier()]= cacheEntry;
			top= bottom;
		}
	}
});

VirtualTableContext.fgIsIOsTouchDevice= navigator.userAgent.indexOf("iPad") !== -1 || navigator.userAgent.indexOf("iPhone") !== -1 || navigator.userAgent.indexOf("iPod") !== -1; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$

})();
