/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.RowDragGadget"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.GridGadget"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.AvatarGadget"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.ViewEntryDragData"); //$NON-NLS-1$

(function() {
var Assert= com.ibm.jdojo.util.Assert;
var GridGadget= com.ibm.team.rtc.foundation.web.ui.gridviewer.GridGadget;
var AvatarGadget= com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.AvatarGadget;
var ViewEntryDragData= com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.ViewEntryDragData;

dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.RowDragGadget", GridGadget, { //$NON-NLS-1$

	fRowEntry: null,

	constructor: function(rowEntry, viewer) {
		this.inherited(arguments, [viewer]);
		this.fRowEntry= rowEntry;
	},

	doCreate: function() {
		var result= dojo.create("div", {className: "dragContainer"}); //$NON-NLS-1$ //$NON-NLS-2$
		dojo.create("div", {className: "dragGrip"}, result); //$NON-NLS-1$ //$NON-NLS-2$
		return result;
	},

	createDragData: function() {
		var viewModel= this.getViewModel();
		if (!viewModel.isSelected(this.fRowEntry)) {
			viewModel.clearSelection();
			viewModel.setSelected(this.fRowEntry, true);
		}
		return new ViewEntryDragData(viewModel.getSelectedEntries());
	},

	notifyDragCompleted: function(dragData, dropResponse) {
	},

	notifyDragCancelled: function(dragData) {
	},

	createDragAvatar: function(dragData) {
		if (!(dragData instanceof ViewEntryDragData)) Assert.fail("dragData instanceof ViewEntryDragData", "com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.RowDragGadget:58");
		var avatarGadget= new DragAvatarGadget(this.fViewer);
		var viewEntries= dragData.getViewEntries();
		var $subject= viewEntries;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var viewEntry= $subject[$count];
			var entryGadget= this.fViewer.getViewEntryGadget(viewEntry);
			if (entryGadget != null) {
				var dragVisuals= entryGadget.createDragVisuals();
				if (dragVisuals != null) {
					avatarGadget.addVisuals(dragVisuals);
				}
			}
		}
		return avatarGadget;
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.IDragSource': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.IDragable': true //$NON-NLS-1$
	}
});
var DragAvatarGadget= dojo.declare("com.ibm.team.rtc.foundation.web.ui.gridviewer.dnd.RowDragGadget.DragAvatarGadget", AvatarGadget, { //$NON-NLS-1$

	fVisuals: null,

	constructor: function(viewer) {
		this.inherited(arguments, [viewer]);
		this.fVisuals= [];
	},

	addVisuals: function(dragVisuals) {
		this.fVisuals.push(dragVisuals);
	},

	doCreate: function() {
		var avatar= dojo.create("div", {className: "avatar"}); //$NON-NLS-1$ //$NON-NLS-2$
		var $subject2= this.fVisuals;
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var visual= $subject2[$count2];
			avatar.appendChild(visual);
		}
		return avatar;
	}
});

})();
