/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// declare the Dojo module
dojo.provide("com.ibm.team.calm.foundation.web.internal.calmdialogs.FrameResponder");

(function() {

var _OSLC1_PROTOCOL_WINDOWNAME = '#oslc-windowName-1.0';
var _OSLC1_PROTOCOL_POSTMSG = '#oslc-postMessage-1.0';
var _MESSAGE_PORT = "oslc-response:";
var _MESSAGE_RESIZE = "oslc-resize:";
var _PARAM_WIDTH = "oslc:hintWidth";
var _PARAM_HEIGHT = "oslc:hintHeight";

var _OSLC2_PROTOCOL_WINDOWNAME = '#oslc-core-windowName-1.0';
var _OSLC2_PROTOCOL_POSTMSG = '#oslc-core-postMessage-1.0';


dojo.declare("com.ibm.team.calm.foundation.web.internal.calmdialogs.FrameResponder", [ ], {

	constructor: function() {
		this._protocol = window.location.hash;
		if (!this.isSupportedOSLCProtocol())
			throw new Error('Unsupported frame communication protocol: ' + this._protocol);
		if (this.isWindowNameProtocol()) {
			this._returnURL = window.name;
			//TODO verify the return URL
		}
	},
	
	isSupportedOSLCProtocol : function () {
		return this.isWindowNameProtocol() || this.isPostMessageProtocol(); 
	},
	
	isWindowNameProtocol : function() {
		return this._protocol == _OSLC1_PROTOCOL_WINDOWNAME || this._protocol == _OSLC2_PROTOCOL_WINDOWNAME;
	},
	
	isPostMessageProtocol : function() {
		return this._protocol == _OSLC1_PROTOCOL_POSTMSG || this._protocol == _OSLC2_PROTOCOL_POSTMSG;
	},
	
	sendResponse: function(/*string*/ response) {
		if (typeof response != 'string')
			throw new Error('The response must be of type String');
		if (this.isWindowNameProtocol()) {
			window.name = response;
			window.location = this._returnURL;
		} else {
			(window.parent || window).postMessage(_MESSAGE_PORT + response, "*");
		}
	},
	
	sendResize: function(/* String */ width, /* String */ height) {
		if ((typeof width != 'string') || (typeof height != 'string'))
			throw new Error('width and height must be of type String');
		if (this.isPostMessageProtocol()) {
			var newSize= {};
			newSize[_PARAM_WIDTH]= width;
			newSize[_PARAM_HEIGHT]= height;
			(window.parent || window).postMessage(_MESSAGE_RESIZE + dojo.toJson(newSize, false), "*");
		}
	}
	
});

})();