/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.shared.common.internal.providers.HttpFilteredValueSetProvider");

dojo.require("com.ibm.team.workitem.api.common.connectors.HttpConnectorParameters");
dojo.require("dojo.string");

(function() {
var HttpConnectorParameters= com.ibm.team.workitem.api.common.connectors.HttpConnectorParameters;

var HttpFilteredValueSetProvider= dojo.declare("com.ibm.team.workitem.shared.common.internal.providers.HttpFilteredValueSetProvider", null, {
	"-chains-": { constructor: "manual" },

	getFilteredValueSet: function(attributeId, workItem, context, filter) {
		var conf= context.getChild(HttpFilteredValueSetProvider.HTTPPARAMS);
		var params= this.readParameters(conf);
		var connector= context.getDataConnector(HttpFilteredValueSetProvider.HTTP_CONNECTOR);
		var values= connector.get(params);
		var filterByLabel= this.readBoolean(conf, HttpFilteredValueSetProvider.FILTER_PARAM, false);
		var sortByLabel= this.readBoolean(conf, HttpFilteredValueSetProvider.SORT_PARAM, false);
		var regEx= filter != null && filter.length > 0 && filterByLabel ? new RegExp("^" + filter, "i") : null;
		var format= conf.getStringDefault(HttpFilteredValueSetProvider.FORMAT_PARAM, "");
		var result= [];
		while(values.hasNext()){
			var entry= values.next();
			var line= "";
			if (format.length === 0) {
				for (var i= 0; i < entry.size(); i++){
					line+= entry.getByPosition(i);
				}
			} else {
				var entries= new Array(entry.size());
				for (var i= 0; i < entry.size(); i++){
					entries[i]= entry.getByPosition(i);
				}
				line= dojo.string.substitute(format, entries);
			}
			if (regEx == null || regEx.test(line)) 
				result.push(line);
		}
		if (sortByLabel) {
			result.sort();
		}
		return result;
	},

	readParameters: function(conf) {
		var httpParams= new HttpConnectorParameters();
		httpParams.url= this.readString(conf, HttpFilteredValueSetProvider.URL_PARAM, null);
		httpParams.xpath= this.readString(conf, HttpFilteredValueSetProvider.XPATH_PARAM, null);
		httpParams.columnXpaths= this.readStringArray(conf, HttpFilteredValueSetProvider.COLUMNXPATHS_PARAM, HttpFilteredValueSetProvider.SEPARATOR);
		httpParams.columnIds= this.readStringArray(conf, HttpFilteredValueSetProvider.COLUMNIDS_PARAM, HttpFilteredValueSetProvider.SEPARATOR);
		httpParams.formBasedAuthenticationLoginURL= this.readString(conf, HttpFilteredValueSetProvider.FORMBASEDURL_PARAM, null);
		httpParams.formBasedAuthenticationUsernameInputName= this.readString(conf, HttpFilteredValueSetProvider.FORMBASEDUSER_PARAM, null);
		httpParams.formBasedAuthenticationPasswordInputName= this.readString(conf, HttpFilteredValueSetProvider.FORMBASEDPASS_PARAM, null);
		httpParams.credentialsId= this.readString(conf, HttpFilteredValueSetProvider.CREDENTIALSID_PARAM, null);
		httpParams.useBasicAuthentication= this.readBoolean(conf, HttpFilteredValueSetProvider.USEBASIC_PARAM, false);
		httpParams.userName= this.readString(conf, HttpFilteredValueSetProvider.USERNAME_PARAM, null);
		httpParams.password= this.readString(conf, HttpFilteredValueSetProvider.PASSWORD_PARAM, null);
		httpParams.ignoreInvalidCertificates= this.readBoolean(conf, HttpFilteredValueSetProvider.IGNORECERTIFICATES_PARAM, false);
		return httpParams;
	},

	readString: function(conf, key, defaultValue) {
		var val= conf.getStringDefault(key, "");
		if (val.length === 0) 
			return defaultValue;
		return val;
	},

	readBoolean: function(conf, key, defaultValue) {
		var val= conf.getStringDefault(key, String(defaultValue));
		return (val.toLowerCase() === "true");
	},

	readStringArray: function(conf, key, separator) {
		var val= conf.getStringDefault(key, "");
		if (val.length === 0) 
			return null;
		return val.split(separator);
	},

	$interfaces: {
		'com.ibm.team.workitem.api.common.providers.IFilteredValueSetProvider': true
	}
});

HttpFilteredValueSetProvider.HTTP_CONNECTOR= "HttpConnector";
HttpFilteredValueSetProvider.HTTPPARAMS= "httpparams";
HttpFilteredValueSetProvider.URL_PARAM= "url";
HttpFilteredValueSetProvider.XPATH_PARAM= "xpath";
HttpFilteredValueSetProvider.COLUMNXPATHS_PARAM= "columnxpath";
HttpFilteredValueSetProvider.COLUMNIDS_PARAM= "columnid";
HttpFilteredValueSetProvider.FORMBASEDURL_PARAM= "formbasedurl";
HttpFilteredValueSetProvider.FORMBASEDUSER_PARAM= "formbaseduser";
HttpFilteredValueSetProvider.FORMBASEDPASS_PARAM= "formbasedpass";
HttpFilteredValueSetProvider.CREDENTIALSID_PARAM= "credentialid";
HttpFilteredValueSetProvider.USEBASIC_PARAM= "usebasic";
HttpFilteredValueSetProvider.USERNAME_PARAM= "username";
HttpFilteredValueSetProvider.PASSWORD_PARAM= "password";
HttpFilteredValueSetProvider.IGNORECERTIFICATES_PARAM= "ignorecertificates";
HttpFilteredValueSetProvider.SEPARATOR= "|";
HttpFilteredValueSetProvider.FORMAT_PARAM= "format";
HttpFilteredValueSetProvider.FILTER_PARAM= "filterByLabel";
HttpFilteredValueSetProvider.SORT_PARAM= "sortByLabel";

})();
