/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.shared.common.internal.providers.NumberRangeValidator");

dojo.require("com.ibm.team.workitem.api.common.Severity");
dojo.require("com.ibm.team.workitem.api.common.Status");
dojo.require("com.ibm.team.workitem.shared.common.internal.providers.ValidatorConstants");

(function() {
var Severity= com.ibm.team.workitem.api.common.Severity;
var Status= com.ibm.team.workitem.api.common.Status;
var ValidatorConstants= com.ibm.team.workitem.shared.common.internal.providers.ValidatorConstants;

var NumberRangeValidator= dojo.declare("com.ibm.team.workitem.shared.common.internal.providers.NumberRangeValidator", null, {
	"-chains-": { constructor: "manual" },

	validate: function(attributeId, workItem, context) {
		var currentValue= workItem.getValue(attributeId);
		if (currentValue == null || currentValue.length === 0) 
			return Status.OK_STATUS;
		var range= context.getChild(NumberRangeValidator.RANGE);
		var severity= range.getStringDefault(ValidatorConstants.SEVERITY, Severity.ERROR.name);
		var message= range.getStringDefault(ValidatorConstants.MESSAGE, "");
		var min= range.getStringDefault(NumberRangeValidator.MIN, null);
		var max= range.getStringDefault(NumberRangeValidator.MAX, null);
		var numberValue= parseInt(currentValue, 10);
		if (isNaN(numberValue)) {
			return this.createStatus(severity, message);
		}
		if (min != null) {
			var minimum= parseInt(min, 10);
			if (numberValue < minimum) {
				return this.createStatus(severity, message);
			}
		}
		if (max != null) {
			var maximum= parseInt(max, 10);
			if (numberValue > maximum) {
				return this.createStatus(severity, message);
			}
		}
		return Status.OK_STATUS;
	},

	createStatus: function(severity, message) {
		return new Status(Severity[severity], message);
	},

	$interfaces: {
		'com.ibm.team.workitem.api.common.providers.IValidator': true
	}
});

NumberRangeValidator.RANGE= "range";
NumberRangeValidator.MIN= "min";
NumberRangeValidator.MAX= "max";

})();
