/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.shared.common.internal.providers.RegularExpressionValidator");

dojo.require("com.ibm.team.workitem.api.common.Severity");
dojo.require("com.ibm.team.workitem.api.common.Status");
dojo.require("com.ibm.team.workitem.shared.common.internal.providers.ValidatorConstants");

(function() {
var Severity= com.ibm.team.workitem.api.common.Severity;
var Status= com.ibm.team.workitem.api.common.Status;
var ValidatorConstants= com.ibm.team.workitem.shared.common.internal.providers.ValidatorConstants;

var RegularExpressionValidator= dojo.declare("com.ibm.team.workitem.shared.common.internal.providers.RegularExpressionValidator", null, {
	"-chains-": { constructor: "manual" },

	validate: function(attributeId, workItem, context) {
		var currentValue= workItem.getValue(attributeId);
		if (currentValue == null || currentValue.length === 0) 
			return Status.OK_STATUS;
		var regularExpression= context.getChild(RegularExpressionValidator.REG_EXP);
		var severity= regularExpression.getStringDefault(ValidatorConstants.SEVERITY, Severity.ERROR.name);
		var message= regularExpression.getStringDefault(ValidatorConstants.MESSAGE, "");
		var match= regularExpression.getStringDefault(RegularExpressionValidator.MATCH, "");
		var caseSensitive= regularExpression.getStringDefault(RegularExpressionValidator.CASE_SENSITIVE, "true");
		var multiLine= regularExpression.getStringDefault(RegularExpressionValidator.MULTI_LINE, "false");
		var regExp= new RegExp(match);
		regExp.ignoreCase= ("false" === caseSensitive);
		regExp.multiline= ("true" === multiLine);
		var matches= regExp.exec(currentValue);
		if (matches != null && (currentValue === matches[0])) {
			return Status.OK_STATUS;
		} else {
			return new Status(Severity[severity], message);
		}
	},

	$interfaces: {
		'com.ibm.team.workitem.api.common.providers.IValidator': true
	}
});

RegularExpressionValidator.REG_EXP= "regExp";
RegularExpressionValidator.MATCH= "match";
RegularExpressionValidator.CASE_SENSITIVE= "casesensitive";
RegularExpressionValidator.MULTI_LINE= "multiline";

})();
