/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.model.EntryColumn"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.model.Column"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.model.EntryColumnList"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.model.PropertyColumnList"); //$NON-NLS-1$

(function() {
var Assert= com.ibm.jdojo.util.Assert;
var Column= com.ibm.team.rtc.foundation.web.ui.model.Column;
var EntryColumnList= com.ibm.team.rtc.foundation.web.ui.model.EntryColumnList;
var PropertyColumnList= com.ibm.team.rtc.foundation.web.ui.model.PropertyColumnList;

/**
 * @since 3.0
 */
var EntryColumn= dojo.declare("com.ibm.team.rtc.foundation.web.ui.model.EntryColumn", Column, { //$NON-NLS-1$

	fPropertyColumnsLists: null,

	fEntryColumnsLists: null,

	fColumnDescriptor: null,

	constructor: function(id, columnDescriptor, label, iconUrl, columnList, viewModel) {
		this.inherited(arguments, [id, label, iconUrl, columnList, viewModel]);
		this.fPropertyColumnsLists= [];
		this.fEntryColumnsLists= [];
		this.fColumnDescriptor= columnDescriptor;
	},

	newInstance: function(id, columnDescriptor, label, iconUrl, columnList, viewModel) {
		return new EntryColumn(id, columnDescriptor, label, iconUrl, columnList, viewModel);
	},

	getColumnList: function() {
		return this.fContainer;
	},

	getPropertyColumnsLists: function(readAccessor) {
		this.fViewModel.checkAccess(readAccessor);
		return this.fPropertyColumnsLists;
	},

	getPropertyColumns: function(id, readAccessor) {
		this.fViewModel.checkAccess(readAccessor);
		var $subject= this.fPropertyColumnsLists;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var columnList= $subject[$count];
			if (columnList.getIdentifier() === id) {
				return columnList;
			}
		}
		return null;
	},

	getEntryColumnsLists: function(readAccessor) {
		this.fViewModel.checkAccess(readAccessor);
		return this.fEntryColumnsLists;
	},

	getEntryColumns: function(id, readAccessor) {
		this.fViewModel.checkAccess(readAccessor);
		var $subject2= this.fEntryColumnsLists;
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var columnList= $subject2[$count2];
			if (columnList.getIdentifier() === id) {
				return columnList;
			}
		}
		return null;
	},

	addPropertyColumnList: function(id, updateAccessor) {
		this.fViewModel.checkAccess(updateAccessor);
		if (!(this.getPropertyColumns(id, updateAccessor) == null)) Assert.fail("this.getPropertyColumns(id, updateAccessor) == null", "com.ibm.team.rtc.foundation.web.ui.model.EntryColumn:78");
		var result= new PropertyColumnList(id, this, this.fViewModel);
		this.fPropertyColumnsLists.push(result);
		return result;
	},

	addEntryColumnList: function(id, updateAccessor) {
		this.fViewModel.checkAccess(updateAccessor);
		if (!(this.getEntryColumns(id, updateAccessor) == null)) Assert.fail("this.getEntryColumns(id, updateAccessor) == null", "com.ibm.team.rtc.foundation.web.ui.model.EntryColumn:89");
		var result= new EntryColumnList(id, this, this, this.fViewModel);
		this.fEntryColumnsLists.push(result);
		return result;
	},

	getColumnDescriptor: function() {
		return this.fColumnDescriptor;
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.model.IEntryColumn': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.web.ui.model.EntryColumnList.IEntryColumnFactory': true //$NON-NLS-1$
	}
});

})();
