/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.model.EntryColumnList"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var Assert= com.ibm.jdojo.util.Assert;

/**
 * @since 3.0
 */
dojo.declare("com.ibm.team.rtc.foundation.web.ui.model.EntryColumnList", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fId: null,

	fViewModel: null,

	fEntryColumnFactory: null,

	fColumns: null,

	fPathId: null,

	constructor: function(id, container, entryColumnFactory, viewModel) {
		this.fColumns= [];
		this.fId= id;
		this.fEntryColumnFactory= entryColumnFactory;
		this.fViewModel= viewModel;
		this.fPathId= container.getIdentifier() + "/" + id; //$NON-NLS-1$
	},

	getId: function() {
		return this.fId;
	},

	getIdentifier: function() {
		return this.fPathId;
	},

	getColumns: function(readAccessor) {
		this.fViewModel.checkAccess(readAccessor);
		return this.fColumns;
	},

	getColumn: function(id, readAccessor) {
		this.fViewModel.checkAccess(readAccessor);
		var $subject= this.fColumns;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var column= $subject[$count];
			if (column.getId() === id) {
				return column;
			}
		}
		return null;
	},

	addColumn: function(id, label, iconUrl, columnDescriptor, updateAccessor) {
		this.fViewModel.checkAccess(updateAccessor);
		if (!(this.getColumn(id, updateAccessor) == null)) Assert.fail("this.getColumn(id, updateAccessor) == null", "com.ibm.team.rtc.foundation.web.ui.model.EntryColumnList:68");
		var result= this.fEntryColumnFactory.newInstance(id, columnDescriptor, label, iconUrl, this, this.fViewModel);
		this.fColumns.push(result);
		return result;
	},

	removeColumn: function(column, updateAccessor) {
		this.fViewModel.checkAccess(updateAccessor);
		var columnIndex= dojo.indexOf(this.fColumns, column);
		if (columnIndex !== -1) {
			this.fColumns.splice(columnIndex, 1);
		}
	},

	$interfaces: {
		'com.ibm.jdojo.util.IMappable': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.api.ui.model.IColumnList': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.api.ui.model.IEntryColumnList': true //$NON-NLS-1$
	}
});
jdojo.declareInterface("com.ibm.team.rtc.foundation.web.ui.model.EntryColumnList.IEntryColumnFactory");


})();
