/******************************************************************************
 Licensed Materials - Property of IBM
 (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 
 Note to U.S. Government Users Restricted Rights:
 Use, duplication or disclosure restricted by GSA ADP Schedule
 Contract with IBM Corp.
******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.model.EntryNavigator"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.tags.PrimaryLocationTag"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.model.EntryUtils"); //$NON-NLS-1$

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var Assert= com.ibm.jdojo.util.Assert;
var PrimaryLocationTag= com.ibm.team.rtc.foundation.api.ui.tags.PrimaryLocationTag;
var EntryUtils= com.ibm.team.rtc.foundation.web.ui.model.EntryUtils;

var EntryNavigator= dojo.declare("com.ibm.team.rtc.foundation.web.ui.model.EntryNavigator", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fReadAccessor: null,

	fEntryFilter: null,

	fChildrenCache: null,

	constructor: function(readAccessor, filter) {
		this.fReadAccessor= readAccessor;
		this.fEntryFilter= filter;
		this.fChildrenCache= {};
	},

	findPrimaryEntry: function(element) {
		return this.firstEntryWithTag(this.fReadAccessor.getElementEntries(element), PrimaryLocationTag.INSTANCE);
	},

	findFirstEntryWithTag: function(element, tag) {
		return this.firstEntryWithTag(this.fReadAccessor.getElementEntries(element), tag);
	},

	findFirstEntryInSubtree: function(element, searchRoot) {
		var $subject= this.fReadAccessor.getElementEntries(element);
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var entry= $subject[$count];
			if (this.isIncluded(entry) && this.startsWith(entry, searchRoot)) {
				return entry;
			}
		}
		return null;
	},

	parentElement: function(entry) {
		return EntryUtils.element(this.parentEntry(entry));
	},

	childern: function(entry) {
		return EntryNavigator.doGetElements(this.childEntries(entry));
	},

	siblings: function(entry) {
		return EntryNavigator.doGetElements(this.siblingEntries(entry));
	},

	firstSibling: function(entry) {
		return EntryUtils.element(this.firstSiblingEntry(entry));
	},

	lastSibling: function(entry) {
		return EntryUtils.element(this.lastSiblingEntry(entry));
	},

	predecessor: function(entry) {
		return EntryUtils.element(this.predecessorEntry(entry));
	},

	successor: function(entry) {
		return EntryUtils.element(this.successorEntry(entry));
	},

	parentEntry: function(entry) {
		return this.fReadAccessor.getParent(entry);
	},

	parentEntryOfType: function(entry, typeClass) {
		while(entry != null){
			if (jdojo.isInstance(entry.getElement(), typeClass)) 
				return entry;
			entry= this.fReadAccessor.getParent(entry);
		}
		return null;
	},

	childEntries: function(entry) {
		var result= this.fChildrenCache[entry.getIdentifier()];
		if (result == null) {
			result= this.filterInvisible(this.fReadAccessor.getChildren(entry));
			this.fChildrenCache[entry.getIdentifier()]= result;
		}
		return result;
	},

	siblingEntries: function(entry) {
		var parent= this.fReadAccessor.getParent(entry);
		return parent != null ? this.childEntries(parent) : null;
	},

	firstSiblingEntry: function(entry) {
		var siblings= this.siblingEntries(entry);
		return siblings != null ? siblings[0] : null;
	},

	lastSiblingEntry: function(entry) {
		var siblings= this.siblingEntries(entry);
		return siblings != null ? siblings[siblings.length - 1] : null;
	},

	predecessorEntry: function(entry) {
		var siblings= this.siblingEntries(entry);
		if (siblings != null && !(siblings.length == 0)) {
			var index= dojo.indexOf(siblings, entry);
			if (!(index !== -1)) Assert.fail("index !== -1", "com.ibm.team.rtc.foundation.web.ui.model.EntryNavigator:131");
			if (index > 0) 
				return siblings[index - 1];
		}
		return null;
	},

	successorEntry: function(entry) {
		var siblings= this.siblingEntries(entry);
		if (siblings != null && !(siblings.length == 0)) {
			var index= dojo.indexOf(siblings, entry);
			if (!(index !== -1)) Assert.fail("index !== -1", "com.ibm.team.rtc.foundation.web.ui.model.EntryNavigator:142");
			if (index < siblings.length - 1) 
				return siblings[index + 1];
		}
		return null;
	},

	index: function(entry) {
		return entry != null ? dojo.indexOf(this.siblingEntries(entry), entry) : -1;
	},

	startsWith: function(entry, prefix) {
		while(entry != null){
			if (entry === prefix) {
				return true;
			}
			entry= this.fReadAccessor.getParent(entry);
		}
		return false;
	},

	isFirst: function(entry) {
		return entry === this.firstSiblingEntry(entry);
	},

	isLast: function(entry) {
		return entry === this.lastSiblingEntry(entry);
	},

	indexOf: function(entry, elementClass) {
		for (var result= 0; entry != null; result++){
			if (jdojo.isInstance(entry.getElement(), elementClass)) {
				return result;
			}
			entry= this.fReadAccessor.getParent(entry);
		}
		return -1;
	},

	isIncluded: function(entry) {
		return this.fEntryFilter == null || this.fEntryFilter(entry);
	},

	filterInvisible: function(entries) {
		if (this.fEntryFilter == null) 
			return entries;
		var result= [];
		var $subject2= entries;
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var entry= $subject2[$count2];
			if (this.isIncluded(entry)) 
				result.push(entry);
		}
		return result;
	},

	firstEntryWithTag: function(entries, tag) {
		var $subject4= entries;
		var $length4= $subject4.length;
		for (var $count4= 0; $count4 < $length4; $count4++){
			var entry= $subject4[$count4];
			if (this.isIncluded(entry) && entry.hasTag(tag)) 
				return entry;
		}
		return null;
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.model.IViewModelNavigator': true //$NON-NLS-1$
	}
});

EntryNavigator.doGetElements= function(entries) {
	var result= [];
	var $subject3= entries;
	var $length3= $subject3.length;
	for (var $count3= 0; $count3 < $length3; $count3++){
		var entry= $subject3[$count3];
		result.push(entry.getElement());
	}
	return result;
};

})();
