/******************************************************************************
 Licensed Materials - Property of IBM
 (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 
 Note to U.S. Government Users Restricted Rights:
 Use, duplication or disclosure restricted by GSA ADP Schedule
 Contract with IBM Corp.
******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.model.EntryState"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.model.ViewerUpdater"); //$NON-NLS-1$

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var Assert= com.ibm.jdojo.util.Assert;
var ViewerUpdater= com.ibm.team.rtc.foundation.web.ui.model.ViewerUpdater;

var EntryState= dojo.declare("com.ibm.team.rtc.foundation.web.ui.model.EntryState", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fIsVisible: null,

	constructor: function(visible) {
		this.fIsVisible= visible;
	},

	isVisible: function() {
		return this.fIsVisible;
	},

	show: function() {
		Assert.isTrue(false, "Abstract method 'show' invoked");
	},

	hide: function() {
		Assert.isTrue(false, "Abstract method 'hide' invoked");
	},

	update: function(properties) {
		Assert.isTrue(false, "Abstract method 'update' invoked");
	},

	resort: function() {
		Assert.isTrue(false, "Abstract method 'resort' invoked");
	},

	refresh: function() {
		Assert.isTrue(false, "Abstract method 'refresh' invoked");
	},

	remove: function() {
		Assert.isTrue(false, "Abstract method 'remove' invoked");
	},

	hasUpdates: function() {
		Assert.isTrue(false, "Abstract method 'hasUpdates' invoked");
	},

	isAdd: function() {
		return false;
	},

	isRemove: function() {
		return false;
	},

	collectUpdates: function(viewer, entry, viewerUpdates) {
		Assert.isTrue(false, "Abstract method 'collectUpdates' invoked");
	},

	getUpdatedState: function() {
		Assert.isTrue(false, "Abstract method 'getUpdatedState' invoked");
	},

	includesChildUpdates: function(entry) {
		Assert.isTrue(false, "Abstract method 'includesChildUpdates' invoked");
	}
});

EntryState.fgInitial= null;
EntryState.INITIAL= function() {
	if (EntryState.fgInitial == null) {
		EntryState.fgInitial= new ShowTransition(new HiddenState());
	}
	return EntryState.fgInitial;
};
var AbstractState= dojo.declare("com.ibm.team.rtc.foundation.web.ui.model.EntryState.AbstractState", EntryState, { //$NON-NLS-1$

	constructor: function(visible) {
		this.inherited(arguments, [visible]);
	},

	show: function() {
		return new ShowTransition(this);
	},

	hide: function() {
		return new HideTransition(this);
	},

	update: function(properties) {
		return new UpdateTransition(this, properties);
	},

	resort: function() {
		return new ResortTransition(this);
	},

	refresh: function() {
		return new RefreshTransition(this);
	},

	remove: function() {
		return new RemoveTransition(this);
	},

	hasUpdates: function() {
		return false;
	},

	collectUpdates: function(viewer, entry, viewerUpdates) {
	},

	getUpdatedState: function() {
		return this;
	},

	includesChildUpdates: function(entry) {
		return false;
	}
});
var ShownState= dojo.declare("com.ibm.team.rtc.foundation.web.ui.model.EntryState.ShownState", AbstractState, { //$NON-NLS-1$

	constructor: function() {
		this.inherited(arguments, [true]);
	},

	show: function() {
		return this;
	}
});

ShownState.INSTANCE= new ShownState();
var HiddenState= dojo.declare("com.ibm.team.rtc.foundation.web.ui.model.EntryState.HiddenState", AbstractState, { //$NON-NLS-1$

	constructor: function() {
		this.inherited(arguments, [false]);
	},

	hide: function() {
		return this;
	},

	update: function(properties) {
		return this;
	},

	resort: function() {
		return this;
	},

	refresh: function() {
		return this;
	}
});

HiddenState.INSTANCE= new HiddenState();
var AbstractStateTransition= dojo.declare("com.ibm.team.rtc.foundation.web.ui.model.EntryState.AbstractStateTransition", EntryState, { //$NON-NLS-1$

	fRootState: null,

	constructor: function(rootState, visible) {
		this.inherited(arguments, [visible]);
		this.fRootState= rootState;
	},

	show: function() {
		return this.isVisible() ? this : this.fRootState.show();
	},

	hide: function() {
		return !this.isVisible() ? this : this.fRootState.hide();
	},

	update: function(properties) {
		return !this.isVisible() ? this : this.fRootState.update(properties);
	},

	resort: function() {
		return !this.isVisible() ? this : this.fRootState.resort();
	},

	refresh: function() {
		return !this.isVisible() ? this : this.fRootState.refresh();
	},

	remove: function() {
		return this.fRootState.remove();
	},

	hasUpdates: function() {
		return true;
	}
});
var ShowTransition= dojo.declare("com.ibm.team.rtc.foundation.web.ui.model.EntryState.ShowTransition", AbstractStateTransition, { //$NON-NLS-1$

	constructor: function(rootState) {
		this.inherited(arguments, [rootState, true]);
	},

	update: function(properties) {
		return this;
	},

	resort: function() {
		return this;
	},

	refresh: function() {
		return this;
	},

	collectUpdates: function(viewer, entry, viewerUpdates) {
		if (entry.isRootEntry()) {
			if (!(this === EntryState.INITIAL())) Assert.fail("this === EntryState.INITIAL()", "com.ibm.team.rtc.foundation.web.ui.model.EntryState:240");
			viewerUpdates.push(ViewerUpdater.getRefreshEntryRunnable(viewer, entry));
		} else {
			viewerUpdates.push(ViewerUpdater.getAddEntryRunnable(viewer, entry));
		}
	},

	getUpdatedState: function() {
		return ShownState.INSTANCE;
	},

	includesChildUpdates: function(entry) {
		return true;
	},

	isAdd: function() {
		return true;
	}
});
var HideTransition= dojo.declare("com.ibm.team.rtc.foundation.web.ui.model.EntryState.HideTransition", AbstractStateTransition, { //$NON-NLS-1$

	constructor: function(rootState) {
		this.inherited(arguments, [rootState, false]);
	},

	collectUpdates: function(viewer, entry, viewerUpdates) {
		viewerUpdates.push(ViewerUpdater.getRemoveEntryRunnable(viewer, entry, true));
	},

	getUpdatedState: function() {
		return HiddenState.INSTANCE;
	},

	includesChildUpdates: function(entry) {
		return true;
	},

	isRemove: function() {
		return true;
	}
});
var UpdateTransition= dojo.declare("com.ibm.team.rtc.foundation.web.ui.model.EntryState.UpdateTransition", AbstractStateTransition, { //$NON-NLS-1$

	fProperties: null,

	constructor: function(rootState, properties) {
		this.inherited(arguments, [rootState, true]);
		this.fProperties= properties;
	},

	update: function(properties) {
		if (properties == null || this.fProperties == null) {
			return this.inherited("update", arguments, [null]); //$NON-NLS-1$
		} else {
			var mergedProperties= {};
			var $subject= properties;
			var $length= $subject.length;
			for (var $count= 0; $count < $length; $count++){
				var property= $subject[$count];
				mergedProperties[property]= true;
			}
			var $subject2= this.fProperties;
			var $length2= $subject2.length;
			for (var $count2= 0; $count2 < $length2; $count2++){
				var property= $subject2[$count2];
				mergedProperties[property]= true;
			}
			return this.inherited("update", arguments, [jdojo.getProperties(mergedProperties)]); //$NON-NLS-1$
		}
	},

	resort: function() {
		return new RefreshTransition(this.fRootState);
	},

	collectUpdates: function(viewer, entry, viewerUpdates) {
		viewerUpdates.push(ViewerUpdater.getUpdateEntryRunnable(viewer, entry, this.fProperties));
	},

	getUpdatedState: function() {
		return ShownState.INSTANCE;
	},

	includesChildUpdates: function(entry) {
		return false;
	}
});
var ResortTransition= dojo.declare("com.ibm.team.rtc.foundation.web.ui.model.EntryState.ResortTransition", AbstractStateTransition, { //$NON-NLS-1$

	constructor: function(rootState) {
		this.inherited(arguments, [rootState, true]);
	},

	collectUpdates: function(viewer, entry, viewerUpdates) {
		viewerUpdates.push(ViewerUpdater.getResortEntryRunnable(viewer, entry));
	},

	update: function(properties) {
		return new RefreshTransition(this.fRootState);
	},

	resort: function() {
		return this;
	},

	getUpdatedState: function() {
		return ShownState.INSTANCE;
	},

	includesChildUpdates: function(entry) {
		return false;
	}
});
var RefreshTransition= dojo.declare("com.ibm.team.rtc.foundation.web.ui.model.EntryState.RefreshTransition", AbstractStateTransition, { //$NON-NLS-1$

	constructor: function(rootState) {
		this.inherited(arguments, [rootState, true]);
	},

	collectUpdates: function(viewer, entry, viewerUpdates) {
		viewerUpdates.push(ViewerUpdater.getRefreshEntryRunnable(viewer, entry));
	},

	update: function(properties) {
		return this;
	},

	resort: function() {
		return this;
	},

	getUpdatedState: function() {
		return ShownState.INSTANCE;
	},

	includesChildUpdates: function(entry) {
		return true;
	}
});
var RemoveTransition= dojo.declare("com.ibm.team.rtc.foundation.web.ui.model.EntryState.RemoveTransition", AbstractStateTransition, { //$NON-NLS-1$

	constructor: function(rootState) {
		this.inherited(arguments, [rootState, false]);
	},

	collectUpdates: function(viewer, entry, viewerUpdates) {
		viewerUpdates.push(ViewerUpdater.getRemoveEntryRunnable(viewer, entry, false));
	},

	getUpdatedState: function() {
		return HiddenState.INSTANCE;
	},

	includesChildUpdates: function(entry) {
		return true;
	},

	isRemove: function() {
		return true;
	}
});

})();
