/******************************************************************************
 Licensed Materials - Property of IBM
 (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 
 Note to U.S. Government Users Restricted Rights:
 Use, duplication or disclosure restricted by GSA ADP Schedule
 Contract with IBM Corp.
******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.model.EntryUtils"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var Assert= com.ibm.jdojo.util.Assert;

var EntryUtils= dojo.declare("com.ibm.team.rtc.foundation.web.ui.model.EntryUtils", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" }
});

EntryUtils.isType= function(entry, type) {
	return jdojo.isInstance(EntryUtils.element(entry), type);
};
EntryUtils.cast= function(entry, type) {
	if (!(EntryUtils.isType(entry, type))) Assert.fail("Can't cast IViewEntry<?> to IViewEntry<" + type.prototype.declaredClass + ">", "com.ibm.team.rtc.foundation.web.ui.model.EntryUtils:26"); //$NON-NLS-1$ //$NON-NLS-2$
	return entry;
};
EntryUtils.elements= function(entries) {
	var result= [];
	var $subject= entries;
	var $length= $subject.length;
	for (var $count= 0; $count < $length; $count++){
		var entry= $subject[$count];
		result.push(entry.getElement());
	}
	return result;
};
EntryUtils.element= function(entry) {
	return entry != null ? entry.getElement() : null;
};
EntryUtils.elementOfType= function(entry, type) {
	return EntryUtils.isType(entry, type) ? EntryUtils.cast(entry, type).getElement() : null;
};
EntryUtils.firstElement= function(entries) {
	return EntryUtils.element(EntryUtils.firstEntry(entries));
};
EntryUtils.lastElement= function(entries) {
	return EntryUtils.element(EntryUtils.lastEntry(entries));
};
EntryUtils.elementsOfType= function(entries, typeClass) {
	return EntryUtils.elements(EntryUtils.entriesOfType(entries, typeClass));
};
EntryUtils.firstElementOfType= function(entries, typeClass) {
	return EntryUtils.element(EntryUtils.firstEntryOfType(entries, typeClass));
};
EntryUtils.lastElementOfType= function(entries, typeClass) {
	return EntryUtils.element(EntryUtils.lastEntryOfType(entries, typeClass));
};
EntryUtils.firstEntry= function(entries) {
	return (entries.length == 0) ? null : entries[0];
};
EntryUtils.lastEntry= function(entries) {
	return (entries.length == 0) ? null : entries[entries.length - 1];
};
EntryUtils.entriesWithTag= function(entries, tag) {
	var result= [];
	var $subject2= entries;
	var $length2= $subject2.length;
	for (var $count2= 0; $count2 < $length2; $count2++){
		var entry= $subject2[$count2];
		if (entry.hasTag(tag)) {
			result.push(entry);
		}
	}
	return result;
};
EntryUtils.firstEntryWithTag= function(entries, tag) {
	var $subject3= entries;
	var $length3= $subject3.length;
	for (var $count3= 0; $count3 < $length3; $count3++){
		var entry= $subject3[$count3];
		if (entry.hasTag(tag)) 
			return entry;
	}
	return null;
};
EntryUtils.lastEntryWithTag= function(entries, tag) {
	for (var i= entries.length - 1; i >= 0; i--){
		var entry= entries[i];
		if (entry.hasTag(tag)) 
			return entry;
	}
	return null;
};
EntryUtils.entriesOfType= function(entries, typeClass) {
	var result= [];
	var $subject4= entries;
	var $length4= $subject4.length;
	for (var $count4= 0; $count4 < $length4; $count4++){
		var entry= $subject4[$count4];
		if (jdojo.isInstance(entry.getElement(), typeClass)) {
			result.push(entry);
		}
	}
	return result;
};
EntryUtils.firstEntryOfType= function(entries, typeClass) {
	var $subject5= entries;
	var $length5= $subject5.length;
	for (var $count5= 0; $count5 < $length5; $count5++){
		var entry= $subject5[$count5];
		if (jdojo.isInstance(entry.getElement(), typeClass)) {
			return entry;
		}
	}
	return null;
};
EntryUtils.lastEntryOfType= function(entries, typeClass) {
	for (var i= entries.length - 1; i >= 0; i--){
		var entry= entries[i];
		if (jdojo.isInstance(entry.getElement(), typeClass)) {
			return entry;
		}
	}
	return null;
};

})();
