/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.model.ModificationPolicy"); //$NON-NLS-1$


(function() {

/**
 * @since 3.0
 */
dojo.declare("com.ibm.team.rtc.foundation.web.ui.model.ModificationPolicy", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fViewModel: null,

	constructor: function(viewModel) {
		this.fViewModel= viewModel;
	},

	contributePopupActions: function(manager, entry) {
		this.fViewModel.contributePopupActions(manager, entry);
	},

	canMove: function(source, targetEntry, location) {
		return this.fViewModel.readModel(dojo.hitch(this, function(readAccessor) {
			var moveRequest= new MoveRequest(source, targetEntry, location);
			var response= this.fViewModel.getMoveHandler().canMove(moveRequest, readAccessor);
			if (response == null) 
				return false;
			return response.canMove();
		}));
	},

	move: function(source, targetEntry, location) {
		this.fViewModel.updateModel(dojo.hitch(this, function(updateAccessor) {
			var moveRequest= new MoveRequest(source, targetEntry, location);
			var moveHandler= this.fViewModel.getMoveHandler();
			var response= moveHandler.canMove(moveRequest, updateAccessor);
			if (response == null || !response.canMove()) 
				return null;
			moveHandler.move(response, updateAccessor);
			return null;
		}));
	},

	canCreate: function(request) {
		return this.fViewModel.readModel(dojo.hitch(this, function(readAccessor) {
			var response= this.fViewModel.getCreateHandler().canCreate(request, readAccessor);
			if (response == null) 
				return false;
			return response.canCreate();
		}));
	},

	create: function(request, callback) {
		this.fViewModel.updateModel(dojo.hitch(this, function(updateAccessor) {
			var createHandler= this.fViewModel.getCreateHandler();
			var response= createHandler.canCreate(request, updateAccessor);
			if (response == null || !response.canCreate()) 
				return null;
			var onCreateCallback= dojo.hitch(this, function(newItem) {
				this.fViewModel.updateModel(dojo.hitch(this, function(updateAccessor) {
					createHandler.onCreate(response, newItem, updateAccessor);
					return null;
				}));
			});
			callback(request, onCreateCallback);
			return null;
		}));
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.essentials.IModificationPolicy': true //$NON-NLS-1$
	}
});
var MoveRequest= dojo.declare("com.ibm.team.rtc.foundation.web.ui.model.ModificationPolicy.MoveRequest", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fSource: null,

	fTargetEntry: null,

	fLocation: null,

	constructor: function(source, targetEntry, location) {
		this.fSource= source;
		this.fTargetEntry= targetEntry;
		this.fLocation= location;
	},

	getSource: function() {
		return this.fSource;
	},

	getTarget: function() {
		return this.fTargetEntry;
	},

	getLocation: function() {
		return this.fLocation;
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.essentials.IMoveHandler.IMoveRequest': true //$NON-NLS-1$
	}
});

})();
