/******************************************************************************
 Licensed Materials - Property of IBM
 (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 
 Note to U.S. Government Users Restricted Rights:
 Use, duplication or disclosure restricted by GSA ADP Schedule
 Contract with IBM Corp.
******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.model.ViewEntry"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.IViewModel"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.model.EntryColumn"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.model.EntryState"); //$NON-NLS-1$

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var Assert= com.ibm.jdojo.util.Assert;
var IViewModel= com.ibm.team.rtc.foundation.api.ui.model.IViewModel;
var Domain= com.ibm.team.rtc.foundation.api.ui.model.IViewModel.Domain;
var EntryColumn= com.ibm.team.rtc.foundation.web.ui.model.EntryColumn;
var EntryState= com.ibm.team.rtc.foundation.web.ui.model.EntryState;

var ViewEntry= dojo.declare("com.ibm.team.rtc.foundation.web.ui.model.ViewEntry", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	NO_CHILDREN: null,

	fElement: null,

	fIsRootEntry: null,

	fModel: null,

	fParent: null,

	fOwnIndex: null,

	fTags: null,

	fChildren: null,

	fRemovedChildren: null,

	fHiddenChildrenCount: null,

	fIsSorting: null,

	fDisposed: null,

	fSortRequest: null,

	fAddedAsNodeCount: null,

	fAddedAsLeafCount: null,

	fState: null,

	fUnfilteredState: null,

	fIdentifier: null,

	fNextChildId: null,

	constructor: function(model, modelElement, parent, isRootEntry) {
		this.NO_CHILDREN= [];
		this.fOwnIndex= -1;
		this.fTags= [];
		this.fDisposed= false;
		this.fSortRequest= SortRequest.None;
		this.fAddedAsNodeCount= 0;
		this.fAddedAsLeafCount= 0;
		this.fState= EntryState.INITIAL();
		this.fNextChildId= 0;
		this.fModel= model;
		this.fElement= modelElement;
		this.fParent= parent;
		this.fIsRootEntry= isRootEntry;
		if (!(!isRootEntry || modelElement instanceof IViewModel.Domain)) Assert.fail("!isRootEntry || modelElement instanceof IViewModel.Domain", "com.ibm.team.rtc.foundation.web.ui.model.ViewEntry:94");
	},

	getIdentifier: function() {
		if (this.fIdentifier == null) {
			this.fIdentifier= this.fParent != null ? this.fParent.generateChildTreeId() : ""; //$NON-NLS-1$
		}
		return this.fIdentifier;
	},

	getModel: function() {
		return this.fModel;
	},

	isRootEntry: function() {
		return this.fIsRootEntry;
	},

	isVisible: function() {
		return this.fState.isVisible();
	},

	isDisposed: function() {
		return this.fDisposed;
	},

	getElement: function() {
		return this.fElement;
	},

	isAddedExplicitly: function() {
		return this.fAddedAsLeafCount > 0;
	},

	hasTag: function(tag) {
		return this.getTagEntry(tag) != null;
	},

	hasTagOfType: function(tagClass) {
		for (var i= 0; this.fTags != null && i < this.fTags.length; i++){
			if (jdojo.isInstance(this.fTags[i].tag, tagClass)) {
				return true;
			}
		}
		return false;
	},

	getTags: function(tagClass) {
		var result= [];
		for (var i= 0; this.fTags != null && i < this.fTags.length; i++){
			if (jdojo.isInstance(this.fTags[i].tag, tagClass)) {
				result.push(this.fTags[i].tag);
			}
		}
		return result;
	},

	getOwnIndex: function() {
		if (this.fParent != null && this.fOwnIndex !== -1) {
			if (!(this.fParent.fIsSorting || this.fParent.fChildren[this.fOwnIndex] === this)) Assert.fail("this.fParent.fIsSorting || this.fParent.fChildren[this.fOwnIndex] === this", "com.ibm.team.rtc.foundation.web.ui.model.ViewEntry:153");
		}
		return this.fOwnIndex;
	},

	getTreePath: function() {
		var result;
		if (this.fParent == null) {
			result= [];
		} else {
			result= this.fParent.getTreePath();
		}
		result.push(this.fElement.getIdentifier());
		return result;
	},

	added: function(asLeaf) {
		if (asLeaf) {
			this.fAddedAsLeafCount++;
		} else {
			this.fAddedAsNodeCount++;
		}
	},

	copy: function(newParent) {
		return {entry: ViewEntry.createCopy(this, newParent), count: this.fAddedAsLeafCount};
	},

	/**
	 * Notifies the entry that it is being released as either a leaf or node from the transformed model. The method
	 * returns whether this entry is still needed or not
	 * @param asLeaf
	 * @return returns true if the element is not being used anymore, and thus was transferred in the removed state
	 */
	removed: function(asLeaf) {
		if (asLeaf) {
			this.fAddedAsLeafCount--;
		} else {
			this.fAddedAsNodeCount--;
		}
		if (!(this.fAddedAsLeafCount >= 0 && this.fAddedAsNodeCount >= 0)) Assert.fail("this.fAddedAsLeafCount >= 0 && this.fAddedAsNodeCount >= 0", "com.ibm.team.rtc.foundation.web.ui.model.ViewEntry:206");
		if (this.fAddedAsLeafCount === 0 && this.fAddedAsNodeCount === 0) {
			if (this.fChildren != null && this.fChildren.length > 0) {
				var $subject= [].concat(this.fChildren);
				var $length= $subject.length;
				for (var $count= 0; $count < $length; $count++){
					var childEntry= $subject[$count];
					if (!(childEntry.getElement() instanceof EntryColumn)) Assert.fail("childEntry.getElement() instanceof EntryColumn", "com.ibm.team.rtc.foundation.web.ui.model.ViewEntry:213");
					childEntry.setState(childEntry.fState.remove());
					this.remove(childEntry);
					this.fModel.unregisterEntry(childEntry);
				}
			}
			if (!(this.fElement instanceof EntryColumn)) {
				this.setState(this.fState.remove());
				this.fParent.remove(this);
				this.fModel.unregisterEntry(this);
			}
		}
	},

	dispose: function() {
		var i;
		if (this.fChildren != null) {
			for (i= 0; i < this.fChildren.length; i++){
				this.fChildren[i].dispose();
			}
			this.fChildren= null;
		}
		if (this.fRemovedChildren != null) {
			for (i= 0; i < this.fRemovedChildren.length; i++){
				this.fRemovedChildren[i].dispose();
			}
			this.fRemovedChildren= null;
		}
		if (this.fTags != null) 
			this.fTags= null;
		this.fOwnIndex= -1;
		this.fDisposed= true;
	},

	setUnfilteredState: function(state) {
		this.fUnfilteredState= state;
	},

	getUnfilteredState: function() {
		return this.fUnfilteredState;
	},

	hasUpdates: function() {
		return this.fState.hasUpdates();
	},

	isAdd: function() {
		return this.fState.isAdd();
	},

	isRemove: function() {
		return this.fState.isRemove();
	},

	collectUpdates: function(viewer, viewerUpdates) {
		this.fState.collectUpdates(viewer, this, viewerUpdates);
		return !this.fState.includesChildUpdates(this);
	},

	processUpdate: function() {
		this.doProcessUpdate(this.fState.includesChildUpdates(this));
	},

	doProcessUpdate: function(updateChildren) {
		var i;
		if (updateChildren && this.fChildren != null) {
			for (i= 0; i < this.fChildren.length; i++){
				this.fChildren[i].doProcessUpdate(updateChildren);
			}
		}
		if (this.fRemovedChildren != null) {
			for (i= 0; i < this.fRemovedChildren.length; i++){
				this.fRemovedChildren[i].dispose();
			}
			this.fRemovedChildren= null;
		}
		this.setState(this.fState.getUpdatedState());
	},

	getParent: function() {
		return this.fParent;
	},

	getChildren: function() {
		return this.fChildren != null ? Array.prototype.concat.apply([], this.fChildren) : this.NO_CHILDREN;
	},

	add: function(childEntry, updateAccessor) {
		if (!(childEntry.fParent === this)) Assert.fail("childEntry.fParent === this", "com.ibm.team.rtc.foundation.web.ui.model.ViewEntry:309");
		if (this.fChildren == null) {
			this.fChildren= [];
		}
		this.fChildren.push(childEntry);
		childEntry.fOwnIndex= this.fChildren.length - 1;
		this.requestSortChildren(updateAccessor, false);
	},

	show: function(updateAccessor) {
		this.setState(this.fState.show());
		this.fParent.updateTwistieState(true);
	},

	hide: function(updateAccessor) {
		this.setState(this.fState.hide());
		this.fParent.updateTwistieState(false);
	},

	/**
	 * We want to update the twistie state only when:
	 *  - all children were hidden but not anymore OR
	 * 	- some children were visible but now they're all hidden.
	 */
	updateTwistieState: function(visible) {
		var childrenCount= this.fChildren.length;
		var oldHiddenChildrenCount= this.fHiddenChildrenCount;
		this.fHiddenChildrenCount+= visible ? -1 : 1;
		if (this.fHiddenChildrenCount === childrenCount ^ oldHiddenChildrenCount === childrenCount) {
			this.setState(this.fState.refresh());
		}
	},

	update: function(properties, updateAccessor) {
		this.setState(this.fState.update(properties));
		if (this.fParent != null) {
			var needsResort= properties == null;
			for (var i= 0; !needsResort && i < properties.length; i++){
				needsResort= this.fModel.isSorterProperty(properties[i]);
			}
			if (needsResort) 
				this.fParent.requestSortChildren(updateAccessor, false);
		}
	},

	setTag: function(tag) {
		var tagEntry= this.getTagEntry(tag);
		if (tagEntry != null) {
			tagEntry.refCount++;
		} else {
			this.fTags.push({tag: tag, refCount: 1});
			this.setState(this.fState.update(null));
		}
	},

	clearTag: function(tag) {
		var tagEntry= this.getTagEntry(tag);
		if (tagEntry != null) {
			if (--tagEntry.refCount === 0) {
				this.fTags.splice(dojo.indexOf(this.fTags, tagEntry), 1);
				this.setState(this.fState.update(null));
			}
		}
	},

	move: function(childEntry, newIndex, updateAccessor) {
		if (!(childEntry.getParent() === this)) Assert.fail("childEntry.getParent() === this", "com.ibm.team.rtc.foundation.web.ui.model.ViewEntry:379");
		if (!(this.fChildren != null)) Assert.fail("this.fChildren != null", "com.ibm.team.rtc.foundation.web.ui.model.ViewEntry:380");
		if (!(newIndex >= 0 && newIndex <= this.fChildren.length)) Assert.fail("newIndex >= 0 && newIndex <= this.fChildren.length", "com.ibm.team.rtc.foundation.web.ui.model.ViewEntry:381");
		var oldIndex= childEntry.getOwnIndex();
		if (!(oldIndex >= 0 && oldIndex < this.fChildren.length)) Assert.fail("oldIndex >= 0 && oldIndex < this.fChildren.length", "com.ibm.team.rtc.foundation.web.ui.model.ViewEntry:384");
		if (!(this.fChildren[oldIndex] === childEntry)) Assert.fail("this.fChildren[oldIndex] === childEntry", "com.ibm.team.rtc.foundation.web.ui.model.ViewEntry:385");
		if (oldIndex !== newIndex) {
			this.fChildren.splice(oldIndex, 1);
			var insertIndex= newIndex < oldIndex ? newIndex : newIndex - 1;
			this.fChildren.splice(insertIndex, 0, childEntry);
			for (var i= Math.min(insertIndex, oldIndex); i < this.fChildren.length; i++){
				this.fChildren[i].fOwnIndex= i;
			}
			if (!childEntry.fState.isAdd()) {
				this.setState(this.fState.resort());
			}
			this.requestSortChildren(updateAccessor, false);
		}
	},

	refresh: function(updateAccessor) {
		this.setState(this.fState.refresh());
	},

	requestSortChildren: function(updateAccessor, forceResort) {
		this.fSortRequest= this.fSortRequest.requestSort(forceResort);
		this.fModel.registerEntrySortRequest(this);
	},

	hasPendingSort: function() {
		return this.fSortRequest !== SortRequest.None;
	},

	doPendingSort: function(updateAccessor) {
		if (this.fSortRequest !== SortRequest.None) {
			if (this.fChildren != null) {
				this.fIsSorting= true;
				try {
					this.fModel.sort(this.fChildren, updateAccessor, this.fSortRequest === SortRequest.Full);
					var hasChanges= false;
					var indexDelta= 0;
					for (var i= 0; i < this.fChildren.length; i++){
						var childEntry= this.fChildren[i];
						if (childEntry.fOwnIndex + indexDelta !== i) {
							if (childEntry.fState.isAdd()) {
								indexDelta++;
							} else {
								hasChanges= true;
							}
						}
						childEntry.fOwnIndex= i;
					}
					if (hasChanges) {
						this.setState(this.fState.resort());
					}
				} finally {
					this.fIsSorting= false;
				}
			}
			this.fSortRequest= SortRequest.None;
		}
	},

	getTagEntry: function(tag) {
		for (var i= 0; i < this.fTags.length; i++){
			if (this.fTags[i].tag.equals(tag)) {
				return this.fTags[i];
			}
		}
		return null;
	},

	remove: function(childEntry) {
		if (!(childEntry.fParent === this)) Assert.fail("childEntry.fParent === this", "com.ibm.team.rtc.foundation.web.ui.model.ViewEntry:462");
		if (!(this.fChildren != null)) Assert.fail("this.fChildren != null", "com.ibm.team.rtc.foundation.web.ui.model.ViewEntry:463");
		if (this.fRemovedChildren == null) {
			this.fRemovedChildren= [];
		}
		this.fRemovedChildren.push(childEntry);
		var oldIndex= childEntry.fOwnIndex;
		childEntry.fOwnIndex= -1;
		if (!(this.fChildren[oldIndex] === childEntry)) Assert.fail("this.fChildren[oldIndex] === childEntry", "com.ibm.team.rtc.foundation.web.ui.model.ViewEntry:473");
		this.fChildren.splice(oldIndex, 1);
		for (var i= oldIndex; i < this.fChildren.length; i++){
			this.fChildren[i].fOwnIndex= i;
		}
	},

	accept: function(visitor, visitDeleted) {
		var i;
		if (visitor(this)) {
			if (visitDeleted && this.fRemovedChildren != null) {
				for (i= 0; i < this.fRemovedChildren.length; i++){
					this.fRemovedChildren[i].accept(visitor, visitDeleted);
				}
			}
			if (this.fChildren != null) {
				for (i= 0; i < this.fChildren.length; i++){
					this.fChildren[i].accept(visitor, visitDeleted);
				}
			}
		}
	},

	setState: function(newState) {
		if (!(newState != null)) Assert.fail("newState != null", "com.ibm.team.rtc.foundation.web.ui.model.ViewEntry:499");
		var oldState= this.fState;
		this.fState= newState;
		if (newState.hasUpdates() && !oldState.hasUpdates()) {
			this.fModel.registerEntryModification(this);
		}
	},

	generateChildTreeId: function() {
		var result= this.getIdentifier();
		if (result !== "") { //$NON-NLS-1$
			result+= "-"; //$NON-NLS-1$
		}
		return result + (this.fNextChildId++);
	},

	$interfaces: {
		'com.ibm.jdojo.util.IMappable': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.api.ui.model.IViewEntry': true //$NON-NLS-1$
	}
});

ViewEntry.createCopy= function(other, parent) {
	if (!(!other.fDisposed)) Assert.fail("!other.fDisposed", "com.ibm.team.rtc.foundation.web.ui.model.ViewEntry:519");
	var result= new ViewEntry(other.fModel, other.fElement, parent, other.fIsRootEntry);
	result.fSortRequest= other.fSortRequest;
	result.fTags= dojo.clone(other.fTags);
	result.fUnfilteredState= other.fUnfilteredState;
	return result;
};
var SortRequest= dojo.declare("com.ibm.team.rtc.foundation.web.ui.model.ViewEntry.SortRequest", null, { //$NON-NLS-1$

	requestSort: function(forceResort) {
		Assert.isTrue(false, "Abstract method 'requestSort' invoked");
	},

	compareTo: function(other) {
		return this.ordinal - other.ordinal;
	}
});

SortRequest.values= [
	dojo.mixin(new SortRequest(), {
		name: 'None',
		ordinal: 0,
		requestSort: function(forceResort) {
			return forceResort ? SortRequest.Full : SortRequest.Normal;
		}
	}),
	dojo.mixin(new SortRequest(), {
		name: 'Normal',
		ordinal: 1,
		requestSort: function(forceResort) {
			return forceResort ? SortRequest.Full : SortRequest.Normal;
		}
	}),
	dojo.mixin(new SortRequest(), {
		name: 'Full',
		ordinal: 2,
		requestSort: function(forceResort) {
			return SortRequest.Full;
		}
	})
];
SortRequest.None= SortRequest.values[0];
SortRequest.Normal= SortRequest.values[1];
SortRequest.Full= SortRequest.values[2];

})();
