/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.model.ViewModel"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Exception"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.lang.JavaScriptException"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.internal.util.CompositeCreateHandler"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.internal.util.CompositeMoveHandler"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.ColumnTag"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.IViewModel"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.LinkElement"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.tags.UnfilteredChildrenTag"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.model.EntryColumn"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.model.EntryNavigator"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.model.LinkEntry"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.model.ModificationPolicy"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.model.ViewEntry"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.model.ViewerUpdater"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.util.ListenerList"); //$NON-NLS-1$

(function() {
var Exception= com.ibm.jdojo.lang.Exception;
var JavaScriptException= com.ibm.jdojo.lang.JavaScriptException;
var jdojo= com.ibm.jdojo.lang.Runtime;
var Assert= com.ibm.jdojo.util.Assert;
var CompositeCreateHandler= com.ibm.team.rtc.foundation.api.ui.internal.util.CompositeCreateHandler;
var CompositeMoveHandler= com.ibm.team.rtc.foundation.api.ui.internal.util.CompositeMoveHandler;
var ColumnTag= com.ibm.team.rtc.foundation.api.ui.model.ColumnTag;
var IViewModel= com.ibm.team.rtc.foundation.api.ui.model.IViewModel;
var Domain= com.ibm.team.rtc.foundation.api.ui.model.IViewModel.Domain;
var LinkElement= com.ibm.team.rtc.foundation.api.ui.model.LinkElement;
var UnfilteredChildrenTag= com.ibm.team.rtc.foundation.api.ui.tags.UnfilteredChildrenTag;
var EntryColumn= com.ibm.team.rtc.foundation.web.ui.model.EntryColumn;
var EntryNavigator= com.ibm.team.rtc.foundation.web.ui.model.EntryNavigator;
var LinkEntry= com.ibm.team.rtc.foundation.web.ui.model.LinkEntry;
var ModificationPolicy= com.ibm.team.rtc.foundation.web.ui.model.ModificationPolicy;
var ViewEntry= com.ibm.team.rtc.foundation.web.ui.model.ViewEntry;
var ViewerUpdater= com.ibm.team.rtc.foundation.web.ui.model.ViewerUpdater;
var ListenerList= com.ibm.team.rtc.foundation.web.ui.util.ListenerList;

/**
 * The Web UI specific implementation of IViewModel.
 * @since 3.0
 */
var ViewModel= dojo.declare("com.ibm.team.rtc.foundation.web.ui.model.ViewModel", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fViewer: null,

	fInput: null,

	fModelTransformer: null,

	fFilters: null,

	fComparators: null,

	fModificationPolicy: null,

	fMoveHandler: null,

	fCreateHandler: null,

	fSelectedEntries: null,

	fRootEntry: null,

	fDomainRootEntries: null,

	fLinksMap: null,

	fLinksEntries: null,

	fRootColumn: null,

	fTotalEntryCount: null,

	fReverseItemMap: null,

	fGenerationCounter: null,

	fNestedUpdates: null,

	fEndUpdateRunnables: null,

	fModifiedEntries: null,

	fModifiedEntryCount: null,

	fSortRequestEntries: null,

	fNestedSelectionChanges: null,

	fInitialSelectedEntries: null,

	fSelectionListeners: null,

	fPostUpdateBeforeFilterRunnables: null,

	fPostUpdateAfterFilterRunnables: null,

	fReadAccessor: null,

	fReadersCount: null,

	constructor: function() {
		this.fFilters= [];
		this.fComparators= [];
		this.fModificationPolicy= new ModificationPolicy(this);
		this.fSelectedEntries= {};
		this.fDomainRootEntries= {};
		this.fTotalEntryCount= 0;
		this.fModifiedEntryCount= 0;
		this.fInitialSelectedEntries= {};
		this.fSelectionListeners= new ListenerList();
		this.fPostUpdateBeforeFilterRunnables= new ListenerList();
		this.fPostUpdateAfterFilterRunnables= new ListenerList();
		this.fReadersCount= 0;
		this.fReadAccessor= new ReadAccessor(this);
	},

	setViewer: function(newViewer) {
		var oldViewer= this.fViewer;
		this.fViewer= newViewer;
		this.fViewer.setInput(this);
		this.refresh();
	},

	getViewer: function() {
		return this.fViewer;
	},

	setInput: function(input) {
		this.updateModel(dojo.hitch(this, function(updateAccessor) {
			if (this.fRootEntry != null) {
				this.fRootEntry.dispose();
				this.fRootEntry= null;
			}
			this.fRootColumn= null;
			this.fReverseItemMap= {};
			this.fTotalEntryCount= 0;
			return null;
		}));
		this.fInput= input;
		if (this.fModelTransformer != null) {
			this.fModelTransformer.inputChanged(this, input);
		}
		var $subject= this.fComparators;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var comparator= $subject[$count];
			comparator.inputChanged(this, input);
		}
		this.refresh();
	},

	getInput: function() {
		return this.fInput;
	},

	setModelTransformer: function(transformer) {
		if (this.fModelTransformer != null) {
			this.fModelTransformer.inputChanged(null, null);
		}
		this.fModelTransformer= transformer;
		this.fMoveHandler= null;
		this.fCreateHandler= null;
		if (this.fModelTransformer != null) {
			this.fModelTransformer.inputChanged(this, this.getInput());
		}
		this.refresh();
	},

	getModelTransformer: function() {
		return this.fModelTransformer;
	},

	getModificationPolicy: function() {
		return this.fModificationPolicy;
	},

	setSorter: function(sorter) {
		if (!(false)) Assert.fail("deprecated - not implemented", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:182"); //$NON-NLS-1$
	},

	getSorter: function() {
		if (!(false)) Assert.fail("deprecated - not implemented", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:186"); //$NON-NLS-1$
		return null;
	},

	addComparator: function(comparator) {
		var viewModel= this;
		this.updateModel(dojo.hitch(this, function(updateAccessor) {
			if (dojo.indexOf(this.fComparators, comparator) === -1) {
				this.fComparators.push(comparator);
				this.fComparators.sort(dojo.hitch(this, function(left, right) {
					return -(left.getPriority() - right.getPriority());
				}));
				this.fMoveHandler= null;
				this.fCreateHandler= null;
				comparator.inputChanged(viewModel, this.getInput());
				this.resort();
			}
			return null;
		}));
	},

	removeComparator: function(comparator) {
		this.updateModel(dojo.hitch(this, function(updateAccessor) {
			var comparatorIndex= dojo.indexOf(this.fComparators, comparator);
			if (comparatorIndex !== -1) {
				this.fComparators.splice(comparatorIndex, 1);
				this.fMoveHandler= null;
				this.fCreateHandler= null;
				comparator.inputChanged(null, null);
				this.resort();
			}
			return null;
		}));
	},

	addFilter: function(filter) {
		if (dojo.indexOf(this.fFilters, filter) === -1) {
			this.fFilters.push(filter);
			this.fMoveHandler= null;
			this.fCreateHandler= null;
		}
		this.refilter();
	},

	removeFilter: function(filter) {
		var filterIndex= dojo.indexOf(this.fFilters, filter);
		if (filterIndex !== -1) {
			this.fFilters.splice(filterIndex, 1);
			this.fMoveHandler= null;
			this.fCreateHandler= null;
		}
		this.refilter();
	},

	refresh: function() {
		this.clearSelection();
		this.updateModel(dojo.hitch(this, function(updateAccessor) {
			if (this.fRootEntry != null) {
				this.fRootEntry.dispose();
				this.fRootEntry= null;
			}
			this.fRootColumn= null;
			this.fReverseItemMap= {};
			this.fTotalEntryCount= 0;
			if (this.fModelTransformer != null && this.fInput != null) {
				this.createRootEntries(updateAccessor);
				this.fModelTransformer.refreshModel(updateAccessor);
				this.resort();
			}
			return null;
		}));
	},

	refreshSortOrder: function() {
		this.resort();
	},

	refreshFilters: function() {
		this.refilter();
	},

	viewerPreservingRefresh: function() {
		this.refresh();
	},

	addPostUpdateRunnable: function(code, runsBeforeFiltering) {
		var listenerList= this.getPostUpdateListenerList(runsBeforeFiltering);
		listenerList.addListener(code);
		return {code: code, runsBeforeFiltering: runsBeforeFiltering};
	},

	removePostUpdateRunnable: function(handle) {
		if (!(handle != null)) Assert.fail("handle != null", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:308");
		var listenerList= this.getPostUpdateListenerList(handle.runsBeforeFiltering);
		listenerList.removeListener(handle.code);
	},

	readModel: function(code) {
		this.fReadAccessor.grantAccess();
		this.fReadersCount+= 1;
		try {
			return code(this.fReadAccessor);
		} finally {
			this.fReadersCount-= 1;
			if (this.fReadersCount === 0) {
				this.fReadAccessor.revokeAccess();
			}
		}
	},

	updateModel: function(code) {
		this.fReadAccessor.clearEntryNavigators();
		var runnableResult;
		var viewerUpdates= null;
		this.fGenerationCounter++;
		var updateAccessor= this.createUpdateAccessor();
		try {
			try {
				if (++this.fNestedUpdates === 1) {
					this.doStartUpdate();
				}
				runnableResult= code(updateAccessor);
			} finally {
				if (--this.fNestedUpdates === 0) {
					viewerUpdates= this.doEndUpdate(updateAccessor);
				}
			}
		} finally {
			updateAccessor.revokeAccess();
		}
		if (viewerUpdates != null) {
			if (!(this.fViewer != null)) Assert.fail("this.fViewer != null", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:350");
			this.fViewer.beginUpdate();
			try {
				for (var i= 0; i < viewerUpdates.length; i++){
					viewerUpdates[i]();
				}
			} finally {
				this.fViewer.endUpdate();
			}
		}
		return runnableResult;
	},

	executeUnlocked: function(code) {
		return this.updateModel(dojo.hitch(this, function(updateAccessor) {
			return updateAccessor.executeUnlocked(code);
		}));
	},

	getSelectedEntries: function() {
		var result= [];
		var $subject2= jdojo.getProperties(this.fSelectedEntries);
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var key= $subject2[$count2];
			result.push(this.fSelectedEntries[key]);
		}
		return result;
	},

	getSelectedElements: function() {
		var result= [];
		var entries= this.getSelectedEntries();
		for (var i= 0; i < entries.length; i++){
			result.push(entries[i].getElement());
		}
		return result;
	},

	isSelected: function(toSelect) {
		return (toSelect.getIdentifier() in this.fSelectedEntries);
	},

	setSelected: function(toSelect, setSelected) {
		if (this.isSelected(toSelect) !== setSelected) {
			this.beginSelectionChange();
			try {
				if (setSelected) {
					this.fSelectedEntries[toSelect.getIdentifier()]= toSelect;
				} else {
					delete this.fSelectedEntries[toSelect.getIdentifier()];
				}
				this.fViewer.setSelectionState(toSelect, setSelected);
			} finally {
				this.endSelectionChange();
			}
		}
	},

	setSelectedEntries: function(toSelect) {
		this.beginSelectionChange();
		try {
			var toDeselect= dojo.mixin({}, this.fSelectedEntries);
			var $subject3= toSelect;
			var $length3= $subject3.length;
			for (var $count3= 0; $count3 < $length3; $count3++){
				var viewEntry= $subject3[$count3];
				if (this.isSelected(viewEntry)) {
					delete toDeselect[viewEntry.getIdentifier()];
				} else {
					this.setSelected(viewEntry, true);
				}
			}
			var $subject4= jdojo.getProperties(toDeselect);
			var $length4= $subject4.length;
			for (var $count4= 0; $count4 < $length4; $count4++){
				var key= $subject4[$count4];
				this.setSelected(toDeselect[key], false);
			}
		} finally {
			this.endSelectionChange();
		}
	},

	clearSelection: function() {
		this.beginSelectionChange();
		try {
			var $subject5= jdojo.getProperties(this.fSelectedEntries);
			var $length5= $subject5.length;
			for (var $count5= 0; $count5 < $length5; $count5++){
				var key= $subject5[$count5];
				this.setSelected(this.fSelectedEntries[key], false);
			}
		} finally {
			this.endSelectionChange();
		}
	},

	expandEntries: function(toExpand) {
		var $subject6= toExpand;
		var $length6= $subject6.length;
		for (var $count6= 0; $count6 < $length6; $count6++){
			var entry= $subject6[$count6];
			this.fViewer.setExpandedState(entry, true);
		}
	},

	setEntryExpandState: function(entry, expanded) {
		this.fViewer.setExpandedState(entry, expanded);
	},

	beginSelectionChange: function() {
		if (this.fNestedSelectionChanges === 0) {
			this.fInitialSelectedEntries= dojo.mixin({}, this.fSelectedEntries);
		}
		this.fNestedSelectionChanges++;
	},

	endSelectionChange: function() {
		this.fNestedSelectionChanges--;
		if (this.fNestedSelectionChanges === 0) {
			var initialKeys= jdojo.getProperties(this.fInitialSelectedEntries);
			var currentKeys= jdojo.getProperties(this.fSelectedEntries);
			initialKeys.sort();
			currentKeys.sort();
			var hasChange= initialKeys.length !== currentKeys.length;
			for (var i= 0; !hasChange && i < initialKeys.length; i++){
				hasChange= initialKeys[i] !== currentKeys[i];
			}
			if (hasChange) {
				var selectedEntries= this.getSelectedEntries();
				var $subject7= this.fSelectionListeners.getListeners();
				var $length7= $subject7.length;
				for (var $count7= 0; $count7 < $length7; $count7++){
					var selectionListener= $subject7[$count7];
					selectionListener(selectedEntries);
				}
			}
		}
	},

	addSelectionListener: function(listener) {
		this.fSelectionListeners.addListener(listener);
	},

	removeSelectionListener: function(listener) {
		this.fSelectionListeners.removeListener(listener);
	},

	revealEntry: function(toReveal) {
		this.fViewer.reveal(toReveal);
	},

	getExpansionHull: function(rootEntry) {
		return this.fViewer.getExpansionHull(rootEntry);
	},

	setExpansionHull: function(rootEntry, expansionHull) {
		this.fViewer.setExpansionHull(rootEntry, expansionHull);
	},

	calculateFilterState: function(entry, readAccessor) {
		if (!entry.isRootEntry()) {
			for (var i= 0; i < this.fFilters.length; i++){
				if (!this.fFilters[i].select(entry, readAccessor)) 
					return false;
			}
		}
		return true;
	},

	isSorterProperty: function(property) {
		var $subject8= this.fComparators;
		var $length8= $subject8.length;
		for (var $count8= 0; $count8 < $length8; $count8++){
			var comparator= $subject8[$count8];
			if (comparator.isComparatorProperty(property)) 
				return true;
		}
		return false;
	},

	registerEntryModification: function(entry) {
		if (this.fModifiedEntries != null) {
			if ((entry.getIdentifier() in this.fModifiedEntries)) 
				return ;
			this.fModifiedEntryCount++;
			if (this.fModifiedEntryCount > ((this.fTotalEntryCount / 4)|0)) {
				this.fModifiedEntries= null;
				return ;
			}
			this.fModifiedEntries[entry.getIdentifier()]= entry;
		}
	},

	registerEntrySortRequest: function(entry) {
		if (!(this.fSortRequestEntries != null)) Assert.fail("this.fSortRequestEntries != null", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:540");
		this.fSortRequestEntries[entry.getIdentifier()]= entry;
	},

	sort: function(entries, readAccessor, forceResort) {
		entries.sort(dojo.hitch(this, function(left, right) {
			var $subject9= this.fComparators;
			var $length9= $subject9.length;
			for (var $count9= 0; $count9 < $length9; $count9++){
				var comparator= $subject9[$count9];
				var result= comparator.compare(left, right, readAccessor, forceResort);
				if (result !== undefined && result !== 0) 
					return result;
			}
			return left.getOwnIndex() - right.getOwnIndex();
		}));
	},

	getMoveHandler: function() {
		if (this.fMoveHandler == null) {
			var modificationHandlers= this.getModificationHandlers();
			if (modificationHandlers.length === 1) {
				this.fMoveHandler= modificationHandlers[0].getMoveHandler();
				if (this.fMoveHandler == null) {
					this.fMoveHandler= new CompositeMoveHandler();
				}
			} else {
				var handler= new CompositeMoveHandler();
				var $subject10= modificationHandlers;
				var $length10= $subject10.length;
				for (var $count10= 0; $count10 < $length10; $count10++){
					var handlerProvider= $subject10[$count10];
					handler.add(handlerProvider.getMoveHandler());
				}
				this.fMoveHandler= handler;
			}
		}
		return this.fMoveHandler;
	},

	getCreateHandler: function() {
		if (this.fCreateHandler == null) {
			var modificationHandlers= this.getModificationHandlers();
			if (modificationHandlers.length === 1) {
				this.fCreateHandler= modificationHandlers[0].getCreateHandler();
				if (this.fCreateHandler == null) {
					this.fCreateHandler= new CompositeCreateHandler();
				}
			} else {
				var handler= new CompositeCreateHandler();
				var $subject11= modificationHandlers;
				var $length11= $subject11.length;
				for (var $count11= 0; $count11 < $length11; $count11++){
					var handlerProvider= $subject11[$count11];
					handler.add(handlerProvider.getCreateHandler());
				}
				this.fCreateHandler= handler;
			}
		}
		return this.fCreateHandler;
	},

	contributePopupActions: function(manager, entry) {
		var actionContributors= this.getActionContributors();
		var $subject12= actionContributors;
		var $length12= $subject12.length;
		for (var $count12= 0; $count12 < $length12; $count12++){
			var contributor= $subject12[$count12];
			contributor.contributePopupActions(manager, entry);
		}
	},

	doRemoveLinkEntry: function(linkEntry) {
		var $subject13= jdojo.getProperties(this.fLinksEntries);
		var $length13= $subject13.length;
		for (var $count13= 0; $count13 < $length13; $count13++){
			var linkKey= $subject13[$count13];
			var linkEntries= this.fLinksEntries[linkKey];
			var index= dojo.indexOf(linkEntries, linkEntry);
			if (index !== -1) {
				if (linkEntries.length === 1) {
					delete this.fLinksEntries[linkKey];
				} else {
					linkEntries.splice(index, 1);
				}
				break;
			}
		}
	},

	getModificationHandlers: function() {
		var result= [];
		if (jdojo.implementsInterface(this.fModelTransformer, "com.ibm.team.rtc.foundation.api.ui.essentials.IModificationHandlerProvider")) {
			result.push(this.fModelTransformer);
		}
		var $subject14= this.fComparators;
		var $length14= $subject14.length;
		for (var $count14= 0; $count14 < $length14; $count14++){
			var comparator= $subject14[$count14];
			if (jdojo.implementsInterface(comparator, "com.ibm.team.rtc.foundation.api.ui.essentials.IModificationHandlerProvider")) {
				result.push(comparator);
			}
		}
		var $subject15= this.fFilters;
		var $length15= $subject15.length;
		for (var $count15= 0; $count15 < $length15; $count15++){
			var filer= $subject15[$count15];
			if (jdojo.implementsInterface(filer, "com.ibm.team.rtc.foundation.api.ui.essentials.IModificationHandlerProvider")) {
				result.push(filer);
			}
		}
		return result;
	},

	getActionContributors: function() {
		var result= [];
		if (jdojo.implementsInterface(this.fModelTransformer, "com.ibm.team.rtc.foundation.api.ui.essentials.IActionContributor")) {
			result.push(this.fModelTransformer);
		}
		var $subject16= this.fComparators;
		var $length16= $subject16.length;
		for (var $count16= 0; $count16 < $length16; $count16++){
			var comparator= $subject16[$count16];
			if (jdojo.implementsInterface(comparator, "com.ibm.team.rtc.foundation.api.ui.essentials.IActionContributor")) {
				result.push(comparator);
			}
		}
		var $subject17= this.fFilters;
		var $length17= $subject17.length;
		for (var $count17= 0; $count17 < $length17; $count17++){
			var filer= $subject17[$count17];
			if (jdojo.implementsInterface(filer, "com.ibm.team.rtc.foundation.api.ui.essentials.IActionContributor")) {
				result.push(filer);
			}
		}
		this.readModel(dojo.hitch(this, function(readAccessor) {
			var rootColumn= readAccessor.getRootColumn();
			this.processEntryColumn(result, rootColumn, readAccessor);
			return null;
		}));
		return result;
	},

	processEntryColumn: function(result, entryColumn, readAccessor) {
		var propertyColumnsLists= entryColumn.getPropertyColumnsLists(readAccessor);
		var $subject18= propertyColumnsLists;
		var $length18= $subject18.length;
		for (var $count18= 0; $count18 < $length18; $count18++){
			var propertyColumnList= $subject18[$count18];
			var $subject19= propertyColumnList.getColumns(readAccessor);
			var $length19= $subject19.length;
			for (var $count19= 0; $count19 < $length19; $count19++){
				var column= $subject19[$count19];
				var descriptor= column.getPropertyDescriptor();
				if (jdojo.implementsInterface(descriptor, "com.ibm.team.rtc.foundation.api.ui.essentials.IActionContributor")) {
					result.push(descriptor);
				}
			}
		}
		var entryColumnsList= entryColumn.getEntryColumnsLists(readAccessor);
		var $subject20= entryColumnsList;
		var $length20= $subject20.length;
		for (var $count20= 0; $count20 < $length20; $count20++){
			var entryColumnList= $subject20[$count20];
			var $subject21= entryColumnList.getColumns(readAccessor);
			var $length21= $subject21.length;
			for (var $count21= 0; $count21 < $length21; $count21++){
				var column= $subject21[$count21];
				this.processEntryColumn(result, column, readAccessor);
			}
		}
	},

	checkAccess: function(accessor) {
		if (!(accessor instanceof LimitedModelAccessor)) Assert.fail("accessor instanceof LimitedModelAccessor", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:688");
		if (!(accessor.fIsAccessGranted)) Assert.fail("The model access has been revoked", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:689"); //$NON-NLS-1$
		if (!(this === accessor.fViewModel)) Assert.fail("ModelAccessor can't grant access to this ViewModel", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:690"); //$NON-NLS-1$
	},

	unregisterEntry: function(entry) {
		var element= entry.getElement();
		this.setSelected(entry, false);
		var entrySet= this.fReverseItemMap[element.getIdentifier()];
		if (!(entrySet != null)) Assert.fail("entrySet != null", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:698");
		if (entrySet.length > 1) {
			var entryIndex= dojo.indexOf(entrySet, entry);
			if (!(entryIndex !== -1)) Assert.fail("entryIndex !== -1", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:702");
			entrySet.splice(entryIndex, 1);
		} else {
			delete this.fReverseItemMap[element.getIdentifier()];
		}
		this.fTotalEntryCount-= 1;
		if (element instanceof LinkElement) {
			this.unregisterLinkEntry(element.fSource, entry);
			this.unregisterLinkEntry(element.fTarget, entry);
		}
	},

	unregisterLinkEntry: function(element, entry) {
		var entrySet= this.fLinksMap[element.getIdentifier()];
		if (!(entrySet != null)) Assert.fail("entrySet != null", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:719");
		if (entrySet.length > 1) {
			var entryIndex= dojo.indexOf(entrySet, entry);
			if (!(entryIndex !== -1)) Assert.fail("entryIndex !== -1", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:723");
			entrySet.splice(entryIndex, 1);
		} else {
			delete this.fLinksMap[element.getIdentifier()];
		}
	},

	doStartUpdate: function() {
		if (!(this.fEndUpdateRunnables == null)) Assert.fail("this.fEndUpdateRunnables == null", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:733");
		this.fEndUpdateRunnables= [];
		this.fModifiedEntries= {};
		this.fSortRequestEntries= {};
	},

	doEndUpdate: function(updateAccessor) {
		var viewerUpdates= [];
		if (this.fRootEntry != null) {
			this.beginSelectionChange();
			try {
				var contentRoot= this.fDomainRootEntries[Domain.Content.getIdentifier()];
				var connectionRoot= this.fDomainRootEntries[Domain.Connection.getIdentifier()];
				this.runPostUpdateRunnables(updateAccessor, true);
				this.filterRecursive(contentRoot, updateAccessor);
				this.executePendingSortRequests(updateAccessor);
				this.runPostUpdateRunnables(updateAccessor, false);
				this.validateColumnInfo(contentRoot, updateAccessor);
				this.updateLinks(updateAccessor);
				if (this.fViewer != null) {
					this.doAcceptModified(dojo.hitch(this, function(entry) {
						return entry.collectUpdates(this.fViewer, viewerUpdates);
					}), contentRoot, true);
					var $subject22= jdojo.getValues(this.fLinksEntries);
					var $length22= $subject22.length;
					for (var $count22= 0; $count22 < $length22; $count22++){
						var links= $subject22[$count22];
						var $subject23= links;
						var $length23= $subject23.length;
						for (var $count23= 0; $count23 < $length23; $count23++){
							var linkEntry= $subject23[$count23];
							linkEntry.collectUpdates(this.fViewer, viewerUpdates);
						}
					}
					connectionRoot.doProcessUpdate(true);
				}
			} finally {
				this.endSelectionChange();
			}
		} else if (this.fViewer != null) {
			viewerUpdates.push(ViewerUpdater.getRefreshRunnable(this.fViewer));
		}
		if (!(this.fEndUpdateRunnables != null)) Assert.fail("this.fEndUpdateRunnables != null", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:780");
		if (this.fViewer != null) {
			Array.prototype.push.apply(viewerUpdates, this.fEndUpdateRunnables);
		}
		this.fEndUpdateRunnables= null;
		this.fModifiedEntries= null;
		this.fSortRequestEntries= null;
		return viewerUpdates;
	},

	updateLinks: function(updateAccessor) {
		if (!(jdojo.implementsInterface(this.fModelTransformer, "com.ibm.team.rtc.foundation.api.ui.model.IViewModelLinkProvider"))) 
			return ;
		var linkProvider= this.fModelTransformer;
		var $self= this;
		this.doAcceptModified(dojo.hitch(this, function(entry) {
			var element= entry.getElement();
			if (element instanceof LinkElement) {
				if (entry.isAdd()) {
					var linkDescriptors= linkProvider.getLinkEntries(element, updateAccessor);
					var linkEntries= [];
					var $subject24= linkDescriptors;
					var $length24= $subject24.length;
					for (var $count24= 0; $count24 < $length24; $count24++){
						var linkDescriptor= $subject24[$count24];
						linkEntries.push(new LinkEntry(linkDescriptor.source, linkDescriptor.target, linkDescriptor.column, element, $self));
					}
					this.fLinksEntries[entry.getIdentifier()]= linkEntries;
				} else if (entry.isRemove()) {
					var existingEntries= this.fLinksEntries[entry.getIdentifier()];
					var $subject25= existingEntries;
					var $length25= $subject25.length;
					for (var $count25= 0; $count25 < $length25; $count25++){
						var linkEntry= $subject25[$count25];
						linkEntry.remove();
					}
				}
			}
			return true;
		}), this.fDomainRootEntries[Domain.Connection.getIdentifier()], true);
		this.doAcceptModified(dojo.hitch(this, function(entry) {
			var element= entry.getElement();
			var affectedLinkElements= this.fLinksMap[element.getIdentifier()];
			if (affectedLinkElements != null) {
				var $subject26= affectedLinkElements;
				var $length26= $subject26.length;
				for (var $count26= 0; $count26 < $length26; $count26++){
					var affectedLinkElement= $subject26[$count26];
					var currentEntries= this.fLinksEntries[affectedLinkElement.getIdentifier()];
					var obsoleteLinks= {};
					if (currentEntries != null) {
						var $subject27= currentEntries;
						var $length27= $subject27.length;
						for (var $count27= 0; $count27 < $length27; $count27++){
							var currentEntry= $subject27[$count27];
							obsoleteLinks[currentEntry.getIdentifier()]= currentEntry;
						}
					}
					var linkDescriptors= linkProvider.getLinkEntries(affectedLinkElement.getElement(), updateAccessor);
					var $subject28= linkDescriptors;
					var $length28= $subject28.length;
					for (var $count28= 0; $count28 < $length28; $count28++){
						var linkDescriptor= $subject28[$count28];
						var existingEntry= null;
						if (currentEntries != null) {
							var $subject29= currentEntries;
							var $length29= $subject29.length;
							for (var $count29= 0; $count29 < $length29; $count29++){
								var linkEntry= $subject29[$count29];
								var sameSource= linkDescriptor.source === linkEntry.getSource();
								var sameTarget= linkDescriptor.target === linkEntry.getTarget();
								var sameColumn= linkDescriptor.column === linkEntry.getColumn();
								if (sameSource && sameTarget && sameColumn) {
									existingEntry= linkEntry;
									break;
								}
							}
						}
						if (existingEntry == null) {
							if (currentEntries == null) {
								currentEntries= [];
								this.fLinksEntries[affectedLinkElement.getIdentifier()]= currentEntries;
							}
							currentEntries.push(new LinkEntry(linkDescriptor.source, linkDescriptor.target, linkDescriptor.column, element, $self));
						} else {
							delete obsoleteLinks[existingEntry.getIdentifier()];
						}
					}
					var $subject30= jdojo.getProperties(obsoleteLinks);
					var $length30= $subject30.length;
					for (var $count30= 0; $count30 < $length30; $count30++){
						var obsoleteKey= $subject30[$count30];
						obsoleteLinks[obsoleteKey].remove();
					}
				}
			}
			return true;
		}), this.fDomainRootEntries[Domain.Content.getIdentifier()], true);
	},

	runPostUpdateRunnables: function(updateAccessor, isBeforeFiltering) {
		var $subject31= this.getPostUpdateListenerList(isBeforeFiltering).getListeners();
		var $length31= $subject31.length;
		for (var $count31= 0; $count31 < $length31; $count31++){
			var listener= $subject31[$count31];
			try {
				listener(updateAccessor);
			} catch (e) {
				if ((e= e instanceof Exception ? e : new JavaScriptException(e)) instanceof Exception) {
					console.log("postUpdateRunnable failed!"); //$NON-NLS-1$
					console.error(e);
				} else {
					throw e;
				}
			}
		}
	},

	getPostUpdateListenerList: function(beforeFiltering) {
		return beforeFiltering ? this.fPostUpdateBeforeFilterRunnables : this.fPostUpdateAfterFilterRunnables;
	},

	/**
	 *  TODO we filter ALL entries after each update
	 */
	filterRecursive: function(entry, updateAccessor) {
		var hasUnfilteredChildren= false;
		var $subject32= entry.getChildren();
		var $length32= $subject32.length;
		for (var $count32= 0; $count32 < $length32; $count32++){
			var child= $subject32[$count32];
			hasUnfilteredChildren|= !this.filterRecursive(child, updateAccessor);
		}
		var isFiltered= !this.calculateFilterState(entry, updateAccessor);
		if (isFiltered && !hasUnfilteredChildren && entry.isVisible()) {
			entry.hide(updateAccessor);
			delete this.fSelectedEntries[entry.getIdentifier()];
		} else if ((!isFiltered || hasUnfilteredChildren) && !entry.isVisible()) {
			entry.show(updateAccessor);
		}
		if (isFiltered && hasUnfilteredChildren) {
			if (!entry.hasTag(UnfilteredChildrenTag.INSTANCE)) {
				updateAccessor.setTag(entry, UnfilteredChildrenTag.INSTANCE);
			}
		} else if (entry.hasTag(UnfilteredChildrenTag.INSTANCE)) {
			updateAccessor.clearTag(entry, UnfilteredChildrenTag.INSTANCE);
		}
		return isFiltered && !hasUnfilteredChildren;
	},

	executePendingSortRequests: function(updateAccessor) {
		var $subject33= jdojo.getValues(this.fSortRequestEntries);
		var $length33= $subject33.length;
		for (var $count33= 0; $count33 < $length33; $count33++){
			var toSort= $subject33[$count33];
			toSort.doPendingSort(updateAccessor);
		}
	},

	validateColumnInfo: function(entry, updateAccessor) {
		this.doAcceptModified(dojo.hitch(this, function(entry) {
			if (!entry.hasTagOfType(ColumnTag)) {
				var columnInfo= this.fModelTransformer.provideColumnInfo(entry, updateAccessor);
				entry.setTag(columnInfo != null ? columnInfo : ViewModel.COLUMNS_NONE);
			}
			var columnList= null;
			var children= entry.getChildren();
			for (var i= 0; i < children.length; i++){
				var child= children[i];
				var element= child.getElement();
				if (columnList != null) {
					if (!(element instanceof EntryColumn)) Assert.fail("element instanceof EntryColumn", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:939");
					if (!(element.getColumnList() === columnList)) Assert.fail("element.getColumnList() === columnList", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:940");
				} else if (element instanceof EntryColumn) {
					if (!(i === 0)) Assert.fail("i === 0", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:942");
					columnList= element.getColumnList();
				}
			}
			return true;
		}), entry, false);
	},

	resort: function() {
		this.updateModel(dojo.hitch(this, function(updateAccessor) {
			if (this.fRootEntry != null) {
				this.fRootEntry.accept(dojo.hitch(this, function(entry) {
					entry.requestSortChildren(updateAccessor, true);
					return true;
				}), true);
			}
			return null;
		}));
	},

	refilter: function() {
		this.updateModel(dojo.hitch(this, function(updateAccessor) {
			return null;
		}));
	},

	doGetElementEntries: function(element) {
		var result= [];
		if (!(jdojo.implementsInterface(element, "com.ibm.jdojo.util.IMappable"))) Assert.fail("jdojo.implementsInterface(element, \"com.ibm.jdojo.util.IMappable\")", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:981");
		var entries= this.fReverseItemMap[element.getIdentifier()];
		if (entries != null) {
			var $subject34= entries;
			var $length34= $subject34.length;
			for (var $count34= 0; $count34 < $length34; $count34++){
				var entry= $subject34[$count34];
				result.push(entry);
			}
		}
		return result;
	},

	createRootEntries: function(updateAccessor) {
		if (!(this.fRootEntry == null)) Assert.fail("this.fRootEntry == null", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:992");
		if (!(this.fRootColumn == null)) Assert.fail("this.fRootColumn == null", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:993");
		this.fDomainRootEntries= {};
		this.fRootEntry= this.createRootEntry(Domain.Root, updateAccessor);
		this.createRootEntry(Domain.Content, updateAccessor);
		this.createRootEntry(Domain.Connection, updateAccessor);
		this.fLinksMap= {};
		this.fLinksEntries= {};
		this.fRootColumn= new EntryColumn("rtc.viewmodel.root", null, null, null, null, this); //$NON-NLS-1$
	},

	createRootEntry: function(domain, updateAccessor) {
		var domainRootEntry= new ViewEntry(this, domain, this.fRootEntry, true);
		this.fDomainRootEntries[domain.getIdentifier()]= domainRootEntry;
		this.registerEntry(domainRootEntry, updateAccessor);
		if (this.fRootEntry != null) {
			this.fRootEntry.add(domainRootEntry, updateAccessor);
		}
		return domainRootEntry;
	},

	doAddEntry: function(domain, path, newElement, updateAccessor) {
		if (Domain.Root === domain) {
			if (!(path.length >= 1 && path[0] instanceof IViewModel.Domain)) Assert.fail("path.length >= 1 && path[0] instanceof IViewModel.Domain", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:1018");
			var pathDomain= path.shift();
			try {
				return this.doAddEntryToDomain(pathDomain, path, newElement, updateAccessor);
			} finally {
				path.unshift(pathDomain);
			}
		} else {
			return this.doAddEntryToDomain(domain, path, newElement, updateAccessor);
		}
	},

	doAddEntryToDomain: function(domain, path, newElement, updateAccessor) {
		var parentCount= path.length;
		path.push(newElement);
		try {
			var pathIndex;
			var currentEntry= null;
			for (pathIndex= path.length - 1; pathIndex >= 0; pathIndex--){
				currentEntry= this.doGetElementEntry(domain, path, pathIndex, path[pathIndex]);
				if (currentEntry != null) 
					break;
			}
			if (currentEntry != null) {
				var existingPathEntry= pathIndex === parentCount ? currentEntry.getParent() : currentEntry;
				while(!existingPathEntry.isRootEntry()){
					existingPathEntry.added(false);
					existingPathEntry= existingPathEntry.getParent();
				}
			} else {
				if (!(pathIndex === -1)) Assert.fail("pathIndex === -1", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:1052");
				currentEntry= this.fDomainRootEntries[domain.getIdentifier()];
			}
			for (pathIndex++; pathIndex < path.length; pathIndex++){
				if (path[pathIndex] instanceof EntryColumn) {
					var columns= path[pathIndex].getColumnList().getColumns(updateAccessor);
					var $subject35= columns;
					var $length35= $subject35.length;
					for (var $count35= 0; $count35 < $length35; $count35++){
						var entryColumn= $subject35[$count35];
						this.createEntry(entryColumn, currentEntry, updateAccessor);
					}
					currentEntry= this.getExistingEntry(currentEntry, path[pathIndex]);
				} else {
					currentEntry= this.createEntry(path[pathIndex], currentEntry, updateAccessor);
				}
				if (pathIndex < parentCount) {
					currentEntry.added(false);
				}
				currentEntry.requestSortChildren(updateAccessor, false);
			}
			currentEntry.added(true);
			return currentEntry;
		} finally {
			path.pop();
		}
	},

	doGetElementEntry: function(domain, path, pathEnd, element) {
		if (!(pathEnd <= path.length)) Assert.fail("pathEnd <= path.length", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:1085");
		var candidateEntries= this.doGetElementEntries(element);
		var $subject36= candidateEntries;
		var $length36= $subject36.length;
		for (var $count36= 0; $count36 < $length36; $count36++){
			var candidateEntry= $subject36[$count36];
			var pathEqual= true;
			var chainEntry= candidateEntry.getParent();
			var level= (pathEnd < 0 ? path.length : pathEnd) - 1;
			while(pathEqual && level >= 0 && chainEntry != null){
				pathEqual&= path[level--].getIdentifier() === chainEntry.getElement().getIdentifier();
				chainEntry= chainEntry.getParent();
			}
			if (pathEqual && level === -1 && chainEntry.getParent().isRootEntry() && domain === chainEntry.getElement()) {
				return candidateEntry;
			}
		}
		return null;
	},

	doRemoveElement: function(domain, path, element, updateAccessor) {
		var entry= this.doGetElementEntry(domain, path, -1, element);
		if (entry != null) {
			this.doRemoveEntry(entry, updateAccessor);
			return true;
		}
		return false;
	},

	doRemoveEntry: function(entry, updateAccessor) {
		if (!(entry != null)) Assert.fail("entry != null", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:1115");
		this.beginSelectionChange();
		try {
			var toRemove= entry;
			while(toRemove != null && !toRemove.isRootEntry()){
				toRemove.removed(toRemove === entry);
				toRemove= toRemove.getParent();
			}
		} finally {
			this.endSelectionChange();
		}
	},

	doReparentEntry: function(entry, path, updateAccessor) {
		var parent= entry;
		while(!parent.isRootEntry()){
			parent= parent.getParent();
		}
		for (var i= 0; i < path.length; i++){
			parent= this.getExistingEntry(parent, path[i]);
			if (!(parent != null)) Assert.fail("parent != null", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:1139");
		}
		return this.doReparentEntryImpl(entry, parent, updateAccessor);
	},

	doReparentEntryImpl: function(entry, parent, updateAccessor) {
		var i;
		var newEntry= entry.copy(parent);
		this.registerEntry(newEntry.entry, updateAccessor);
		parent.add(newEntry.entry, updateAccessor);
		var candidate= newEntry.entry;
		while(candidate != null){
			for (i= 0; i < newEntry.count; i++){
				candidate.added(newEntry.entry === candidate);
			}
			candidate= candidate.getParent();
		}
		var children= parent.getChildren();
		for (i= 0; i < children.length; i++){
			this.doReparentEntryImpl(children[i], newEntry.entry, updateAccessor);
		}
		for (i= 0; i < newEntry.count; i++){
			this.doRemoveEntry(entry, updateAccessor);
		}
		return newEntry.entry;
	},

	getExistingEntry: function(parent, element) {
		var children= parent.getChildren();
		for (var i= 0; i < children.length; i++){
			if (element.getIdentifier() === children[i].getElement().getIdentifier()) {
				return children[i];
			}
		}
		return null;
	},

	createEntry: function(element, parent, updateAccessor) {
		var childEntry= new ViewEntry(this, element, parent, false);
		this.registerEntry(childEntry, updateAccessor);
		if (parent != null) {
			parent.add(childEntry, updateAccessor);
		}
		return childEntry;
	},

	registerEntry: function(entry, updateAccessor) {
		var element= entry.getElement();
		var entrySet= this.fReverseItemMap[element.getIdentifier()];
		if (!(element.getIdentifier() in this.fReverseItemMap)) {
			entrySet= [];
			this.fReverseItemMap[element.getIdentifier()]= entrySet;
		}
		this.registerEntryModification(entry);
		if (entry.hasPendingSort()) {
			this.registerEntrySortRequest(entry);
		}
		if (!(entrySet != null)) Assert.fail("entrySet != null", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:1207");
		entrySet.push(entry);
		this.fTotalEntryCount+= 1;
		if (element instanceof LinkElement) {
			this.registerLinkEntry(element.fSource, entry);
			this.registerLinkEntry(element.fTarget, entry);
		}
	},

	registerLinkEntry: function(element, entry) {
		var entrySet= this.fLinksMap[element.getIdentifier()];
		if (entrySet == null) {
			entrySet= [];
			this.fLinksMap[element.getIdentifier()]= entrySet;
		}
		entrySet.push(entry);
	},

	doAcceptModified: function(visitor, startEntry, visitDeleted) {
		if (this.fModifiedEntries == null) {
			startEntry.accept(dojo.hitch(this, function(entry) {
				if (entry.hasUpdates()) {
					return visitor(entry);
				}
				return true;
			}), visitDeleted);
		} else {
			var modifiedEntries= jdojo.getValues(this.fModifiedEntries);
			var sortKeys= {};
			var $subject37= modifiedEntries;
			var $length37= $subject37.length;
			for (var $count37= 0; $count37 < $length37; $count37++){
				var modifiedEntry= $subject37[$count37];
				var sortKey= [];
				var keyEntry= modifiedEntry;
				while(keyEntry != null){
					sortKey.push(keyEntry.getOwnIndex());
					keyEntry= keyEntry.getParent();
				}
				sortKeys[modifiedEntry.getIdentifier()]= sortKey.reverse();
			}
			modifiedEntries.sort(dojo.hitch(this, function(left, right) {
				var leftKey= sortKeys[left.getIdentifier()];
				var rightKey= sortKeys[right.getIdentifier()];
				var leftLength= leftKey.length;
				var rightLength= rightKey.length;
				for (var i= 0; i < leftLength && i < rightLength; i++){
					var leftValue= leftKey[i];
					var rightValue= rightKey[i];
					if (leftValue !== rightValue) 
						return leftValue - rightValue;
				}
				return leftLength - rightLength;
			}));
			var skipEntry= null;
			var $subject38= modifiedEntries;
			var $length38= $subject38.length;
			for (var $count38= 0; $count38 < $length38; $count38++){
				var modifiedEntry= $subject38[$count38];
				if (modifiedEntry.isDisposed() || (!visitDeleted && modifiedEntry.isRemove())) {
					continue;
				}
				if (skipEntry != null) {
					var shouldSkip= false;
					var candidate= modifiedEntry;
					while(candidate != null){
						if (candidate === skipEntry) {
							shouldSkip= true;
							break;
						}
						candidate= candidate.getParent();
					}
					if (shouldSkip) {
						continue;
					}
					skipEntry= null;
				}
				if (!visitor(modifiedEntry)) {
					skipEntry= modifiedEntry;
				}
			}
		}
	},

	createUpdateAccessor: function() {
		return new UpdateAccessor(this);
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.model.IViewModel': true //$NON-NLS-1$
	}
});

ViewModel.COLUMNS_NONE= new ColumnTag(null, null);
var LimitedModelAccessor= dojo.declare("com.ibm.team.rtc.foundation.web.ui.model.ViewModel.LimitedModelAccessor", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fViewModel: null,

	fIsAccessGranted: null,

	constructor: function(viewModel) {
		this.fIsAccessGranted= true;
		this.fViewModel= viewModel;
	},

	grantAccess: function() {
		this.fIsAccessGranted= true;
	},

	revokeAccess: function() {
		this.fIsAccessGranted= false;
	},

	checkAccess: function(entry) {
		if (!(this.fIsAccessGranted)) Assert.fail("The model access has been revoked", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:1334"); //$NON-NLS-1$
		if (!(entry == null || this.fViewModel === entry.getModel())) Assert.fail("ModelAccessor can't grant access to this ViewEntry", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:1335"); //$NON-NLS-1$
	},

	executeUnlocked: function(code) {
		this.checkAccess(null);
		this.fIsAccessGranted= false;
		try {
			return code();
		} finally {
			this.fIsAccessGranted= true;
		}
	}
});
var ReadAccessor= dojo.declare("com.ibm.team.rtc.foundation.web.ui.model.ViewModel.ReadAccessor", LimitedModelAccessor, { //$NON-NLS-1$

	fVisibleEntryNavigator: null,

	fAllEntryNavigator: null,

	constructor: function(viewModel) {
		this.inherited(arguments, [viewModel]);
	},

	clearEntryNavigators: function() {
		this.fVisibleEntryNavigator= null;
		this.fAllEntryNavigator= null;
	},

	getEntryNavigator: function(navigateVisibleOnly) {
		this.checkAccess(null);
		var result= navigateVisibleOnly ? this.fVisibleEntryNavigator : this.fAllEntryNavigator;
		if (result == null) {
			result= new EntryNavigator(this, navigateVisibleOnly ? ReadAccessor.fInvisibleFilter : null);
			if (navigateVisibleOnly) {
				this.fVisibleEntryNavigator= result;
			} else {
				this.fAllEntryNavigator= result;
			}
		}
		return result;
	},

	getFilterEntryNavigator: function(filter) {
		return new EntryNavigator(this, filter);
	},

	accept: function(visitor, startEntry) {
		if (startEntry != null) {
			this.checkAccess(startEntry);
			startEntry.accept(visitor, false);
		} else {
			this.checkAccess(null);
			if (this.fViewModel.fRootEntry != null) 
				this.fViewModel.fRootEntry.accept(visitor, false);
		}
	},

	getRootEntry: function(domain) {
		this.checkAccess(null);
		return this.fViewModel.fDomainRootEntries[domain.getIdentifier()];
	},

	getRootColumn: function() {
		this.checkAccess(null);
		return this.fViewModel.fRootColumn;
	},

	containsElement: function(element) {
		this.checkAccess(null);
		if (!(jdojo.implementsInterface(element, "com.ibm.jdojo.util.IMappable"))) Assert.fail("jdojo.implementsInterface(element, \"com.ibm.jdojo.util.IMappable\")", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:1412");
		return (element.getIdentifier() in this.fViewModel.fReverseItemMap);
	},

	getElementEntries: function(element) {
		this.checkAccess(null);
		if (!(jdojo.implementsInterface(element, "com.ibm.jdojo.util.IMappable"))) Assert.fail("jdojo.implementsInterface(element, \"com.ibm.jdojo.util.IMappable\")", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:1418");
		return this.fViewModel.doGetElementEntries(element);
	},

	getElementEntry: function(domain, path, element) {
		this.checkAccess(null);
		if (!(jdojo.implementsInterface(element, "com.ibm.jdojo.util.IMappable"))) Assert.fail("jdojo.implementsInterface(element, \"com.ibm.jdojo.util.IMappable\")", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:1424");
		return this.fViewModel.doGetElementEntry(domain, path, -1, element);
	},

	getParent: function(entry) {
		this.checkAccess(entry);
		return entry.getParent();
	},

	getChildren: function(entry) {
		this.checkAccess(entry);
		return entry.getChildren();
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.model.IViewModelReader': true //$NON-NLS-1$
	}
});

ReadAccessor.fInvisibleFilter= dojo.hitch(this, function(entry) {
	return entry.isVisible();
});
var UpdateAccessor= dojo.declare("com.ibm.team.rtc.foundation.web.ui.model.ViewModel.UpdateAccessor", ReadAccessor, { //$NON-NLS-1$

	constructor: function(viewModel) {
		this.inherited(arguments, [viewModel]);
	},

	addEntry: function(domain, path, element) {
		this.checkAccess(null);
		if (!(jdojo.implementsInterface(element, "com.ibm.jdojo.util.IMappable"))) Assert.fail("jdojo.implementsInterface(element, \"com.ibm.jdojo.util.IMappable\")", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:1447");
		return this.fViewModel.doAddEntry(domain, path, element, this);
	},

	reparentEntry: function(entry, path) {
		this.checkAccess(null);
		if (!(jdojo.implementsInterface(entry.getElement(), "com.ibm.jdojo.util.IMappable"))) Assert.fail("jdojo.implementsInterface(entry.getElement(), \"com.ibm.jdojo.util.IMappable\")", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:1453");
		return this.fViewModel.doReparentEntry(entry, path, this);
	},

	update: function(entry, properties) {
		this.checkAccess(entry);
		entry.update(properties, this);
	},

	setTag: function(entry, tag) {
		this.checkAccess(entry);
		entry.setTag(tag);
	},

	clearTag: function(entry, tag) {
		this.checkAccess(entry);
		entry.clearTag(tag);
	},

	move: function(entry, index) {
		this.checkAccess(entry);
		if (!(!entry.isRootEntry())) Assert.fail("Can't move root item", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:1474"); //$NON-NLS-1$
		entry.getParent().move(entry, index, this);
	},

	requestChildrenSort: function(entry, forceResort) {
		this.checkAccess(entry);
		entry.requestSortChildren(this, forceResort);
	},

	removeElement: function(domain, path, element) {
		this.checkAccess(null);
		return this.fViewModel.doRemoveElement(domain, path, element, this);
	},

	removeEntry: function(entry) {
		this.checkAccess(entry);
		this.fViewModel.doRemoveEntry(entry, this);
	},

	isModified: function(entry) {
		return entry.hasUpdates();
	},

	acceptModified: function(visitor, startEntry) {
		if (startEntry == null) {
			if (this.fViewModel.fRootEntry == null) {
				return ;
			}
			startEntry= this.fViewModel.fRootEntry;
		}
		this.checkAccess(startEntry);
		this.fViewModel.doAcceptModified(visitor, startEntry, false);
	},

	executeAfterUpdate: function(code) {
		this.checkAccess(null);
		if (!(this.fViewModel.fEndUpdateRunnables != null)) Assert.fail("this.fViewModel.fEndUpdateRunnables != null", "com.ibm.team.rtc.foundation.web.ui.model.ViewModel:1511");
		this.fViewModel.fEndUpdateRunnables.push(code);
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.model.IViewModelUpdater': true //$NON-NLS-1$
	}
});

})();
