/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008, 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.policy.internal.AbstractPolicy"); //$NON-NLS-1$
/*
 * This abstract class defines the methods that should be implemented when
 * creating an Policy extension, such as a work item change propagation.
 * 
 * Policies operate as singletons and should not maintain state
 */
dojo.require("com.ibm.team.workitem.web.ui.internal.page.EventTopics");


(function(){
    dojo.declare("com.ibm.team.workitem.web.policy.internal.AbstractPolicy", null, { //$NON-NLS-1$
    	/*
    	 * Constructor is called when the policy is created, when the page loads.
         * policySpec
         *   policy: (String) id of the action class
         */
        constructor: function(){
			this.subscribeToEvents();
        },
        /*
         * Subscribe to events
         */
        subscribeToEvents: function() {
        	// this.subscribeToWorkItemCreatedEvent();
        	// to be overridden
        },
        subscribeToWorkItemCreatedEvent: function() {
        	dojo.subscribe(com.ibm.team.workitem.web.ui.internal.page.EventTopics.WORKITEM_CREATED, dojo.hitch(this, this.onWorkItemCreated));
        	// No need to destroy the handle as the policy is a long-living singleton
        },
        onWorkItemCreated: function(workingCopy) {
        	// to be overridden
        },
        _sentinal: true
    });
    
})();
