/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.toolbar.ActionItemManager"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle"); //$NON-NLS-1$

(function() {
var ItemStyle= com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle;

dojo.declare("com.ibm.team.rtc.foundation.web.ui.toolbar.ActionItemManager", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fItems: null,

	fDirty: null,

	constructor: function() {
		this.fItems= [];
		this.fDirty= false;
	},

	addItem: function(item) {
		this.addItemAt(-1, item);
	},

	addItemAt: function(index, item) {
		if (index >= 0) 
			index= Math.min(index, this.fItems.length);
		if (index < 0 || index >= this.fItems.length) {
			this.fItems.push(item);
		} else {
			this.fItems.splice(index, 0, item);
		}
		this.fDirty= true;
	},

	addItemsAt: function(index, items) {
		if (index >= 0) 
			index= Math.min(index, this.fItems.length);
		var $subject= items;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var item= $subject[$count];
			this.addItemAt(index, item);
			if (index >= 0) 
				index++;
		}
	},

	addItemWithPath: function(path, item) {
		this.addItemAt(this.computeIndex(path), item);
	},

	addItemsWithPath: function(path, items) {
		this.addItemsAt(this.computeIndex(path), items);
	},

	removeItemWithID: function(id) {
		for (var i= 0; i < this.fItems.length; i++){
			if ((this.fItems[i].getId() === id)) {
				this.fItems.splice(i, 1);
				this.fDirty= true;
				return ;
			}
		}
	},

	removeItem: function(item) {
		this.removeItemWithID(item.getId());
	},

	isEmpty: function() {
		return this.fItems.length === 0;
	},

	computeIndex: function(path) {
		var index= this.fItems.length;
		if (path == null) {
		} else if (path != null && path.length === 0) {
			index= 0;
		} else {
			for (var i= 0; i < this.fItems.length; i++){
				var item= this.fItems[i];
				if ((path === item.getId())) {
					var style= item.getStyle();
					if (style === ItemStyle.SEPARATOR || style === ItemStyle.GROUP) {
						for (var y= i + 1; y < this.fItems.length; y++){
							item= this.fItems[y];
							style= item.getStyle();
							if (style === ItemStyle.SEPARATOR || style === ItemStyle.GROUP) {
								index= y;
								break;
							}
						}
						break;
					} else {
						index= i + 1;
						break;
					}
				}
			}
		}
		return index;
	},

	getItem: function(id) {
		for (var i= 0; i < this.fItems.length; i++){
			var item= this.fItems[i];
			if (item.getId() === id) 
				return item;
		}
		return null;
	},

	isDirty: function() {
		return this.fDirty;
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.actions.IActionItemManager': true //$NON-NLS-1$
	}
});

})();
