/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.toolbar.DeferredToolBarActionItem"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Exception"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.lang.JavaScriptException"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.Property"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.actions.AbstractAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.util.ListenerList"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dojo.string"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.rtc.foundation.web.ui.toolbar", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var Exception= com.ibm.jdojo.lang.Exception;
var JavaScriptException= com.ibm.jdojo.lang.JavaScriptException;
var jdojo= com.ibm.jdojo.lang.Runtime;
var ItemStyle= com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle;
var Property= com.ibm.team.rtc.foundation.api.ui.actions.Property;
var AbstractAction= com.ibm.team.rtc.foundation.web.ui.actions.AbstractAction;
var Messages= dojo.i18n.getLocalization("com.ibm.team.rtc.foundation.web.ui.toolbar", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
var ListenerList= com.ibm.team.rtc.foundation.web.ui.util.ListenerList;
var string= dojo.string;

dojo.declare("com.ibm.team.rtc.foundation.web.ui.toolbar.DeferredToolBarActionItem", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fViewPart: null,

	fId: null,

	fName: null,

	fImplementation: null,

	fIconUrl: null,

	fInstance: null,

	fPropertyListener: null,

	constructor: function(viewPart, namespace, id, name, iconUrl, implementation) {
		this.fPropertyListener= new ListenerList();
		this.fViewPart= viewPart;
		this.fId= id;
		this.fName= name;
		this.fImplementation= implementation;
		var contextRoot= dojo.getObject("net.jazz.ajax._contextRoot"); //$NON-NLS-1$
		var webuiPrefix= dojo.getObject("net.jazz.ajax._webuiPrefix"); //$NON-NLS-1$
		this.fIconUrl= String(contextRoot) + String(webuiPrefix) + namespace + "/" + iconUrl; //$NON-NLS-1$
		this.fInstance= null;
	},

	canHandle: function() {
		if (this.fInstance != null) {
			return this.fInstance.canHandle();
		}
		return true;
	},

	getIconUrl: function() {
		return this.fIconUrl;
	},

	getId: function() {
		return this.fId;
	},

	getName: function() {
		return this.fName;
	},

	showCannotExecutePopup: function() {
		var message= string.substitute(Messages.DeferredToolBarActionItem_CANNOT_EXECUTE_ACTION, [this.fName ]);
		window.alert(message);
	},

	handle: function() {
		if (this.fInstance == null) {
			var $this= this;
			var previousChecked= this.isChecked();
			var previousCanHandle= this.canHandle();
			try {
				this.firePropertyChangeEvent(Property.Enabled, false);
				jdojo.newInstanceByName(this.fImplementation, dojo.hitch(this, function(instance) {
					this.firePropertyChangeEvent(Property.Enabled, previousCanHandle);
					this.fInstance= instance;
					if (jdojo.implementsInterface(this.fInstance, "com.ibm.team.rtc.foundation.api.ui.actions.IPropertyChangeEventProvider")) {
						this.fInstance.addPropertyListener($this);
					}
					if (previousChecked !== this.isChecked()) {
						this.firePropertyChangeEvent(Property.Checked, this.isChecked());
					}
					if (previousCanHandle !== this.canHandle()) {
						this.firePropertyChangeEvent(Property.Enabled, this.canHandle());
					}
					if (!this.canHandle()) {
						this.showCannotExecutePopup();
						return ;
					}
					this.fInstance.handle();
				}), this.fViewPart);
			} catch (e) {
				if ((e= e instanceof Exception ? e : new JavaScriptException(e)) instanceof Exception) {
					this.showCannotExecutePopup();
					return ;
				} else {
					throw e;
				}
			}
		} else {
			this.fInstance.handle();
		}
	},

	getStyle: function() {
		return ItemStyle.FLAT;
	},

	isChecked: function() {
		if (this.fInstance != null && this.fInstance instanceof AbstractAction) {
			return this.fInstance.isChecked();
		}
		return false;
	},

	addPropertyListener: function(listener) {
		this.fPropertyListener.addListener(listener);
	},

	removePropertyListener: function(listener) {
		this.fPropertyListener.removeListener(listener);
	},

	firePropertyChangeEvent: function(property, newValue) {
		var $subject= this.fPropertyListener.getListeners();
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var listener= $subject[$count];
			listener.onPropertyChange(this, property, newValue);
		}
	},

	onPropertyChange: function(source, property, newValue) {
		this.firePropertyChangeEvent(property, newValue);
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.actions.IAbstractItem': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.api.ui.actions.IAction': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.api.ui.actions.IPropertyChangeEventProvider': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.api.ui.actions.IPropertyListener': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.api.ui.actions.IToolBarItem': true //$NON-NLS-1$
	}
});

})();
