/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.toolbar.PopupMenu"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.IPopupMenuManager"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.Property"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.widgets.IconUrlMenuItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.widgets.JDeferredPopupMenuItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.widgets.JPopupMenuItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.widgets.SectionMenuItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.widgets.ToolbarMenuItem"); //$NON-NLS-1$
dojo.require("dijit.CheckedMenuItem"); //$NON-NLS-1$
dojo.require("dijit.MenuItem"); //$NON-NLS-1$
dojo.require("dijit.MenuSeparator"); //$NON-NLS-1$
dojo.require("jazz.ui.Menu"); //$NON-NLS-1$

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var Assert= com.ibm.jdojo.util.Assert;
var Properties= com.ibm.team.rtc.foundation.api.ui.actions.IPopupMenuManager.Properties;
var ItemStyle= com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle;
var Property= com.ibm.team.rtc.foundation.api.ui.actions.Property;
var IconUrlMenuItem= com.ibm.team.rtc.foundation.web.ui.widgets.IconUrlMenuItem;
var JDeferredPopupMenuItem= com.ibm.team.rtc.foundation.web.ui.widgets.JDeferredPopupMenuItem;
var JPopupMenuItem= com.ibm.team.rtc.foundation.web.ui.widgets.JPopupMenuItem;
var SectionMenuItem= com.ibm.team.rtc.foundation.web.ui.widgets.SectionMenuItem;
var ToolbarMenuItem= com.ibm.team.rtc.foundation.web.ui.widgets.ToolbarMenuItem;
var CheckedMenuItem= dijit.CheckedMenuItem;
var MenuItem= dijit.MenuItem;
var MenuSeparator= dijit.MenuSeparator;
var Menu= jazz.ui.Menu;

var PopupMenu= dojo.declare("com.ibm.team.rtc.foundation.web.ui.toolbar.PopupMenu", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fManager: null,

	fItemIdToWidget: null,

	constructor: function(manager) {
		this.fItemIdToWidget= {};
		this.fManager= manager;
	},

	create: function() {
		return this.internalCreateMenu(this.fManager);
	},

	onPropertyChange: function(source, property, newValue) {
		var widget= this.fItemIdToWidget[source.getId()];
		if (widget != null) {
			switch(property) {
				case Property.Enabled:
					this.updateEnabled(widget, newValue);
					break;
				case Property.Name:
					this.updateName(widget, newValue);
					break;
				case Property.Checked:
					this.updateChecked(widget, newValue);
			}
		}
	},

	updateName: function(widget, newValue) {
		if (widget instanceof MenuItem) {
			widget.attr("label", newValue); //$NON-NLS-1$
		}
	},

	updateEnabled: function(widget, enabled) {
		if (widget instanceof MenuItem) {
			widget.attr("disabled", !enabled); //$NON-NLS-1$
		}
	},

	updateChecked: function(widget, checked) {
		if (widget instanceof MenuItem) {
			widget.attr("checked", checked); //$NON-NLS-1$
		}
	},

	internalCreateMenu: function(manager) {
		var result= new Menu();
		var items= manager.getItems();
		var $subject3= items;
		var $length3= $subject3.length;
		for (var $count3= 0; $count3 < $length3; $count3++){
			var item= $subject3[$count3];
			var menuItem= this.createMenuItem(item);
			if (menuItem != null) {
				result.addChild(menuItem);
			}
		}
		return result;
	},

	createMenuItem: function(item) {
		var result= null;
		if (PopupMenu.hasStyle(item, ItemStyle.FLAT | ItemStyle.DROP_DOWN)) {
			result= PopupMenu.createSubMenuAsToolbar(item);
		} else if (PopupMenu.hasStyle(item, ItemStyle.FLAT)) {
			result= PopupMenu.createActionMenuItem(item);
		} else if (PopupMenu.hasStyle(item, ItemStyle.PUSH)) {
			result= PopupMenu.createActionMenuItem(item);
		} else if (PopupMenu.hasStyle(item, ItemStyle.TOGGLE)) {
			result= PopupMenu.createCheckBoxActionMenuItem(item);
		} else if (PopupMenu.hasStyle(item, ItemStyle.DROP_DOWN)) {
			result= this.createSubMenu(item);
		} else if (PopupMenu.hasStyle(item, ItemStyle.SEPARATOR | ItemStyle.TEXT)) {
			result= PopupMenu.createGroupMenuItem(item);
		} else if (PopupMenu.hasStyle(item, ItemStyle.TEXT)) {
			result= PopupMenu.createActionMenuItem(item);
		} else if (PopupMenu.hasStyle(item, ItemStyle.SEPARATOR)) {
			result= new MenuSeparator();
		}
		if (result != null && jdojo.implementsInterface(item, "com.ibm.team.rtc.foundation.api.ui.actions.IPropertyChangeEventProvider")) {
			item.addPropertyListener(this);
			this.fItemIdToWidget[item.getId()]= result;
		}
		return result;
	},

	createSubMenu: function(item) {
		if (!(jdojo.implementsInterface(item, "com.ibm.team.rtc.foundation.api.ui.actions.IPopupMenuItem"))) {
			return PopupMenu.createActionMenuItem(item);
		}
		var manager= item.getPopupMenu();
		var isDeferred= jdojo.implementsInterface(manager, "com.ibm.team.rtc.foundation.api.ui.actions.IDeferredPopupMenuManager");
		if (!isDeferred && (manager == null || manager.isEmpty())) {
			return PopupMenu.createActionMenuItem(item);
		}
		var subMenu= this.internalCreateMenu(manager);
		var name= jazz.util.html.escape(item.getName());
		var iconUrl= item.getIconUrl();
		if (isDeferred) {
			manager.addPropertyListener(new DeferredMenuListener(this, subMenu));
			return new JDeferredPopupMenuItem({label: name, iconUrl: iconUrl, manager: manager, popup: subMenu});
		} else {
			return new JPopupMenuItem({label: name, iconUrl: iconUrl, popup: subMenu});
		}
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.actions.IPropertyListener': true //$NON-NLS-1$
	}
});

PopupMenu.createSubMenuAsToolbar= function(item) {
	if (!(jdojo.implementsInterface(item, "com.ibm.team.rtc.foundation.api.ui.actions.IPopupMenuItem"))) Assert.fail("jdojo.implementsInterface(item, \"com.ibm.team.rtc.foundation.api.ui.actions.IPopupMenuItem\")", "com.ibm.team.rtc.foundation.web.ui.toolbar.PopupMenu:161");
	var popupMenuItem= item;
	var result= new ToolbarMenuItem({label: item.getName(), iconUrl: item.getIconUrl(), popupMenuManager: popupMenuItem.getPopupMenu()});
	result.onClick= dojo.hitch(this, function(event) {
		if (result.isEventHandled(event)) {
			dojo.stopEvent(event);
		} else {
			var defaultAction= popupMenuItem.getDefaultAction();
			if (defaultAction != null && defaultAction.canHandle()) {
				defaultAction.handle();
			}
		}
	});
	return result;
};
PopupMenu.createGroupMenuItem= function(item) {
	return new SectionMenuItem({label: item.getName()});
};
PopupMenu.createActionMenuItem= function(item) {
	var result= new IconUrlMenuItem({label: jazz.util.html.escape(item.getName()), iconUrl: item.getIconUrl()});
	result.attr("disabled", !item.canHandle()); //$NON-NLS-1$
	result.onClick= dojo.hitch(this, function(event) {
		event.preventDefault();
		item.handle();
	});
	return result;
};
PopupMenu.createCheckBoxActionMenuItem= function(item) {
	var params= {label: jazz.util.html.escape(item.getName()), checked: item.isChecked(), onChange: dojo.hitch(this, function(checked) {
		item.handle();
	})};
	return new CheckedMenuItem(params);
};
PopupMenu.hasStyle= function(item, style) {
	return (item.getStyle() & style) === style;
};
var DeferredMenuListener= dojo.declare("com.ibm.team.rtc.foundation.web.ui.toolbar.PopupMenu.DeferredMenuListener", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fOuter: null,

	fMenu: null,

	constructor: function(outer, menu) {
		this.fOuter= outer;
		this.fMenu= menu;
	},

	onPropertyChange: function(source, property, newValue) {
		if (Properties.ITEMS !== property) {
			return ;
		}
		var $subject= this.fMenu.getChildren();
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var widget= $subject[$count];
			this.fMenu.removeChild(widget);
		}
		var items= source.getItems();
		var $subject2= items;
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var item= $subject2[$count2];
			var menuItem= this.fOuter.createMenuItem(item);
			if (menuItem != null) {
				this.fMenu.addChild(menuItem);
			}
		}
		if (this.fMenu.hasChildren()) {
			this.fMenu.focus();
		}
		source.removePropertyListener(this);
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.actions.IPropertyListener': true //$NON-NLS-1$
	}
});

})();
