/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.toolbar.SimplePopupMenuManager"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.IPopupMenuManager"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.actions.ActionItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.toolbar.ActionItemManager"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.util.ListenerList"); //$NON-NLS-1$

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var Properties= com.ibm.team.rtc.foundation.api.ui.actions.IPopupMenuManager.Properties;
var ItemStyle= com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle;
var ActionItem= com.ibm.team.rtc.foundation.web.ui.actions.ActionItem;
var ActionItemManager= com.ibm.team.rtc.foundation.web.ui.toolbar.ActionItemManager;
var ListenerList= com.ibm.team.rtc.foundation.web.ui.util.ListenerList;

dojo.declare("com.ibm.team.rtc.foundation.web.ui.toolbar.SimplePopupMenuManager", ActionItemManager, { //$NON-NLS-1$

	constructor: function() {
		this.inherited(arguments, []);
	},

	addAction: function(action) {
		if (jdojo.implementsInterface(action, "com.ibm.team.rtc.foundation.api.ui.actions.IMenuItem")) {
			this.addItem(action);
		} else {
			this.addItem(new ActionItem(action));
		}
	},

	addActionAt: function(index, action) {
		if (jdojo.implementsInterface(action, "com.ibm.team.rtc.foundation.api.ui.actions.IMenuItem")) {
			this.addItemAt(index, action);
		} else {
			this.addItemAt(index, new ActionItem(action));
		}
	},

	addActionsAt: function(index, actions) {
		var items= [];
		var $subject= actions;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var action= $subject[$count];
			if (jdojo.implementsInterface(action, "com.ibm.team.rtc.foundation.api.ui.actions.IMenuItem")) {
				items.push(action);
			} else {
				items.push(new ActionItem(action));
			}
		}
		this.addItemsAt(index, items);
	},

	addActionWithPath: function(path, action) {
		if (jdojo.implementsInterface(action, "com.ibm.team.rtc.foundation.api.ui.actions.IMenuItem")) {
			this.addItemWithPath(path, action);
		} else {
			this.addItemWithPath(path, new ActionItem(action));
		}
	},

	addActionsWithPath: function(path, actions) {
		var items= [];
		var $subject2= actions;
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var action= $subject2[$count2];
			if (jdojo.implementsInterface(action, "com.ibm.team.rtc.foundation.api.ui.actions.IMenuItem")) {
				items.push(action);
			} else {
				items.push(new ActionItem(action));
			}
		}
		this.addItemsWithPath(path, items);
	},

	getItems: function() {
		var result= [];
		var lastItemIsSeparator= false;
		for (var i= 0; i < this.fItems.length; i++){
			var item= this.fItems[i];
			switch(item.getStyle()) {
				case ItemStyle.GROUP:
					continue;
				case ItemStyle.SEPARATOR:
					if (i === 0 || i === this.fItems.length - 1 || lastItemIsSeparator) {
						lastItemIsSeparator= true;
						continue;
					}
					result.push(item);
					lastItemIsSeparator= true;
					break;
				default:
					lastItemIsSeparator= false;
					result.push(item);
			}
		}
		return result;
	},

	update: function() {
		this.firePropertyChangeEvent(Properties.ITEMS, this.fItems);
	},

	fPropertyListener: null,

	addPropertyListener: function(listener) {
		if (this.fPropertyListener == null) 
			this.fPropertyListener= new ListenerList();
		this.fPropertyListener.addListener(listener);
	},

	removePropertyListener: function(listener) {
		if (this.fPropertyListener == null) 
			return ;
		this.fPropertyListener.removeListener(listener);
	},

	firePropertyChangeEvent: function(property, newValue) {
		if (this.fPropertyListener == null) 
			return ;
		var $subject3= this.fPropertyListener.getListeners();
		var $length3= $subject3.length;
		for (var $count3= 0; $count3 < $length3; $count3++){
			var listener= $subject3[$count3];
			listener.onPropertyChange(this, property, newValue);
		}
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.actions.IPopupMenuManager': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.api.ui.actions.IPropertyChangeEventProvider': true //$NON-NLS-1$
	}
});

})();
