/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.toolbar.SimpleToolbarManager"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.Property"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.actions.ActionItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.widgets.AbstractFormWidget"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.widgets.ActionLink"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.widgets.CheckBox"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.widgets.DropDownButton"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.widgets.IconUrlMenuItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.widgets.PushButton"); //$NON-NLS-1$
dojo.require("dijit.MenuSeparator"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("jazz.ui.SimpleToolbar"); //$NON-NLS-1$

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var ItemStyle= com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle;
var Property= com.ibm.team.rtc.foundation.api.ui.actions.Property;
var ActionItem= com.ibm.team.rtc.foundation.web.ui.actions.ActionItem;
var AbstractFormWidget= com.ibm.team.rtc.foundation.web.ui.widgets.AbstractFormWidget;
var ActionLink= com.ibm.team.rtc.foundation.web.ui.widgets.ActionLink;
var CheckBox= com.ibm.team.rtc.foundation.web.ui.widgets.CheckBox;
var DropDownButton= com.ibm.team.rtc.foundation.web.ui.widgets.DropDownButton;
var IconUrlMenuItem= com.ibm.team.rtc.foundation.web.ui.widgets.IconUrlMenuItem;
var PushButton= com.ibm.team.rtc.foundation.web.ui.widgets.PushButton;
var MenuSeparator= dijit.MenuSeparator;
var _Widget= dijit._Widget;
var SimpleToolbar= jazz.ui.SimpleToolbar;

var SimpleToolbarManager= dojo.declare("com.ibm.team.rtc.foundation.web.ui.toolbar.SimpleToolbarManager", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fItems: null,

	fActionIdToObject: null,

	fToolbar: null,

	constructor: function() {
		this.fItems= [];
		this.fActionIdToObject= {};
	},

	addItem: function(item) {
		this.addItemAt(-1, item);
	},

	addItemAt: function(index, item) {
		if (index >= 0) 
			index= Math.min(index, this.fItems.length);
		if (index < 0 || index >= this.fItems.length) {
			this.fItems.push(item);
		} else {
			this.fItems.splice(index, 0, item);
		}
		if (jdojo.implementsInterface(item, "com.ibm.team.rtc.foundation.api.ui.actions.IPropertyChangeEventProvider")) {
			item.addPropertyListener(this);
		}
		if (this.fToolbar != null) {
			this.createWidgetForAction(item, index);
		}
	},

	addItemsAt: function(index, items) {
		if (index >= 0) 
			index= Math.min(index, this.fItems.length);
		var $subject= items;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var item= $subject[$count];
			this.addItemAt(index, item);
			if (index >= 0) 
				index++;
		}
	},

	addItemWithPath: function(path, item) {
		this.addItemAt(this.computeIndex(path), item);
	},

	addItemsWithPath: function(path, items) {
		this.addItemsAt(this.computeIndex(path), items);
	},

	computeIndex: function(path) {
		var index= this.fItems.length;
		if (path == null) {
		} else if (path != null && path.length === 0) {
			index= 0;
		} else {
			for (var i= 0; i < this.fItems.length; i++){
				var item= this.fItems[i];
				if ((path === item.getId())) {
					if (item.getStyle() === ItemStyle.SEPARATOR) {
					} else {
						index= i + 1;
						break;
					}
				}
			}
		}
		return index;
	},

	addAction: function(action) {
		if (jdojo.implementsInterface(action, "com.ibm.team.rtc.foundation.api.ui.actions.IToolBarItem")) {
			this.addItem(action);
		} else {
			this.addItem(new ActionItem(action));
		}
	},

	addActionAt: function(index, action) {
		if (jdojo.implementsInterface(action, "com.ibm.team.rtc.foundation.api.ui.actions.IToolBarItem")) {
			this.addItemAt(index, action);
		} else {
			this.addItemAt(index, new ActionItem(action));
		}
	},

	addActionsAt: function(index, actions) {
		var items= new Array(actions.length);
		var $subject2= actions;
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var action= $subject2[$count2];
			if (jdojo.implementsInterface(action, "com.ibm.team.rtc.foundation.api.ui.actions.IToolBarItem")) {
				items.push(action);
			} else {
				items.push(new ActionItem(action));
			}
		}
		this.addItemsAt(index, items);
	},

	addActionWithPath: function(path, action) {
		if (jdojo.implementsInterface(action, "com.ibm.team.rtc.foundation.api.ui.actions.IToolBarItem")) {
			this.addItemWithPath(path, action);
		} else {
			this.addItemWithPath(path, new ActionItem(action));
		}
	},

	addActionsWithPath: function(path, actions) {
		var items= new Array(actions.length);
		var $subject3= actions;
		var $length3= $subject3.length;
		for (var $count3= 0; $count3 < $length3; $count3++){
			var action= $subject3[$count3];
			if (jdojo.implementsInterface(action, "com.ibm.team.rtc.foundation.api.ui.actions.IToolBarItem")) {
				items.push(action);
			} else {
				items.push(new ActionItem(action));
			}
		}
		this.addItemsWithPath(path, items);
	},

	getAction: function(id) {
		for (var i= 0; i < this.fItems.length; i++){
			var item= this.fItems[i];
			if (item.getId() === id) 
				return item;
		}
		return null;
	},

	getItems: function() {
		return this.fItems;
	},

	destroy: function(preserveDom) {
		var $subject4= jdojo.getProperties(this.fActionIdToObject);
		var $length4= $subject4.length;
		for (var $count4= 0; $count4 < $length4; $count4++){
			var key= $subject4[$count4];
			var o= this.fActionIdToObject[key];
			if (o instanceof _Widget) {
				o.destroy(preserveDom);
			}
		}
		this.fToolbar.destroy(preserveDom);
	},

	createToolbar: function(node) {
		if (this.fToolbar == null) {
			this.fToolbar= new SimpleToolbar();
			dojo.place(this.fToolbar.domNode, node);
			for (var i= 0; i < this.fItems.length; i++){
				var action= this.fItems[i];
				this.createWidgetForAction(action, -1);
			}
		}
		return this.fToolbar;
	},

	createWidgetForAction: function(item, index) {
		if (SimpleToolbarManager.hasStyle(item, ItemStyle.FLAT)) {
			this.addFlatButtonAction(item, index);
		} else if (SimpleToolbarManager.hasStyle(item, ItemStyle.PUSH)) {
			this.addPushButtonAction(item, index);
		} else if (SimpleToolbarManager.hasStyle(item, ItemStyle.TOGGLE)) {
			this.addCheckBoxAction(item, index);
		} else if (SimpleToolbarManager.hasStyle(item, ItemStyle.DROP_DOWN)) {
			this.addPopupMenuItem(item, index);
		} else if (SimpleToolbarManager.hasStyle(item, ItemStyle.TEXT)) {
			this.addLinkAction(item, index);
		} else if (SimpleToolbarManager.hasStyle(item, ItemStyle.SEPARATOR)) {
			this.fToolbar.addSeparator(index >= 0 ? index : null);
		}
	},

	addFlatButtonAction: function(action, index) {
		var args= {};
		args.imgSrc= action.getIconUrl();
		args.label= action.getName();
		args.buttonType= 'simple'; //$NON-NLS-1$
		args.index= index >= 0 ? index : null;
		var widget= this.fToolbar.addButton(null, dojo.hitch(this, function() {
			action.handle();
		}), args);
		this.fActionIdToObject[action.getId()]= widget;
		this.updateEnabled(widget, action.canHandle());
	},

	addPushButtonAction: function(action, index) {
		var params= {};
		params.label= action.getName();
		params.onClickHandler= dojo.hitch(this, function(event) {
			action.handle();
			return false;
		});
		var pushButton= new PushButton(params);
		var args= {};
		args.index= index >= 0 ? index : null;
		this.fToolbar.addWidget(pushButton, args);
		this.fActionIdToObject[action.getId()]= pushButton;
		this.updateEnabled(pushButton, action.canHandle());
	},

	addCheckBoxAction: function(action, index) {
		var params= {};
		params.label= action.getName();
		params.checked= action.isChecked();
		params.onClickHandler= dojo.hitch(this, function(event) {
			action.handle();
			return false;
		});
		var checkbox= new CheckBox(params);
		var args= {};
		args.index= index >= 0 ? index : null;
		this.fToolbar.addWidget(checkbox, args);
		this.fActionIdToObject[action.getId()]= checkbox;
		this.updateEnabled(checkbox, action.canHandle());
	},

	addPopupMenuItem: function(action, index) {
		var params= {fName: action.getName(), fIconUrl: action.getIconUrl()};
		params.fOnActionClick= (jdojo.implementsInterface(action, "com.ibm.team.rtc.foundation.api.ui.actions.IPopupMenuItem")) ? action.getDefaultAction() : action;
		if (jdojo.implementsInterface(action, "com.ibm.team.rtc.foundation.api.ui.actions.IPopupMenuItem")) {
			params.fPopupMenuCreator= dojo.hitch(this, function() {
				return action.getPopupMenu();
			});
		}
		params.fLabel= SimpleToolbarManager.hasStyle(action, ItemStyle.TEXT) ? action.getName() : null;
		var dropDown= new DropDownButton(params);
		var args= {};
		args.index= index >= 0 ? index : null;
		this.fToolbar.addWidget(dropDown, args);
		this.fActionIdToObject[action.getId()]= dropDown;
		this.updateEnabled(dropDown, action.canHandle());
	},

	addLinkAction: function(action, index) {
		var params= {};
		params.label= action.getName();
		params.onClick= dojo.hitch(this, function(event) {
			dojo.stopEvent(event);
			if (action.canHandle()) {
				action.handle();
			}
		});
		var widget= new ActionLink(params);
		var args= {};
		args.index= index >= 0 ? index : null;
		this.fToolbar.addWidget(widget, args);
		this.fActionIdToObject[action.getId()]= widget;
	},

	createMenuItem: function(item) {
		if (item.getStyle() === ItemStyle.SEPARATOR) {
			return new MenuSeparator();
		}
		var menuItem= new IconUrlMenuItem({label: jazz.util.html.escape(item.getName()), iconUrl: item.getIconUrl()});
		menuItem.attr("disabled", !item.canHandle()); //$NON-NLS-1$
		menuItem.onClick= dojo.hitch(this, function(event) {
			event.preventDefault();
			item.handle();
		});
		return menuItem;
	},

	onPropertyChange: function(source, property, newValue) {
		var widget= this.fActionIdToObject[source.getId()];
		if (widget == null) {
			return ;
		}
		switch(property) {
			case Property.Enabled:
				this.updateEnabled(widget, newValue);
				break;
			case Property.Name:
				this.updateName(widget, newValue);
				break;
			case Property.Checked:
				this.updateChecked(widget, newValue);
				break;
		}
	},

	updateName: function(widget, newValue) {
		if (widget instanceof ActionLink) {
			widget.update(Property.Name, newValue);
		} else if (widget instanceof DropDownButton) {
			widget.setLabel(newValue);
		} else {
			var args= {};
			args.label= newValue;
			this.fToolbar.updateButton(widget, args);
		}
	},

	updateEnabled: function(widget, enabled) {
		if (widget instanceof AbstractFormWidget) {
			widget.setEnabled(enabled);
		} else {
			if (enabled) {
				this.fToolbar.enableButton(widget);
			} else {
				this.fToolbar.disableButton(widget);
			}
		}
	},

	updateChecked: function(widget, checked) {
		if (widget instanceof CheckBox) {
			widget.setChecked(checked);
		} else if (widget instanceof DropDownButton) {
			widget.setChecked(checked);
		} else {
			this.fToolbar.setPressed(widget, checked);
		}
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.actions.IPropertyListener': true //$NON-NLS-1$
	}
});

SimpleToolbarManager.hasStyle= function(item, style) {
	return (item.getStyle() & style) === style;
};

})();
