/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.toolbar.ToolBarContributionManager"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.toolbar.DeferredToolBarActionItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.toolbar.Separator"); //$NON-NLS-1$
dojo.require("jazz.core.RegistryFactory"); //$NON-NLS-1$

(function() {
var Assert= com.ibm.jdojo.util.Assert;
var DeferredToolBarActionItem= com.ibm.team.rtc.foundation.web.ui.toolbar.DeferredToolBarActionItem;
var Separator= com.ibm.team.rtc.foundation.web.ui.toolbar.Separator;
var RegistryFactory= jazz.core.RegistryFactory;

var ToolBarContributionManager= dojo.declare("com.ibm.team.rtc.foundation.web.ui.toolbar.ToolBarContributionManager", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fViewPart: null,

	fToolBarId: null,

	fToolBarManager: null,

	constructor: function(part, toolbarManager, toolBarId) {
		this.fViewPart= part;
		this.fToolBarId= toolBarId;
		this.fToolBarManager= toolbarManager;
	},

	addContributions: function() {
		var registry= RegistryFactory.getRegistry();
		var extensionPoint= registry.getExtensionPoint("com.ibm.team.rtc.foundation.web.ui.toolBars"); //$NON-NLS-1$
		if (!(extensionPoint != null)) Assert.fail("extensionPoint != null", "com.ibm.team.rtc.foundation.web.ui.toolbar.ToolBarContributionManager:50");
		var extensions= extensionPoint.getExtensions();
		var $subject= extensions;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var extension= $subject[$count];
			var $subject2= extension.getConfigurationElements();
			var $length2= $subject2.length;
			for (var $count2= 0; $count2 < $length2; $count2++){
				var toolBarContribution= $subject2[$count2];
				if (!(ToolBarContributionManager.TOOL_BAR_CONTRIBUTION === toolBarContribution.getName())) 
					continue;
				if (!(this.fToolBarId === toolBarContribution.getAttribute(ToolBarContributionManager.TOOL_BAR_ID))) 
					continue;
				var $subject3= toolBarContribution.getChildren();
				var $length3= $subject3.length;
				for (var $count3= 0; $count3 < $length3; $count3++){
					var item= $subject3[$count3];
					var name= item.getName();
					if ((ToolBarContributionManager.ACTION_GROUP === name)) {
						var path= item.getAttribute(ToolBarContributionManager.PATH);
						this.fToolBarManager.addItemsWithPath(path, this.processGroup(extension.getNamespace(), item));
					} else if ((ToolBarContributionManager.ACTION_ITEM === name)) {
						var deferred= new DeferredToolBarActionItem(this.fViewPart, extension.getNamespace(), item.getAttribute(ToolBarContributionManager.ACTION_ID), item.getAttribute(ToolBarContributionManager.ACTION_NAME), item.getAttribute(ToolBarContributionManager.ACTION_ICON_URL), item.getAttribute(ToolBarContributionManager.ACTION_IMPLEMENTATION));
						var path= item.getAttribute(ToolBarContributionManager.PATH);
						this.fToolBarManager.addActionWithPath(path, deferred);
					} else if ((ToolBarContributionManager.SEPARATOR_ITEM === name)) {
						var path= item.getAttribute(ToolBarContributionManager.PATH);
						this.fToolBarManager.addItemWithPath(path, new Separator(item.getAttribute(ToolBarContributionManager.ID)));
					}
				}
			}
		}
	},

	processGroup: function(namespace, item) {
		var result= [];
		var $subject4= item.getChildren();
		var $length4= $subject4.length;
		for (var $count4= 0; $count4 < $length4; $count4++){
			var groupItem= $subject4[$count4];
			var name= groupItem.getName();
			if ((ToolBarContributionManager.ACTION_ITEM === name)) {
				var deferred= new DeferredToolBarActionItem(this.fViewPart, namespace, groupItem.getAttribute(ToolBarContributionManager.ACTION_ID), groupItem.getAttribute(ToolBarContributionManager.ACTION_NAME), groupItem.getAttribute(ToolBarContributionManager.ACTION_ICON_URL), groupItem.getAttribute(ToolBarContributionManager.ACTION_IMPLEMENTATION));
				result.push(deferred);
			} else if ((ToolBarContributionManager.SEPARATOR_ITEM === name)) {
				result.push(new Separator(groupItem.getAttribute(ToolBarContributionManager.ID)));
			}
		}
		return result;
	}
});

ToolBarContributionManager.ACTION_GROUP= "actionGroup"; //$NON-NLS-1$
ToolBarContributionManager.SEPARATOR_ITEM= "separator"; //$NON-NLS-1$
ToolBarContributionManager.ACTION_ITEM= "action"; //$NON-NLS-1$
ToolBarContributionManager.TOOL_BAR_CONTRIBUTION= "toolBarContribution"; //$NON-NLS-1$
ToolBarContributionManager.TOOL_BAR_ID= "toolBarId"; //$NON-NLS-1$
ToolBarContributionManager.ID= "id"; //$NON-NLS-1$
ToolBarContributionManager.PATH= "path"; //$NON-NLS-1$
ToolBarContributionManager.ACTION_IMPLEMENTATION= "implementation"; //$NON-NLS-1$
ToolBarContributionManager.ACTION_ICON_URL= "iconUrl"; //$NON-NLS-1$
ToolBarContributionManager.ACTION_NAME= "name"; //$NON-NLS-1$
ToolBarContributionManager.ACTION_ID= "id"; //$NON-NLS-1$

})();
