/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.viewlets.web.ui.internal.WorkItemsGadget");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("jazz.util.format");
dojo.require("jazz.util.i18n");
dojo.require("jazz.ui.OverlayIcon");
dojo.require("jazz.ui.PagedTable");
dojo.require("jazz.ui.ListBox");


//dojo.require("com.ibm.team.workitem.viewlets.web.ui.internal.utils.HoverFloat");
dojo.require("com.ibm.team.workitem.viewlets.web.ui.internal.utils.WorkItemQueryChooser");
dojo.require("com.ibm.team.workitem.viewlets.web.ui.internal.utils.SecondIconChooser");
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemAttributes");
dojo.require("com.ibm.team.workitem.web.client.internal.Constants");
dojo.require("com.ibm.team.workitem.viewlets.web.ui.internal.QueryClient2");
dojo.require("com.ibm.team.workitem.web.client.internal.QueryClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");

dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.team.workitem.viewlets.web.ui.internal", "WorkItemsMessages");

dojo.require("net.jazz.ajax.ui.internal.OpenSocialJazz");

(function() {

var OverlayIcon = jazz.ui.OverlayIcon,

//	HoverFloat = com.ibm.team.workitem.viewlets.web.ui.internal.utils.HoverFloat,
	WorkItemQueryChooserContent = com.ibm.team.workitem.viewlets.web.ui.internal.utils.WorkItemQueryChooserContent,
	SecondIconChooser = com.ibm.team.workitem.viewlets.web.ui.internal.utils.SecondIconChooser,
	WorkItemAttributes = com.ibm.team.workitem.web.client.internal.WorkItemAttributes,
	Constants = com.ibm.team.workitem.web.client.internal.Constants,
	QueryClient2 = com.ibm.team.workitem.viewlets.web.ui.internal.QueryClient2,
	QueryClient = com.ibm.team.workitem.web.client.internal.QueryClient,
	ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler,

	PREF_ID_QUERY = "query",
	PREF_ID_QUERY_CATEGORY = "queryCategory",
	PREF_ID_TITLE = "title",
	PREF_ID_SECOND_ICON = "secondIcon",
	PREF_ID_ITEMS_PER_PAGE = "itemsPerPage",

	IMG_PATH = dojo.moduleUrl("com.ibm.team.workitem.viewlets.web","graphics/work-items/images/"),
	IMG_URL_CLOSED_OVERLAY = IMG_PATH + "wi_complete_ovr.gif",
	IMG_URL_IN_PROGRESS_OVERLAY = IMG_PATH + "wi_in_progress_ovr.gif",

	messages = dojo.i18n.getLocalization("com.ibm.team.workitem.viewlets.web.ui.internal", "WorkItemsMessages");

dojo.declare("com.ibm.team.workitem.viewlets.web.ui.internal.WorkItemsGadget",
		[dijit._Widget, dijit._Templated], {
	
	templatePath: dojo.moduleUrl("com.ibm.team.workitem.viewlets.web", "ui/internal/templates/WorkItemsGadget.html"),
	
	constructor: function() {
		this.noResults = messages.noResults;
		this.backToResults = messages.backToResults;
		this.saveMessage = messages.save;
		this.cancelMessage = messages.cancel;
	},
	
	postCreate: function() {
		this.prefs = new gadgets.Prefs();
		this.connect(this._configure,"onclick",dojo.hitch(this,this.onConfigure));
		this.connect(this.domNode,"onmouseover",dojo.hitch(this,this.onShowConfigure,true));
		this.connect(this.domNode,"onmouseout",dojo.hitch(this,this.onShowConfigure,false));
		var title = this.prefs.getString(PREF_ID_TITLE);
		if (title)
			gadgets.window.setTitle(title);
		this.refresh();
	},
	
	refresh: function() {
		gadgets.window.adjustHeight();
		var query = this.prefs.getString(PREF_ID_QUERY);
		if (!query || this._configureMode) {
			this.setConfigureArea(true);
		} else {
			this._hideMessageArea();
			if (!this.pagedTable) {
				this.pagedTable = new jazz.ui.PagedTable({
					resultCount: -1,
					itemsPerPage: this.prefs.getInt(PREF_ID_ITEMS_PER_PAGE),
					fetch: dojo.hitch(this,this.fetch),
					renderEntry: dojo.hitch(this,this.renderEntry),
					renderDetails: dojo.hitch(this,this.renderDetails),
					onHeightChange: gadgets.window.adjustHeight,
					onNoResults: dojo.hitch(this,this.handleNoResults)
				});
				this._contentArea.appendChild(this.pagedTable.domNode);
			} else {
				if (query != this._oldQuery) {
					this.pagedTable.setResultCount(-1);
					this.pagedTable.reset(true);
				} else {
					this.pagedTable.refresh();
				}
			}
			this.setConfigureArea(false);
			this._oldQuery = query;
		}
	},
	
	fetch: function(/* int */ startIndex, /* int */ count, /* boolean */ entries, /* boolean */ details, finalDeferred) {
		if (!finalDeferred)
			finalDeferred = new dojo.Deferred();
		var serviceObj = {
			success: dojo.hitch(this,function(response) {
				console.debug(response);
				this.pagedTable.setResultCount(response.totalCount);
				if (response.totalCount > 0) {
					this._resultHeaderIndex = {};
					this._resultHeaders = response.headers;
					for (var i = 0; i < response.headers.length; i++) 
						this._resultHeaderIndex[response.headers[i].attributeId] = i;
					for (var i = 0; i < count; i++) {
						if (response.rows[i])
							response.rows[i].queryIndex = startIndex + i;
					}
					finalDeferred.callback({
						entries: response.rows,
						details: response.rows
					});
				} else {
					this.handleNoResults();
				}
			}),
			failure: dojo.hitch(this,function(error) {
				this._onServiceError(error);
				throw error;
			})
		};
		var srh = new ServiceResponseHandler(serviceObj, "success", "failure");
		QueryClient2.getResultSet(null, {
			startIndex: startIndex,
			maxResults: count,
			absoluteURIs: true,
			itemId: this.prefs.getString(PREF_ID_QUERY),
			projectAreaItemId: true,
			columnIdentifiers: [WorkItemAttributes.TYPE, WorkItemAttributes.SUMMARY, WorkItemAttributes.STATE,
				WorkItemAttributes.CREATOR, WorkItemAttributes.OWNER, WorkItemAttributes.SEVERITY, WorkItemAttributes.PRIORITY,
				WorkItemAttributes.CREATION_DATE, WorkItemAttributes.RESOLUTION, WorkItemAttributes.ESTIMATE,
				WorkItemAttributes.CATEGORY, WorkItemAttributes.TARGET, WorkItemAttributes.PROJECT_AREA, WorkItemAttributes.TAGS]
		}, srh);
		return finalDeferred;
	},
	
	renderEntry: function(resultDTO) {
		var columns = new Array();
		
		var titleColSpan = 2;
		
		var iconCell = document.createElement("td");
		var iconContainer = document.createElement("div");
		iconContainer.className = "iconContainer";
		
		iconCell.className = "iconCell";
		
		// add overlay if available/needed
		var overlay = "", iconClass;
		if (resultDTO.stateGroup) {
			switch (resultDTO.stateGroup) {
				case Constants.CLOSED_STATES:	
					overlay = IMG_URL_CLOSED_OVERLAY;
					iconClass = "closed-icon";
					break;
				case Constants.IN_PROGRESS_STATES:	
					overlay = IMG_URL_IN_PROGRESS_OVERLAY;
					break;
			}
		}
		var icon = new OverlayIcon({
			icon: resultDTO.iconUrls[this._resultHeaderIndex[WorkItemAttributes.TYPE]],
			overlay: overlay,
			layout: OverlayIcon.BOTTOM_LEFT
		});
		if (iconClass)
			dojo.addClass(icon.domNode, iconClass);
		icon.domNode.style.marginRight = "0.2em";
		icon.domNode.title = resultDTO.labels[this._resultHeaderIndex[WorkItemAttributes.TYPE]];
		iconCell.appendChild(icon.domNode);
		columns.push(iconCell);
		
		var secondIcon = this.prefs.getString(PREF_ID_SECOND_ICON)
		if (secondIcon != "none") {
			secondIcon = WorkItemAttributes.getInternalId(secondIcon);
			titleColSpan = 1;
			var secondIconCell = document.createElement("td");
			secondIconCell.className = "iconCell";
			var secondIconSrc = resultDTO.iconUrls[this._resultHeaderIndex[secondIcon]];
			if (secondIconSrc) {
				var secondIconImg = document.createElement("img");
				secondIconImg.width = 16;
				secondIconImg.height = 16;
				secondIconImg.style.marginRight = "0.2em";
				secondIconImg.src = secondIconSrc;
				secondIconImg.title = dojo.string.substitute(messages.iconTooltip,[this._resultHeaders[this._resultHeaderIndex[secondIcon]].label, resultDTO.labels[this._resultHeaderIndex[secondIcon]]]);
				secondIconCell.appendChild(secondIconImg);
			}
			columns.push(secondIconCell);
		}
		
		var titleCell = document.createElement("td");
		titleCell.className = "titleCell";
		titleCell.colSpan = titleColSpan;
		var titleWrapper = document.createElement("div");
		titleWrapper.className = "titleWrapper";
		var titleLink = document.createElement("a");
		titleLink.href = "../resource/itemName/com.ibm.team.workitem.WorkItem/" + resultDTO.id;
		titleLink.target = "_top";
		titleLink.innerHTML = resultDTO.id + ": " + jazz.util.format.insertWordBreaks(resultDTO.labels[this._resultHeaderIndex[WorkItemAttributes.SUMMARY]], 20, true);

//		temporarily disabled until it's polished
//		new HoverFloat({
//			around: titleLink,
//			parent: this,
//			queryIndex: resultDTO.queryIndex,
//			showDetails: messages.showDetails
//		});

		titleWrapper.appendChild(titleLink);
		titleCell.appendChild(titleWrapper);
		columns.push(titleCell);
		
		return columns;
	},
	
	renderDetails: function(resultDTO) {
		var detailsCell = document.createElement("td");
		detailsCell.colSpan = "3";
		var div = document.createElement("div");
		var iframe = document.createElement("iframe");
		iframe.height = "250px";
		iframe.src = "../resource/itemOid/com.ibm.team.workitem.WorkItem/" + resultDTO.itemId + "?_mediaType=text%2Fhtml&_selector=smallHover&_context=web";
		iframe.style.width = "100%";
		iframe.frameBorder = "0";
		div.appendChild(iframe);
		detailsCell.appendChild(div);
		
		return [detailsCell];
	},
	
	handleDetailsClick: function(i,e) {
		dojo.stopEvent(e);
		this.pagedTable.setItemsPerPage(1);
		this.pagedTable.setCurrentPage(i+1);
		this.pagedTable.setShowDetails(true);
		dojo.removeClass(this._backToResults, "hidden");
	},
	
	_handleBackToResults: function(e) {
		dojo.stopEvent(e);
		var itemsPerPage = this.prefs.getInt(PREF_ID_ITEMS_PER_PAGE)
		var page = Math.ceil(this.pagedTable.currentPage / itemsPerPage);
		this.pagedTable.setItemsPerPage(itemsPerPage);
		this.pagedTable.setCurrentPage(page);
		this.pagedTable.setShowDetails(false);
		dojo.addClass(this._backToResults, "hidden");
	},
	
	onShowConfigure: function(show) {
		if (show && (this._configureMode || (this.prefs && !this.prefs.getString(PREF_ID_QUERY))))
			return;
		this.doShowConfigure(show);
	},
	
	doShowConfigure: function(show) {
		if (show)
			dojo.removeClass(this._configure, "hidden");
		else
			dojo.addClass(this._configure, "hidden");
	},
	
	onConfigure: function(e) {
		dojo.stopEvent(e);
		this.doShowConfigure(false);
		this._configureMode = true;
		this.refresh();
	},
	
	setConfigureArea: function(visible) {
		if (visible) {
			if (!this.tabs) {
				this.tabs = new gadgets.TabSet("configureTabSet", "Query");
				this.tabs.addTab("Query", {
					contentContainer: this._configureQuery, 
					callback: dojo.hitch(this, this._createQueryTab)
				});
				this.tabs.addTab("Second Icon", {
					contentContainer: this._configureIcon, 
					callback: dojo.hitch(this, this._createIconTab)
				});
				this.tabs.alignTabs("left");
				this.connect(this._cancelCmd, "onclick", dojo.hitch(this,function(){
					this._configureMode = false;
					this.refresh();
				}));
				this.connect(this._okCmd, "onclick", dojo.hitch(this, this._saveSettings));
			} else if (!this.queryChooser) {
				// recreate the query tab if we were not authed before
				this._createQueryTab();
			}
			if (this._configureMode)
				dojo.removeClass(this._cancelCmd, "hidden");
			else
				dojo.addClass(this._cancelCmd, "hidden");
			dojo.addClass(this._contentArea, "hidden");
			dojo.removeClass(this._configureControls, "hidden");
		} else {
			dojo.addClass(this._configureControls, "hidden");
			dojo.removeClass(this._contentArea, "hidden");
		}
		if (this.tabs)
			this.tabs.displayTabs(visible);
		gadgets.window.adjustHeight();
	},
	
	destroyPagedTable: function() {
		if (this.pagedTable) {
			this._contentArea.removeChild(this.pagedTable.domNode);
			this.pagedTable.destroy();
			delete this.pagedTable;
		}
	},
	
	_onServiceError: function(error) {
		if (error.oauthApprovalUrl) {
			this.destroyPagedTable();
			var popup = new gadgets.oauth.Popup(
	  	        error.oauthApprovalUrl,
	            "height=600,width=600",
	            dojo.hitch(this,function(e) {
					this._messageArea.innerHTML = "Waiting for login. <a href='#'>Click here</a> when you are done.";
					var link = this._messageArea.getElementsByTagName("a")[0];
					link.onclick = popup.createApprovedOnClick();
					this.connect(link, "onclick", dojo.stopEvent);
					this._showMessageArea();
				}),
	            dojo.hitch(this, this.refresh)
			);
			this.showLogin(popup);
		} else {
			console.error(error);
		}
	},
	
	_createQueryTab: function() {
		if (!this._configureQuery.firstChild) {
			this.queryChooser = new WorkItemQueryChooserContent({
				okButton: this._okCmd,
				multiSelect: false,
				loadedCallback: function() {},
				scope: QueryClient.SCOPE_PERSONAL,
				defaultValue: this.prefs.getString(PREF_ID_QUERY),
				defaultCategory: this.prefs.getString(PREF_ID_QUERY_CATEGORY),
				suppressCrossRepoQueries: true,
				onError: dojo.hitch(this,function(error){
						this._onServiceError(error);
						this._configureQuery.removeChild(this.queryChooser.domNode);
						this.queryChooser.destroy();
						delete this.queryChooser;
					})
			});
			this._configureQuery.appendChild(this.queryChooser.domNode);
			this.queryChooser.init();
		}
		gadgets.window.adjustHeight();
	},
	
	_createIconTab: function() {
		var projectArea = this.queryChooser && this.queryChooser.getCurrentProjectArea();
		if (projectArea) {
			if (!this.iconChooser) {
				this.iconChooser = new SecondIconChooser({
					width: "",
					allowMultipleSelections: false,
					sortOrder: 2,
					projectAreaItemId: projectArea,
					defaultSelection: this.prefs.getString(PREF_ID_SECOND_ICON) || "none"
				});
				this._configureIcon.appendChild(this.iconChooser.domNode);
			}
		} else {
			this._configureIcon.innerHTML = "You must select a project area on the Query tab.";
		}
		gadgets.window.adjustHeight();
	},
	
	_saveSettings: function() {
		this._configureMode = false;
		var prefArgs = [], title;
		var query = this.queryChooser && this.queryChooser.getSelection();
		if (query) {
			prefArgs.push(PREF_ID_QUERY);
			prefArgs.push(query.itemId);
			prefArgs.push(PREF_ID_QUERY_CATEGORY);
			prefArgs.push(query.queryCategory);
			prefArgs.push(PREF_ID_TITLE);
			title = query.name;
			prefArgs.push(title);
		}
		var secondIcon = this.iconChooser && this.iconChooser.getSelection();
		if (secondIcon && secondIcon.length) {
			prefArgs.push(PREF_ID_SECOND_ICON);
			prefArgs.push(secondIcon[0].value);
		}
		if (prefArgs.length)
			this.prefs.set.apply(this,prefArgs);
		if (title)
			gadgets.window.setTitle(title);
		this.destroyPagedTable();
		this.refresh();
	},
	
	handleNoResults: function() {
		this._messageArea.innerHTML = messages.noResults;
		this._showMessageArea();
	},
	
	showLogin: function(popup) {
		this._messageArea.innerHTML = "";
		var link = jazz.util.i18n.addMessage(this._messageArea, messages.gadgetLogin)[0];
		link.onclick = popup.createOpenerOnClick();
		this.connect(link, "onclick", dojo.stopEvent);
		this._showMessageArea();
	},
	
	_showMessageArea: function() {
		if (this.pagedTable)
			dojo.addClass(this.pagedTable.domNode, "hidden");
		dojo.removeClass(this._messageArea, "hidden");
		this.setConfigureArea(false);
	},
	
	_hideMessageArea: function() {
		if (this.pagedTable)
			dojo.removeClass(this.pagedTable.domNode, "hidden");
		dojo.addClass(this._messageArea, "hidden");
	}
			
});

})();
