/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
 
class MathUtility {
	
	public static var BASE10:Number = 10;
	
	private static var _ROUND_PRECISION = 5;
	
	public static function log10(number:Number):Number {
		
		var naturalLog:Number = Math.log(number);
		var base10Log:Number = naturalLog * Math.LOG10E;

		// Compensate for number precision errors on certain platforms
		// (e.g. Firefox on MacOS)
		// Defect 138192
		// e.g. 
		// log10(10) = 1                  [Correct]
		// log10(10) = 0.9999999999999996 [Wrong]
		var result:Number = MathUtility.customRound(base10Log, MathUtility._ROUND_PRECISION);
		
		return result;
	}
	
	public static function customRound(number:Number, decimalPlaces:Number):Number {

		var multiple:Number = Math.pow(MathUtility.BASE10, decimalPlaces);
		var enlargedNumber:Number = number * multiple;
		var roundNumber:Number = Math.round(enlargedNumber);
		var reducedNumber:Number = roundNumber / multiple;
		
		return reducedNumber;
	}	
	
}