/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

// IDEAS

// TODO: Show breakdown of work item results in hover popup
// TODO: Ability to copy text
// TODO: Ability to copy drill-in URL
// TODO: Ability to scroll horizontally along X-Axis if a lot of values
// TODO: Ability to scroll vertically along Y-Axis if a lot of values
 
// FEATURES

// TODO: Other category legend text should have a special colour
// TODO: Other category chart colour should be set to a fixed colour
// TODO: Highlight legend entry when chart area is hovered over
// TODO: Allow selection of legend text?
// TODO: Animate grow bars width-wise on mouse over
// TODO: Animate grow legend swatch on mouse over
// TODO: Lightweight chart scaling - Scale when Y-Axis recalcuation deemed unnecessary (90% of the time) - Regenerate other 10%
// TODO: Show JFChart version number in debug mode (will match Jazz source control revision number)

// DEFECTS

// TODO: IMPORTANT: Revisit all uses of Floor and Round when calculating Grid data - Should not be flooring or rounding unless absolutely necessary
// TODO: Legend needs to autodetect when too many legend entries (exceeds height) and suppress
// TODO: Set minimum length for bar width
// TODO: Set minimum arc for pie shape
// TODO: Draw tooltips in actual mouseover position instead of 0,0 - Sometimes glitch where tooltip appears in 0 position
// TODO: Verify rounded numbers are used for all drawing routines
// TODO: Implement smoother bar scaling - do not clear and redraw
// TODO: Set limit on Y-axis labels width
// TODO: Set limit on tooltip width?
// TODO: No legend mouseover for gap between swatch and label 
// TODO: Movie destroyed on viewlet drag
// TODO: Buffer delay in chart resize event?
// TODO: Get rid of all text field occurences of autosize - use exact sizes
// TODO: Review pie shape and centralize all variables that have the same values for all shapes
// TODO: Do not allow graph area heights that have decimals - avoid blurry grid lines
// TODO: When Y-axis labels go above 1,000,000, switch to exponential notation?
// TODO: Bar chart is top-aligned instead of bottom-aligned - add difference to top of chart?
// TODO: Set limit on chart width
// TODO: Set limit on chart height
// TODO: Flashvars in JS must escape double quotes or HTML will get mangled
// TODO: Specify generic parent field for chart objects
// TODO: Maximize label text field width - right margin too high
// TODO: On resize, the legend entries don't adapt to new constrained size - get crunched (using cached parameters)
// TODO: Make legend spacing between chart tighter or dynamic depending on available width
// TODO: Reduce spacing between legend swatches and labels
// TODO: JS alert on drill-in orphans tooltip on canvas
// TODO: Strict horizontal resize of pie chart causes chart area to overlap legend area
// TODO: Do drill-in on mouse up not on mouse down
// TODO: Tighten up margin between column legend entry labels and right-most chart margin
// TODO: On initial mouse-over (only) legend entry whose tooltip exceeds chart area width gets clipped off canvas

// TASKS

// TODO: Sweep statistics viewlet for dead JS code
// TODO: Viewlet container replaces content node on zoom - recreates flash object
// TODO: IMPORTANT: Verify that model is being destroyed on refresh

// TESTS

// TODO: Test large Y-scale max number: 1,000,000
// TODO: Test NLS japanese text
// TODO: Test System without Arial font?
// TODO: Test zero value for values, max, min, total
// TODO: Test model validation method

class Tester {

	public static function loadParameters1():Void {
		_root._fparameterNames = "High|Medium|Low|Unassigned";
		_root._fparameterValues = "14|3|6|48";
		_root._fparameterColours = "R255G191B191|R250G234B187|R196G220B245|R240G240B240";
		_root._fpresentation = "bar";
		_root._fisDebug = "true";
		_root._fanimation = "true";		
	}

	public static function loadParameters2():Void {
		_root._fparameterNames = "Blocker|Critical|Major|Normal|Minor|Unclassified";
		_root._fparameterValues = "11|6|9|18|15|2";
		_root._fparameterColours = "R179G107B107|R223G127B127|R255G204B204|R229G218B184|R255G255B222|R240G240B240";
		_root._fpresentation = "pie";
		_root._fisDebug = "true";
		_root._fanimation = "true";		
	}

	public static function loadParameters3():Void {
		_root._fparameterNames = "hard|project|new|soft|admin|rock|fire|chocolate|acura|2d|3d|ford|left|right|top|bottom|Other";
		_root._fparameterValues = "4|4|3|3|3|2|2|1|1|1|1|1|15|22|9|7|28";
		_root._fpresentation = "column";
		_root._fisDebug = "true";
		_root._fanimation = "true";		
	}		
 
 	public static function loadParameters4():Void {
		_root._fparameterNames = "Unassigned|Project Area Setup|Jazz Project|Eclipse Project|Foundation Web UI";
		_root._fparameterValues = "122|14|501|59|220";
		_root._fpresentation = "column";
		_root._fisDebug = "true";
		_root._fanimation = "true";		
	}		

 	public static function loadParameters5():Void {
		_root._fparameterNames = "hard|project|new|soft|admin|rock|left|right|top|bottom|Other";
		_root._fparameterValues = "4|4|3|3|3|2|15|22|9|7|35";
		_root._fpresentation = "pie";
		_root._fisDebug = "true";
		_root._fanimation = "true";		
	}		
	
 	public static function loadParameters6():Void {
		ChartEngine.getInstance().setChartParameters("_fparameterNames=%5C%5CBackSlash%5C%5C%5C%5CCat%5C%5C|Ampersand%26Cat|AspectJ%2FCompiler|DoubleQuote%22Cat|Equal%3DCat|Pipe%5C%7CCat|Pipe%5C%7CCat%2F%5C%7CPipeOnEitherSideCat%5C%7C&_fparameterValues=1|1|1|1|1|1|1&_fparameterColours=&_fpresentation=bar&_fchartID=com_ibm_team_workitem_viewlets_web_ui_internal_StatisticsViewlet_2");
	}			

 	public static function loadParameters7():Void {
		_root._fparameterNames = "hard|project|new|soft|admin|rock|Other";
		_root._fparameterValues = "7409|90409|53|23000|2300|3201|350";
		_root._fpresentation = "bar";
		_root._fisDebug = "true";
		_root._fanimation = "false";		
	}		

 	public static function loadParameters8():Void {
		_root._fparameterNames = "/Jazz Development/Developer Test Team/Zurich Test Team|areallylongtagtotesttheresizehandlertoupdatelabels|/Jazz Development/Dashboard|/Jazz Development/Web UI Foundation|admin|/Jazz Development/Visual Studio Client|/Jazz Post 1.0 Explorations/Web UI Explorations";
		_root._fparameterValues = "7409|90409|53|23000|2300|3201|80350";
		_root._fpresentation = "bar";
		_root._fisDebug = "true";
		_root._fonClickHandler = "true";
	}		
	
	public static function loadParameters9():Void {
		_root._fparameterNames = "HighHighHighHighHighHighHigh|MediumMediumMediumMediumMediumMediumMedium|LowLowLowLowLowLowLow|UnassignedUnassignedUnassignedUnassignedUnassignedUnassignedUnassigned";
		_root._fparameterValues = "14|3|6|48";
		_root._fparameterColours = "R255G191B191|R250G234B187|R196G220B245|R240G240B240";
		_root._fpresentation = "bar";
	}

 	public static function loadParameters10():Void {
		_root._fparameterNames = "/Jazz Development/Developer Test Team/Zurich Test Team|areallylongtagtotesttheresizehandlertoupdatelabels|/Jazz Development/Dashboard|/Jazz Development/Web UI Foundation|admin|/Jazz Development/Visual Studio Client|/Jazz Post 1.0 Explorations/Web UI Explorations";
		_root._fparameterValues = "111|111|111|111|111|111|111";
		_root._fpresentation = "column";
	}		

 	public static function loadParameters11():Void {
		_root._fparameterNames = "Single";
		_root._fparameterValues = "111";
		_root._fpresentation = "column";
	}		

 	public static function loadParameters12():Void {
		_root._fparameterNames = "One|Two";
		_root._fparameterValues = "1|1";
		_root._fpresentation = "column";
	}		

 	public static function loadParameters13():Void {
		_root._fparameterNames = "Documentation - User Assistance|Work Items|Agile Planning|Source Control|PMC|Release Engineering|Build|Traditional Planning|Visual Studio Client|Performance and Reliability Team|Install|User Experience|ClearCase Connector|Dashboard Viewlets|JavaScript Tooling|RTC Commons|Other";
		_root._fparameterValues = "134|47|36|33|27|26|24|24|12|11|9|3|3|3|2|2|2";
		_root._fpresentation = "bar";
		_root._fisDebug = "true";
	}		
	
	public static function dumpModel(model:ChartModel):Void {
		trace("===========================================================");				
		trace("Max Value: " + model.maxValue);
		trace("Min Value: " + model.minValue);
		trace("Parameter Count: " + model.parameterCount);
		trace("Parameter Names: " + model.parameterNames);
		trace("Parameter Values: " + model.parameterValues);
		trace("Parameter Colours: " + model.parameterColours);
		trace("Total: " + model.total);
		trace("Presentation: " + model.presentation);
		trace("On Click Handler: " + model.onClickHandler);
		trace("Debug Mode: " + model.isDebug);
		trace("Animation: " + model.animation);
		trace("===========================================================");				
	}	
	
	public static function dumpGridData(gridData:GridData):Void {
		trace("===========================================================");				
		trace("Start X:            " + gridData.startX);
		trace("Start Y:            " + gridData.startY);
		trace("H Tick Offset X:    " + gridData.hTickOffsetX);
		trace("H Tick Offset Y:    " + gridData.hTickOffsetY);
		trace("Y Zero Position:    " + gridData.yZeroPosition);
		trace("X Zero Position:    " + gridData.xZeroPosition);
		trace("Height:             " + gridData.height);
		trace("Width:              " + gridData.width);
		trace("Max:                " + gridData.max);
		trace("Y Section Count:    " + gridData.yAxisSectionCount);
		trace("Y Spacing:          " + gridData.yAxisSpacing);
		trace("Y Increment:        " + gridData.yAxisIncrement);		
		trace("X Section Count:    " + gridData.xAxisSectionCount);
		trace("X Spacing:          " + gridData.xAxisSpacing);
		trace("X Increment:        " + gridData.xAxisIncrement);		
		trace("X Max Label Width:  " + gridData.xAxisMaxLabelWidth);		
		trace("Y Max Label Width:  " + gridData.yAxisMaxLabelWidth);		
		trace("Graph Area Width:   " + gridData.graphAreaWidth);
		trace("Graph Area Height:  " + gridData.graphAreaHeight);
		trace("===========================================================");			
	}

	public static function dumpGridValues(id:String, increment:Number, sectionCount:Number, maxValue:Number, area:Number, minSpacing:Number, spacing:Number):Void {
		trace(">> " + id + "============");
		trace("Increment:                 " + increment);
		trace("Section Count:             " + sectionCount);
		trace("Increment x Section Count: " + (increment * sectionCount));
		trace("Max Value:                 " + maxValue);
		trace("(I x S) < Max Value:       " + ((increment * sectionCount) < maxValue));
		trace("Spacing:                   " + spacing);
		trace("Min Spacing:               " + minSpacing);
		trace("Spacing < Min Spacing:     " + (spacing < minSpacing));
		trace("Area:                      " + area);
		trace("<<");
	}
	
}