/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.module.AbstractFramedWidget"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.module.WindowContext"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "ModuleMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var Assert= com.ibm.jdojo.util.Assert;
var WindowContext= com.ibm.team.workitem.web.ui.internal.module.WindowContext;
var _Widget= dijit._Widget;

dojo.declare("com.ibm.team.workitem.web.ui.internal.module.AbstractFramedWidget", _Widget, { //$NON-NLS-1$

	_bodyClickHandle: null,

	_resizeHandle: null,

	_hashChangeSubscribeHandle: null,

	parentOrigin: null,

	frameId: null,

	_moduleMessages: null,

	constructor: function() {
		this._moduleMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "ModuleMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	},

	_getFrameHeight: function() {
		Assert.isTrue(false, "Abstract method '_getFrameHeight' invoked");
	},

	_getFrameWidth: function() {
		Assert.isTrue(false, "Abstract method '_getFrameWidth' invoked");
	},

	_navigateToHash: function(url) {
		Assert.isTrue(false, "Abstract method '_navigateToHash' invoked");
	},

	postCreate: function() {
		dojo.setObject('net.jazz.ajax.ui.PlatformUI',new com.ibm.team.workitem.web.ui.internal.page.PlatformUIProxy());; //$NON-NLS-1$
		var hash= window.location.hash;
		if (hash.indexOf("#") === 0) { //$NON-NLS-1$
			hash= hash.substring(1);
		}
		this.validateParameters(hash);
		this.inherited("postCreate", arguments, []); //$NON-NLS-1$
	},

	validateParameters: function(hash) {
		var parms= dojo.queryToObject(hash);
		if (parms.origin != null) {
			this.parentOrigin= parms.origin;
		}
		if (parms.frameId != null) {
			this.frameId= parms.frameId;
		}
		if (!dojo.isString(this.parentOrigin) || this.parentOrigin.length === 0) {
			window.alert("The argument 'origin=' was not specified!"); //$NON-NLS-1$
			return false;
		}
		if (!dojo.isString(this.frameId) || this.frameId.length === 0) {
			window.alert("The argument 'frameId=' was not specified!"); //$NON-NLS-1$
			return false;
		}
		return true;
	},

	destroy: function(preserveDom) {
		if (this._bodyClickHandle != null) 
			this._bodyClickHandle.destroy(preserveDom);
		if (this._resizeHandle != null) 
			this._resizeHandle.destroy(preserveDom);
		if (this._hashChangeSubscribeHandle != null) 
			this._hashChangeSubscribeHandle.destroy(preserveDom);
		this.inherited("destroy", arguments, [preserveDom]); //$NON-NLS-1$
	},

	_addFramedBodyClickRedirectionListener: function() {
		this._bodyClickHandle= WindowContext.addBodyClickRedirectionListener(this);
	},

	handleBodyClick: function(e) {
		WindowContext.forwardUrlToParentWindow((window.parent || window), e.target, this.parentOrigin, this.frameId);
		return true;
	},

	_addFramedResizeListener: function() {
		var resizeHandler= dojo.hitch(this, function() {
			this._handleResize();
		});
		this._resizeHandle= WindowContext.addResizeListener(this, resizeHandler);
	},

	_handleResize: function() {
		window.setTimeout(dojo.hitch(this, function() {
			this._setFrameSize();
		}), 250);
	},

	_addFramedHashChangeListener: function() {
		var hashChangeHandler= dojo.hitch(this, function( /*, args... */ ) {
			var args= [];
			for (var $sourceIdx= 0; $sourceIdx < arguments.length; $sourceIdx++)
				args.push(arguments[$sourceIdx]);

			var context= args[0];
			this._navigateToHash("" + context); //$NON-NLS-1$
		});
		this._hashChangeSubscribeHandle= WindowContext.subscribeToHashChange(this, hashChangeHandler);
	},

	_setFrameSize: function() {
		var height= this._getFrameHeight();
		var width= this._getFrameWidth();
		if (height >= 0) {
			this._setSizeInParent(height, width);
		}
	},

	_setHeightInParent: function(height) {
		if (this.parentOrigin == null) 
			return ;
		var message= "frameId=" + this.frameId + "&height=" + height; //$NON-NLS-1$ //$NON-NLS-2$
		WindowContext.postMessage((window.parent || window), message, this.parentOrigin);
	},

	_setSizeInParent: function(height, width) {
		if (this.parentOrigin == null) 
			return ;
		var message= "frameId=" + this.frameId + "&height=" + height + "&width=" + width; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		;
		WindowContext.postMessage((window.parent || window), message, this.parentOrigin);
	},

	$interfaces: {
		'com.ibm.team.workitem.web.ui.internal.module.WindowContext.IBodyClickHandler': true //$NON-NLS-1$
	}
});

})();
