/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.module.AbstractGadgetContainerWidget_JDojo_Helper"); //$NON-NLS-1$
dojo.require("jazz.opensocial.Gadget"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.module.AbstractFrameContainerWidget"); //$NON-NLS-1$
/*
 * This class is a workaround which allows the rpc register to get attached to a callback that is not hitched to this.
 * Thus, the callback body can reference this, which is the rpc object.
 *   RPC object contents:
 *	   s: Service Name
 *     f: From, the gadget.id of the calling gadget
 *     c: The callback ID or 0 if none.
 *     a: The arguments for this RPC call.
 *     t: The authentication token.
 * 
 */
(function() {
var AbstractFrameContainerWidget= com.ibm.team.workitem.web.ui.internal.module.AbstractFrameContainerWidget;

dojo.declare("com.ibm.team.workitem.web.ui.internal.module.AbstractGadgetContainerWidget_JDojo_Helper", AbstractFrameContainerWidget, { //$NON-NLS-1$
    postCreate: function() {
		this.inherited("postCreate", arguments, []); //$NON-NLS-1$
		var self= this;
		var callback= function(url) {
			var gadget= dijit.byId(this.f);
			return self._handleRpcNavigateTo(gadget, url);
		};
		gadgets.rpc.register("com_ibm_team_workitem_rpc_requestNavigateToWithVeto", callback); //$NON-NLS-1$
		
		var onChangeCallback= function(workItemProxy) {
			var gadget= dijit.byId(this.f);
			return self._handleRpcOnChange(gadget, workItemProxy);
		};
		gadgets.rpc.register("com_ibm_team_workitem_rpc_onchange", onChangeCallback); //$NON-NLS-1$
		
		var onStoreCallback= function(workItemProxy) {
			var gadget= dijit.byId(this.f);
			return self._handleRpcOnStore(gadget, workItemProxy);
		};
		gadgets.rpc.register("com_ibm_team_workitem_rpc_onstore", onStoreCallback); //$NON-NLS-1$

    }
});

})();
