/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.module.WindowContext"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Exception"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.lang.JavaScriptException"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.client.session.Session"); //$NON-NLS-1$
dojo.require("jazz.app.context"); //$NON-NLS-1$
dojo.require("jazz.util.BodyClickListener"); //$NON-NLS-1$
dojo.require("jazz.util.ResizeNotifier"); //$NON-NLS-1$
dojo.require("net.jazz.ajax.ui.PlatformUI"); //$NON-NLS-1$

(function() {
var Exception= com.ibm.jdojo.lang.Exception;
var JavaScriptException= com.ibm.jdojo.lang.JavaScriptException;
var jdojo= com.ibm.jdojo.lang.Runtime;
var session= com.ibm.team.repository.web.client.session;
var context2= jazz.app.context;
var BodyClickListener= jazz.util.BodyClickListener;
var ResizeNotifier= jazz.util.ResizeNotifier;
var PlatformUI= net.jazz.ajax.ui.PlatformUI;

var WindowContext= dojo.declare("com.ibm.team.workitem.web.ui.internal.module.WindowContext", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" }
});

WindowContext.RECENT_PREFIX= "com_ibm_team_workitem_web_internal_RECENT_"; //$NON-NLS-1$
WindowContext.RECENT_VALUES_MAX_SIZE= 5;
WindowContext.isGadget= false;
WindowContext.addBodyClickRedirectionListener= function(handler) {
	var clickHandler= dojo.hitch(this, function(context) {
		var event= {};
		event.target= WindowContext.fullyQualifyUrl(context);
		var result= handler.handleBodyClick(event);
		return "" + result; //$NON-NLS-1$
	});
	var handle= new DestroyableBodyClickHandle();
	handle.clickHandle= BodyClickListener.register(clickHandler, 999);
	return handle;
};
WindowContext.fullyQualifyUrl= function(url) {
	if (url.indexOf("#") === 0) { //$NON-NLS-1$
		var split= window.location.href.split("#"); //$NON-NLS-1$
		if (split.length > 0) {
			url= split[0] + url;
		} else {
			url= window.location.href + url;
		}
	}
	return url;
};
WindowContext.replaceWindowLocation= function(targetUrl) {
	WindowContext.setWindowLocation3(WindowContext.isGadget, false, targetUrl, null, null, true);
};
WindowContext.setWindowLocation= function(isGadget, isFramed, targetUrl, originUrl, frameId) {
	WindowContext.setWindowLocation3(isGadget, isFramed, targetUrl, originUrl, frameId, false);
};
WindowContext.setWindowLocation2= function(targetUrl) {
	WindowContext.setWindowLocation3(WindowContext.isGadget, false, targetUrl, null, null, false);
};
WindowContext.setWindowLocation3= function(isGadget, isFramed, targetUrl, originUrl, frameId, isReplace) {
	if (isGadget) {
		WindowContext.rpcNavigateTo(targetUrl);
	} else {
		if (isFramed === true) {
			targetUrl= WindowContext.fullyQualifyUrl(targetUrl);
			WindowContext.forwardUrlToParentWindow((window.parent || window), targetUrl, originUrl, frameId);
		} else {
			if (PlatformUI.getWorkbench().shouldVetoNavigation(targetUrl)) 
				return ;
			if (!isReplace) {
				window.location.href= targetUrl;
			} else {
				window.location.replace(targetUrl);
			}
		}
	}
};
WindowContext.rpcNavigateTo= function(parmsUrl) {
	try {
		var onReturnCallback= dojo.hitch(this, function(url, ignore) {
			if (url != null) {
				window.location.href= url;
			}
			return null;
		});
		parmsUrl= WindowContext._convertOidUrlToLocationUrl(parmsUrl);
		WindowContext.rpcCallToContainer("com_ibm_team_workitem_rpc_requestNavigateToWithVeto", onReturnCallback, parmsUrl, null, null); //$NON-NLS-1$
	} catch (throwable) {
		if ((throwable= throwable instanceof Exception ? throwable : new JavaScriptException(throwable)) instanceof JavaScriptException) {
			console.log("gadgets.rpc call failed: requestNavigateTo from WorkItemGadget"); //$NON-NLS-1$
		} else {
			throw throwable;
		}
	}
	return true;
};
WindowContext.rpcSetTitle= function(title) {
	try {
		WindowContext.rpcCallToContainer("set_title", null, title, null, null); //$NON-NLS-1$
	} catch (throwable) {
		if ((throwable= throwable instanceof Exception ? throwable : new JavaScriptException(throwable)) instanceof JavaScriptException) {
			console.log("[WindowContext] gadgets.rpc call failed: set_title from WorkItemGadget"); //$NON-NLS-1$
		} else {
			throw throwable;
		}
	}
};
WindowContext.oidPart= "resource/itemOid/com.ibm.team.workitem.WorkItem"; //$NON-NLS-1$
WindowContext._convertOidUrlToLocationUrl= function(parmsUrl) {
	parmsUrl= WindowContext._convertNameUrlToLocationUrl(parmsUrl);
	var currentHostWithContext= window.location.protocol + "//" + window.location.host + net.jazz.ajax._contextRoot; //$NON-NLS-1$
	if (parmsUrl.indexOf(currentHostWithContext) !== 0) 
		return parmsUrl;
	var i= parmsUrl.indexOf(WindowContext.oidPart);
	if (i === -1) 
		return parmsUrl;
	var projectAreaName= WindowContext.getCurrentProjectAreaName();
	if (projectAreaName == null) 
		return parmsUrl;
	var encodedProjectAreaName= encodeURIComponent(projectAreaName);
	encodedProjectAreaName.replace(new RegExp("\\("), "%28"); //$NON-NLS-1$ //$NON-NLS-2$
	encodedProjectAreaName.replace(new RegExp("\\)"), "%29"); //$NON-NLS-1$ //$NON-NLS-2$
	var result= currentHostWithContext + "/web/projects/" + encodedProjectAreaName; //$NON-NLS-1$
	if (window.location.href.indexOf("?debug=true") !== -1) { //$NON-NLS-1$
		result+= "?debug=true"; //$NON-NLS-1$
	}
	var itemId= parmsUrl.substring(i + WindowContext.oidPart.length + 1, parmsUrl.length);
	result+= "#action=com.ibm.team.workitem.viewWorkItem&itemId=" + itemId; //$NON-NLS-1$
	return result;
};
WindowContext.namePart= "resource/itemName/com.ibm.team.workitem.WorkItem"; //$NON-NLS-1$
WindowContext._convertNameUrlToLocationUrl= function(parmsUrl) {
	var currentHostWithContext= window.location.protocol + "//" + window.location.host + net.jazz.ajax._contextRoot; //$NON-NLS-1$
	if (parmsUrl.indexOf(currentHostWithContext) !== 0) 
		return parmsUrl;
	var i= parmsUrl.indexOf(WindowContext.namePart);
	if (i === -1) 
		return parmsUrl;
	var projectAreaName= WindowContext.getCurrentProjectAreaName();
	if (projectAreaName == null) 
		return parmsUrl;
	var result= currentHostWithContext + "/web/projects/" + projectAreaName; //$NON-NLS-1$
	if (window.location.href.indexOf("?debug=true") !== -1) { //$NON-NLS-1$
		result+= "?debug=true"; //$NON-NLS-1$
	}
	var id= parmsUrl.substring(i + WindowContext.namePart.length + 1, parmsUrl.length);
	result+= "#action=com.ibm.team.workitem.viewWorkItem&id=" + id; //$NON-NLS-1$
	return result;
};
WindowContext.rpcCallToContainer= function(serviceName, callback, var_args1, var_args2, var_args3) {
	gadgets.rpc.call("", serviceName, callback, var_args1, var_args2, var_args3); //$NON-NLS-1$
};
WindowContext.rpcCallToGadget= function(gadgetId, serviceName, callback, var_args1, var_args2, var_args3) {
	gadgets.rpc.call(gadgetId, serviceName, callback, var_args1, var_args2, var_args3);
};
WindowContext.forwardUrlToParentWindow= function(targetWindow, targetUrl, originUrl, frameId) {
	var message= "frameId=" + frameId + "&openUrl=" + targetUrl; //$NON-NLS-1$ //$NON-NLS-2$
	originUrl= originUrl == null ? "" : originUrl; //$NON-NLS-1$
	WindowContext.postMessage(targetWindow, message, originUrl);
};
WindowContext.addResizeListener= function(context, callback) {
	var parms= {};
	parms.context= context;
	parms.callback= callback;
	parms.force= true;
	var result= new DestroyableResizeNotifierHandle();
	result.resizeNotifierHandle= ResizeNotifier.register(parms);
	return result;
};
WindowContext._checkOrigin= function(fragment, origin) {
	if (origin.indexOf(fragment) !== 1) {
		return true;
	}
	return false;
};
WindowContext.postMessage= function(targetWindow, message, originUrl) {
	if ((!dojo.isIE || dojo.isIE>7)) {
		if (message == null) 
			message= ""; //$NON-NLS-1$
		if (originUrl == null) 
			originUrl= ""; //$NON-NLS-1$
		var win=targetWindow;win.postMessage(message, originUrl);
	} else {
		console.debug("Post Message Not available"); //$NON-NLS-1$
		if (originUrl.indexOf("#") !== (originUrl.length - 1)) { //$NON-NLS-1$
			message= "#" + message; //$NON-NLS-1$
		}
		window.top.location.replace(originUrl + message);
	}
};
WindowContext.addMessageEventHandler= function(caller, callerHandler, callerOrigin) {
	if ((!dojo.isIE || dojo.isIE>7)) {
		return WindowContext._addPostMessageEventHandler(callerHandler, callerOrigin);
	}
	return WindowContext._addHashMessageEventHandler(caller, callerHandler, callerOrigin);
};
WindowContext._addHashMessageEventHandler= function(caller, callerHandler, callerOrigin) {
	var hashChangeHandler= dojo.hitch(this, function( /*, args... */ ) {
		var args= [];
		for (var $sourceIdx= 0; $sourceIdx < arguments.length; $sourceIdx++)
			args.push(arguments[$sourceIdx]);

		var event= {};
		event.data= window.location.hash;
		;
		callerHandler(event);
	});
	return WindowContext.subscribeToHashChange(caller, hashChangeHandler);
};
WindowContext._addPostMessageEventHandler= function(callerHandler, callerOrigin) {
	var result= new DestroyableConnectHandle();
	var localHandler= dojo.hitch(this, function(e) {
		var me= e;
		if (!WindowContext._checkOrigin(me.origin, callerOrigin)) {
			window.alert("WindowContext event cancelled because of origin mismatch. Data: " + me.data + " origin:" + me.origin); //$NON-NLS-1$ //$NON-NLS-2$
			return ;
		}
		callerHandler(me);
	});
	result.connectHandle= dojo.connect(window, "message", localHandler); //$NON-NLS-1$
	return result;
};
WindowContext.getSafeText= function(text) {
	var span= window.document.createElement("span"); //$NON-NLS-1$
	span.appendChild(window.document.createTextNode(text));
	return span.innerHTML;
};
WindowContext.touchRecentItem= function(itemId, value) {
	var items= WindowContext.getRecentItems(itemId);
	var newItems= [];
	for (var i= 0; i < items.length; i++){
		if (items[i] !== value) {
			newItems.push(items[i]);
		}
	}
	items= [];
	if (newItems.length >= WindowContext.RECENT_VALUES_MAX_SIZE) {
		for (var i= 0; i < newItems.length - 1; i++){
			items.push(newItems[i]);
		}
	} else {
		items= newItems;
	}
	itemId= WindowContext.getRecentId(itemId);
	items.splice(0, 0, value);
	var itemsString= dojo.toJson(items, false);
	WindowContext.setLocalStorageValue(itemId, itemsString);
};
WindowContext.getRecentId= function(itemId) {
	return WindowContext.RECENT_PREFIX + itemId;
};
WindowContext.getRecentItems= function(itemId) {
	return WindowContext.getLocalStorageValues(WindowContext.getRecentId(itemId));
};
WindowContext.getLocalStorageId= function(key) {
	var currentContributorItemId= session.getAuthenticatedContributor().itemId;
	return currentContributorItemId + "_" + key; //$NON-NLS-1$
};
WindowContext.setLocalStorageValue= function(key, value) {
	if (window.localStorage == null) 
		return ;
	if (window.location.href.indexOf("resetLocalStorage=true") !== -1) { //$NON-NLS-1$
		window.localStorage.clear();
		return ;
	}
	key= WindowContext.getLocalStorageId(key);
	window.localStorage.setItem(key, value);
};
WindowContext.getLocalStorageValues= function(key) {
	if (window.localStorage == null) 
		return [];
	if (window.location.href.indexOf("resetLocalStorage=true") !== -1) { //$NON-NLS-1$
		window.localStorage.clear();
		return [];
	}
	key= WindowContext.getLocalStorageId(key);
	var valueString= window.localStorage.getItem(key);
	if (valueString == null || valueString.length === 0) 
		return [];
	var result= dojo.fromJson(valueString);
	return result;
};
WindowContext.publishHashChange= function(parm) {
	dojo.publish("/dojo/hashchange", [parm]); //$NON-NLS-1$
};
WindowContext.subscribeToHashChange= function(caller, callback) {
	var result= new DestroyableSubscribeHandle();
	result.subscribeHandle= dojo.subscribe("/dojo/hashchange", caller, callback); //$NON-NLS-1$
	return result;
};
WindowContext.handleError= function(parms) {
	window.alert(parms.summaryMessage + ". " + parms.detailsMessage); //$NON-NLS-1$
	return false;
};
WindowContext.getCurrentProjectArea= function() {
	return context2.get();
};
WindowContext.getCurrentProjectAreaName= function() {
	return WindowContext.getCurrentProjectArea().name;
};
jdojo.declareInterface("com.ibm.team.workitem.web.ui.internal.module.WindowContext.IBodyClickHandler");

jdojo.declareInterface("com.ibm.team.workitem.web.ui.internal.module.WindowContext.IDestroyableHandle");

jdojo.declareInterface("com.ibm.team.workitem.web.ui.internal.module.WindowContext.IDestroyable");

var DestroyableSubscribeHandle= dojo.declare("com.ibm.team.workitem.web.ui.internal.module.WindowContext.DestroyableSubscribeHandle", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	subscribeHandle: null,

	destroy: function(preserveDom) {
		if (this.subscribeHandle != null) 
			dojo.unsubscribe(this.subscribeHandle);
	},

	$interfaces: {
		'com.ibm.team.workitem.web.ui.internal.module.WindowContext.IDestroyable': true, //$NON-NLS-1$
		'com.ibm.team.workitem.web.ui.internal.module.WindowContext.IDestroyableHandle': true //$NON-NLS-1$
	}
});
var DestroyableConnectHandle= dojo.declare("com.ibm.team.workitem.web.ui.internal.module.WindowContext.DestroyableConnectHandle", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	connectHandle: null,

	destroy: function(preserveDom) {
		if (this.connectHandle != null) 
			dojo.disconnect(this.connectHandle);
	},

	$interfaces: {
		'com.ibm.team.workitem.web.ui.internal.module.WindowContext.IDestroyable': true, //$NON-NLS-1$
		'com.ibm.team.workitem.web.ui.internal.module.WindowContext.IDestroyableHandle': true //$NON-NLS-1$
	}
});
var DestroyableBodyClickHandle= dojo.declare("com.ibm.team.workitem.web.ui.internal.module.WindowContext.DestroyableBodyClickHandle", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	clickHandle: null,

	destroy: function(preserveDom) {
		if (this.clickHandle != null) 
			BodyClickListener.unregister(this.clickHandle);
	},

	$interfaces: {
		'com.ibm.team.workitem.web.ui.internal.module.WindowContext.IDestroyable': true, //$NON-NLS-1$
		'com.ibm.team.workitem.web.ui.internal.module.WindowContext.IDestroyableHandle': true //$NON-NLS-1$
	}
});
var DestroyableResizeNotifierHandle= dojo.declare("com.ibm.team.workitem.web.ui.internal.module.WindowContext.DestroyableResizeNotifierHandle", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	resizeNotifierHandle: null,

	destroy: function(preserveDom) {
		if (this.resizeNotifierHandle != null) 
			ResizeNotifier.unregister(this.resizeNotifierHandle);
	},

	$interfaces: {
		'com.ibm.team.workitem.web.ui.internal.module.WindowContext.IDestroyable': true, //$NON-NLS-1$
		'com.ibm.team.workitem.web.ui.internal.module.WindowContext.IDestroyableHandle': true //$NON-NLS-1$
	}
});
jdojo.declareInterface("com.ibm.team.workitem.web.ui.internal.module.WindowContext.WindowEventHandler");


})();
