/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.module.WorkItemCreationWidget"); //$NON-NLS-1$

dojo.require("com.ibm.team.calm.foundation.web.calmdialogs.AbstractCALMDialogWidget"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.cache.internal.WorkItemProxyFactory"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemAttributes"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.module.WindowContext"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.EventTopics"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.widget.InlineWorkItemContent"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("jazz.util.iframe"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "ModuleMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var AbstractCALMDialogWidget= com.ibm.team.calm.foundation.web.calmdialogs.AbstractCALMDialogWidget;
var ServiceResponseHandler= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var WorkItemProxyFactory= com.ibm.team.workitem.web.cache.internal.WorkItemProxyFactory;
var WorkItemAttributes= com.ibm.team.workitem.web.client.internal.WorkItemAttributes;
var WorkItemClient= com.ibm.team.workitem.web.client.internal.WorkItemClient;
var DestroyableSubscribeHandle= com.ibm.team.workitem.web.ui.internal.module.WindowContext.DestroyableSubscribeHandle;
var EventTopics= com.ibm.team.workitem.web.ui.internal.page.EventTopics;
var InlineWorkItemContent= com.ibm.team.workitem.web.ui2.internal.widget.InlineWorkItemContent;
var iframe= jazz.util.iframe;

dojo.declare("com.ibm.team.workitem.web.ui.internal.module.WorkItemCreationWidget", AbstractCALMDialogWidget, { //$NON-NLS-1$

	_okButton: null,

	_editorContent: null,

	_messages: null,

	_richTextResizeHandle: null,

	_workItemTypes: null,

	_currentProjectArea: null,

	_workItemTypeContainer: null,

	_editorContainer: null,

	_workItemTypeSelect: null,

	_changedAttributes: null,

	constructor: function() {
		this._messages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "ModuleMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	},

	_openDialog: function(currentProjectArea) {
		this._richTextResizeHandle= new DestroyableSubscribeHandle();
		this._richTextResizeHandle.subscribeHandle= dojo.subscribe(EventTopics.WORKITEM_RICH_TEXT_RESIZED, this, "_handleRichTextResize"); //$NON-NLS-1$
		this._currentProjectArea= currentProjectArea;
		var document= window.document;
		var bodyDiv= document.createElement("div"); //$NON-NLS-1$
		bodyDiv.className= "com-ibm-team-workitem-web-ui-internal-module-WorkItemCreationWidget"; //$NON-NLS-1$
		this._workItemTypeContainer= document.createElement("div"); //$NON-NLS-1$
		this._workItemTypeContainer.style.display= "none"; //$NON-NLS-1$
		bodyDiv.appendChild(this._workItemTypeContainer);
		this._editorContainer= document.createElement("div"); //$NON-NLS-1$
		this._editorContainer.className= "editorContainer"; //$NON-NLS-1$
		bodyDiv.appendChild(this._editorContainer);
		var buttonDiv= document.createElement("div"); //$NON-NLS-1$
		buttonDiv.className= "buttonSection"; //$NON-NLS-1$
		var okButton= document.createElement("button"); //$NON-NLS-1$
		okButton.className= "Button"; //$NON-NLS-1$
		okButton.tabIndex= 5;
		okButton.disabled= "disabled"; //$NON-NLS-1$
		okButton.appendChild(document.createTextNode(this._messages.buttonOK));
		this._okButton= okButton;
		this.connect(okButton, 'click', dojo.hitch(this, function(event) { //$NON-NLS-1$
			if (this._editorContent != null) {
				this._editorContent.handleOk(event);
			}
		}));
		var cancelButton= document.createElement("button"); //$NON-NLS-1$
		cancelButton.className= "Button"; //$NON-NLS-1$
		cancelButton.tabIndex= 6;
		cancelButton.appendChild(document.createTextNode(this._messages.buttonCancel));
		this.connect(cancelButton, 'click', dojo.hitch(this, function(event) { //$NON-NLS-1$
			if (this._editorContent != null) {
				this._editorContent.handleCancel(event);
			}
		}));
		buttonDiv.appendChild(okButton);
		buttonDiv.appendChild(cancelButton);
		bodyDiv.appendChild(buttonDiv);
		this._setContentWidget(bodyDiv);
		this._fetchWorkItemTypes();
	},

	_getBottomMargin: function() {
		return 20;
	},

	_handleRichTextResize: function(event) {
		if (event.type === "fullScreenShown") { //$NON-NLS-1$
			return ;
		}
		window.setTimeout(dojo.hitch(this, function() {
			this._handleResizeActual();
		}), 250);
	},

	_handleResizeActual: function() {
		var heightInt= this._getHeight();
		if (heightInt > 0) {
			heightInt= Math.max(this._getHeight(), this._getBottomMargin());
			var height= (heightInt - this._getBottomMargin()) + "px"; //$NON-NLS-1$
			this._editorContent.domNode.style.height= height;
		}
		this._performEditorLoaded();
		return heightInt;
	},

	_onWorkItemTypesFetched: function(workItemTypes) {
		this._workItemTypes= workItemTypes;
		var draftId= this._dialogArguments["draftId"]; //$NON-NLS-1$
		if (draftId != null) {
			this._createWorkingCopy(this._currentProjectArea, "", draftId); //$NON-NLS-1$
		} else {
			var workItemTypeId= this._dialogArguments["dc:type"]; //$NON-NLS-1$
			if (workItemTypeId == null) {
				workItemTypeId= workItemTypes[0].id;
			}
			this._createWorkingCopy(this._currentProjectArea, workItemTypeId, null);
		}
	},

	_getReturnNamespace: function() {
		return "oslc_cm"; //$NON-NLS-1$
	},

	_fetchWorkItemTypes: function() {
		var onSuccess= dojo.hitch(this, function(valueSet) {
			this._onWorkItemTypesFetched(valueSet[0].uiItems);
		});
		var onFailure= dojo.hitch(this, function(result) {
			this._handleError(this._messages.errorCannotFetchWorkItemTypes);
		});
		var params= {};
		params.newWorkItem= "true"; //$NON-NLS-1$
		params.ids= [WorkItemAttributes.TYPE];
		var handler= new ServiceResponseHandler({'onSuccess': onSuccess, 'onFailure': onFailure}, 'onSuccess', 'onFailure'); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		WorkItemClient.getAllValues(handler, params);
	},

	_createWorkingCopy: function(currentProjectArea, workItemTypeId, draftId) {
		var proxyArgs= {};
		proxyArgs.createIfNeeded= true;
		var workingCopy= WorkItemProxyFactory.getWorkItemProxy(proxyArgs);
		workingCopy.incrementUseCount();
		var initArgs= {};
		initArgs.fetchEditorPresentation= false;
		initArgs.fetchInlinePresentation= false;
		initArgs.type= workItemTypeId;
		if (draftId != null) 
			initArgs.draftId= draftId;
		initArgs.onSuccess= dojo.hitch(this, function() {
			this._populateDialog(workingCopy);
		});
		initArgs.onError= dojo.hitch(this, function() {
			workingCopy.decrementUseCount(true);
			this._handleError(this._messages.errorCannotCreateWorkingCopy);
		});
		workingCopy.initialize(initArgs);
	},

	_populateDialog: function(workingCopy) {
		if (this._changedAttributes == null) {
			var initialSummary= this._dialogArguments["dc:name"]; //$NON-NLS-1$
			if (initialSummary != null) 
				this._setWorkingCopyValue(workingCopy, WorkItemAttributes.SUMMARY, initialSummary, "content"); //$NON-NLS-1$
			var initialDescription= this._dialogArguments["dc:description"]; //$NON-NLS-1$
			if (initialDescription != null) 
				this._setWorkingCopyValue(workingCopy, WorkItemAttributes.DESCRIPTION, initialDescription, "content"); //$NON-NLS-1$
			var initialTarget= this._dialogArguments["dc:target"]; //$NON-NLS-1$
			if (initialTarget != null) 
				this._setWorkingCopyValue(workingCopy, WorkItemAttributes.TARGET, initialTarget, "id"); //$NON-NLS-1$
		} else {
			for (var i= 0; i < this._changedAttributes.length; i++){
				workingCopy.setValue(this._changedAttributes[i]);
			}
		}
		this.populateWorkTypeSelection(workingCopy);
		this.populateEditorContent(workingCopy);
	},

	populateEditorContent: function(workingCopy) {
		var contentParams= {};
		contentParams.workingCopy= workingCopy;
		contentParams.parentWidget= this;
		contentParams.onClose= dojo.hitch(this, function(info, changedAttributes) {
			this._onEditorClose(info, changedAttributes);
		});
		contentParams.okEnabled= dojo.hitch(this, function(isEnabled) {
			this._onOkEnablementChange(isEnabled);
		});
		contentParams.onEditorLoaded= dojo.hitch(this, function() {
			this._performEditorLoaded();
		});
		this._editorContent= new InlineWorkItemContent(contentParams);
		dojo.style(this._editorContent.domNode, 'overflow', "auto"); //$NON-NLS-1$ //$NON-NLS-2$
		dojo.style(this._editorContent.domNode, 'position', "relative"); //$NON-NLS-1$ //$NON-NLS-2$
		this._editorContainer.appendChild(this._editorContent.domNode);
	},

	_performEditorLoaded: function() {
		this._editorContent.domNode.style.visibility= "hidden"; //$NON-NLS-1$
		this._editorContent.domNode.style.height= ""; //$NON-NLS-1$
		this._workItemTypeContainer.style.display= ""; //$NON-NLS-1$
		var documentHeight= iframe.getDocumentHeight() + this._getBottomMargin();
		this.updateSize(680 + "px", documentHeight + "px"); //$NON-NLS-1$ //$NON-NLS-2$
		this._editorContent.domNode.style.visibility= "visible"; //$NON-NLS-1$
	},

	populateWorkTypeSelection: function(workingCopy) {
		var getValueArgs= {};
		getValueArgs.path= ["attributes", "workItemType"]; //$NON-NLS-1$ //$NON-NLS-2$
		var workItemType= workingCopy.getValue(getValueArgs).id;
		if (this._workItemTypeSelect == null) {
			this._workItemTypeSelect= window.document.createElement("select"); //$NON-NLS-1$
			this._workItemTypeSelect.className= "workItemTypeSelection"; //$NON-NLS-1$
			dojo.connect(this._workItemTypeSelect, "onchange", dojo.hitch(this, function(e) { //$NON-NLS-1$
				this.changeWorkItemType(this._workItemTypeSelect.value);
			}));
			var selectedIndex= 0;
			for (var i= 0; i < this._workItemTypes.length; i++){
				var item= this._workItemTypes[i];
				var option= window.document.createElement("option"); //$NON-NLS-1$
				option.value= item.id;
				option.appendChild(window.document.createTextNode(item.label));
				this._workItemTypeSelect.appendChild(option);
				if (item.id === workItemType) 
					selectedIndex= i;
			}
			this._workItemTypeSelect.selectedIndex= selectedIndex;
			var parent= window.document.createElement("table"); //$NON-NLS-1$
			parent.className= "workItemTypeContainer"; //$NON-NLS-1$
			var row= parent.appendChild(window.document.createElement("tr")); //$NON-NLS-1$
			var labelCell= window.document.createElement("td"); //$NON-NLS-1$
			labelCell.className= "workItemTypeLabel"; //$NON-NLS-1$
			labelCell.appendChild(window.document.createTextNode(this._messages.defectTypeLabel));
			var comboCell= window.document.createElement("td"); //$NON-NLS-1$
			comboCell.appendChild(this._workItemTypeSelect);
			row.appendChild(labelCell);
			row.appendChild(comboCell);
			parent.appendChild(row);
			this._workItemTypeContainer.appendChild(parent);
		} else {
			this._workItemTypeSelect.value= workItemType;
		}
	},

	changeWorkItemType: function(workItemTypeId) {
		if (this._editorContent != null) {
			this._editorContainer.removeChild(this._editorContent.domNode);
			this._changedAttributes= this._editorContent.getChangedAttributes();
		}
		this._editorContent.destroy(true);
		this._createWorkingCopy(this._currentProjectArea, workItemTypeId, null);
	},

	_onEditorClose: function(info, changedAttributes) {
		var results= null;
		if (info != null) {
			var result= {};
			result.summary= info.description;
			result.url= window.location.protocol + "//" + window.location.host + net.jazz.ajax._contextRoot + "/resource/itemName/com.ibm.team.workitem.WorkItem/" + info.workItemId; //$NON-NLS-1$ //$NON-NLS-2$
			results= [result];
		}
		this._close(results, "oslc_cm.create"); //$NON-NLS-1$
	},

	_onOkEnablementChange: function(isEnabled) {
		if (this._okButton != null) {
			this._okButton.disabled= isEnabled ? "" : "disabled"; //$NON-NLS-1$ //$NON-NLS-2$
		}
	},

	_setWorkingCopyValue: function(workingCopy, attributeId, newValue, valueName) {
		var args= {};
		args.caller= this;
		args.path= ["attributes", attributeId, valueName]; //$NON-NLS-1$
		args.savedAttributePath= ["attributes", attributeId, valueName]; //$NON-NLS-1$
		args.attributeId= attributeId;
		args.value= newValue;
		workingCopy.setValue(args);
	},

	destroy: function(preserveDom) {
		this._richTextResizeHandle.destroy(preserveDom);
		if (this._editorContent != null) {
			this._editorContent.destroy(false);
			this._editorContent= null;
		}
		this.inherited("destroy", arguments, [preserveDom]); //$NON-NLS-1$
	}
});

})();
