/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.module.WorkItemGadget"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Exception"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.lang.JavaScriptException"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.module.WindowContext"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.module.WorkItemGadgetViewWidget"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.WorkItemPageView"); //$NON-NLS-1$

(function() {
var Exception= com.ibm.jdojo.lang.Exception;
var JavaScriptException= com.ibm.jdojo.lang.JavaScriptException;
var WindowContext= com.ibm.team.workitem.web.ui.internal.module.WindowContext;
var WorkItemGadgetViewWidget= com.ibm.team.workitem.web.ui.internal.module.WorkItemGadgetViewWidget;
var Prefs= gadgets.Prefs;

/**
 * 
 *
 */
dojo.declare("com.ibm.team.workitem.web.ui.internal.module.WorkItemGadget", WorkItemGadgetViewWidget, { //$NON-NLS-1$

	postCreate: function() {
		var prefs= new Prefs();
		if (this.fParameters == null) {
			var p= {};
			this.fParameters= p;
		}
		if (this.fParameters.projectAreaItemId == null) {
			var id= prefs.getString("projectAreaItemId"); //$NON-NLS-1$
			if (id != null) 
				this.fParameters.projectAreaItemId= id;
		}
		this.fParameters.hideProjectAreaSelection= prefs.getString("hideProjectAreaSelection") === "true"; //$NON-NLS-1$ //$NON-NLS-2$
		this.inherited("postCreate", arguments, []); //$NON-NLS-1$
		var self= this;
		var callback= dojo.hitch(this, function(searchTerm, ignore) {
			return self._searchFor(searchTerm);
		});
		gadgets.rpc.register("com_ibm_team_workitem_rpc_requestSearch", callback); //$NON-NLS-1$
		var callback2= dojo.hitch(this, function(action, ignore) {
			return self.navigateToHash(action);
		});
		gadgets.rpc.register("com_ibm_team_workitem_rpc_requestAction", callback2); //$NON-NLS-1$
		try {
			var hash= prefs.getString("hash"); //$NON-NLS-1$
			this.navigateToHash(hash);
		} catch (e) {
			if ((e= e instanceof Exception ? e : new JavaScriptException(e)) instanceof Exception) {
				console.log("error showing prefs"); //$NON-NLS-1$
			} else {
				throw e;
			}
		}
	},

	_searchFor: function(searchTerm) {
		if (searchTerm == null || searchTerm.length === 0) 
			return null;
		var hash= "#action=com.ibm.team.workitem.search&q=" + searchTerm; //$NON-NLS-1$
		this.navigateToHash(hash);
		return null;
	},

	_setSizeInParent: function(height, width) {
		try {
			WindowContext.rpcCallToContainer("resize_iframe", null, height + 400 + "", null, null); //$NON-NLS-1$ //$NON-NLS-2$
		} catch (throwable) {
			if ((throwable= throwable instanceof Exception ? throwable : new JavaScriptException(throwable)) instanceof JavaScriptException) {
				console.log("gadgets.rpc call failed: resize_iframe from WorkItemGadget"); //$NON-NLS-1$
			} else {
				throw throwable;
			}
		}
	},

	handleBodyClick: function(e) {
		return this.navigateTo(e.target);
	},

	navigateToHash: function(hash) {
		if (hash == null || hash.length === 0) 
			return true;
		if (hash.indexOf("#") === -1)  //$NON-NLS-1$
			hash= "#" + hash; //$NON-NLS-1$
		return this.navigateTo(hash);
	},

	navigateTo: function(parmsUrl) {
		if (parmsUrl == null || parmsUrl.length === 0) 
			return true;
		var split= parmsUrl.split("com.ibm.team.workitem.WorkItemGadget#"); //$NON-NLS-1$
		if (split.length === 2 && split[1] === "") { //$NON-NLS-1$
			return true;
		}
		try {
			var callback= dojo.hitch(this, function(url, ignore) {
				if (url != null) {
					var locationUrl= new dojo._Url(window.document.baseURI, url);
					window.location.href= locationUrl.uri;
				}
				return null;
			});
			parmsUrl= WindowContext._convertOidUrlToLocationUrl(parmsUrl);
			WindowContext.rpcCallToContainer("com_ibm_team_workitem_rpc_requestNavigateToWithVeto", callback, parmsUrl, null, null); //$NON-NLS-1$
		} catch (throwable) {
			if ((throwable= throwable instanceof Exception ? throwable : new JavaScriptException(throwable)) instanceof JavaScriptException) {
				console.log("gadgets.rpc call failed: requestNavigateTo from WorkItemGadget"); //$NON-NLS-1$
			} else {
				throw throwable;
			}
		}
		return true;
	},

	validateParameters: function(hash) {
		return true;
	}
});

})();
