/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.module.WorkItemPickerWidget"); //$NON-NLS-1$

dojo.require("com.ibm.team.calm.foundation.web.calmdialogs.AbstractCALMDialogWidget"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.SelectWorkItemContent"); //$NON-NLS-1$
dojo.require("jazz.util.iframe"); //$NON-NLS-1$

(function() {
var AbstractCALMDialogWidget= com.ibm.team.calm.foundation.web.calmdialogs.AbstractCALMDialogWidget;
var SelectWorkItemContent= com.ibm.team.workitem.web.ui.internal.view.editor.SelectWorkItemContent;
var iframe= jazz.util.iframe;

dojo.declare("com.ibm.team.workitem.web.ui.internal.module.WorkItemPickerWidget", AbstractCALMDialogWidget, { //$NON-NLS-1$

	postCreate: function() {
		var body= dojo.body();
		dojo.style(body, 'overflow', "hidden"); //$NON-NLS-1$ //$NON-NLS-2$
		this.inherited("postCreate", arguments, []); //$NON-NLS-1$
	},

	_getReturnNamespace: function() {
		return "oslc_cm"; //$NON-NLS-1$
	},

	_openDialog: function(projectArea) {
		var bodyDiv= window.document.createElement("div"); //$NON-NLS-1$
		bodyDiv.className= "com-ibm-team-workitem-web-ui-internal-module-WorkItemPickerWidget"; //$NON-NLS-1$
		var contentParams= {};
		contentParams.onOk= dojo.hitch(this, "_onOk"); //$NON-NLS-1$
		contentParams.onCancel= dojo.hitch(this, "_onCancel"); //$NON-NLS-1$
		contentParams.key= this._dialogArguments;
		contentParams.projectAreaItemId= projectArea.itemId;
		contentParams.currentTypeSelection= this._dialogArguments["dc:type"]; //$NON-NLS-1$
		var content= new SelectWorkItemContent(contentParams);
		var exclusionList= this._dialogArguments["exclusionList"]; //$NON-NLS-1$
		if (exclusionList != null) {
			content.setExclusionList(exclusionList);
		} else {
			content.setExclusionList([]);
		}
		var allowsMultiple= this._dialogArguments["allowsMultiple"]; //$NON-NLS-1$
		if (allowsMultiple != null) {
			content.setAllowsMultiple(allowsMultiple);
		} else {
			content.setAllowsMultiple(false);
		}
		bodyDiv.appendChild(content.domNode);
		this._setContentWidget(bodyDiv);
		window.setTimeout(dojo.hitch(this, function() {
			var documentHeight= iframe.getDocumentHeight();
			this.updateSize(550 + "px", documentHeight + "px"); //$NON-NLS-1$ //$NON-NLS-2$
		}), 100);
	},

	_onOk: function(selectedItems, key) {
		var results= [];
		for (var i= 0; i < selectedItems.length; i++){
			var item= selectedItems[i];
			var result= {};
			result.summary= item.id + ": " + item.summary; //$NON-NLS-1$
			result.url= window.location.protocol + "//" + window.location.host + net.jazz.ajax._contextRoot + "/resource/itemName/com.ibm.team.workitem.WorkItem/" + item.id; //$NON-NLS-1$ //$NON-NLS-2$
			results.push(result);
		}
		this._close(results, "oslc_cm.select"); //$NON-NLS-1$
	},

	_onCancel: function() {
		this._close(null, null);
	}
});

})();
