/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  
 * Use, duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp. 
 *******************************************************************************/
// NLS_CHARSET=UTF-8

({
	EditorTitle: "Editor Presentations",
	EditorDesc: "Define the presentation structure of work item editors: pages, sections, and presentations. Drag to move sections or presentations.",
	EditorListLabel: "Choose the Editor Presentation to edit: ",
	Add: "Add...",
	Loading: "Loading...",
	Remove: "Remove",
	WarnRemoveEditor: "Are you sure you want to remove this editor presentation?",
	Design: "Design",
	PresentationDesc: "Define the presentation structure of work item editors: pages, sections, and attributes within sections.",
	LabelValue : "${0}: ",
	ProjectArea: "Project Area",
	TeamArea: "Team Area",
	Correction: "Correction",
	
	// Add Editor dialog strings
	AddEditorDialogTitle: "Add Editor Presentation",
	EnterEditorID: "Enter an ID for the Editor Presentation",
	LabelEditorID: "ID: ",
	LabelEditorName: "Name: ",
	ErrIDEmpty: "ID must not be empty",
	ErrDupID: "An Editor Presentation with the same ID already exists.",

	ConfirmRemoveEditor: "Are you sure you want to remove editor '${0}'?",
	HeaderTitle: "Header Slot",
	DummyWIType: "Work Item Type",
	SaveBtn: "Save",
	CancelBtn: "Cancel",
	AddHeader: "Add Header",
	labelSummary: "Summary",
	
	// Add tab dialog strings
	AddTabDialogTitle: "Add Tab",
	EditTabDialogTitle: "Edit Tab",
	TabTitle: "Title: ",
	TabLayout: "Layout: ",
	TabId: "Tab ID:",
	None: "None",
	builtInOverviewLayout: "Overview Layout",
	builtInHLayout: "H Layout",
	builtInCustomAttributesLayout: "Custom Attributes Layout",
	builtInLinksLayout: "Links Layout",
	builtInApprovalsLayout: "Approvals Layout",
	builtInHistoryLayout: "History Layout",
	Tab: "Tab",
	CreateTabID: "Create Tab ID: ",
	ReuseTabID: "Reuse Existing Tab: ",
	ErrEmptyTabID: "Tab ID must not be empty",
	ErrEmptyTabTitle: "Title must not be empty",
	ErrEmptyTabLayout: "Layout must not be empty",
	
	Menu: "Menu",
	EditTab: "Edit",
	RemoveTab: "Delete",
	ConfirmRemoveTab: "Are you sure you want to remove tab '${0}'?",
	RenameTab: "Rename",
	MoveTabLeft: "Move Left",
	MoveTabRight: "Move Right",
	RenameTabMsg: "Please specify a new tab name",
	LayoutTab: "Layout",
	AddSection: "Add Section",
	SlotLabel: '${0} Slot',
	
	// Add/Edit Section dialog strings
	AddSectionDialogTitle: "Add Section",
	EditSectionDialogTitle: "Edit Section",
	SectionTitle: "Title:",
	SectionSlot: "Slot:",
	SectionID: "Section ID:",
	Section: "Section",
	CreateSectionID: "Create Section ID: ",
	ReuseSectionID: "Reuse Existing Section: ",
	slot_hidden: "Hidden",
	slot_none: "None",
	slot_defaultSection: "None",
	slot_details: "Details",
	slot_description: "Description",
	slot_discussion: "Discussion",
	slot_quickInfo: "Quick Information",
	slot_links: "Links",
	slot_subscribers: "Subscribers",
	slot_attachments: "Attachments",
	slot_left: "Left",
	slot_right: "Right",
	slot_top: "Top",
	slot_bottom: "Bottom",
	labelDescriptionPlus: "Description ${0}",
	ErrSectionTitleEmpty: "Title must not be empty",
	ErrSectionIDEmpty: "Section ID must not be empty",
	
	// Add Header Section dialog strings
	AddHeaderSectionDialogTitle: "Add Header Section",
	
	AddPresentation: "Add Presentation",
	EditSection: "Edit Section",
	RemoveSection: "Remove Section",
	ConfirmRemoveSection: "Are you sure you want to remove section '${0}'?",
	
	// Add presentation dialog strings
	AddPresentationDlgTitle: "Add Presentation",
	EditPresentationDlgTitle: "Edit Presentation",
	AttrBased: "Attribute-based Presentation",
	AttrFieldLabel: "Attribute:",
	KindFieldLabel: "Kind:",
	NonAttrBased: "Non-Attribute-based Presentation",
	Hidden: "Hidden",
	ReadOnly: "Read Only:",
	InheritAttr: "Inherit from Attribute",
	TrueValue: "True",
	FalseValue: "False",
	PresentationLabel: "Label:",
	PresentationDesc: "Description:",
	PresentationId: "ID:",
	HideIfEmpty: "Hide if Empty:",
	ErrAttrIdEmpty: "An attribute must be selected",
	ErrKindEmpty: "A kind must be selected",
	AttrFiltes: "Filters",
	ShowConfigAttr: "Show already configured attributes",
	
	// kind labels
	// see com.ibm.team.workitem.ide.ui\plugin.properties
	"editorPresentation.displayName.enumeration": "Enumeration",
	"editorPresentation.displayName.workflowState": "Workflow State",
	"editorPresentation.displayName.workflowResolution": "Workflow Resolution",
	"editorPresentation.displayName.string": "String",
	"editorPresentation.displayName.smallHtml": "Small HTML",
	"editorPresentation.displayName.long": "Long",
	"editorPresentation.displayName.integer": "Integer",
	"editorPresentation.displayName.text": "Text",
	"editorPresentation.displayName.timestamp": "Timestamp",
	"editorPresentation.displayName.contributor": "Contributor",
	"editorPresentation.displayName.boolean": "Boolean",
	"editorPresentation.displayName.teamarea": "Team and Project Area",
	"editorPresentation.displayName.tags": "Tags",
	"editorPresentation.displayName.category": "Category",
	"editorPresentation.displayName.iteration": "Iteration",
	"editorPresentation.displayName.deliverable": "Release",
	"editorPresentation.displayName.description": "Description",
	"editorPresentation.displayName.html": "HTML",
	"editorPresentation.displayName.discussion": "Discussion",
	"editorPresentation.displayName.quickInformation": "Quick Information",
	"editorPresentation.displayName.attachments": "Attachments",
	"editorPresentation.displayName.contributorList": "Contributor List",
	"editorPresentation.displayName.processAreaList": "Process Area List",
	"editorPresentation.displayName.processArea": "Process Area",
	"editorPresentation.displayName.workItem": "Work Item",
	"editorPresentation.displayName.workItemList": "Work Item List",
	"editorPresentation.displayName.links": "Links",
	"editorPresentation.displayName.approvals": "Approvals",
	"editorPresentation.displayName.history": "History",
	"editorPresentation.displayName.separator": "Separator",
	"editorPresentation.displayName.list": "Multi-Select List",
	"editorPresentation.displayName.checkbox": "Checkbox Multi-Select List",
	"editorPresentation.displayName.radio": "Radio Group",
	"editorPresentation.displayName.staticText": "Static Text",
	"editorPresentation.displayName.lineSeparator": "Line Separator",
	"editorPresentation.displayName.eSignature": "E-Signature",
	"editorPresentation.displayName.references": "References",
	"editorPresentation.displayName.itemCombo": "Generic Combo",
	"editorPresentation.displayName.accesscontrolCombo": "Access Control",
	"editorPresentation.displayName.item": "Item",
	"editorPresentation.displayName.itemList": "Item List",
	"editorPresentation.displayName.valueSetCombo": "Value Set Combo",
	"editorPresentation.displayName.valueSetPicker": "Value Set Picker",
	
	// see com.ibm.team.apt.ide.ui\plugin.properties
	"editorPresentation.displayName.estimate": "Time Estimates",
	"editorPresentation.displayName.duration": "Time Duration",
	"editorPresentation.displayName.timeSpent": "Time Spent",
	"editorPresentation.displayName.progress": "Work Progress",
	"editorPresentation.displayName.wiki": "Wiki",
	"editorPresentation.displayName.constraintDate": "Constraint Date",
	"editorPresentation.displayName.plannedTime": "Planned Time",
	
	// see com.ibm.team.tpt.ide.ui\plugin.properties
	"editorPresentation.displayName.timeSheet": "Time Sheet Table",
	"editorPresentation.displayName.timeSheetEntries": "Quick Information (Time tracking)",
	"editorPresentation.displayName.riskmatrix": "Risk Matrix",
	"editorPresentation.displayName.riskcost": "Risk Cost",
	
	// properties table
	Properties: "Properties:",
	AddNoDot: "Add",
	AddProperty: "Add Property",
	NoPropAvailable: "No additional properties are available.",
	Key: "Key",
	Value: "Value",
	Actions: "Actions",
	RemoveProperty: "Remove Property",
	ConfirmRemoveProp: "Are you sure you want to remove property '${0}'?",
	SelectPropKey: "--Select--",
	readonly: "Read Only",
	labelVisible: "Show Label",
	hideIfEmpty: "Hide if Empty",
	hideIfCreation: "Hide on Creation",
	hideIfInState: "Hide in Workflow States",
	hideIfEndpointEmpty: "Hide if no Links Exist",
	hideIfNoProjectLink: "Hide if no Project Link Exists",
	toBeLinkedPartId: "Comments Presentation",
	warningMessage: "Warning Message",
	
	// presentation hover actions
	EditPresentation: "Edit Presentation",
	RemovePresentation: "Remove Presentation",
	ConfirmRemovePresentationNoLabel: "Are you sure you want to remove this presentation?",
	ConfirmRemovePresentation: "Are you sure you want to remove presentation '${0}'?",
	
	NotAvialable: "Not Available",

	ContentShared: "Content Shared",
	LockedTabDesc: "This tab is shared by other editor presentations. Modifying this shared tab will affect all instances of the shared tab in other editor presentations. Do you want to continue?",
	LockedSectionDesc: "This section is shared by other editor presentations. Modifying this shared section will affect all instances of the shared section in other editor presentations. Do you want to continue?",
	
	//// strings in each presentation widgets
	// CategoryAttributePart
	labelGuessCategory: "Guess Category",
	// TeamAreaWidget
	LabelProjectArea: "Project Area:",
	LabelTeamArea: "Team Area:",
	DummyProjArea: "ABC Project",
	DummyTeamArea: "XYZ Team",
	labelTeamAreaAndProjectArea: "${0} / ${1}",
	// AttachmentsPart
	LabelAddAttachments: "Add File:",
	LabelNoAttachments: "No Attachments.",
	// LinksPart
	LabelRelated: "Related",
	LabelAddLinks: "Add: ",
	// Quick Information
	QuickInfoNoLinks: "No Links.",
	// DiscussionsPart
	NoComments: "No Comments",
	AddComment: "Add Comment",
	// HistoryPart
	NoHistory: "No History",
	// SubscribersPart
	NoSubscribers: "No Subscribers.",
	// ApprovalsPart
	NewApproval: "New:",
	ApprovalLabel: "Approval",
	NoApprovals: "No Approvals",
	
	ProgressLabel: "Progress:",
	NotAvailable: "Not Available",
	NoWorkPlanned: "No work planned",
	ProgressNumbers: "Progress 0 / 0 h",
	ProgressEstimated: "Estimated: ",
	NoItems: "No Items.",
	NoWorkItems: "No Work Items.",
	NoProjArea: "No Project Areas.",
	PlannedStartDate: "Planned Start Date:",
	PlannedEndDate: "Planned End Date:",
	
	// TimeSheetEntryPartWeb widget
	TimesheetAdd: "Add:",
	TimeCode: "Time Code",
	TimesheetPrev: "Previous",
	TimesheetNext: "Next",
	Sunday: "Sunday",
	Monday: "Monday",
	Tuesday: "Tuesday",
	Wednesday: "Wednesday",
	Thursday: "Thursday",
	Friday: "Friday",
	Saturday: "Saturday",
	WeekTotal: "Week Total",
	WITotal: "Work Item Total",
	TimesheetOwner: "Timesheet Owner",
	TimesheetActions: "Actions",
	
	//
	RiskProbability: "Probability %",
	RiskImpact: "Impact %",
	
	NoTimesheet: "No Timesheet Record Present"
})