/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.CategoriesToolbarActionItem"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.IViewModel"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.actions.AbstractAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionMenu"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesArchiveUnArchiveAllAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesModel"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var ItemStyle= com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle;
var Domain= com.ibm.team.rtc.foundation.api.ui.model.IViewModel.Domain;
var AbstractAction= com.ibm.team.rtc.foundation.web.ui.actions.AbstractAction;
var CategoriesMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var CategoriesActionHelper= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper;
var CategoriesActionMenu= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionMenu;
var CategoriesArchiveUnArchiveAllAction= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesArchiveUnArchiveAllAction;
var CategoryEntry= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesModel.CategoryEntry;

dojo.declare("com.ibm.team.workitem.web.ui.internal.page.CategoriesToolbarActionItem", AbstractAction, { //$NON-NLS-1$

	fAction: null,

	fModel: null,

	fStyle: null,

	constructor: function(actionClass, label, iconUrl, style) {
		this.inherited(arguments, []);
		this.fAction= actionClass;
		this.fStyle= style;
		this.inherited("setName", arguments, [label]); //$NON-NLS-1$
		this.inherited("setIconUrl", arguments, [iconUrl]); //$NON-NLS-1$
		this.inherited("setCanHandle", arguments, [true]); //$NON-NLS-1$
	},

	getId: function() {
		return this.fAction.prototype.declaredClass;
	},

	handle: function() {
		if (this.inherited("canHandle", arguments, [])) { //$NON-NLS-1$
			if (this.fModel == null) {
				return ;
			}
			if (this.fModel.getSelectedEntries().length > 0) {
				this.setActionHandle(this.fModel.getSelectedEntries()[0]);
			}
		}
	},

	setActionHandle: function(category) {
		if (category == null) {
			return ;
		}
		var action= jdojo.newInstance(this.fAction, category);
		if (action instanceof CategoriesArchiveUnArchiveAllAction) {
			var archiveAction= this.getName() === CategoriesMessages.ARCHIVE_TOOLTIP ? true : false;
			var scopedModel= null;
			scopedModel= this.fModel;
			this.fModel.updateModel(dojo.hitch(this, function(updateAccessor) {
				var categoryEntries= new Array(scopedModel.getSelectedEntries().length);
				var array= scopedModel.getSelectedEntries();
				CategoriesActionHelper.archiveAllItems(updateAccessor, array, archiveAction);
				scopedModel.getInput().setPendingChanges(true);
				return null;
			}));
			return ;
		}
		action.handle();
	},

	getStyle: function() {
		return this.fStyle;
	},

	updateViewModel: function(model) {
		this.fModel= model;
	}
});
dojo.declare("com.ibm.team.workitem.web.ui.internal.page.CategoriesToolbarActionItem.CategoriesActionMenuWrapper", CategoriesActionMenu, { //$NON-NLS-1$

	fViewModel: null,

	constructor: function() {
		this.inherited(arguments, []);
	},

	getId: function() {
		return this.inherited("getId", arguments, []); //$NON-NLS-1$
	},

	canHandle: function() {
		return this.inherited("canHandle", arguments, []); //$NON-NLS-1$
	},

	handle: function() {
		this.inherited("handle", arguments, []); //$NON-NLS-1$
	},

	setModel: function(model) {
		this.fViewModel= model;
		this.setItemsInput();
	},

	setItemsInput: function() {
		if (this.fViewModel.getSelectedEntries().length === 0) {
			this.fViewModel.readModel(dojo.hitch(this, function(readAccessor) {
				var rootEntry= readAccessor.getRootEntry(Domain.Content);
				if (rootEntry != null) {
					var children= readAccessor.getChildren(rootEntry);
					if (children != null && children.length > 0 && jdojo.implementsInterface(children[0], "com.ibm.team.rtc.foundation.api.ui.model.IViewEntry") && children[0].getElement() instanceof CategoryEntry) {
						this.setInput(children[0], true);
					}
				}
				return null;
			}));
		} else {
			this.setInput(this.fViewModel.getSelectedEntries()[0], true);
		}
	},

	getStyle: function() {
		return this.inherited("getStyle", arguments, []); //$NON-NLS-1$
	},

	getPopupMenu: function() {
		this.setItemsInput();
		return this.inherited("getPopupMenu", arguments, []); //$NON-NLS-1$
	}
});
var ShowArhivedCategories= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.CategoriesToolbarActionItem.ShowArhivedCategories", AbstractAction, { //$NON-NLS-1$

	fModel: null,

	fIsChecked: null,

	fArchiveFilter: null,

	constructor: function(filter) {
		this.inherited(arguments, []);
		this.fIsChecked= false;
		this.fArchiveFilter= filter;
	},

	updateViewModel: function(model) {
		this.fModel= model;
	},

	getId: function() {
		return ShowArhivedCategories.prototype.declaredClass;
	},

	getName: function() {
		return CategoriesMessages.SHOW_ARCHIVED;
	},

	getIconUrl: function() {
		return null;
	},

	canHandle: function() {
		return true;
	},

	handle: function() {
		this.fIsChecked= !this.fIsChecked;
		if (this.fModel.getInput() != null && this.fArchiveFilter != null) {
			if (this.fIsChecked) {
				this.fModel.removeFilter(this.fArchiveFilter);
			} else {
				this.fModel.addFilter(this.fArchiveFilter);
			}
		}
	},

	getStyle: function() {
		return ItemStyle.TOGGLE;
	},

	isChecked: function() {
		return this.fIsChecked;
	},

	setIsChecked: function(isChecked) {
		this.fIsChecked= isChecked;
	}
});

})();
