/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.ReleasesDialog"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.web.ui.widgets.CheckBox"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit.form.DateTextBox"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("jazz.ui.Dialog"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal.nls", "ReleasesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var CheckBox= com.ibm.team.rtc.foundation.web.ui.widgets.CheckBox;
var ReleasesMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal.nls", "ReleasesMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var _Templated= dijit._Templated;
var _Widget= dijit._Widget;
var DateTextBox= dijit.form.DateTextBox;
var Dialog= jazz.ui.Dialog;

/**
 * A Dialog to add or edit Releases.
 */
dojo.declare("com.ibm.team.workitem.web.ui.internal.page.ReleasesDialog", [ _Widget, _Templated], { //$NON-NLS-1$

	templatePath: dojo.moduleUrl("com.ibm.team.workitem.web", "ui/internal/page/templates/ReleasesDialog.html"), //$NON-NLS-1$ //$NON-NLS-2$

	_messages: null,

	fDialog: null,

	fOkButton: null,

	fCancelButton: null,

	fNameInput: null,

	fDescriptionInput: null,

	fCreationDateInput: null,

	fFilterInput: null,

	fClickOKHandler: null,

	fClickCancelHandler: null,

	fOkCallback: null,

	fEditedRelease: null,

	fSequenceValue: null,

	fDateText: null,

	fFilterCheckBox: null,

	fReleasesName: null,

	fErrorMsg: null,

	STRING_EMPTY: null,

	constructor: function(params) {
		this._messages= ReleasesMessages;
		this.STRING_EMPTY= ""; //$NON-NLS-1$
		this.fOkCallback= params.onOK;
		this.fEditedRelease= params.editedRelease;
		this.fSequenceValue= params.sequenceValue;
		this.fReleasesName= params.releasesName;
	},

	postCreate: function() {
		this.inherited("postCreate", arguments, []); //$NON-NLS-1$
		this.connectHandlers();
		var filterParms= {};
		filterParms.label= ReleasesMessages.FILTERED_LABEL;
		if (this.fEditedRelease != null) {
			if (this.fEditedRelease.getName() != null) 
				this.fNameInput.value= this.fEditedRelease.getName();
			if (this.fEditedRelease.getDescription() != null) 
				this.fDescriptionInput.value= this.fEditedRelease.getDescription();
			filterParms.checked= this.fEditedRelease.isVisibleToTeam();
		}
		this.fFilterCheckBox= new CheckBox(filterParms);
		dojo.place(this.fFilterCheckBox.domNode, this.fFilterInput);
		var params= {};
		if (this.fEditedRelease != null && this.fEditedRelease.getReleaseDate() != null) 
			params= dojo.mixin(params, {value: new Date(this.fEditedRelease.getReleaseDate())});
		this.fDateText= new DateTextBox(params, this.fCreationDateInput);
	},

	connectHandlers: function() {
		this.fClickOKHandler= this.connect(this.fOkButton, 'click', dojo.hitch(this, function(event) { //$NON-NLS-1$
			this.onOk(event);
		}));
		this.fClickCancelHandler= this.connect(this.fCancelButton, 'click', dojo.hitch(this, function(event) { //$NON-NLS-1$
			this.onCancel(event);
		}));
	},

	onOk: function(event) {
		dojo.stopEvent(event);
		if (this.fNameInput.value == null || dojo.trim(this.fNameInput.value).length === 0) {
			if (this.fErrorMsg.hasChildNodes()) {
				this.fErrorMsg.removeChild(this.fErrorMsg.firstChild);
			}
			this.fErrorMsg.appendChild(dojo.doc.createTextNode(ReleasesMessages.RELEASES_EMPTY_ERRORMSG));
			this.fNameInput.focus();
			return ;
		}
		if (this.fReleasesName != null && (!(dojo.trim(this.fNameInput.value) === this.fEditedRelease.getName())) && !(dojo.indexOf(this.fReleasesName, dojo.trim(this.fNameInput.value)) === -1)) {
			if (this.fErrorMsg.hasChildNodes()) {
				this.fErrorMsg.removeChild(this.fErrorMsg.firstChild);
			}
			this.fErrorMsg.appendChild(dojo.doc.createTextNode(ReleasesMessages.RELEASES_DUPLICATE_ERRORMSG));
			this.fNameInput.focus();
			return ;
		}
		this.fEditedRelease.setName(dojo.trim(this.fNameInput.value));
		this.fEditedRelease.setDescription(dojo.trim(this.fDescriptionInput.value));
		if (this.fDateText.value != null) 
			this.fEditedRelease.setReleaseDate(this.fDateText.value.toUTCString());
		else 
			this.fEditedRelease.setReleaseDate(this.STRING_EMPTY);
		if (this.fEditedRelease.getSequenceValue() === 0 && this.fSequenceValue > 0 && this.fEditedRelease.getSequenceValue() !== this.fSequenceValue) {
			this.fEditedRelease.setSequenceValue(this.fSequenceValue);
		}
		this.fEditedRelease.setVisibleToTeam(this.fFilterCheckBox.isChecked());
		this.fEditedRelease.setModified();
		this.fEditedRelease.setDirty();
		this.fOkCallback();
		this.hide();
	},

	onCancel: function(event) {
		dojo.stopEvent(event);
		this.hide();
	},

	disconnectHandlers: function() {
		if (this.fClickOKHandler != null) {
			this.disconnect(this.fClickOKHandler);
			this.fClickOKHandler= null;
		}
		if (this.fClickCancelHandler != null) {
			this.disconnect(this.fClickCancelHandler);
			this.fClickCancelHandler= null;
		}
	},

	show: function() {
		var args= {};
		args.contentNode= this.domNode;
		if (this.fEditedRelease.getName() == null || dojo.trim(this.fEditedRelease.getName()).length === 0) 
			args.primaryTitle= ReleasesMessages.ADD_RELEASE;
		else 
			args.primaryTitle= dojo.string.substitute(ReleasesMessages.EDIT_RELEASE_LABEL, [this.fEditedRelease.getName()]);
		args.width= "40em"; //$NON-NLS-1$
		args.onClose= dojo.hitch(this, function() {
			this.onDialogClosed();
			return true;
		});
		this.fDialog= new Dialog(args);
		this.fNameInput.focus();
	},

	hide: function() {
		if (this.fDialog != null) 
			this.fDialog.close(null);
	},

	onDialogClosed: function() {
		this.destroy(false);
	},

	destroy: function(preserveDom) {
		this.disconnectHandlers();
		this.fFilterCheckBox.destroy(preserveDom);
		this.fDateText.destroy(preserveDom);
		this.inherited("destroy", arguments, [preserveDom]); //$NON-NLS-1$
	}
});

})();
