/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.ReleasesModel"); //$NON-NLS-1$

dojo.require("dojo.date.locale"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal.nls", "ReleasesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var ReleasesMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal.nls", "ReleasesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var ReleasesModel= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.ReleasesModel", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fReleasesArray: null,

	fPageDirtyCallBack: null,

	constructor: function(callBack) {
		this.fReleasesArray= [];
		this.fPageDirtyCallBack= callBack;
	},

	loadReleases: function(releases) {
		if (releases == null) {
			return ;
		}
		var entry;
		var $subject= releases;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var release= $subject[$count];
			entry= new ReleaseEntry();
			entry.fRelease= release;
			this.fReleasesArray.push(entry);
		}
	},

	getRootElements: function() {
		return this.fReleasesArray;
	},

	setPageDirty: function(value) {
		this.fPageDirtyCallBack(value);
	},

	getModifiedReleases: function() {
		var releases= [];
		var $subject2= this.fReleasesArray;
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var entry= $subject2[$count2];
			if (entry.fRelease.isModified) {
				releases.push(entry.fRelease);
			}
		}
		return releases;
	},

	getMaxSequenceValue: function() {
		var maxSequenceValue= 0;
		if (this.fReleasesArray != null) {
			var $subject3= this.fReleasesArray;
			var $length3= $subject3.length;
			for (var $count3= 0; $count3 < $length3; $count3++){
				var release= $subject3[$count3];
				maxSequenceValue= release.getSequenceValue() > maxSequenceValue ? release.getSequenceValue() : maxSequenceValue;
			}
		}
		return maxSequenceValue + 1;
	},

	addReleaseEntry: function(entry) {
		if (entry != null && entry.getName() != null && entry.getName().length > 0) {
			this.fReleasesArray.push(entry);
		}
	},

	getReleasesCount: function() {
		if (this.fReleasesArray == null) {
			return 0;
		}
		return this.fReleasesArray.length;
	},

	getReleasesNameList: function() {
		var nameList= [];
		var $subject4= this.fReleasesArray;
		var $length4= $subject4.length;
		for (var $count4= 0; $count4 < $length4; $count4++){
			var entry= $subject4[$count4];
			nameList.push(entry.getName());
		}
		return nameList;
	}
});

ReleasesModel.STRING_EMPTY= ""; //$NON-NLS-1$
var ReleasePageColumns= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.ReleasesModel.ReleasePageColumns", null, { //$NON-NLS-1$

	fLabel: null,

	constructor: function(label) {
		this.fLabel= label;
	},

	getIdentifier: function() {
		return this.name;
	},

	getLabel: function() {
		return this.fLabel;
	},

	compareTo: function(other) {
		return this.ordinal - other.ordinal;
	},

	$interfaces: {
		'com.ibm.jdojo.util.IMappable': true
	}
});

ReleasePageColumns.values= [
	dojo.mixin(new ReleasePageColumns(ReleasesMessages.ACTION_LABEL), {
		name: 'ACTIONS',
		ordinal: 0
	}),
	dojo.mixin(new ReleasePageColumns(ReleasesModel.STRING_EMPTY), {
		name: 'MARKER',
		ordinal: 1
	}),
	dojo.mixin(new ReleasePageColumns(ReleasesMessages.NAME_LABEL), {
		name: 'NAME',
		ordinal: 2
	}),
	dojo.mixin(new ReleasePageColumns(ReleasesMessages.RELEASE_DATE_LABEL), {
		name: 'RELEASE_DATE',
		ordinal: 3
	}),
	dojo.mixin(new ReleasePageColumns(ReleasesMessages.VISIBILITY_LABEL), {
		name: 'VISIBILITY',
		ordinal: 4
	}),
	dojo.mixin(new ReleasePageColumns(ReleasesMessages.ARTIFACT_LABEL), {
		name: 'ARTIFACT',
		ordinal: 5
	})
];
ReleasePageColumns.ACTIONS= ReleasePageColumns.values[0];
ReleasePageColumns.MARKER= ReleasePageColumns.values[1];
ReleasePageColumns.NAME= ReleasePageColumns.values[2];
ReleasePageColumns.RELEASE_DATE= ReleasePageColumns.values[3];
ReleasePageColumns.VISIBILITY= ReleasePageColumns.values[4];
ReleasePageColumns.ARTIFACT= ReleasePageColumns.values[5];
var ReleaseEntry= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.ReleasesModel.ReleaseEntry", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fRelease: null,

	fIsDirty: null,

	fCanMove: null,

	constructor: function() {
		this.fRelease= {};
		this.fIsDirty= false;
		this.fCanMove= true;
	},

	getName: function() {
		return this.fRelease.name;
	},

	setName: function(name) {
		this.fRelease.name= name;
	},

	getReleaseDate: function() {
		if (this.fRelease.creationDate > 0) {
			var options= {};
			options.selector= "date"; //$NON-NLS-1$
			options.formatLength= "long"; //$NON-NLS-1$
			return dojo.date.locale.format(new Date(this.fRelease.creationDate), options);
		}
		return null;
	},

	setReleaseDate: function(date) {
		if (date == null) {
			return ;
		}
		if (date === ReleasesModel.STRING_EMPTY) {
			this.fRelease.creationDate= 0;
			return ;
		}
		this.fRelease.creationDate= new Date(date).getTime();
	},

	isVisibleToTeam: function() {
		return this.fRelease.isFiltered;
	},

	setVisibleToTeam: function(filtered) {
		this.fRelease.isFiltered= filtered;
	},

	isArchived: function() {
		return this.fRelease.isArchived;
	},

	setArchived: function(archived) {
		this.fRelease.isArchived= archived;
	},

	getArtifact: function() {
		return this.fRelease.artifactUri;
	},

	setArtifact: function(artifact) {
		this.fRelease.artifactUri= artifact;
	},

	getDescription: function() {
		return this.fRelease.description;
	},

	setDescription: function(description) {
		this.fRelease.description= description;
	},

	getIdentifier: function() {
		if (this.fRelease.itemId == null) {
			return this.fRelease.sequenceValue.toString();
		}
		return this.fRelease.itemId;
	},

	isDirty: function() {
		return this.fIsDirty;
	},

	setDirty: function() {
		this.fIsDirty= true;
	},

	setModified: function() {
		this.fRelease.isModified= true;
	},

	setMoved: function() {
		this.fRelease.isMoved= true;
	},

	setSequenceValue: function(value) {
		this.fRelease.sequenceValue= value;
	},

	getSequenceValue: function() {
		return this.fRelease.sequenceValue;
	},

	setCanMove: function(value) {
		this.fCanMove= value;
	},

	canMove: function() {
		return this.fCanMove;
	},

	getPropertyValue: function(column) {
		switch(column) {
			case ReleasePageColumns.NAME:
				return this.getName();
			case ReleasePageColumns.RELEASE_DATE:
				return this.getReleaseDate();
			case ReleasePageColumns.ARTIFACT:
				return this.getArtifact();
			case ReleasePageColumns.VISIBILITY:
				var value;
				var bit1= 1;
				var bit0= 0;
				if (this.fRelease.isFiltered) {
					value= bit1.toString();
				} else {
					value= bit0.toString();
				}
				return value;
		}
		return ReleasesModel.STRING_EMPTY;
	},

	$interfaces: {
		'com.ibm.jdojo.util.IMappable': true //$NON-NLS-1$
	}
});

})();
