/*******************************************************************************
* Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.ReleasesPageActionMenu"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.IViewModel"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.actions.AbstractAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.toolbar.SimplePopupMenuManager"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.ReleasesDialog"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.ReleasesModel"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.SeparatorMenuItem"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal.nls", "ReleasesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var ItemStyle= com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle;
var Domain= com.ibm.team.rtc.foundation.api.ui.model.IViewModel.Domain;
var AbstractAction= com.ibm.team.rtc.foundation.web.ui.actions.AbstractAction;
var SimplePopupMenuManager= com.ibm.team.rtc.foundation.web.ui.toolbar.SimplePopupMenuManager;
var ReleasesMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal.nls", "ReleasesMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var ReleasesDialog= com.ibm.team.workitem.web.ui.internal.page.ReleasesDialog;
var ReleaseEntry= com.ibm.team.workitem.web.ui.internal.page.ReleasesModel.ReleaseEntry;
var SeparatorMenuItem= com.ibm.team.workitem.web.ui.internal.page.categories.SeparatorMenuItem;

var ReleasesPageActionMenu= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.ReleasesPageActionMenu", AbstractAction, { //$NON-NLS-1$

	fMenuManager: null,

	fRowEntry: null,

	fDefaultAction: null,

	constructor: function(defaultAction) {
		this.inherited(arguments, []);
		this.fDefaultAction= defaultAction;
		this.setName(ReleasesMessages.ACTION_MENU_NAME);
		if (defaultAction === ReleasesActionMenuItems.EDIT) {
			this.setIconUrl(ReleasesPageActionMenu.fIconFolder + "edit_category.gif"); //$NON-NLS-1$
		}
		this.setCanHandle(true);
	},

	getId: function() {
		return ReleasesPageActionMenu.ID;
	},

	handle: function() {
		if (this.canHandle() && this.fRowEntry != null && this.fDefaultAction === ReleasesActionMenuItems.EDIT) {
			var edit= new ReleasesPageEditAction(this.fRowEntry);
			edit.handle();
		}
	},

	getStyle: function() {
		return ItemStyle.DROP_DOWN;
	},

	getPopupMenu: function() {
		if (this.fMenuManager == null) {
			this.setInput(null, true);
		}
		return this.fMenuManager;
	},

	refresh: function(isSimpleToolBarMenu) {
		if (this.fMenuManager == null) {
			this.fMenuManager= new SimplePopupMenuManager();
			this.createItems(isSimpleToolBarMenu);
		} else {
			this.updateItems();
		}
	},

	setInput: function(rowEntry, isSimpleToolBarMenu) {
		this.fRowEntry= rowEntry;
		this.refresh(isSimpleToolBarMenu);
	},

	addItem: function(item, index) {
		if (index != null) {
			this.fMenuManager.addItemAt(index, item);
		} else {
			this.fMenuManager.addItem(item);
		}
		this.setCanHandle(!this.fMenuManager.isEmpty());
	},

	createItems: function(isSimpleToolBarMenu) {
		var items= ReleasesActionMenuItems.values;
		var itemCount= 0;
		for (var i= 0; i < 9; i++){
			if (items[i].ordinal === 1 || items[i].ordinal === 5) {
				this.addItem(new SeparatorMenuItem(), itemCount);
				itemCount++;
			}
			switch(items[i]) {
				case ReleasesActionMenuItems.EDIT:
					var edit= new ReleasesPageEditAction(this.fRowEntry);
					this.addItem(edit, itemCount);
					itemCount++;
					break;
				case ReleasesActionMenuItems.VISIBILITY:
					if (isSimpleToolBarMenu) {
						break;
					}
					var filter= new ReleasesPageFilterAction(this.fRowEntry);
					filter.setToogleIcon(true);
					this.addItem(filter, itemCount);
					itemCount++;
					break;
				case ReleasesActionMenuItems.VISIBILITYALL:
					var filterAll= new ReleasesPageFilterAction(this.fRowEntry);
					filterAll.setFilterALLSelected();
					filterAll.setToogleIcon(true);
					this.addItem(filterAll, itemCount);
					itemCount++;
					break;
				case ReleasesActionMenuItems.ARCHIVED:
					if (isSimpleToolBarMenu) {
						break;
					}
					var archive= new ReleasesPageToggleArchiveAction(this.fRowEntry);
					this.addItem(archive, itemCount);
					itemCount++;
					break;
				case ReleasesActionMenuItems.ARCHIVEALL:
					var archiveAll= new ReleasesPageToggleArchiveAction(this.fRowEntry);
					archiveAll.setToggleArchiveAllSelected();
					this.addItem(archiveAll, itemCount);
					itemCount++;
					break;
				case ReleasesActionMenuItems.MOVEUP:
					if (isSimpleToolBarMenu) {
						break;
					}
					var moveUp= new ReleasesPageMoveAction(this.fRowEntry);
					this.addItem(moveUp, itemCount);
					itemCount++;
					break;
				case ReleasesActionMenuItems.MOVEUPALL:
					var moveUpAll= new ReleasesPageMoveAction(this.fRowEntry);
					moveUpAll.setMoveAllSelected();
					this.addItem(moveUpAll, itemCount);
					itemCount++;
					break;
				case ReleasesActionMenuItems.MOVEDOWN:
					if (isSimpleToolBarMenu) {
						break;
					}
					var moveDown= new ReleasesPageMoveAction(this.fRowEntry);
					moveDown.setDirectionDown();
					this.addItem(moveDown, itemCount);
					itemCount++;
					break;
				case ReleasesActionMenuItems.MOVEDOWNALL:
					var moveDownAll= new ReleasesPageMoveAction(this.fRowEntry);
					moveDownAll.setDirectionDown();
					moveDownAll.setMoveAllSelected();
					this.addItem(moveDownAll, itemCount);
					itemCount++;
					break;
			}
			;
		}
	},

	updateItems: function() {
		var $subject= this.fMenuManager.getItems();
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var item= $subject[$count];
			if (item instanceof ReleasesGenericAction) {
				item.setInput(this.fRowEntry);
			}
		}
	},

	getDefaultAction: function() {
		return null;
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.actions.IPopupMenuItem': true //$NON-NLS-1$
	}
});

ReleasesPageActionMenu.fIconFolder= dojo.moduleUrl("com.ibm.team.workitem.web", "ui/internal/view/common/images/"); //$NON-NLS-1$ //$NON-NLS-2$
ReleasesPageActionMenu.ID= ReleasesPageActionMenu.prototype.declaredClass;
ReleasesPageActionMenu.STRING_EMPTY= ""; //$NON-NLS-1$
var ReleasesActionMenuItems= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.ReleasesPageActionMenu.ReleasesActionMenuItems", null, { //$NON-NLS-1$

	compareTo: function(other) {
		return this.ordinal - other.ordinal;
	}
});

ReleasesActionMenuItems.values= [
	dojo.mixin(new ReleasesActionMenuItems(), {
		name: 'EDIT',
		ordinal: 0
	}),
	dojo.mixin(new ReleasesActionMenuItems(), {
		name: 'VISIBILITY',
		ordinal: 1
	}),
	dojo.mixin(new ReleasesActionMenuItems(), {
		name: 'VISIBILITYALL',
		ordinal: 2
	}),
	dojo.mixin(new ReleasesActionMenuItems(), {
		name: 'ARCHIVED',
		ordinal: 3
	}),
	dojo.mixin(new ReleasesActionMenuItems(), {
		name: 'ARCHIVEALL',
		ordinal: 4
	}),
	dojo.mixin(new ReleasesActionMenuItems(), {
		name: 'MOVEUP',
		ordinal: 5
	}),
	dojo.mixin(new ReleasesActionMenuItems(), {
		name: 'MOVEUPALL',
		ordinal: 6
	}),
	dojo.mixin(new ReleasesActionMenuItems(), {
		name: 'MOVEDOWN',
		ordinal: 7
	}),
	dojo.mixin(new ReleasesActionMenuItems(), {
		name: 'MOVEDOWNALL',
		ordinal: 8
	}),
	dojo.mixin(new ReleasesActionMenuItems(), {
		name: 'POPUPMENU',
		ordinal: 9
	}),
	dojo.mixin(new ReleasesActionMenuItems(), {
		name: 'ADD',
		ordinal: 10
	})
];
ReleasesActionMenuItems.EDIT= ReleasesActionMenuItems.values[0];
ReleasesActionMenuItems.VISIBILITY= ReleasesActionMenuItems.values[1];
ReleasesActionMenuItems.VISIBILITYALL= ReleasesActionMenuItems.values[2];
ReleasesActionMenuItems.ARCHIVED= ReleasesActionMenuItems.values[3];
ReleasesActionMenuItems.ARCHIVEALL= ReleasesActionMenuItems.values[4];
ReleasesActionMenuItems.MOVEUP= ReleasesActionMenuItems.values[5];
ReleasesActionMenuItems.MOVEUPALL= ReleasesActionMenuItems.values[6];
ReleasesActionMenuItems.MOVEDOWN= ReleasesActionMenuItems.values[7];
ReleasesActionMenuItems.MOVEDOWNALL= ReleasesActionMenuItems.values[8];
ReleasesActionMenuItems.POPUPMENU= ReleasesActionMenuItems.values[9];
ReleasesActionMenuItems.ADD= ReleasesActionMenuItems.values[10];
var ReleasesGenericAction= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.ReleasesPageActionMenu.ReleasesGenericAction", AbstractAction, { //$NON-NLS-1$

	fRowEntry: null,

	constructor: function() {
		this.inherited(arguments, []);
	},

	setInput: function(rowEntry) {
		this.fRowEntry= rowEntry;
	}
});
var ReleasesPageEditAction= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.ReleasesPageActionMenu.ReleasesPageEditAction", ReleasesGenericAction, { //$NON-NLS-1$

	constructor: function(rowEntry) {
		this.inherited(arguments, []);
		this.fRowEntry= rowEntry;
	},

	getId: function() {
		return ReleasesPageEditAction.ID;
	},

	handle: function() {
		if (this.canHandle() && this.fRowEntry != null) {
			var params= {};
			params.sequenceValue= this.fRowEntry.getElement().getSequenceValue();
			params.editedRelease= this.fRowEntry.getElement();
			params.releasesName= this.fRowEntry.getModel().getInput().getReleasesNameList();
			params.onOK= dojo.hitch(this, function() {
				this.fRowEntry.getModel().updateModel(dojo.hitch(this, function(updateAccessor) {
					updateAccessor.update(this.fRowEntry, null);
					this.fRowEntry.getModel().getInput().setPageDirty(true);
					return null;
				}));
			});
			var dialog= new ReleasesDialog(params);
			dialog.show();
		}
	},

	getStyle: function() {
		return ItemStyle.FLAT;
	},

	canHandle: function() {
		if (this.fRowEntry == null) {
			return false;
		}
		return true;
	},

	getIconUrl: function() {
		return ReleasesPageActionMenu.fIconFolder + "edit_category.gif"; //$NON-NLS-1$
	},

	getName: function() {
		return ReleasesMessages.EDIT_RELEASE;
	}
});

ReleasesPageEditAction.ID= ReleasesPageEditAction.prototype.declaredClass;
var ReleasesPageToggleArchiveAction= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.ReleasesPageActionMenu.ReleasesPageToggleArchiveAction", ReleasesGenericAction, { //$NON-NLS-1$

	fIsMultipleItems: null,

	constructor: function(rowEntry) {
		this.inherited(arguments, []);
		this.fRowEntry= rowEntry;
		this.fIsMultipleItems= false;
	},

	getId: function() {
		return ReleasesPageToggleArchiveAction.ID;
	},

	handle: function() {
		if (this.canHandle() && this.fRowEntry != null) {
			var isMultiSelect= this.fIsMultipleItems;
			this.fRowEntry.getModel().updateModel(dojo.hitch(this, function(updateAccessor) {
				var isArchived= !this.fRowEntry.getElement().isArchived();
				if (isMultiSelect) {
					var selectedEntries= this.fRowEntry.getModel().getSelectedEntries();
					if (selectedEntries != null) {
						var $subject2= selectedEntries;
						var $length2= $subject2.length;
						for (var $count2= 0; $count2 < $length2; $count2++){
							var entry= $subject2[$count2];
							if (entry.getElement() instanceof ReleaseEntry) {
								entry.getElement().setArchived(isArchived);
								entry.getElement().setDirty();
								entry.getElement().setModified();
								updateAccessor.update(entry, null);
							}
						}
						this.fRowEntry.getModel().getInput().setPageDirty(true);
					}
				} else {
					this.fRowEntry.getElement().setArchived(isArchived);
					this.fRowEntry.getElement().setDirty();
					this.fRowEntry.getElement().setModified();
					updateAccessor.update(this.fRowEntry, null);
					this.fRowEntry.getModel().getInput().setPageDirty(true);
				}
				return null;
			}));
		}
	},

	getStyle: function() {
		return ItemStyle.FLAT;
	},

	canHandle: function() {
		if (this.fRowEntry == null) {
			return false;
		}
		if (!this.fIsMultipleItems && this.fRowEntry.getModel().getSelectedEntries().length > 0 && this.fRowEntry.getModel().isSelected(this.fRowEntry)) {
			return false;
		}
		if (this.fIsMultipleItems && this.fRowEntry.getModel().getSelectedEntries().length === 0) {
			return false;
		}
		if (this.fIsMultipleItems && this.fRowEntry.getModel().getSelectedEntries().length > 0 && !this.fRowEntry.getModel().isSelected(this.fRowEntry)) {
			return false;
		}
		return true;
	},

	setToggleArchiveAllSelected: function() {
		this.fIsMultipleItems= true;
	},

	getIconUrl: function() {
		if (this.fIsMultipleItems) {
			return null;
		}
		if (this.fRowEntry == null) {
			return ReleasesPageActionMenu.fIconFolder + "archive_co.gif"; //$NON-NLS-1$
		}
		var iconFile= this.fRowEntry.getElement().isArchived() ? "unarchive_co.gif" : "archive_co.gif"; //$NON-NLS-1$ //$NON-NLS-2$
		return ReleasesPageActionMenu.fIconFolder + iconFile;
	},

	getName: function() {
		if (this.fRowEntry == null) {
			return this.fIsMultipleItems ? ReleasesMessages.ARCHIVE_ALL_RELEASE : ReleasesMessages.ARCHIVE_RELEASE;
		}
		var name= ReleasesPageActionMenu.STRING_EMPTY;
		if (this.fIsMultipleItems) {
			name= this.fRowEntry.getElement().isArchived() ? ReleasesMessages.UNARCHIVE_ALL_RELEASE : ReleasesMessages.ARCHIVE_ALL_RELEASE;
		} else {
			name= this.fRowEntry.getElement().isArchived() ? ReleasesMessages.UNARCHIVE_RELEASE : ReleasesMessages.ARCHIVE_RELEASE;
		}
		return name;
	}
});

ReleasesPageToggleArchiveAction.ID= ReleasesPageToggleArchiveAction.prototype.declaredClass;
var ReleasesPageAddAction= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.ReleasesPageActionMenu.ReleasesPageAddAction", AbstractAction, { //$NON-NLS-1$

	fModel: null,

	constructor: function(model) {
		this.inherited(arguments, []);
		this.fModel= model;
	},

	getId: function() {
		return ReleasesPageAddAction.ID;
	},

	handle: function() {
		if (this.canHandle() && this.fModel != null) {
			var entry= new ReleaseEntry();
			var params= {};
			params.sequenceValue= this.fModel.getInput().getMaxSequenceValue();
			params.editedRelease= entry;
			entry.setSequenceValue(params.sequenceValue);
			entry.setArchived(false);
			entry.setVisibleToTeam(false);
			params.releasesName= this.fModel.getInput().getReleasesNameList();
			params.onOK= dojo.hitch(this, function() {
				if (entry.getName() != null && entry.getName().length > 0) {
					this.fModel.updateModel(dojo.hitch(this, function(updateAccessor) {
						var addEntry= updateAccessor.addEntry(Domain.Content, [], entry);
						if (addEntry == null) {
							return null;
						}
						this.fModel.getInput().addReleaseEntry(entry);
						this.fModel.getInput().setPageDirty(true);
						return null;
					}));
				}
			});
			var dialog= new ReleasesDialog(params);
			dialog.show();
		}
	},

	getStyle: function() {
		return ItemStyle.FLAT;
	},

	canHandle: function() {
		return !(this.fModel == null);
	},

	getIconUrl: function() {
		return ReleasesPageActionMenu.fIconFolder + "add.gif"; //$NON-NLS-1$
	},

	getName: function() {
		return ReleasesMessages.ADD_RELEASE;
	}
});

ReleasesPageAddAction.ID= ReleasesPageAddAction.prototype.declaredClass;
var ReleasesPageMoveAction= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.ReleasesPageActionMenu.ReleasesPageMoveAction", ReleasesGenericAction, { //$NON-NLS-1$

	fIsDirectionUp: null,

	fIsMultipleItems: null,

	constructor: function(rowEntry) {
		this.inherited(arguments, []);
		this.fRowEntry= rowEntry;
		this.fIsMultipleItems= false;
		this.fIsDirectionUp= true;
	},

	setDirectionDown: function() {
		this.fIsDirectionUp= false;
	},

	setMoveAllSelected: function() {
		this.fIsMultipleItems= true;
	},

	getId: function() {
		return ReleasesPageMoveAction.ID;
	},

	handle: function() {
		if (this.canHandle() && this.fRowEntry != null) {
			var isMultiSelect= this.fIsMultipleItems;
			var isDirectionUp= this.fIsDirectionUp;
			this.fRowEntry.getModel().updateModel(dojo.hitch(this, function(updateAccessor) {
				if (isMultiSelect) {
					var $subject3= this.fRowEntry.getModel().getSelectedEntries();
					var $length3= $subject3.length;
					for (var $count3= 0; $count3 < $length3; $count3++){
						var entry= $subject3[$count3];
						this.moveEntry(entry, updateAccessor, isDirectionUp);
					}
					this.fRowEntry.getModel().getInput().setPageDirty(true);
				} else {
					this.moveEntry(this.fRowEntry, updateAccessor, isDirectionUp);
					this.fRowEntry.getModel().getInput().setPageDirty(true);
				}
				return null;
			}));
		}
	},

	moveEntry: function(source, updateAccessor, isDirectionUp) {
		var targetEntry;
		var entryNavigator= updateAccessor.getEntryNavigator(false);
		targetEntry= isDirectionUp ? entryNavigator.predecessorEntry(source) : entryNavigator.successorEntry(source);
		if (targetEntry != null && targetEntry.getElement() instanceof ReleaseEntry) {
			var temp= targetEntry.getElement().getSequenceValue();
			targetEntry.getElement().setSequenceValue(source.getElement().getSequenceValue());
			targetEntry.getElement().setModified();
			source.getElement().setSequenceValue(temp);
			source.getElement().setModified();
			source.getElement().setDirty();
			updateAccessor.update(source, null);
			updateAccessor.update(targetEntry, null);
		}
	},

	getStyle: function() {
		return ItemStyle.FLAT;
	},

	canHandle: function() {
		if (this.fRowEntry == null || !(this.fRowEntry.getElement() instanceof ReleaseEntry) || !this.fRowEntry.getElement().canMove()) {
			return false;
		}
		if (!this.fIsMultipleItems && this.fRowEntry.getModel().getSelectedEntries().length > 0 && this.fRowEntry.getModel().isSelected(this.fRowEntry)) {
			return false;
		}
		if (this.fIsMultipleItems && this.fRowEntry.getModel().getSelectedEntries().length === 0) {
			return false;
		}
		if (this.fIsMultipleItems && this.fRowEntry.getModel().getSelectedEntries().length > 0 && !this.fRowEntry.getModel().isSelected(this.fRowEntry)) {
			return false;
		}
		var isDirectionUp= this.fIsDirectionUp;
		var isMultiSelect= this.fIsMultipleItems;
		return this.fRowEntry.getModel().readModel(dojo.hitch(this, function(readAccessor) {
			if (isMultiSelect) {
				var allMove= true;
				var $subject4= this.fRowEntry.getModel().getSelectedEntries();
				var $length4= $subject4.length;
				for (var $count4= 0; $count4 < $length4; $count4++){
					var selectedEntry= $subject4[$count4];
					allMove&= this.canMove(selectedEntry, readAccessor, isDirectionUp);
				}
				return allMove;
			} else {
				return this.canMove(this.fRowEntry, readAccessor, isDirectionUp);
			}
		}));
	},

	canMove: function(entry, readAccessor, directionUp) {
		var entryNavigator= readAccessor.getEntryNavigator(true);
		if (directionUp && entryNavigator.predecessorEntry(entry) == null) {
			return false;
		}
		if (!directionUp && entryNavigator.successorEntry(entry) == null) {
			return false;
		}
		return true;
	},

	getIconUrl: function() {
		if (this.fIsMultipleItems) {
			return this.inherited("getIconUrl", arguments, []); //$NON-NLS-1$
		}
		var iconFile= this.fIsDirectionUp ? "up.gif" : "down.gif"; //$NON-NLS-1$ //$NON-NLS-2$
		return ReleasesPageActionMenu.fIconFolder + iconFile;
	},

	getName: function() {
		var name= ""; //$NON-NLS-1$
		if (this.fIsMultipleItems) {
			name= this.fIsDirectionUp ? ReleasesMessages.MOVE_UP_ALL_LABEL : ReleasesMessages.MOVE_DOWN_ALL_LABEL;
		} else {
			name= this.fIsDirectionUp ? ReleasesMessages.MOVE_UP : ReleasesMessages.MOVE_DOWN;
		}
		return name;
	}
});

ReleasesPageMoveAction.ID= ReleasesPageMoveAction.prototype.declaredClass;
var ReleasesPageFilterAction= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.ReleasesPageActionMenu.ReleasesPageFilterAction", ReleasesGenericAction, { //$NON-NLS-1$

	fIsMultipleItems: null,

	fToogleIcon: null,

	constructor: function(rowEntry) {
		this.inherited(arguments, []);
		this.fRowEntry= rowEntry;
		this.fIsMultipleItems= false;
		this.fToogleIcon= false;
		this.inherited("setName", arguments, [ReleasesMessages.FILTERED_LABEL]); //$NON-NLS-1$
	},

	getId: function() {
		return ReleasesPageFilterAction.ID;
	},

	setToogleIcon: function(value) {
		this.fToogleIcon= value;
	},

	handle: function() {
		if (this.canHandle() && this.fRowEntry != null) {
			var isMultiSelect= this.fIsMultipleItems;
			this.fRowEntry.getModel().updateModel(dojo.hitch(this, function(updateAccessor) {
				var isFiltered= !this.fRowEntry.getElement().isVisibleToTeam();
				if (isMultiSelect) {
					var selectedEntries= this.fRowEntry.getModel().getSelectedEntries();
					if (selectedEntries != null) {
						var $subject5= selectedEntries;
						var $length5= $subject5.length;
						for (var $count5= 0; $count5 < $length5; $count5++){
							var entry= $subject5[$count5];
							if (entry.getElement() instanceof ReleaseEntry) {
								entry.getElement().setVisibleToTeam(isFiltered);
								entry.getElement().setDirty();
								entry.getElement().setModified();
								updateAccessor.update(entry, null);
							}
						}
						this.fRowEntry.getModel().getInput().setPageDirty(true);
					}
				} else {
					this.fRowEntry.getElement().setVisibleToTeam(isFiltered);
					this.fRowEntry.getElement().setDirty();
					this.fRowEntry.getElement().setModified();
					updateAccessor.update(this.fRowEntry, null);
					this.fRowEntry.getModel().getInput().setPageDirty(true);
				}
				return null;
			}));
		}
	},

	getStyle: function() {
		return ItemStyle.FLAT;
	},

	setFilterALLSelected: function() {
		this.fIsMultipleItems= true;
	},

	canHandle: function() {
		if (this.fRowEntry == null) {
			return false;
		}
		if (!this.fIsMultipleItems && this.fRowEntry.getModel().getSelectedEntries().length > 0 && this.fToogleIcon && this.fRowEntry.getModel().isSelected(this.fRowEntry)) {
			return false;
		}
		if (this.fIsMultipleItems && this.fRowEntry.getModel().getSelectedEntries().length === 0) {
			return false;
		}
		if (this.fIsMultipleItems && this.fRowEntry.getModel().getSelectedEntries().length > 0 && !this.fRowEntry.getModel().isSelected(this.fRowEntry)) {
			return false;
		}
		return true;
	},

	getIconUrl: function() {
		if (this.fIsMultipleItems) {
			return null;
		}
		if (this.fToogleIcon) 
			return null;
		if (this.fRowEntry == null) {
			return ReleasesPageActionMenu.fIconFolder + "checkbox_checked.png"; //$NON-NLS-1$
		}
		var iconFile= this.fRowEntry.getElement().isVisibleToTeam() ^ this.fToogleIcon ? "checkbox_checked.png" : "checkbox_unchecked.png"; //$NON-NLS-1$ //$NON-NLS-2$
		return ReleasesPageActionMenu.fIconFolder + iconFile;
	},

	getName: function() {
		if (this.fRowEntry == null) {
			return this.fIsMultipleItems ? ReleasesMessages.FILTERED_ALL_LABEL : this.inherited("getName", arguments, []); //$NON-NLS-1$
		}
		var name= ReleasesPageActionMenu.STRING_EMPTY;
		if (this.fIsMultipleItems) {
			name= this.fRowEntry.getElement().isVisibleToTeam() ? ReleasesMessages.UNFILTERED_ALL_LABEL : ReleasesMessages.FILTERED_ALL_LABEL;
		} else {
			name= this.fRowEntry.getElement().isVisibleToTeam() ? ReleasesMessages.UNFILTERED_LABEL : ReleasesMessages.FILTERED_LABEL;
		}
		return name;
	}
});

ReleasesPageFilterAction.ID= ReleasesPageFilterAction.prototype.declaredClass;
var ShowArhivedReleasesAction= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.ReleasesPageActionMenu.ShowArhivedReleasesAction", AbstractAction, { //$NON-NLS-1$

	fModel: null,

	fIsChecked: null,

	fArchiveFilter: null,

	constructor: function(filter) {
		this.inherited(arguments, []);
		this.fIsChecked= false;
		this.fArchiveFilter= filter;
	},

	updateViewModel: function(model) {
		this.fModel= model;
	},

	getId: function() {
		return ShowArhivedReleasesAction.prototype.declaredClass;
	},

	getName: function() {
		return ReleasesMessages.SHOW_ARCHIVED;
	},

	getIconUrl: function() {
		return null;
	},

	canHandle: function() {
		return true;
	},

	handle: function() {
		if (this.fModel == null) {
			return ;
		}
		this.fIsChecked= !this.fIsChecked;
		if (this.fModel.getInput() != null && this.fArchiveFilter != null) {
			if (this.fIsChecked) {
				this.fModel.removeFilter(this.fArchiveFilter);
			} else {
				this.fModel.addFilter(this.fArchiveFilter);
			}
		}
	},

	getStyle: function() {
		return ItemStyle.TOGGLE;
	},

	isChecked: function() {
		return this.fIsChecked;
	},

	setIsChecked: function(isChecked) {
		this.fIsChecked= isChecked;
	}
});
var ReleasesSimpleToolbarActionWrapper= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.ReleasesPageActionMenu.ReleasesSimpleToolbarActionWrapper", AbstractAction, { //$NON-NLS-1$

	fAction: null,

	fModel: null,

	fStyle: null,

	fPopUpMenuContainer: null,

	constructor: function(actionClass, label, iconUrl, style) {
		this.inherited(arguments, []);
		this.fAction= actionClass;
		this.fStyle= style;
		this.inherited("setName", arguments, [label]); //$NON-NLS-1$
		this.inherited("setIconUrl", arguments, [iconUrl]); //$NON-NLS-1$
		this.inherited("setCanHandle", arguments, [true]); //$NON-NLS-1$
	},

	getId: function() {
		return ReleasesSimpleToolbarActionWrapper.prototype.declaredClass;
	},

	handle: function() {
		if (this.inherited("canHandle", arguments, [])) { //$NON-NLS-1$
			if (this.fModel == null) {
				return ;
			}
			if (this.fAction === ReleasesActionMenuItems.ADD) {
				var add= new ReleasesPageAddAction(this.fModel);
				add.handle();
			}
			if (this.fModel.getSelectedEntries().length > 0) {
				this.setActionHandle(this.fModel.getSelectedEntries()[0]);
			}
		}
	},

	setActionHandle: function(rowEntry) {
		if (rowEntry == null) {
			return ;
		}
		switch(this.fAction) {
			case ReleasesActionMenuItems.ARCHIVED:
				if (this.fModel.getSelectedEntries().length === 0) {
					return ;
				}
				var archiveAction= this.getName() === ReleasesMessages.ARCHIVE_TOOLTIP ? true : false;
				this.fModel.updateModel(dojo.hitch(this, function(updateAccessor) {
					var $subject6= this.fModel.getSelectedEntries();
					var $length6= $subject6.length;
					for (var $count6= 0; $count6 < $length6; $count6++){
						var entry= $subject6[$count6];
						if (entry.getElement() instanceof ReleaseEntry && entry.getElement().isArchived() ^ archiveAction) {
							entry.getElement().setArchived(archiveAction);
							entry.getElement().setModified();
							entry.getElement().setDirty();
							updateAccessor.update(entry, null);
							this.fModel.getInput().setPageDirty(true);
						}
					}
					return null;
				}));
				break;
		}
		;
	},

	getStyle: function() {
		return this.fStyle;
	},

	updateViewModel: function(viewModel) {
		this.fModel= viewModel;
	},

	setPopUpMenuPlacement: function(container) {
		if (container == null) {
			return ;
		}
		this.fPopUpMenuContainer= container;
	}
});

})();
