/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2008, 2010.  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */
(function(){

dojo.provide("com.ibm.team.workitem.web.process.ui.internal.page.WorkItemConfigModel");

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.workitem.web.process.client.internal.WorkItemConfigClient");
dojo.require("com.ibm.team.workitem.web.process.ui.internal.page.models._TypeModel");
dojo.require("com.ibm.team.workitem.web.process.ui.internal.page.models._EnumerationModel");
dojo.require("com.ibm.team.workitem.web.process.ui.internal.page.models._PresentationModel");
dojo.require("com.ibm.team.workitem.web.process.ui.internal.page.models._WorkflowModel");
dojo.require("com.ibm.team.workitem.web.process.ui.internal.page.models._OSLCModel");
dojo.require("com.ibm.team.workitem.web.process.ui.internal.page.models._ProcessAttachmentModel");

var WorkItemConfigClient = com.ibm.team.workitem.web.process.client.internal.WorkItemConfigClient;
var ServiceResponseHandler	= com.ibm.team.repository.web.transport.ServiceResponseHandler;

dojo.declare(
	"com.ibm.team.workitem.web.process.ui.internal.page.WorkItemConfigModel",
	[
		com.ibm.team.workitem.web.process.ui.internal.page.models._TypeModel,
		com.ibm.team.workitem.web.process.ui.internal.page.models._EnumerationModel,
		com.ibm.team.workitem.web.process.ui.internal.page.models._PresentationModel,
		com.ibm.team.workitem.web.process.ui.internal.page.models._WorkflowModel,
		com.ibm.team.workitem.web.process.ui.internal.page.models._OSLCModel,
		com.ibm.team.workitem.web.process.ui.internal.page.models._ProcessAttachmentModel
	],
{    
    constructor: function(){
		WorkItemConfigClient.setCurrentProjectArea();
    },
	
	validate: function(){
		// there are only enumeration & workflow validation for now
		var msg = this.validateEnumerations();
		if(!msg){
			msg = this.validateWorkflows();
		}
		return msg;
	},
	
	postConfigurations: function(args){
		if(!args){
			args = {};
		}
		var self = this;
		var serviceObj= {
			success: function(configData) {
				var callback = args.callback;
				if(callback && dojo.isFunction(callback)){
					callback();
				}
			},
			failure: function(errorObj) {
				var error = args.error;
				if(error && dojo.isFunction(error)){
					error(errorObj);
				}
				self.onError(errorObj);
			}
		};
		var appArgs = {};
		var types = this.getTypesPostData();
		if(types){
			appArgs.types = types;
		}
		var enumerations = this.getEnumerationsPostData();
		if(enumerations){
			appArgs.enumerations = enumerations;
		}
		var presentations = this.getPresentationPostData();
		if(presentations){
			appArgs.presentations = presentations;
		}
		var workflows = this.getWorkflowPostData();
		if(workflows){
			appArgs.workflows = workflows;
		}
		var oslc = this.getOslcPostData();
		if(oslc){
			appArgs.oslc = oslc;
		}
		var srh = new ServiceResponseHandler(serviceObj, "success", "failure");
		WorkItemConfigClient.postConfigurations(srh, appArgs);
	}
});

})();