/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.IViewModel"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.actions.AbstractAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesModel"); //$NON-NLS-1$

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var Domain= com.ibm.team.rtc.foundation.api.ui.model.IViewModel.Domain;
var AbstractAction= com.ibm.team.rtc.foundation.web.ui.actions.AbstractAction;
var CategoryEntry= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesModel.CategoryEntry;

var CategoriesActionHelper= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" }
});

CategoriesActionHelper.fIconUrl= dojo.moduleUrl("com.ibm.team.workitem.web", "ui/internal/view/common/images/"); //$NON-NLS-1$ //$NON-NLS-2$
CategoriesActionHelper.CATEGORY_PATH_SEPARATOR= "/"; //$NON-NLS-1$
CategoriesActionHelper.iterateDescendants= function(updateAccessor, currentEntry, childAction) {
	var navigator= updateAccessor.getEntryNavigator(false);
	if (navigator == null || navigator.childEntries(currentEntry).length === 0) {
		return ;
	} else {
		var $subject= navigator.childEntries(currentEntry);
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var childEntry= $subject[$count];
			if (childEntry.getElement() instanceof CategoryEntry) {
				childAction(childEntry, currentEntry);
				updateAccessor.update(childEntry, null);
				CategoriesActionHelper.iterateDescendants(updateAccessor, childEntry, childAction);
			}
		}
	}
};
CategoriesActionHelper.archiveItem= function(updateAccessor, rowEntry, isArchived) {
	if (rowEntry == null || rowEntry.getElement().isRootCategory()) {
		return ;
	}
	if (!isArchived) {
		var parentEntry= updateAccessor.getParent(rowEntry);
		if (!parentEntry.getElement().isRootCategory() && parentEntry.getElement().fCategory.isArchived) {
			var parentRow= parentEntry.getElement();
			parentRow.fCategory.isArchived= isArchived;
			parentRow.setDirty();
			updateAccessor.update(parentEntry, null);
		}
	}
	var selectedRow= rowEntry.getElement();
	selectedRow.setDirty();
	selectedRow.fCategory.isArchived= isArchived;
	selectedRow.setIsModified(true);
	updateAccessor.update(rowEntry, null);
	var initialArchiveValue= !isArchived;
	CategoriesActionHelper.iterateDescendants(updateAccessor, rowEntry, dojo.hitch(this, function(childEntry, parentEntry) {
		if ((childEntry.getElement()).fCategory.isArchived === initialArchiveValue) {
			(childEntry.getElement()).fCategory.isArchived= (parentEntry.getElement()).fCategory.isArchived;
		}
		(childEntry.getElement()).setDirty();
	}));
	var addEntry= null;
	addEntry= rowEntry;
	updateAccessor.executeAfterUpdate(dojo.hitch(this, function() {
		addEntry.getModel().setEntryExpandState(addEntry, true);
	}));
};
CategoriesActionHelper.archiveAllItems= function(updateAccessor, selectedRowEntries, isArchived) {
	if (selectedRowEntries == null) {
		return ;
	}
	var $subject2= selectedRowEntries;
	var $length2= $subject2.length;
	for (var $count2= 0; $count2 < $length2; $count2++){
		var selectedEntry= $subject2[$count2];
		if (selectedEntry.getElement().isRootCategory()) {
			continue;
		}
		if (selectedEntry.getElement().fCategory.isArchived ^ isArchived) {
			CategoriesActionHelper.archiveItem(updateAccessor, selectedEntry, isArchived);
		}
	}
};
CategoriesActionHelper.associateItem= function(updateAccessor, rowEntry, initialTeamAreaId, finalTeamAreaId) {
	rowEntry.getModel().getInput().updateCategoryTeamAreaTimelineView(rowEntry.getElement(), initialTeamAreaId, finalTeamAreaId);
	rowEntry.getElement().setDirty();
	rowEntry.getElement().setIsModified(true);
	updateAccessor.update(rowEntry, null);
	CategoriesActionHelper.iterateDescendants(updateAccessor, rowEntry, dojo.hitch(this, function(child, parent) {
		var model= child.getModel().getInput();
		var teamAreaId= model.getCategoryTeamAreaId(child.getElement());
		if (teamAreaId === initialTeamAreaId) {
			model.updateCategoryTeamAreaTimelineView(child.getElement(), initialTeamAreaId, finalTeamAreaId);
			child.getElement().setDirty();
		}
	}));
	var addEntry= null;
	addEntry= rowEntry;
	updateAccessor.executeAfterUpdate(dojo.hitch(this, function() {
		addEntry.getModel().setEntryExpandState(addEntry, true);
	}));
};
CategoriesActionHelper.associateAllItems= function(updateAccessor, selectedRowEntries, initialTeamAreaId, finalTeamAreaId) {
	if (selectedRowEntries == null) {
		return ;
	}
	var $subject3= selectedRowEntries;
	var $length3= $subject3.length;
	for (var $count3= 0; $count3 < $length3; $count3++){
		var selectedEntry= $subject3[$count3];
		CategoriesActionHelper.associateItem(updateAccessor, selectedEntry, initialTeamAreaId, finalTeamAreaId);
	}
};
CategoriesActionHelper.disassociateItem= function(updateAccessor, rowEntry) {
	if (rowEntry == null) {
		return ;
	}
	if (rowEntry.getElement().isRootCategory()) {
		var projectAreaId= null;
		var initialTeamAreaId= rowEntry.getElement().getCurrentTeamAreaId();
		CategoriesActionHelper.associateItem(updateAccessor, rowEntry, initialTeamAreaId, projectAreaId);
	} else {
		var parentEntry= updateAccessor.getParent(rowEntry);
		if (parentEntry != null && parentEntry.getElement() instanceof CategoryEntry) {
			var finalTeamAreaId= parentEntry.getElement().getCurrentTeamAreaId();
			var defaultTeamAreaId= parentEntry.getElement().fCategory.defaultTeamArea;
			if ((finalTeamAreaId == null || finalTeamAreaId.length === 0)) {
				if (defaultTeamAreaId != null && defaultTeamAreaId.length > 0) {
					finalTeamAreaId= defaultTeamAreaId;
				} else {
					finalTeamAreaId= null;
				}
			}
			var initialTeamAreaId= rowEntry.getElement().getCurrentTeamAreaId();
			if (initialTeamAreaId !== finalTeamAreaId) {
				CategoriesActionHelper.associateItem(updateAccessor, rowEntry, initialTeamAreaId, finalTeamAreaId);
			}
		}
	}
};
CategoriesActionHelper.disassociateAllItems= function(updateAccessor, selectedRowEntries) {
	if (selectedRowEntries == null) {
		return ;
	}
	var $subject4= selectedRowEntries;
	var $length4= $subject4.length;
	for (var $count4= 0; $count4 < $length4; $count4++){
		var selectedEntry= $subject4[$count4];
		if (selectedEntry.getElement().isRootCategory()) {
			continue;
		}
		CategoriesActionHelper.disassociateItem(updateAccessor, selectedEntry);
	}
};
CategoriesActionHelper.filterAllItems= function(updateAccessor, selectedRowEntries, isFiltered) {
	if (selectedRowEntries == null) {
		return ;
	}
	var $subject5= selectedRowEntries;
	var $length5= $subject5.length;
	for (var $count5= 0; $count5 < $length5; $count5++){
		var selectedEntry= $subject5[$count5];
		if (selectedEntry.getElement().fCategory.isFiltered ^ isFiltered) {
			CategoriesActionHelper.filterItem(updateAccessor, selectedEntry, isFiltered);
		}
	}
};
CategoriesActionHelper.filterItem= function(updateAccessor, rowEntry, isFiltered) {
	if (!isFiltered && !rowEntry.getElement().isRootCategory()) {
		var parentEntry= updateAccessor.getParent(rowEntry);
		while(parentEntry != null && parentEntry.getElement() instanceof CategoryEntry && parentEntry.getElement().fCategory.isFiltered){
			CategoriesActionHelper.updateParentFilter(updateAccessor, parentEntry, isFiltered);
			parentEntry= updateAccessor.getParent(parentEntry);
		}
	}
	var selectedRow= rowEntry.getElement();
	selectedRow.setDirty();
	selectedRow.fCategory.isFiltered= isFiltered;
	selectedRow.setIsModified(true);
	updateAccessor.update(rowEntry, null);
	CategoriesActionHelper.iterateDescendants(updateAccessor, rowEntry, dojo.hitch(this, function(childEntry, parentEntry) {
		(childEntry.getElement()).fCategory.isFiltered= (parentEntry.getElement()).fCategory.isFiltered;
		(childEntry.getElement()).setDirty();
	}));
	var addEntry= null;
	addEntry= rowEntry;
	updateAccessor.executeAfterUpdate(dojo.hitch(this, function() {
		addEntry.getModel().setEntryExpandState(addEntry, true);
	}));
};
CategoriesActionHelper.readAccessAllItems= function(updateAccessor, selectedRowEntries, isReadAccessEnabled) {
	if (selectedRowEntries == null) {
		return ;
	}
	var $subject6= selectedRowEntries;
	var $length6= $subject6.length;
	for (var $count6= 0; $count6 < $length6; $count6++){
		var selectedEntry= $subject6[$count6];
		if (selectedEntry.getElement().fCategory.isReadAccessEnabled ^ isReadAccessEnabled) {
			CategoriesActionHelper.readAccessItem(updateAccessor, selectedEntry, isReadAccessEnabled);
		}
	}
};
CategoriesActionHelper.readAccessItem= function(updateAccessor, rowEntry, isReadAccessEnabled) {
	if (!isReadAccessEnabled && !rowEntry.getElement().isRootCategory()) {
		var parentEntry= updateAccessor.getParent(rowEntry);
		while(parentEntry != null && parentEntry.getElement() instanceof CategoryEntry && parentEntry.getElement().fCategory.isReadAccessEnabled){
			CategoriesActionHelper.updateParentReadAccess(updateAccessor, parentEntry, isReadAccessEnabled);
			parentEntry= updateAccessor.getParent(parentEntry);
		}
	}
	var selectedRow= rowEntry.getElement();
	selectedRow.setDirty();
	selectedRow.fCategory.isReadAccessEnabled= isReadAccessEnabled;
	selectedRow.setIsModified(true);
	updateAccessor.update(rowEntry, null);
	CategoriesActionHelper.iterateDescendants(updateAccessor, rowEntry, dojo.hitch(this, function(childEntry, parentEntry) {
		(childEntry.getElement()).fCategory.isReadAccessEnabled= (parentEntry.getElement()).fCategory.isReadAccessEnabled;
		(childEntry.getElement()).setDirty();
	}));
	var addEntry= null;
	addEntry= rowEntry;
	updateAccessor.executeAfterUpdate(dojo.hitch(this, function() {
		addEntry.getModel().setEntryExpandState(addEntry, true);
	}));
};
CategoriesActionHelper.moveItem= function(updateAccessor, responseData) {
	var current= responseData.getCurrentElement().getElement();
	if (current.isRootCategory()) {
		return ;
	}
	var oldParent= responseData.getOldParent().getElement();
	var newParent= responseData.getNewParent().getElement();
	var oldCategoryId= current.fCategory.categoryId;
	current.fCategory.categoryId= newParent.fCategory.categoryId;
	if (newParent.fCategory.isArchived && !current.fCategory.isArchived) {
		current.fCategory.isArchived= newParent.fCategory.isArchived;
	}
	if (newParent.fCategory.isFiltered && !current.fCategory.isFiltered) {
		current.fCategory.isFiltered= newParent.fCategory.isFiltered;
	}
	if (newParent.fCategory.isReadAccessEnabled && !current.fCategory.isReadAccessEnabled) {
		current.fCategory.isReadAccessEnabled= newParent.fCategory.isReadAccessEnabled;
	}
	current.fCategory.categoryId+= current.fCategory.name + CategoriesActionHelper.CATEGORY_PATH_SEPARATOR;
	current.fCategory.isModified= true;
	current.setDirty();
	responseData.getCurrentElement().getModel().getInput().updateCategoryEntry(oldCategoryId, current);
	var allCategoriesOnPath= responseData.getCurrentElement().getModel().getInput().getAllCategoriesOnPath(current.fCategory.categoryId);
	var addEntry= null;
	if (allCategoriesOnPath.length > 1) {
		var parentCategories= allCategoriesOnPath.slice(0, allCategoriesOnPath.length - 1);
		addEntry= updateAccessor.addEntry(Domain.Content, parentCategories, current);
		addEntry.getModel().getInput().setPendingChanges(true);
	}
	CategoriesActionHelper.iterateDescendants(updateAccessor, responseData.getCurrentElement(), dojo.hitch(this, function(child, parent) {
		var childEntry= child.getElement();
		var oldCategoryId= childEntry.fCategory.categoryId;
		childEntry.fCategory.categoryId= parent.getElement().fCategory.categoryId;
		childEntry.fCategory.categoryId+= childEntry.fCategory.name + CategoriesActionHelper.CATEGORY_PATH_SEPARATOR;
		if (parent.getElement().fCategory.isArchived && !childEntry.fCategory.isArchived) {
			childEntry.fCategory.isArchived= parent.getElement().fCategory.isArchived;
		}
		if (parent.getElement().fCategory.isFiltered && !childEntry.fCategory.isFiltered) {
			childEntry.fCategory.isFiltered= parent.getElement().fCategory.isFiltered;
		}
		if (parent.getElement().fCategory.isReadAccessEnabled && !childEntry.fCategory.isReadAccessEnabled) {
			childEntry.fCategory.isReadAccessEnabled= parent.getElement().fCategory.isReadAccessEnabled;
		}
		childEntry.setDirty();
		child.getModel().getInput().updateCategoryEntry(oldCategoryId, childEntry);
		var allCategoriesOnPath= child.getModel().getInput().getAllCategoriesOnPath(childEntry.fCategory.categoryId);
		if (allCategoriesOnPath.length > 1) {
			var parentCategories= allCategoriesOnPath.slice(0, allCategoriesOnPath.length - 1);
			updateAccessor.addEntry(Domain.Content, parentCategories, childEntry);
		}
	}));
	var removeEntry= CategoriesActionHelper.removeEntry(updateAccessor, responseData.getCurrentElement());
	if (removeEntry != null) {
		updateAccessor.removeEntry(removeEntry);
	}
	if (addEntry != null && oldParent.getCurrentTeamAreaId() === addEntry.getElement().getCurrentTeamAreaId()) {
		CategoriesActionHelper.disassociateItem(updateAccessor, addEntry);
	}
	updateAccessor.executeAfterUpdate(dojo.hitch(this, function() {
		addEntry.getModel().setEntryExpandState(addEntry, true);
	}));
};
CategoriesActionHelper.selectedEntriesHasRoot= function(rowEntry) {
	if (rowEntry == null || !rowEntry.getModel().isSelected(rowEntry) || rowEntry.getModel().getSelectedEntries().length === 0) {
		return rowEntry.getElement().isRootCategory();
	}
	var entries= rowEntry.getModel().getSelectedEntries();
	var $subject7= entries;
	var $length7= $subject7.length;
	for (var $count7= 0; $count7 < $length7; $count7++){
		var entry= $subject7[$count7];
		if (jdojo.implementsInterface(entry, "com.ibm.team.rtc.foundation.api.ui.model.IViewEntry") && entry.getElement() instanceof CategoryEntry) {
			if (entry.getElement().isRootCategory()) {
				return true;
			}
		}
	}
	return false;
};
CategoriesActionHelper.removeEntry= function(updateAccessor, parentEntry) {
	if (updateAccessor.getChildren(parentEntry) == null || updateAccessor.getChildren(parentEntry).length === 0) {
		return parentEntry;
	}
	var $subject8= updateAccessor.getChildren(parentEntry);
	var $length8= $subject8.length;
	for (var $count8= 0; $count8 < $length8; $count8++){
		var entry= $subject8[$count8];
		var childEntry= CategoriesActionHelper.removeEntry(updateAccessor, entry);
		if (childEntry != null) {
			updateAccessor.removeEntry(childEntry);
		}
	}
	return parentEntry;
};
CategoriesActionHelper.updateParentFilter= function(updateAccessor, parentEntry, isFiltered) {
	var parentRow= parentEntry.getElement();
	parentRow.fCategory.isFiltered= isFiltered;
	parentRow.setDirty();
	updateAccessor.update(parentEntry, null);
};
CategoriesActionHelper.updateParentReadAccess= function(updateAccessor, parentEntry, isReadAccessEnabled) {
	var parentRow= parentEntry.getElement();
	parentRow.fCategory.isReadAccessEnabled= isReadAccessEnabled;
	parentRow.setDirty();
	updateAccessor.update(parentEntry, null);
};
dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper.CategoriesAction", AbstractAction, { //$NON-NLS-1$

	fRowEntry: null,

	constructor: function() {
		this.inherited(arguments, []);
	},

	setInput: function(rowEntry) {
		this.fRowEntry= rowEntry;
	}
});

})();
