/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesArchiveUnArchiveAllAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var ItemStyle= com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle;
var CategoriesMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var CategoriesActionHelper= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper;
var CategoriesAction= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper.CategoriesAction;

var CategoriesArchiveUnArchiveAllAction= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesArchiveUnArchiveAllAction", CategoriesAction, { //$NON-NLS-1$

	constructor: function(rowEntry) {
		this.inherited(arguments, []);
		this.fRowEntry= rowEntry;
		this.setCanHandle(true);
		this.setName(CategoriesMessages.ARCHIVE_ALL_CATEGORY);
	},

	getId: function() {
		return CategoriesArchiveUnArchiveAllAction.ID;
	},

	getName: function() {
		if (this.fRowEntry == null) {
			return this.inherited("getName", arguments, []); //$NON-NLS-1$
		}
		if (!this.fRowEntry.getElement().fCategory.isArchived) {
			return CategoriesMessages.ARCHIVE_ALL_CATEGORY;
		} else {
			return CategoriesMessages.UNARCHIVE_ALL_CATEGORY;
		}
	},

	getIconUrl: function() {
		return null;
	},

	canHandle: function() {
		if (this.fRowEntry == null || this.fRowEntry.getModel().getSelectedEntries().length === 0) {
			return false;
		} else if (this.fRowEntry.getModel().getSelectedEntries().length > 0 && !this.fRowEntry.getModel().isSelected(this.fRowEntry)) {
			return false;
		}
		return !CategoriesActionHelper.selectedEntriesHasRoot(this.fRowEntry);
	},

	handle: function() {
		if (this.canHandle()) {
			var isArchived= !this.fRowEntry.getElement().fCategory.isArchived;
			var selectedRows= this.fRowEntry.getModel().getSelectedEntries();
			if (selectedRows == null) {
				return ;
			}
			this.fRowEntry.getModel().updateModel(dojo.hitch(this, function(updateAccessor) {
				var selectedRowEntries= this.fRowEntry.getModel().getSelectedEntries();
				CategoriesActionHelper.archiveAllItems(updateAccessor, selectedRowEntries, isArchived);
				this.fRowEntry.getModel().getInput().setPendingChanges(true);
				return null;
			}));
		}
	},

	getStyle: function() {
		return ItemStyle.FLAT;
	}
});

CategoriesArchiveUnArchiveAllAction.ID= CategoriesArchiveUnArchiveAllAction.prototype.declaredClass;

})();
