/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesAssociateAllAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesTeamAreaDialog"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var ItemStyle= com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle;
var CategoriesMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var CategoriesActionHelper= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper;
var CategoriesAction= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper.CategoriesAction;
var CategoriesTeamAreaDialog= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesTeamAreaDialog;

var CategoriesAssociateAllAction= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesAssociateAllAction", CategoriesAction, { //$NON-NLS-1$

	constructor: function(rowEntry) {
		this.inherited(arguments, []);
		this.fRowEntry= rowEntry;
		this.setCanHandle(true);
		this.inherited("setName", arguments, [CategoriesMessages.ASSOCIATE_ALL_CATEGORY]); //$NON-NLS-1$
	},

	getId: function() {
		return CategoriesAssociateAllAction.ID;
	},

	getName: function() {
		return this.inherited("getName", arguments, []); //$NON-NLS-1$
	},

	getIconUrl: function() {
		return null;
	},

	canHandle: function() {
		if (this.fRowEntry == null || this.fRowEntry.getModel().getSelectedEntries().length === 0) {
			return false;
		} else if (this.fRowEntry.getModel().getInput().teamAreasViewSize() === 0) {
			return false;
		} else if (this.fRowEntry.getModel().getSelectedEntries().length > 0 && !this.fRowEntry.getModel().isSelected(this.fRowEntry)) {
			return false;
		}
		return true;
	},

	handle: function() {
		if (this.canHandle()) {
			var parms= {};
			parms.categoriesModel= this.fRowEntry.getModel().getInput();
			parms.selectedCategory= this.fRowEntry.getElement();
			parms.onOK= dojo.hitch(this, function(initialTeamAreaId, finalTeamAreaId) {
				var selectedRows= this.fRowEntry.getModel().getSelectedEntries();
				if (selectedRows == null) {
					return ;
				}
				this.fRowEntry.getModel().updateModel(dojo.hitch(this, function(updateAccessor) {
					CategoriesActionHelper.associateAllItems(updateAccessor, selectedRows, initialTeamAreaId, finalTeamAreaId);
					this.fRowEntry.getModel().getInput().setPendingChanges(true);
					return null;
				}));
			});
			var dialogBox= new CategoriesTeamAreaDialog(parms);
			dialogBox.show();
		}
	},

	getStyle: function() {
		return ItemStyle.FLAT;
	}
});

CategoriesAssociateAllAction.ID= CategoriesAssociateAllAction.prototype.declaredClass;

})();
