/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesAssociatedTeamAreasCell"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.SelectionCell"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesModel"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoryAssociateAction"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var SelectionCell= com.ibm.team.rtc.foundation.web.ui.gridviewer.SelectionCell;
var CategoriesMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var CategoryEntry= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesModel.CategoryEntry;
var CategoryAssociateAction= com.ibm.team.workitem.web.ui.internal.page.categories.CategoryAssociateAction;
var keys= dojo.keys;

dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesAssociatedTeamAreasCell", SelectionCell, { //$NON-NLS-1$

	fAssociateAction: null,

	constructor: function(column, rowEntry, viewer) {
		this.inherited(arguments, [column, rowEntry, viewer]);
		this.fAssociateAction= new CategoryAssociateAction(this.fRowEntry);
	},

	onMouseClick: function(event) {
		this.fAssociateAction.handle();
		return false;
	},

	doCreateCellContent: function(cellContainer) {
		if (this.fRowEntry == null || !(this.fRowEntry.getElement() instanceof CategoryEntry)) {
			return ;
		}
		if (!this.fAssociateAction.canHandle()) {
			dojo.addClass(cellContainer, "noTeamArea"); //$NON-NLS-1$
		} else if (dojo.hasClass(cellContainer, "noTeamArea")) { //$NON-NLS-1$
			dojo.removeClass(cellContainer, "noTeamArea"); //$NON-NLS-1$
		}
		dojo.addClass(cellContainer, "associatedTeamArea"); //$NON-NLS-1$
		if (dojo.hasClass(cellContainer, "archived")) { //$NON-NLS-1$
			dojo.removeClass(cellContainer, "archived"); //$NON-NLS-1$
		}
		var entry= this.fRowEntry.getElement();
		if (entry.fCategory.isArchived) {
			dojo.addClass(cellContainer, "archived"); //$NON-NLS-1$
		}
		var teamAreaId= entry.getCurrentTeamAreaId();
		var defaultTeamAreaId= this.fRowEntry.getElement().fCategory.defaultTeamArea;
		if (teamAreaId == null || teamAreaId.length === 0) {
			this.setProjectAreaAsTeamArea(cellContainer);
			return ;
		}
		var selectedTimelineIndex= this.getViewModel().getInput().getSelectedTimelineIndex();
		if (selectedTimelineIndex > 0 && (teamAreaId === defaultTeamAreaId)) {
			var teamAreaName= this.getViewModel().getInput().getTeamAreaNamePath(defaultTeamAreaId);
			teamAreaName+= CategoriesMessages.DEFAULT_TEAMAREA_LABEL;
			dojo.place(dojo.doc.createTextNode(teamAreaName), cellContainer);
			if (!dojo.hasClass(cellContainer, "archived")) { //$NON-NLS-1$
				dojo.addClass(cellContainer, "archived"); //$NON-NLS-1$
			}
			return ;
		}
		var teamAreaName= this.getViewModel().getInput().getTeamAreaNamePath(teamAreaId);
		var path= entry.fCategory.categoryId;
		var allCategoriesOnPath= this.fRowEntry.getModel().getInput().getAllCategoriesOnPath(path);
		if (allCategoriesOnPath != null && allCategoriesOnPath.length > 1 && teamAreaId === allCategoriesOnPath[allCategoriesOnPath.length - 2].getCurrentTeamAreaId()) {
			teamAreaName+= CategoriesMessages.INHERITED_TEAMAREA_LABEL;
			if (!dojo.hasClass(cellContainer, "archived")) { //$NON-NLS-1$
				dojo.addClass(cellContainer, "archived"); //$NON-NLS-1$
			}
		}
		dojo.place(dojo.doc.createTextNode(teamAreaName), cellContainer);
	},

	isProjectAreaInherited: function() {
		return this.getViewModel().readModel(dojo.hitch(this, function(readAccessor) {
			var parent= readAccessor.getParent(this.fRowEntry);
			if (parent.getElement() instanceof CategoryEntry) {
				if (parent.getElement().getCurrentTeamAreaId() == null || parent.getElement().getCurrentTeamAreaId().length === 0) {
					return true;
				}
			}
			return false;
		}));
	},

	setProjectAreaAsTeamArea: function(cellContainer) {
		var teamAreaName= this.getViewModel().getInput().getProjectAreaName();
		var defaultTeamArea= this.fRowEntry.getElement().fCategory.defaultTeamArea;
		var selectedTimelineIndex= this.getViewModel().getInput().getSelectedTimelineIndex();
		if (selectedTimelineIndex > 0 && (defaultTeamArea == null || defaultTeamArea.length === 0)) {
			teamAreaName+= CategoriesMessages.DEFAULT_TEAMAREA_LABEL;
		} else if (!this.fRowEntry.getElement().isRootCategory() && this.isProjectAreaInherited()) {
			teamAreaName+= CategoriesMessages.INHERITED_TEAMAREA_LABEL;
		}
		dojo.place(dojo.doc.createTextNode(teamAreaName), cellContainer);
		if (!dojo.hasClass(cellContainer, "archived")) { //$NON-NLS-1$
			dojo.addClass(cellContainer, "archived"); //$NON-NLS-1$
		}
	},

	onKeyDown: function(event) {
		if (event.keyCode === keys.ENTER) {
			this.fAssociateAction.handle();
			event.preventDefault();
			return true;
		}
		return false;
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.IKeyboardHandler': true //$NON-NLS-1$
	}
});

})();
