/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesCell"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.SelectionCell"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.TreeTwistie"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesGadgetTreeUtility"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesModel"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoryEditAction"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var SelectionCell= com.ibm.team.rtc.foundation.web.ui.gridviewer.SelectionCell;
var TreeTwistie= com.ibm.team.rtc.foundation.web.ui.gridviewer.TreeTwistie;
var CategoriesMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var CategoriesGadgetTreeUtility= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesGadgetTreeUtility;
var CategoryEntry= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesModel.CategoryEntry;
var CategoryEditAction= com.ibm.team.workitem.web.ui.internal.page.categories.CategoryEditAction;
var keys= dojo.keys;

dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesCell", SelectionCell, { //$NON-NLS-1$

	fTreeTwistie: null,

	fEditCategoryAction: null,

	constructor: function(column, rowEntry, viewer) {
		this.inherited(arguments, [column, rowEntry, viewer]);
		this.fTreeTwistie= this.registerChild(new TreeTwistie(CategoriesGadgetTreeUtility.getTreeLevel(rowEntry), rowEntry, this.fViewer));
		if (this.fRowEntry != null && this.fRowEntry.getElement() instanceof CategoryEntry && !this.fRowEntry.getElement().isRootCategory()) {
			this.fEditCategoryAction= new CategoryEditAction(this.fRowEntry);
		}
	},

	onMouseClick: function(event) {
		if (this.fEditCategoryAction == null || this.fRowEntry.getElement().isRootCategory()) {
			return false;
		}
		this.fEditCategoryAction.handle();
		return false;
	},

	doCreateCellContent: function(cellContainer) {
		dojo.addClass(cellContainer, "categories"); //$NON-NLS-1$
		if (this.fRowEntry.getElement().isRootCategory()) {
			dojo.addClass(cellContainer, "rootCategory"); //$NON-NLS-1$
		}
		dojo.place(this.fTreeTwistie.createGadget(), cellContainer);
		var spanElement= dojo.create("span", null); //$NON-NLS-1$
		dojo.addClass(spanElement, "category"); //$NON-NLS-1$
		cellContainer.appendChild(spanElement);
		if (this.fRowEntry.getElement().fCategory.isArchived) {
			dojo.addClass(cellContainer, "archived"); //$NON-NLS-1$
		} else if (dojo.hasClass(cellContainer, "archived")) { //$NON-NLS-1$
			dojo.removeClass(cellContainer, "archived"); //$NON-NLS-1$
		}
		var categoryName= this.fRowEntry.getElement().fCategory.name;
		if (this.fRowEntry.getElement().isRootCategory()) {
			categoryName= CategoriesMessages.ROOT_CATEGORY_NAME;
		}
		dojo.place(dojo.doc.createTextNode(categoryName), spanElement);
	},

	onKeyDown: function(event) {
		if (event.keyCode === keys.ENTER) {
			if (this.fEditCategoryAction == null || this.fRowEntry.getElement().isRootCategory()) {
				return false;
			}
			this.fEditCategoryAction.handle();
			event.preventDefault();
			return true;
		}
		return false;
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.IKeyboardHandler': true //$NON-NLS-1$
	}
});

})();
