/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesDemoteAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.essentials.IModificationPolicy"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesModel"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var ItemStyle= com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle;
var Location= com.ibm.team.rtc.foundation.api.ui.essentials.IModificationPolicy.Location;
var CategoriesMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var CategoriesActionHelper= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper;
var CategoriesAction= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper.CategoriesAction;
var CategoryEntry= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesModel.CategoryEntry;

var CategoriesDemoteAction= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesDemoteAction", CategoriesAction, { //$NON-NLS-1$

	constructor: function(rowEntry) {
		this.inherited(arguments, []);
		this.fRowEntry= rowEntry;
		this.setCanHandle(true);
		this.setName(CategoriesMessages.DEMOTE_CATEGORY);
		this.setIconUrl(CategoriesActionHelper.fIconUrl + "increase_indent.gif"); //$NON-NLS-1$
	},

	getId: function() {
		return CategoriesDemoteAction.ID;
	},

	getName: function() {
		return this.inherited("getName", arguments, []); //$NON-NLS-1$
	},

	getIconUrl: function() {
		return this.inherited("getIconUrl", arguments, []); //$NON-NLS-1$
	},

	canHandle: function() {
		if (this.fRowEntry == null || !(this.fRowEntry.getElement() instanceof CategoryEntry) || this.fRowEntry.getElement().isRootCategory() || (this.fRowEntry.getModel().getSelectedEntries().length > 1 && this.fRowEntry.getModel().isSelected(this.fRowEntry))) 
			return false;
		return this.fRowEntry.getModel().readModel(dojo.hitch(this, function(readAccessor) {
			var n= readAccessor.getEntryNavigator(true);
			var predecessorEntry= n.predecessorEntry(this.fRowEntry);
			var successorEntry= n.successorEntry(this.fRowEntry);
			if (predecessorEntry != null) {
				var modificationPolicy= this.fRowEntry.getModel().getModificationPolicy();
				var toMove= [];
				toMove.push(this.fRowEntry);
				return modificationPolicy.canMove(toMove, predecessorEntry, Location.Child);
			} else if (successorEntry != null) {
				var modificationPolicy= this.fRowEntry.getModel().getModificationPolicy();
				var toMove= [];
				toMove.push(this.fRowEntry);
				return modificationPolicy.canMove(toMove, successorEntry, Location.Child);
			}
			return false;
		}));
	},

	handle: function() {
		this.fRowEntry.getModel().updateModel(dojo.hitch(this, function(updateAccessor) {
			var n= updateAccessor.getEntryNavigator(true);
			var modificationPolicy= this.fRowEntry.getModel().getModificationPolicy();
			var newParentEntry= n.predecessorEntry(this.fRowEntry);
			if (newParentEntry == null) {
				newParentEntry= n.successorEntry(this.fRowEntry);
			}
			var toMove= [];
			toMove.push(this.fRowEntry);
			modificationPolicy.move(toMove, newParentEntry, Location.Child);
			return null;
		}));
	},

	getStyle: function() {
		return ItemStyle.FLAT;
	}
});

CategoriesDemoteAction.ID= CategoriesDemoteAction.prototype.declaredClass;

})();
