/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesDisassociateAllAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var ItemStyle= com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle;
var CategoriesMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var CategoriesActionHelper= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper;
var CategoriesAction= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper.CategoriesAction;

var CategoriesDisassociateAllAction= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesDisassociateAllAction", CategoriesAction, { //$NON-NLS-1$

	constructor: function(rowEntry) {
		this.inherited(arguments, []);
		this.fRowEntry= rowEntry;
		this.setCanHandle(true);
		this.setName(CategoriesMessages.DISASSOCIATE_ALL_CATEGORY);
	},

	getId: function() {
		return CategoriesDisassociateAllAction.ID;
	},

	getName: function() {
		return this.inherited("getName", arguments, []); //$NON-NLS-1$
	},

	getIconUrl: function() {
		return null;
	},

	canHandle: function() {
		if (this.fRowEntry == null || this.fRowEntry.getModel().getSelectedEntries().length === 0) {
			return false;
		} else if (this.fRowEntry.getModel().getInput().teamAreasViewSize() === 0) {
			return false;
		} else if (this.fRowEntry.getElement().isRootCategory() && (this.fRowEntry.getElement().getCurrentTeamAreaId() == null || this.fRowEntry.getElement().getCurrentTeamAreaId().length === 0)) {
			return false;
		} else if (this.fRowEntry.getModel().getSelectedEntries().length > 0 && !this.fRowEntry.getModel().isSelected(this.fRowEntry)) {
			return false;
		} else {
			var path= this.fRowEntry.getElement().fCategory.categoryId;
			var allCategoriesOnPath= this.fRowEntry.getModel().getInput().getAllCategoriesOnPath(path);
			if (allCategoriesOnPath != null && allCategoriesOnPath.length > 1) {
				return !(this.fRowEntry.getElement().getCurrentTeamAreaId() === allCategoriesOnPath[allCategoriesOnPath.length - 2].getCurrentTeamAreaId());
			}
		}
		return !CategoriesActionHelper.selectedEntriesHasRoot(this.fRowEntry);
	},

	handle: function() {
		if (this.canHandle()) {
			var selectedRows= this.fRowEntry.getModel().getSelectedEntries();
			if (selectedRows == null) {
				return ;
			}
			this.fRowEntry.getModel().updateModel(dojo.hitch(this, function(updateAccessor) {
				CategoriesActionHelper.disassociateAllItems(updateAccessor, selectedRows);
				this.fRowEntry.getModel().getInput().setPendingChanges(true);
				return null;
			}));
		}
	},

	getStyle: function() {
		return ItemStyle.FLAT;
	}
});

CategoriesDisassociateAllAction.ID= CategoriesDisassociateAllAction.prototype.declaredClass;

})();
