/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesFilterAllAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var ItemStyle= com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle;
var CategoriesMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var CategoriesActionHelper= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper;
var CategoriesAction= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper.CategoriesAction;

var CategoriesFilterAllAction= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesFilterAllAction", CategoriesAction, { //$NON-NLS-1$

	fToggleVisibilityAction: null,

	constructor: function(rowEntry) {
		this.inherited(arguments, []);
		this.fRowEntry= rowEntry;
		this.setCanHandle(true);
		this.fToggleVisibilityAction= true;
		this.setName(CategoriesMessages.FILTERED_ALL_LABEL);
	},

	getId: function() {
		return CategoriesFilterAllAction.ID;
	},

	getName: function() {
		if (this.fRowEntry == null) {
			return this.inherited("getName", arguments, []); //$NON-NLS-1$
		}
		if (this.fRowEntry.getElement().fCategory.isFiltered) {
			if (!this.fToggleVisibilityAction) {
				return CategoriesMessages.UNFILTER_TOOLTIP;
			}
			return CategoriesMessages.UNFILTERED_ALL_LABEL;
		} else {
			if (!this.fToggleVisibilityAction) {
				return CategoriesMessages.FILTER_TOOLTIP;
			}
			return CategoriesMessages.FILTERED_ALL_LABEL;
		}
	},

	getIconUrl: function() {
		return null;
	},

	canHandle: function() {
		if (this.fRowEntry == null || this.fRowEntry.getModel().getSelectedEntries().length === 0) {
			return false;
		} else if (this.fRowEntry.getModel().getSelectedEntries().length > 0 && !this.fRowEntry.getModel().isSelected(this.fRowEntry)) {
			return false;
		}
		return true;
	},

	handle: function() {
		if (this.canHandle()) {
			var selectedRows= this.fRowEntry.getModel().getSelectedEntries();
			if (selectedRows == null) {
				return ;
			}
			this.fRowEntry.getModel().updateModel(dojo.hitch(this, function(updateAccessor) {
				if (this.fRowEntry.getModel().getSelectedEntries().length > 0) {
					CategoriesActionHelper.filterAllItems(updateAccessor, selectedRows, !this.fRowEntry.getElement().fCategory.isFiltered);
					this.fRowEntry.getModel().getInput().setPendingChanges(true);
				}
				return null;
			}));
		}
	},

	getStyle: function() {
		return ItemStyle.FLAT;
	},

	setToggleVisiblityAction: function(toggle) {
		this.fToggleVisibilityAction= toggle;
	}
});

CategoriesFilterAllAction.ID= CategoriesFilterAllAction.prototype.declaredClass;

})();
