/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesModel"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var CategoriesMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesModel", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fCategoriesMap: null,

	fDummyCategoriesMap: null,

	fTeamAreas: null,

	fTeamAreaTimelineGroup: null,

	fTimelines: null,

	fTeamAreasWithoutTimeLine: null,

	fAddedCategoriesCount: null,

	fTeamAreasTimeLineView: null,

	fSelectedTimelineIndex: null,

	fDirtyCallBack: null,

	fProjectAreaId: null,

	fProjectArea: null,

	constructor: function(projectAreaId, isDirty) {
		this.fCategoriesMap= {};
		this.fDummyCategoriesMap= {};
		this.fTeamAreas= {};
		this.fTeamAreaTimelineGroup= {};
		this.fTeamAreasWithoutTimeLine= [];
		this.fAddedCategoriesCount= 0;
		this.fTeamAreasTimeLineView= [];
		this.fSelectedTimelineIndex= 0;
		this.fProjectAreaId= projectAreaId;
		this.fDirtyCallBack= isDirty;
	},

	getCategoriesTree: function(index) {
		if (this.fCategoriesMap == null || jdojo.getProperties(this.fCategoriesMap).length < index) {
			return null;
		}
		return this.getAllCategoriesOnPath(jdojo.getProperties(this.fCategoriesMap)[index]);
	},

	categoriesSize: function() {
		if (this.fCategoriesMap == null) {
			return 0;
		}
		return jdojo.getProperties(this.fCategoriesMap).length;
	},

	addNewCategoryEntry: function(entry) {
		if (entry != null && !(entry.fCategory.categoryId in this.fCategoriesMap)) {
			this.fCategoriesMap[entry.fCategory.categoryId]= entry;
		}
	},

	updateCategoryEntry: function(oldKey, entry) {
		if (entry != null && (oldKey in this.fCategoriesMap)) {
			delete this.fCategoriesMap[oldKey];
			this.addNewCategoryEntry(entry);
		}
	},

	setPendingChanges: function(isPendingChanges) {
		this.fDirtyCallBack(isPendingChanges);
	},

	teamAreasViewSize: function() {
		if (this.fTeamAreasTimeLineView == null) {
			return 0;
		}
		return this.fTeamAreasTimeLineView.length;
	},

	timelineSize: function() {
		if (this.fTimelines == null) {
			return 0;
		}
		return this.fTimelines.length;
	},

	getTimeline: function(index) {
		if (this.fTimelines == null || index > this.fTimelines.length) {
			return null;
		}
		return this.fTimelines[index].name;
	},

	teamAreaSize: function() {
		if (this.fTeamAreas == null) {
			return 0;
		}
		return jdojo.getProperties(this.fTeamAreas).length;
	},

	teamAreaSizeExcludingArchived: function() {
		if (this.fTeamAreas == null) {
			return 0;
		}
		var count= 0;
		var $subject= jdojo.getProperties(this.fTeamAreas);
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var key= $subject[$count];
			if (!this.fTeamAreas[key].fTeamArea.isArchived) {
				count++;
			}
		}
		return count;
	},

	getTeamAreaNamePath: function(teamAreaId) {
		if (this.fTeamAreas == null || teamAreaId == null || teamAreaId.length === 0 || !(teamAreaId in this.fTeamAreas)) {
			return ""; //$NON-NLS-1$
		}
		var entry= this.fTeamAreas[teamAreaId];
		var path= entry.fTeamArea.name;
		if (entry.fTeamArea.parentItemId == null || entry.fTeamArea.parentItemId.length === 0) {
			return path;
		}
		var parentTeamAreaId= entry.fTeamArea.parentItemId;
		while(parentTeamAreaId != null && parentTeamAreaId !== this.fProjectAreaId){
			if (!(parentTeamAreaId in this.fTeamAreas)) {
				break;
			} else {
				var parentTeam= this.fTeamAreas[parentTeamAreaId];
				path= parentTeam.fTeamArea.name + "/" + path; //$NON-NLS-1$
				parentTeamAreaId= parentTeam.fTeamArea.parentItemId;
			}
		}
		return path;
	},

	getTimelineName: function(timelineId) {
		if (timelineId == null || timelineId.length === 0 || this.fTimelines == null) {
			return ""; //$NON-NLS-1$
		}
		for (var i= 0; i < this.fTimelines.length; i++){
			if (this.fTimelines[i].itemId === timelineId) {
				return this.fTimelines[i].name;
			}
		}
		return ""; //$NON-NLS-1$
	},

	setTimeLineIndex: function(timelineIndex) {
		if (timelineIndex < 0 || timelineIndex > this.fTimelines.length) {
			return ;
		}
		this.fSelectedTimelineIndex= timelineIndex;
		this.updateTimelineCategoryView();
		this.updateTeamAreasTimeLineView();
	},

	getProjectAreaName: function() {
		return this.fProjectArea.fTeamArea.name;
	},

	loadCategories: function(result) {
		if (result == null) {
			return ;
		}
		var categoryCount= 0;
		var $subject2= result;
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var category= $subject2[$count2];
			var entry= new CategoryEntry();
			entry.fCategory= category;
			entry.fCategory.isModified= false;
			if (category.defaultTeamArea != null) {
				if ((category.defaultTeamArea in this.fTeamAreas)) {
					entry.setCurrentTeamAreaId(category.defaultTeamArea);
				}
			} else {
				category.defaultTeamArea= null;
			}
			if (category.associatedTeamAreas == null) {
				category.associatedTeamAreas= [];
			}
			this.fCategoriesMap[category.categoryId]= entry;
			categoryCount++;
		}
	},

	setTimelines: function(timelineResults) {
		if (timelineResults == null) {
			return ;
		}
		this.fTimelines= timelineResults;
	},

	getSelectedTimelineIndex: function() {
		return this.fSelectedTimelineIndex;
	},

	getTeamAreaName: function(teamAreaId) {
		if (teamAreaId == null || teamAreaId.length === 0) {
			return ""; //$NON-NLS-1$
		}
		if ((teamAreaId in this.fTeamAreas)) {
			return this.fTeamAreas[teamAreaId].fTeamArea.name;
		}
		return ""; //$NON-NLS-1$
	},

	getCategoriesDTO: function() {
		var category= [];
		var $subject3= jdojo.getProperties(this.fCategoriesMap);
		var $length3= $subject3.length;
		for (var $count3= 0; $count3 < $length3; $count3++){
			var key= $subject3[$count3];
			category.push(this.fCategoriesMap[key].fCategory);
		}
		return category;
	},

	getCategoryTeamAreaId: function(entry) {
		if (entry == null || entry.fCategory.associatedTeamAreas == null) {
			return null;
		}
		if (this.fSelectedTimelineIndex === 0) {
			return entry.fCategory.defaultTeamArea;
		}
		var $subject4= entry.fCategory.associatedTeamAreas;
		var $length4= $subject4.length;
		for (var $count4= 0; $count4 < $length4; $count4++){
			var teamArea= $subject4[$count4];
			if ((teamArea in this.fTeamAreas) && this.fTeamAreas[teamArea].fTeamArea.timelineId === this.fTimelines[this.fSelectedTimelineIndex - 1].itemId) {
				return teamArea;
			}
		}
		return null;
	},

	loadTeamAreas: function(teamAreaResults) {
		if (teamAreaResults == null) {
			return ;
		}
		var $subject5= teamAreaResults;
		var $length5= $subject5.length;
		for (var $count5= 0; $count5 < $length5; $count5++){
			var teamArea= $subject5[$count5];
			var objEntry= new TeamAreaEntry();
			objEntry.fTeamArea= teamArea;
			if (teamArea.itemId === this.fProjectAreaId) {
				objEntry.fTeamArea.name+= CategoriesMessages.PROJECT_TEAMAREA_LABEL;
				this.fProjectArea= objEntry;
			}
			if (teamArea.itemId !== this.fProjectAreaId && teamArea.isArchived) {
				objEntry.fTeamArea.name+= CategoriesMessages.ARCHIVED_TEAMAREA_LABEL;
			}
			this.fTeamAreas[teamArea.itemId]= objEntry;
			if (teamArea.timelineId != null && teamArea.timelineId.length > 0) {
				if (!(teamArea.timelineId in this.fTeamAreaTimelineGroup)) {
					var arr= [];
					arr.push(teamArea.itemId);
					this.fTeamAreaTimelineGroup[teamArea.timelineId]= arr;
				} else {
					this.fTeamAreaTimelineGroup[teamArea.timelineId].push(teamArea.itemId);
				}
			} else if (teamArea.itemId !== this.fProjectAreaId) {
				this.fTeamAreasWithoutTimeLine.push(teamArea.itemId);
			}
		}
		this.updateTeamAreasTimeLineView();
	},

	getTeamAreasView: function(index) {
		if (this.fTeamAreasTimeLineView.length < index) {
			return null;
		}
		return this.fTeamAreasTimeLineView[index];
	},

	getProjectAreaId: function() {
		return this.fProjectAreaId;
	},

	/**
	 * Create the Team Area Timeline view to be used by Team Area Grid Viewer
	 * @param String TeamArea 
	 * 			the current team of the selected category  
	 */
	updateTeamAreasTimeLineView: function() {
		this.fTeamAreasTimeLineView= [];
		if (this.fSelectedTimelineIndex === 0) {
			for (var i= 0; i < jdojo.getProperties(this.fTeamAreaTimelineGroup).length; i++){
				if ((jdojo.getProperties(this.fTeamAreaTimelineGroup)[i] in this.fTeamAreaTimelineGroup)) {
					var $subject6= this.fTeamAreaTimelineGroup[jdojo.getProperties(this.fTeamAreaTimelineGroup)[i]];
					var $length6= $subject6.length;
					for (var $count6= 0; $count6 < $length6; $count6++){
						var teamAreaId= $subject6[$count6];
						var teamAreas= this.getTeamAreas(teamAreaId);
						if (teamAreas != null && teamAreas.length > 0) {
							this.fTeamAreasTimeLineView.push(teamAreas);
						}
					}
				}
			}
			var $subject7= this.fTeamAreasWithoutTimeLine;
			var $length7= $subject7.length;
			for (var $count7= 0; $count7 < $length7; $count7++){
				var teamAreaId= $subject7[$count7];
				var teamAreas= this.getTeamAreas(teamAreaId);
				if (teamAreas != null && teamAreas.length > 0) {
					this.fTeamAreasTimeLineView.push(teamAreas);
				}
			}
		} else {
			var timelineId= this.fTimelines[this.fSelectedTimelineIndex - 1].itemId;
			if ((timelineId in this.fTeamAreaTimelineGroup)) {
				var $subject8= this.fTeamAreaTimelineGroup[timelineId];
				var $length8= $subject8.length;
				for (var $count8= 0; $count8 < $length8; $count8++){
					var teamAreaId= $subject8[$count8];
					var teamAreas= this.getTeamAreas(teamAreaId);
					if (teamAreas != null && teamAreas.length > 0) {
						this.fTeamAreasTimeLineView.push(teamAreas);
					}
				}
			}
		}
	},

	getAllCategoriesOnPath: function(path) {
		if (path == null || path.length === 0) {
			return null;
		}
		var parents= this.parseCategory(path);
		var key= "/"; //$NON-NLS-1$
		var selectedEntries= [];
		for (var i= 0; i < parents.length; i++){
			key+= parents[i] + "/"; //$NON-NLS-1$
			if ((key in this.fCategoriesMap)) {
				selectedEntries.push(this.fCategoriesMap[key]);
			} else if ((key in this.fDummyCategoriesMap)) {
				selectedEntries.push(this.fDummyCategoriesMap[key]);
			}
		}
		return selectedEntries;
	},

	parseCategory: function(path) {
		if (path == null || path.length === 0) {
			return null;
		}
		var categoryPathNodes= [];
		var currentNode= ""; //$NON-NLS-1$
		var pathLength= path.length;
		for (var i= 0; i < pathLength; i++){
			if (path.charAt(i) !== "/") { //$NON-NLS-1$
				currentNode+= path.charAt(i);
			} else if (i > 0) {
				categoryPathNodes.push(currentNode);
				currentNode= ""; //$NON-NLS-1$
			}
		}
		return categoryPathNodes;
	},

	updateTimelineCategoryView: function() {
		if (this.fSelectedTimelineIndex < 0) {
			return ;
		}
		var $subject9= jdojo.getProperties(this.fCategoriesMap);
		var $length9= $subject9.length;
		for (var $count9= 0; $count9 < $length9; $count9++){
			var key= $subject9[$count9];
			if ((key in this.fCategoriesMap)) {
				var entryObj= this.fCategoriesMap[key];
				if (this.fSelectedTimelineIndex === 0 && (entryObj.fCategory.defaultTeamArea in this.fTeamAreas)) {
					entryObj.setCurrentTeamAreaId(entryObj.fCategory.defaultTeamArea);
				} else {
					var teamArea= this.getCategoryTeamAreaId(entryObj);
					entryObj.setCurrentTeamAreaId(teamArea);
				}
			}
		}
	},

	updateCategoryTeamAreaTimelineView: function(category, initialTeamAreaId, finalTeamAreaId) {
		if (category == null || (initialTeamAreaId === finalTeamAreaId)) {
			return ;
		}
		if (this.fSelectedTimelineIndex === 0) {
			initialTeamAreaId= category.fCategory.defaultTeamArea;
		}
		var initialIndex= -1;
		if (initialTeamAreaId != null && initialTeamAreaId.length > 0) {
			initialIndex= dojo.indexOf(category.fCategory.associatedTeamAreas, initialTeamAreaId);
		}
		if (initialIndex >= 0) {
			category.fCategory.associatedTeamAreas.splice(initialIndex, 1);
		}
		if (this.fSelectedTimelineIndex === 0 || this.fTimelines[this.fSelectedTimelineIndex - 1].isDefault) {
			category.fCategory.defaultTeamArea= finalTeamAreaId;
		}
		if (initialIndex === -1 && finalTeamAreaId != null) {
			if (category.fCategory.associatedTeamAreas == null) {
				category.fCategory.associatedTeamAreas= [];
			}
			category.fCategory.associatedTeamAreas.push(finalTeamAreaId);
		} else if (initialIndex >= 0 && finalTeamAreaId != null) {
			category.fCategory.associatedTeamAreas[initialIndex]= finalTeamAreaId;
		}
		category.setCurrentTeamAreaId(finalTeamAreaId);
	},

	createNewCategory: function(categoryName, categoryPath, categoryDescription, parentCategory) {
		if (categoryName == null || categoryName.length === 0) {
			return null;
		}
		var newEntry= new CategoryEntry();
		newEntry.fCategory= {};
		newEntry.fCategory.name= categoryName;
		newEntry.setDirty();
		newEntry.fCategory.categoryId= parentCategory.fCategory.categoryId + categoryName + "/"; //$NON-NLS-1$
		newEntry.fCategory.description= categoryDescription;
		newEntry.fCategory.isFiltered= parentCategory.fCategory.isFiltered;
		newEntry.fCategory.isArchived= parentCategory.fCategory.isArchived;
		newEntry.fCategory.isReadAccessEnabled= parentCategory.fCategory.isReadAccessEnabled;
		newEntry.fCategory.itemId= this.fAddedCategoriesCount + ""; //$NON-NLS-1$
		newEntry.fCategory.associatedTeamAreas= [];
		if (parentCategory.getAssociatedTeamAreas() != null) {
			var $subject10= parentCategory.getAssociatedTeamAreas();
			var $length10= $subject10.length;
			for (var $count10= 0; $count10 < $length10; $count10++){
				var teamArea= $subject10[$count10];
				newEntry.fCategory.associatedTeamAreas.push(teamArea);
			}
		}
		newEntry.fCategory.defaultTeamArea= parentCategory.fCategory.defaultTeamArea;
		newEntry.setCurrentTeamAreaId(parentCategory.getCurrentTeamAreaId());
		this.fAddedCategoriesCount++;
		newEntry.setIsModified(true);
		return newEntry;
	},

	getTeamAreas: function(teamArea) {
		if (teamArea == null || teamArea.length === 0 || !(teamArea in this.fTeamAreas)) {
			return null;
		}
		var entry= this.fTeamAreas[teamArea];
		if (entry == null || entry.fTeamArea.isArchived) {
			return null;
		}
		var pathEntries= [];
		pathEntries.push(entry);
		var parentItemId= entry.fTeamArea.parentItemId;
		while(entry.fTeamArea.parentItemId != null && entry.fTeamArea.parentItemId.length > 0){
			if ((parentItemId in this.fTeamAreas)) {
				var parent= this.fTeamAreas[parentItemId];
				pathEntries.push(parent);
				parentItemId= parent.fTeamArea.parentItemId;
			} else {
				break;
			}
		}
		return pathEntries.reverse();
	}
});
var CategoryEntry= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesModel.CategoryEntry", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fCategory: null,

	fIsRoot: null,

	fCurrentTeamAreaId: null,

	fIsDirty: null,

	constructor: function() {
		this.fIsRoot= false;
		this.fIsDirty= false;
	},

	getIdentifier: function() {
		return this.fCategory.itemId;
	},

	setIsModified: function(isModified) {
		this.fCategory.isModified= isModified;
	},

	setDirty: function() {
		this.fIsDirty= true;
	},

	unsetDirty: function() {
		this.fIsDirty= false;
	},

	isDirty: function() {
		return this.fIsDirty;
	},

	isRootCategory: function() {
		return this.fIsRoot;
	},

	setIsRootCategory: function(status) {
		this.fIsRoot= status;
	},

	getCurrentTeamAreaId: function() {
		return this.fCurrentTeamAreaId;
	},

	setCurrentTeamAreaId: function(teamAreaId) {
		this.fCurrentTeamAreaId= teamAreaId;
	},

	getAssociatedTeamAreas: function() {
		var associatedTeams= [];
		Array.prototype.push.apply(associatedTeams, this.fCategory.associatedTeamAreas);
		return associatedTeams;
	},

	$interfaces: {
		'com.ibm.jdojo.util.IMappable': true //$NON-NLS-1$
	}
});
var TeamAreaEntry= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesModel.TeamAreaEntry", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fTeamArea: null,

	fIsDirty: null,

	setDirty: function() {
		this.fIsDirty= true;
	},

	unsetDirty: function() {
		this.fIsDirty= false;
	},

	isDirty: function() {
		return this.fIsDirty;
	},

	getIdentifier: function() {
		return this.fTeamArea.itemId;
	},

	$interfaces: {
		'com.ibm.jdojo.util.IMappable': true //$NON-NLS-1$
	}
});

})();
