/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesMoveHandler"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.essentials.IModificationPolicy"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesModel"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesMoveResponse"); //$NON-NLS-1$

(function() {
var Assert= com.ibm.jdojo.util.Assert;
var Location= com.ibm.team.rtc.foundation.api.ui.essentials.IModificationPolicy.Location;
var CategoriesActionHelper= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper;
var CategoryEntry= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesModel.CategoryEntry;
var CategoriesMoveResponse= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesMoveResponse;

dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesMoveHandler", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	canMove: function(request, readAccessor) {
		if (!(request.getTarget().getElement() instanceof CategoryEntry)) 
			return CategoriesMoveResponse.DENY;
		var newParent= null;
		if (request.getLocation() === Location.Child) {
			newParent= request.getTarget();
		} else {
			var parent= readAccessor.getParent(request.getTarget());
			if (parent.getElement() instanceof CategoryEntry) {
				newParent= parent;
			}
		}
		if (newParent == null) {
			return CategoriesMoveResponse.DENY;
		}
		var data= [];
		var source= request.getSource();
		var $subject= source;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var viewEntry= $subject[$count];
			if (viewEntry.getElement() instanceof CategoryEntry) {
				var categoryItem= viewEntry.getElement();
				if (categoryItem != null) {
					if (categoryItem.isRootCategory()) {
						continue;
					}
					var oldParent= null;
					var parent= readAccessor.getParent(viewEntry);
					if (parent == null || !(parent.getElement() instanceof CategoryEntry)) {
						continue;
					}
					oldParent= parent;
					if (oldParent.getElement().getIdentifier() === newParent.getElement().getIdentifier()) {
						continue;
					}
					var candidate= newParent;
					while(candidate.getElement() instanceof CategoryEntry){
						if ((candidate.getElement().getIdentifier() === categoryItem.getIdentifier())) {
							return CategoriesMoveResponse.DENY;
						}
						candidate= readAccessor.getParent(candidate);
					}
					var addEntry= true;
					var children= readAccessor.getChildren(newParent);
					if (children != null) {
						var $subject2= children;
						var $length2= $subject2.length;
						for (var $count2= 0; $count2 < $length2; $count2++){
							var child= $subject2[$count2];
							if (child.getElement() instanceof CategoryEntry && (child.getElement().getIdentifier() === viewEntry.getElement().getIdentifier())) {
								addEntry= false;
								break;
							}
						}
					}
					if (addEntry && oldParent != null && newParent != null && viewEntry != null) {
						data.push(new MoveResponseData(newParent, oldParent, viewEntry));
					}
				}
			}
		}
		if (data.length === 0) 
			return CategoriesMoveResponse.DENY;
		;
		return new CategoriesMoveResponse(data);
	},

	move: function(response, updateAccessor) {
		if (!(response instanceof CategoriesMoveResponse)) Assert.fail("response instanceof CategoriesMoveResponse", "com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesMoveHandler:94");
		var data= response.getData();
		var $subject3= data;
		var $length3= $subject3.length;
		for (var $count3= 0; $count3 < $length3; $count3++){
			var responseData= $subject3[$count3];
			CategoriesActionHelper.moveItem(updateAccessor, responseData);
		}
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.essentials.IMoveHandler': true //$NON-NLS-1$
	}
});
var MoveResponseData= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesMoveHandler.MoveResponseData", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fNewParent: null,

	fOldParent: null,

	fCategoryElement: null,

	constructor: function(newParent, oldParent, categoryElement) {
		this.fNewParent= newParent;
		this.fOldParent= oldParent;
		this.fCategoryElement= categoryElement;
	},

	getNewParent: function() {
		return this.fNewParent;
	},

	getOldParent: function() {
		return this.fOldParent;
	},

	getCurrentElement: function() {
		return this.fCategoryElement;
	}
});

})();
