/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesReadAccessAllAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var ItemStyle= com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle;
var CategoriesMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var CategoriesActionHelper= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper;
var CategoriesAction= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper.CategoriesAction;

var CategoriesReadAccessAllAction= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesReadAccessAllAction", CategoriesAction, { //$NON-NLS-1$

	fToggleReadAccessAction: null,

	constructor: function(rowEntry) {
		this.inherited(arguments, []);
		this.fRowEntry= rowEntry;
		this.setCanHandle(true);
		this.fToggleReadAccessAction= true;
		this.setName(CategoriesMessages.READ_ACCESS_ALL_LABEL);
	},

	getId: function() {
		return CategoriesReadAccessAllAction.ID;
	},

	getName: function() {
		if (this.fRowEntry == null) {
			return this.inherited("getName", arguments, []); //$NON-NLS-1$
		}
		if (this.fRowEntry.getElement().fCategory.isReadAccessEnabled) {
			if (!this.fToggleReadAccessAction) {
				return CategoriesMessages.NO_READ_ACCESS_TOOLTIP;
			}
			return CategoriesMessages.NO_READ_ACCESS_ALL_TOOLTIP;
		} else {
			if (!this.fToggleReadAccessAction) {
				return CategoriesMessages.READ_ACCESS_TOOLTIP;
			}
			return CategoriesMessages.READ_ACCESS_ALL_LABEL;
		}
	},

	getIconUrl: function() {
		return null;
	},

	canHandle: function() {
		if (this.fRowEntry == null || this.fRowEntry.getModel().getSelectedEntries().length === 0) {
			return false;
		} else if (this.fRowEntry.getModel().getSelectedEntries().length > 0 && !this.fRowEntry.getModel().isSelected(this.fRowEntry)) {
			return false;
		}
		return true;
	},

	handle: function() {
		if (this.canHandle()) {
			var selectedRows= this.fRowEntry.getModel().getSelectedEntries();
			if (selectedRows == null) {
				return ;
			}
			this.fRowEntry.getModel().updateModel(dojo.hitch(this, function(updateAccessor) {
				if (this.fRowEntry.getModel().getSelectedEntries().length > 0) {
					CategoriesActionHelper.readAccessAllItems(updateAccessor, selectedRows, !this.fRowEntry.getElement().fCategory.isReadAccessEnabled);
					this.fRowEntry.getModel().getInput().setPendingChanges(true);
				}
				return null;
			}));
		}
	},

	getStyle: function() {
		return ItemStyle.FLAT;
	},

	setToggleReadAccessAction: function(toggle) {
		this.fToggleReadAccessAction= toggle;
	}
});

CategoriesReadAccessAllAction.ID= CategoriesReadAccessAllAction.prototype.declaredClass;

})();
