/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesTeamAreaTransformer"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.api.ui.model.ColumnTag"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.IColumn"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.IViewModel"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesModel"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesTeamAreaGridRow"); //$NON-NLS-1$

(function() {
var ColumnTag= com.ibm.team.rtc.foundation.api.ui.model.ColumnTag;
var Unit= com.ibm.team.rtc.foundation.api.ui.model.IColumn.Unit;
var Domain= com.ibm.team.rtc.foundation.api.ui.model.IViewModel.Domain;
var TeamAreaEntry= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesModel.TeamAreaEntry;
var CategoriesTeamAreaColumns= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesTeamAreaGridRow.CategoriesTeamAreaColumns;

dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesTeamAreaTransformer", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fCategoryModel: null,

	fCategoryTeamAreaColumnInfo: null,

	fViewModel: null,

	fSelectedTeamAreaId: null,

	constructor: function(selectedTeamAreaId) {
		this.fSelectedTeamAreaId= selectedTeamAreaId;
	},

	getElementsToExpandInitially: function() {
		return this.fViewModel.readModel(dojo.hitch(this, function(readAccessor) {
			return readAccessor.getChildren(readAccessor.getRootEntry(Domain.Content));
		}));
	},

	inputChanged: function(model, newInput) {
		this.fViewModel= model;
		this.fCategoryModel= newInput;
	},

	provideColumnInfo: function(entry, readAccessor) {
		var element= entry.getElement();
		if (element instanceof TeamAreaEntry) 
			return this.fCategoryTeamAreaColumnInfo;
		return null;
	},

	refreshModel: function(updater) {
		this.doRefreshHeader(updater);
		if (this.fCategoryModel != null) {
			var teamAreasCount= this.fCategoryModel.teamAreasViewSize();
			for (var i= 0; i < teamAreasCount; i++){
				var teamArea= this.fCategoryModel.getTeamAreasView(i);
				var addEntry= null;
				if (teamArea == null || teamArea[teamArea.length - 1].fTeamArea.isArchived) {
					continue;
				}
				if (teamArea != null && teamArea.length > 1) {
					var parentCategories= teamArea.slice(0, teamArea.length - 1);
					addEntry= updater.addEntry(Domain.Content, parentCategories, teamArea[teamArea.length - 1]);
					updater.setTag(addEntry, this.fCategoryTeamAreaColumnInfo);
				} else if (teamArea != null && teamArea.length === 1) {
					addEntry= updater.addEntry(Domain.Content, [], teamArea[teamArea.length - 1]);
					updater.setTag(addEntry, this.fCategoryTeamAreaColumnInfo);
				}
				if (addEntry != null && this.fSelectedTeamAreaId != null && this.fSelectedTeamAreaId.length > 0 && this.fSelectedTeamAreaId === addEntry.getElement().fTeamArea.itemId) {
					addEntry.getModel().setSelected(addEntry, true);
					var expandEntry= null;
					expandEntry= addEntry;
					updater.executeAfterUpdate(dojo.hitch(this, function() {
						expandEntry.getModel().setEntryExpandState(expandEntry, true);
					}));
				}
			}
		}
	},

	doRefreshHeader: function(updateAccessor) {
		var rootColumn= updateAccessor.getRootColumn();
		var teamAreaColumns= rootColumn.addPropertyColumnList(TeamAreaEntry.prototype.declaredClass, updateAccessor);
		this.addColumn(teamAreaColumns, CategoriesTeamAreaColumns.TEAM_AREA, {size: 150, unit: Unit.px}, null, 100, updateAccessor);
		this.fCategoryTeamAreaColumnInfo= new ColumnTag(teamAreaColumns, null);
		updateAccessor.setTag(updateAccessor.getRootEntry(Domain.Content), new ColumnTag(null, [teamAreaColumns]));
	},

	addColumn: function(columnList, column, min, max, weight, updateAccessor) {
		var result= columnList.addColumn(column.getIdentifier(), column.getLabel(), null, column, updateAccessor);
		result.setSize(min, max, weight, updateAccessor);
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.model.IViewModelTransformer': true //$NON-NLS-1$
	}
});

})();
