/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesTreeTransformer"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.api.ui.model.ColumnTag"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.IColumn"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.IViewModel"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesColumns"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesModel"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesMoveHandler"); //$NON-NLS-1$

(function() {
var ColumnTag= com.ibm.team.rtc.foundation.api.ui.model.ColumnTag;
var Unit= com.ibm.team.rtc.foundation.api.ui.model.IColumn.Unit;
var Domain= com.ibm.team.rtc.foundation.api.ui.model.IViewModel.Domain;
var CategoriesColumns= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesColumns;
var CategoryEntry= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesModel.CategoryEntry;
var CategoriesMoveHandler= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesMoveHandler;

dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesTreeTransformer", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fCategoryModel: null,

	fCategoryColumnInfo: null,

	fViewModel: null,

	fMoveHandler: null,

	fCreateHandler: null,

	getElementsToExpandInitially: function() {
		return this.fViewModel.readModel(dojo.hitch(this, function(readAccessor) {
			return readAccessor.getChildren(readAccessor.getRootEntry(Domain.Content));
		}));
	},

	inputChanged: function(model, newInput) {
		this.fViewModel= model;
		this.fCategoryModel= newInput;
	},

	provideColumnInfo: function(entry, readAccessor) {
		var element= entry.getElement();
		if (element instanceof CategoryEntry) 
			return this.fCategoryColumnInfo;
		return null;
	},

	refreshModel: function(updater) {
		this.doRefreshHeader(updater);
		if (this.fCategoryModel != null) {
			var catLength= this.fCategoryModel.categoriesSize();
			for (var i= 0; i < catLength; i++){
				var categories= this.fCategoryModel.getCategoriesTree(i);
				if (categories != null && categories.length > 0) {
					var addEntry;
					if (categories.length === 1) {
						categories[0].setIsRootCategory(true);
						addEntry= updater.addEntry(Domain.Content, [], categories[categories.length - 1]);
					} else {
						var parentCategories= categories.slice(0, categories.length - 1);
						addEntry= updater.addEntry(Domain.Content, parentCategories, categories[categories.length - 1]);
					}
					if (addEntry != null) {
						updater.setTag(addEntry, this.fCategoryColumnInfo);
					}
				}
			}
		}
	},

	doRefreshHeader: function(updateAccessor) {
		var rootColumn= updateAccessor.getRootColumn();
		var categoryColumns= rootColumn.addPropertyColumnList(CategoryEntry.prototype.declaredClass, updateAccessor);
		this.addColumn(categoryColumns, CategoriesColumns.ACTIONS, {size: 75, unit: Unit.px}, {size: 90, unit: Unit.px}, 0, updateAccessor);
		this.addColumn(categoryColumns, CategoriesColumns.MARKERS, {size: 1, unit: Unit.em}, null, 0, updateAccessor);
		this.addColumn(categoryColumns, CategoriesColumns.CATEGORIES, {size: 150, unit: Unit.px}, null, 32, updateAccessor);
		this.addColumn(categoryColumns, CategoriesColumns.ASSOCIATED_TEAM_AREA, {size: 150, unit: Unit.px}, null, 56, updateAccessor);
		this.addColumn(categoryColumns, CategoriesColumns.VISIBILITY, {size: 200, unit: Unit.px}, null, 0, updateAccessor);
		this.addColumn(categoryColumns, CategoriesColumns.READ_ACCESS, {size: 200, unit: Unit.px}, null, 0, updateAccessor);
		this.fCategoryColumnInfo= new ColumnTag(categoryColumns, null);
		updateAccessor.setTag(updateAccessor.getRootEntry(Domain.Content), new ColumnTag(null, [categoryColumns]));
	},

	addColumn: function(columnList, column, min, max, weight, updateAccessor) {
		var result= columnList.addColumn(column.getIdentifier(), column.getLabel(), null, column, updateAccessor);
		result.setSize(min, max, weight, updateAccessor);
	},

	getMoveHandler: function() {
		if (this.fMoveHandler == null) {
			this.fMoveHandler= new CategoriesMoveHandler();
		}
		return this.fMoveHandler;
	},

	getCreateHandler: function() {
		if (this.fCreateHandler == null) {
			this.fCreateHandler= new CreateHandler();
		}
		return this.fCreateHandler;
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.essentials.IModificationHandlerProvider': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.api.ui.model.IViewModelTransformer': true //$NON-NLS-1$
	}
});
var CreateHandler= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesTreeTransformer.CreateHandler", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	onCreate: function(response, newItem, updateAccessor) {
	},

	canCreate: function(request, readAccessor) {
		return null;
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.essentials.ICreateHandler': true //$NON-NLS-1$
	}
});

})();
