/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.categories.CategoryAddAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.IViewModel"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesModel"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoryAddEditDialog"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var ItemStyle= com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle;
var Domain= com.ibm.team.rtc.foundation.api.ui.model.IViewModel.Domain;
var CategoriesMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var CategoriesActionHelper= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper;
var CategoriesAction= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper.CategoriesAction;
var CategoryEntry= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesModel.CategoryEntry;
var CategoryAddEditDialog= com.ibm.team.workitem.web.ui.internal.page.categories.CategoryAddEditDialog;

var CategoryAddAction= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoryAddAction", CategoriesAction, { //$NON-NLS-1$

	constructor: function(rowEntry) {
		this.inherited(arguments, []);
		this.fRowEntry= rowEntry;
		this.setCanHandle(true);
	},

	getId: function() {
		return CategoryAddAction.ID;
	},

	getName: function() {
		return CategoriesMessages.ADD_CATEGORY;
	},

	getIconUrl: function() {
		return CategoriesActionHelper.fIconUrl + "add.gif"; //$NON-NLS-1$
	},

	canHandle: function() {
		return !(this.fRowEntry == null);
	},

	handle: function() {
		if (this.canHandle()) {
			var path= this.fRowEntry.getModel().getInput().parseCategory(this.fRowEntry.getElement().fCategory.categoryId);
			path.splice(0, 1);
			var parms= {};
			parms.CategoryName= ""; //$NON-NLS-1$
			parms.CategoryPath= path.join(CategoriesActionHelper.CATEGORY_PATH_SEPARATOR);
			parms.CategoryDescription= ""; //$NON-NLS-1$
			parms.DialogBoxTitle= CategoriesMessages.ADD_CATEGORY_LABEL;
			this.fRowEntry.getModel().readModel(dojo.hitch(this, function(readAccessor) {
				var categorySiblingsName= [];
				var children= readAccessor.getChildren(this.fRowEntry);
				if (children != null) {
					var $subject= children;
					var $length= $subject.length;
					for (var $count= 0; $count < $length; $count++){
						var child= $subject[$count];
						if (child.getElement() instanceof CategoryEntry) {
							categorySiblingsName.push(child.getElement().fCategory.name);
						}
					}
				}
				parms.Siblings= categorySiblingsName;
				return null;
			}));
			parms.onOK= dojo.hitch(this, function(categoryName, categoryPath, categoryDescription) {
				this.updateRowEntry(categoryName, categoryPath, categoryDescription);
			});
			var diag= new CategoryAddEditDialog(parms);
			diag.show();
		}
	},

	getStyle: function() {
		return ItemStyle.FLAT;
	},

	updateRowEntry: function(categoryName, categoryPath, categoryDescription) {
		if (categoryName.length > 0) {
			this.fRowEntry.getModel().updateModel(dojo.hitch(this, function(updateAccessor) {
				var parents= this.fRowEntry.getModel().getInput().getAllCategoriesOnPath(this.fRowEntry.getElement().fCategory.categoryId);
				if (parents == null) {
					return null;
				}
				var newEntry= this.fRowEntry.getModel().getInput().createNewCategory(categoryName, categoryPath, categoryDescription, this.fRowEntry.getElement());
				var addedElement= null;
				var entry= updateAccessor.addEntry(Domain.Content, parents, newEntry);
				addedElement= updateAccessor.getParent(entry);
				this.fRowEntry.getModel().getInput().addNewCategoryEntry(newEntry);
				this.fRowEntry.getModel().getInput().setPendingChanges(true);
				updateAccessor.executeAfterUpdate(dojo.hitch(this, function() {
					addedElement.getModel().setEntryExpandState(addedElement, true);
				}));
				return null;
			}));
		}
	}
});

CategoryAddAction.ID= CategoryAddAction.prototype.declaredClass;

})();
