/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.categories.CategoryAddEditDialog"); //$NON-NLS-1$

dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("jazz.ui.Dialog"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var CategoriesMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var CategoriesActionHelper= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper;
var _Templated= dijit._Templated;
var _Widget= dijit._Widget;
var Dialog= jazz.ui.Dialog;

dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoryAddEditDialog", [ _Widget, _Templated], { //$NON-NLS-1$

	templatePath: dojo.moduleUrl("com.ibm.team.workitem.web", "ui/internal/page/templates/CategoriesAddEditDialog.html"), //$NON-NLS-1$ //$NON-NLS-2$

	fCMessages: null,

	fDialog: null,

	fCategoryName: null,

	fCategoryPath: null,

	fErrorMsg: null,

	fCategoryDescription: null,

	fOkButton: null,

	fCancelButton: null,

	fOnOk: null,

	fName: null,

	fPath: null,

	fDescription: null,

	fClickOkHandler: null,

	fClickCancelHandler: null,

	fInputTextChangeHandler: null,

	fTextAreaTextChangeHandler: null,

	fDialogBoxTitle: null,

	fSiblings: null,

	constructor: function(parms) {
		this.fCMessages= CategoriesMessages;
		this.fName= parms.CategoryName;
		this.fPath= parms.CategoryPath;
		this.fDescription= parms.CategoryDescription;
		this.fOnOk= parms.onOK;
		this.fDialogBoxTitle= parms.DialogBoxTitle;
		this.fSiblings= parms.Siblings;
	},

	postCreate: function() {
		this.inherited("postCreate", arguments, []); //$NON-NLS-1$
		this.connectHandlers();
		this.fCategoryName.type= "text"; //$NON-NLS-1$
		this.fCategoryName.value= this.fName;
		this.fCategoryName.tabIndex= 1;
		if (this.fPath.length > 0) {
			this.fCategoryPath.appendChild(dojo.doc.createTextNode(this.fPath));
		}
		this.fCategoryDescription.cols= 1;
		this.fCategoryDescription.rows= 4;
		this.fCategoryDescription.tabIndex= 2;
		this.fOkButton.tabIndex= 3;
		this.fCancelButton.tabIndex= 4;
		this.fCategoryDescription.value= this.fDescription;
	},

	connectHandlers: function() {
		this.fClickOkHandler= this.connect(this.fOkButton, 'click', dojo.hitch(this, function(event) { //$NON-NLS-1$
			dojo.stopEvent(event);
			if (this.canUpdateProperties()) {
				this.fPath= this.fDialogBoxTitle === CategoriesMessages.EDIT_CATEGORY ? this.fName : this.fPath + CategoriesActionHelper.CATEGORY_PATH_SEPARATOR + this.fName;
				this.fOnOk(this.fName, this.fPath, this.fDescription);
				this.hide();
			}
		}));
		this.fClickCancelHandler= this.connect(this.fCancelButton, 'click', dojo.hitch(this, function(event) { //$NON-NLS-1$
			dojo.stopEvent(event);
			this.onCancel(event);
		}));
		this.fTextAreaTextChangeHandler= this.connect(this.fCategoryDescription, 'change', dojo.hitch(this, function(event) { //$NON-NLS-1$
			dojo.stopEvent(event);
			this.fDescription= this.fCategoryDescription.value;
		}));
		this.fInputTextChangeHandler= this.connect(this.fCategoryName, 'change', dojo.hitch(this, function(event) { //$NON-NLS-1$
			dojo.stopEvent(event);
			if (this.canUpdateProperties()) {
				this.fName= dojo.trim(this.fCategoryName.value);
				var finalPath= this.fDialogBoxTitle === CategoriesMessages.EDIT_CATEGORY ? this.fName : this.fPath + CategoriesActionHelper.CATEGORY_PATH_SEPARATOR + this.fName;
				if (this.fCategoryPath.hasChildNodes()) {
					this.fCategoryPath.removeChild(this.fCategoryPath.firstChild);
				}
				this.fCategoryPath.appendChild(dojo.doc.createTextNode(finalPath));
			}
		}));
	},

	canUpdateProperties: function() {
		var categoryName= dojo.trim(this.fCategoryName.value);
		if (this.fErrorMsg.hasChildNodes()) {
			this.fErrorMsg.removeChild(this.fErrorMsg.firstChild);
			dojo.removeClass(this.fErrorMsg);
			dojo.addClass(this.fErrorMsg, "invisible"); //$NON-NLS-1$
		}
		if (categoryName.length === 0) {
			this.fErrorMsg.appendChild(dojo.doc.createTextNode(CategoriesMessages.ADDEDIT_CATEGORY_EMPTY_ERRORMSG));
			dojo.removeClass(this.fErrorMsg);
			dojo.addClass(this.fErrorMsg, "visible"); //$NON-NLS-1$
			return false;
		}
		var exp= new RegExp(CategoriesActionHelper.CATEGORY_PATH_SEPARATOR);
		if (exp.test(categoryName)) {
			this.fErrorMsg.appendChild(dojo.doc.createTextNode(CategoriesMessages.ADDEDIT_CATEGORY_INCORRECT_NAME_ERRORMSG));
			dojo.removeClass(this.fErrorMsg);
			dojo.addClass(this.fErrorMsg, "visible"); //$NON-NLS-1$
			return false;
		}
		if (categoryName !== this.fName && dojo.indexOf(this.fSiblings, categoryName) !== -1) {
			this.fErrorMsg.appendChild(dojo.doc.createTextNode(CategoriesMessages.ADDEDIT_CATEGORY_DUPLICATE_ERRORMSG));
			dojo.removeClass(this.fErrorMsg);
			dojo.addClass(this.fErrorMsg, "visible"); //$NON-NLS-1$
			return false;
		}
		return true;
	},

	onCancel: function(event) {
		dojo.stopEvent(event);
		this.hide();
	},

	disconnectHandlers: function() {
		if (this.fClickOkHandler != null) {
			this.disconnect(this.fClickOkHandler);
			this.fClickOkHandler= null;
		}
		if (this.fClickCancelHandler != null) {
			this.disconnect(this.fClickCancelHandler);
			this.fClickCancelHandler= null;
		}
		if (this.fInputTextChangeHandler != null) {
			this.disconnect(this.fInputTextChangeHandler);
			this.fInputTextChangeHandler= null;
		}
		if (this.fTextAreaTextChangeHandler != null) {
			this.disconnect(this.fTextAreaTextChangeHandler);
			this.fTextAreaTextChangeHandler= null;
		}
	},

	show: function() {
		var args= {};
		args.width= "400px"; //$NON-NLS-1$
		args.contentNode= this.domNode;
		args.primaryTitle= this.fDialogBoxTitle;
		args.onClose= dojo.hitch(this, function() {
			this.onDialogClosed();
			return true;
		});
		this.fDialog= new Dialog(args);
		this.fCategoryName.focus();
	},

	hide: function() {
		if (this.fDialog != null) 
			this.fDialog.close(null);
	},

	onDialogClosed: function() {
		this.fDialog= null;
		this.destroy(false);
	},

	destroy: function(preserveDom) {
		this.disconnectHandlers();
		this.inherited("destroy", arguments, [preserveDom]); //$NON-NLS-1$
	}
});

})();
