/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.categories.CategoryArchiveUnArchiveAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var ItemStyle= com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle;
var CategoriesMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var CategoriesActionHelper= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper;
var CategoriesAction= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper.CategoriesAction;

var CategoryArchiveUnArchiveAction= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoryArchiveUnArchiveAction", CategoriesAction, { //$NON-NLS-1$

	constructor: function(rowEntry) {
		this.inherited(arguments, []);
		this.fRowEntry= rowEntry;
		this.inherited("setName", arguments, [CategoriesMessages.ARCHIVE_CATEGORY]); //$NON-NLS-1$
	},

	getId: function() {
		return CategoryArchiveUnArchiveAction.ID;
	},

	getName: function() {
		if (this.fRowEntry == null) {
			return this.inherited("getName", arguments, []); //$NON-NLS-1$
		}
		return this.fRowEntry.getElement().fCategory.isArchived ? CategoriesMessages.UNARCHIVE_CATEGORY : CategoriesMessages.ARCHIVE_CATEGORY;
	},

	getIconUrl: function() {
		if (this.fRowEntry == null || !this.fRowEntry.getElement().fCategory.isArchived) {
			return CategoriesActionHelper.fIconUrl + "archive_co.gif"; //$NON-NLS-1$
		} else {
			return CategoriesActionHelper.fIconUrl + "unarchive_co.gif"; //$NON-NLS-1$
		}
	},

	canHandle: function() {
		if (this.fRowEntry == null || (this.fRowEntry.getModel().getSelectedEntries().length > 0 && this.fRowEntry.getModel().isSelected(this.fRowEntry))) {
			return false;
		}
		return !this.fRowEntry.getElement().isRootCategory();
	},

	handle: function() {
		if (this.canHandle()) {
			this.fRowEntry.getModel().updateModel(dojo.hitch(this, function(updateAccessor) {
				var isArchived= !this.fRowEntry.getElement().fCategory.isArchived;
				CategoriesActionHelper.archiveItem(updateAccessor, this.fRowEntry, isArchived);
				this.fRowEntry.getModel().getInput().setPendingChanges(true);
				return null;
			}));
		}
	},

	getStyle: function() {
		return ItemStyle.FLAT;
	}
});

CategoryArchiveUnArchiveAction.ID= CategoryArchiveUnArchiveAction.prototype.declaredClass;

})();
