/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.categories.CategoryAssociateAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesTeamAreaDialog"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var ItemStyle= com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle;
var CategoriesMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var CategoriesActionHelper= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper;
var CategoriesAction= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper.CategoriesAction;
var CategoriesTeamAreaDialog= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesTeamAreaDialog;

var CategoryAssociateAction= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoryAssociateAction", CategoriesAction, { //$NON-NLS-1$

	constructor: function(rowEntry) {
		this.inherited(arguments, []);
		this.fRowEntry= rowEntry;
	},

	getId: function() {
		return CategoryAssociateAction.ID;
	},

	getName: function() {
		return CategoriesMessages.ASSOCIATE_CATEGORY;
	},

	getIconUrl: function() {
		return CategoriesActionHelper.fIconUrl + "associate_co.gif"; //$NON-NLS-1$
	},

	canHandle: function() {
		if (this.fRowEntry == null || (this.fRowEntry.getModel().getSelectedEntries().length > 0 && this.fRowEntry.getModel().isSelected(this.fRowEntry))) {
			return false;
		} else if (this.fRowEntry.getModel().getInput().teamAreasViewSize() === 0) {
			return false;
		}
		return true;
	},

	handle: function() {
		if (this.canHandle()) {
			var parms= {};
			parms.categoriesModel= this.fRowEntry.getModel().getInput();
			parms.selectedCategory= this.fRowEntry.getElement();
			parms.onOK= dojo.hitch(this, function(initialTeamAreaId, finalTeamAreaId) {
				this.fRowEntry.getModel().updateModel(dojo.hitch(this, function(updateAccessor) {
					CategoriesActionHelper.associateItem(updateAccessor, this.fRowEntry, initialTeamAreaId, finalTeamAreaId);
					this.fRowEntry.getModel().getInput().setPendingChanges(true);
					return null;
				}));
			});
			var dialogBox= new CategoriesTeamAreaDialog(parms);
			dialogBox.show();
		}
	},

	getStyle: function() {
		return ItemStyle.FLAT;
	}
});

CategoryAssociateAction.ID= CategoryAssociateAction.prototype.declaredClass;

})();
