/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.categories.CategoryDisassociateAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var ItemStyle= com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle;
var CategoriesMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var CategoriesActionHelper= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper;
var CategoriesAction= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper.CategoriesAction;

var CategoryDisassociateAction= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoryDisassociateAction", CategoriesAction, { //$NON-NLS-1$

	fRowEntry: null,

	constructor: function(rowEntry) {
		this.inherited(arguments, []);
		this.fRowEntry= rowEntry;
	},

	getId: function() {
		return CategoryDisassociateAction.ID;
	},

	getName: function() {
		return CategoriesMessages.DISASSOCIATE_CATEGORY;
	},

	getIconUrl: function() {
		return CategoriesActionHelper.fIconUrl + "disassociate_co.gif"; //$NON-NLS-1$
	},

	canHandle: function() {
		if (this.fRowEntry == null || (this.fRowEntry.getModel().getSelectedEntries().length > 0 && this.fRowEntry.getModel().isSelected(this.fRowEntry))) {
			return false;
		} else if (this.fRowEntry.getModel().getInput().teamAreasViewSize() === 0) {
			return false;
		} else if (this.fRowEntry.getElement().isRootCategory() && (this.fRowEntry.getElement().getCurrentTeamAreaId() == null || this.fRowEntry.getElement().getCurrentTeamAreaId().length === 0)) {
			return false;
		} else {
			var path= this.fRowEntry.getElement().fCategory.categoryId;
			var allCategoriesOnPath= this.fRowEntry.getModel().getInput().getAllCategoriesOnPath(path);
			if (allCategoriesOnPath != null && allCategoriesOnPath.length > 1) {
				return !(this.fRowEntry.getElement().getCurrentTeamAreaId() === allCategoriesOnPath[allCategoriesOnPath.length - 2].getCurrentTeamAreaId());
			}
		}
		return true;
	},

	handle: function() {
		if (this.canHandle()) {
			this.fRowEntry.getModel().updateModel(dojo.hitch(this, function(updateAccessor) {
				CategoriesActionHelper.disassociateItem(updateAccessor, this.fRowEntry);
				this.fRowEntry.getModel().getInput().setPendingChanges(true);
				return null;
			}));
		}
	},

	getStyle: function() {
		return ItemStyle.FLAT;
	}
});

CategoryDisassociateAction.ID= CategoryDisassociateAction.prototype.declaredClass;

})();
