/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.categories.CategoryEditAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesModel"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoryAddEditDialog"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var ItemStyle= com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle;
var CategoriesMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var CategoriesActionHelper= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper;
var CategoriesAction= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper.CategoriesAction;
var CategoryEntry= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesModel.CategoryEntry;
var CategoryAddEditDialog= com.ibm.team.workitem.web.ui.internal.page.categories.CategoryAddEditDialog;

var CategoryEditAction= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoryEditAction", CategoriesAction, { //$NON-NLS-1$

	constructor: function(rowEntry) {
		this.inherited(arguments, []);
		this.fRowEntry= rowEntry;
		this.setCanHandle(true);
	},

	getId: function() {
		return CategoryEditAction.ID;
	},

	getName: function() {
		return CategoriesMessages.EDIT_CATEGORY;
	},

	getIconUrl: function() {
		return CategoriesActionHelper.fIconUrl + "edit_category.gif"; //$NON-NLS-1$
	},

	canHandle: function() {
		return !(this.fRowEntry == null) && !this.fRowEntry.getElement().isRootCategory();
	},

	handle: function() {
		if (this.canHandle()) {
			var parms= {};
			parms.CategoryName= this.fRowEntry.getElement().fCategory.name;
			var pathElements= this.fRowEntry.getModel().getInput().parseCategory(this.fRowEntry.getElement().fCategory.categoryId);
			if (pathElements.length >= 1) {
				pathElements.splice(0, 1);
			}
			parms.CategoryPath= pathElements.join(CategoriesActionHelper.CATEGORY_PATH_SEPARATOR);
			parms.CategoryDescription= this.fRowEntry.getElement().fCategory.description;
			parms.DialogBoxTitle= CategoriesMessages.EDIT_CATEGORY_LABEL;
			this.fRowEntry.getModel().readModel(dojo.hitch(this, function(readAccessor) {
				var parent= readAccessor.getParent(this.fRowEntry);
				var categorySiblingsName= [];
				if (parent != null) {
					var children= readAccessor.getChildren(parent);
					if (children != null) {
						var $subject= children;
						var $length= $subject.length;
						for (var $count= 0; $count < $length; $count++){
							var child= $subject[$count];
							if (child.getElement() instanceof CategoryEntry) {
								categorySiblingsName.push(child.getElement().fCategory.name);
							}
						}
					}
				}
				parms.Siblings= categorySiblingsName;
				return null;
			}));
			parms.onOK= dojo.hitch(this, function(categoryName, categoryPath, categoryDescription) {
				this.updateEditedEntry(categoryName, categoryPath, categoryDescription);
			});
			var diag= new CategoryAddEditDialog(parms);
			diag.show();
		}
	},

	getStyle: function() {
		return ItemStyle.FLAT;
	},

	updateEditedEntry: function(categoryName, categoryPath, categoryDescription) {
		var isEdited= categoryName.length > 0 && (this.fRowEntry.getElement().fCategory.name !== categoryName || this.fRowEntry.getElement().fCategory.description !== categoryDescription);
		if (isEdited) {
			this.fRowEntry.getModel().updateModel(dojo.hitch(this, function(updateAccessor) {
				if (this.fRowEntry.getElement().fCategory.name !== dojo.trim(categoryName) || this.fRowEntry.getElement().fCategory.description !== dojo.trim(categoryDescription)) {
					var oldKey= this.fRowEntry.getElement().fCategory.categoryId;
					this.fRowEntry.getElement().setDirty();
					this.fRowEntry.getElement().setIsModified(true);
					this.fRowEntry.getElement().fCategory.name= categoryName;
					this.fRowEntry.getElement().fCategory.categoryId= updateAccessor.getParent(this.fRowEntry).getElement().fCategory.categoryId + categoryName + CategoriesActionHelper.CATEGORY_PATH_SEPARATOR;
					this.fRowEntry.getElement().fCategory.description= categoryDescription;
					updateAccessor.update(this.fRowEntry, null);
					this.fRowEntry.getModel().getInput().updateCategoryEntry(oldKey, this.fRowEntry.getElement());
					this.fRowEntry.getModel().getInput().setPendingChanges(true);
					CategoriesActionHelper.iterateDescendants(updateAccessor, this.fRowEntry, dojo.hitch(this, function(childEntry, parentEntry) {
						var oldPath= (childEntry.getElement()).fCategory.categoryId;
						var parentPath= (parentEntry.getElement()).fCategory.categoryId;
						var path= parentPath + (childEntry.getElement()).fCategory.name + CategoriesActionHelper.CATEGORY_PATH_SEPARATOR;
						(childEntry.getElement()).fCategory.categoryId= path;
						this.fRowEntry.getModel().getInput().updateCategoryEntry(oldPath, (childEntry.getElement()));
					}));
				}
				return null;
			}));
		}
	}
});

CategoryEditAction.ID= CategoryEditAction.prototype.declaredClass;

})();
