/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.categories.CategoryReadAccessAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var ItemStyle= com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle;
var CategoriesMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var CategoriesActionHelper= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper;
var CategoriesAction= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper.CategoriesAction;

var CategoryReadAccessAction= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoryReadAccessAction", CategoriesAction, { //$NON-NLS-1$

	fToggleReadAccessAction: null,

	constructor: function(rowEntry) {
		this.inherited(arguments, []);
		this.fRowEntry= rowEntry;
		this.setCanHandle(true);
		this.fToggleReadAccessAction= true;
	},

	getId: function() {
		return CategoryReadAccessAction.ID;
	},

	getName: function() {
		if (this.fRowEntry == null || !this.fRowEntry.getElement().fCategory.isReadAccessEnabled) {
			return CategoriesMessages.READ_ACCESS_TOOLTIP;
		} else {
			return CategoriesMessages.NO_READ_ACCESS_TOOLTIP;
		}
	},

	getIconUrl: function() {
		if (this.fToggleReadAccessAction) 
			return null;
		if (this.fRowEntry != null && this.fRowEntry.getElement() != null && this.fRowEntry.getElement().getCurrentTeamAreaId() == null) 
			return CategoriesActionHelper.fIconUrl + "checkbox_unchecked.png"; //$NON-NLS-1$
		if (this.fRowEntry == null || (this.fRowEntry.getElement().fCategory.isReadAccessEnabled ^ this.fToggleReadAccessAction)) {
			return CategoriesActionHelper.fIconUrl + "checkbox_checked.png"; //$NON-NLS-1$
		} else {
			return CategoriesActionHelper.fIconUrl + "checkbox_unchecked.png"; //$NON-NLS-1$
		}
	},

	canHandle: function() {
		if (this.fRowEntry == null) 
			return false;
		if (this.fToggleReadAccessAction && this.fRowEntry.getModel().getSelectedEntries().length > 0 && this.fRowEntry.getModel().isSelected(this.fRowEntry)) 
			return false;
		if (this.fRowEntry.getElement() != null && this.fRowEntry.getElement().getCurrentTeamAreaId() == null) 
			return false;
		return true;
	},

	handle: function() {
		if (this.canHandle()) {
			this.fRowEntry.getModel().updateModel(dojo.hitch(this, function(updateAccessor) {
				CategoriesActionHelper.readAccessItem(updateAccessor, this.fRowEntry, !this.fRowEntry.getElement().fCategory.isReadAccessEnabled);
				this.fRowEntry.getModel().getInput().setPendingChanges(true);
				return null;
			}));
		}
	},

	getStyle: function() {
		return ItemStyle.FLAT;
	},

	setToggleReadAccessAction: function(toggle) {
		this.fToggleReadAccessAction= toggle;
	}
});

CategoryReadAccessAction.ID= CategoryReadAccessAction.prototype.declaredClass;

})();
