/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.page.categories.CategoryVisibilityAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var ItemStyle= com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle;
var CategoriesMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal.nls", "CategoriesMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var CategoriesActionHelper= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper;
var CategoriesAction= com.ibm.team.workitem.web.ui.internal.page.categories.CategoriesActionHelper.CategoriesAction;

var CategoryVisibilityAction= dojo.declare("com.ibm.team.workitem.web.ui.internal.page.categories.CategoryVisibilityAction", CategoriesAction, { //$NON-NLS-1$

	fToggleVisibilityAction: null,

	constructor: function(rowEntry) {
		this.inherited(arguments, []);
		this.fRowEntry= rowEntry;
		this.setCanHandle(true);
		this.fToggleVisibilityAction= true;
	},

	getId: function() {
		return CategoryVisibilityAction.ID;
	},

	getName: function() {
		if (this.fRowEntry == null || !this.fRowEntry.getElement().fCategory.isFiltered) {
			if (!this.fToggleVisibilityAction) {
				return CategoriesMessages.FILTER_TOOLTIP;
			}
			return CategoriesMessages.FILTERED_LABEL;
		} else {
			if (!this.fToggleVisibilityAction) {
				return CategoriesMessages.UNFILTER_TOOLTIP;
			}
			return CategoriesMessages.UNFILTERED_LABEL;
		}
	},

	getIconUrl: function() {
		if (this.fToggleVisibilityAction) 
			return null;
		if (this.fRowEntry == null || (this.fRowEntry.getElement().fCategory.isFiltered ^ this.fToggleVisibilityAction)) {
			return CategoriesActionHelper.fIconUrl + "checkbox_checked.png"; //$NON-NLS-1$
		} else {
			return CategoriesActionHelper.fIconUrl + "checkbox_unchecked.png"; //$NON-NLS-1$
		}
	},

	canHandle: function() {
		if (this.fRowEntry == null) {
			return false;
		}
		if (this.fToggleVisibilityAction && this.fRowEntry.getModel().getSelectedEntries().length > 0 && this.fRowEntry.getModel().isSelected(this.fRowEntry)) {
			return false;
		}
		return true;
	},

	handle: function() {
		if (this.canHandle()) {
			this.fRowEntry.getModel().updateModel(dojo.hitch(this, function(updateAccessor) {
				CategoriesActionHelper.filterItem(updateAccessor, this.fRowEntry, !this.fRowEntry.getElement().fCategory.isFiltered);
				this.fRowEntry.getModel().getInput().setPendingChanges(true);
				return null;
			}));
		}
	},

	getStyle: function() {
		return ItemStyle.FLAT;
	},

	setToggleVisiblityAction: function(toggle) {
		this.fToggleVisibilityAction= toggle;
	}
});

CategoryVisibilityAction.ID= CategoryVisibilityAction.prototype.declaredClass;

})();
