/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.process.ui.internal.page.models._AbstractModel");

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.workitem.web.process.client.internal.WorkItemConfigClient");

(function(){

var WorkItemConfigClient = com.ibm.team.workitem.web.process.client.internal.WorkItemConfigClient;
var ServiceResponseHandler	= com.ibm.team.repository.web.transport.ServiceResponseHandler;

dojo.declare(
	"com.ibm.team.workitem.web.process.ui.internal.page.models._AbstractModel",
	null,
{
	getConfig: function(entryPoint, callback, params){
		var self = this;
		var serviceObj= {
			success: function(configData) {
				callback(configData);
			},
			failure: function(errorObj) {
				self.onError(errorObj);
			}
		};
		var srh = new ServiceResponseHandler(serviceObj, "success", "failure");
		var appArgs = params || {};
		WorkItemConfigClient[entryPoint](srh, appArgs);
	},
	
	onError: function(errorObj){}
});

})();