/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.process.ui.internal.page.models._ProcessAttachmentModel");

dojo.require("com.ibm.team.workitem.web.process.ui.internal.page.models._AbstractModel");

(function(){

var SERVICE_ENTRY_POINT = "getProcessAttachments";

dojo.declare(
	"com.ibm.team.workitem.web.process.ui.internal.page.models._ProcessAttachmentModel",
	com.ibm.team.workitem.web.process.ui.internal.page.models._AbstractModel,
{
	// this model is for GET only, not to be POST'ed

	// prefix can be "workitemtype"/"enumeration"/"workflow"
	getProcessAttachments: function(prefix, callback){
		if(this._processAttachments && this._processAttachments[prefix]){
			callback(this._processAttachments[prefix]);
			return;
		}		

		// actually make XHR call to fetch data from server
		var self = this;
		this.getConfig(SERVICE_ENTRY_POINT, function(configData){
			if(!self._processAttachments){
				self._processAttachments = {};
			}
			self._processAttachments[prefix] = configData;
			callback(configData);
		}, { prefix: prefix });
	},

	addProcessAttachment: function(prefix, attachment){
		if(this._processAttachments && this._processAttachments[prefix]){
			if(!this._processAttachments[prefix].processAttachments){
				this._processAttachments[prefix].processAttachments = [];
			}
			attachment._eQualifiedClassName = "com.ibm.team.workitem.process.dto:ProcessAttachment";
			this._processAttachments[prefix].processAttachments.push(attachment);
		}
	}
});

})();