/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.viewlets.web.ui.internal.utils.HoverFloat");
dojo.require("jazz.ui.HoverPopup");

(function() {

var TRIM_WIDTH = 33;
var TRIM_HEIGHT = 19;
var OFFSET_LARGE = 12;
var OFFSET_SMALL = 2;

dojo.declare("com.ibm.team.workitem.viewlets.web.ui.internal.utils.HoverFloat", jazz.ui.HoverPopup, {
	
	closeDelay: 400,
	customClass: "com-ibm-team-workitem-viewlets-web-ui-internal-utils-HoverFloat",
	
	parent: null,
	queryIndex: 0,
	showDetails: "",
	
	open: function() {
		if (this._onMouseMove){
			this.disconnect(this._onMouseMove);
			delete this._onMouseMove;
		}
		this.inherited(arguments);
	},
	
	createContents: function() {
		var a = document.createElement("a");
		a.className = "detailsButton";
		a.title = this.showDetails;
		a.href = "#";
		this.connect(a,"onclick",dojo.hitch(this.parent,this.parent.handleDetailsClick,this.queryIndex));
		var img = document.createElement("img");
		img.src = dojo.moduleUrl("com.ibm.team.workitem.viewlets.web", "graphics/gadget/images/zoom.gif");
		a.appendChild(img);
		return a;
	},
	
	_hover: function(e) {
		this.lastMouseEvent = e;
		if (!this._onMouseMove) {
			this._onMouseMove = this.connect(this._determineTarget(e.target), "onmousemove", dojo.hitch(this,function(e) {
				this.lastMouseEvent = e;
			}));
		}
		this.inherited(arguments);
	},
	
	_unhover: function() {
		if(this._onMouseMove){
			this.disconnect(this._onMouseMove);
			delete this._onMouseMove;
		}
//		this.inherited(arguments);
	},
	
	position: function(node) {
		var master = jazz.ui._getMasterPopup();
		if (!node) {
			if (!this._isOpen || !this._target)
				return;
			node = this._target;
		}
		var posAbs = dojo.coords(node, true);
		var posRel = dojo.coords(node, false);
		
		var v = dijit.getViewport();
		master.arrow.style.display = "none";
		
		var h = master.domNode.clientHeight; // hover height
		var y = this.lastMouseEvent.clientY + OFFSET_LARGE; // desired position from the top of the viewport based on mouse location
		var b = v.h - y; // amount of space below the desired location
		var roomB = b >= h; // enough room below
		
		if (roomB) {
			// room below, put it below
			master.domNode.style.top = y + "px";
		} else {
			// not enough room below, see if we can put it above
			var a = this.lastMouseEvent.clientY - OFFSET_SMALL; // amount of space above desired location
			y = v.h - a; // desired position from the bottom of the viewport based on mouse location
			var roomA = a >= h;
			if (roomA) {
				// room above, put it above
				master.domNode.style.bottom = y + "px";
			}
		}
		
		// clientWidth can be wrong in IE8
		// since master.content is overflow hidden, using scrollWidth is okay
		var w = master.domNode.scrollWidth; // hover width
		var offsetRight = roomB ? OFFSET_LARGE : OFFSET_SMALL; // use appropriate offset based on if we are placing it above/below
		var x = this.lastMouseEvent.clientX + offsetRight; // desired position from the left of the viewport based on mouse location
		var r = v.w - x; // amount of space to the right of the desired location
		var roomR = r >= w; // enough room on the right
		
		if (roomR) {
			// room on right, put it on right
			master.domNode.style.left = x + "px";
			if (!roomB && !roomA) {
				// we haven't set the vertical yet and didn't have room, mash it to the top
				master.domNode.style.top = 0;
			}
		} else {
			if (roomB || roomA) {
				// there was room above or below, just mash it against the right side
				master.domNode.style.right = 0;
			} else {
				// there wasn't room on the right, above or below, mash it to the top and put it to the left (hope there is room!)
				master.domNode.style.top = 0;
				master.domNode.style.right = (v.w - (this.lastMouseEvent.clientX - OFFSET_SMALL)) + "px";
			}
		}
	}
});

})();
