/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.viewlets.web.ui.internal.utils.SecondIconChooser");

dojo.require("jazz.ui.ListBox");
dojo.require("jazz.ui.Dialog");

dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemClient");
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemAttributes");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");

dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.team.workitem.viewlets.web.ui.internal", "WorkItemsMessages");

(function() {
	
var WorkItemClient = com.ibm.team.workitem.web.client.internal.WorkItemClient,
	WorkItemAttributes = com.ibm.team.workitem.web.client.internal.WorkItemAttributes,
	ServiceResponseHandler = com.ibm.team.repository.web.transport.ServiceResponseHandler,
	
	messages = dojo.i18n.getLocalization("com.ibm.team.workitem.viewlets.web.ui.internal", "WorkItemsMessages");

var enumsByProject = {};
dojo.declare("com.ibm.team.workitem.viewlets.web.ui.internal.utils.SecondIconChooser",
	[jazz.ui.ListBox], {

	projectAreaItemId: null,
	defaultSelection: null,

	postCreate: function() {
		this.inherited(arguments);
		if (enumsByProject[this.projectAreaItemId]) {
			this.addEntries(this.enumsByProject[this.projectAreaItemId]);
			if (this.defaultSelection)
				this.setSelection([{id: this.defaultSelection}], true);
		} else {
			var serviceObj = {
				success: dojo.hitch(this,function(response) {
					var options = [];
					var length = response.length;
					for (var i = 0; i < length; i++) {
						var current = response[i];
						if (current.id !== WorkItemAttributes.TYPE) {
							options.push({
								label: current.label,
								value: current.externalId,
								id: current.externalId
							});
						}
					}
					options.sort(function(a,b) {
						return a.label.localeCompare(b.label);
					});
					options.splice(0,0,{label: messages.none, value: "none", id: "none"});
					enumsByProject[this.projectAreaItemId] = options;
					this.addEntries(options);
					if (this.defaultSelection)
						this.setSelection([{id: this.defaultSelection}], true);
				}),
				failure: console.error
			}
			var srh = new ServiceResponseHandler(serviceObj, "success", "failure");
			WorkItemClient.getAttributes(srh, {
				projectAreaItemId: this.projectAreaItemId,
				iconsOnly: true
			});
		}
	}

});

})();
