/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.common.CompositeContentArea");

	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");
	
dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.common.ContentArea");

(function() {

var checkNotNull=	net.jazz.ajax.toolbox.lang.checkNotNull;

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.common.CompositeContentArea",
	[dijit._Widget, dijit._Templated], 
	{
		
	templatePath: dojo.moduleUrl("com.ibm.team.workitem.web", "ui/internal/view/common/templates/CompositeContentArea.html"),
	// templateCssPath: dojo.uri.dojoUri("../com.ibm.team.workitem.web/ui/internal/view/common/templates/CompositeContentArea.css"),
		
	postCreate: function() {
		this._contentAreaWidgets= {};
		checkNotNull(this.parentController, "this.controller");
	},
/*
 * Do not destroy the contained widgets because they are cached
 */
	destroy: function() {
		if(this._contentAreaWidgets) {
			for(var key in this._contentAreaWidgets) {
			    if(this._contentAreaWidgets[key]) {
//					this._contentAreaWidgets[key].destroy();
					this._contentAreaWidgets[key] = null;
				}
			}
		}
		this.inherited(arguments);
	},
	// API methods
	setContent: function(id, mainContentDomNode, bannerDomNode) {
		var contentAreaWidget= this._contentAreaWidgets[id];
		if (!contentAreaWidget) {
			contentAreaWidget= /* createWidget */ new com.ibm.team.workitem.web.ui.internal.view.common.ContentArea({ controller: this.parentController });
			this.compositeDiv.appendChild(contentAreaWidget.domNode);
			this._contentAreaWidgets[id]= contentAreaWidget;
		}
		contentAreaWidget.setContent(mainContentDomNode, bannerDomNode);
	},
	
	clearContent: function(id) {
		var contentAreaWidget= this._contentAreaWidgets[id];
		if (contentAreaWidget) {
			this.compositeDiv.removeChild(contentAreaWidget.domNode);
//			this._contentAreaWidgets[id].destroy();
			this._contentAreaWidgets[id]= null;
		}
	}
});
	
})();