/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.common.MultipaneContentView");

	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.common.MultipaneContentController");
dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");
dojo.require("com.ibm.team.workitem.web.ui.internal.page.EventTopics");

(function() {
var EventTopics= com.ibm.team.workitem.web.ui.internal.page.EventTopics;
var checkNotNull		= net.jazz.ajax.toolbox.lang.checkNotNull;
var checkNonNegative	= net.jazz.ajax.toolbox.lang.checkNonNegative;

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.common.MultipaneContentView",
	[dijit._Widget, dijit._Templated],
	{
		templatePath:    dojo.moduleUrl("com.ibm.team.workitem.web", "ui/internal/view/common/templates/MultipaneContent.html"),
		// templateCssPath: dojo.uri.dojoUri("../com.ibm.team.workitem.web/ui/internal/view/common/templates/MultipaneContent.css"),
		currentWidget: null,
		parentController: null,
		// initialization
		postCreate: function() {
		 	this.controller = new com.ibm.team.workitem.web.ui.internal.view.common.MultipaneContentController(this);
			this._window_onscroll_handle = this.connect(window, "onscroll", "_handleScroll");
		},
		destroy: function() {
			this.disconnect(this._window_onscroll_handle);
			this.controller.destroy();			
 			this.inherited(arguments);
		},
		
		_handleScroll: function (e) {
			try {
				// When the back button is used, we get a scroll but are pointing to different content.
				// URL can have an extra tab attribute so use indexOf
				var url = "";
				var loc = "";
				if (this.currentWidget && this.currentWidget.getUrl && this.currentWidget.getUrl()) { // work item
					url = this.currentWidget.getUrl();
				}
				else 
					if (this.currentWidget && this.currentWidget.href) { // query
						url = this.currentWidget.href;
					}
				
				// remove timestamps
				url = url.replace(/&t[s|q]=([0-9]+)/, "");
				loc = window.location.href.replace(/&t[s|q]=([0-9]+)/, "");
				if (url.indexOf(loc) != -1) {
					this.currentWidget.scrollTop = document.documentElement.scrollTop; // window.pageYOffset
					this.currentWidget.scrollLeft = document.documentElement.scrollLeft; // window.pageXOffset
				}
			} 
			catch (e) {
				console.debug("Error in MultipaneContentView._handleScroll");
			}
		}, 
		getWidgetCache: function() {
			return this.controller.getWidgetCache();	
		},
		setItemListWidget: function(aWidget) {
			this._itemListWidget = aWidget;
		},
		isWidgetAvailable: function(widgetId, instanceId) {
			return this.controller.getCachedWidget(widgetId, null, instanceId) != null;
		},
		getCachedWidget: function(widgetId, instanceId, isSimple, instanceUUID) {
			return this.controller.getCachedWidget(widgetId, null, instanceId, isSimple, instanceUUID);
		},  
		removeCachedWidget: function(widgetId, instanceId) {
			return this.controller.removeCachedWidget(widgetId, instanceId);
		},  
		showContent: function(widgetId, widget, instanceId, skipNavUpdate) {

			this.currentWidget = this.controller.getCachedWidget(widgetId, widget, instanceId);
			
			if(this.currentWidget && widgetId == "__jazzWorkItemEditor") {
				dojo.publish(EventTopics.WORKITEM_ITEM_VIEWED, [this.currentWidget.workingCopy, this.currentWidget]);
			} else {
				if(this.currentWidget && widgetId == "__jazzQueryResults") {
					dojo.publish(EventTopics.WORKITEM_ACTION_NOTIFY_INLINE_TO_PUBLISH_ITEM_VIEWED, [this.currentWidget]);
				}				
			}
			
			if (this.domNode.childNodes.length == 1) {
				this.domNode.replaceChild(this.currentWidget.domNode, this.domNode.firstChild);
			}
			else {
				dojox.xml.parser.removeChildren(this.domNode);
				this.domNode.appendChild(this.currentWidget.domNode);
			}

			if(this.currentWidget.scrollTop) {
				window.scrollTo(this.currentWidget.scrollLeft, this.currentWidget.scrollTop);
			} else {
				window.scrollTo(0,0);
			}		
				
			var label = widget.getShortLabel ? widget.getShortLabel() : "";
			var url = widget.getUrl ? widget.getUrl() : window.location.href;
			if(!this.currentWidget.getUrl && !this.currentWidget.href) {
				this.currentWidget.href = url;
			}
			
			var summary = widget.getSummaryLabel ? widget.getSummaryLabel() : "";
			dojo.publish(EventTopics.WORKITEM_VIEW_CHANGED);
			dojo.publish("jazz.util.ResizeNotifier.resizeEvent");
		}, 
	
		getCurrentWidget: function() {
			return this.currentWidget;
		},
		setIsDirty: function(widgetId, widget, instanceId, isDirty) {
			this.controller.setIsDirty(widgetId, widget, instanceId, isDirty);
		}	
	}
);

})();