/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.process.ui.internal.view.common.SectionLayout");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.SectionLayout");
dojo.require("com.ibm.team.workitem.web.process.ui.internal.view.common.utils");

(function(){

var createActionIcon = com.ibm.team.workitem.web.process.ui.internal.view.common.utils.createActionIcon;

dojo.declare(
	"com.ibm.team.workitem.web.process.ui.internal.view.common.SectionLayout",
	com.ibm.team.workitem.web.ui.internal.view.layout.SectionLayout,
{
	isCollapsible: true,
	actions: [],
	
	postCreate: function(){
		if(!this.isCollapsible){
			this._addListenersSectionTitleBar = function(){};
		}
	
		this.inherited(arguments);
		
		dojo.addClass(this.domNode, "com-ibm-team-workitem-process-SectionLayout");
		
		// add action buttons
		var actionContainer = dojo.create("span", {
			className: "actionButtons"
		}, this._sectionTitleBarDIV);
		dojo.forEach(this.actions, function(action){
			actionContainer.appendChild(createActionIcon({
				iconClass: action.iconClass,
				onClick: action.onClick,
				title: action.title,
				owner: this
			}));
		}, this);
	},
	
	// override com.ibm.team.workitem.web.ui.internal.view.layout.SectionLayout
	setContent: function(widget) {
		if(this.content){
			this.content.destroy();
		}
		this._contentDIV.innerHTML = "";
		if(widget){
			this._contentDIV.appendChild(widget.domNode);
		}
		this.content = widget;
	},
	
	getContent: function(){
		return this.content;
	},

	setBackgroundClassName: function(backgroundClassName) {
		// override com.ibm.team.workitem.web.ui.internal.view.layout.SectionLayout
		// to clear background class when backgroundClassName=null is passed
		if(backgroundClassName && backgroundClassName.length>0){
			dojo.addClass(this.borderDIV, backgroundClassName);
		}else{
			dojo.attr(this.borderDIV, {
				className: ""
			});
		}
	},
	
	showWarningIcon: function(warningMessage){
		if(warningMessage){
			var icon = dojo.create("img", {
				src: dojo.moduleUrl("com.ibm.team.workitem.web.process", "ui/internal/page/templates/warning_ovr.gif").toString(),
				alt: warningMessage,
				title: warningMessage,
				style: {
					position: "absolute",
					left: "-1px",
					top: "7px"
				}
			});
			dojo.place(icon, this.sectionTitle.parentNode, "first");
		}
	},
	
	destroy: function(preserveDom){
		this.setContent(null);
		this.inherited(arguments);
	}
});

})();