/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.process.ui.internal.view.common.Select");

dojo.require("dijit.form._FormWidget");

dojo.declare(
	"com.ibm.team.workitem.web.process.ui.internal.view.common.Select",
	dijit.form._FormValueWidget,
{
	// summary:
	//		simple widget to render HTML SELECT element so that it can be used in InlineEditBox
	
	options: [],
	
	buildRendering: function(){
		var select = dojo.create('select');
		this.focusNode = select;
		this.domNode = select;
		var self = this;
		this.connect(select, "onchange", function(e){
			self.attr("value", select.value);
		});
	},
	
	postCreate: function(){
		this.inherited(arguments);
		
		this.setOptions(this.options);
	},
	
	setOptions: function(options){
		this.options = options;
		var select = this.domNode;
		select.options.length = 0;
		dojo.forEach(options, function(opt, idx){
			select.options[idx] = new Option(opt.label, opt.value);
			if(opt.selected === true){
				select.options[idx].selected = true;
			}
		});		
	}
});