/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.process.ui.internal.view.common.utils");

com.ibm.team.workitem.web.process.ui.internal.view.common.utils =
{
	createActionIcon: function(/*Object*/ arg){
		// summary:
		//		creates action button which:
		//		- Changes background on mouse hover
		//		- Invokes an action when clicked
		// arg:
		//		an object with 'iconClass' or 'iconUrl', 'onClick', 'title' properties
		//			/*String*/ iconClass : CSS class name string for icon
		//			/*String*/ iconUrl : URL for icon image
		//			/*Function*/ onClick : function that gets called when this icon is clicked
		//			/*String*/ title : tooltip text
		//			/*_Widget*/ owner : pass owner widget so that 'onclick' handler gets disconnected when that widget gets destroyed
		var anchor = dojo.create("a", {
			href: "#",
			title: arg.title,
			className: "dijitInline actionIcon"
		});
		arg.owner.connect(anchor, "onclick", function(e){
			dojo.stopEvent(e);
			arg.onClick(anchor);
		});
		if(arg.iconClass){
			dojo.create("span", {
				className: "dijitInline "+arg.iconClass
			}, anchor);
		}else{
			dojo.create("img", {
				src: arg.iconUrl
			}, anchor);
		}
		return anchor;
	}
};