/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.editor.parts.AbstractAttributePart");

/*
 * This is a wrapper widget that provides the presentation and value
 * processing for Duration, presented in 
 */
(function() {
 dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.editor.parts.AbstractAttributePart",
	[ ],
	{
		constructor: function() {

		},
		getAllValueAttributeMap: function(editProps) {
			// convert the array of attribute values to a map keyed by the property name
			var allValuesMap= {};
			if(editProps == null || editProps.allValues == null ) return allValuesMap;
			for (var i=0; i<editProps.allValues.length; i++) {
				var cursor= editProps.allValues[i];
				allValuesMap[cursor.attributeName]= cursor.uiItems;
			}
			return allValuesMap;
		},
		isNew: function() {
			if(this.workingCopy) return this.workingCopy.isNew();
			if(!this.workItem) return false;
			var id = this.workItem.id;
			var intId;
			try {
				if(!isNaN(id)) {					
					intId = parseInt(id);
				} else {
					intId = -1;
				}
			} catch(e) { 
				intId = -1;
			};
			return  intId < 0;
		}
});

})();
