/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.editor.parts.AnchorAttributePart");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.common.ImagePool");
dojo.require("com.ibm.team.workitem.web.ui2.internal.widget.StatusIndicator");

/*
 * Handle presentation operations pertaining to the owner attribute
 */
(function() {

var WidgetUtil = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil;
var ImagePool = com.ibm.team.workitem.web.ui.internal.view.common.ImagePool;

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.editor.parts.AnchorAttributePart",
	[dijit._Widget, dijit._Templated],
	{

		templateString: '<div class="LayoutValue" dojoAttachPoint="_root">' +
						'<div dojoAttachPoint="_rowCommands" style="display:none;float:right"><span dojoAttachPoint="_imgDIV"></span></a><a dojoAttachPoint="_chooseAnchor" class="AddValueAnchor AddApproversAnchor" href="#">Choose...</a></div>' +
						'<span dojoAttachPoint="_statusIconContainer" class="StatusIconReadOnlyContainer">' +
						'<div dojoAttachPoint="_statusIcon"></div></span>' +
						'<div style="margin-right: 6.4em; padding-left:10px;" dojoAttachPoint="_valueDIV"></div>' +
						'</div>',

		postCreate: function() {
			this.statusIndicator= new com.ibm.team.workitem.web.ui2.internal.widget.StatusIndicator({}, this._statusIcon);

			this.connect(this._chooseAnchor, "onclick", this._handleChooseClick);
			this.removeImg = document.createElement("IMG");
			this.removeImg.src = ImagePool.REMOVE;
			this._imgDIV.appendChild(this.removeImg);
			this.connect(this.removeImg, "onclick", this._handleRemoveClick);
				// TODO: put back hovers - task 82207
	//		this.connect(this.removeImg, "onmouseover", this._handleImgMouseOver);
	//		this.connect(this.removeImg, "onmouseout", this._handleImgMouseOut);
			var self = this;
			this.connect(this.domNode, "onmouseover", function(){
				self._rowCommands.style.display="";
				self.domNode.parentNode.style.backgroundColor = "#F3F7F9";
			});
			this.connect(this.domNode, "onmouseout", function(){
				self._rowCommands.style.display="none";
				self.domNode.parentNode.style.backgroundColor = "";
			});
			this.workingCopy.addListener({
				path: ["attributes", this.attributeId],
				event: "onchange",
				listener: this,
				functionName: "_handleWorkingCopyChange"
			});			
			dojo.addClass(this.domNode, "overflow-visible");
			var status= this.workingCopy._validate(this.attributeId);
			this.statusIndicator.setStatus(status);
			// this.statusIndicator.test();
		},
		destroy: function(preserveDom) {
			if(this.statusIndicator) this.statusIndicator.destroy(preserveDom);
			this.statusIndicator = null;
            this.inherited(arguments);
		},
		_handleWorkingCopyChange: function(parms) {
			if(this.refresh) this.refresh();
		},
		_handleRemoveClick: function(){
			if(this.removeValue) {
				this.removeValue();
			}
		},
//		_handleImgMouseOver: function(img) {
//			this.removeImg.src = ImagePool.REMOVE_HOVER;
//		},
//		_handleImgMouseOut: function(img) {
//			this.removeImg.src = ImagePool.REMOVE;
//		},
		setValueLabel: function(label, href, isGrey){
			if(href) {
				var valueNode = document.createElement("A");
				valueNode.href = href;
				valueNode.appendChild(document.createTextNode(label));
			} else {
				var valueNode = document.createTextNode(label);
			}
			if(isGrey) {
				this._valueDIV.style.color = "#999999";
			} else {
				this._valueDIV.style.color = "";
			}
			this._valueDIV.style.paddingTop = "2px";
			dojox.xml.parser.replaceChildren(this._valueDIV, valueNode);
			var status= this.workingCopy._validate(this.attributeId);
			this.statusIndicator.setStatus(status);
			// this.statusIndicator.test();
		},
		_handleChooseClick: function(e) {
			dojo.stopEvent(e);
			if(this._openChooseDialog) {
				this._openChooseDialog(e);
			}
		}
		
	}
);

})();
