/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.editor.parts.PasswordAttributePart");

	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.TextWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.page.EventTopics");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
/*
 * This is a wrapper widget for password
 */
(function() {

var WidgetUtil = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil;

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.editor.parts.PasswordAttributePart",
	[dijit._Widget, dijit._Templated],
	{
		
		templateString: '<div class="PasswordAttributePart">' +
						'<div dojoAttachPoint="_content" style="position:relative;left:10px;"></div>' +
						'</div>',
      constructor: function() {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
		},	
		postCreate: function() {
			this.layoutHints = {
				isWide: true,
				mustBeWide: false,
				mustBeMultiline: false,
				isOneLine: true
			}
			var value = ""; // Password always starts out blank

			var timeout = this._modifiers.timeout || 120;
			try{
				if(!isNaN(timeout)) {
					timeout = parseInt(timeout, 10);
				} else {
					timeout = 120;
				}
			} catch(e) {
				timeout = 120;
			}
			timeout = Math.max(timeout, 5);
			this.timeout = timeout * 1000;
			
			var creationArgs = {
						parentWidget: this,
						onValueChanged: "onValueChanged",
						isPassword: true,
						presentation: {
							attribute: {
								attributeTypeId: "ValidatedAttribute"
							}
						},
						parentController: this.parentController
			};
					
			this.inputWidget = new com.ibm.team.workitem.web.ui.internal.view.layout.TextWidget(creationArgs);
			/*
			 * If the field is in the header, make it nearrower
			 */
			if(this.headerParentController) {
				this.inputWidget.domNode.style.maxWidth = "8em";
				this.inputWidget._textInput.style.width = "85%";
			} else {
				this.inputWidget.domNode.style.maxWidth = "19em";
				this.inputWidget._textInput.style.width = "92%";		
			}
			
			this._content.appendChild(this.inputWidget.domNode);
			this._eventHandles = [];	
			this._eventHandles.push(dojo.subscribe(com.ibm.team.workitem.web.ui.internal.page.EventTopics.WORKITEM_ABOUT_TO_SAVE, this, this._workItemAboutToSave));
			
		},

		destroy: function()  {		
			this.isDestroyed = true;
			for(var i=0;i<this._eventHandles.length;i++){
				dojo.unsubscribe(this._eventHandles[i]);
			}
			if(this.inputWidget) this.inputWidget.destroy();
			this.inherited(arguments);
		},
		/*
		 * When the value changes, start a timer and clear the field after "timeout" seconds of inactivity
		 */
		onValueChanged: function() {
			if(this._timeoutHandle) {
				clearTimeout(this._timeoutHandle);
			}

			this._timeoutHandle = setTimeout(dojo.hitch(this,this._handleTimeout),this.timeout);

		},
		_handleTimeout: function() {
			if(this.isDestroyed) return;
			this._setTextValue("");
		},
		_getAttributeValue: function() {
			return this.workingCopy.getValue({ path: ["attributes", this.attributeId] });			
		},
		_setAttributeValue: function(value, isInit){
		// If the value changes, clear the field.
			this._setTextValue("");
		},
		_setTextValue: function(value){
			value = value || "";
			this.inputWidget._textInput.value = value;
		},
		setReadOnly: function(isReadOnly) {
			this.inputWidget.setReadOnly(isReadOnly);
		},
	     getValue: function() {
			return this.inputWidget._textInput.value;
		 },
		_workItemAboutToSave: function(parms /* workItemProxy, widgetFormElements, widgetCommands */) {
			// The header is a special case... if it is the container, use it's parentController
			var parentController = this.headerParentController ? this.headerParentController : this.parentController;
			if(!(parms.workItemProxy === this.workingCopy)
			|| !(parms.instigator === parentController)) return;
			
			// if another password field already declared, leave the value unchanged
			if( parms.widgetFormElements != null && parms.widgetFormElements[this.attributeId] == null 
			&& this.getValue() != "" ) {
				this._getFormElementValues(parms.widgetFormElements);				
			}
			this._setTextValue("");
		},
		_getFormElementValues: function(formElements) {
			var value = this.getValue();
			if(value) {
					formElements[this.attributeId] = value;
				} else {
					formElements[this.attributeId] = "";
				}
      }
	}
)

})();
