/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.editor.parts.QuickInformationPart");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("jazz.ui.HoverPopup");
dojo.require("jazz.ui.ImagePreview");
dojo.require("jazz.util.html");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.workitem.web.client.util");
dojo.require("com.ibm.team.workitem.web.client.internal.ImageClient");
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemClient");
dojo.require("com.ibm.team.workitem.web.ui.internal.page.EventTopics");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.common.ImagePool");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
/*
 * This is a wrapper widget that shows the Approvals Section
 */
(function(){
	var EventTopics= com.ibm.team.workitem.web.ui.internal.page.EventTopics;
	var WorkItemUtil = com.ibm.team.workitem.web.client.util;
    var WidgetUtil = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil;
    var EditorUtil = com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil;
	var ImageClient = com.ibm.team.workitem.web.client.internal.ImageClient;
    var ImagePool = com.ibm.team.workitem.web.ui.internal.view.common.ImagePool;
    var ImagePreview = jazz.ui.ImagePreview;
	var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
	var ServiceResponseHandler	= com.ibm.team.repository.web.transport.ServiceResponseHandler;
	var WorkItemClient			= com.ibm.team.workitem.web.client.internal.WorkItemClient;
    
var DOWNLOAD_SERVICE_URI = "com.ibm.team.workitem.service.internal.rest.IAttachmentRestService/repo/csid/Attachment/";
var ATTACHMENT_ID= "com.ibm.team.workitem.linktype.attachment";
var DEFAULT_LINK_TYPE_MAP = {
	"com_ibm_team_workitem_linktype_subscriber": {
		iconUrl: ImagePool.USERS
	},
	"com_ibm_team_workitem_linktype_attachment":  {
		iconUrl: ImagePool.ATTACHMENT
	}
}
    /* defineWidget */
    dojo.declare("com.ibm.team.workitem.web.ui.internal.view.editor.parts.QuickInformationPart", [dijit._Widget, dijit._Templated], {
    
        templateString: '<div class="QuickInformationPart SectionPart">' +
        '<span dojoAttachPoint="_sectionMenuSPAN"></span>' +
        '<div dojoAttachPoint="_contentNode">' +
        '</div>' +
        '<BR dojoAttachPoint="_endBR"></div>',
        constructor: function() {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
		},	
        postCreate: function(){
			if(dojo.isIE) {
				this._endBR.style.display = "none";
			}
            this._childWidgets = [];

            this._isInitialized = false;
            this._workItem = this.parentController.workingCopy.object;
			if(this.sectionLayout && !this.sectionLayout._isDetails) {
	            this.sectionLayout.setBackgroundClassName("com-ibm-team-workitem-QuickInformationBackground");	
			} else {
				dojo.addClass(this.domNode, "com-ibm-team-workitem-QuickInformationInDetails");
			}

			this.workingCopy.addListener({
				path: ["attributes", "internalSubscriptions" ],
				event: "onchange",
				listener: this,
				functionName: "_workItemChanged"
			});				
			this.workingCopy.addListener({
				path: ["linkTypes"],
				event: "onchange",
				listener: this,
				functionName: "_workItemChanged"
			});				
			this.workingCopy.addListener({
				path: ["approvals"],
				event: "onchange",
				listener: this,
				functionName: "_workItemChanged"
			});				

			this._currentUser = com.ibm.team.repository.web.client.session.getAuthenticatedContributor();
			
			this._fetchQuickInformation();

        },
        destroyWidget: function(){
			this.resetWidget();
			if(this.workingCopy) this.workingCopy.removeAllListeners({listener: this});
			this.destroy();
		},
		getDefaultLabel: function() {
			return this.messages.labelQuickInformation;
		},
		_workItemChanged: function() {
				this.refresh();
		},
        resetWidget: function(){

            for (var i = 0; i < this._childWidgets.length; i++) {
                if (this._childWidgets[i].destroyWidget) {
					this._childWidgets[i].destroyWidget()
				}
				else {
					if (this._childWidgets[i].destroy) {
						this._childWidgets[i].destroy()
					}
				}
				
                this._childWidgets[i] = null;
            }
            
            this._childWidgets = [];
            if(this._contentNode) dojox.xml.parser.removeChildren(this._contentNode);
			
        },
        /*
         * Load the tab when it is shown
         */
        showWidget: function(){

        },
		_showLoading: function(isLoading) {
			
		},
		_showEmpty: function(isEmpty) {
//			if(isEmpty) {
//				this.domNode.style.display="none";
//			} else {
//				this.domNode.style.display="";
//			}
		},
        _fetchQuickInformation: function() {
			if(!this._modifiers.quickinformationConfiguration && this.sectionLayout && this.sectionLayout.domNode) {
				this.sectionLayout.domNode.style.display = "none";
				this._showLoading(false);
				this._showEmpty(true);
				return;
			}
			
			if(this._needsApprovalTypes()) {
				this._fetchApprovalTypes();
	// TODO: Add icons showing approval states
	//			this._fetchApprovalStates();
			}
			
			var self = this;
			var serviceObj= {
				success: function(qiPres) {
					if(self.parentController && self.parentController.isDestroyed) return;
					self._qiPres = qiPres;
            		self._fetchComplete();
				},
				failure: function(errorObj) {
					if(self.parentController && self.parentController.isDestroyed) return;
					self._showLoading(false);
					self._showEmpty(true);
					alert(self.messages.errorLoadingQuickInformation);
					console.debug(self.messages.errorLoadingQuickInformation + " " + errorObj.message);
				}
			};
			var srh= new ServiceResponseHandler(serviceObj, "success", "failure");
			var args = { configurationId:this._modifiers.quickinformationConfiguration  || "com.ibm.team.workitem.configuration.quickinformation.default"};
			args.projectAreaItemId = this.workingCopy.getProjectAreaItemId();
			WorkItemClient.getQuickInformationPresentation(srh, args);
		},
		_needsApprovalTypes: function() {
			if(this._approvalTypeMap) return false; // already have it
			if(!this._workItem.approvals || this._workItem.approvals.length ==0) return false; // none to do
			return true;
		},
		_fetchApprovalTypes: function() {
			var fetchArgs = {
				serviceSelector: "getApprovalTypes",
				responseObject: this,
				responseSelector: "_typesLoaded",
				progressText: this.messages.busyLoading
			};
			
			this.workingCopy.fetchSimpleInfo(fetchArgs);
		},
		_typesLoaded: function(approvalTypes) {
			this._approvalTypeMap = {};
			if(approvalTypes) {
				for(var i=0;i<approvalTypes.length;i++) {
					this._approvalTypeMap[approvalTypes[i].id] = approvalTypes[i];
				}
			}
			this._fetchComplete();
		},
//		_fetchApprovalStates: function() {
//			var fetchArgs = {
//				serviceSelector: "getApprovalStates",
//				responseObject: this,
//				responseSelector: "_statesLoaded",
//				progressText: this.messages.busyLoading
//			};
//			
//			this.workingCopy.fetchSimpleInfo(fetchArgs);
//		},
//		_statesLoaded: function(approvalStates) {
//			this._approvalStates = approvalStates;
//			this._fetchComplete();
//		},
		_fetchComplete: function() {
			if(!this._needsApprovalTypes()  /* && this._approvalStates */ && this._qiPres) {
				this._showLoading(false);
				this.refresh(this._qiPres);
			}
		},
        /*
         * Setup the page and read the states and types
         */
        refresh: function(qiPres){
        	if(this._needsApprovalTypes()) {
        		this._fetchApprovalTypes();
        		return; // will come back after types loaded
        	}
        	
			if(qiPres) {
				this.presentation = qiPres;
			}
			if(!this.presentation) return;
			qiPres = this.presentation;
            this.resetWidget();
            this._markDirtyIfDifferent();
            
			var sectionNode = this._contentNode;
			var sectionLayout = this.sectionLayout;
//            try {
                var self = this;
                var summaryLinks = document.createElement("ul");
                summaryLinks.className = "SummaryListElement";
                sectionNode.appendChild(summaryLinks);
                
                var listObjects = [];
                
				if(this.sectionLayout) {
				      sectionLayout.setBorder(true);	
				}
                var linkTypeMap = dojo.clone(DEFAULT_LINK_TYPE_MAP);

				var linkTypes = this._workItem.linkTypes || [];
				var id;
				for (var i = 0; i < linkTypes.length; i++) {
					id = linkTypes[i].id.replace(/\./g,"_");
					if(linkTypes[i].isSource /* || linkTypes[i].isSymmetric */){
						id = id+"_source";
					}
					linkTypeMap[id] = linkTypes[i];
					linkTypes[i]._wasShown = false; // reset so shown again
				}
				
				var linkTypeId;
				for (var i = 0; i < qiPres.length; i++) {
					linkTypeId = qiPres[i].linkTypeId;
					if (linkTypeId) {
						linkTypeId = linkTypeId.replace(/\./g, "_");
						// related doesn't match in linkDTO and qiPres
						if (qiPres[i].isSourceLink) {
							linkTypeId = linkTypeId + "_source";
						}
					}
					if (linkTypeId) {
						if(linkTypeMap[linkTypeId] && !linkTypeMap[linkTypeId]._wasShown) {
							linkTypeMap[linkTypeId]._wasShown = true;
							this.showLinkTypePresentation(listObjects, qiPres[i], linkTypeMap[linkTypeId]);
						}
					}
					else {
						if (qiPres[i].targetPartId == "com.ibm.team.workitem.attribute.subscriptions") {
							this.showSubscriptionPresentation(listObjects, qiPres[i], linkTypeMap["com_ibm_team_workitem_linktype_subscriber"]);
						}
						else {
							if (qiPres[i].targetPartId == "com.ibm.team.workitem.presentation.approvals") {
								this.showApprovalPresentation(listObjects, qiPres[i], linkTypeMap["com_ibm_team_workitem_linktype_approval"]);
							}
							else {
								if (qiPres[i].targetPartId == "com.ibm.team.workitem.presentation.attachments") {
									this.showAttachmentPresentation(listObjects, qiPres[i], linkTypeMap["com_ibm_team_workitem_linktype_attachment"]);
								}
							}
						}
					}
				}
                                
                if (listObjects.length == 0) {
                    var noLinks = document.createElement("li");
                    noLinks.className = "NoLinks";
                    noLinks.appendChild(document.createTextNode(this.messages.labelNoLinks));
                    summaryLinks.appendChild(noLinks);
                }
                else {
                    for (var i = 0; i < listObjects.length; i++) {
                        var li = this.getListElement(listObjects[i]);
                        summaryLinks.appendChild(li);
                    }
                }
				// Add an invisible item to the end to force the box to contain the lists
				if (!dojo.isIE) {
					var end = document.createElement("li");
					end.className = "SummaryListElementItem";
					var hr = document.createElement("hr");
					hr.style.visibility = "hidden";
					hr.style.marginBottom = "-1.3em";
					end.appendChild(hr);
					summaryLinks.appendChild(end);
				}
//            } 
//            catch (e) {
//                console.debug("Error loading quick information: " + e.message + "\n" + (e.stack ? e.stack : ""));
//            }
            
        },
		showLinkTypePresentation: function(listObjects, qiPres, linkType) {
            var listObjectToUpdate = null;
            listObjectToUpdate = {
                    label: qiPres.title || linkType.displayName,
                    id: linkType.id,
                    iconUrl: linkType.iconUrl || false,
                    count: 0,
                    itemList: [],
                    toString: function(){
                        return this.label;
                    }
                }

			var itemCount = 0;
			var anonymousLinkId = 1;
            for (var j = 0; j < linkType.linkDTOs.length; j++) {
				var linkDTO = linkType.linkDTOs[j];
				if(linkDTO._isDeleted) continue;
				var attr = this._getTargetAttr(linkDTO);
				if (attr.id) { // a work item
				    itemCount++;
					this._addWorkItem(linkDTO, listObjectToUpdate, attr);
				}
				else 
					if(linkDTO.url) {
						itemCount++;
						this._addUrlItem(linkDTO,listObjectToUpdate, attr, anonymousLinkId++);
					} else {
						if (linkDTO.comment) {
					    	itemCount++;
							listObjectToUpdate.itemList.push({
								summary: linkDTO.comment
							})
						}
					}
				
				listObjectToUpdate.itemList.sort(function(x, y){
					try {
						if(x.id != null && y.id != null && !isNaN(x.id) && !isNaN(x.id)) {							
							return x.id - y.id
						} else {
							return 0
						}
					} 
					catch (e) {
						return 0;
					}
				});
			}
            listObjectToUpdate.count += itemCount;
			if(listObjectToUpdate.count > 0 ) {
			     listObjects.push(listObjectToUpdate);
			}
		},

		showSubscriptionPresentation: function(listObjects, qiPres, linkType) {
          if (this._workItem.attributes && this._workItem.attributes.internalSubscriptions && this._workItem.attributes.internalSubscriptions.items) {
           	this._addSubscriptions(listObjects, qiPres, linkType);
          }
		},
		showApprovalPresentation: function(listObjects, qiPres, linkType) {
          if (this._workItem.approvals) {
			this._addApprovals(listObjects, qiPres, linkType);
          }
		},
		showAttachmentPresentation: function(listObjects, qiPres, linkType) {
			if(!linkType || !linkType.linkDTOs || linkType.linkDTOs.length==0) return;
            var itemList = [];
			var count = 0;
            for (var k = 0; k < linkType.linkDTOs.length; k++) {
               if(this._addAttachment(itemList,linkType.linkDTOs[k] )) count++;
            }
            
            itemList.sort(function(x, y){
                if (!x || !y || x.id == null || y.id == null) 
                    return 0;
                return x.id < y.id ? -1 : 1
            });
			if(itemList.length == 0) return;
            listObjects.unshift({
                label: qiPres.title || this.messages.labelAttachments,
                iconUrl: linkType.iconUrl || false,
                id: "attachments",
                count: count,
                itemList: itemList
            });
		},
		_addAttachment: function(itemList, linkDTO) {
			if(!linkDTO || linkDTO.isRemoved) return false;
			  if (linkDTO.comment) { // attachment
						var href = TeamServerClient._getServicePrefix() + DOWNLOAD_SERVICE_URI + linkDTO.itemId;
						href = EditorUtil._swizzleQuickInformationAttachmentUrls(href, this.workingCopy);
						
						var id = 0;
						if (linkDTO && linkDTO.target && linkDTO.target.id) {
							id = linkDTO.target.id;
						}
						if (id) {
							var fileName = linkDTO.comment
							var index = fileName.lastIndexOf(".");
							var previewParms = false;
							var ext = index == -1 ? null : fileName.substring(index + 1);
							ext = ext ? ext.toLowerCase() : ext;
							if (ext == "gif" || ext == "png" || ext == "jpeg" || ext == "jpg") {
								var previewParms = {
									src: href,
									filename: fileName
								}
							}
							
							itemList.push({
								shortName: jazz.util.html.escape("" + id),
								id: id,
								summary: id + ": " + linkDTO.comment,
								href: href,
//								newWindow: true,
								previewParms: previewParms
							});
						}
						else {
							itemList.push({
								id: 0,
								summary: linkDTO.comment,
//								newWindow: true,
								href: href
							});
						}
					}
					return true;
		}, 
		_getTargetAttr : function(linkDTO) {
				if(!linkDTO) return;
				var id = false;
				var stateGroup = -1;
				if (linkDTO.target && linkDTO.target.attributes) {
					for (var i = 0; i < linkDTO.target.attributes.length; i++) {
						if (linkDTO.target.attributes[i].key == "id") {
							id = linkDTO.target.attributes[i].value.id;
							break;
						}
					}
					for (var i = 0; i < linkDTO.target.attributes.length; i++) {
						if (linkDTO.target.attributes[i].key == "stateGroup") {
							stateGroup = linkDTO.target.attributes[i].value.id;
							break;
						}
					}
				}
				return { id: id, stateGroup: stateGroup };
		},
		_addWorkItem: function(linkDTO, listObjectToUpdate, attr) {
			if(!linkDTO) return;
            var linkName = linkDTO.comment;
            if (linkDTO.target && linkDTO.target._eQualifiedClassName && linkDTO.target._eQualifiedClassName.indexOf("WorkItemLinkDTO") != -1 && linkName.indexOf("<") == 0) {
                var newId = attr.id + ":";
                linkName = linkName.replace(/<.*>:/, newId);
            }
            if (linkName.indexOf("#") == 0 && linkName.length > 1) {
                linkName = linkName.substring(1, linkName.length);
            }
            listObjectToUpdate.itemList.push({
				shortName: jazz.util.html.escape("" + attr.id),
                id: attr.id,
				stateGroup: attr.stateGroup,
                summary: linkName,
                resourceLinkUri: linkDTO.url
            })
		}, 
		_addUrlItem: function(linkDTO, listObjectToUpdate, attr, id) {
			if(!linkDTO) return;
            var linkName = linkDTO.comment;
            var newId = "id";
            linkName = linkName.replace(/<.*>:/, newId);
			if(linkDTO.url && linkDTO.url.indexOf("com.ibm.team.repository.Contributor") != -1) {
				var shortName = this._getUserAbbrev(linkName);
			} else {				
				var shortName = "" + id;
			}
            listObjectToUpdate.itemList.push({
                isUrlItem: true,
				shortName: shortName,
				stateGroup: attr.stateGroup,
                summary: linkName,
                resourceLinkUri: linkDTO.url,
                href: linkDTO.url
            })
		}, 
		_addSubscriptions: function(listObjects, qiPres, linkType) {
            var itemList = [];
            var subItems = this.workingCopy.getItems({ attributeId: "internalSubscriptions", skipDeleted: true });
			if(subItems.length == 0) return;
			var split, shortName;
            for (var k = 0; k < subItems.length; k++) {
                var item = {};
                item.summary = subItems[k].name;
				var emailSubject;
				if(this.parentController && this.parentController.workingCopy) {
					try {
						emailSubject =  this.parentController.workingCopy.object.attributes.workItemType.label + " " + this.parentController.workingCopy.getId() + ": " + EditorUtil.restoreTags(this.parentController.workingCopy.object.attributes.summary.content);
					}	catch(e) {} // ignore;			
				}
				item.href = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil._getMailto(subItems[k].emailAddress, emailSubject); // subject can be null
				item.shortName = this._getUserAbbrev(item.summary);
				var summary;
				if(subItems[k].userId) {
					var userIdText = "";
					item.userId = subItems[k].userId;
					item.summary = dojo.string.substitute(this.messages.titleUserNameWithId, [ item.summary, subItems[k].userId ]);
				} else {
					item.summary = item.summary; // user id
				}
				item.resourceLinkUri = subItems[k].locationUri;
                itemList.push(item);
            }
            
            itemList.sort(function(x, y){
                if (!x || !y || !x.summary || !y.summary) 
                    return 0;
                return x.summary < y.summary ? -1 : 1
            });
            listObjects.unshift({
                label: qiPres.title || this.messages.labelSubscriptions,
                iconUrl: linkType.iconUrl || false,
                id: "subscriptions",
                count: subItems.length,
                itemList: itemList
            });
		},
		_getUserAbbrev: function(fullName) {
				var split = fullName.split(" ");
				var shortName = "";
				for(var m=0;m<split.length;m++) {
					shortName += split[m].substring(0,1);
				}
				return jazz.util.html.escape(shortName); // Avoid scripting via first letters of user name
		},
		/*
		 * Each approval gets it's own line showing pending or approved
		 */
		_addApprovals: function(listObjects, qiPres, linkType) {
			if(!this._workItem.approvals || this._workItem.approvals.length ==0) return;
			/*
			 * Since they are pushed, go in reverse order to match how they appear in the list
			 */
            for (var k=this._workItem.approvals.length-1; k >= 0; k--) {
                if (!this._workItem.approvals[k]._isDeleted) {
                	var iconUrl = this._approvalTypeMap[this._workItem.approvals[k].approvalType] || {iconUrl: false};
            		this._addApproval(this._workItem.approvals[k], listObjects, qiPres, {iconUrl: iconUrl.iconUrl});
                }
            }
		},
		/*
		 * Each approval gets it's own line showing pending or approved
		 *  [img] Approval title: state (n of m)
		 */
		_addApproval: function(approval, listObjects, qiPres, linkType) {

	        var stateName = this.messages.labelUnknown;
			var pendingCount = 0;
			var rejectedCount = 0;
			var approvedCount = 0;
			var headingCount = 0;
			var myState;
			if(approval.approvals) {
	           		for(var i=0;i<approval.approvals.length;i++) {
	           			if(!approval.approvals[i]._isDeleted) {
		           			if(approval.approvals[i].state == "com.ibm.team.workitem.approvalState.pending") {
		           				pendingCount++;
		           			} else 
		           			if(approval.approvals[i].state == "com.ibm.team.workitem.approvalState.approved") {
		           				approvedCount++;
		           			} else
		           			if(approval.approvals[i].state == "com.ibm.team.workitem.approvalState.rejected") {
		           				rejectedCount++
		           			}
		           			if(approval.approvals[i].approver.itemId == this._currentUser.itemId) {
		           				myState = approval.approvals[i].state;
		           			} 
	           			}
	           		}
	           	}

			if(myState) {
			 	if(myState == "com.ibm.team.workitem.approvalState.pending") {
	           		myState = this.messages.labelApprovalPending;
	           	} else 
	          	if(myState == "com.ibm.team.workitem.approvalState.approved") {
	           		myState = this.messages.labelApprovalApproved;
	          	} else 
	          	if(myState == "com.ibm.team.workitem.approvalState.rejected") {
	           		myState = this.messages.labelApprovalPending;
	          	}
			}

           	if(approval.cumulativeState == "com.ibm.team.workitem.approvalState.pending") {
           		stateName = this.messages.labelApprovalPending;
           		headingCount=pendingCount;
           	} else 
          	if(approval.cumulativeState == "com.ibm.team.workitem.approvalState.approved") {
          		// the count is always the number of approvals
           		stateName = this.messages.labelApprovalApproved;
           		headingCount = approvedCount;
          	} else 
          	if(approval.cumulativeState == "com.ibm.team.workitem.approvalState.rejected") {
           		stateName = this.messages.labelApprovalPending;
				headingCount = rejectedCount;
          	}
          	
          	var approvalName = approval.name;
			var totalCount = approvedCount + pendingCount + rejectedCount;
			var qiLabelFull = dojo.string.substitute(this.messages.labelQuickInformationApproval, [ approvalName, stateName, headingCount, totalCount]);
			if(approval.name.length > 24) {
				approvalName=approvalName.substr(0,21) + "... ";
			}
			var qiLabel = dojo.string.substitute(this.messages.labelQuickInformationApproval, [ approvalName, stateName, headingCount, totalCount]);
          	/*
          	 * For each approval, create an entry for the hover
          	 */
          	var hoverContent= document.createElement("div");
          	var hoverContentContainer= document.createElement("span");
          	dojo.addClass(hoverContentContainer,"com-ibm-team-workitem-quickinfo" );
          	var hoverContentList= document.createElement("ul"); 
          	dojo.addClass(hoverContentList, "com-ibm-team-workitem-QuickInformationHoverList");
          	var hoverHeading = document.createElement("li");
          	dojo.addClass(hoverHeading, "heading");
          	dojo.addClass(hoverHeading, "com-ibm-team-workitem-QuickInformationHoverListItem");

		    if(linkType.iconUrl) {
		    	var url = WorkItemUtil.getBackgroundImageUrl(linkType.iconUrl);
				hoverHeading.style.backgroundImage = "url('"+url+"')";	 // causes mix-mode messge in ie
			} else {
				dojo.addClass(hoverHeading, "com-ibm-team-workitem-QuickInformationPixelIcon");
			} 
          	
          	hoverHeading.innerHTML = WorkItemUtil.plainToHTML(qiLabelFull); // innerHTML OK
          	hoverContentList.appendChild(hoverHeading);
          	/*
          	 * Under the heading
          	 *   Cumulative State: <b>Pending</b>
          	 *   Your State: <b>Pending</B>
          	 *    - 2 Pending
          	 *    - 1 Approved
          	 *    - 3 Rejected  		
          	 */
          	var hoverState = document.createElement("li");
          	dojo.addClass(hoverState, "com-ibm-team-workitem-QuickInformationListDetailsItem");
          	hoverState.appendChild(document.createTextNode(dojo.string.substitute(this.messages.labelApprovalCumulativeState, [ stateName ])));
			hoverContentList.appendChild(hoverState);
			
			if(myState) {
          		var myStateLi = document.createElement("li");
          		dojo.addClass(myStateLi, "com-ibm-team-workitem-QuickInformationListDetailsItem");
          		myStateLi.appendChild(document.createTextNode(dojo.string.substitute(this.messages.labelApprovalMyState, [ myState ])));
				hoverContentList.appendChild(myStateLi);				
			}
			
          	if(approval.approvals && approval.approvals.length > 0) {
	   		  	var li = document.createElement("li");
	   		  	dojo.addClass(li, "com-ibm-team-workitem-QuickInformationListDetailsItem");
	   		  	li.appendChild(document.createTextNode(dojo.string.substitute(this.messages.labelApprovalCountApproved, [ approvedCount ])));
	   		  	hoverContentList.appendChild(li);
	   		  	var li = document.createElement("li");
	   		  	dojo.addClass(li, "com-ibm-team-workitem-QuickInformationListDetailsItem");
	   		  	li.appendChild(document.createTextNode(dojo.string.substitute(this.messages.labelApprovalCountRejected, [ rejectedCount ])));
	   		  	hoverContentList.appendChild(li);
	   		  	var li = document.createElement("li");
	   		  	dojo.addClass(li, "com-ibm-team-workitem-QuickInformationListDetailsItem");
	   		  	li.appendChild(document.createTextNode(dojo.string.substitute(this.messages.labelApprovalCountPending, [ pendingCount ])));
	   		  	hoverContentList.appendChild(li);

          	}
          	
          	hoverContentContainer.appendChild(hoverContentList);
          	hoverContent.appendChild(hoverContentContainer);

            listObjects.unshift({
            	hoverContent: hoverContent,
                label: qiLabel,
                iconUrl: linkType.iconUrl,
                id: "approval_" + approval.id,
                itemList: [],
                doNotTruncate: true
            });
		},
		getListElement: function(linkType) {
				var li= document.createElement("li");
				li.className = "SummaryListElementItem";
				
				var tabLink= document.createElement("a");
				var tabName= "links";
				tabName= (linkType.id.indexOf("approval_") != -1) ? "approvals" : tabName;

				tabLink.href= EditorUtil._getUriForTab(tabName, this.parentController.getUrl());
				
				// Truncate long names
				if(!linkType.doNotTruncate && linkType.label.length > 24) {
					linkType.label=linkType.label.substr(0,21) + "... ";
				}
				
				if(linkType.count) { 
					var label=  dojo.string.substitute(this.messages.labelItemCount, [ linkType.label, linkType.count + "" ]);
				} else {
					var label = linkType.label
				}
				
				var self=this;
				this.connect(tabLink, "onclick",
					function(e) {
						if (window.location.href.indexOf("_ajax-modules") > 0) {
							dojo.stopEvent(e);
							return;
						}
						self._handleSummaryItemClick(e);
					});
	
	
				for (var k=0; k<linkType.itemList.length; k++) {
					try {
					if(linkType.itemList[k].id != null && linkType.itemList[k].id == 0) {
						// lets see if we can derive the id from the summary
						var summary = linkType.itemList[k].summary;
						if(summary) {
							var m = summary.indexOf(": ");
							if(m != -1) {
								var idString = summary.substring(0,m);
								if(idString && idString.indexOf(" ")) {
									var split = idString.split(" ");
									var idValue = 0;
									idValue = split[split.length-1];
									try{
										if(!isNaN(idValue)) {											
											idValue = parseInt(idValue);
											linkType.itemList[k].id = idValue;
										}
									} catch(e) {}; // ignore if not a number
									
								}
							}
						}
					}
					} catch(e) {}; // ignore  problem here
					if(!linkType.itemList[k].href && linkType.itemList[k].id) {
						linkType.itemList[k].href= WorkItemUtil.getViewWorkItemUri(linkType.itemList[k].id);
					}
				}
				
				var itemList = document.createElement("ul");
				itemList.className = "com-ibm-team-workitem-QuickInformationList";
				var anchor, nameLi, headerLi, ext, previewParms, itemCount = 0;

				headerLi = document.createElement("li");
				headerLi.className = "com-ibm-team-workitem-QuickInformationListItem";
				headerLi.appendChild(tabLink)
				itemList.appendChild(headerLi);

				var tipSpan = document.createElement("span");
				var innerSpan = document.createElement("span");
				innerSpan.className = "com-ibm-team-workitem-quickinfo";
				tipSpan.appendChild(innerSpan);
				label = WorkItemUtil.plainToHTML(label); // remove scripts
				innerSpan.innerHTML += "<div class=\"heading\">" + label + "</div>"; // innerHTML OK
				for (var i = 0; i < linkType.itemList.length; i++) {
					if(!linkType.itemList[i].summary) continue;
					linkType.itemList[i].safeSummary = WorkItemUtil.plainToHTML(linkType.itemList[i].summary); // remove scripts
					linkType.itemList[i].safeHref = EditorUtil.removeHrefScripting(linkType.itemList[i].href); // remove scripts

					if(linkType.itemList[i].href) {
						if(linkType.itemList[i].shortName && itemCount < 10) {
							itemCount++;
							if (!this._isAjaxModule()) {
								anchor = document.createElement("A");
								anchor.appendChild(document.createTextNode(linkType.itemList[i].shortName));
								anchor.href = linkType.itemList[i].href;
								if (linkType.itemList[i].newWindow) {
									anchor.target = "_blank";
								}
								if (linkType.itemList[i].stateGroup == 2) {
									dojo.addClass(anchor, "Closed");
								}
							} else { // non module
							    anchor = document.createElement("span");
								anchor.appendChild(document.createTextNode(linkType.itemList[i].shortName));
								if (linkType.itemList[i].stateGroup == 2) {
									dojo.addClass(anchor, "Closed");
								}
							}
							nameLi = document.createElement("LI");
							nameLi.className = "com-ibm-team-workitem-QuickInformationListItemDetail";

							nameLi.appendChild(anchor);
							if(i<linkType.itemList.length -1 ) {
									nameLi.appendChild(document.createTextNode(", "));
							}
							itemList.appendChild(nameLi);
							if(linkType.itemList[i].previewParms) {
								previewParms = linkType.itemList[i].previewParms;
								previewParms.around = [ anchor ];
								new ImagePreview(previewParms, document.createElement("div"));
							} else {
								anchor.title = linkType.itemList[i].summary;
							}
							
							var currentEntry= linkType.itemList[i];
							if (currentEntry.resourceLinkUri && !this._isAjaxModule()) {
								if(!linkType.itemList[i].isUrlItem && linkType.id != "subscriptions") {								
									anchor.title = ""; // No title if resourcelink, unless anonymous
								}
								var resourceLinkArgs= { 
									userId: currentEntry.userId,
									retainLinkText: true,
									uri: currentEntry.resourceLinkUri,
									presentationUri: currentEntry.href,
									label: currentEntry.shortName  // already escaped
								};
								this._childWidgets.push(this.workingCopy.applyResourceLinkToAnchor(resourceLinkArgs, anchor));
							}
						}
						if(itemCount ==10 && linkType.itemList.length> 10) {
							itemCount ++;
							anchor=document.createElement("A");
							anchor.appendChild(document.createTextNode("..."));
							anchor.title = this.messages.labelMore;
							anchor.href = tabLink.href;
							nameLi = document.createElement("LI");
							nameLi.className = "com-ibm-team-workitem-QuickInformationListItemDetail";
							nameLi.appendChild(anchor);
							itemList.appendChild(nameLi);
						}
						
						if (!this._isAjaxModule()) {
							var target = "";
							if(linkType.itemList[i].newWindow) {
								target = " target=\"_blank\"";
							}
							if (linkType.itemList[i].stateGroup == 2) {
								innerSpan.innerHTML += "<div class='com-ibm-team-workitem-Strikeout'><a" + target + " href=\"" + linkType.itemList[i].safeHref + "\">" + linkType.itemList[i].safeSummary + "</a></div>";
							}
							else {
								innerSpan.innerHTML += "<div><a" + target + " href=\"" + linkType.itemList[i].safeHref + "\">" + linkType.itemList[i].safeSummary + "</a></div>";
							}
						} else {
								innerSpan.innerHTML += "<div>" + linkType.itemList[i].safeSummary + "</div>";
						}
							
					} else {
						innerSpan.innerHTML += "<div>"+linkType.itemList[i].safeSummary + "</div>";
					}
				}
				
				if(itemCount ==0) {
					headerLi.className = "com-ibm-team-workitem-QuickInformationListItemLast";
					tabLink.appendChild(document.createTextNode(label));
				} else {
					tabLink.appendChild(document.createTextNode(dojo.string.substitute(this.messages.labelValue, [ label ])));
					nameLi = document.createElement("LI");
					nameLi.className = "com-ibm-team-workitem-QuickInformationListItemDetailLast";
					nameLi.appendChild(document.createTextNode(" "));
					itemList.appendChild(nameLi);
				}

			    if(linkType.iconUrl) {
			    	var url = linkType.iconUrl;
			    	if(url.uri) url = url.uri;
			    	var url = WorkItemUtil.getBackgroundImageUrl(url);
					headerLi.style.backgroundImage = "url('"+url+"')";
				} else {
					dojo.addClass(headerLi, "com-ibm-team-workitem-QuickInformationPixelIcon");
				} 

				if(linkType.hoverContent) {
					this._childWidgets.push(new jazz.ui.HoverPopup({ around: [ tabLink ], html: linkType.hoverContent.innerHTML}));
				} else {
 					this._childWidgets.push(new jazz.ui.HoverPopup({ around: [ tabLink ], html: tipSpan.innerHTML}));
				}
				li.appendChild(itemList);

				
				return li;
			},
		_isAjaxModule: function() {
			return window.location.href.indexOf("_ajax-modules") > 0;
		},
		_handleSummaryItemClick: function(e) {

		},
        _markDirtyIfDifferent: function(){
        
        
        },
        
        //
        // Part API Metnods
        //
        setReadOnly: function(isReadOnly){
        },
        getFormElementValues: function(formElements){
        },
        setFormElementValues: function(retainedState){
        },
        /*
         * Add values to the updateLinks commands
         *
         */
        getSaveCommands: function(allCommands){
            return allCommands;
        },
        getValue: function(){
        
        }
    });
    
})();
