/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.editor.parts.SubscribersPart");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil");
dojo.require("com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog");
dojo.require("com.ibm.team.workitem.web.ui2.internal.widget.StatusIndicator");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
/*
 * Shows subscribers and can be extended to show any attribute as a list in a section
 */
(function() {

var WidgetUtil = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil;
var EditorUtil	= com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil;
var SelectContributorDialog = com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog;
var SUBSCRIBERS_ID= "internalSubscriptions";
var headingColor = "#666668";
var headingNames  = {} 

var columnLayout = {
	name: {
		style: {
			position: "relative",
//			left: "5px",
			color: headingColor,
			width: "100%",
			top: "1px"
			}
	},
	subscribersName: {
			style: {
				position: "relative",
				left: "3px",
				color: headingColor,
				width: "100%",
				top: "1px"
			}
	}
}

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.editor.parts.SubscribersPart",
	[dijit._Widget, dijit._Templated],
	{
		
		templateString: 
						'<div class="SubscribersPart SectionPart">' +
						'<span dojoAttachPoint="_statusIconContainer" class="StatusIconContainer">' +
						'<div dojoAttachPoint="_statusIcon"></div></span>' +
						'<div dojoAttachPoint="_border" style="margin-left:0.75em; margin-bottom: 0.5em;">' +
						'<div dojoAttachPoint="_titleDiv" class="SubscribersPartTitleDiv" style="display:none">&nbsp;</div>' +
						'<div dojoAttachPoint="_addDIV" style="display:none" class="AddApproversAnchor SubscribersPartTitleActionDiv"><a dojoAttachPoint="_addCommand" href="#"></a></div>' +
						'<div class="SubscribersContent" dojoAttachPoint="_contentNode">No items.</div>' +
						'</div></div>',
  		constructor: function() {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
			columnLayout.name.label = this.messages.labelName;
			headingNames = {
				contributorList: this.messages.labelListOfUsers,
				processAreaList: this.messages.labelListOfProcessAreas,// "Process Areas",
				projectAreaList: this.messages.labelListOfProjectAreas, //"Project Areas"
				subscriptions: this.messages.labelListOfSubscribers, //"Subscribers"
				teamAreaList: this.messages.labelListOfTeamAreas, // "Team Areas",
				workItemList: this.messages.labelListOfWorkItems, //  "Work Items"
				itemList: this.messages.labelListOfItems //  "Items"
			}
		},	
		postCreate: function() {	
		// this.parentController is the work item editor
			this._childWidgets = [];
			this._isInitialized = false;
			this._workItem = this.parentController._workItem;
			this.statusIndicator= new com.ibm.team.workitem.web.ui2.internal.widget.StatusIndicator({}, this._statusIcon);

			var addLabel = this.getAddLabel();
			this._addCommand.appendChild(document.createTextNode(addLabel));
			
			if(!this.isReadOnly()) {
				var thingName;
				if(this.presentation.attributeLabel) {
					thingName = this.presentation.attributeLabel;
				} else {
					thingName = this.attributeId;
				}
				var actionTitle = dojo.string.substitute(this.messages.titleAddToThingsList, [ thingName ])
				if(this.sectionLayout && (!this.sectionLayout._childWidgets || this.sectionLayout._childWidgets.length ==0)) {
					this._addSubscriberAction = this.sectionLayout.addActionText(this.messages.buttonAddPrompt, 
						this, "_handleNewItemPressed", actionTitle);
					this._border.style.marginLeft="0";
					this.connect(this._addSubscriberAction, "onkeypress", "checkEnterForNewItem");
				} else {
					this._titleDiv.style.display="";
					this._addDIV.style.display="";
					this._border.style.border="1px #C7DCE7 solid";  //TODO: move to class, template too
					this._addCommand.title = actionTitle;
					this.connect(this._addCommand, "onclick", this._handleNewItemPressed2);
					if(this.isWorkItemListPart) {
						if(this.presentation.attributeLabel) {
							dojox.xml.parser.replaceChildren(this._titleDiv, document.createTextNode(this.presentation.attributeLabel));
						} else  {
							dojox.xml.parser.replaceChildren(this._titleDiv, document.createTextNode(headingNames[this.presentation.attributeType]));
						}
					} else 
						if(this.presentation && headingNames[this.presentation.attributeType]) {
							dojox.xml.parser.replaceChildren(this._titleDiv, document.createTextNode(headingNames[this.presentation.attributeType]));	
						}
					}
			}
			if(this.attributeId) {
				this.workingCopy.addListener({
					path: ["attributes", this.attributeId],
					event: "onchange",
					listener: this,
					functionName: "_handleWorkingCopyChange"
				});	
			} else {
				if(this.addWorkingCopyChangedListener)
				this.addWorkingCopyChangedListener();
			}
			this.postCreateRefresh();
		},
		destroy: function(preserveDom) {
			if(this.statusIndicator) this.statusIndicator.destroy(preserveDom);
			this.statusIndicator = null;
			this._destroyDialog();
            this.inherited(arguments);
		},
		postCreateRefresh: function() {
			this.refresh();
		},
		isReadOnly: function() {
			return this.workingCopy.isGuest();
		},
		getAddLabel: function() {
			return this.messages.actionAdd;
		},
		setListTitle: function(titleString) {
			dojox.xml.parser.replaceChildren(this._titleDiv, document.createTextNode(titleString));
		},
		destroyWidget: function() {
			this.destroyChildWidgets();
		},
		destroyChildWidgets: function() {
			for (var i = 0; i < this._childWidgets.length; i++) {
				if (this._childWidgets[i].destroyWidget) {
					this._childWidgets[i].destroyWidget();
					this._childWidgets[i] = null;
				}
				else {
					if (this._childWidgets[i].destroy) 
						this._childWidgets[i].destroy();
					this._childWidgets[i] = null;
				}
			}

			this._childWidgets = [];
			if(this._contentNode) dojox.xml.parser.removeChildren(this._contentNode);
		},
		/*
		 * Load the tab when it is shown
		 */
		showWidget: function() {
			if(this._isInitialized) return;
			this._isInitialized = true;
			this.refresh();
		},
		_handleWorkingCopyChange: function(parms) {
			this.refresh();
// Validation is handled in refresh
//			if(parms.validationStatus)
//				this.statusIndicator.setStatus(parms.validationStatus);
		},
		/*
		 * Setup the page and read the states and types 
		 */
		refresh: function() {

			this.destroyChildWidgets();			
			this._markDirtyIfDifferent();
			var creationArgs = {
						parentWidget: this,
						parentController: this.parentController,
						isHeading: false,
						isFirst: false,
						tableClass: "SectionListTableNoBorder"
					};
			var listWidget = new com.ibm.team.workitem.web.ui.internal.view.layout.SectionListWidget(creationArgs);
			
			var rowItems = [];
			var subscribers = this.getItems();
			
			subscribers.sort(function(a, b){
				try {
					if(a.name && b.name)
						return a.name.toLowerCase() < b.name.toLowerCase() ? -1 : 1;
					else return -1;
				} 
				catch (e) {
					return -1
				}
			});
			
			var isReadOnly = this.isReadOnly();
			for (var i = 0; i < subscribers.length; i++) {
				if (subscribers[i]) {
					var item = {};
					item.columnWidgets = [this._getRow(listWidget, subscribers[i], /* noBorder */ true, /* isLast withborder */ false) ]
					item.noBorder = true ;
					item.value  = subscribers[i];
					item.showDelete = !isReadOnly;
					rowItems.push(item);
				}
			}

			if(this.isUserDeleteable()) {
				listWidget.setRows(
					{
						itemList: rowItems,
						  deleteAction: {
								selector: "_handleDeleteSubscriber",
								title: this.messages.titleItemRemove
						},
 						restoreAction: {
								selector: "_handleRestoreSubscriber",
								title: this.messages.titleItemRestore
						}
					}
					)
			} else {
				listWidget.setRows(
						{
							itemList: rowItems
						}
						)				
			}
			
			dojox.xml.parser.removeChildren(this._contentNode);					
			if(subscribers.length > 0) {
				this._contentNode.appendChild(listWidget.domNode);
				this._childWidgets.push(listWidget);			
				dojo.removeClass(this._contentNode,"SubscribersEmptyContent");
			} else {
				var span = document.createElement("SPAN");
				span.style.color = "#999999"; // TODO: move to class
				span.style.paddingLeft = "5px";				
				if(!this.presentation) {
					span.appendChild(document.createTextNode(this.messages.labelListNoItemsDefault));
				} else {
					var typeName = headingNames[this.presentation.attributeType] || this.messages.labelListOfItems;
					span.appendChild(document.createTextNode(dojo.string.substitute(this.messages.labelListNoItems, [typeName])));
				}
				dojo.addClass(this._contentNode,"SubscribersEmptyContent");
				this._contentNode.appendChild(span);
			}
			if(this.attributeId) {
				var status= this.workingCopy._validate(this.attributeId);
				this.statusIndicator.setStatus(status);
				// this.statusIndicator.test();				
			}
		},
		isUserDeleteable: function() {
			return true;
		},
		getItems: function() {
			return this.workingCopy.getItems({attributeId: this.attributeId});
		},
		_markDirtyIfDifferent: function() {
			if(this.workingCopy.isChanged()) {
				if(this.parentWidget && this.parentWidget.markDirty) {
					this.parentWidget.markDirty();
				} 
				if(this.parentWidget && this.parentWidget.parentController && this.parentWidget.parentController.markDirty) {
						this.parentWidget.parentController.markDirty();
				}
			}
		},
		_handleDeleteSubscriber: function(e) {
			
			if(e && e.target && e.target.parentWidget && e.target.parentWidget.deleteItem) {
				e.target.parentWidget.deleteItem(e.target.value);
			}		
			
		},
		markParentDirty: function () {
			if(this.parentWidget && this.parentWidget.parentController && this.parentWidget.parentController.markDirty) {
				this.parentWidget.parentController.markDirty();
			}			
		},
		deleteItem:function(subscriber) {
			this.workingCopy.deleteItems({
				items: [subscriber],
				attributeId: this.attributeId
			});
			this.refresh();
				var status= this.workingCopy._validate(this.attributeId);
			this.statusIndicator.setStatus(status);
			// this.statusIndicator.test();		
		},
		_handleRestoreSubscriber: function(e) {
			if (e && e.target && e.target.parentWidget && e.target.parentWidget.restoreItem) {
				e.target.parentWidget.restoreItem(e.target.value);
			}
		},
		restoreItem: function(subscriber) {
			this.restoreSubscriber(subscriber);
		},
		restoreSubscriber:function(subscriber) {
			this.workingCopy.restoreItems({
				items: [subscriber],
				attributeId: this.attributeId
			});
			this.refresh();
			if(this.attributeId) {				
				var status= this.workingCopy._validate(this.attributeId);
				this.statusIndicator.setStatus(status);
				// this.statusIndicator.test();
			}
		},
		_getRow: function(listWidget, subscriber, noBorder , isLast) {
			var layout;
			if(this.attributeId == "internalSubscriptions") {
				layout = WidgetUtil.mergeObjects({}, columnLayout.subscribersName);
			} else {				
				layout = WidgetUtil.mergeObjects({}, columnLayout.name);
			}
			subscriber.name = this._getItemLabel(subscriber);
			var split = subscriber.name.split(" ");
			var name = "";
			for(var i=0;i<split.length;i++) {
				var word = split[i];
				if(word.length> 16) {
					word = word.replace(/.{15}/g,"$& ");
				}
				name += " " + word;
			}
			
			name.replace(/  /g," ");
			layout.label = name;
			layout.isFirst = noBorder;
			layout.isLast = isLast;
			if(subscriber.emailAddress) {
				var emailSubject;
				if(this.parentController && this.parentController.workingCopy) {
					try {
						emailSubject =  this.parentController.workingCopy.object.attributes.workItemType.label + " " + this.parentController.workingCopy.getId() + ": " + EditorUtil.restoreTags(this.parentController.workingCopy.object.attributes.summary.content);
					}	catch(e) {} // ignore;			
				}
				layout.href = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil._getMailto(subscriber.emailAddress, emailSubject); // subject can be null
			} else {
				if(this._getItemHref) {
					var href = this._getItemHref(subscriber);
					if(href) layout.href = href;
				}
			}
			layout.locationUri = subscriber.locationUri;
			layout.userId = subscriber.userId;
			layout.workingCopy = this.workingCopy;
			var widget =listWidget.getLabelWidget(layout);
			if(subscriber.userId) {
				widget.domNode.title= name + " (@" + subscriber.userId + ")";
			}
			
			if(noBorder) widget.columnParms = { className: "SectionListTableHeaderNoBorder" } 
			return widget;
		},
		_getItemLabel: function(item) {
			return item.name || item.label || this.messages.labelUnknown;
		},
		addSubscribers: function(newContribs) {
			this.workingCopy.addItems({
				items: newContribs,
				attributeId: this.attributeId
			});
			this.refresh();
			var status= this.workingCopy._validate(this.attributeId);
			this.statusIndicator.setStatus(status);
			// this.statusIndicator.test();
		},
		
		checkEnterForNewItem: function(e) {
			var characterCode;
			characterCode = e.keyCode;
			if(characterCode == 13) { //the key presed was 'enter'
				this._handleNewItemPressed2(e);			
			}	
		},

		_handleNewItemPressed2: function(e) {
			dojo.stopEvent(e);
			this._openCustomChooseDialog();
		},
		_handleNewItemPressed: function(action) {
			this._openCustomChooseDialog();
		},		
		_openCustomChooseDialog: function() {
			if(this._openChooseDialog) {
				this._openChooseDialog()
			} else {
				this._openSubscribersDialog();
			}
		},
		_openSubscribersDialog: function() {
			this._destroyDialog();
			var self= this;

			var params= {
				disableUsers: this.getCurrentItems()
			};
				
			this.contributorListWidget= new SelectContributorDialog(params);
			this.connect(this.contributorListWidget, "onClose", dojo.hitch(this, function() { this.parentController.focus(); this._destroyDialog();}));
			this.connect(this.contributorListWidget, "onOK", dojo.hitch(this, function(selectedContribs) { this.addSubscribers(selectedContribs);}));
			this.contributorListWidget.searchText.focus();				
		},
		_destroyDialog: function() {
			if(this.contributorListWidget) this.contributorListWidget.destroy(false);
			this.contributorListWidget = null;
		},
		/**
		 * Returns an array of the itemIds of the current subscribers.
		 */
		getCurrentItems: function() {
			return this.workingCopy.getCurrentItems({attributeId: this.attributeId, includeCreator: false});
		},
		handleSaveComplete: function() {
			this.refresh();
		}
	}
);

})();
