/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.editor.parts.ValueSetPickerContent"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.api.common.WorkItemCollections"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.ValueSetRestClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.module.WindowContext"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.parts.ValueSetPickerListBox"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("jazz.ui.Dialog"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "ValueSetPickerMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var ServiceResponseHandler= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var WorkItemCollections= com.ibm.team.workitem.api.common.WorkItemCollections;
var ValueSetRestClient= com.ibm.team.workitem.web.client.internal.ValueSetRestClient;
var ValueSetPickerMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "ValueSetPickerMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var WindowContext= com.ibm.team.workitem.web.ui.internal.module.WindowContext;
var ValueSetPickerListBox= com.ibm.team.workitem.web.ui.internal.view.editor.parts.ValueSetPickerListBox;
var _Templated= dijit._Templated;
var _Widget= dijit._Widget;
var Dialog= jazz.ui.Dialog;

dojo.declare("com.ibm.team.workitem.web.ui.internal.view.editor.parts.ValueSetPickerContent", [ _Widget, _Templated], { //$NON-NLS-1$

	templatePath: dojo.moduleUrl("com.ibm.team.workitem.web", "ui/internal/view/editor/templates/ValueSetPickerContent.html"), //$NON-NLS-1$ //$NON-NLS-2$

	TYPE_ID: null,

	ftAttributeConstant: null,

	ATTRIBUTE_ID: null,

	CONTENT: null,

	fDialog: null,

	oldValue: null,

	results: null,

	queryInput: null,

	okCmd: null,

	cancelCmd: null,

	status: null,

	list: null,

	workingCopy: null,

	attributeId: null,

	attributeLabel: null,

	_onCloseCallback: null,

	DELAY: null,

	intervalID: null,

	EnterFilterString: null,

	Values: null,

	OkButton: null,

	CancelButton: null,

	Disabled: null,

	EMPTY_STRING: null,

	constructor: function(params) {
		this.TYPE_ID= "workItemType"; //$NON-NLS-1$
		this.ftAttributeConstant= WorkItemCollections.ATTRIBUTES;
		this.ATTRIBUTE_ID= "id"; //$NON-NLS-1$
		this.CONTENT= "content"; //$NON-NLS-1$
		this.DELAY= 750;
		this.Disabled= "Disabled"; //$NON-NLS-1$
		this.EMPTY_STRING= ""; //$NON-NLS-1$
		this.workingCopy= params.workingCopy;
		this._onCloseCallback= params.onCloseCallback;
		this.attributeId= params.attributeId;
		this.attributeLabel= params.attributeLabel;
		this.oldValue= params.currentValue;
		this.EnterFilterString= ValueSetPickerMessages.ENTERSEARCHSTRING;
		this.Values= ValueSetPickerMessages.VALUES_LABEL;
		this.OkButton= ValueSetPickerMessages.OKBUTTON;
		this.CancelButton= ValueSetPickerMessages.CANCELBUTTON;
	},

	postCreate: function() {
		this._initalize();
		this._connectEvents();
		this.subscribeEvents();
		this.createDialog();
	},

	createDialog: function() {
		var dialogParams= {};
		dialogParams.primaryTitle= dojo.string.substitute(ValueSetPickerMessages.DIALOG_TITLE, [this.attributeLabel]);
		dialogParams.contentNode= this.domNode;
		dialogParams.width= "32em"; //$NON-NLS-1$
		dialogParams.onClose= dojo.hitch(this, function() {
			return true;
		});
		this.fDialog= new Dialog(dialogParams);
	},

	/**
	 * Initialize the List Box Add the onDoubleClick and onClick
	 */
	_initalize: function() {
		if (this.list == null) {
			var params= {};
			params.ondblClick= dojo.hitch(this, function(entry) {
				this._close(entry.id);
			});
			params.allowMultipleSelections= false;
			this.list= new ValueSetPickerListBox(params);
		}
		this.results.appendChild(this.list.domNode);
	},

	subscribeEvents: function() {
		dojo.subscribe("PUBLISH_ON_SELECT", this, "_enable"); //$NON-NLS-1$ //$NON-NLS-2$
		dojo.subscribe("PUBLISH_ON_ESCAPE", this, "_onCancel"); //$NON-NLS-1$ //$NON-NLS-2$
		dojo.subscribe("PUBLISH_ON_ENTER", this, "_onOk"); //$NON-NLS-1$ //$NON-NLS-2$
		dojo.subscribe("PUBLISH_ON_CHANGE_FOCUS", this, "_setFocus"); //$NON-NLS-1$ //$NON-NLS-2$
	},

	_enable: function() {
		this.okCmd.disabled= this.EMPTY_STRING;
	},

	_onCancel: function() {
		this._close(this.oldValue);
	},

	_onOk: function() {
		if (this.list != null) {
			var entries= this.list.getSelection();
			if (entries != null && entries.length === 1) {
				this._close(entries[0].id);
			}
		}
	},

	_setFocus: function() {
		this.queryInput.focus();
	},

	/**
	 * Connect the Required Events
	 */
	_connectEvents: function() {
		this.connect(this.queryInput, 'keyup', dojo.hitch(this, function(e) { //$NON-NLS-1$
			this._search(e);
		}));
		this.connect(this.okCmd, 'click', dojo.hitch(this, function(e) { //$NON-NLS-1$
			this._onOk();
		}));
		this.connect(this.cancelCmd, 'click', dojo.hitch(this, function(e) { //$NON-NLS-1$
			this._onCancel();
		}));
	},

	/**
	 * Call the Search method and add the Message
	 */
	_doSearch: function() {
		this.status.innerHTML= ValueSetPickerMessages.SEARCHING;
		var onSuccess= dojo.hitch(this, "_onSearchPerformed"); //$NON-NLS-1$
		var onFailure= dojo.hitch(this, "_searchProblem"); //$NON-NLS-1$
		var parameters= {};
		parameters.attributeId= this.attributeId;
		if (this.workingCopy != null && !this.workingCopy.isNewWorkItem()) {
			parameters.itemId= this.workingCopy.getItemId();
			parameters.id= String(this.workingCopy.getId());
		}
		parameters.projectAreaItemId= WindowContext.getCurrentProjectArea().itemId;
		parameters.filter= this.queryInput.value;
		if (this.workingCopy != null) {
			var args= {path: [this.ftAttributeConstant, this.TYPE_ID, this.ATTRIBUTE_ID]};
			parameters.typeId= this.workingCopy.getValue(args);
			var numChangedAttribtues= jdojo.getProperties(this.workingCopy.changedAttributes).length;
			if (numChangedAttribtues > 0) {
				parameters.attributeIdentifiers= new Array(numChangedAttribtues);
				parameters.attributeValues= new Array(numChangedAttribtues);
				for (var i= 0; i < numChangedAttribtues; i++){
					var attr= jdojo.getValues(this.workingCopy.changedAttributes)[i];
					parameters.attributeIdentifiers[i]= attr.attributeId;
					parameters.attributeValues[i]= attr.value;
				}
			}
		}
		var responseHandler= new ServiceResponseHandler({'onSuccess': onSuccess, 'onFailure': onFailure}, 'onSuccess', 'onFailure'); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		ValueSetRestClient.getValueSet(responseHandler, parameters);
	},

	/**
	 * Reset and search
	 */
	_search: function(kEvent) {
		this._reset();
		if (kEvent != null) {
			if (kEvent.keyCode === 38) {
				return ;
			}
			if (kEvent.keyCode === 40) {
				var args= [this];
				dojo.publish("PUBLISH_ON_CHANGE_DOWN", args); //$NON-NLS-1$
				return ;
			}
		}
		if (this.intervalID > 0) {
			window.clearTimeout(this.intervalID);
		}
		this.intervalID= window.setTimeout(dojo.hitch(this, function() {
			this._doSearch();
		}), this.DELAY);
	},

	_onSearchPerformed: function(searchResult) {
		this.list.removeAllEntries();
		this.list.showLoading(true);
		var numberOfEntries= 0;
		if (searchResult.valueSet != null) {
			numberOfEntries= searchResult.valueSet.length;
		}
		this.status.innerHTML= dojo.string.substitute(ValueSetPickerMessages.RESULTS, [numberOfEntries]);
		if (numberOfEntries > 0) {
			var $subject= searchResult.valueSet;
			var $length= $subject.length;
			for (var $count= 0; $count < $length; $count++){
				var item= $subject[$count];
				var entry= {};
				entry.label= item.label;
				entry.id= item.id;
				entry.value= item.label;
				entry.type= "string"; //$NON-NLS-1$
				this.list.addEntry(entry);
			}
		}
		this.list.selectFirst();
		this.results.replaceChild(this.list.domNode, this.list.domNode);
		this.results.setAttribute("tabIndex", "0"); //$NON-NLS-1$ //$NON-NLS-2$
		this.list.showLoading(false);
		if (searchResult.status.severity === 4) {
			this.status.innerHTML= searchResult.status.message;
		}
	},

	_searchProblem: function(error) {
		this._handleError(String(error));
		this.status.innerHTML= ValueSetPickerMessages.NORESULTS;
	},

	/**
	 * Handle the error Message
	 * 
	 * @param errorMsg
	 */
	_handleError: function(error) {
		console.log(error);
	},

	/**
	 * Reset the ok button to disabled
	 */
	_reset: function() {
		this.okCmd.disabled= this.Disabled;
		this.results.setAttribute("tabIndex", "1"); //$NON-NLS-1$ //$NON-NLS-2$
	},

	_close: function(value) {
		if (this._onCloseCallback != null) {
			this._onCloseCallback(value);
		}
		this.fDialog.close(null);
	}
});

})();
