/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.editor.parts.WorkItemTypeAttributePart");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.EnumerationWidget");
/*
 * Handle presentation operations pertaining to the owner attribute
 */
(function() {

var EnumerationWidget = com.ibm.team.workitem.web.ui.internal.view.layout.EnumerationWidget;

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.editor.parts.WorkItemTypeAttributePart",
	EnumerationWidget,
	{
        constructor: function() {

		},
		postCreate: function()  {
			this.inherited(arguments);
		},
		onValueChanged: function(newValue, isInit) {
			
			this._handleWorkItemTypeChange(newValue, isInit);
		},
		getRetainedState: function(retainedState) {
			if(!this._isChanged) return;
			retainedState.workItemType= this.getValue();
		},
		setFormElementValues: function(retainedState, isGuest){
		 	if(retainedState.workItemType) {
				this.setValue(retainedState.workItemType, /* noNotify */ true);
			}
		 },
		/*
		 * Handle a change to the work item type
		 */
		_handleWorkItemTypeChange: function(value, isInitialization) {
			if(!isInitialization) {
				var e = { target: this._select };
				this.parentController.conditionalMarkDirty(e);	
			}
			var imgSrc= value.iconUrl;
			if(this.parentController.updateType) {
				this.parentController.updateType(value, value.label, imgSrc,isInitialization);
			}
		}
 	}
);

})();
