/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.process.ui.internal.view.enumeration.AddEnumerationContent");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.i18n");
dojo.require("com.ibm.team.workitem.web.process.ui.internal.view.common.ButtonDialog");
dojo.requireLocalization("com.ibm.team.workitem.web.process.ui.internal", "EnumerationMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare(
	"com.ibm.team.workitem.web.process.ui.internal.view.enumeration.AddEnumerationContent",
	[dijit._Widget, dijit._Templated],
{
	templatePath: dojo.moduleUrl("com.ibm.team.workitem.web.process", "ui/internal/view/enumeration/templates/AddEnumerationContent.html"),

	postMixInProperties: function(){
		this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.process.ui.internal", "EnumerationMessages");
		this.inherited(arguments);
	},
	
	_handleIdChanged: function(e){
		if(this.enumNameField.value.length === 0){
			this.enumNameField.value = this.enumIdField.value;
		}
	},
	
	getValues: function(){
		return {
			id: this.enumIdField.value,
			name: this.enumNameField.value
		};
	}
});

com.ibm.team.workitem.web.process.ui.internal.view.enumeration.AddEnumerationContent.openDialog = function(prop){
	var contentWidget = new com.ibm.team.workitem.web.process.ui.internal.view.enumeration.AddEnumerationContent();

	var self = this;
	var model = prop.model;
	model.getAttributeTypes(function(configData){
		// show dialog
		new com.ibm.team.workitem.web.process.ui.internal.view.common.ButtonDialog({
			primaryTitle: prop.title,
			dialogContent: contentWidget,
			onOpen: function(){
				dijit.focus(contentWidget.enumIdField);
			},
			validate: function(values, callback){
				if(!values.id || values.id.length === 0){
					alert(contentWidget.messages.errEnumIDEmpty);
				}else{
					// check duplicate ID
					if(configData.enumerationTypes && dojo.some(configData.enumerationTypes, function(enumInfo){
							return (enumInfo.id == values.id);
						})){
						alert(contentWidget.messages.errEnumIDAlreadyExist);
					}else{
						callback();
					}
				}
			},
			onOK: function(values){
				// add work item type to the model
				var id = values.id;
				var name = values.name;
				if(!name || name.length===0){
					name = id;
				}
				model.addEnumeration({
					id: id,
					displayName: name
				});
			}
		});
	});


}