/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.layout.RequiredPropertyMarkWidget");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.team.workitem.web.ui.internal.page.EventTopics");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");

(function() {
dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.layout.RequiredPropertyMarkWidget",
	[dijit._Widget, dijit._Templated],
	{
		templateString: '<span class="RequiredPropertyMarkWidget">' +
						   '<span style="visibility: hidden" class="RequiredMarker" dojoAttachPoint="requiredMarkerSpan"></span>'+
						'</span>',

		postCreate: function() {
	// workingCopy
		this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
		this.requiredMarkerSpan.innerHTML = this.messages.labelRequired; // "* " innerHTML OK 
		this.requiredMarkerSpan.title = this.messages.titleRequiredMarker;
		this._setRequiredMarker();
		this._handles = [dojo.subscribe(com.ibm.team.workitem.web.ui.internal.page.EventTopics.WORKITEM_REQUIRED_PROPERTIES_CHANGED, 
				dojo.hitch(this, this._handleRequiredPropertiesChanged))];
		
		this.inherited(arguments);
		},
		uninitialize: function() {
			for(var i=0;i<this._handles.length;i++) {
				dojo.unsubscribe(this._handles[i]);
			}
		},
		setAttributeId: function(id) {
			this.attributeId = id;
			this._setRequiredMarker();
		},
		_handleRequiredPropertiesChanged: function(parms /* workingCopy */ ) {
			if(parms.workingCopy != this.workingCopy) return;
			this._setRequiredMarker();
		},
		_setRequiredMarker: function() {
		var isRequired = this.attributeId && this.workingCopy ? this.workingCopy.getIsRequired(this.attributeId) : false;
		if(isRequired) { 
				this.requiredMarkerSpan.style.visibility = "visible";
			} else {
				this.requiredMarkerSpan.style.visibility = "hidden";
			}
	},
		_sentinal: true
	}
);

})();
