/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.layout.SectionListTableWidget");

	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil");

(function() {

var WidgetUtil = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil;

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.layout.SectionListTableWidget",
	[dijit._Widget, dijit._Templated],
	{
		templateString: '<div class="SectionListTableWidget">' +
						'<div dojoAttachPoint="_tableNode" class="SectionListTableNode"></div>' +
						'</div>',

		postCreate: function() {
			this._table = document.createElement("TABLE");
			this._table.cellPadding = 0;
			this._table.cellSpacing = 1;
			this._table.border=0;
			
			this._table.className = this.tableClass ? this.tableClass : "SectionListTable";
			this._spannedCells = [];
			this._columnCount = 1;
			
			this._tableNode.appendChild(this._table);
		},
		destroyWidget: function() {
			this.destroy();
		},
		addRow: function (parms) {
			parms = parms ? parms : {};
			var row;
			if(this.isHeading) {
				var thead = this._table.createTHead();
				row = document.createElement("TH");
				thead.appendChild(row);
			} else { 
				row =this._table.insertRow(-1);
			}
			row.parms = parms;
			if(parms.className) {
				row.className = parms.className;
			} else {
				row.className = "SectionListTableRow";
			}
			return row;
		},
		addColumnWidget: function (row, widget, parms) {
			return this.addColumn(row, widget.domNode, parms);
			},
		addColumn: function (row, domNode, parms, className) {
			parms = parms ? parms : {};
			var td = document.createElement("TD");
		 	var cell = row.appendChild(td);
			cell.appendChild(domNode)
			cell.parms = parms;

			if(parms.attributes) {
				for(var attr in parms.attributes) {
					cell[attr] = parms.attributes[attr];
				}
			}
			
			if(parms.style) {
				for(var style in parms.style) {
					cell.style[style] = parms.style[style];
				}
			}
			if(!dojo.hasClass(row,"SectionListTableHeadingRow")) {
				cell.style.paddingRight = "1px";
			}
			
			
			
			if (className) {
				cell.className = className;
			}
			else {
				if (parms.className) {
					cell.className = parms.className;
				}
				else {
					cell.className = this.columnClass ? this.columnClass : "SectionListTableColumn";
				}
			}
			/*
			 * cell
			 */
			if(parms.isSpanner) {
				cell.colspan = this._columnCount;
			} else {
				this._columnCount  = this._columnCount == 1 ? this._columnCount : this._columnCount + 1;
				for(var i=0;i<this._spannedCells.length;i++) {
					this._spannedCells[i].colSpan = this._columnCount;
				}
			}
			return cell;
		}
	}
);

})();
