/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.layout.SelfSizingTextAreaWidget");

	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");
dojo.require("com.ibm.team.repository.web.client.session.Session");
dojo.require("com.ibm.team.workitem.web.ui2.internal.widget.StatusIndicator");

// dojo.requirx("dijit.form.Textarea");

(function() {

// This is a *PLACEHOLDER* for a self sizing textarea like dijit.textarea

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.layout.SelfSizingTextAreaWidget",
	[dijit._Widget, dijit._Templated],
	{
		templateString: '<span class="SelfSizingTextareaWidget">' +
						   '<div class="fieldWrapper">' +
						'<div dojoAttachPoint="_statusIconContainer" class="StatusIconTextContainer">' +						   
						'<div dojoAttachPoint="_statusIcon"></div></div>' +						   
						   '<textarea dojoAttachPoint="textarea" class="SelfSizingTextArea WidgetInput"></textarea></div>'+
						'</span>',

		postCreate: function() {
			this._isEnabled = true;
			if (com.ibm.team.repository.web.client.session.isGuest()) {
				dojo.addClass(this.textarea, "GuestField");
			}
			if(this.creationSpec && this.creationSpec.isReadOnly) {
				this.textarea.readOnly = true;
			}
			if(this.creationSpec && this.creationSpec.height) {
				this.setHeight(this.creationSpec.height);
			}
			if(this.creationSpec && this.creationSpec.width) {
				this.setWidth(this.creationSpec.width);
			}
			if(this.creationSpec && this.creationSpec.className) {
				dojo.addClass(this.textarea, this.creationSpec.className);
			}
			this.statusIndicator= new com.ibm.team.workitem.web.ui2.internal.widget.StatusIndicator({}, this._statusIcon);
			var status= this.parentController.workingCopy._validate(this.attributeId);
			this.statusIndicator.setStatus(status);
			// this.statusIndicator.test();
		},
		destroy: function(preserveDom) {
			if(this.statusIndicator) this.statusIndicator.destroy(preserveDom);
			this.statusIndicator = null;
            this.inherited(arguments);
		},
//		createTextarea: function () {
//			var textBox = new dijit.form.Textarea({});
//
//			this.textBox.editNode.style.fontFamily = "Arial, Helvetica, sans-serif";
//			if(!dojo.isIE) {
//				this.textBox.editNode.style.fontSize = "0.8em";
//			}
//			if(this.textBox.iframe) { // IE doesn't have this
//				this.textBox.iframe.style.minHeight = "3.5em";
//				this.textBox.iframe.style.padding = "0px 3px 3px 3px";
//			}
//			
//			// Fix an error when textbox are hidden
//			textBox._changedActual = textBox._changed;
//			textBox._changed = function (e, p) {
//				if(this.iframe && this.iframe.contentDocument) {
//					this._changedActual(e, p);
//				} else  {
//					this.setValue(null, p);
//				}
//			}				
//		},
		_setStatusAttr: function(status) {
			// summary:
			//      Registers that attr("value", foo) should call setValue(foo)
			this.setStatus(status);
		},
		setStatus: function(status) {
			this.statusIndicator.setStatus(status);
		},
	     getValue: function() {
			// fix a bug that return /n even in empty strings
//			if(value == "\n") return "";
			if(!this._isEnabled) {
				return ""; // no value returned even if disabled value exists
			}
			return this.textarea.value;			
		 },
	     setValue: function(value) {
			this.textarea.value = value;
		 },
		 focus: function() {
		 	this.textarea.focus();
		 },
		 _setWidthAttr: function(width) {
			// summary:
			//      Registers that attr("value", foo) should call setValue(foo)
		 	this.setWidth(width);
		 },
		 setWidth: function(width) {
		 	this.textarea.style.width = width;
		 },
		 _setHeightAttr: function(height) {
			// summary:
			//      Registers that attr("value", foo) should call setValue(foo)
			this.setHeight(height);
		 },
		 setHeight: function(height) {
		 	this.textarea.style.height = height;
		 },
		 setEnabled: function(isEnabled) {
		 	if(isEnabled && !this._isEnabled) {
		 		this.setValue(""); // After disable/enable, reset the value
		 	}
		 	this._isEnabled = isEnabled;
		 	if(isEnabled) {
			 	dojo.removeAttr(this.textarea, "DISABLED");
			 	this.textarea.style.background = ""; // for IE
		 	} else {	 		
			 	this.textarea.style.background = "#EEE"; // for IE
			 	dojo.attr(this.textarea, "DISABLED", "DISABLED");
		 	}
		 }
	}
);

})();
