/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.layout.TimestampWidget");

	dojo.require("dijit._Widget");
	dojo.require("dijit._Templated");

dojo.require("dijit.form.DateTextBox");
dojo.require("dojo.i18n");
dojo.require("dojo.date.stamp");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.common.ImagePool");
dojo.require("com.ibm.team.workitem.web.client.util");
dojo.require("com.ibm.team.workitem.web.ui2.internal.widget.StatusIndicator");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WidgetMessages");
dojo.require("com.ibm.team.repository.web.client.session.Session");
(function() {

var WidgetUtil = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil;
var EditorUtil = com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil;
var util = com.ibm.team.workitem.web.client.util;
var ImagePool = com.ibm.team.workitem.web.ui.internal.view.common.ImagePool;

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.layout.TimestampWidget",
	[dijit._Widget, dijit._Templated],
	{
		templateString: '<div class="TimestampWidget">' +
						'<img dojoAttachPoint="_spacer" class="PreFieldImage" />' +
						'<span dojoAttachPoint="_statusIconContainer" class="StatusIconTimestampContainer">' +
						'<div dojoAttachPoint="_statusIcon"></div></span>' +
						'<span style="display: none" dojoAttachPoint="_dateReadOnlyValueSPAN" tabindex="0" class="ReadOnlyTextValue TimestampLabel"></span>' +
						'<span style="display: inline" dojoAttachPoint="_dateTextSPAN" class="TimestampInput"><span dojoAttachPoint="_dateBoxSPAN"></span><img dojoAttachPoint="_calandarImage" class="CalendarImage" dojoAttachEvent="onclick: _handleCalendarClick"/></span>' +
						'</div>',
 		constructor: function() {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WidgetMessages");
		},
		postCreate: function() {
			this.statusIndicator= new com.ibm.team.workitem.web.ui2.internal.widget.StatusIndicator({}, this._statusIcon);
			WidgetUtil.setSpacerImage(this._spacer);
			
			if(!this._modifiers) this._modifiers = {};
						
			var isReadOnly = com.ibm.team.repository.web.client.session.isGuest() || this._modifiers.readonly == "true";
			// Timestamp is used in ApprovalWidget, so support values or workingCopy
			if(this.workingCopy) {
				var value = this._getAttributeValue();
			} else {
				var value =  WidgetUtil.getFirstValue(this.values, true, true);
			}

							
			var contributor = false;
			if(isReadOnly) {
				this._statusIconContainer.className="StatusIconTimestampReadOnlyContainer";
				if(this.presentation && this.presentation.properties) {
					for(var i=0;i<this.presentation.properties.length; i++) {
						if(this.presentation.properties[i] &&
							this.presentation.properties[i].key == "contributorAttributeId" ){
								var split = this.presentation.properties[i].value.split(".");
								if(split.length > 0) {
									var attrName = split[split.length-1];
									if(this.workItem && this.workItem.attributes && this.workItem.attributes[attrName]) {
										contributor = this.workItem.attributes[attrName];
									}
								}
							}
					}
				}								
			} else {
				if(value && value.content != null) value = value.content;
				if(value && !value.id && value.label) value = "";
				if(!value || (isNaN(value) && (value.indexOf("1969-12-31") != -1))) value = "";
			}

			this.createDateLabel(value, /* isSeconds */ false, contributor);
			if(!isReadOnly) {
				this.createDateTextBox();
			} else {
				this._dateTextSPAN.style.display="none";
				this._dateReadOnlyValueSPAN.style.display="inline";				
			}
			this._isChanged = false;
			this._calandarImage.src = ImagePool.CALENDAR;
			
			if (this.workingCopy) {
				this.workingCopy.addListener({
					path: ["attributes", this.attributeId],
					event: "onchange",
					listener: this,
					functionName: "_handleAttributeChange"
				});
				var status= this.workingCopy._validate(this.attributeId);
				this.statusIndicator.setStatus(status);
				// this.statusIndicator.test();
			}
		},
		_handleAttributeChange: function(parms) {
			this._setDateValue(parms.attributeValue);
			if(parms.validationStatus)
				this.statusIndicator.setStatus(parms.validationStatus);		

		},
		_getAttributeValue: function() {
			if(!this.workingCopy) return;
			return this.workingCopy.getValue({ path: ["attributes", this.attributeId, "id"] });			
		},
		_setAttributeValue: function(value, isInit){
			if(!this.workingCopy) return;
			this.workingCopy.setValue({
				caller: this,
				path: ["attributes", this.attributeId, "id"],
				savedAttributePath: ["attributes", this.attributeId, "id"],
				attributeId: this.attributeId,
				isInitialization: isInit,
				value: value
			});
			var status= this.workingCopy._validate(this.attributeId);
			this.statusIndicator.setStatus(status);
		},
		_setDateValue: function(value){
			if (!this.dateWidget) 
				return;
			var currentValue = this.dateWidget.attr("value") ? this.dateWidget.attr("value").getTime() : null;
			if (currentValue != value) {
				if (value > 0) {
					this.dateWidget.attr("value", new Date(value));
				}
				this.createDateLabel(value, /*isSeconds*/ true);
				this._isChanged = true;
				if (this._modifiers && this._modifiers.onValueChanged && this.parentWidget && this.parentWidget[this._modifiers.onValueChanged]) {
					this.parentWidget[this._modifiers.onValueChanged](this, value);
				}
			}
		},
		_getDateValue: function() {
			var dueDate = null;
			try {
				dueDate = this.dateWidget.attr("value");
				if (dueDate != null && dueDate != -1) {
					// Set to noon local
					dueDate.setHours(12);
					dueDate.setMinutes(0);
					dueDate.setSeconds(0);
					dueDate.setMilliseconds(0);
					dueDate = dueDate.getTime();
				}
			} catch(e) { } // ignore

			dueDate = dueDate === -1 ? null : dueDate;
			
			if(dueDate && (typeof dueDate) != "number") {
				var	dueDateDate = util.fromISOString(dueDate);
				if(dueDateDate) {
					dueDate =dueDateDate.getTime();						
				} else {
					dueDate = null;
				}
			}
			
			if (dueDate != null) {
				dueDate = new Date(dueDate);
				dueDate.setUTCHours(12, 0, 0, 0);
				dueDate = dojo.date.stamp.toISOString(dueDate, {milliseconds:true, zulu:true});
			}
				
			return dueDate;
		},
		destroy: function() {
			if(this.statusIndicator) this.statusIndicator.destroy();
			this.statusIndicator = null;
			this._isDestroyed = true;
			if(this.dateWidget) this.dateWidget.destroy();
			this.inherited(arguments);
		},
		setReadOnly: function(isReadOnly) {
			if(this._modifiers && this._modifiers.readonly == "true")return;
			if (isReadOnly) { // was mouse out
				if (this._isChanged) {
					this.setReadOnly(false);
					return;
				}
				this._dateTextSPAN.style.display="none";
				this._dateReadOnlyValueSPAN.style.display="inline";
			}
			else {
				this._dateTextSPAN.style.display="inline";
				this._dateReadOnlyValueSPAN.style.display="none";
			}
		},
		_handleCalendarClick: function(e) {
			this.dateWidget.focus();
		},
		createDateLabel: function(value, isSeconds, contributor) {
			var timeValue = value;
			
			if(value == "Unassigned") {
				value = "";
			}
			if(value && value.label && value.label == "Unassigned") {
				value.label = "";
			} 
			
			if(!value || value.length == 0) {
				if(this._modifiers.noValueLabel) {
					value = this._modifiers.noValueLabel; 
				} else {
					value = this.messages.labelDefaultNullDate;					
				}
				if (this._modifiers.noValueTitle) {
					timeValue = this._modifiers.noValueTitle;
				} else {
					timeValue = this.messages.titleNullDate;					
				}
				if (this._modifiers.readonly == "true") {
					dojo.addClass(this._dateReadOnlyValueSPAN, "GreyLabel");
				}
			} else {
				var date;
				if(isNaN(value) && !isSeconds) {
					date = util.fromISOString(value);					
				} else {
					date = new Date(value);
				}
				
				if(date != null ) {
					value = EditorUtil._getDateString(date, false);
					timeValue = EditorUtil._getDateString(date, true);
					// Defect 66967. Dojo does not return a string for all locales.
					if(!dojo.isString(timeValue)) {
						timeValue = value;
					}
					
					if(!contributor) {
						value = timeValue;
					}
				
				} else {
					if(value.label) {
						value = value.label;
					} else {
						if(value.id) {
							value = value.id
						} else {
							value = "";
						}
					}
					if (!value || value.length == 0) {
						if (this._modifiers.noValueLabel) {
							value = this._modifiers.noValueLabel;
						}
						else {
							value = this.messages.labelDefaultNullDate;
						}
						if (this._modifiers.noValueTitle) {
							timeValue = this._modifiers.noValueTitle;
						}
						else {
							timeValue = this.messages.titleNullDate;
						}
						if (this._modifiers.readonly == "true") {
							dojo.addClass(this._dateReadOnlyValueSPAN, "GreyLabel");
						}
					}
				}
			}
			dojox.xml.parser.removeChildren(this._dateReadOnlyValueSPAN);
			var dateSpan = document.createElement("SPAN");
			dateSpan.appendChild(document.createTextNode(value));
			// Defect 66967. Dojo does not return a string for all locales.
			if(dojo.isString(timeValue)) {
				dateSpan.title = timeValue;
			}			

 			this._dateReadOnlyValueSPAN.appendChild(dateSpan);
			var contribSpan = this.createContributorLabel(contributor);
			if(contribSpan) {
				this._dateReadOnlyValueSPAN.appendChild(contribSpan);	
			}
		},
		createContributorLabel: function (contributor) {
			if(!contributor || !contributor.name) return null;
			var href;
			if(contributor.emailAddress) {
				href = this.parentController._getMailto(contributor.emailAddress);
			}
// If there is an href, add the anchor, otherwise just add a label
// <a dojoAttachPoint="_anchor" class="LayoutValue Anchor"><span dojoAttachPoint="_labelSPAN" class=""></span></a>
			var labelTarget;
			if(href) {
				var anchor = document.createElement("A");
				anchor.href = href;
				dojo.addClass(anchor, "LayoutValue");
				dojo.addClass(anchor, "Anchor");
				anchor.style.paddingLeft = "1em;"
//				anchor.style.fontSize = "100%";
				anchor.appendChild(document.createTextNode(contributor.name));
				labelTarget = anchor;
			} else {
				labelTarget = document.createElement("SPAN");
				labelTarget.appendChild(document.createTextNode(contributor.name));
				labelTarget.className  = "LayoutContributorLabel";
			}
			
			return labelTarget;
		},
		createDateTextBox: function() {
		    dojo.addClass(this.domNode, "DateTextContainer"); 
			var value =  WidgetUtil.getFirstValue(this.values, true, true);
			if(value.content != null) value = value.content;
			if(value && !value.id && value.label) value = "";
			if(!value || (isNaN(value) && value.indexOf("1969-12-31") != -1)) value = "";
			var constraints = {};
			if(dojo.i18n.normalizeLocale() == "en-us") {
				constraints = { datePattern: "MMM d, yyyy"	}; 
			}
			this.dateWidget= /* createWidget */ new dijit.form.DateTextBox (
				{ isDate: true, containerToggle: "fade", constraints: constraints },
			this._dateBoxSPAN);
			var date = null;
			if (isNaN(value) || value == "") {
				if (value != "") {
					date = util.fromISOString(value);
				}
			} else {
				date = new Date(value);
			}
			if(date)this.dateWidget.attr("value", date);
			
			this.dateWidget.__jazzWidget = this;
			var self = this;
			this._date = date;
			this.connect(this.dateWidget, "onChange", dojo.hitch(this, function(e) {
				if((this._date + "") == (this.dateWidget.value + "")) return;
				this._handleDateChange();

//				var value = self.dateWidget.getValue().getTime();
//				self.currentValue = value;
//				self.createDateLabel(value, /*isSeconds*/ true);
			}));
			
			// Date widget dynamically replaced its class so need to set element style.
			this.dateWidget.domNode.style.width = "71%";
			this.dateWidget.domNode.style.margin = "0";
			this.dateWidget.domNode.style.fontFamily = "inherit";
//			dojo.addClass(this.dateWidget.domNode, "DateInputField");
		},
		getFormElementValues: function(formElements) {
			if(this._modifiers.readonly == "true") return;
//			if(!this._isChanged) return;
			var dueDate = null;
			try {
				dueDate = this.dateWidget.attr("value");
				if (dueDate != null && dueDate != -1) {
					// Set to noon local
					dueDate.setHours(12);
					dueDate.setMinutes(0);
					dueDate.setSeconds(0);
					dueDate.setMilliseconds(0);
					dueDate = dueDate.getTime();
				}
			} catch(e) { } // ignore

			dueDate = dueDate === -1 ? null : dueDate;
			
			if(dueDate && (typeof dueDate) != "number") {
				var	dueDateDate = util.fromISOString(dueDate);
				if(dueDateDate) {
					dueDate =dueDateDate.getTime();						
				} else {
					dueDate = null;
				}
			}
			
			formElements[this.attributeId] = dueDate == null ? "" : {
				type: "date",
				value: dueDate
			};
			
		},
		_handleDateChange: function() {
			if(this._isDestroyed ) {
				return;
			}	 
			this._isChanged=true;
			var e = { 
				target: this.dateWidget,
				__jazzChanged: true };
			this.parentWidget._handleDirtyingEvent(e);
			var functionName = this._modifiers["onValueChanged"];
			if(functionName && this.parentWidget[functionName]) {
				var value = this.dateWidget.attr("value");
				this.parentWidget[functionName](this, value);
			}
			this.createDateLabel(this.dateWidget.attr("displayedValue"));
			this._setAttributeValue(this._getDateValue());
		}
	}
);

})();
