/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.process.ui.internal.view.presentation.controllers.tabButtonUtil");

dojo.require("jazz.ui.Menu");
dojo.require("dijit.MenuItem");
dojo.require("dijit.MenuSeparator");
dojo.require("dijit.PopupMenuItem");

(function(){

var layouts = [
	"builtInOverviewLayout", "builtInHLayout", "builtInCustomAttributesLayout",
	"builtInLinksLayout", "builtInApprovalsLayout", "builtInHistoryLayout"
];

com.ibm.team.workitem.web.process.ui.internal.view.presentation.controllers.tabButtonUtil.openMenu = function(tabController, tabDropdownNode){
	var tabContainer = tabController.tabContainer;
	var menu = tabController._tabDropdownMenu;
	if(!menu){
		var messages = tabController.messages;
		menu = new jazz.ui.Menu();
		dojo.addClass(menu.domNode, "com-ibm-team-workitem-process");
		
		// edit tab menu
		menu.addChild(new dijit.MenuItem({
			label: messages.EditTab,
			iconClass: "iconNode edit-command",
			onClick: dojo.hitch(tabController, "editTab")
		}));

		// remove tab menu
		menu.addChild(new dijit.MenuItem({
			label: messages.RemoveTab,
			iconClass: "iconNode delete-command",
			onClick: dojo.hitch(tabController, "removeTab")
		}));

		menu.addChild(new dijit.MenuSeparator());

		menu.addChild(new dijit.MenuItem({
			label: messages.MoveTabLeft,
			iconClass: "iconNode left-command",
			onClick: dojo.hitch(tabController, "moveTabLeft")
		}));
		menu.addChild(new dijit.MenuItem({
			label: messages.MoveTabRight,
			iconClass: "iconNode right-command",
			onClick: dojo.hitch(tabController, "moveTabRight")
		}));
/*		
		// rename tab menu
		menu.addChild(new dijit.MenuItem({
			label: messages.RenameTab,
			iconClass: "iconNode rename-command",
			onClick: dojo.hitch(tabController, "renameTab")
		}));
		menu.addChild(new dijit.MenuSeparator());

		// layout tab menu
		var popupMenu = new dijit.PopupMenuItem({
			label: messages.LayoutTab,
			iconClass: "iconNode layoutIcon"
		});
		var layoutMenu = new jazz.ui.Menu();
		dojo.addClass(layoutMenu.domNode, "com-ibm-team-workitem-process");
		dojo.forEach(layouts, function(layout){
			layoutMenu.addChild(new dijit.MenuItem({
				label: messages[layout],
				onClick: function(e){
					var tabId = tabController.getSelectedTabId();
					tabController.setTabLayout(tabId, layout);
				}
			}));
		});
		popupMenu.popup = layoutMenu;
		menu.addChild(popupMenu);
		popupMenu.startup();
		layoutMenu.startup();
		menu._layoutMenu = layoutMenu;
*/		
		menu.startup();
		tabController._tabDropdownMenu = menu;
	}
/*	
	// update checkmark for selected tab layout
	var selectedLayout = tabController.model.getTabLayout(tabController.getSelectedTabId());
	var index = dojo.indexOf(layouts, selectedLayout);
	dojo.forEach(menu._layoutMenu.getChildren(), function(menu, idx){
		var iconCls = (idx == index) ? "selectedItem" : "";
		menu.attr("iconClass", iconCls);
	});
*/	
	var closeMenu = function(){
		if(menu){
			dijit.popup.close(menu);
		}
	};
	menu.connect(menu, "_onBlur", closeMenu);
	dijit.popup.open({
		popup: menu,
		parent: tabContainer,
		around: tabDropdownNode,
		orient: {"BL":"TL"},
		onExecute: closeMenu,
		onCancel: closeMenu
	});
	menu.focus();
};

})();