/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.process.ui.internal.view.presentation.dialogs.AddEditorContent");

dojo.require("dojo.i18n");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.team.workitem.web.process.ui.internal.view.common.ButtonDialog");

dojo.requireLocalization("com.ibm.team.workitem.web.process.ui.internal", "PresentationMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare(
	"com.ibm.team.workitem.web.process.ui.internal.view.presentation.dialogs.AddEditorContent",
	[ dijit._Widget, dijit._Templated ],
{
	templatePath: dojo.moduleUrl("com.ibm.team.workitem.web.process", "ui/internal/view/presentation/dialogs/templates/AddEditorContent.html"),
	
	postMixInProperties: function(){
		this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.process.ui.internal", "PresentationMessages");
		this.inherited(arguments);
	},
	
	getValues: function(){
		return {
			id: this.editorIdField.value,
			name: this.editorNameField.value
		};
	}
});

com.ibm.team.workitem.web.process.ui.internal.view.presentation.dialogs.AddEditorContent.openDialog = function(prop){
	//create add tab dialog content
	var contentWidget = new com.ibm.team.workitem.web.process.ui.internal.view.presentation.dialogs.AddEditorContent();

	// show dialog
	var model = prop.model;
	new com.ibm.team.workitem.web.process.ui.internal.view.common.ButtonDialog({
		primaryTitle: contentWidget.messages.AddEditorDialogTitle,
		dialogContent: contentWidget,
		onOpen: function(){
			dijit.focus(contentWidget.editorIdField);
		},
		validate: function(values, callback){
			if(!values.id || values.id.length === 0){
				alert(contentWidget.messages.ErrIDEmpty);
			}else{
				// check duplicate ID
				var editor = model._findEditorData(values.id);
				if(editor){
					alert(contentWidget.messages.ErrDupID);
					return;
				}
				
				callback();
			}
		},
		onOK: function(values){
			model.addEditor({
				id: values.id,
				name: values.name
			});
		}
	});
};