/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.process.ui.internal.view.presentation.layout.DescriptionSectionContent");

dojo.require("com.ibm.team.workitem.web.process.ui.internal.view.presentation.layout.GenericSectionContent");
dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.team.workitem.web.process.ui.internal", "PresentationMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){

var messages;
var LayoutUtil = com.ibm.team.workitem.web.process.ui.internal.view.presentation.layout.LayoutUtil;

dojo.declare(
	"com.ibm.team.workitem.web.process.ui.internal.view.presentation.layout.DescriptionSectionContent",
	com.ibm.team.workitem.web.process.ui.internal.view.presentation.layout.GenericSectionContent,
{
	// corresponds to com.ibm.team.workitem.web.ui.internal.view.editor.WorkItemOverview#_renderDescription

	postMixInProperties: function(){
		messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.process.ui.internal", "PresentationMessages");
		this.inherited(arguments);
	},
	
	addPresentation: function(containerNode, presentation, index, len){
		if(index > 0) {
			dojo.create("hr", {
				className: "subDescriptionRule"
			}, containerNode);
		}

		// add label node
		var label = presentation.label || presentation.displayName;
		if(!LayoutUtil.isHiddenKind(presentation) &&
			presentation.kind != "com.ibm.team.workitem.kind.lineSeparator" &&
			presentation.kind != "com.ibm.team.workitem.kind.staticText" &&
			presentation.kind != "com.ibm.team.workitem.kind.internal.discussion" &&
			!(index === 0 && this.title == label) && // first presentation with the same label as section title is hidden
			len !== 1 && // hide label if there is only one presentation
			LayoutUtil.getProperty(presentation.properties, "labelVisible") != "false" 
			){
			if(!label || label.length === 0){
				label = dojo.string.substitute(messages.labelDescriptionPlus, [ "" + index]);
			}
			var titleNode = dojo.create("div", {
				className: "subDescriptionTitle"
			}, containerNode);
			LayoutUtil.addLabel(titleNode, label, true);
		}
			
		// add value node
		var descriptionNode = dojo.create("div", {
			style: {
				paddingLeft: "5px",
				paddingRight: "10px"
			}
		}, containerNode);
		LayoutUtil.addPresentation(descriptionNode, presentation);
	}
});

})();