/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.process.ui.internal.view.presentation.layout.DraggableContainer");

dojo.require("jazz.ui.dnd.DraggableContainer");
dojo.require("jazz.ui.dnd.DraggableManager");

(function(){

var draggableManager = jazz.ui.dnd.draggableManager();

dojo.declare(
	"com.ibm.team.workitem.web.process.ui.internal.view.presentation.layout.DraggableContainer",
	jazz.ui.dnd.DraggableContainer,
{
		insertPlaceholder: function(before){
			// override jazz.ui.dnd.DraggableContainer
			// so that placeholder spans across whole table
			var widgetCoords = draggableManager.widgetCoords;
			
			this.height = widgetCoords.h - 2;
			if (this.height == 0) {
				this.height = 50;
			}
			this.clearPlaceholder();
			
//			var placeholder = document.createElement("div");
			var tagName = (this.node.tagName.toLowerCase() == "tbody") ? "tr" : "div";
			var placeholder = document.createElement(tagName);
			
			placeholder.id = "jazz-ui-dnd-placeholder";
			
			placeholder.style.height = this.height - (widgetCoords.marginTop + widgetCoords.marginBottom) + "px";
			if (this.horizontal) {
				placeholder.style.width = dojo.byId("avatar").offsetWidth - widgetCoords.marginLeft - widgetCoords.marginRight + "px";
			}
			var dec = 0;
			if (this == draggableManager.fromContainer && this.overWidget.index >= draggableManager.widget.index) {
				dec = 1;
			}
			
			if (this.dropAtEnd) {
				if (!this.node.lastChild || dojo.hasClass(this.node.lastChild,"dndItem")){
					this.node.appendChild(placeholder);
				} else {
					this.node.insertBefore(placeholder,this.node.lastChild);
				}
				placeholder.index = this.widgets.length - dec;
				return;
			}
			if (before) {
				this.node.insertBefore(placeholder,this.overWidget.domNode);
				placeholder.index = this.overWidget.index - dec;
			} else {
				var next = this.overWidget.domNode.nextSibling;
				if (!next) {
					this.node.appendChild(placeholder);
				} else {
					this.node.insertBefore(placeholder,next);
				}
				placeholder.index = this.overWidget.index + 1 - dec;
			}
		},
		
	move: function(fromIndex, toContainer, toIndex){
		// override so that moving is delayed until model is updated
	}
});

})();