/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.process.ui.internal.view.presentation.layout.HeaderContent");

dojo.require("dojo.i18n");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("com.ibm.team.workitem.web.process.ui.internal.view.common.SectionLayout");
dojo.requireLocalization("com.ibm.team.workitem.web.process.ui.internal", "PresentationMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){

dojo.declare(
	"com.ibm.team.workitem.web.process.ui.internal.view.presentation.layout.HeaderContent",
	[ dijit._Widget, dijit._Templated ],
{
	// summary:
	//		Tab content widget that contains sections
	//		TwoColumnLayout widget is used for layouting of sections 
	//		and drag & drop is supported
	templatePath: dojo.moduleUrl("com.ibm.team.workitem.web.process", "ui/internal/view/presentation/layout/templates/HeaderContent.html"),
	
	isHeader: true,
	dndType: "section",

	postMixInProperties: function(){
		this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.process.ui.internal", "PresentationMessages");
		this.inherited(arguments);
	},
	
	postCreate: function(){
		this.inherited(arguments);
		
		// add section
	},
	
	onAddHeaderLinkClicked: function(e){
		dojo.stopEvent(e);
	},
	
	clearSections: function(){
		if(this.sectionLayout){
			this.headerSection.removeChild(this.sectionLayout.domNode);
			this.sectionLayout.destroy();
			this.sectionLayout = null;
		}
		this.headerSection.style.display = "none";
		this.addHeaderLink.style.display = "";
	},
	
	addSection: function(sectionLayout){
		this.headerSection.appendChild(sectionLayout.domNode);
		this.sectionLayout = sectionLayout;
		
		this.headerSection.style.display = "";
		this.addHeaderLink.style.display = "none";
	},
	
	getSections: function(){
		return [ this.sectionLayout ];
	},
	
	destroy: function(preserveDom){
		// destroying DraggableContainer will destroy their child widgets
		this.clearSections();
		this.inherited(arguments);
	}
});

})();