/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.process.ui.internal.view.presentation.layout.QuickInfoSectionContent");

dojo.require("com.ibm.team.workitem.web.process.ui.internal.view.presentation.layout.GenericSectionContent");

(function(){

var LayoutUtil = com.ibm.team.workitem.web.process.ui.internal.view.presentation.layout.LayoutUtil;
var GenericSectionContent = com.ibm.team.workitem.web.process.ui.internal.view.presentation.layout.GenericSectionContent;

dojo.declare(
	"com.ibm.team.workitem.web.process.ui.internal.view.presentation.layout.QuickInfoSectionContent",
	GenericSectionContent,
{
	// see com.ibm.team.workitem.web.ui.internal.view.editor.WorkItemOverview#_renderGenericSection
	addPresentations: function(presentations){
		// only make first presentation visible
		var presentations2 = dojo.clone(presentations);
		var len = presentations2.length;
		if(len > 1){
			for(var i=1; i<len; i++){
				presentations2[i].widget.widgetClass = LayoutUtil.HIDDEN_WIDGET;
				delete presentations2[i].widget.widgetParams;
			}
		}
		return GenericSectionContent.prototype.addPresentations.apply(this, [ presentations2 ]);
	},
	
	addPresentation: function(containerNode, presentation){
		// no label, value only
		LayoutUtil.addPresentation(containerNode, presentation);
	}	
});

})();