/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.process.ui.internal.view.presentation.parts.CategoryAttributePart");

dojo.require("com.ibm.team.workitem.web.process.ui.internal.view.presentation.parts.EnumerationWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.common.ImagePool");
dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.team.workitem.web.process.ui.internal", "PresentationMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){

var messages;
var ImagePool = com.ibm.team.workitem.web.ui.internal.view.common.ImagePool;

dojo.declare(
	"com.ibm.team.workitem.web.process.ui.internal.view.presentation.parts.CategoryAttributePart",
	com.ibm.team.workitem.web.process.ui.internal.view.presentation.parts.EnumerationWidget,
{
	// see com.ibm.team.workitem.web.ui.internal.view.editor.parts.CategoryAttributePart

	postMixInProperties: function(){
		messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.process.ui.internal", "PresentationMessages");
		this.inherited(arguments);
	},

	postCreate: function(){
		this.inherited(arguments);
		
		this._createGuessCategoryLink();
	},
	
	_createGuessCategoryLink: function(){
		
		// Make Category Combo a little smaller to leave room for guess-button
		dojo.addClass(this._select, "category-select-width");
		
		this._enumGuessValue.style.display = "inline";
		
		// Create Control to Guess Category (Link with Image)
		dojo.create("img", {
			src: ImagePool.GUESS_CATEGORY.toString(),
			alt: messages.labelGuessCategory,
			title: messages.labelGuessCategory
		}, this._enumGuessValue);
	}
});

})();