/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.process.ui.internal.view.presentation.parts.ContributorWidget");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.declare(
	"com.ibm.team.workitem.web.process.ui.internal.view.presentation.parts.ContributorWidget",
	[dijit._Widget, dijit._Templated],
{
	// see com.ibm.team.workitem.web.ui.internal.view.layout.ContributorWidget
	templateString: '<div class="ContributorWidget NarrowWidget">' +
						'<span dojoAttachPoint="_statusIconContainer" class="StatusIconContainer">' +
						'<div dojoAttachPoint="_statusIcon"></div></span>' +
						'<span  style="display: none" dojoAttachPoint="_readOnlySelectValue" class="ReadOnlySelectValue"></span>' +						
						'<div class="fieldWrapper"><select style="display: none" dojoAttachPoint="_select" class="Select"></select></div>' +
						'<span style="display: none" dojoAttachPoint="_anchorSPAN"></span>' +
						'<span style="display:none" dojoAttachPoint="_noValueLabelSPAN" class="LayoutValue GreyLabel"></span>' +
						'</div>',
	
	properties: null,
	
	postCreate: function(){
//		this.inherited(arguments); // somehow this causes script error in IE
		
		this._createLabel();
		
		var properties = this.properties;
		var isReadOnly = (properties && properties.readonly == "true");
		this.setReadOnly(isReadOnly);
	},
	
	_createLabel: function(){
		this._readOnlySelectValue.innerHTML = "ADMIN"; // dummy label
	},
	
	setReadOnly: function(isReadOnly) {
		if(isReadOnly){
			this._select.style.display = "none";
			this._readOnlySelectValue.style.display = "inline";
		}else{
			this._select.style.display = "inline";
			this._readOnlySelectValue.style.display = "none";
		}
	}
});