/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.process.ui.internal.view.presentation.parts.TagWidget");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.declare(
	"com.ibm.team.workitem.web.process.ui.internal.view.presentation.parts.TagWidget",
	[dijit._Widget, dijit._Templated],
{
	templatePath: dojo.moduleUrl("com.ibm.team.workitem.web.process", "ui/internal/view/presentation/parts/templates/TagWidget.html"),
	
	postCreate: function() {
		this.inherited(arguments);
		
		// without this, textarea won't be shown
		this.setReadOnly(false);
	},
	
	// same as com.ibm.team.workitem.web.ui.internal.view.layout.TagWidget
	setReadOnly: function(isReadOnly) {
		if (isReadOnly) { // was mouse out
			if (this._isChanged) {
				this.setReadOnly(false);
				return;
			}
			this.tags.style.display = "none";
			this._readOnlyTagValues.style.display = "inline";
		}
		else {
			this.tags.style.display = "inline";
			this._readOnlyTagValues.style.display = "none";
		}
	},

	_handleTagKeydown: function(e){},
	
	_handleTagKeystroke: function(e){},
	
	_handleDirtyingEvent: function(e){},
	
	_handleTagBlur: function(e){}
});