/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.process.ui.internal.view.presentation.parts.TeamAreaWidget");

dojo.require("dijit._Widget");
dojo.require("dojo.string");
dojo.require("dojo.i18n");
dojo.requireLocalization("com.ibm.team.workitem.web.process.ui.internal", "PresentationMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){

var messages;

dojo.declare(
	"com.ibm.team.workitem.web.process.ui.internal.view.presentation.parts.TeamAreaWidget",
	dijit._Widget,
{
	// see com.ibm.team.workitem.web.ui.internal.view.layout.TeamAreaWidget
	// runtime TeamAreaWidget widget uses 2 TeamAreaWidgets, but in design time we use one to support drag & drop
	isSingleRow: true,

	postMixInProperties: function(){
		messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.process.ui.internal", "PresentationMessages");
		this.inherited(arguments);
	},
	
	postCreate: function(){	
		this.inherited(arguments);

		if(this.isSingleRow){
			dojo.create("div", {
				innerHTML: dojo.string.substitute(messages.labelTeamAreaAndProjectArea, [messages.DummyProjArea , messages.DummyTeamArea])
			}, this.domNode);
		}else{
			dojo.create("div", {
				innerHTML: messages.DummyProjArea
			}, this.domNode);
			dojo.create("div", {
				className: "TeamAreaDiv",
				innerHTML: messages.DummyTeamArea
			}, this.domNode);
		}
	}
});

})();