/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.process.ui.internal.view.presentation.parts.TimestampWidget");

dojo.require("dijit._Widget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.common.ImagePool");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil");

(function(){

var ImagePool = com.ibm.team.workitem.web.ui.internal.view.common.ImagePool;
var EditorUtil = com.ibm.team.workitem.web.ui.internal.view.editor.EditorUtil;

dojo.declare(
	"com.ibm.team.workitem.web.process.ui.internal.view.presentation.parts.TimestampWidget",
	dijit._Widget,
{
	// see com.ibm.team.workitem.web.ui.internal.view.layout.TimestampWidget
	
	properties: null,
	
	postCreate: function(){
		this.inherited(arguments);
		
		dojo.addClass(this.domNode, "TimestampWidget");
		
		var properties = this.properties;
		if(properties && properties.readonly == "true"){
			this._createDateLabel();
		}else{
			this._createDateTextBox();
		}
	},
	
	_createDateLabel: function(){
		this.domNode.innerHTML = "";
		var date = new Date(); // use current date as dummy data
		var value = EditorUtil._getDateString(date, false);
		var timeValue = EditorUtil._getDateString(date, true);
		// Defect 66967. Dojo does not return a string for all locales.
		if(!dojo.isString(timeValue)) {
			timeValue = value;
		}
		
		var dateSpan = dojo.create("span", {
			innerHTML: timeValue,
			className: "ReadOnlyTextValue TimestampLabel"
		}, this.domNode);
		// Defect 66967. Dojo does not return a string for all locales.
		if(dojo.isString(timeValue)) {
			dateSpan.title = timeValue;
		}
	},
	
	_createDateTextBox: function(){
		this.domNode.innerHTML = "";
		dojo.create("input", {
			type: "text",
			style: {
				width: "71%"
			}
		}, this.domNode);
		dojo.create("img", {
			src: ImagePool.CALENDAR.toString(),
			style: {
				position: "relative",
				top: "0.5em",
				width: "21px",
				height: "20px"
			}
		}, this.domNode);		
	}
});

})();