/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.queryeditor.ResultColumnsSection");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.queryeditor.EditableTableSection");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.queryeditor.SelectAttributeDialog");

(function() {
	
var EditableTableSection= com.ibm.team.workitem.web.ui.internal.view.queryeditor.EditableTableSection;
var TableEntry= com.ibm.team.workitem.web.ui.internal.view.queryeditor.TableEntry;
var SelectAttributeDialog= com.ibm.team.workitem.web.ui.internal.view.queryeditor.SelectAttributeDialog;

dojo.declare("com.ibm.team.workitem.web.ui.internal.view.queryeditor.ResultColumnsSection", EditableTableSection, {

	onAdd: function(event) {
		dojo.stopEvent(event);
		var self=this;
		this.selectDialog = new SelectAttributeDialog({
			onOk: dojo.hitch(this, function(columns) {
				this._addColumns(columns);
				setTimeout(function() {self._destroySelectDialog(); }, 200);
			}),
			onCancel: function() {
				setTimeout(function() {self._destroySelectDialog(); }, 200);
			},
			filterAttribute: "isColumn",
			attributeTree: this._attributes
			});
	},
	destroy: function() {
	  this._destroySelectDialog();
	  this.inherited(arguments);
	},
	_destroySelectDialog: function() {
		if(this.selectDialog) {
			this.selectDialog.destroy(); 
			this.selectDialog = null;
		}
	},	
	setCachedAttributeTree: function(attributes) {
		this._attributes= attributes;
	},
	
	setInput: function(columns) {
		this.deleteAllEntries();
		if (columns)
			this._addColumns(columns);
		this._setChanged(false);
	},
	
	_addColumns: function(columns) {
		for (var i= 0; i < columns.length; i++) {
			var entry= new TableEntry({ item: columns[i], labelProperty: "label", section: this});
			this.addEntry(entry);
		}
	}
});
	
})();
