/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.queryeditor.TeamAreaSection");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.queryeditor.EditableTableSection");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.queryeditor.SelectTeamAreaDialog");
dojo.require("jazz.app.context"); //$NON-NLS-1$

(function() {
	
var EditableTableSection= com.ibm.team.workitem.web.ui.internal.view.queryeditor.EditableTableSection;
var TableEntry= com.ibm.team.workitem.web.ui.internal.view.queryeditor.TableEntry;
var SelectTeamAreaDialog= com.ibm.team.workitem.web.ui.internal.view.queryeditor.SelectTeamAreaDialog;

dojo.declare("com.ibm.team.workitem.web.ui.internal.view.queryeditor.TeamAreaSection", EditableTableSection, {

	onAdd: function(event) {
		dojo.stopEvent(event);
		var self=this;
		this._destroySelectDialog();
		this.selectDialog = new SelectTeamAreaDialog({ 
			onOk: dojo.hitch(this, function(teamAreas) {
				setTimeout(function() {self._destroySelectDialog(); }, 200);
				this._addTeamAreas(teamAreas); 
			}),
			onCancel: function() {
				setTimeout(function() {self._destroySelectDialog(); }, 200);
			},
			filterProjectArea: jazz.app.context.get().itemId,
			allowProjectArea: true
			});
	},
	_destroySelectDialog: function() {
		if(this.selectDialog) {
			this.selectDialog.destroy(); 
			this.selectDialog = null;
		}
	},		
	setInput: function(teamAreas) {
		this.deleteAllEntries();
		if (teamAreas)
			this._addItems(teamAreas);
		this._setChanged(false);
	},
	
	_addItems: function(teamAreas) {
		for (var i= 0; i < teamAreas.length; i++) {
			this._addItem(teamAreas[i]);
		}
	},
	
	_addTeamAreas: function(teamAreas) {
		for (var i= 0; i < teamAreas.length; i++) {
			var team= teamAreas[i];
			var item= { id: team.itemId[0], label: team.name };
			this._addItem(item);
		}
	},
	
	_addItem: function(item) {
		var entry= new TableEntry({ item: item, labelProperty: "label", section: this });
		this.addEntry(entry);
	}
});
	
})();
