/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.queryeditor.VariableControl");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("jazz.core.loader");

dojo.require("com.ibm.team.workitem.web.ui.internal.page.EventTopics");
dojo.require("com.ibm.team.workitem.web.client.internal.query.Variable");

(function(){

var EventTopics= com.ibm.team.workitem.web.ui.internal.page.EventTopics;
var Variable= com.ibm.team.workitem.web.client.internal.query.Variable;

dojo.declare("com.ibm.team.workitem.web.ui.internal.view.queryeditor.VariableControl", [dijit._Widget, dijit._Templated], {

	templateString: '<div class="checkBox"><input type="checkbox" dojoattachpoint="_checkBox"/><span style="margin-left:3px" dojoattachpoint="_label"></input></span></div>',
	
	constructor: function(args) {
		this.variable= args.variable; // VariableDTO
	},
	
	postCreate: function() {
		this._checkBox.setAttribute("name", this.variable.id);
		this._label.appendChild(document.createTextNode(this.variable.label));
		this.connect(this._checkBox, "onclick", this._handleCheck);
	},
	
	/* boolean */ isChecked: function() {
		return this._checkBox.checked == true;
	},
	
	_handleCheck: function(e) {
		this.setChecked(this.isChecked());
		dojo.publish(EventTopics.QUERY_EDITOR_CHANGED, []);
	},
	
	setChecked: function(/* boolean */ checked) {
		this._checkBox.checked= checked;
		this._checkBox.defaultChecked= checked;
	},
	
	/* Variable */ getVariable: function() {
		var variable= this.variable;
		return new Variable(variable.id, variable.arguments);
	}
	
});
	
})();
