/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.queryeditor.widgets.ApprovalTypeWidget");

dojo.require("com.ibm.team.workitem.web.ui.internal.view.queryeditor.widgets.ListWidget");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemClient");

(function(){
	
var ServiceResponseHandler= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var WorkItemClient= com.ibm.team.workitem.web.client.internal.WorkItemClient;

var ListWidget= com.ibm.team.workitem.web.ui.internal.view.queryeditor.widgets.ListWidget;

dojo.declare("com.ibm.team.workitem.web.ui.internal.view.queryeditor.widgets.ApprovalTypeWidget", ListWidget, {

	///////////////////////////////////////////////////////////////////////////////////
	// API
	
	postCreate: function() {
		
		this._select.size= 6;
		this._select.multiple= "multiple";
		
		var attributeId= this.presentation.attribute.id;
		var srh= new ServiceResponseHandler(this, "_initList", "_handleError");
		WorkItemClient.getApprovalTypes(srh);
	},
	
	///////////////////////////////////////////////////////////////////////////////////
	// Internals
	
	_initList: function(approvalTypes) {
		this._select.length= 0;
		this._addValues(approvalTypes);
		this._selectValues(this.selection);
	}
	
});
	
})();
