/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2010. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.queryeditor.widgets.ProcessAreaWidget");

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");

dojo.require("com.ibm.team.workitem.web.client.util"); 
dojo.require("com.ibm.team.workitem.web.ui.internal.view.queryeditor.widgets.ListWidget");
dojo.require("com.ibm.team.workitem.web.client.internal.ImageClient");
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemClient");
dojo.require("jazz.app.context"); //$NON-NLS-1$

(function(){
	
var ImageClient= com.ibm.team.workitem.web.client.internal.ImageClient;
var ServiceResponseHandler= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var WorkItemClient= com.ibm.team.workitem.web.client.internal.WorkItemClient;
var Util= com.ibm.team.workitem.web.client.util;

var ListWidget= com.ibm.team.workitem.web.ui.internal.view.queryeditor.widgets.ListWidget;

dojo.declare("com.ibm.team.workitem.web.ui.internal.view.queryeditor.widgets.ProcessAreaWidget", ListWidget, {

	///////////////////////////////////////////////////////////////////////////////////
	// API
	
	postCreate: function() {
		
		this._select.size= 10;
		this._select.multiple= "multiple";
		
		var srh= new ServiceResponseHandler(this, "_initProcessAreas", "_handleError");
		WorkItemClient.getProcessAreaHierarchies(srh);
	},
	
	///////////////////////////////////////////////////////////////////////////////////
	// Internals
	
	_initProcessAreas: function(processAreaHierarchy) {
		
		var processAreas= new Array();
		var attributeType= this.presentation.attribute.attributeTypeId;
		var properties= Util.buildMap(this.presentation.properties);
		var restrictToProjectArea= (properties.restrictToProjectArea == "true");
		
		if ("teamArea" == attributeType) {
			
			if (restrictToProjectArea) {
				
				var projectArea= this._findProjectArea(processAreaHierarchy);
				this._collectProcessAreas(projectArea.children, processAreas, "", true, false);
				
			} else {
				
				this._collectProcessAreas(processAreaHierarchy, processAreas, "", true, true);
			}
			
		} else if ("projectArea" == attributeType) {
			
			this._collectProcessAreas(processAreaHierarchy, processAreas, "", false, false);
			
		} else {
			
			this._collectProcessAreas(processAreaHierarchy, processAreas, "", true, false);
			
		}
		
		this._select.length= 0;
		this._addValues(processAreas);
		this._selectValues(this.selection);
	},
	
	_findProjectArea: function(processAreaHierarchy) {
		var itemId= jazz.app.context.get().itemId;
		for (var i= 0; i < processAreaHierarchy.length; i++) {
			if (processAreaHierarchy[i].itemId == itemId)
				return processAreaHierarchy[i];
		}
		return null;
	},
	
	_collectProcessAreas: function(processAreas, collector, indent, includeChildren, disable) {
		if (processAreas) {
			for (var i= 0; i < processAreas.length; i++) {
				var team= processAreas[i];
				
				var item= { id: team.itemId, label: indent + team.name, disabled: disable };
				collector.push(item);
				
				if (includeChildren)
					this._collectProcessAreas(team.children, collector, indent + "   ", true, false);
			}
		}
	}
	
});
	
})();
