/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.richtext.plugins.AtUserLink");

dojo.require("dijit._editor._Plugin");
dojo.require("dojo.i18n");
dojo.require("jazz.core.loader");

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WidgetMessages");

(function(){

var messages;

dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.richtext.plugins.AtUserLink",
	dijit._editor._Plugin,
{
	// Override _Plugin.useDefaultCommand... processing is handled by this plugin, not by dijit.Editor.
	useDefaultCommand: false,

	showButton: true,

	iconClass: "com-ibm-team-workitem-UserLink",
	
	// function with this name will be invoked when selecting dropdown menu of com.ibm.team.workitem.web.ui.internal.view.richtext.plugins.DropDownButton
	actionFuncName: "_openDialog",

	constructor: function(/*Object?*/args, /*DomNode?*/node){
		messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WidgetMessages");
		this.label = messages.insertUserLink;
	},

	getLabel: function(/*String*/key){
		return this.label;
	},

	// override 
	_initButton: function(){
		if(this.showButton){
			this.command = "insertUserLink";
			this.inherited(arguments);
			delete this.command; // kludge so setEditor doesn't make the button invisible
			this.connect(this.button, "onClick", this.actionFuncName);
		}
	},
	
	_openDialog: function(){
		var self = this;
		jazz.core.loader.load_async("com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog", function(){
			self.selectUserDialog = new com.ibm.team.process.web.ui.internal.TeamContributorSelectionDialog({
				dialogTitle: self.getLabel(self.command),
				useOkCancel: true,
				isMultiselect: true,
				onOK: function(selectedContribs){
					if(selectedContribs && selectedContribs.length > 0){
						var html = "";
						dojo.forEach(selectedContribs, function(contrib){
							if(html.length > 0){
								html += " ";
							}
							html += "@"+contrib.userId;
						});
						self.editor.execCommand("inserthtml", html);
					}
					setTimeout(function(){self._destroyDialog(); }, 200);
				},
				onClose: function(args){
					setTimeout(function(){self._destroyDialog(); }, 200);
				}
			});
		});
	},
	
	_destroyDialog: function(){
		if(this.selectUserDialog){
			this.selectUserDialog.destroy(); 
			this.selectUserDialog = null;
		}
	},
	
	destroy: function(){
		this._destroyDialog();
		this.inherited(arguments);
	}
});

})();