/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.richtext.plugins.ExternalLink");

dojo.require("dijit._editor._Plugin");
dojo.require("dojo.i18n");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("jazz.core.loader");

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WidgetMessages");

(function(){

var messages;

dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.richtext.plugins.ExternalLink",
	dijit._editor._Plugin,
{
	// Override _Plugin.useDefaultCommand... processing is handled by this plugin, not by dijit.Editor.
	useDefaultCommand: false,

	showButton: true,

	iconClass: "com-ibm-team-workitem-ExternalLink",
	
	// function with this name will be invoked when selecting dropdown menu of com.ibm.team.workitem.web.ui.internal.view.richtext.plugins.DropDownButton
	actionFuncName: "_openDialog",

	constructor: function(/*Object?*/args, /*DomNode?*/node){
		messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WidgetMessages");
		this.label = messages.insertExternalLink;
	},

	getLabel: function(/*String*/key){
		return this.label;
	},

	// override 
	_initButton: function(){
		if(this.showButton){
			this.command = "insertExternalLink";
			this.inherited(arguments);
			delete this.command; // kludge so setEditor doesn't make the button invisible
			this.connect(this.button, "onClick", this.actionFuncName);
		}
	},
	
	_openDialog: function(){
		var self = this;
		jazz.core.loader.load_async("com.ibm.team.workitem.web.ui.internal.view.common.ButtonDialog", function(){
			var contentWidget = new com.ibm.team.workitem.web.ui.internal.view.richtext.plugins._ExternalLinkContent();
		
			new com.ibm.team.workitem.web.ui.internal.view.common.ButtonDialog({
				primaryTitle: self.getLabel(self.command),
				dialogContent: contentWidget,
				onOK: function(values){
					self.editor.execCommand("inserthtml", '<a href="'+values.url+'" target="_blank">'+values.title+'</a>');
				}
			});
		});
	}
});

dojo.declare(
	"com.ibm.team.workitem.web.ui.internal.view.richtext.plugins._ExternalLinkContent",
	[ dijit._Widget, dijit._Templated ],
{
	templatePath: dojo.moduleUrl("com.ibm.team.workitem.web", "ui/internal/view/richtext/templates/ExternalLink.html"),
	
	postMixInProperties: function(){
		this.messages = messages;
		this.inherited(arguments);
	},
	
	getValues: function(){
		var url = this.urlField.value;
		var title = this.titleField.value || url;
		return {
			url: url,
			title: title
		};
	}
});

})();