/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.process.ui.internal.view.type.SelectPresentationContent");

dojo.require("dijit._Widget");
dojo.require("dojo.i18n");
dojo.require("com.ibm.team.workitem.web.process.ui.internal.view.common.ButtonDialog");
dojo.requireLocalization("com.ibm.team.workitem.web.process.ui.internal", "TypeMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function(){

var messages;

dojo.declare(
	"com.ibm.team.workitem.web.process.ui.internal.view.type.SelectPresentationContent",
	dijit._Widget,
{
	editors: [],
	
	postMixInProperties: function(){
		messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.process.ui.internal", "TypeMessages");
		this.inherited(arguments);
	},
	
	postCreate: function(){
		this.inherited(arguments);
		
		dojo.create("div", {
			innerHTML: messages.SelectPresentationDesc
		}, this.domNode);
		var sel = dojo.create("select", {
			size: "15",
			style: {
				width: "100%",
				marginTop: "10px"
			}
		}, this.domNode);
		this.editorIdList = sel;
		
		// populate editor ID list
		dojo.forEach(this.editors, function(editorId, idx){
			sel.options[idx] = new Option(editorId, editorId);
		});
	},
	
	getValues: function(){
		return this.editorIdList.value;
	}
});

com.ibm.team.workitem.web.process.ui.internal.view.type.SelectPresentationContent.openDialog = function(prop){
	//create edit icon dialog content
	var contentWidget = new com.ibm.team.workitem.web.process.ui.internal.view.type.SelectPresentationContent({
		editors: prop.editors
	});

	// show dialog
	new com.ibm.team.workitem.web.process.ui.internal.view.common.ButtonDialog({
		primaryTitle: messages.SelectPresentationTitle,
		dialogContent: contentWidget,
		validate: function(editorId, callback){
			if(!editorId || editorId.length === 0){
				alert(messages.NoEditorSelected);
				return;
			}
			
			callback();
		},
		onOK: function(editorId){
			var tabId = null;
			var selectedId = prop.selectedId;
			if(prop.elementType == "tab"){
				tabId = selectedId;
			}else if(prop.elementType == "section"){
				var presentationModel = prop.model;
				var tabs = presentationModel.getTabs(editorId);
				var isFound = false;
				for(var i=0, len=tabs.length; i<len; i++){
					var sections = presentationModel.getSections(tabs[i].tabId);
					for(var j=0, len2=sections.length; j<len2; j++){
						if(sections[j].sectionId == selectedId){
							isFound = true;
							break;
						}
					}
					if(isFound){
						tabId = tabs[i].tabId;
						break;
					}
				}
			}
			prop.onOK(editorId, tabId);
		}
	});
};

})();