/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.process.ui.internal.view.workflow.AddWorkflowContent");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dojo.i18n");
dojo.require("com.ibm.team.workitem.web.process.ui.internal.view.common.ButtonDialog");
dojo.requireLocalization("com.ibm.team.workitem.web.process.ui.internal", "WorkflowMessages"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare(
	"com.ibm.team.workitem.web.process.ui.internal.view.workflow.AddWorkflowContent",
	[ dijit._Widget, dijit._Templated ],
{
	templatePath: dojo.moduleUrl("com.ibm.team.workitem.web.process", "ui/internal/view/workflow/templates/AddWorkflowContent.html"),

	postMixInProperties: function(){
		this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.process.ui.internal", "WorkflowMessages");
		this.inherited(arguments);
	},
	
	_handleIdChanged: function(e){
		if(this.nameField.value.length === 0){
			this.nameField.value = this.idField.value;
		}
	},
	
	getValues: function(){
		return {
			id: this.idField.value,
			name: this.nameField.value
		};
	}
});

com.ibm.team.workitem.web.process.ui.internal.view.workflow.AddWorkflowContent.openDialog = function(prop){
	var contentWidget = new com.ibm.team.workitem.web.process.ui.internal.view.workflow.AddWorkflowContent();

	var model = prop.model;
	// show dialog
	new com.ibm.team.workitem.web.process.ui.internal.view.common.ButtonDialog({
		primaryTitle: contentWidget.messages.AddWorkflowDlgTitle,
		dialogContent: contentWidget,
		onOpen: function(){
			dijit.focus(contentWidget.idField);
		},
		validate: function(values, callback){
			if(!values.id || values.id.length === 0){
				alert(contentWidget.messages.ErrIDEmpty);
			}else{
				// check duplicate ID
				var workflow = model.getWorkflowById(values.id);
				if(workflow){
					alert(contentWidget.messages.ErrDupID);
					return;
				}
				
				callback();
			}
		},
		onOK: function(values){
			// add work item type to the model
			var id = values.id;
			var name = values.name;
			if(!name || name.length===0){
				name = id;
			}
			model.addWorkflow(id, name);
		}
	});
};