 /*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui2.internal.action.ActionFactory"); //$NON-NLS-1$
dojo.require("jazz.core.loader"); //$NON-NLS-1$


(function() {
	
com.ibm.team.workitem.web.ui2.internal.action.ActionFactory = {	
	/*
	 * Create a new action. 
	 *   action: (String) class name of the action
	 */
	getAction: function(createArgs /* actionSpec: { action }, workingCopy: workingCopy */) {
		var actionClassNameString = createArgs.actionSpec.action;
		var loadedAction = null;
		try{
			/*
			 * If the class is already loaded, which it should be because they are preloaded in WorkItemProxyClient,
			 * then return a newly constructed instance. Else load synchronously (which should never happen).
			 */
			var clazz = dojo.getObject(actionClassNameString);
			if(clazz != null) {
				try{
					result = new clazz(createArgs);
				} catch(e1) {
					console.debug("[ActionFactory] Work Items error detecting loaded action: " + createArgs.actionSpec.action + " - " + e1.message); //$NON-NLS-1$
					return null;
				}
				return result;
			}
			
			// TODO: Remove this path
			console.debug("[WorkItemEditor] Loaded using deprecated load_sync: " + result.widgetName);  // $NON-NLS-1$
			jazz.core.loader.load_sync(actionClassNameString);
			loadedAction = eval(actionClassNameString);
		} catch(e){
			console.debug("Work Items could not load action: " + createArgs.actionSpec.action + " - " + e.message); //$NON-NLS-1$
			return null;
		}
		
		try{
			var result = new loadedAction(createArgs);
		} catch(e) {
			console.debug("Work Items could not create action: " + createArgs.actionSpec.action + " - " + e.message); //$NON-NLS-1$
			return null;
		}
		
		return result;
	}
};

})();