/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/

//To run in a browser, start the test server and open a full work item editor.
// A toolbar button should appear that works for launching this action
dojo.provide("com.ibm.team.workitem.web.ui2.internal.action.CreateFromTemplateAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.action.AbstractAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.QueryClient");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.workitem.web.ui2.internal.dialog.CreateFromTemplateDialogLauncher"); 
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemAttributes"); 
dojo.require("com.ibm.team.workitem.web.client.util"); 

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");


dojo.declare("com.ibm.team.workitem.web.ui2.internal.action.CreateFromTemplateAction", [com.ibm.team.workitem.web.ui2.internal.action.AbstractAction, com.ibm.team.workitem.web.ui2.internal.dialog.CreateFromTemplateDialogLauncher] 
, { //$NON-NLS-1$	
	run: function(parms) {
		this.controller = parms.controller;
		var serviceObject= {
			_self: this,
			success: function(templates) {
				if(!templates) {
					alert(this._self._getMessage('labelNoTemplates')); // $NON-NLS-1$
				} else {
					this._self._selectAndLaunchTemplate(templates);
				}
			},
			error: function(error) { 
				alert(error.message);
			}
		};
		
		var srh= new com.ibm.team.repository.web.transport.ServiceResponseHandler(serviceObject, "success", "error")
		com.ibm.team.workitem.web.client.internal.QueryClient.getWorkItemTemplates(srh);
	},
	_getMessage: function(messageId) {
		this.messages = this.messages || dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages"); 
		return this.messages[messageId];
	},
	_selectAndLaunchTemplate: function(templates) {
		this.openCreateFromTemplateDialog({
			onOk: dojo.hitch(this, this._dialogOK),
			templates: templates
		});
	},
	_dialogOK: function(policyRequest) {
		this.instantiate(policyRequest);
	},
	_createFromTemplate: function(template) {
			if (!templates[i].attributeVariables) {
				this.instantiate(templates[i]);
				return
			} 
	},
	instantiate: function(parms) {
		var policyRequest = parms.workingCopy;
		var template = policyRequest.getValue({path: "attributes.template"});
		if(!template || !template.id) {
			console.error("No template selected.");
			return;
		}
		
		var op = parms.workingCopy.createOperation({
	        message: this._getMessage("busyCreatingWorkItems"),
	        id: "loadingTemplatePossibleValues"
	  	});
	  	parms.workingCopy.startOperation(op);
//		var templateMap = parms.caller.parentWidget.getPropertyMapFromArray({
//			array: template.attributeVariables, 
//			result: {}, 
//			keySelector: "id"}).result;
		var serviceObject= {
			_self: this,
			success: function(result) {
				parms.workingCopy.finishOperation(op);
				if (com.ibm.team.workitem.web.client.internal.QueryClient.PROCESS_REPORT_OK == result.severity) {
					this._self.controller._setTemplateQuery(result.query);
					this._self.controller.setWindowLocationHref(com.ibm.team.workitem.web.client.util.getShowTemplateQueryUri());
				} else {
					var message = dojo.string.substitute(this._self._getMessage("errorCreatingWorkItemSet"), [template.label, result.message || this._self._getMessage("labelNone")]);
					console.error(message);
					this._self.controller.pageController._showErrorPage(message);
				}
			},
			error: function(error) { 
				parms.workingCopy.finishOperation(op);
				console.error(error.message);
				this._self.controller.pageController._showErrorPage(error.message);
			}
		};
		var WorkItemAttributes = com.ibm.team.workitem.web.client.internal.WorkItemAttributes;
		var values = [];
		var attributeIds = [];
		var category = policyRequest.getValue({path: "attributes.category"});
		
		if(category) {
			attributeIds.push(WorkItemAttributes.CATEGORY);
			values.push(category.id);
		} 
		var target = policyRequest.getValue({path: "attributes.target"});
		if(target) {
			attributeIds.push(WorkItemAttributes.TARGET);
			values.push(target.id);
		} 				
		var args= {
			templateId: template.id,
			attributeIds: attributeIds,
			values: values
		}
		var srh= new com.ibm.team.repository.web.transport.ServiceResponseHandler(serviceObject, "success", "error")
		com.ibm.team.workitem.web.client.internal.QueryClient.instantiateWorkItemTemplate(srh, args);
	}
});

