/******************************************************************************
 Licensed Materials - Property of IBM
 (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved. 
 
 Note to U.S. Government Users Restricted Rights:  Use, 
 duplication or disclosure restricted by GSA ADP Schedule 
 Contract with IBM Corp.
 ******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui2.internal.action.DeleteWorkItemsAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.util"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.module.WindowContext"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.EventTopics"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.action.AbstractAction"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dojo.string"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "QueryMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var ServiceResponseHandler= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var WorkItemClient= com.ibm.team.workitem.web.client.internal.WorkItemClient;
var util= com.ibm.team.workitem.web.client.util;
var QueryMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "QueryMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var WindowContext= com.ibm.team.workitem.web.ui.internal.module.WindowContext;
var EventTopics= com.ibm.team.workitem.web.ui.internal.page.EventTopics;
var AbstractAction= com.ibm.team.workitem.web.ui2.internal.action.AbstractAction;

/**
 * Delete a set of work items, or the current working copy
 */
dojo.declare("com.ibm.team.workitem.web.ui2.internal.action.DeleteWorkItemsAction", AbstractAction, { //$NON-NLS-1$

	constructor: function(params) {
	},

	run: function(params) {
		var messageString;
		var deleteParams= params.actionSpec.parameter;
		var itemIds= [];
		var ids= [];
		if (deleteParams == null) {
			if (params.workingCopy == null) 
				return ;
			itemIds= [];
			itemIds.push(params.workingCopy.getItemId());
			ids= [];
			ids.push(params.workingCopy.getId());
		} else {
			itemIds= deleteParams.itemIds;
			ids= deleteParams.ids;
		}
		if (itemIds.length === 1) {
			messageString= dojo.string.substitute(QueryMessages.confirmDeleteWorkItem, [ "" + ids[0] ]) ; //$NON-NLS-1$
		} else {
			messageString= dojo.string.substitute(QueryMessages.confirmDeleteWorkItems, [ "" + itemIds.length ]) ; //$NON-NLS-1$
		}
		if (window.confirm(messageString)) {
			this._deleteWorkItems(itemIds, ids[0], deleteParams != null);
		}
	},

	isVisible: function(parms) {
		var isAdmin= util.hasAdministratorRole();
		return isAdmin && !parms.workingCopy.isNewWorkItem();
	},

	_deleteWorkItems: function(itemIdsToDelete, id, isFromQuery) {
		var onSuccess= dojo.hitch(this, function(reports) {
			if (reports.length > 0) {
				var reportDTO= reports[0];
				if (reportDTO.severity > 0) {
					window.alert(reportDTO.message);
					return ;
				}
			}
			if (itemIdsToDelete.length === 1) {
				var message= dojo.string.substitute(QueryMessages.msgDeleteOneSuccessful, [ "" + id ]) ; //$NON-NLS-1$
				window.alert(message);
			} else {
				var message= dojo.string.substitute(QueryMessages.msgDeleteManySuccessful, [ "" + itemIdsToDelete.length ]) ; //$NON-NLS-1$
				window.alert(message);
			}
			dojo.publish(EventTopics.WORKITEM_ITEMS_DELETED, [itemIdsToDelete]);
			dojo.publish(EventTopics.WORKITEM_ACTION_COMPONENT_MENU_REFRESH, []);
			if (!isFromQuery) {
				WindowContext.setWindowLocation2(util.getWelcomePageUri());
			}
		});
		var onFailure= dojo.hitch(this, function(result) {
			window.alert(result.message);
		});
		var params= {};
		params.workItemIds= itemIdsToDelete;
		var handler= new ServiceResponseHandler({'onSuccess': onSuccess, 'onFailure': onFailure}, 'onSuccess', 'onFailure'); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		WorkItemClient.postDeleteWorkItems(handler, params);
	}
});

})();
