/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui2.internal.dialog.AddDelegatedArtifactDialog"); //$NON-NLS-1$

dojo.require("com.ibm.team.workitem.web.cache.internal.PolicyRequestProxy"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.parts.RadioGroupPart"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.IconMessageWidget"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.dialog.PolicyDialog"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.widget.DialogListWidget"); //$NON-NLS-1$

(function() {
var PolicyRequestProxy= com.ibm.team.workitem.web.cache.internal.PolicyRequestProxy;
var PolicyDialog= com.ibm.team.workitem.web.ui2.internal.dialog.PolicyDialog;

dojo.declare("com.ibm.team.workitem.web.ui2.internal.dialog.AddDelegatedArtifactDialog", PolicyDialog, { //$NON-NLS-1$

	presentations: null,

	constructor: function(parameters) {
	},

	postCreate: function() {
		if (this.workingCopy == null) {
			this.workingCopy= new PolicyRequestProxy();
		}
		var parms= {};
		parms.path= "attributes.newOrExisting"; //$NON-NLS-1$
		parms.event= "onchange"; //$NON-NLS-1$
		parms.functionName= "_handleNewOrExistingChange"; //$NON-NLS-1$
		parms.listener= this;
		this.workingCopy.addListener(parms);
		var parms2= {};
		parms2.path= "attributes.serviceProvider"; //$NON-NLS-1$
		parms2.event= "onchange"; //$NON-NLS-1$
		parms2.functionName= "_handleServiceProviderChange"; //$NON-NLS-1$
		parms2.listener= this;
		this.workingCopy.addListener(parms2);
		this.dialogTitle= this.messages.dialogTitleSelectServiceProvider;
		this.secondaryTitle= this.messages.dialogTitleSelectServiceProvider2;
		this.initPresentations();
		this.inherited("postCreate", arguments, []); //$NON-NLS-1$
		var initialValue= {};
		initialValue.attributeId= "newOrExisting"; //$NON-NLS-1$
		initialValue.value= "New"; //$NON-NLS-1$
		initialValue.path= ["attributes", "newOrExisting", "id"]; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		this.workingCopy.setValue(initialValue);
	},

	initPresentations: function() {
		this.presentations= [];
		var newOrExistingRadioButtonGroup= {};
		newOrExistingRadioButtonGroup.widgetCssClass= "DialogRadioGroup"; //$NON-NLS-1$
		newOrExistingRadioButtonGroup.attributeId= "newOrExisting"; //$NON-NLS-1$
		newOrExistingRadioButtonGroup.isWide= true;
		newOrExistingRadioButtonGroup.id= "newOrExistingRadioButtonWidget"; //$NON-NLS-1$
		newOrExistingRadioButtonGroup.widget= "com.ibm.team.workitem.web.ui.internal.view.editor.parts.RadioGroupPart"; //$NON-NLS-1$
		newOrExistingRadioButtonGroup.possibleValues= [];
		var newItem= {};
		newItem.id= "New"; //$NON-NLS-1$
		newItem.label= this.messages.labelSelectNew;
		newOrExistingRadioButtonGroup.possibleValues.push(newItem);
		var selectItem= {};
		selectItem.id= "Select"; //$NON-NLS-1$
		selectItem.label= this.messages.labelSelectExisting;
		newOrExistingRadioButtonGroup.possibleValues.push(selectItem);
		this.presentations.push(newOrExistingRadioButtonGroup);
		var serviceProviderSelectorList= {};
		serviceProviderSelectorList.label= this.messages.labelServiceProviders;
		serviceProviderSelectorList.attributeId= "serviceProvider"; //$NON-NLS-1$
		serviceProviderSelectorList.isWide= true;
		serviceProviderSelectorList.size= 10;
		serviceProviderSelectorList.id= "serviceProviderListWidget"; //$NON-NLS-1$
		serviceProviderSelectorList.widget= "com.ibm.team.workitem.web.ui2.internal.widget.DialogListWidget"; //$NON-NLS-1$
		serviceProviderSelectorList.isErrorList= false;
		this.presentations.push(serviceProviderSelectorList);
		var actionMessage= {};
		actionMessage.message= this.messages.labelSelectServiceProviderAndPressOK;
		actionMessage.severity= 3;
		actionMessage.iconSize= -1;
		actionMessage.label= ""; //$NON-NLS-1$
		actionMessage.isWide= true;
		actionMessage.id= "messageArea"; //$NON-NLS-1$
		actionMessage.widget= "com.ibm.team.workitem.web.ui.internal.view.layout.IconMessageWidget"; //$NON-NLS-1$
		this.presentations.push(actionMessage);
	},

	_handleNewOrExistingChange: function(parms) {
		var message;
		if (parms.value === "Select") { //$NON-NLS-1$
			message= this.messages.labelLoadingSelectItemServiceProviders;
		} else {
			message= this.messages.labelLoadingNewItemServiceProviders;
		}
		var items= [];
		var loadingItem= {};
		loadingItem.id= "loading-message"; //$NON-NLS-1$
		loadingItem.message= message;
		items.push(loadingItem);
		var list= this.getChildWidget("serviceProviderListWidget"); //$NON-NLS-1$
		list.setPossibleValues(items);
	},

	isOkButtonDisabled: function() {
		return true;
	},

	_handleServiceProviderChange: function(parms) {
		this.okButton.disabled= ""; //$NON-NLS-1$
		console.debug("Service provider selected"); //$NON-NLS-1$
	},

	destroy: function(preserveDom) {
		this.inherited("destroy", arguments, [preserveDom]); //$NON-NLS-1$
	}
});

})();
