/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui2.internal.dialog.AlertDialogLauncher"); 
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.IconMessageWidget");
dojo.require("com.ibm.team.workitem.web.ui2.internal.dialog.PolicyDialog");
dojo.require("com.ibm.team.workitem.web.cache.internal.PolicyRequestProxy"); 
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");


/*
 * Example:	this.openAlertDialog({ message: self.messages.alertWithError } );
 */

(function() {


dojo.declare("com.ibm.team.workitem.web.ui2.internal.dialog.AlertDialogLauncher", null, {
	openAlertDialog: function(parms) {
 	 if(!this.alertDialogLauncherMessages) 
    	this.alertDialogLauncherMessages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
  
    var self = this;
	var presentations = [
		{
			widget: "com.ibm.team.workitem.web.ui.internal.view.layout.IconMessageWidget",
			message: parms.message,
			severity: parms.severity || 0, // info
			iconSize: 1 // small	
		}
	];
	
	var policyRequest = {
		attributes: parms
	}
	var policyRequestProxy =  new com.ibm.team.workitem.web.cache.internal.PolicyRequestProxy({ object: policyRequest}); 
	
	var dialogArgs = {
		dialogTitle: this.alertDialogLauncherMessages.dialogTitleAlert,
		secondaryTitle: "",
		height: "8em",
		noCancelButton: true,
		workingCopy: policyRequestProxy,
		onOk: function(args) {
				parms.onOk(args);
			},
		onCancel: function(args) {
			parms.onCancel(args);
		},
		presentations: presentations
	}
	new com.ibm.team.workitem.web.ui2.internal.dialog.PolicyDialog(dialogArgs);
}
}
);

})();
