/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui2.internal.dialog.CreateWorkItemDialog"); //$NON-NLS-1$

dojo.require("com.ibm.team.workitem.web.cache.internal.Cache"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.cache.internal.PolicyRequestProxy"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.dialog.PolicyDialog"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.widget.DialogListWidget"); //$NON-NLS-1$

(function() {
var Cache= com.ibm.team.workitem.web.cache.internal.Cache;
var PolicyRequestProxy= com.ibm.team.workitem.web.cache.internal.PolicyRequestProxy;
var PolicyDialog= com.ibm.team.workitem.web.ui2.internal.dialog.PolicyDialog;

dojo.declare("com.ibm.team.workitem.web.ui2.internal.dialog.CreateWorkItemDialog", PolicyDialog, { //$NON-NLS-1$

	presentations: null,

	constructor: function(parameters) {
	},

	postCreate: function() {
		if (this.workingCopy == null) {
			this.workingCopy= new PolicyRequestProxy();
		}
		var parms= {};
		parms.path= "attributes.workItemType"; //$NON-NLS-1$
		parms.event= "onchange"; //$NON-NLS-1$
		parms.functionName= "_handleWorkItemTypeChange"; //$NON-NLS-1$
		parms.listener= this;
		this.workingCopy.addListener(parms);
		var types= Cache.getItem("workitems/itemTypes"); //$NON-NLS-1$
		if (types == null || types.length === 0) {
			window.alert(this.messages.errorNoWorkItemTypes);
			return ;
		}
		this.height= "270px"; //$NON-NLS-1$
		this.dialogTitle= this.messages.dialogTitleCreateWorkItem;
		this.secondaryTitle= this.messages.dialogTitleSelectWorkItemType;
		this.initPresentations(types);
		this.inherited("postCreate", arguments, []); //$NON-NLS-1$
	},

	initPresentations: function(types) {
		var items= [];
		for (var i= 0; i < types.length; i++){
			var item= {};
			item.message= types[i].label;
			item.id= types[i].id;
			items.push(item);
		}
		var doubleClickHandler= dojo.hitch(this, function(event) {
			this._handleOkClick(event);
			return event;
		});
		this.presentations= [];
		var workItemTypeList= {};
		workItemTypeList.onDoubleClick= doubleClickHandler;
		workItemTypeList.label= this.messages.labelWorkItemTypes;
		workItemTypeList.attributeId= "workItemType"; //$NON-NLS-1$
		workItemTypeList.isWide= true;
		workItemTypeList.size= 12;
		workItemTypeList.width= "97%"; //$NON-NLS-1$
		workItemTypeList.id= "workItemTypeListWidget"; //$NON-NLS-1$
		workItemTypeList.widget= "com.ibm.team.workitem.web.ui2.internal.widget.DialogListWidget"; //$NON-NLS-1$
		workItemTypeList.isErrorList= false;
		workItemTypeList.possibleValues= items;
		this.presentations.push(workItemTypeList);
	},

	_handleWorkItemTypeChange: function(parms) {
		this.okButton.disabled= ""; //$NON-NLS-1$
	},

	isOkButtonDisabled: function() {
		return true;
	},

	destroy: function(preserveDom) {
		this.inherited("destroy", arguments, [preserveDom]); //$NON-NLS-1$
	}
});

})();
