/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui2.internal.dialog.PolicyDialog");

dojo.require("jazz.ui.Dialog");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.LayoutUtil");
dojo.require("com.ibm.team.workitem.web.ui2.internal.widget.AbstractEditor");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.NameValueLayout");

dojo.require("net.jazz.ajax.toolbox.lang.internal.Lang");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");

(function() {

var checkNotNull=	net.jazz.ajax.toolbox.lang.checkNotNull;
var LayoutUtil= com.ibm.team.workitem.web.ui.internal.view.layout.LayoutUtil;

dojo.declare(
	"com.ibm.team.workitem.web.ui2.internal.dialog.PolicyDialog",
	[com.ibm.team.workitem.web.ui2.internal.widget.AbstractEditor ], 
	{
	OKBUTTON: "okbutton",
	CANCELBUTTON: "cancelbutton",
	templateString: '<div class="com-ibm-team-workitem-view-layout-dialoglayout">'
		+ '<div dojoAttachpoint="_contentDiv" class="com-ibm-team-workitem com-ibm-team-workitem-dialoglayout-content">'
		+ '</div>'
		+ '<div dojoAttachpoint="_buttonDiv" class="com-ibm-team-workitem com-ibm-team-workitem-dialoglayout-buttons">'
		+ '</div></div>',
	constructor: function() {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
		},
	
	postCreate: function() {
		this.policyRequest = this.policyRequest || {};
		
		this.initDialogContent();
		this.inherited(arguments);
	},
	initDialogContent: function() {
		this.childWidgetMap = {};
		for(var i=0;i<this.presentations.length;i++) { 
			var valueNode = document.createElement("DIV");
			var args = {
				workingCopy: this.workingCopy, 
				presentation: this.presentations[i], 
				valueNode: valueNode, 
				attributeId: this.presentations[i].attributeId,
				value: this.presentations[i].value,
				possibleValues: this.presentations[i].possibleValues || [],
				caller: { parentWidget: this } // for init consistency with events
			}
			if(this.presentations[i].creationArgs) {
				args = dojo.mixin(args, this.presentations[i].creationArgs)
			}
			
			var widget = this.getPolicyWidget(args);
			var widgetId = this.presentations[i].id;
			dojo.addClass(widget.domNode, "com-ibm-team-workitem-policydialog-widget");
			if(widget) {
				args.widget = widget;
				if(this.presentations[i].label != null) {
					var nameValueLayout = new com.ibm.team.workitem.web.ui.internal.view.layout.NameValueLayout();
					args.layout = nameValueLayout;
					nameValueLayout.addRow({labelText: this.presentations[i].label, 
							valueNode: widget.domNode,
							isWide: this.presentations[i].isWide || false});
					dojo.addClass(nameValueLayout.domNode, "com-ibm-team-workitem-policydialog-layout");
					args.layoutWidget = nameValueLayout;
					this._contentDiv.appendChild(nameValueLayout.domNode);
				} else {
					 this._contentDiv.appendChild(widget.domNode);
				}
				args.presentation = this.presentations[i];
				this.childWidgetMap[widgetId] = args;
			}			
		}
/*
 * Initialize after all widgets have been added
 */
		for(var key in this.childWidgetMap) {
			var args = this.childWidgetMap[key];
			if(args.presentation.initialize) args.presentation.initialize(args);
		}

		var okButton = document.createElement("button");
		if(this.isOkButtonDisabled()) {
			dojo.attr(okButton, "disabled", "DISABLED");			
		}
		this.okButton = okButton;
		this.childWidgetMap[this.OKBUTTON] = {widget: okButton};
		okButton.className = "com-ibm-team-workitem-policydialog-button";
		var okButtonLabel = this.okLabel || this.messages.buttonOK;
		okButton.appendChild(document.createTextNode(okButtonLabel));
		var cancelButton = document.createElement("button");
		this.childWidgetMap[this.CANCELBUTTON] = {widget: okButton};
		cancelButton.className = "com-ibm-team-workitem-policydialog-button";
		cancelButton.appendChild(document.createTextNode(this.messages.buttonCancel));
		var buttonDiv = this._buttonDiv;
		dojo.addClass(buttonDiv, "com-ibm-team-workitem-buttonsection");
		buttonDiv.appendChild(okButton);
		buttonDiv.appendChild(cancelButton);
		if(this.noCancelButton) {
			cancelButton.style.display = "none";
		}
		this._contentDiv.appendChild(buttonDiv);
		this.connect(okButton, "onclick", this._handleOkClick);
		this.connect(cancelButton, "onclick", this._handleCancelClick);
		if(this.okButtonHandler) this.okButtonHandler.enableOkButton({okButton: okButton, workingCopy: this.workingCopy, parentWidget: this});
		
		var floatingPaneParams = {
			dialog: this,
            primaryTitle: this.dialogTitle,
            onFocus: function(e) {}, // fix odd problem in jazz.ui.Dialog
            secondaryTitle: this.secondaryTitle,
			width: this.width || '575px',
			height: this.height || '320px',
			onClose: dojo.hitch(this, this._handleCancelClick),
			contentNode: this._contentDiv,
			showBackground: false
		};		
	
		this.floatingPane = new jazz.ui.Dialog(floatingPaneParams);
	},
	getChildWidget: function(id) {
		return this.childWidgetMap[id].widget;
	},
	getChildWidgetLayout: function(id) {
		return this.childWidgetMap[id].layout;
	},
	isOkButtonDisabled: function() {
		return false;
	},
	_handleOkClick: function(e) {
		this.isOK = true;
		this.floatingPane.close();
		if(this.onOk) {
			this.onOk({workingCopy: this.workingCopy, caller: this });
		}
		this.isOK = false;
	},
	_handleCancelClick: function() {
		if(this.isCancelled || this. isOK) return;
		this.isCancelled = true;
		this.floatingPane.close();
		if(this.onCancel) {
			this.onCancel({workingCopy: this.workingCopy, caller: this});
		}
		this.isCancelled = false;
	}
});
})();
	