/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui2.internal.dialog.SelectTargetDialog"); //$NON-NLS-1$

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.cache.internal.PolicyRequestProxy"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.dtos.DTOUtil"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.IconMessageWidget"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.dialog.PolicyDialog"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.widget.DialogListWidget"); //$NON-NLS-1$

(function() {
var ServiceResponseHandler= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var PolicyRequestProxy= com.ibm.team.workitem.web.cache.internal.PolicyRequestProxy;
var DTOUtil= com.ibm.team.workitem.web.client.dtos.DTOUtil;
var WorkItemClient= com.ibm.team.workitem.web.client.internal.WorkItemClient;
var PolicyDialog= com.ibm.team.workitem.web.ui2.internal.dialog.PolicyDialog;

var SelectTargetDialog= dojo.declare("com.ibm.team.workitem.web.ui2.internal.dialog.SelectTargetDialog", PolicyDialog, { //$NON-NLS-1$

	attributeId: null,

	presentations: null,

	constructor: function(parameters) {
		this.isChanged= false;
	},

	isChanged: null,

	postCreate: function() {
		if (this.workingCopy == null) {
			this.workingCopy= new PolicyRequestProxy();
		}
		var parms= {};
		parms.path= ["attributes", this.attributeId]; //$NON-NLS-1$
		parms.event= "onchange"; //$NON-NLS-1$
		parms.functionName= "_handleTargetChange"; //$NON-NLS-1$
		parms.listener= this;
		this.workingCopy.addListener(parms);
		this.dialogTitle= this.messages.dialogTitleSelectPlannedFor;
		this.secondaryTitle= this.messages.dialogTitleSelectPlannedFor2;
		this.initPresentations();
		this.inherited("postCreate", arguments, []); //$NON-NLS-1$
		var listWidget= this.getChildWidget("targetListWidget"); //$NON-NLS-1$
		this.loadIterations(listWidget);
	},

	onDoubleClick: function() {
		this._handleOkClick(null);
	},

	initPresentations: function() {
		this.presentations= [];
		var allValues= this.workingCopy.getEditPropsAllValues();
		var dtoMap= DTOUtil.getAllValuesMap(allValues);
		var targetDTO= dtoMap[this.attributeId];
		var iterationDTOs= targetDTO.uiItems;
		var getArgs= {};
		getArgs.path= ["attributes", this.attributeId]; //$NON-NLS-1$
		var currentValue= this.workingCopy.getValue(getArgs);
		var doubleClickHandler= dojo.hitch(this, function(object) {
			this.onDoubleClick();
			return null;
		});
		var loadingHandler= dojo.hitch(this, function(widget) {
			this.loadIterations(widget);
			return widget;
		});
		var targetSelectList= {};
		targetSelectList.label= this.messages.attributePlannedFor;
		targetSelectList.messageSelector= "label"; //$NON-NLS-1$
		targetSelectList.detailsSelector= "label"; //$NON-NLS-1$
		targetSelectList.possibleValues= iterationDTOs;
		targetSelectList.currentValue= currentValue;
		targetSelectList.isCurrentValueDisabled= true;
		targetSelectList.onDoubleClick= doubleClickHandler;
		targetSelectList.onLoading= loadingHandler;
		targetSelectList.attributeId= this.attributeId;
		targetSelectList.isWide= true;
		targetSelectList.size= 15;
		targetSelectList.id= "targetListWidget"; //$NON-NLS-1$
		targetSelectList.widget= "com.ibm.team.workitem.web.ui2.internal.widget.DialogListWidget"; //$NON-NLS-1$
		targetSelectList.isErrorList= false;
		this.presentations.push(targetSelectList);
	},

	loadIterations: function(widget) {
		var getIterationsSuccess= dojo.hitch(this, function(iterationDtos) {
			var unassigned= null;
			var result= [];
			for (var i= 0; i < iterationDtos.length; i++){
				var value= iterationDtos[i];
				if (value.current) {
					if (value.label.indexOf(SelectTargetDialog.CARAT) !== 0) {
						value.label= SelectTargetDialog.CARAT + " " + value.label; //$NON-NLS-1$
					}
				}
				if (value.id === "") { //$NON-NLS-1$
					unassigned= value;
				} else {
					result.splice(0, 0, value);
				}
			}
			if (unassigned != null) {
				result.splice(0, 0, unassigned);
			}
			widget.setPossibleValues(result);
		});
		var getIterationsFailure= dojo.hitch(this, function(result) {
			window.alert(result.message);
		});
		var getArgs= {};
		getArgs.path= ["attributes", "projectArea", "id"]; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		var projectAreaItemId= this.workingCopy.getValue(getArgs);
		var params= {};
		params.projectAreaItemId= projectAreaItemId;
		WorkItemClient.getIterations(new ServiceResponseHandler({'onSuccess': getIterationsSuccess, 'onFailure': getIterationsFailure}, 'onSuccess', 'onFailure'), params); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
	},

	isOkButtonDisabled: function() {
		if (this.isChanged) 
			return false;
		return true;
	},

	_handleTargetChange: function(parms) {
		this.okButton.disabled= ""; //$NON-NLS-1$
		this.isChanged= true;
	},

	destroy: function(preserveDom) {
		this.inherited("destroy", arguments, [preserveDom]); //$NON-NLS-1$
	}
});

SelectTargetDialog.CARAT= "\u25b8"; //$NON-NLS-1$

})();
