/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui2.internal.grid.view.query.DeleteQueryAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.actions.AbstractIdAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.QueryClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.module.WindowContext"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.EventTopics"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.view.common.ImagePool"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "QueryMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var ServiceResponseHandler= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var ItemStyle= com.ibm.team.rtc.foundation.api.ui.actions.ItemStyle;
var AbstractIdAction= com.ibm.team.rtc.foundation.web.ui.actions.AbstractIdAction;
var QueryClient= com.ibm.team.workitem.web.client.internal.QueryClient;
var QueryMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "QueryMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var WindowContext= com.ibm.team.workitem.web.ui.internal.module.WindowContext;
var EventTopics= com.ibm.team.workitem.web.ui.internal.page.EventTopics;
var ImagePool= com.ibm.team.workitem.web.ui.internal.view.common.ImagePool;

dojo.declare("com.ibm.team.workitem.web.ui2.internal.grid.view.query.DeleteQueryAction", AbstractIdAction, { //$NON-NLS-1$

	fQuery: null,

	constructor: function(item) {
		this.inherited(arguments, ["com.ibm.team.workitem.action.deleteQuery", ItemStyle.FLAT]); //$NON-NLS-1$
		this.setName(QueryMessages.buttonDelete);
		this.setIconUrl(ImagePool.DELETE);
		this.setCanHandle(true);
		this.fQuery= item;
	},

	handle: function() {
		if (window.confirm(QueryMessages.confirmDeleteQuery)) {
			var itemId= this.fQuery.getIdentifier();
			var onSuccess= dojo.hitch(this, function(valueSet) {
				dojo.publish(EventTopics.BUILDER_POST_SAVE, []);
				dojo.publish(EventTopics.QUERY_DELETED, [itemId]);
			});
			var onFailure= dojo.hitch(this, function(result) {
				var parms= {};
				parms.summaryMessage= QueryMessages.errorDeletingQuery;
				parms.detailsMessage= result.message;
				WindowContext.handleError(parms);
			});
			var handler= new ServiceResponseHandler({'onSuccess': onSuccess, 'onFailure': onFailure}, 'onSuccess', 'onFailure'); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
			QueryClient.deleteQuery(itemId, handler);
		}
	}
});

})();
