/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui2.internal.grid.view.query.QueryFilter"); //$NON-NLS-1$

dojo.require("com.ibm.team.workitem.web.ui2.internal.grid.view.query.model.Query"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.grid.view.query.model.ScopeFolder"); //$NON-NLS-1$
dojo.require("dojo.regexp"); //$NON-NLS-1$

(function() {
var Query= com.ibm.team.workitem.web.ui2.internal.grid.view.query.model.Query;
var ScopeFolder= com.ibm.team.workitem.web.ui2.internal.grid.view.query.model.ScopeFolder;
var regexp= dojo.regexp;

dojo.declare("com.ibm.team.workitem.web.ui2.internal.grid.view.query.QueryFilter", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fMatcher: null,

	setFilterCriteria: function(filterCriteria) {
		this.fMatcher= WordMatcher.create(filterCriteria);
	},

	isFilterProperty: function(entry, property) {
		return true;
	},

	select: function(entry, readAccessor) {
		if (this.fMatcher == null) 
			return true;
		var element= entry.getElement();
		if (element instanceof Query) {
			if (this.fMatcher.matches(element.getLabel()) || this.fMatcher.matches(element.getDescription())) 
				return true;
			var scopeFolder= readAccessor.getEntryNavigator(true).parentEntryOfType(entry, ScopeFolder);
			if (scopeFolder != null) {
				if (this.fMatcher.matches(scopeFolder.getElement().getLabel())) {
					return true;
				}
			}
			return false;
		}
		return !(element instanceof ScopeFolder);
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.model.IViewEntryFilter': true //$NON-NLS-1$
	}
});
var WordMatcher= dojo.declare("com.ibm.team.workitem.web.ui2.internal.grid.view.query.QueryFilter.WordMatcher", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fInput: null,

	fCamelCaseMatcher: null,

	constructor: function(input) {
		if (input != null && input.length > 0) {
			var camelCaseRegExp= "^"; //$NON-NLS-1$
			for (var i= 0; i < input.length; i++){
				var start= i;
				while(++i < input.length && String(input.charAt(i)) === String(input.charAt(i)).toLowerCase()){
				}
				camelCaseRegExp+= regexp.escapeString(input.substring(start, i--));
				camelCaseRegExp+= "[^A-Z]*"; //$NON-NLS-1$
			}
			camelCaseRegExp+= ".*$"; //$NON-NLS-1$
			this.fCamelCaseMatcher= new RegExp(camelCaseRegExp);
			this.fInput= input.toLowerCase();
		}
	},

	matches: function(candidate) {
		if (this.fInput == null) 
			return true;
		if (candidate.toLowerCase().indexOf(this.fInput) !== -1) 
			return true;
		return this.fCamelCaseMatcher.test(candidate);
	}
});

WordMatcher.create= function(input) {
	if (input == null || dojo.trim(input).length === 0) 
		return null;
	return new WordMatcher(input);
};

})();
