/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui2.internal.grid.view.query.QueryGridGadgetFactory"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.ColumnHeaderGadget"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.GridRow"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.LabelCell"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.ToolbarCell"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.TreeLabelCell"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.styles.JazzTableStyle"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.model.EntryUtils"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.util"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.grid.view.query.DeleteQueryAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.grid.view.query.EditQueryAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.grid.view.query.QueryColumns"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.grid.view.query.model.Query"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.grid.view.query.model.ScopeFolder"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dojo.string"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "QueryMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
var Assert= com.ibm.jdojo.util.Assert;
var ColumnHeaderGadget= com.ibm.team.rtc.foundation.web.ui.gridviewer.ColumnHeaderGadget;
var GridRow= com.ibm.team.rtc.foundation.web.ui.gridviewer.GridRow;
var LabelCell= com.ibm.team.rtc.foundation.web.ui.gridviewer.LabelCell;
var ToolbarCell= com.ibm.team.rtc.foundation.web.ui.gridviewer.ToolbarCell;
var TreeLabelCell= com.ibm.team.rtc.foundation.web.ui.gridviewer.TreeLabelCell;
var JazzTableStyle= com.ibm.team.rtc.foundation.web.ui.gridviewer.styles.JazzTableStyle;
var EntryUtils= com.ibm.team.rtc.foundation.web.ui.model.EntryUtils;
var util= com.ibm.team.workitem.web.client.util;
var QueryMessages= dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "QueryMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var DeleteQueryAction= com.ibm.team.workitem.web.ui2.internal.grid.view.query.DeleteQueryAction;
var EditQueryAction= com.ibm.team.workitem.web.ui2.internal.grid.view.query.EditQueryAction;
var QueryColumns= com.ibm.team.workitem.web.ui2.internal.grid.view.query.QueryColumns;
var Query= com.ibm.team.workitem.web.ui2.internal.grid.view.query.model.Query;
var ScopeFolder= com.ibm.team.workitem.web.ui2.internal.grid.view.query.model.ScopeFolder;
var string= dojo.string;

/**
 * @since 3.0
 */
dojo.declare("com.ibm.team.workitem.web.ui2.internal.grid.view.query.QueryGridGadgetFactory", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fGridViewer: null,

	constructor: function() {
	},

	newCellGadget: function(column, rowEntry) {
		var element= rowEntry.getElement();
		if (element instanceof ScopeFolder) {
			if (!(column.getPropertyDescriptor() === QueryColumns.NAME)) Assert.fail("column.getPropertyDescriptor() === QueryColumns.NAME", "com.ibm.team.workitem.web.ui2.internal.grid.view.query.QueryGridGadgetFactory:57");
			return new FolderNameCell(element.getLabel(), null, column, rowEntry, this.fGridViewer);
		} else {
			switch(column.getPropertyDescriptor()) {
				case QueryColumns.NAME:
					var nameCell= new TreeLabelCell(element.getLabel(), element.getIconUrl(), column, rowEntry, this.fGridViewer);
					nameCell.setLink(util.getRefreshSavedQueryUri(rowEntry.getElement().getIdentifier()));
					nameCell.setParentLevelType(Query);
					return nameCell;
				case QueryColumns.DESCRIPTION:
					return new LabelCell(element.getDescription(), null, column, rowEntry, this.fGridViewer);
				case QueryColumns.ACTION:
					var toolbarCell= new ToolbarCell(column, rowEntry, this.fGridViewer);
					toolbarCell.addAction(new EditQueryAction(element));
					toolbarCell.addAction(new DeleteQueryAction(element));
					return toolbarCell;
			}
		}
		return null;
	},

	setGridViewer: function(gridViewer) {
		this.fGridViewer= gridViewer;
	},

	newHeaderGadget: function(column) {
		return new ColumnHeaderGadget(column, this.fGridViewer);
	},

	newEntryGadget: function(rowEntry, entryColumn, readAccessor) {
		var result= new GridRow(rowEntry, entryColumn, readAccessor, this, this.fGridViewer);
		var displayClass= JazzTableStyle.ITEM_ENTRY_CLASS;
		if (rowEntry.getElement() instanceof ScopeFolder) {
			displayClass= JazzTableStyle.SECONDARY_ENTRY_CLASS;
		}
		result.setDisplayClasses([displayClass]);
		return result;
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.IGridCellFactory': true, //$NON-NLS-1$
		'com.ibm.team.rtc.foundation.web.ui.gridviewer.IGridGadgetFactory': true //$NON-NLS-1$
	}
});
var FolderNameCell= dojo.declare("com.ibm.team.workitem.web.ui2.internal.grid.view.query.QueryGridGadgetFactory.FolderNameCell", TreeLabelCell, { //$NON-NLS-1$

	constructor: function(label, iconUrl, column, entry, viewer) {
		this.inherited(arguments, [label, iconUrl, column, entry, viewer]);
		this.addDisplayClasses(["folder"]); //$NON-NLS-1$
	},

	doCreateCellContent: function(cellContainer) {
		var fillContainer= dojo.create("div", {className: "fill"}, cellContainer); //$NON-NLS-1$ //$NON-NLS-2$
		this.inherited("doCreateCellContent", arguments, [fillContainer]); //$NON-NLS-1$
		var queryCount= 0;
		var filteredCount= 0;
		this.fRowEntry.getModel().readModel(dojo.hitch(this, function(readAccessor) {
			readAccessor.accept(dojo.hitch(this, function(entry) {
				if (EntryUtils.isType(entry, Query)) {
					queryCount+= 1;
					if (!entry.isVisible()) {
						filteredCount+= 1;
					}
				}
				return true;
			}), this.fRowEntry);
			return null;
		}));
		var queryCountPattern= filteredCount === 0 ? QueryMessages.QueryGridGadgetFactory_COUNT : QueryMessages.QueryGridGadgetFactory_COUNT_FILTERED;
		var countContainer= dojo.create("span", {className: "counts"}, fillContainer); //$NON-NLS-1$ //$NON-NLS-2$
		countContainer.appendChild(dojo.doc.createTextNode(string.substitute(queryCountPattern, [queryCount , filteredCount])));
	}
});

})();
