/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved. 
 * 
 * Note to U.S. Government Users Restricted Rights:  Use, 
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui2.internal.grid.view.query.QueryGridTransformer"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.api.ui.model.ColumnTag"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.IColumn"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.api.ui.model.IViewModel"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.model.EntryUtils"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.grid.view.query.QueryColumns"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.grid.view.query.model.Query"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.grid.view.query.model.ScopeFolder"); //$NON-NLS-1$

(function() {
var ColumnTag= com.ibm.team.rtc.foundation.api.ui.model.ColumnTag;
var Unit= com.ibm.team.rtc.foundation.api.ui.model.IColumn.Unit;
var Domain= com.ibm.team.rtc.foundation.api.ui.model.IViewModel.Domain;
var EntryUtils= com.ibm.team.rtc.foundation.web.ui.model.EntryUtils;
var QueryColumns= com.ibm.team.workitem.web.ui2.internal.grid.view.query.QueryColumns;
var Query= com.ibm.team.workitem.web.ui2.internal.grid.view.query.model.Query;
var ScopeFolder= com.ibm.team.workitem.web.ui2.internal.grid.view.query.model.ScopeFolder;

/**
 * Show a Query-of-queries grid
 */
dojo.declare("com.ibm.team.workitem.web.ui2.internal.grid.view.query.QueryGridTransformer", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fInput: null,

	fQueryColumnInfo: null,

	fScopeColumnInfo: null,

	fViewModel: null,

	inputChanged: function(model, newInput) {
		this.fViewModel= model;
		this.fInput= newInput;
	},

	refreshModel: function(updater) {
		this.doRefreshHeader(updater);
		if (this.fInput != null) {
			var $subject= this.fInput;
			var $length= $subject.length;
			for (var $count= 0; $count < $length; $count++){
				var element= $subject[$count];
				this.addRecursive(element, [], updater);
			}
		}
	},

	addRecursive: function(element, path, updater) {
		updater.addEntry(Domain.Content, path, element);
		if (element instanceof ScopeFolder) {
			path.push(element);
			try {
				var $subject2= element.getQueries();
				var $length2= $subject2.length;
				for (var $count2= 0; $count2 < $length2; $count2++){
					var child= $subject2[$count2];
					this.addRecursive(child, path, updater);
				}
			} finally {
				path.pop();
			}
		}
	},

	getElementsToExpandInitially: function() {
		return this.fViewModel.readModel(dojo.hitch(this, function(readAccessor) {
			var n= readAccessor.getEntryNavigator(true);
			var folders= EntryUtils.entriesOfType(n.childEntries(readAccessor.getRootEntry(Domain.Content)), ScopeFolder);
			if (folders.length > 1) {
				var toExpand= folders[0];
				folders= [];
				folders.push(toExpand);
			}
			return folders;
		}));
	},

	doRefreshHeader: function(updateAccessor) {
		var rootColumn= updateAccessor.getRootColumn();
		var queryColumns= rootColumn.addPropertyColumnList(Query.prototype.declaredClass, updateAccessor);
		this.addColumn(queryColumns, QueryColumns.NAME, {size: 10, unit: Unit.em}, null, 20, updateAccessor);
		this.addColumn(queryColumns, QueryColumns.DESCRIPTION, {size: 10, unit: Unit.em}, null, 50, updateAccessor);
		this.addColumn(queryColumns, QueryColumns.ACTION, {size: 5, unit: Unit.em}, null, 0, updateAccessor);
		var scopeFolderColumns= rootColumn.addPropertyColumnList(ScopeFolder.prototype.declaredClass, updateAccessor);
		this.addColumn(scopeFolderColumns, QueryColumns.NAME, null, null, 10, updateAccessor);
		this.fQueryColumnInfo= new ColumnTag(queryColumns, null);
		this.fScopeColumnInfo= new ColumnTag(scopeFolderColumns, null);
		updateAccessor.setTag(updateAccessor.getRootEntry(Domain.Content), new ColumnTag(null, [queryColumns]));
	},

	addColumn: function(columnList, column, min, max, weight, updateAccessor) {
		var result= columnList.addColumn(column.getIdentifier(), column.getLabel(), null, column, updateAccessor);
		result.setSize(min, max, weight, updateAccessor);
	},

	provideColumnInfo: function(entry, readAccessor) {
		if (EntryUtils.isType(entry, ScopeFolder)) 
			return this.fScopeColumnInfo;
		if (EntryUtils.isType(entry, Query)) 
			return this.fQueryColumnInfo;
		return null;
	},

	$interfaces: {
		'com.ibm.team.rtc.foundation.api.ui.model.IViewModelTransformer': true //$NON-NLS-1$
	}
});

})();
