/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui2.internal.presentation.ReferencedWorkItemList"); //$NON-NLS-1$

dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.api.common.WorkItemCollections"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.client.internal.WorkItemClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.view.editor.parts.WorkItemListPart"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.presentation.model.DTOArray"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.presentation.model.LayoutHints"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.presentation.model.PresentationPropertyNames"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("dojox.xml.parser"); //$NON-NLS-1$

(function() {
var ServiceResponseHandler= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var WorkItemCollections= com.ibm.team.workitem.api.common.WorkItemCollections;
var WorkItemClient= com.ibm.team.workitem.web.client.internal.WorkItemClient;
var WorkItemListPart= com.ibm.team.workitem.web.ui.internal.view.editor.parts.WorkItemListPart;
var DTOArray= com.ibm.team.workitem.web.ui2.internal.presentation.model.DTOArray;
var LayoutHints= com.ibm.team.workitem.web.ui2.internal.presentation.model.LayoutHints;
var PresentationPropertyNames= com.ibm.team.workitem.web.ui2.internal.presentation.model.PresentationPropertyNames;
var parser= dojox.xml.parser;

dojo.declare("com.ibm.team.workitem.web.ui2.internal.presentation.ReferencedWorkItemList", WorkItemListPart, { //$NON-NLS-1$

	workingCopy: null,

	presentation: null,

	layoutHints: null,

	_addCommand: null,

	fLinkTypeDTO: null,

	_messages: dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages"), //$NON-NLS-1$ //$NON-NLS-2$

	postCreate: function() {
		this.layoutHints= new LayoutHints();
		this.layoutHints.isWide= true;
		this.layoutHints.isHideLabel= true;
		this._fetchEditableLinkTypes();
		this.inherited("postCreate", arguments, []); //$NON-NLS-1$
	},

	postCreateRefresh: function() {
	},

	_fetchEditableLinkTypes: function() {
		var onSuccess= dojo.hitch(this, function(result) {
			this._initialize(result);
		});
		var onFailure= dojo.hitch(this, function(result) {
			window.alert(dojo.string.substitute(this._messages.errorFailedToLoadEditableLinkTypes, [result.message]));
		});
		var parms= {};
		parms.projectAreaItemId= this.workingCopy.getProjectAreaItemId();
		var responseHandler= new ServiceResponseHandler({'onSuccess': onSuccess, 'onFailure': onFailure}, 'onSuccess', 'onFailure'); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
		WorkItemClient.getLinkTypes(responseHandler, parms);
	},

	_initialize: function(linkTypeDTOs) {
		if (this.presentation.displaySpec != null && this.presentation.displaySpec.hasDeferredLabel) {
			parser.removeChildren(this.presentation.displaySpec.labelSpan);
		}
		var endpointPath= DTOArray.findProperty(this.presentation.properties, PresentationPropertyNames.ENDPOINT_ID);
		if (endpointPath != null) {
			var endpointPathArray= endpointPath.split("/"); //$NON-NLS-1$
			if (endpointPathArray.length === 2) {
				if (endpointPathArray[1] === "") { //$NON-NLS-1$
					endpointPathArray[1]= "related"; //$NON-NLS-1$
				}
				var linkTypeDTO= DTOArray.findDTOWithIdAndEndpoint(linkTypeDTOs, endpointPathArray[0], endpointPathArray[1]);
				if (linkTypeDTO != null) {
					this.fLinkTypeDTO= linkTypeDTO;
					var label= linkTypeDTO.displayName;
					if (this.presentation.attributeLabel != null) {
						label= this.presentation.attributeLabel;
					}
					parser.removeChildren(this._addCommand);
					if (this.fLinkTypeDTO.isUserWriteable) 
						if (this.fLinkTypeDTO.isSingleValued) {
							this._addCommand.appendChild(window.document.createTextNode(this._messages.actionSet));
						} else {
							this._addCommand.appendChild(window.document.createTextNode(this._messages.actionAdd));
						}
					this.setListTitle(label);
				}
			}
		}
		this.refresh();
	},

	isUserDeleteable: function() {
		if (this.fLinkTypeDTO == null) 
			return false;
		return this.fLinkTypeDTO.isUserDeleteable;
	},

	getItems: function() {
		var result= [];
		var parms= {};
		parms.path= [WorkItemCollections.LINKTYPES];
		var linkTypeDTOs= this.workingCopy.getValue(parms);
		var endpointPath= DTOArray.findProperty(this.presentation.properties, PresentationPropertyNames.ENDPOINT_ID);
		if (endpointPath != null) {
			var endpointPathArray= endpointPath.split("/"); //$NON-NLS-1$
			if (endpointPathArray.length === 2) {
				if (endpointPathArray[1] === "") { //$NON-NLS-1$
					endpointPathArray[1]= "related"; //$NON-NLS-1$
				}
				var linkTypeDTO= DTOArray.findDTOWithIdAndEndpoint(linkTypeDTOs, endpointPathArray[0], endpointPathArray[1]);
				if (linkTypeDTO != null && linkTypeDTO.linkDTOs != null) {
					for (var i= 0; i < linkTypeDTO.linkDTOs.length; i++){
						result.push(linkTypeDTO.linkDTOs[i]);
					}
				}
			}
		}
		return result;
	},

	deleteItem: function(item) {
		if (item._isNew) {
			this.deleteLinkDTO(item);
		} else {
			item._isDeleted= true;
		}
		this.setWorkignCopyValue();
		this.markParentDirty();
	},

	getAddLabel: function() {
		return ""; //$NON-NLS-1$
	},

	openWorkItemDialog: function() {
		this.addWorkItemLink(this.fLinkTypeDTO, this.getItems());
	},

	destroy: function(preserveDom) {
		this.inherited("destroy", arguments, [preserveDom]); //$NON-NLS-1$
	}
});

})();
