/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui2.internal.presentation.Target"); //$NON-NLS-1$

dojo.require("com.ibm.team.workitem.web.cache.internal.WorkItemProxyFactory"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.module.WindowContext"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.EnumerationWidget"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.dialog.SelectTargetDialog"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$

(function() {
var WorkItemProxyFactory= com.ibm.team.workitem.web.cache.internal.WorkItemProxyFactory;
var WindowContext= com.ibm.team.workitem.web.ui.internal.module.WindowContext;
var EnumerationWidget= com.ibm.team.workitem.web.ui.internal.view.layout.EnumerationWidget;
var SelectTargetDialog= com.ibm.team.workitem.web.ui2.internal.dialog.SelectTargetDialog;

var Target= dojo.declare("com.ibm.team.workitem.web.ui2.internal.presentation.Target", EnumerationWidget, { //$NON-NLS-1$

	constructor: function(params) {
		this.SEPARATOR_ID= "-2"; //$NON-NLS-1$
	},

	priorTarget: null,

	SEPARATOR_ID: null,

	_messages: dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages"), //$NON-NLS-1$ //$NON-NLS-2$

	postCreate: function() {
		this.inherited("postCreate", arguments, []); //$NON-NLS-1$
	},

	enableOkButton: function(parms) {
	},

	getSelectValues: function(values, isMore) {
		if (isMore) {
			var onCancelHandler= dojo.hitch(this, function(objectArgs) {
				this.setAttributeValue(this.priorTarget, true, null, true);
				return objectArgs;
			});
			var onOKHandler= dojo.hitch(this, function(objectArgs) {
				var args= objectArgs;
				var getArgs= {};
				getArgs.path= ["attributes", this.attributeId]; //$NON-NLS-1$
				var value= args.workingCopy.getValue(getArgs);
				this.setAttributeValue(value, true, null, true);
				return args;
			});
			var args= {};
			args.createIfNeeded= true;
			args.id= -1;
			args.doNotCache= true;
			var policyRequestWI= WorkItemProxyFactory.getWorkItemProxy(args);
			policyRequestWI.workItemSpec= this.workingCopy.workItemSpec;
			var getArgs= {};
			getArgs.path= ["attributes", this.attributeId]; //$NON-NLS-1$
			this.attributeValue= this.workingCopy.getValue(getArgs);
			var setArgs= {};
			setArgs.path= getArgs.path;
			setArgs.value= this.attributeValue;
			setArgs.attributeId= this.attributeId;
			policyRequestWI.setValue(setArgs);
			var getArgsProjectArea= {};
			getArgsProjectArea.path= ["attributes", "projectArea"]; //$NON-NLS-1$ //$NON-NLS-2$
			this.attributeValue= this.workingCopy.getValue(getArgsProjectArea);
			var setArgsProjectArea= {};
			setArgsProjectArea.path= getArgsProjectArea.path;
			setArgsProjectArea.value= this.attributeValue;
			setArgsProjectArea.attributeId= "projectArea"; //$NON-NLS-1$
			policyRequestWI.setValue(setArgsProjectArea);
			var policyRequest= policyRequestWI;
			var parms= {};
			parms.okButtonHandler= this;
			parms.workingCopy= policyRequest;
			parms.onCancel= onCancelHandler;
			parms.onOk= onOKHandler;
			parms.attributeId= this.attributeId;
			new SelectTargetDialog(parms);
			return values;
		}
		if (values == null) {
			return this.inherited("getSelectValues", arguments, [values, false]); //$NON-NLS-1$
		}
		var attributeValueId= null;
		if (this.attributeValue != null) {
			var getArgs= {};
			getArgs.path= ["attributes", this.attributeId]; //$NON-NLS-1$
			this.attributeValue= this.workingCopy.getValue(getArgs);
			attributeValueId= this.attributeValue.id;
		}
		var currentIndex= -1;
		var unassignedIndex= -1;
		var attributeValueIndex= -1;
		var allInscopeValues= [];
		for (var i= 0; i < values.length; i++){
			var value= values[i];
			value.isHidden= false;
			if (value.current || value.inScope || value.id === attributeValueId || value.id === "") { //$NON-NLS-1$
				if (value.id === "") { //$NON-NLS-1$
					unassignedIndex= allInscopeValues.length;
				}
				if (value.current) {
					if (value.label.indexOf(Target.CARAT) !== 0) {
						value.label= Target.CARAT + " " + value.label; //$NON-NLS-1$
					}
					currentIndex= currentIndex === -1 ? allInscopeValues.length : currentIndex;
				}
				if (value.id === attributeValueId) {
					attributeValueIndex= allInscopeValues.length;
				}
			}
			if (value.id !== this.MORE_ID) {
				allInscopeValues.push(value);
			}
		}
		if (currentIndex === -1) 
			currentIndex= 0;
		var recentItemIds= WindowContext.getRecentItems(this.attributeId);
		var recentItems= [];
		if (recentItemIds != null && recentItemIds.length > 0) {
			for (var i= 0; i < recentItemIds.length; i++){
				var recentItem= {};
				recentItem.id= recentItemIds[i];
				recentItems.push(recentItem);
			}
		}
		var filteredInscopeValues= [];
		var currentIndexStart= currentIndex;
		var currentIndexEnd= currentIndex + 5;
		if (currentIndexEnd > allInscopeValues.length - 1) {
			currentIndexEnd= allInscopeValues.length - 1;
			currentIndexStart= Math.max(0, currentIndexEnd - 5);
		}
		var value;
		for (var i= 0; i < allInscopeValues.length; i++){
			var isHidden= false;
			value= allInscopeValues[i];
			if (value.id === "")  //$NON-NLS-1$
				continue;
			if (value.id !== attributeValueId) {
				if (!this._isInRecentArray(recentItems, value)) {
					if (i < currentIndexStart || i > currentIndexEnd) {
						isHidden= true;
					}
				}
			}
			if (!isHidden) {
				filteredInscopeValues.splice(0, 0, value);
			}
		}
		if (attributeValueIndex === -1) {
			filteredInscopeValues.splice(0, 0, this.attributeValue);
			attributeValueIndex= 0;
		}
		if (unassignedIndex !== -1) {
			filteredInscopeValues.splice(0, 0, allInscopeValues[unassignedIndex]);
		}
		var dto= {};
		dto.label= this._messages.optionMore;
		dto.id= this.MORE_ID;
		filteredInscopeValues.push(dto);
		return filteredInscopeValues;
	},

	_isInRecentArray: function(recentItems, value) {
		for (var i= 0; i < recentItems.length; i++){
			if (recentItems[i].id === value.id) 
				return true;
		}
		return false;
	},

	setAttributeValue: function(value, setValue, ignored, ignored2) {
		if (this.priorTarget == null) {
			var getArgs= {};
			getArgs.path= ["attributes", this.attributeId]; //$NON-NLS-1$
			this.priorTarget= this.workingCopy.getValue(getArgs);
		}
		if (!this.isMore(value) && !this.isSeparator(value)) {
			if (value.id !== "") { //$NON-NLS-1$
				WindowContext.touchRecentItem(this.attributeId, value.id);
			}
			this.priorTarget= value;
			var found= false;
			for (var i= 0; i < this._possibleValues.length; i++){
				if (value.id === this._possibleValues[i].id) {
					found= true;
					break;
				}
			}
			if (!found) {
				this._possibleValues.push(value);
			}
			this.inherited("setAttributeValue", arguments, [value, true, value, true]); //$NON-NLS-1$
		} else {
			this.inherited("setAttributeValue", arguments, [this.priorTarget, true, null, true]); //$NON-NLS-1$
		}
		this.setPossibleValues(this._possibleValues, this._select, this._image, this.isMore(value));
		this.inherited("setAttributeValue", arguments, [this.priorTarget, true, value, true]); //$NON-NLS-1$
	},

	isMore: function(value) {
		var dto= value;
		if (dto != null && dto.id === this.MORE_ID) {
			return true;
		}
		return false;
	},

	isSeparator: function(value) {
		var dto= value;
		if (dto != null && dto.id === this.SEPARATOR_ID) {
			return true;
		}
		return false;
	}
});

Target.CARAT= "\u25b8"; //$NON-NLS-1$
dojo.declare("com.ibm.team.workitem.web.ui2.internal.presentation.Target.SimpleProxy", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	workItemSpec: null
});

})();
