/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui2.internal.presentation._WikiMixin");

dojo.require("dojo.string");
dojo.require("jazz.util.html");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.richtext.EditorProxy");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil");

(function(){

var WidgetUtil = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil;

dojo.declare(
	"com.ibm.team.workitem.web.ui2.internal.presentation._WikiMixin",
	null,
{
	// override methods of HTMLWidgets so that SelfSizingTextArea is used instead of rich text editor
	// this should really be included in Wiki.js
	// implemented as a mixin class to speed up implementating as Wiki.js is implemented in JDojo
	
	editorProxyClass: com.ibm.team.workitem.web.ui.internal.view.richtext.EditorProxy,

	setupEditor: function(editor){
		var textarea = editor.textarea;
		this.connect(textarea, "onblur", dojo.hitch(this, this._handleBlur));
		if(this.setSectionMenu) {
			dojo.addClass(textarea, "SelfSizingTextAreaTall");
		} else {
			dojo.addClass(textarea, "SelfSizingTextAreaShort");
		}
		this._updateListener= WidgetUtil.runAfterTyping(textarea, WidgetUtil.DEFAULT_DELAY, dojo.hitch(this, this._handleTextChange, {target: textarea}));
	},

	_handleAttributeChange: function(parms) {
		var attrValue = parms.attributeValue || "";
		if(this.getValue() == attrValue){ return; }
		this.setValue(attrValue);

		this._setHTMLEditorState(this._isReadOnly, /* skipFocus */ true );
		if(parms.validationStatus){
			this._setStatus(parms.validationStatus);
		}
	},

	_isValueChanged: function() {
		// IE adds returns to the values so strip them for compare
		var oldValue = this._originalModifiedTextValue.replace(/\r/g,"");
		var newValue = this.getValue().replace(/\r/g,"");
		return (oldValue != newValue);
	},

	setValue: function(value) {
		this._originalUnmodifiedTextValue = value;
		this._originalModifiedTextValue = this._cleanText(value);
		this._editorProxy.setValue(this._originalModifiedTextValue);
	},

	escape: function(value){
		return jazz.util.html.escape(value);
	}
});

})();