/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui2.internal.widget.DialogListWidget");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("jazz.util.html");
dojo.require("com.ibm.team.workitem.web.ui2.internal.widget.AbstractWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");


(function() {

var WidgetUtil = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil;

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui2.internal.widget.DialogListWidget",
	[dijit._Widget, dijit._Templated, com.ibm.team.workitem.web.ui2.internal.widget.AbstractWidget],
	{

		templateString: '<div><div class="DialogListWidget">' +
						'<select dojoAttachPoint="_select" dojoAttachEvent="onkeyup: _handleKeyUp, onchange: _handleSelectChange, onclick:_handleSelectClick,ondblclick:_handleSelectDoubleClick, onfocus:_handleSelectFocus, onblur: _handleSelectBlur" style="width: 100%" class="Select"></select>' +
						'</div></div>',
		LOADING_ID: "_synthetic_loading",
		postCreate: function() {
            this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
			this.presentation = this.presentation || {};
			
			/*
			 * If the widget is loading, show loading until setPossibleValues are set
			 */
			this._wasPresentationValueDisabled = this.presentation.isCurrentValueDisabled;
			this._select.style.visibility = "hidden";
			if(this.presentation.onLoading) {
				loadingValue = { id: this.LOADING_ID };
				loadingValue[this.presentation.messageSelector] =  this.messages.busyLoading

				this.presentation.isCurrentValueDisabled = true; 

				pv = [ loadingValue ];
				this.setPossibleValues(pv);
			} else {
				if(this._possibleValues) {				
					this.setPossibleValues(this._possibleValues);
				}			
			}
			if(this.presentation.onClick) {
				this.onClick = this.presentation.onClick;
			}
			if(this.presentation.onDoubleClick) {
				this.onDoubleClick = this.presentation.onDoubleClick;
			}
			if (this.presentation.accessibleLabel) {
				this._select.setAttribute("aria-label", this.presentation.accessibleLabel);
			}
			/*
			 * DBCS fonts on IE8 require us to swizzle the size
			 */
			 if(dojo.isIE) {
				this._select.size = 0
				var self = this;
			 	window.setTimeout(function() { 
					self._select.size =  self.presentation.size || "6";
					self._select.style.visibility = "visible";
	 				self._select.selectedIndex = -1;
 				} , 100);
			 } else {		 	
				this._select.size = this.presentation.size || "6";
				this._select.style.visibility = "visible";
				this._select.selectedIndex = -1;
			 }

			
 		},
 		destroy: function() {
 			this._destroyChildren();
 			this.inherited(arguments);
 		},
 		setPossibleValues: function (possibleValues) {
 		 	this.presentation.isCurrentValueDisabled = this._wasPresentationValueDisabled;
 			dojox.xml.parser.removeChildren(this._select);
			this.presentation.messageSelector = this.presentation.messageSelector || "message";
			this.presentation.detailsSelector = this.presentation.detailsSelector || "details";
 			if(!possibleValues) return;
 			this._possibleValues = possibleValues;		
			for(var i=0;i<possibleValues.length;i++) {
				var option = document.createElement("option");
				var message = "";
				if(possibleValues[i][this.presentation.messageSelector]) {
					if(dojo.isFunction(possibleValues[i][this.presentation.messageSelector])) {
						message = possibleValues[i][this.presentation.messageSelector]();
					} else {
						message = possibleValues[i][this.presentation.messageSelector];	
					}
				}
				var details = "";
				if(possibleValues[i][this.presentation.detailsSelector]) {
					if(dojo.isFunction(possibleValues[i][this.presentation.detailsSelector])) {
						details = possibleValues[i][this.presentation.detailsSelector]();
					} else {
						details = possibleValues[i][this.presentation.detailsSelector];	
					}
				}
				
				if(this.presentation.isErrorList) {
					var optionMessage = details.length > 0 ? details : message;
				} else {					
					var optionMessage = message;			
				}
				var text = document.createTextNode(optionMessage);
				if(possibleValues[i].isDisabled || (this.presentation.isCurrentValueDisabled &&
					this.presentation.currentValue && this.presentation.currentValue.id != null && possibleValues[i] && possibleValues[i].id != null &&
					this.presentation.currentValue.id == possibleValues[i].id )) {
					option.style.backgroundColor = "#EEEEEE";
					dojo.attr(option,"disabled", true);
				} else {
					if(possibleValues[i].id == this.LOADING_ID) {
						option.style.color = "#999999";
						dojo.attr(option,"disabled", true);
					}
				}
				option.appendChild(text);
				this._select.appendChild(option);
				
			}
			
 		},
 		getSelected: function() {
 			var result = [];
 			var selected = this._getCurrentSelectValue(this._select);
 			if(selected) result.push(selected); 
 			return result;
 		},
 		_handleKeyUp: function(e) {
 			if(this.onKeyUp) this.onKeyUp(e);
			var selectValue = this._getCurrentSelectValue(this._select);
			if(selectValue && this._lastSelectedValue) {
				if(selectValue.id != this._lastSelectedValue.id) {
					this._handleSelectChange(e, selectValue);
				}
			} else {
				this._handleSelectChange(e, selectValue);
			}
 		},
 		_handleSelectChange: function(e, value) {
 			if(!value) {
 				value = this._getCurrentSelectValue(this._select)
 			}
 			this._lastSelectedValue = value;
 			if(this.workingCopy) { 				
	 			this.workingCopy.setValue({
	 				path: ["attributes", this.attributeId],
	 				attributeId: this.attributeId,
	 				caller: this,
	 				value: value
	 				})
 			}
 			if(!this.onChange) return;
 			this.onChange({event: e, parentWidget: this.parentWidget, value: value }); 			
 		},
 		_handleSelectClick: function(e) {
 			if(this.onClick) this.onClick(e); 			
 		},
		_handleSelectDoubleClick: function(e) {
			if(this.onDoubleClick) {
				this._handleKeyUp(e); // Set the value
				this.onDoubleClick(e);
			} 
		},
 		_handleSelectFocus: function(e) {
 //			if(this.onFocus) this.onFocus(e); 			
 		},
 		_handleSelectBlur: function(e) {
// 			if(this.onBlur) this.onBlur(e); 			
 		}
	}
);

})();