/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp. 
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui2.internal.widget.InlineWorkItemContent"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui.internal.page.EventTopics"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.web.ui2.internal.widget.InlineWorkItemEditor"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dojo.string"); //$NON-NLS-1$

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var EventTopics= com.ibm.team.workitem.web.ui.internal.page.EventTopics;
var InlineWorkItemEditor= com.ibm.team.workitem.web.ui2.internal.widget.InlineWorkItemEditor;
var _Templated= dijit._Templated;
var _Widget= dijit._Widget;

dojo.declare("com.ibm.team.workitem.web.ui2.internal.widget.InlineWorkItemContent", [ _Widget, _Templated], { //$NON-NLS-1$

	templateString: "<div dojoAttachPoint='_contentArea'></div>", //$NON-NLS-1$

	_contentArea: null,

	_heightHint: null,

	_workingCopy: null,

	_onClose: null,

	_onEditorLoaded: null,

	_okEnabled: null,

	_presentation: null,

	_inlineWorkItemEditor: null,

	_changedAttributes: null,

	_eventHandle: null,

	/**
	 * Takes a working copy already initialized and use count incremented. 
	 * The {@link InlineWorkItemContent} will decrement the use count on close.
	 */
	constructor: function(parameters) {
		this._heightHint= parameters.heightHint;
		this._workingCopy= parameters.workingCopy;
		this._onClose= parameters.onClose;
		this._onEditorLoaded= parameters.onEditorLoaded;
		this._okEnabled= parameters.okEnabled;
		this._presentation= parameters.presentation;
	},

	postCreate: function() {
		this.inherited("postCreate", arguments, []); //$NON-NLS-1$
		var contentParams= {};
		contentParams.workItemId= this._workingCopy.getId();
		contentParams.parentWidget= this;
		contentParams.isContentOnly= true;
		contentParams.heightHint= this._heightHint;
		contentParams.presentation= this._presentation;
		var content= new InlineWorkItemEditor(contentParams);
		dojo.style(content.domNode, "marginLeft", "0em"); //$NON-NLS-1$ //$NON-NLS-2$
		dojo.style(content.domNode, "width", "100%"); //$NON-NLS-1$ //$NON-NLS-2$
		this._contentArea.appendChild(content.domNode);
		this._eventHandle= dojo.subscribe(EventTopics.WORKITEM_EDITOR_CHANGED, this, dojo.hitch(this, function( /*, args... */ ) {
			var args= [];
			for (var $sourceIdx= 0; $sourceIdx < arguments.length; $sourceIdx++)
				args.push(arguments[$sourceIdx]);

			if (args.length > 0 && args[0] === this._workingCopy) {
				dojo.unsubscribe(this._eventHandle);
				this._eventHandle= null;
				if (this._onEditorLoaded != null) {
					this._onEditorLoaded();
				}
			}
		}));
		this._inlineWorkItemEditor= content;
	},

	getChangedAttributes: function() {
		var changedAttributes= this._workingCopy.changedAttributes;
		var result= [];
		var propertyNames= jdojo.getProperties(changedAttributes);
		for (var i= 0; i < propertyNames.length; i++){
			result.push(changedAttributes[propertyNames[i]]);
		}
		return result;
	},

	handleOk: function(event) {
		this._changedAttributes= this.getChangedAttributes();
		this._inlineWorkItemEditor._handleBottomOkClicked(event);
	},

	setIsDirty: function(isDirty) {
		if (this._inlineWorkItemEditor != null) {
			this._inlineWorkItemEditor.setIsDirty(isDirty);
		}
	},

	handleCancel: function(event) {
		this._inlineWorkItemEditor._handleBottomCancelClicked(event);
	},

	hidePreviewEditor: function() {
		if (this._workingCopy == null) 
			return ;
		if (!this._workingCopy.isNewWorkItem()) {
			var info= {};
			info.itemId= this._workingCopy.getItemId();
			info.workItemId= this._workingCopy.getId();
			info.description= this.getWorkItemLabel(this._workingCopy);
			this._onClose(info, this._changedAttributes);
		} else {
			this._onClose(null, null);
		}
		this._releaseWorkingCopy();
	},

	getWorkItemLabel: function(proxy) {
		var summaryContent= proxy.getSummaryContent();
		if (summaryContent != null && summaryContent.length > 0) {
			return dojo.string.substitute("${0}: ${1}", [String(proxy.getId()), summaryContent]); //$NON-NLS-1$
		}
		return proxy.getSummaryLabel();
	},

	setSaveEnabled: function(parentParms, isDirty) {
		if (this._okEnabled != null) {
			this._okEnabled(isDirty);
		}
	},

	_releaseWorkingCopy: function() {
		if (this._workingCopy != null) {
			this._workingCopy.decrementUseCount(true);
			this._workingCopy= null;
		}
	},

	destroy: function(preserveDom) {
		this._releaseWorkingCopy();
		if (this._inlineWorkItemEditor != null) {
			this._inlineWorkItemEditor.destroy(preserveDom);
			this._inlineWorkItemEditor= null;
		}
		if (this._eventHandle != null) {
			dojo.unsubscribe(this._eventHandle);
			this._eventHandle= null;
		}
		this.inherited("destroy", arguments, [preserveDom]); //$NON-NLS-1$
	}
});

})();
