/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2010, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.workitem.web.ui2.internal.widget.StatusIndicator"); //$NON-NLS-1$

dojo.require("com.ibm.team.workitem.api.common.Severity"); //$NON-NLS-1$
dojo.require("com.ibm.team.workitem.api.common.Status"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("jazz.ui.HoverPopup"); //$NON-NLS-1$

(function() {
var Severity= com.ibm.team.workitem.api.common.Severity;
var Status= com.ibm.team.workitem.api.common.Status;
var _Templated= dijit._Templated;
var _Widget= dijit._Widget;
var HoverPopup= jazz.ui.HoverPopup;

dojo.declare("com.ibm.team.workitem.web.ui2.internal.widget.StatusIndicator", [ _Widget, _Templated], { //$NON-NLS-1$

	templateString: "<div dojoAttachPoint='_statusDiv' class='com-ibm-team-workitem-web-ui2-internal-widget-StatusIndicator'></div>", //$NON-NLS-1$

	_statusDiv: null,

	_hoverPopup: null,

	fCurrentStatus: null,

	postCreate: function() {
		this.inherited("postCreate", arguments, []); //$NON-NLS-1$
		var args= {};
		args.around= [this._statusDiv];
		args.orientation= "L"; //$NON-NLS-1$
		args.createContents= dojo.hitch(this, function(hoverPopup) {
			return window.document.createTextNode(this.fCurrentStatus.getMessage());
		});
		this._hoverPopup= new HoverPopup(args);
		this.setStatus(Status.OK_STATUS);
	},

	test: function() {
		this.setStatus(new Status(Severity.ERROR, "test")); //$NON-NLS-1$
	},

	setStatus: function(status) {
		if (status == null) 
			status= Status.OK_STATUS;
		if (status.isOK()) 
			this.hide();
		else 
			this.show();
		this._setIcon(status.getSeverity());
		this.fCurrentStatus= status;
	},

	show: function() {
		this._hoverPopup.attr("enabled", true); //$NON-NLS-1$
		this._statusDiv.style.display= ""; //$NON-NLS-1$
	},

	hide: function() {
		this._hoverPopup.close();
		this._hoverPopup.attr("enabled", false); //$NON-NLS-1$
		this._statusDiv.style.display= "none"; //$NON-NLS-1$
	},

	_setIcon: function(severity) {
		if (this.fCurrentStatus != null) 
			dojo.removeClass(this._statusDiv, this._getCSSClassName(this.fCurrentStatus.getSeverity()));
		dojo.addClass(this._statusDiv, this._getCSSClassName(severity));
	},

	_getCSSClassName: function(severity) {
		return "Annotation-" + severity.name; //$NON-NLS-1$
	},

	destroy: function(preserveDom) {
		if (this._hoverPopup != null) 
			this._hoverPopup.destroy(preserveDom);
		this._hoverPopup= null;
		this.inherited("destroy", arguments, [preserveDom]); //$NON-NLS-1$
	}
});

})();
