/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui2.internal.widget.TableListWidget");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("jazz.util.html");
dojo.require("com.ibm.team.workitem.web.ui2.internal.widget.AbstractWidget");
dojo.require("com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");


(function() {

var WidgetUtil = com.ibm.team.workitem.web.ui.internal.view.layout.WidgetUtil;

/* defineWidget */ dojo.declare(
	"com.ibm.team.workitem.web.ui2.internal.widget.TableListWidget",
	[dijit._Widget, dijit._Templated, com.ibm.team.workitem.web.ui2.internal.widget.AbstractWidget],
	{

		templateString: '<div><div dojoAttachPoint="_selectDIV" style="overflow:auto; background-color:#FCFCFC; margin: 0 5px 15px; border: 1px solid #EEE;" class="TableListWidget">' +
						'<table dojoAttachPoint="_table"  style="position:static !important;scroll: none;width: 100% !important; overflow:visible;" class="Select"></table>' +
						'</div></div>',

		postCreate: function() {
            this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "WorkItemEditorMessages");
			this.presentation = this.presentation || {};
			var selectSize = this.presentation.size || 6;
			this._selectDIV.style.height = Math.max((selectSize * 1.25), 6) + "em"; // must be 6em to see scroll bars
			this.setPossibleValues(this._possibleValues);
 		},
 		destroy: function() {
 			this._destroyChildren();
 			this.inherited(arguments);
 		},
 		setPossibleValues: function (possibleValues) {
 			dojox.xml.parser.removeChildren(this._table);
			this.presentation.messageSelector = this.presentation.messageSelector || "message";
			this.presentation.detailsSelector = this.presentation.detailsSelector || "details";

 			if(!possibleValues) return;
 			this._possibleValues = possibleValues;		
			for(var i=0;i<possibleValues.length;i++) {
				var row = this._table.insertRow(-1);
				var col = row.insertCell(-1);
				if(i>0) col.style.borderTop = "1px solid #EFEFEF";
				var message = "";
				var messageSelector = this.presentation.messageSelector; 
				if(possibleValues[i][messageSelector]) {
					if(dojo.isFunction(possibleValues[i][messageSelector])) {
						message = possibleValues[i][messageSelector]();
					} else {
						message = possibleValues[i][messageSelector];	
					}
				}
				var details = "";
				if(possibleValues[i][this.presentation.detailsSelector]) {
					if(dojo.isFunction(possibleValues[i][this.presentation.detailsSelector])) {
						details = possibleValues[i][this.presentation.detailsSelector]();
					} else {
						details = possibleValues[i][this.presentation.detailsSelector];	
					}
				}
				
				if(this.presentation.isErrorList) {
					var optionMessage = details.length > 0 ? details : message;
				} else {					
					var optionMessage = message;			
				}
				var text = document.createTextNode(optionMessage);
				col.appendChild(text);
				col.title = optionMessage;
			}
			
 		}
	}
);

})();