/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.util.StackTrace"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.JavaScriptException"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$

(function() {
var JavaScriptException= com.ibm.jdojo.lang.JavaScriptException;
var Assert= com.ibm.jdojo.util.Assert;

var StackTrace= dojo.declare("com.ibm.team.rtc.foundation.web.ui.util.StackTrace", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fStackTraceElements: null,

	constructor: function(e) {
		this.fStackTraceElements= [];
		var stack= e.getThrown()[StackTrace.STACK_NAME];
		if (dojo.isString(stack)) {
			var lines= stack.split("\n"); //$NON-NLS-1$
			var $subject= lines;
			var $length= $subject.length;
			for (var $count= 0; $count < $length; $count++){
				var line= $subject[$count];
				this.fStackTraceElements.push(new StackTraceElement(line));
			}
		}
	},

	getElements: function() {
		return this.fStackTraceElements;
	},

	print: function() {
		var array= this.fStackTraceElements;
		for (var i= array.length - 1; i >= 0; i--){
			console.error(array[i].getValue());
		}
	}
});

StackTrace.STACK_NAME= "stack"; //$NON-NLS-1$
StackTrace.fromHere= function() {
	return new StackTrace(new JavaScriptException({}));
};
StackTrace.from= function(e) {
	if (!(e != null)) Assert.fail("e != null", "com.ibm.team.rtc.foundation.web.ui.util.StackTrace:117");
	return new StackTrace(e);
};
var StackTraceElement= dojo.declare("com.ibm.team.rtc.foundation.web.ui.util.StackTrace.StackTraceElement", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fValue: null,

	fUri: null,

	fLineNo: null,

	constructor: function(value) {
		this.fValue= value;
		this.fLineNo= -1;
		this.fUri= null;
	},

	getValue: function() {
		return this.fValue;
	},

	getUri: function() {
		if (this.fUri == null) {
			this.init();
		}
		return this.fUri === StackTraceElement.URI_NULL ? null : this.fUri;
	},

	getLineNo: function() {
		if (this.fLineNo === -1) {
			this.init();
		}
		return this.fLineNo === StackTraceElement.LN_NULL ? -1 : this.fLineNo;
	},

	init: function() {
		if (dojo.isChrome !== undefined) {
			this.chromeInit();
		} else if (dojo.isFF !== undefined) {
			this.ffInit();
		}
	},

	ffInit: function() {
		var idx1= this.fValue.lastIndexOf("@"); //$NON-NLS-1$
		var idx2= this.fValue.lastIndexOf(":"); //$NON-NLS-1$
		if (idx1 * idx2 < 0 || idx1 >= idx2) {
			this.fUri= StackTraceElement.URI_NULL;
			this.fLineNo= StackTraceElement.LN_NULL;
		} else {
			this.fUri= this.fValue.substring(idx1 + 1, idx2);
			this.fLineNo= parseInt(this.fValue.substring(idx2 + 1));
		}
	},

	chromeInit: function() {
		var match= this.fValue.match(new RegExp(".*?(http\\S*):(\\d*):(\\d*).*")); //$NON-NLS-1$
		if (match == null) {
			this.fUri= StackTraceElement.URI_NULL;
			this.fLineNo= StackTraceElement.LN_NULL;
		} else {
			this.fUri= match[1];
			this.fLineNo= parseInt(match[2]);
		}
	}
});

StackTraceElement.URI_NULL= "__null__"; //$NON-NLS-1$
StackTraceElement.LN_NULL= -2;

})();
