/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.util.WebServiceGuard"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.guard"); //$NON-NLS-1$

(function() {
var Assert= com.ibm.jdojo.util.Assert;
var ServiceResponseHandler= com.ibm.team.repository.web.transport.ServiceResponseHandler;

var WebServiceGuard= dojo.declare("com.ibm.team.rtc.foundation.web.ui.util.WebServiceGuard", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fSubject: null,

	fPropertyName: null,

	/**
	 * 
	 * @param name The parameter name of the token
	 */
	constructor: function(name) {
		this.fSubject= dojo.getObject(WebServiceGuard.NAME);
		if (!(this.fSubject != null)) Assert.fail("this.fSubject != null", "com.ibm.team.rtc.foundation.web.ui.util.WebServiceGuard:35");
		if (!(name != null)) Assert.fail("name != null", "com.ibm.team.rtc.foundation.web.ui.util.WebServiceGuard:36");
		this.fPropertyName= name;
	},

	getToken: function(service) {
		if (!(service != null)) Assert.fail("service != null", "com.ibm.team.rtc.foundation.web.ui.util.WebServiceGuard:41");
		return String(this.fSubject[service]);
	},

	wrappedParams: function(service, params) {
		params= dojo.clone(params);
		var token= this.getToken(service);
		if (token !== undefined) {
			params[this.fPropertyName]= token;
		}
		return params;
	},

	/**
	 * Convenience method which adds the guard token to the call and handles errors
	 * that can occur when the server has been restarted but the client
	 * hasn't been (browser-)refreshed.
	 * 
	 * @param <T>
	 * @param fn
	 * @param handler
	 * @param serviceName
	 * @param method
	 * @param params
	 */
	invokeServiceCall: function(fn, handler, serviceName, method, params) {
		var onSuccess= dojo.hitch(this, function(result) {
			handler.doCallback(result);
		});
		var onFailure= dojo.hitch(this, function(data) {
			if (data.errorClass === WebServiceGuard.EXEC_NAME) {
				var details= data.errorData;
				if (this.fSubject[details.serviceName] !== undefined && details.token != null) {
					this.fSubject[details.serviceName]= details.token;
					fn(serviceName, method, handler, this.wrappedParams(serviceName, params));
				} else {
					handler.doErrorCallback(data);
				}
			} else {
				handler.doErrorCallback(data);
			}
		});
		fn(serviceName, method, new ServiceResponseHandler({'onSuccess': onSuccess, 'onFailure': onFailure}, 'onSuccess', 'onFailure'), this.wrappedParams(serviceName, params)); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
	}
});

WebServiceGuard.NAME= "com.ibm.team.rtc.foundation.web.ui.guard"; //$NON-NLS-1$
WebServiceGuard.EXEC_NAME= "com.ibm.team.rtc.common.internal.service.web.guard.WebServiceUsageException"; //$NON-NLS-1$

})();
