/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.util.performance.PerformanceDude"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var Assert= com.ibm.jdojo.util.Assert;

var PerformanceDude= dojo.declare("com.ibm.team.rtc.foundation.web.ui.util.performance.PerformanceDude", null, { //$NON-NLS-1$
	"-chains-": { constructor: "manual" },

	fStatisticsContainer: null,

	fCloseLink: null,

	constructor: function() {
		PerformanceDude.fDomNode= dojo.create("div", {}); //$NON-NLS-1$
		PerformanceDude.fDomNode.style.position= "absolute"; //$NON-NLS-1$
		PerformanceDude.fDomNode.style.left= "0"; //$NON-NLS-1$
		PerformanceDude.fDomNode.style.top= "0"; //$NON-NLS-1$
		PerformanceDude.fDomNode.style.background= "white"; //$NON-NLS-1$
		PerformanceDude.fDomNode.style.cursor= "pointer"; //$NON-NLS-1$
		PerformanceDude.fDomNode.innerHTML= "PerformanceDude"; //$NON-NLS-1$
		dojo.body().appendChild(PerformanceDude.fDomNode);
		dojo.connect(PerformanceDude.fDomNode, 'click', dojo.hitch(this, function(event) { //$NON-NLS-1$
			this.showStatistics();
		}));
	},

	getTime: function(item) {
		if (item.stopTime == null) {
			return "UNK"; //$NON-NLS-1$
		}
		return (item.stopTime.getTime() - item.startTime.getTime()) + ""; //$NON-NLS-1$
	},

	getAbsoluteTime: function(time) {
		if (time == null) {
			return "UNK"; //$NON-NLS-1$
		}
		return (time.getTime() - PerformanceDude.ROOT.startTime.getTime()) + ""; //$NON-NLS-1$
	},

	getCloseLink: function() {
		if (this.fCloseLink == null) {
			this.fCloseLink= dojo.create("a", {}); //$NON-NLS-1$
			this.fCloseLink.style.cursor= "pointer"; //$NON-NLS-1$
			this.fCloseLink.innerHTML= "[ CLOSE ]"; //$NON-NLS-1$
			dojo.connect(this.fCloseLink, 'click', dojo.hitch(this, function(event) { //$NON-NLS-1$
				this.fStatisticsContainer.style.display= "none"; //$NON-NLS-1$
			}));
		}
		return this.fCloseLink;
	},

	getStatisticsContainer: function() {
		if (this.fStatisticsContainer == null) {
			this.fStatisticsContainer= dojo.create("div", {}); //$NON-NLS-1$
			this.fStatisticsContainer.style.position= "absolute"; //$NON-NLS-1$
			this.fStatisticsContainer.style.left= "100px"; //$NON-NLS-1$
			this.fStatisticsContainer.style.top= "100px"; //$NON-NLS-1$
			this.fStatisticsContainer.style.background= "white"; //$NON-NLS-1$
			this.fStatisticsContainer.style.padding= "3px"; //$NON-NLS-1$
			this.fStatisticsContainer.style.paddingLeft= "20px"; //$NON-NLS-1$
			this.fStatisticsContainer.style.paddingRight= "20px"; //$NON-NLS-1$
			this.fStatisticsContainer.style.paddingBottom= "20px"; //$NON-NLS-1$
			this.fStatisticsContainer.style.border= "2px solid #000"; //$NON-NLS-1$
			dojo.body().appendChild(this.fStatisticsContainer);
		}
		this.fStatisticsContainer.style.display= "inherit"; //$NON-NLS-1$
		return this.fStatisticsContainer;
	},

	findFirst: function(label) {
		var $subject2= PerformanceDude.fFinished;
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var item= $subject2[$count2];
			if (item.label === label) {
				return item;
			}
		}
		return null;
	},

	findLast: function(label) {
		for (var i= PerformanceDude.fFinished.length - 1; i >= 0; i--){
			if (PerformanceDude.fFinished[i].label === label) {
				return PerformanceDude.fFinished[i];
			}
		}
		return null;
	},

	showStatistics: function() {
		var html= "<center><h2>Performance Dude Quick Report</h2></center>"; //$NON-NLS-1$
		html+= "<table padding=\"0\" border=\"0\" margin=\"5\" style=\"border:1px solid #ccc;\">"; //$NON-NLS-1$
		html+= "<tr><th>Label</th><th>Execution Time</th><th>Start Time</th><th>Stop Time</th></tr>"; //$NON-NLS-1$
		var odd= false;
		var $subject3= PerformanceDude.fFinished;
		var $length3= $subject3.length;
		for (var $count3= 0; $count3 < $length3; $count3++){
			var item= $subject3[$count3];
			html+= "<tr style=\"background: " + (odd ? "#fff" : "#ddd") + "\">"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
			html+= "<td>" + item.label + "</td>"; //$NON-NLS-1$ //$NON-NLS-2$
			html+= "<td>" + this.getTime(item) + "</td>"; //$NON-NLS-1$ //$NON-NLS-2$
			html+= "<td>" + this.getAbsoluteTime(item.startTime) + "</td>"; //$NON-NLS-1$ //$NON-NLS-2$
			html+= "<td>" + this.getAbsoluteTime(item.stopTime) + "</td>"; //$NON-NLS-1$ //$NON-NLS-2$
			html+= "</tr>"; //$NON-NLS-1$
			odd= !odd;
		}
		html+= "</table>"; //$NON-NLS-1$
		if (PerformanceDude.fFinished.length > 0) {
			var currentTime= PerformanceDude.fFinished[PerformanceDude.fFinished.length - 1].startTime.getTime();
			var gap= 0;
			for (var i= PerformanceDude.fFinished.length - 1; i >= 0; i--){
				while(i >= 0 && PerformanceDude.fFinished[i].startTime.getTime() > currentTime){
					i--;
				}
				if (i >= 0) {
					if (PerformanceDude.fFinished[i].stopTime.getTime() < currentTime) {
						gap+= currentTime - PerformanceDude.fFinished[i].stopTime.getTime();
					}
					currentTime= PerformanceDude.fFinished[i].startTime.getTime();
				}
			}
			var explainedTime= PerformanceDude.fFinished[PerformanceDude.fFinished.length - 1].stopTime.getTime() - currentTime;
			var explainedTimeGap= gap;
			var explained= (explainedTime - explainedTimeGap) / explainedTime * 100;
			var totalTime= PerformanceDude.fFinished[PerformanceDude.fFinished.length - 1].stopTime.getTime() - PerformanceDude.ROOT.startTime.getTime();
			var totalTimeGap= gap + (currentTime - PerformanceDude.ROOT.startTime.getTime());
			var total= (totalTime - totalTimeGap) / totalTime * 100;
			html+= "Coverage from first hit: " + parseInt(explained + "") + "%<br/>"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			html+= "Total coverage: " + parseInt(total + "") + "%<br/>"; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		}
		this.getStatisticsContainer().innerHTML= html;
		this.getStatisticsContainer().appendChild(this.getCloseLink());
		this.getStatisticsContainer().appendChild(dojo.create("br", null)); //$NON-NLS-1$
		if (PerformanceDude.fFinished.length > 0) {
			html= ""; //$NON-NLS-1$
			html+= this.getAbsoluteTime(PerformanceDude.fFinished[0].startTime);
			var myItem= this.findFirst("PlanEditorHeader.postCreate"); //$NON-NLS-1$
			if (myItem == null) {
				return ;
			}
			html+= "\t" + this.getAbsoluteTime(myItem.startTime) + "\t" + this.getAbsoluteTime(myItem.stopTime); //$NON-NLS-1$ //$NON-NLS-2$
			myItem= this.findFirst("PlanEditor.doLoadPlanModel(...)"); //$NON-NLS-1$
			if (myItem == null) {
				return ;
			}
			html+= "\t" + this.getAbsoluteTime(myItem.startTime) + "\t" + this.getAbsoluteTime(myItem.stopTime); //$NON-NLS-1$ //$NON-NLS-2$
			myItem= this.findFirst("PlannedItemsTab.applyPlanMode2"); //$NON-NLS-1$
			if (myItem == null) {
				return ;
			}
			html+= "\t" + this.getAbsoluteTime(myItem.startTime) + "\t" + this.getAbsoluteTime(myItem.stopTime); //$NON-NLS-1$ //$NON-NLS-2$
			myItem= this.findFirst("PlannedItemsTab.onAttributeInitialize"); //$NON-NLS-1$
			if (myItem == null) {
				return ;
			}
			html+= "\t" + this.getAbsoluteTime(myItem.startTime) + "\t" + this.getAbsoluteTime(myItem.stopTime); //$NON-NLS-1$ //$NON-NLS-2$
			myItem= this.findLast("GridViewer.refresh"); //$NON-NLS-1$
			if (myItem == null) {
				return ;
			}
			html+= "\t" + this.getAbsoluteTime(myItem.startTime) + "\t" + this.getAbsoluteTime(myItem.stopTime); //$NON-NLS-1$ //$NON-NLS-2$
			var textArea= dojo.create("textarea", {}); //$NON-NLS-1$
			textArea.style.width= "400px"; //$NON-NLS-1$
			textArea.style.height= "70px"; //$NON-NLS-1$
			textArea.innerHTML= html;
			this.getStatisticsContainer().appendChild(textArea);
		}
	}
});

PerformanceDude.fFinished= [];
PerformanceDude.ROOT= {label: "ALL", startTime: new Date(), hits: 1}; //$NON-NLS-1$
PerformanceDude.fOngoing= {};
PerformanceDude.fDomNode= null;
PerformanceDude.foo= new PerformanceDude();
PerformanceDude.start= function(label) {
	if ((label in PerformanceDude.fOngoing)) {
		PerformanceDude.fOngoing[label].hits++;
	} else {
		PerformanceDude.fOngoing[label]= {label: label, startTime: new Date(), hits: 1};
	}
};
PerformanceDude.stop= function(label) {
	if (!((label in PerformanceDude.fOngoing))) Assert.fail("(label in PerformanceDude.fOngoing)", "com.ibm.team.rtc.foundation.web.ui.util.performance.PerformanceDude:72");
	var item= PerformanceDude.fOngoing[label];
	item.hits--;
	if (item.hits === 0) {
		item.stopTime= new Date();
		delete PerformanceDude.fOngoing[label];
		PerformanceDude.fFinished.push(item);
	}
};
PerformanceDude.log= function(message) {
	var item= {label: "LOG:" + message, startTime: new Date(), hits: 0}; //$NON-NLS-1$
	item.stopTime= new Date();
	PerformanceDude.fFinished.push(item);
};
PerformanceDude.finish= function() {
	var $subject= jdojo.getProperties(PerformanceDude.fOngoing);
	var $length= $subject.length;
	for (var $count= 0; $count < $length; $count++){
		var label= $subject[$count];
		PerformanceDude.fOngoing[label].stopTime= new Date();
		PerformanceDude.fFinished.push(PerformanceDude.fOngoing[label]);
	}
	PerformanceDude.ROOT.stopTime= new Date();
	return PerformanceDude.ROOT;
};

})();
