/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2010. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.widgets.ContentAssistField"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.web.ui.util.PopupMenuManager"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$

(function() {
var PopupMenuManager= com.ibm.team.rtc.foundation.web.ui.util.PopupMenuManager;
var _Widget= dijit._Widget;

var ContentAssistField= dojo.declare("com.ibm.team.rtc.foundation.web.ui.widgets.ContentAssistField", _Widget, { //$NON-NLS-1$

	fTextChangeListener: null,

	fProposalComputer: null,

	fTimeoutHandle: null,

	fInitialValue: null,

	fText: null,

	fHasFocus: null,

	fPopup: null,

	fPopupHandle: null,

	constructor: function(params) {
		this.fInitialValue= params.initialValue != null ? params.initialValue : ""; //$NON-NLS-1$
		this.fProposalComputer= params.proposalComputer;
		this.fTextChangeListener= params.textChangeListener;
	},

	postCreate: function() {
		dojo.addClass(this.domNode, "com-ibm-team-rtc-foundation-web-ui-widgets-ContentAssistField"); //$NON-NLS-1$
		this.fText= dojo.create("input", {type: "text", value: this.fInitialValue}, this.domNode); //$NON-NLS-1$ //$NON-NLS-2$
		dojo.addClass(this.fText, "width-input"); //$NON-NLS-1$
		this.connect(this.fText, 'keyup', dojo.hitch(this, "doTriggerProposalComputation")); //$NON-NLS-1$ //$NON-NLS-2$
		this.connect(this.fText, 'focus', dojo.hitch(this, function(event) { //$NON-NLS-1$
			this.fHasFocus= true;
			if (this.fText.value.length === 0) {
				this.doDeplayedProposalComputation(1000);
			}
		}));
		this.connect(this.fText, 'blur', dojo.hitch(this, function(event) { //$NON-NLS-1$
			this.fHasFocus= false;
			window.setTimeout(dojo.hitch(this, function() {
				if (this.fHasFocus) 
					return ;
				if (this.fTextChangeListener == null) 
					return ;
				if (!this.isPopupShown() || !this.fPopup.hasFocus()) {
					this.fTextChangeListener(this.fText.value);
					if (this.isPopupShown()) {
						this.fPopupHandle.close();
					}
				}
			}), 50);
		}));
		var params= {};
		params.proposalSelectionListener= dojo.hitch(this, "applyProposal"); //$NON-NLS-1$
		this.fPopup= new ProposalPopup(params);
	},

	focus: function() {
		this.fText.focus();
	},

	doTriggerProposalComputation: function(event) {
		this.cancelPendingComputation();
		if (this.isPopupShown()) {
			if (event.keyCode === 40) {
				this.fPopup.focus();
			} else if (event.keyCode === 27) {
				this.fPopupHandle.close();
				dijit.focus(this.fText);
			} else if (event.keyCode === 8 || ContentAssistField.isCharacterOrDigit(event.keyCode)) {
				this.doProposalComputation();
			}
		} else {
			this.doDeplayedProposalComputation(500);
		}
	},

	doProposalComputation: function() {
		this.fPopup.clear();
		if (this.fPopup.hasFocus() || this.fHasFocus) {
			var propsals= this.fProposalComputer(this.fText.value, this.fText.selectionEnd);
			if (propsals.length > 0) {
				this.fPopup.add(propsals);
				if (!this.isPopupShown()) {
					this.fPopupHandle= PopupMenuManager.INSTANCE.show({around: this.fText, popup: this.fPopup, onClose: dojo.hitch(this, function() {
						this.fPopup.onClose();
					})});
				}
			} else if (this.isPopupShown()) {
				this.fPopupHandle.close();
			}
		}
	},

	doDeplayedProposalComputation: function(millis) {
		this.cancelPendingComputation();
		this.fTimeoutHandle= window.setTimeout(dojo.hitch(this, "doProposalComputation"), millis); //$NON-NLS-1$
	},

	cancelPendingComputation: function() {
		if (this.fTimeoutHandle !== 0) {
			window.clearTimeout(this.fTimeoutHandle);
		}
	},

	isPopupShown: function() {
		return this.fPopupHandle != null && !this.fPopupHandle.isClosed();
	},

	applyProposal: function(proposal) {
		this.cancelPendingComputation();
		this.fPopupHandle.close();
		dijit.focus(this.fText);
		var value= this.fText.value;
		var s1= value.substring(0, proposal.start);
		var s2= value.substring(proposal.end);
		this.fText.value= s1 + proposal.value + s2;
		this.fText.selectionEnd= this.fText.selectionEnd + proposal.cursorPosition;
		this.fText.selectionStart= this.fText.selectionEnd + proposal.cursorPosition;
	}
});

ContentAssistField.isCharacterOrDigit= function(keyCode) {
	return keyCode >= 48 && keyCode <= 90;
};
var ProposalPopup= dojo.declare("com.ibm.team.rtc.foundation.web.ui.widgets.ContentAssistField.ProposalPopup", _Widget, { //$NON-NLS-1$

	fHasFocus: null,

	fSelectElement: null,

	fProposalSelectionListener: null,

	constructor: function(params) {
		this.fProposalSelectionListener= params.proposalSelectionListener;
	},

	postCreate: function() {
		dojo.addClass(this.domNode, "com-ibm-team-rtc-foundation-web-ui-widgets-ContentAssistField"); //$NON-NLS-1$
		this.fSelectElement= dojo.create("select", {size: 8}, this.domNode); //$NON-NLS-1$
		dojo.addClass(this.fSelectElement, "width-input"); //$NON-NLS-1$
		this.connect(this.fSelectElement, 'keypress', dojo.hitch(this, function(event) { //$NON-NLS-1$
			var idx= this.fSelectElement.selectedIndex;
			if (event.keyCode === 13 && idx !== -1) {
				event.preventDefault();
				var optionElement= this.fSelectElement.options.item(idx);
				var proposal= optionElement[ProposalPopup.PROPOSAL];
				if (proposal != null && this.fProposalSelectionListener != null) {
					this.fProposalSelectionListener(proposal);
				}
			}
		}));
		this.connect(this.fSelectElement, 'click', dojo.hitch(this, function(event) { //$NON-NLS-1$
			var optionElement= event.target;
			var proposal= optionElement[ProposalPopup.PROPOSAL];
			if (this.fProposalSelectionListener != null) {
				this.fProposalSelectionListener(proposal);
			}
		}));
		this.connect(this.fSelectElement, 'focus', dojo.hitch(this, function(event) { //$NON-NLS-1$
			this.fHasFocus= true;
		}));
		this.connect(this.fSelectElement, 'blur', dojo.hitch(this, function(event) { //$NON-NLS-1$
			this.fHasFocus= false;
		}));
	},

	hasFocus: function() {
		return this.fHasFocus;
	},

	focus: function() {
		dijit.focus(this.fSelectElement);
	},

	onClose: function() {
		this.fHasFocus= false;
	},

	add: function(proposals) {
		if (proposals.length !== 0) {
			var $subject= proposals;
			var $length= $subject.length;
			for (var $count= 0; $count < $length; $count++){
				var proposal= $subject[$count];
				var optionElement= dojo.create("option", null, this.fSelectElement); //$NON-NLS-1$
				optionElement.appendChild(dojo.doc.createTextNode(proposal.label));
				optionElement[ProposalPopup.PROPOSAL]= proposal;
			}
			this.fSelectElement.selectedIndex= 0;
		}
	},

	clear: function() {
		while(this.fSelectElement.childNodes.length > 0){
			var node= this.fSelectElement.childNodes.item(0);
			node.parentNode.removeChild(node);
		}
	}
});

ProposalPopup.PROPOSAL= "__proposal"; //$NON-NLS-1$

})();
