/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.widgets.DropDownButton"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.web.ui.toolbar.PopupMenu"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.util.PopupMenuManager"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.widgets.AbstractFormWidget"); //$NON-NLS-1$

(function() {
var PopupMenu= com.ibm.team.rtc.foundation.web.ui.toolbar.PopupMenu;
var PopupMenuManager= com.ibm.team.rtc.foundation.web.ui.util.PopupMenuManager;
var AbstractFormWidget= com.ibm.team.rtc.foundation.web.ui.widgets.AbstractFormWidget;

var DropDownButton= dojo.declare("com.ibm.team.rtc.foundation.web.ui.widgets.DropDownButton", AbstractFormWidget, { //$NON-NLS-1$

	fButton: null,

	fActionLink: null,

	fDropDownLink: null,

	fLabelSpan: null,

	fName: null,

	fIconUrl: null,

	fLabel: null,

	fOnActionClick: null,

	fPopupMenuCreator: null,

	fPopupIsVisible: null,

	fMouseIsOver: null,

	fEnabled: null,

	fIsSingleButton: null,

	fMenu: null,

	fOnMenuClose: null,

	constructor: function(attrs) {
		this.fName= attrs.fName;
		this.fIconUrl= attrs.fIconUrl;
		this.fLabel= attrs.fLabel;
		this.fOnActionClick= attrs.fOnActionClick;
		this.fPopupMenuCreator= attrs.fPopupMenuCreator;
		this.fPopupIsVisible= false;
		this.fEnabled= true;
		this.fIsSingleButton= this.fOnActionClick == null;
	},

	postCreate: function() {
		var name= this.fName;
		var iconUrl= String(this.fIconUrl);
		dojo.addClass(this.domNode, "com-ibm-team-rtc-foundation-web-ui-widgets-DropDownButton"); //$NON-NLS-1$
		this.fButton= dojo.create("div", {className: DropDownButton.CLASS_BUTTON}); //$NON-NLS-1$
		this.fActionLink= dojo.create("a", {href: "#", title: name, className: DropDownButton.CLASS_ACTION}, this.fButton); //$NON-NLS-1$ //$NON-NLS-2$
		dojo.create("img", {src: iconUrl, alt: name}, this.fActionLink); //$NON-NLS-1$
		this.setLabel(this.fLabel);
		if (this.fIsSingleButton) 
			dojo.addClass(this.fActionLink, [DropDownButton.CLASS_SINGLE, DropDownButton.CLASS_ARROW]);
		else 
			this.fDropDownLink= dojo.create("a", {href: "#", className: DropDownButton.CLASS_DROP_DOWN + " " + DropDownButton.CLASS_ARROW}, this.fButton); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		this.connectHandlers();
		dojo.place(this.fButton, this.domNode, 'last'); //$NON-NLS-1$
	},

	setLabel: function(label) {
		this.fLabel= label;
		if (this.fLabel != null) {
			if (this.fLabelSpan == null) {
				this.fLabelSpan= dojo.create("span", {className: DropDownButton.CLASS_LABEL}, this.fActionLink, 'last'); //$NON-NLS-1$ //$NON-NLS-2$
				this.fLabelSpan.appendChild(dojo.doc.createTextNode(this.fLabel));
			} else {
				dojo.place(dojo.doc.createTextNode(this.fLabel), this.fLabelSpan, 'only'); //$NON-NLS-1$
			}
		}
	},

	onMouseOver: function(target) {
		dojo.addClass(this.fButton, DropDownButton.CLASS_HOVER);
		if (!this.fPopupIsVisible && !this.fIsSingleButton) {
			if (target === this.fDropDownLink) 
				dojo.addClass(this.fDropDownLink, DropDownButton.CLASS_HOVER);
			else 
				dojo.removeClass(this.fDropDownLink, DropDownButton.CLASS_HOVER);
		}
	},

	onMouseOut: function() {
		if (this.fPopupIsVisible) 
			return ;
		dojo.removeClass(this.fButton, DropDownButton.CLASS_HOVER);
		if (!this.fIsSingleButton) 
			dojo.removeClass(this.fDropDownLink, DropDownButton.CLASS_HOVER);
	},

	createPopup: function(elementToFocusOnClose) {
		if (this.fPopupMenuCreator != null) {
			if (this.fMenu == null) {
				this.fMenu= new PopupMenu(this.fPopupMenuCreator()).create();
				this.fOnMenuClose= dojo.hitch(this, function() {
					this.fPopupIsVisible= false;
					if (!this.fMouseIsOver) {
						this.onMouseOut();
						dijit.focus(elementToFocusOnClose);
					}
				});
			}
			var args= {around: this.domNode, popup: this.fMenu, onClose: this.fOnMenuClose};
			PopupMenuManager.INSTANCE.show(args);
			this.fPopupIsVisible= true;
			this.fMenu.focus();
		}
	},

	connectHandlers: function() {
		this.connect(this.domNode, 'mouseover', dojo.hitch(this, function(event) { //$NON-NLS-1$
			this.fMouseIsOver= true;
			this.onMouseOver(event.target);
		}));
		this.connect(this.domNode, 'mouseout', dojo.hitch(this, function(event) { //$NON-NLS-1$
			this.fMouseIsOver= false;
			this.onMouseOut();
		}));
		this.connect(this.fActionLink, 'click', dojo.hitch(this, function(event) { //$NON-NLS-1$
			event.preventDefault();
			if (!this.fEnabled) {
				return ;
			}
			if (this.fOnActionClick != null) {
				if (this.fOnActionClick.canHandle()) 
					this.fOnActionClick.handle();
			} else {
				this.createPopup(this.fActionLink);
			}
		}));
		if (!this.fIsSingleButton) {
			this.connect(this.fDropDownLink, 'click', dojo.hitch(this, function(event) { //$NON-NLS-1$
				event.preventDefault();
				if (!this.fEnabled) {
					return ;
				}
				this.createPopup(this.fDropDownLink);
			}));
		}
	},

	setEnabled: function(enabled) {
		this.fEnabled= enabled;
		dojo.toggleClass(this.fButton, DropDownButton.CLASS_DISABLED, !enabled);
	},

	setChecked: function(checked) {
		dojo.toggleClass(this.fButton, DropDownButton.CLASS_CHECKED, checked);
	},

	destroy: function(preserveDom) {
		if (this.fMenu != null) {
			this.fMenu.destroy(preserveDom);
		}
		this.inherited("destroy", arguments, [preserveDom]); //$NON-NLS-1$
	}
});

DropDownButton.CLASS_BUTTON= "button"; //$NON-NLS-1$
DropDownButton.CLASS_DISABLED= "disabled"; //$NON-NLS-1$
DropDownButton.CLASS_CHECKED= "checked"; //$NON-NLS-1$
DropDownButton.CLASS_ACTION= "action"; //$NON-NLS-1$
DropDownButton.CLASS_DROP_DOWN= "dropDown"; //$NON-NLS-1$
DropDownButton.CLASS_HOVER= "hover"; //$NON-NLS-1$
DropDownButton.CLASS_LABEL= "label"; //$NON-NLS-1$
DropDownButton.CLASS_ARROW= "arrow"; //$NON-NLS-1$
DropDownButton.CLASS_SINGLE= "single"; //$NON-NLS-1$

})();
