/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.widgets.Gallery"); //$NON-NLS-1$

dojo.require("com.ibm.jdojo.lang.Runtime"); //$NON-NLS-1$
dojo.require("com.ibm.jdojo.util.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.gridviewer.MeasureUtil"); //$NON-NLS-1$
dojo.require("com.ibm.team.rtc.foundation.web.ui.util.HTML5Features"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dojox.xml.parser"); //$NON-NLS-1$

(function() {
var jdojo= com.ibm.jdojo.lang.Runtime;
var Assert= com.ibm.jdojo.util.Assert;
var MeasureUtil= com.ibm.team.rtc.foundation.web.ui.gridviewer.MeasureUtil;
var HTML5Features= com.ibm.team.rtc.foundation.web.ui.util.HTML5Features;
var _Widget= dijit._Widget;
var parser= dojox.xml.parser;

dojo.declare("com.ibm.team.rtc.foundation.web.ui.widgets.Gallery", _Widget, { //$NON-NLS-1$

	fIdentifier: null,

	fItems: null,

	fGalleryItemsMap: null,

	fActiveItem: null,

	fIsActive: null,

	fMasterElement: null,

	fSlaveElement: null,

	constructor: function(params) {
		this.fIdentifier= params.identifier;
	},

	postCreate: function() {
		dojo.addClass(this.domNode, "com-ibm-team-rtc-foundation-web-ui-widgets-Gallery"); //$NON-NLS-1$
		this.fMasterElement= dojo.create("div", {className: "master inline-block"}, this.domNode); //$NON-NLS-1$ //$NON-NLS-2$
		this.fSlaveElement= dojo.create("div", {className: "slave inline-block"}, this.domNode); //$NON-NLS-1$ //$NON-NLS-2$
	},

	setItems: function(galleryItems) {
		if (!(this.fItems == null && this.fGalleryItemsMap == null)) Assert.fail("Gallery.setItems can't be called twice", "com.ibm.team.rtc.foundation.web.ui.widgets.Gallery:88"); //$NON-NLS-1$
		this.fItems= [];
		this.fGalleryItemsMap= {};
		var $subject= galleryItems;
		var $length= $subject.length;
		for (var $count= 0; $count < $length; $count++){
			var galleryItem= $subject[$count];
			var item= this.createItem(galleryItem);
			this.fItems.push(item);
			this.fGalleryItemsMap[galleryItem.getIdentifier()]= item;
			this.fMasterElement.appendChild(item.fContainer);
		}
		this.adjustWidth();
		if (this.fIsActive) {
			this.setActive(null);
		}
	},

	createItem: function(galleryItem) {
		var item= {};
		item.fGalleryItem= galleryItem;
		item.fContainer= dojo.create("div", null); //$NON-NLS-1$
		item.fTitleElement= dojo.create("a", {href: "#", className: "item"}, item.fContainer); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
		item.fConnectHandle= this.connect(item.fTitleElement, 'click', dojo.hitch(this, function(event) { //$NON-NLS-1$
			dojo.stopEvent(event);
			this.activateItem(galleryItem);
		}));
		item.fTitle= galleryItem.getTitle();
		dojo.place(dojo.doc.createTextNode(item.fTitle), item.fTitleElement, 'only'); //$NON-NLS-1$
		return item;
	},

	destroy: function(preserveDom) {
		var $subject2= this.fItems;
		var $length2= $subject2.length;
		for (var $count2= 0; $count2 < $length2; $count2++){
			var i= $subject2[$count2];
			this.disconnect(i.fConnectHandle);
			i.fGalleryItem.destroy(preserveDom);
		}
		this.inherited("destroy", arguments, [preserveDom]); //$NON-NLS-1$
	},

	setActive: function(galleryItem) {
		this.fIsActive= true;
		if (galleryItem != null) {
			this.activateItem(galleryItem);
		} else if (this.fActiveItem == null && this.fItems != null && this.fItems.length > 0) {
			galleryItem= this.fItems[0].fGalleryItem;
			if (HTML5Features.LocaleStorage.isSupported()) {
				var galleryItemKey= window.localStorage.getItem(this.getStorageName());
				if (galleryItemKey != null) {
					var item= this.fGalleryItemsMap[galleryItemKey];
					if (item != null) {
						galleryItem= item.fGalleryItem;
					}
				}
			}
			this.activateItem(galleryItem);
		}
	},

	getStorageName: function() {
		return this.fIdentifier;
	},

	adjustWidth: function() {
		var maxWidth= 0;
		var $subject3= this.fItems;
		var $length3= $subject3.length;
		for (var $count3= 0; $count3 < $length3; $count3++){
			var item= $subject3[$count3];
			if (item.fTitle != null) {
				maxWidth= Math.max(maxWidth, MeasureUtil.INSTANCE.getTextWidth(item.fTitle));
			}
		}
		dojo.style(this.fMasterElement, {width: (maxWidth * 1.2) + "px"}); //$NON-NLS-1$
	},

	activateItem: function(galleryItem) {
		if (this.fActiveItem != null) {
			dojo.removeClass(this.fActiveItem.fContainer, "selected"); //$NON-NLS-1$
		}
		this.fActiveItem= this.fGalleryItemsMap[galleryItem.getIdentifier()];
		dojo.addClass(this.fActiveItem.fContainer, "selected"); //$NON-NLS-1$
		parser.removeChildren(this.fSlaveElement);
		this.fSlaveElement.appendChild(galleryItem.getContents());
		if (HTML5Features.LocaleStorage.isSupported()) {
			window.localStorage.setItem(this.getStorageName(), galleryItem.getIdentifier());
		}
	}
});
jdojo.declareInterface("com.ibm.team.rtc.foundation.web.ui.widgets.Gallery.GalleryItem");


})();
