/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2011. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule 
 * Contract with IBM Corp.
 *******************************************************************************/
// NOTE: THIS IS A GENERATED FILE. DO NOT EDIT DIRECTLY!
dojo.provide("com.ibm.team.rtc.foundation.web.ui.widgets.Section"); //$NON-NLS-1$

dojo.require("com.ibm.team.rtc.foundation.web.ui.toolbar.SimpleToolbarManager"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dojo.fx"); //$NON-NLS-1$

(function() {
var SimpleToolbarManager= com.ibm.team.rtc.foundation.web.ui.toolbar.SimpleToolbarManager;
var _Templated= dijit._Templated;
var _Widget= dijit._Widget;
var fx= dojo.fx;

dojo.declare("com.ibm.team.rtc.foundation.web.ui.widgets.Section", [ _Widget, _Templated], { //$NON-NLS-1$

	templatePath: dojo.moduleUrl("com.ibm.team.rtc.foundation.web.ui", "widgets/templates/Section.html"), //$NON-NLS-1$ //$NON-NLS-2$

	ftHeader: null,

	ftTitle: null,

	ftTitleDetails: null,

	ftToolbar: null,

	ftBody: null,

	fParams: null,

	fToolbarManager: null,

	fExpanded: null,

	constructor: function(params) {
		this.fParams= params;
		this.fExpanded= this.fParams.expanded;
	},

	postCreate: function() {
		dojo.addClass(this.domNode, "com-ibm-team-rtc-foundation-web-ui-widgets-Section"); //$NON-NLS-1$
		this.setTitle(this.fParams.title);
		this.fToolbarManager= new SimpleToolbarManager();
		this.fToolbarManager.createToolbar(this.ftToolbar);
		this.setTitleDetails(this.fParams.titleDetails);
		this.setContent(this.fParams.content);
		if (!this.fExpanded) {
			var params= {};
			params.node= this.ftBody;
			var animation= fx.wipeOut(params);
			animation.duration= 1;
			animation.play();
		} else {
			dojo.addClass(this.ftHeader, "expanded"); //$NON-NLS-1$
		}
		this.connect(this.ftHeader, 'click', dojo.hitch(this, function(event) { //$NON-NLS-1$
			event.preventDefault();
			this.setExpanded(!this.isExpanded());
		}));
	},

	setExpanded: function(expanded) {
		if (this.fExpanded === expanded) 
			return ;
		this.fExpanded= expanded;
		var wipeParams= {};
		wipeParams.node= this.ftBody;
		var animation;
		if (this.fExpanded) {
			animation= fx.wipeIn(wipeParams);
		} else {
			animation= fx.wipeOut(wipeParams);
		}
		animation.duration= 200;
		animation.play();
		this.connect(animation, "onEnd", "onAnimationEnd"); //$NON-NLS-1$ //$NON-NLS-2$
	},

	isExpanded: function() {
		return this.fExpanded;
	},

	onAnimationEnd: function(source) {
		if (this.fExpanded) {
			dojo.addClass(this.ftHeader, "expanded"); //$NON-NLS-1$
		} else {
			dojo.removeClass(this.ftHeader, "expanded"); //$NON-NLS-1$
		}
		if (this.fParams.onExpand != null) {
			this.fParams.onExpand(this.fExpanded);
		}
	},

	setTitle: function(title) {
		dojo.empty(this.ftTitle);
		if (title == null) 
			return ;
		title= dojo.trim(title);
		if (title.length === 0) 
			return ;
		this.ftTitle.appendChild(dojo.doc.createTextNode(title));
	},

	getManager: function() {
		return this.fToolbarManager;
	},

	setContent: function(content) {
		if (content == null) {
			content= dojo.create("div", null); //$NON-NLS-1$
		}
		dojo.place(content, this.ftBody, 'only'); //$NON-NLS-1$
	},

	setTitleDetails: function(details) {
		if (details == null) {
			details= dojo.create("div", null); //$NON-NLS-1$
		}
		dojo.place(details, this.ftTitleDetails, 'only'); //$NON-NLS-1$
	},

	destroy: function(preserveDom) {
		this.fToolbarManager.destroy(preserveDom);
		this.inherited("destroy", arguments, [preserveDom]); //$NON-NLS-1$
	}
});

})();
